"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name2 in all)
    __defProp(target, name2, { get: all[name2], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  TabbyAgent: () => TabbyAgent,
  agentEventNames: () => agentEventNames
});
module.exports = __toCommonJS(src_exports);

// src/TabbyAgent.ts
var import_events4 = require("events");
var import_uuid2 = require("uuid");
var import_deep_equal3 = __toESM(require("deep-equal"));
var import_deepmerge_ts = require("deepmerge-ts");
var import_dot_prop3 = require("dot-prop");
var import_openapi_fetch3 = __toESM(require("openapi-fetch"));

// src/utils.ts
var levenshtein = __toESM(require("fast-levenshtein"));
function splitLines(input) {
  const lines = input.match(/.*(?:$|\r?\n)/g)?.filter(Boolean) ?? [];
  if (lines.length > 0 && lines[lines.length - 1]?.endsWith("\n")) {
    lines.push("");
  }
  return lines;
}
function isBlank(input) {
  return input.trim().length === 0;
}
function getIndentationLevel(line, indentation) {
  if (indentation === void 0) {
    return line.match(/^[ \t]*/)?.[0]?.length ?? 0;
  } else if (indentation === "	") {
    return line.match(/^\t*/)?.[0].length ?? 0;
  } else if (indentation.match(/^ *$/)) {
    const spaces = line.match(/^ */)?.[0].length ?? 0;
    return spaces / indentation.length;
  } else {
    throw new Error(`Invalid indentation: ${indentation}`);
  }
}
function isBlockOpeningLine(lines, index) {
  if (index < 0 || index >= lines.length - 1) {
    return false;
  }
  return getIndentationLevel(lines[index]) < getIndentationLevel(lines[index + 1]);
}
function isBlockClosingLine(lines, index) {
  if (index <= 0 || index > lines.length - 1) {
    return false;
  }
  return getIndentationLevel(lines[index - 1]) > getIndentationLevel(lines[index]);
}
var autoClosingPairs = [
  {
    open: {
      chars: "(",
      reg: /\(/
    },
    close: {
      chars: ")",
      reg: /\)/
    }
  },
  {
    open: {
      chars: "[",
      reg: /\[/
    },
    close: {
      chars: "]",
      reg: /\]/
    }
  },
  {
    open: {
      chars: "{",
      reg: /\{/
    },
    close: {
      chars: "}",
      reg: /\}/
    }
  },
  {
    open: {
      chars: "<",
      reg: /<(?=\w)/
    },
    close: {
      chars: "/>",
      reg: /\/>/
    }
  },
  {
    open: {
      chars: "<",
      reg: /<(?=[/\w])/
    },
    close: {
      chars: ">",
      reg: />/
    }
  },
  {
    openOrClose: {
      chars: '"',
      reg: /"/
    }
  },
  {
    openOrClose: {
      chars: "'",
      reg: /'/
    }
  },
  {
    openOrClose: {
      chars: "`",
      reg: /`/
    }
  }
];
var regOnlyAutoClosingCloseChars = /^([)\]}>"'`]|(\/>))*$/g;
function findUnpairedAutoClosingChars(input) {
  const stack = [];
  let index = 0;
  while (index < input.length) {
    const remain = input.slice(index);
    let nextFound = {
      index: remain.length,
      found: void 0
    };
    autoClosingPairs.forEach((pair) => {
      Object.entries(pair).forEach(([pos, pattern]) => {
        const match = remain.match(pattern.reg);
        if (match && match.index !== void 0 && match.index < nextFound.index) {
          nextFound = {
            index: match.index,
            found: { pair, pos, pattern }
          };
        }
      });
    });
    if (!nextFound.found) {
      break;
    }
    switch (nextFound.found.pos) {
      case "openOrClose": {
        const chars = nextFound.found.pattern.chars;
        if (stack.length > 0 && stack.includes(chars)) {
          stack.splice(stack.lastIndexOf(chars), stack.length - stack.lastIndexOf(chars));
        } else {
          stack.push(chars);
        }
        break;
      }
      case "open": {
        stack.push(nextFound.found.pattern.chars);
        break;
      }
      case "close": {
        const pair = nextFound.found.pair;
        if (stack.length > 0 && "open" in pair && stack[stack.length - 1] === pair.open.chars) {
          stack.pop();
        } else {
          stack.push(nextFound.found.pattern.chars);
        }
        break;
      }
    }
    index += nextFound.index + nextFound.found.pattern.chars.length;
  }
  return stack;
}
function calcDistance(a, b) {
  return levenshtein.get(a, b);
}
function abortSignalFromAnyOf(signals) {
  const controller = new AbortController();
  for (const signal of signals) {
    if (signal?.aborted) {
      controller.abort(signal.reason);
      return signal;
    }
    signal?.addEventListener("abort", () => controller.abort(signal.reason), {
      signal: controller.signal
    });
  }
  return controller.signal;
}
var HttpError = class extends Error {
  constructor(response) {
    super(`${response.status} ${response.statusText}`);
    this.name = "HttpError";
    this.status = response.status;
    this.statusText = response.statusText;
    this.response = response;
  }
};
function isTimeoutError(error) {
  return error instanceof Error && error.name === "TimeoutError" || error instanceof HttpError && [408, 499].includes(error.status);
}
function isCanceledError(error) {
  return error instanceof Error && error.name === "AbortError";
}
function errorToString(error) {
  let message = error.message || error.toString();
  if (error.cause) {
    message += "\nCaused by: " + errorToString(error.cause);
  }
  return message;
}

// src/Auth.ts
var import_events2 = require("events");
var import_jwt_decode = __toESM(require("jwt-decode"));
var import_openapi_fetch = __toESM(require("openapi-fetch"));

// src/dataStore.ts
var import_events = require("events");
var import_path = __toESM(require("path"));
var import_os = __toESM(require("os"));
var import_fs_extra = __toESM(require("fs-extra"));
var import_deep_equal = __toESM(require("deep-equal"));
var import_chokidar = __toESM(require("chokidar"));

// src/env.ts
var isBrowser = false;
var isTest = false;
var testLogDebug = !!process.env["TEST_LOG_DEBUG"];

// src/dataStore.ts
var FileDataStore = class extends import_events.EventEmitter {
  constructor(filepath) {
    super();
    this.filepath = filepath;
    this.data = {};
  }
  async load() {
    this.data = await import_fs_extra.default.readJson(dataFile, { throws: false }) || {};
  }
  async save() {
    await import_fs_extra.default.outputJson(dataFile, this.data);
  }
  watch() {
    this.watcher = import_chokidar.default.watch(this.filepath, {
      interval: 1e3
    });
    const onChanged = async () => {
      const oldData = this.data;
      await this.load();
      if (!(0, import_deep_equal.default)(oldData, this.data)) {
        super.emit("updated", this.data);
      }
    };
    this.watcher.on("add", onChanged);
    this.watcher.on("change", onChanged);
  }
};
var dataFile = import_path.default.join(import_os.default.homedir(), ".tabby-client", "agent", "data.json");
var dataStore = isBrowser ? void 0 : new FileDataStore(dataFile);

// src/logger.ts
var import_path2 = __toESM(require("path"));
var import_os2 = __toESM(require("os"));
var import_pino = __toESM(require("pino"));
var FileStreamRotator = __toESM(require("file-stream-rotator"));
var LogFileStream = class {
  constructor() {
    this.streamOptions = {
      // Rotating file locate at `~/.tabby-client/agent/logs/`.
      filename: import_path2.default.join(import_os2.default.homedir(), ".tabby-client", "agent", "logs", "%DATE%"),
      frequency: "daily",
      size: "10M",
      max_logs: "30d",
      extension: ".log",
      create_symlink: true
    };
  }
  write(data) {
    if (!this.stream) {
      this.stream = FileStreamRotator.getStream(this.streamOptions);
    }
    this.stream.write(data);
  }
};
var stream = isBrowser || isTest ? void 0 : new LogFileStream();
var options = { serializers: { error: import_pino.default.stdSerializers.err } };
var rootLogger = stream ? (0, import_pino.default)(options, stream) : (0, import_pino.default)(options);
if (isTest && testLogDebug) {
  rootLogger.level = "debug";
} else {
  rootLogger.level = "silent";
}
var allLoggers = [rootLogger];
rootLogger.onChild = (child) => {
  allLoggers.push(child);
};

// src/Auth.ts
var RetryLimitReachedError = class extends Error {
  constructor(cause) {
    super();
    this.cause = cause;
    this.name = "RetryLimitReachedError";
  }
};
var Auth = class _Auth extends import_events2.EventEmitter {
  constructor(endpoint) {
    super();
    this.endpoint = endpoint;
    this.logger = rootLogger.child({ component: "Auth" });
    this.authApi = (0, import_openapi_fetch.default)({ baseUrl: "https://app.tabbyml.com/api" });
  }
  static {
    this.authPageUrl = "https://app.tabbyml.com/account/device-token";
  }
  static {
    this.tokenStrategy = {
      polling: {
        // polling token after auth url generated
        interval: 5e3,
        // polling token every 5 seconds
        timeout: 5 * 60 * 1e3
        // stop polling after trying for 5 min
      },
      refresh: {
        // check token every 15 min, refresh token if it expires in 30 min
        interval: 15 * 60 * 1e3,
        beforeExpire: 30 * 60 * 1e3,
        whenLoaded: {
          // after token loaded from data store, refresh token if it is about to expire or has expired
          maxTry: 5,
          // keep loading time not too long
          retryDelay: 1e3
          // retry after 1 seconds
        },
        whenScheduled: {
          // if running until token is about to expire, refresh token as scheduled
          maxTry: 60,
          retryDelay: 30 * 1e3
          // retry after 30 seconds
        }
      }
    };
  }
  async init(options2) {
    if (options2?.dataStore) {
      this.dataStore = options2.dataStore;
    } else {
      this.dataStore = dataStore;
      if (dataStore) {
        dataStore.on("updated", async () => {
          await this.load();
          super.emit("updated", this.jwt);
        });
        dataStore.watch();
      }
    }
    this.scheduleRefreshToken();
    await this.load();
  }
  get token() {
    return this.jwt?.token;
  }
  get user() {
    return this.jwt?.payload.email;
  }
  async load() {
    if (!this.dataStore) {
      return;
    }
    try {
      await this.dataStore.load();
      const storedJwt = this.dataStore.data.auth?.[this.endpoint]?.jwt;
      if (typeof storedJwt === "string" && this.jwt?.token !== storedJwt) {
        this.logger.debug({ storedJwt }, "Load jwt from data store.");
        const jwt = {
          token: storedJwt,
          payload: (0, import_jwt_decode.default)(storedJwt)
        };
        if (jwt.payload.exp * 1e3 - Date.now() < _Auth.tokenStrategy.refresh.beforeExpire) {
          this.jwt = await this.refreshToken(jwt, _Auth.tokenStrategy.refresh.whenLoaded);
          await this.save();
        } else {
          this.jwt = jwt;
        }
      }
    } catch (error) {
      this.logger.debug({ error }, "Error when loading auth");
    }
  }
  async save() {
    if (!this.dataStore) {
      return;
    }
    try {
      if (this.jwt) {
        if (this.dataStore.data.auth?.[this.endpoint]?.jwt === this.jwt.token) {
          return;
        }
        this.dataStore.data.auth = { ...this.dataStore.data.auth, [this.endpoint]: { jwt: this.jwt.token } };
      } else {
        if (typeof this.dataStore.data.auth?.[this.endpoint] === "undefined") {
          return;
        }
        delete this.dataStore.data.auth[this.endpoint];
      }
      await this.dataStore.save();
      this.logger.debug("Save changes to data store.");
    } catch (error) {
      this.logger.error({ error }, "Error when saving auth");
    }
  }
  async reset() {
    if (this.jwt) {
      this.jwt = void 0;
      await this.save();
    }
  }
  async requestAuthUrl(options2) {
    try {
      await this.reset();
      if (options2?.signal.aborted) {
        throw options2.signal.reason;
      }
      this.logger.debug("Start to request device token");
      const response = await this.authApi.POST("/device-token", {
        body: { auth_url: this.endpoint },
        signal: options2?.signal
      });
      if (response.error || !response.response.ok) {
        throw new HttpError(response.response);
      }
      const deviceToken = response.data;
      this.logger.debug({ deviceToken }, "Request device token response");
      const authUrl = new URL(_Auth.authPageUrl);
      authUrl.searchParams.append("code", deviceToken.data.code);
      return { authUrl: authUrl.toString(), code: deviceToken.data.code };
    } catch (error) {
      this.logger.error({ error }, "Error when requesting token");
      throw error;
    }
  }
  async pollingToken(code, options2) {
    return new Promise((resolve, reject) => {
      const signal = abortSignalFromAnyOf([AbortSignal.timeout(_Auth.tokenStrategy.polling.timeout), options2?.signal]);
      const timer = setInterval(async () => {
        try {
          const response = await this.authApi.POST("/device-token/accept", { params: { query: { code } }, signal });
          if (response.error || !response.response.ok) {
            throw new HttpError(response.response);
          }
          const result = response.data;
          this.logger.debug({ result }, "Poll jwt response");
          this.jwt = {
            token: result.data.jwt,
            payload: (0, import_jwt_decode.default)(result.data.jwt)
          };
          super.emit("updated", this.jwt);
          await this.save();
          clearInterval(timer);
          resolve(true);
        } catch (error) {
          if (error instanceof HttpError && [400, 401, 403, 405].includes(error.status)) {
            this.logger.debug({ error }, "Expected error when polling jwt");
          } else {
            this.logger.error({ error }, "Error when polling jwt");
          }
        }
      }, _Auth.tokenStrategy.polling.interval);
      if (signal.aborted) {
        clearInterval(timer);
        reject(signal.reason);
      } else {
        signal.addEventListener("abort", () => {
          clearInterval(timer);
          reject(signal.reason);
        });
      }
    });
  }
  async refreshToken(jwt, options2 = { maxTry: 1, retryDelay: 1e3 }, retry = 0) {
    try {
      this.logger.debug({ retry }, "Start to refresh token");
      const response = await this.authApi.POST("/device-token/refresh", {
        headers: { Authorization: `Bearer ${jwt.token}` }
      });
      if (response.error || !response.response.ok) {
        throw new HttpError(response.response);
      }
      const refreshedJwt = response.data;
      this.logger.debug({ refreshedJwt }, "Refresh token response");
      return {
        token: refreshedJwt.data.jwt,
        payload: (0, import_jwt_decode.default)(refreshedJwt.data.jwt)
      };
    } catch (error) {
      if (error instanceof HttpError && [400, 401, 403, 405].includes(error.status)) {
        this.logger.debug({ error }, "Error when refreshing jwt");
      } else {
        this.logger.error({ error }, "Unknown error when refreshing jwt");
        if (retry < options2.maxTry) {
          this.logger.debug(`Retry refreshing jwt after ${options2.retryDelay}ms`);
          await new Promise((resolve) => setTimeout(resolve, options2.retryDelay));
          return this.refreshToken(jwt, options2, retry + 1);
        }
      }
      throw new RetryLimitReachedError(error);
    }
  }
  scheduleRefreshToken() {
    setInterval(async () => {
      if (!this.jwt) {
        return;
      }
      if (this.jwt.payload.exp * 1e3 - Date.now() < _Auth.tokenStrategy.refresh.beforeExpire) {
        try {
          this.jwt = await this.refreshToken(this.jwt, _Auth.tokenStrategy.refresh.whenScheduled);
          super.emit("updated", this.jwt);
          await this.save();
        } catch (error) {
          this.logger.error({ error }, "Error when refreshing jwt");
        }
      } else {
        this.logger.debug("Check token, still valid");
      }
    }, _Auth.tokenStrategy.refresh.interval);
  }
};

// src/AgentConfig.ts
var defaultAgentConfig = {
  server: {
    endpoint: "http://localhost:8080",
    token: "",
    requestHeaders: {},
    requestTimeout: 2 * 60 * 1e3
    // 2 minutes
  },
  completion: {
    prompt: {
      experimentalStripAutoClosingCharacters: true,
      maxPrefixLines: 20,
      maxSuffixLines: 20,
      clipboard: {
        minChars: 3,
        maxChars: 2e3
      }
    },
    debounce: {
      mode: "adaptive",
      interval: 250
      // ms
    }
  },
  postprocess: {
    limitScope: {
      experimentalSyntax: true,
      indentation: {
        experimentalKeepBlockScopeWhenCompletingLine: true
      }
    },
    calculateReplaceRange: {
      experimentalSyntax: true
    }
  },
  logs: {
    level: "silent"
  },
  anonymousUsageTracking: {
    disable: false
  }
};

// src/configFile.ts
var import_events3 = require("events");
var import_path3 = __toESM(require("path"));
var import_os3 = __toESM(require("os"));
var import_fs_extra2 = __toESM(require("fs-extra"));
var import_toml = __toESM(require("toml"));
var import_chokidar2 = __toESM(require("chokidar"));
var import_deep_equal2 = __toESM(require("deep-equal"));
var import_dot_prop = require("dot-prop");
var configTomlTemplate = `## Tabby agent configuration file

## Online documentation: https://tabby.tabbyml.com/docs/extensions/configurations
## You can uncomment and edit the values below to change the default settings.
## Configurations in this file have lower priority than the IDE settings.

## Server
## You can set the server endpoint here and an optional authentication token if required.
# [server]
# endpoint = "http://localhost:8080" # http or https URL
# token = "your-token-here" # if token is set, request header Authorization = "Bearer $token" will be added automatically

## You can add custom request headers.
# [server.requestHeaders]
# Header1 = "Value1" # list your custom headers here
# Header2 = "Value2" # values can be strings, numbers or booleans

## Logs
## You can set the log level here. The log file is located at ~/.tabby-client/agent/logs/.
# [logs]
# level = "silent" # "silent" or "error" or "debug"

## Anonymous usage tracking
## Tabby collects anonymous usage data and sends it to the Tabby team to help improve our products.
## Your code, generated completions, or any sensitive information is never tracked or sent.
## For more details on data collection, see https://tabby.tabbyml.com/docs/extensions/configurations#usage-collection
## Your contribution is greatly appreciated. However, if you prefer not to participate, you can disable anonymous usage tracking here.
# [anonymousUsageTracking]
# disable = false # set to true to disable

`;
var typeCheckSchema = {
  server: "object",
  "server.endpoint": "string",
  "server.token": "string",
  "server.requestHeaders": "object",
  "server.requestTimeout": "number",
  completion: "object",
  "completion.prompt": "object",
  "completion.prompt.experimentalStripAutoClosingCharacters": "boolean",
  "completion.prompt.maxPrefixLines": "number",
  "completion.prompt.maxSuffixLines": "number",
  "completion.prompt.clipboard": "object",
  "completion.prompt.clipboard.minChars": "number",
  "completion.prompt.clipboard.maxChars": "number",
  "completion.debounce": "object",
  "completion.debounce.mode": "string",
  "completion.debounce.interval": "number",
  postprocess: "object",
  "postprocess.limitScopeByIndentation": "object",
  "postprocess.limitScopeByIndentation.experimentalKeepBlockScopeWhenCompletingLine": "boolean",
  logs: "object",
  "logs.level": "string",
  anonymousUsageTracking: "object",
  "anonymousUsageTracking.disable": "boolean"
};
function validateConfig(config) {
  for (const [key, type] of Object.entries(typeCheckSchema)) {
    if (typeof (0, import_dot_prop.getProperty)(config, key) !== type) {
      (0, import_dot_prop.deleteProperty)(config, key);
    }
  }
  return config;
}
var ConfigFile = class extends import_events3.EventEmitter {
  constructor(filepath) {
    super();
    this.filepath = filepath;
    this.data = {};
    this.logger = rootLogger.child({ component: "ConfigFile" });
  }
  get config() {
    return this.data;
  }
  async load() {
    try {
      const fileContent = await import_fs_extra2.default.readFile(this.filepath, "utf8");
      const data = import_toml.default.parse(fileContent);
      if (Object.keys(data).length === 0 && fileContent.trim() !== configTomlTemplate.trim()) {
        await this.createTemplate();
        return;
      }
      this.data = validateConfig(data);
    } catch (error) {
      if (error instanceof Error && "code" in error && error.code === "ENOENT") {
        await this.createTemplate();
      } else {
        this.logger.error({ error }, "Failed to load config file");
      }
    }
  }
  watch() {
    this.watcher = import_chokidar2.default.watch(this.filepath, {
      interval: 1e3
    });
    const onChanged = async () => {
      const oldData = this.data;
      await this.load();
      if (!(0, import_deep_equal2.default)(oldData, this.data)) {
        super.emit("updated", this.data);
      }
    };
    this.watcher.on("add", onChanged);
    this.watcher.on("change", onChanged);
  }
  async createTemplate() {
    try {
      await import_fs_extra2.default.outputFile(this.filepath, configTomlTemplate);
    } catch (error) {
      this.logger.error({ error }, "Failed to create config template file");
    }
  }
};
var configFilePath = import_path3.default.join(import_os3.default.homedir(), ".tabby-client", "agent", "config.toml");
var configFile = isBrowser ? void 0 : new ConfigFile(configFilePath);

// src/CompletionCache.ts
var import_lru_cache = require("lru-cache");

// src/CompletionContext.ts
var import_object_hash = __toESM(require("object-hash"));
function isAtLineEndExcludingAutoClosedChar(suffix) {
  return suffix.trimEnd().match(regOnlyAutoClosingCloseChars);
}
var CompletionContext = class {
  constructor(request) {
    this.filepath = request.filepath;
    this.language = request.language;
    this.text = request.text;
    this.position = request.position;
    this.indentation = request.indentation;
    this.prefix = request.text.slice(0, request.position);
    this.suffix = request.text.slice(request.position);
    this.prefixLines = splitLines(this.prefix);
    this.suffixLines = splitLines(this.suffix);
    this.currentLinePrefix = this.prefixLines[this.prefixLines.length - 1] ?? "";
    this.currentLineSuffix = this.suffixLines[0] ?? "";
    this.clipboard = request.clipboard?.trim() ?? "";
    const lineEnd = isAtLineEndExcludingAutoClosedChar(this.suffixLines[0] ?? "");
    this.mode = lineEnd ? "default" : "fill-in-line";
    this.hash = (0, import_object_hash.default)({
      filepath: this.filepath,
      language: this.language,
      text: this.text,
      position: this.position,
      clipboard: this.clipboard
    });
  }
};

// src/CompletionCache.ts
var CompletionCache = class {
  constructor() {
    this.logger = rootLogger.child({ component: "CompletionCache" });
    this.options = {
      maxCount: 1e4,
      prebuildCache: {
        enabled: true,
        perCharacter: {
          lines: 1,
          max: 50
        },
        perLine: {
          max: 10
        },
        autoClosingPairCheck: {
          max: 3
        }
      }
    };
    this.cache = new import_lru_cache.LRUCache({
      max: this.options.maxCount
    });
  }
  has(key) {
    return this.cache.has(key.hash);
  }
  buildCache(key, value) {
    this.logger.debug({ key, value }, "Starting to build cache");
    const entries = this.createCacheEntries(key, value);
    entries.forEach((entry) => {
      this.cache.set(entry.key.hash, { value: entry.value, rebuildFlag: entry.rebuildFlag });
    });
    this.logger.debug({ newEntries: entries.length, cacheSize: this.cache.size }, "Cache updated");
  }
  get(key) {
    const entry = this.cache.get(key.hash);
    if (entry?.rebuildFlag) {
      this.buildCache(key, entry?.value);
    }
    return entry?.value;
  }
  createCacheEntries(key, value) {
    const list = [{ key, value, rebuildFlag: false }];
    if (this.options.prebuildCache.enabled) {
      for (const choice of value.choices) {
        const completionText = choice.text.slice(key.position - choice.replaceRange.start);
        const perLinePositions = this.getPerLinePositions(completionText);
        this.logger.trace({ completionText, perLinePositions }, "Calculate per-line cache positions");
        for (const position of perLinePositions) {
          const completionTextPrefix = completionText.slice(0, position);
          const completionTextPrefixWithAutoClosedChars = this.generateAutoClosedPrefixes(completionTextPrefix);
          for (const prefix of [completionTextPrefix, ...completionTextPrefixWithAutoClosedChars]) {
            const entry = {
              key: new CompletionContext({
                ...key,
                text: key.text.slice(0, key.position) + prefix + key.text.slice(key.position),
                position: key.position + position
              }),
              value: {
                ...value,
                choices: [
                  {
                    index: choice.index,
                    text: completionText.slice(position),
                    replaceRange: {
                      start: key.position + position,
                      end: key.position + position
                    }
                  }
                ]
              },
              rebuildFlag: true
            };
            this.logger.trace({ prefix, entry }, "Build per-line cache entry");
            list.push(entry);
          }
        }
        const perCharacterPositions = this.getPerCharacterPositions(completionText);
        this.logger.trace({ completionText, perCharacterPositions }, "Calculate per-character cache positions");
        for (const position of perCharacterPositions) {
          let lineStart = position;
          while (lineStart > 0 && completionText[lineStart - 1] !== "\n") {
            lineStart--;
          }
          const completionTextPrefix = completionText.slice(0, position);
          const completionTextPrefixWithAutoClosedChars = this.generateAutoClosedPrefixes(completionTextPrefix);
          for (const prefix of [completionTextPrefix, ...completionTextPrefixWithAutoClosedChars]) {
            const entry = {
              key: new CompletionContext({
                ...key,
                text: key.text.slice(0, key.position) + prefix + key.text.slice(key.position),
                position: key.position + position
              }),
              value: {
                ...value,
                choices: [
                  {
                    index: choice.index,
                    text: completionText.slice(lineStart),
                    replaceRange: {
                      start: key.position + lineStart,
                      end: key.position + position
                    }
                  }
                ]
              },
              rebuildFlag: false
            };
            this.logger.trace({ prefix, entry }, "Build per-character cache entry");
            list.push(entry);
          }
        }
      }
    }
    const result = list.reduce((prev, curr) => {
      const found = prev.find((entry) => entry.key.hash === curr.key.hash);
      if (found) {
        found.value.choices.push(...curr.value.choices);
        found.rebuildFlag = found.rebuildFlag || curr.rebuildFlag;
      } else {
        prev.push(curr);
      }
      return prev;
    }, []);
    return result;
  }
  // positions for every line end (before newline character) and line begin (after indent)
  getPerLinePositions(completion) {
    const result = [];
    const option = this.options.prebuildCache;
    const lines = splitLines(completion);
    let index = 0;
    let offset = 0;
    while (index < lines.length - 1 && index < option.perLine.max) {
      offset += lines[index]?.length ?? 0;
      result.push(offset - 1);
      result.push(offset);
      let offsetNextLineBegin = offset;
      while (offsetNextLineBegin < completion.length && completion[offsetNextLineBegin].match(/\s/)) {
        offsetNextLineBegin++;
      }
      result.push(offsetNextLineBegin);
      index++;
    }
    return result;
  }
  // positions for every character in the leading lines
  getPerCharacterPositions(completion) {
    const result = [];
    const option = this.options.prebuildCache;
    const text = splitLines(completion).slice(0, option.perCharacter.lines).join("");
    let offset = 0;
    while (offset < text.length && offset < option.perCharacter.max) {
      result.push(offset);
      offset++;
    }
    return result;
  }
  // FIXME: add unit tests
  // "function(" => ["function()"]
  // "call([" => ["call([]", "call([])" ]
  // "function(arg" => ["function(arg)" ]
  generateAutoClosedPrefixes(prefix) {
    const result = [];
    const unpaired = findUnpairedAutoClosingChars(prefix);
    let checkIndex = 0;
    let autoClosing = "";
    while (checkIndex < unpaired.length && checkIndex < this.options.prebuildCache.autoClosingPairCheck.max) {
      autoClosingPairs.filter((pair) => {
        let pattern;
        if ("open" in pair) {
          pattern = pair.open;
        } else {
          pattern = pair.openOrClose;
        }
        return pattern.chars === unpaired[unpaired.length - 1 - checkIndex];
      }).forEach((pair) => {
        let pattern;
        if ("close" in pair) {
          pattern = pair.close;
        } else {
          pattern = pair.openOrClose;
        }
        autoClosing += pattern.chars;
        result.push(prefix + autoClosing);
      });
      checkIndex++;
    }
    return result;
  }
};

// src/CompletionDebounce.ts
function clamp(min, max, value) {
  return Math.max(min, Math.min(max, value));
}
var CompletionDebounce = class {
  constructor() {
    this.lastCalledTimeStamp = 0;
    this.baseInterval = 200;
    // ms
    this.calledIntervalHistory = [];
    this.options = {
      baseIntervalSlideWindowAvg: {
        minSize: 20,
        maxSize: 100,
        min: 100,
        max: 400
      },
      adaptiveRate: {
        min: 1.5,
        max: 3
      },
      contextScoreWeights: {
        triggerCharacter: 0.5,
        noSuffixInCurrentLine: 0.4,
        noSuffix: 0.1
      },
      requestDelay: {
        min: 100,
        // ms
        max: 1e3
      }
    };
  }
  async debounce(context, options2) {
    const { request, config, responseTime } = context;
    if (request.manually) {
      return this.sleep(0, options2);
    }
    if (config.mode === "fixed") {
      return this.sleep(config.interval, options2);
    }
    const now = Date.now();
    this.updateBaseInterval(now - this.lastCalledTimeStamp);
    this.lastCalledTimeStamp = now;
    const contextScore = this.calcContextScore(request);
    const adaptiveRate = this.options.adaptiveRate.max - (this.options.adaptiveRate.max - this.options.adaptiveRate.min) * contextScore;
    const expectedLatency = adaptiveRate * this.baseInterval;
    const delay = clamp(this.options.requestDelay.min, this.options.requestDelay.max, expectedLatency - responseTime);
    return this.sleep(delay, options2);
  }
  async sleep(delay, options2) {
    return new Promise((resolve, reject) => {
      const timer = setTimeout(resolve, Math.min(delay, 2147483647));
      if (options2?.signal) {
        if (options2.signal.aborted) {
          clearTimeout(timer);
          reject(options2.signal.reason);
        } else {
          options2.signal.addEventListener("abort", () => {
            clearTimeout(timer);
            reject(options2.signal.reason);
          });
        }
      }
    });
  }
  updateBaseInterval(interval) {
    if (interval > this.options.baseIntervalSlideWindowAvg.max) {
      return;
    }
    this.calledIntervalHistory.push(interval);
    if (this.calledIntervalHistory.length > this.options.baseIntervalSlideWindowAvg.maxSize) {
      this.calledIntervalHistory.shift();
    }
    if (this.calledIntervalHistory.length > this.options.baseIntervalSlideWindowAvg.minSize) {
      const avg = this.calledIntervalHistory.reduce((a, b) => a + b, 0) / this.calledIntervalHistory.length;
      this.baseInterval = clamp(
        this.options.baseIntervalSlideWindowAvg.min,
        this.options.baseIntervalSlideWindowAvg.max,
        avg
      );
    }
  }
  // return score in [0, 1], 1 means the context has a high chance to accept the completion
  calcContextScore(request) {
    let score = 0;
    const weights = this.options.contextScoreWeights;
    const triggerCharacter = request.text[request.position - 1] ?? "";
    score += triggerCharacter.match(/^\W*$/) ? weights.triggerCharacter : 0;
    const suffix = request.text.slice(request.position) ?? "";
    const currentLineInSuffix = splitLines(suffix)[0] ?? "";
    score += currentLineInSuffix.match(/^\W*$/) ? weights.noSuffixInCurrentLine : 0;
    score += suffix.match(/^\W*$/) ? weights.noSuffix : 0;
    score = clamp(0, 1, score);
    return score;
  }
};

// src/postprocess/base.ts
var logger = rootLogger.child({ component: "Postprocess" });
if (!Array.prototype.distinct) {
  Array.prototype.distinct = function(identity) {
    return [...new Map(this.map((item) => [identity?.(item) ?? item, item])).values()];
  };
}
if (!Array.prototype.mapAsync) {
  Array.prototype.mapAsync = async function(callbackfn, thisArg) {
    return await Promise.all(this.map((item, index) => callbackfn.call(thisArg, item, index, this)));
  };
}
function applyFilter(filter, context) {
  return applyChoiceFilter(async (choice) => {
    const replaceLength = context.position - choice.replaceRange.start;
    const input = choice.text.slice(replaceLength);
    const filtered = await filter(input, context);
    choice.text = choice.text.slice(0, replaceLength) + (filtered ?? "");
    return choice;
  }, context);
}
function applyChoiceFilter(choiceFilter, context) {
  return async (response) => {
    response.choices = (await response.choices.mapAsync(async (choice) => {
      return await choiceFilter(choice, context);
    })).filter((choice) => {
      return !!choice && !!choice.text;
    }).distinct((choice) => choice.text);
    return response;
  };
}

// src/postprocess/removeRepetitiveBlocks.ts
function blockSplitter(_) {
  return /\n(\s*)\n/g;
}
function removeRepetitiveBlocks() {
  return (input, context) => {
    const inputBlocks = input.split(blockSplitter(context.language));
    let repetitionCount = 0;
    const repetitionThreshold = 2;
    let index = inputBlocks.length - 2;
    while (index >= 1) {
      if (isBlank(inputBlocks[index])) {
        index--;
        continue;
      }
      let prev = index - 1;
      while (prev >= 0 && isBlank(inputBlocks[prev])) {
        prev--;
      }
      if (prev < 0)
        break;
      const currentBlock = inputBlocks[index].trim();
      const previousBlock = inputBlocks[prev].trim();
      const threshold = Math.max(0.1 * currentBlock.length, 0.1 * previousBlock.length);
      const distance = calcDistance(currentBlock, previousBlock);
      if (distance <= threshold) {
        repetitionCount++;
        index--;
      } else {
        break;
      }
    }
    if (repetitionCount >= repetitionThreshold) {
      logger.debug(
        {
          inputBlocks,
          repetitionCount
        },
        "Remove repetitive blocks."
      );
      return inputBlocks.slice(0, index + 1).join("").trimEnd();
    }
    return input;
  };
}

// src/postprocess/removeRepetitiveLines.ts
function removeRepetitiveLines() {
  return (input) => {
    const inputLines = splitLines(input);
    let repetitionCount = 0;
    const repetitionThreshold = 5;
    let index = inputLines.length - 2;
    while (index >= 1) {
      if (isBlank(inputLines[index])) {
        index--;
        continue;
      }
      let prev = index - 1;
      while (prev >= 0 && isBlank(inputLines[prev])) {
        prev--;
      }
      if (prev < 0)
        break;
      const currentLine = inputLines[index].trim();
      const previousLine = inputLines[prev].trim();
      const threshold = Math.max(0.1 * currentLine.length, 0.1 * previousLine.length);
      const distance = calcDistance(currentLine, previousLine);
      if (distance <= threshold) {
        repetitionCount++;
        index = prev;
      } else {
        break;
      }
    }
    if (repetitionCount >= repetitionThreshold) {
      logger.debug(
        {
          inputLines,
          repetitionCount
        },
        "Remove repetitive lines."
      );
      return inputLines.slice(0, index + 1).join("").trimEnd();
    }
    return input;
  };
}

// src/postprocess/removeLineEndsWithRepetition.ts
var repetitionTests = [
  /(.{3,}?)\1{5,}$/g,
  // match a 3+ characters pattern repeating 5+ times
  /(.{10,}?)\1{3,}$/g
  // match a 10+ characters pattern repeating 3+ times
];
function removeLineEndsWithRepetition() {
  return (input) => {
    const inputLines = splitLines(input);
    let index = inputLines.length - 1;
    while (index >= 0 && isBlank(inputLines[index])) {
      index--;
    }
    if (index < 0)
      return input;
    for (const test of repetitionTests) {
      const match = inputLines[index].match(test);
      if (match) {
        logger.debug(
          {
            inputLines,
            lineNumber: index,
            match
          },
          "Remove line ends with repetition."
        );
        if (index < 1)
          return null;
        return inputLines.slice(0, index).join("").trimEnd();
      }
    }
    return input;
  };
}

// src/postprocess/removeDuplicatedBlockClosingLine.ts
function removeDuplicatedBlockClosingLine() {
  return (input, context) => {
    const { suffixLines, currentLinePrefix } = context;
    const inputLines = splitLines(input);
    if (inputLines.length < 2) {
      return input;
    }
    const inputLinesForDetection = inputLines.map((line, index) => {
      return index === 0 ? currentLinePrefix + line : line;
    });
    if (!isBlockClosingLine(inputLinesForDetection, inputLines.length - 1)) {
      return input;
    }
    const inputEndingLine = inputLines[inputLines.length - 1];
    let suffixBeginningIndex = 1;
    while (suffixBeginningIndex < suffixLines.length && isBlank(suffixLines[suffixBeginningIndex])) {
      suffixBeginningIndex++;
    }
    if (suffixBeginningIndex >= suffixLines.length) {
      return input;
    }
    const suffixBeginningLine = suffixLines[suffixBeginningIndex];
    if (inputEndingLine.startsWith(suffixBeginningLine.trimEnd()) || suffixBeginningLine.startsWith(inputEndingLine.trimEnd())) {
      logger.debug({ inputLines, suffixLines }, "Removing duplicated block closing line");
      return inputLines.slice(0, inputLines.length - 1).join("").trimEnd();
    }
    return input;
  };
}

// src/postprocess/limitScopeByIndentation.ts
function parseIndentationContext(inputLines, inputLinesForDetection, context, config) {
  const result = {
    indentLevelLimit: 0,
    allowClosingLine: true
  };
  const { prefixLines, suffixLines, currentLinePrefix } = context;
  if (inputLines.length == 0 || prefixLines.length == 0) {
    return result;
  }
  const isCurrentLineInPrefixBlank = isBlank(currentLinePrefix);
  let referenceLineInPrefixIndex = prefixLines.length - 1;
  while (referenceLineInPrefixIndex >= 0 && isBlank(prefixLines[referenceLineInPrefixIndex])) {
    referenceLineInPrefixIndex--;
  }
  if (referenceLineInPrefixIndex < 0) {
    return result;
  }
  const referenceLineInPrefix = prefixLines[referenceLineInPrefixIndex];
  const referenceLineInPrefixIndent = getIndentationLevel(referenceLineInPrefix);
  const currentLineInCompletion = inputLines[0];
  const isCurrentLineInCompletionBlank = isBlank(currentLineInCompletion);
  let referenceLineInCompletionIndex = 0;
  while (referenceLineInCompletionIndex < inputLines.length && isBlank(inputLines[referenceLineInCompletionIndex])) {
    referenceLineInCompletionIndex++;
  }
  if (referenceLineInCompletionIndex >= inputLines.length) {
    return result;
  }
  const referenceLineInCompletion = inputLines[referenceLineInCompletionIndex];
  let referenceLineInCompletionIndent;
  if (isCurrentLineInCompletionBlank) {
    referenceLineInCompletionIndent = getIndentationLevel(referenceLineInCompletion);
  } else {
    referenceLineInCompletionIndent = getIndentationLevel(currentLinePrefix + referenceLineInCompletion);
  }
  if (!isCurrentLineInCompletionBlank && !isCurrentLineInPrefixBlank) {
    if (config.experimentalKeepBlockScopeWhenCompletingLine) {
      result.indentLevelLimit = referenceLineInPrefixIndent;
    } else {
      result.indentLevelLimit = referenceLineInPrefixIndent + 1;
      result.allowClosingLine &&= isBlockOpeningLine(inputLinesForDetection, 0);
    }
  } else if (referenceLineInCompletionIndent > referenceLineInPrefixIndent) {
    result.indentLevelLimit = referenceLineInPrefixIndent + 1;
  } else if (referenceLineInCompletionIndent < referenceLineInPrefixIndent) {
    result.indentLevelLimit = referenceLineInPrefixIndent;
  } else {
    result.indentLevelLimit = referenceLineInPrefixIndent;
  }
  let firstNonBlankLineInSuffix = 1;
  while (firstNonBlankLineInSuffix < suffixLines.length && isBlank(suffixLines[firstNonBlankLineInSuffix])) {
    firstNonBlankLineInSuffix++;
  }
  if (firstNonBlankLineInSuffix < suffixLines.length) {
    const firstNonBlankLineInSuffixText = suffixLines[firstNonBlankLineInSuffix];
    result.allowClosingLine &&= getIndentationLevel(firstNonBlankLineInSuffixText) < result.indentLevelLimit;
  }
  return result;
}
function limitScopeByIndentation(config) {
  return (input, context) => {
    const { prefixLines, suffixLines, currentLinePrefix } = context;
    const inputLines = splitLines(input);
    const inputLinesForDetection = inputLines.map((line, index2) => {
      return index2 === 0 ? currentLinePrefix + line : line;
    });
    const indentContext = parseIndentationContext(inputLines, inputLinesForDetection, context, config);
    let index = 1;
    while (index < inputLines.length) {
      const line = inputLines[index];
      const prevLine = inputLines[index - 1];
      if (isBlank(line)) {
        index++;
        continue;
      }
      const indentLevel = getIndentationLevel(line);
      if (indentLevel < indentContext.indentLevelLimit) {
        if (isBlockClosingLine(inputLinesForDetection, index) && isBlockOpeningLine(inputLinesForDetection, index)) {
          index++;
          continue;
        }
        if (indentContext.allowClosingLine && (context.language !== "python" || !isBlank(prevLine))) {
          index++;
        }
        break;
      }
      index++;
    }
    if (index < inputLines.length) {
      logger.debug(
        { inputLines, prefixLines, suffixLines, scopeLineCount: index },
        "Remove content out of indent scope"
      );
      return inputLines.slice(0, index).join("").trimEnd();
    }
    return input;
  };
}

// src/syntax/parser.ts
var import_path4 = __toESM(require("path"));
var import_web_tree_sitter = __toESM(require("web-tree-sitter"));
var languagesConfigs = {
  javascript: "tsx",
  typescript: "tsx",
  javascriptreact: "tsx",
  typescriptreact: "tsx",
  python: "python",
  go: "go",
  rust: "rust",
  ruby: "ruby"
};
var treeSitterInitialized = false;
async function createParser(languageConfig) {
  if (!treeSitterInitialized) {
    await import_web_tree_sitter.default.init({
      locateFile(scriptName, scriptDirectory) {
        const paths = isTest ? [scriptDirectory, scriptName] : [scriptDirectory, "wasm", scriptName];
        return import_path4.default.join(...paths);
      }
    });
    treeSitterInitialized = true;
  }
  const parser = new import_web_tree_sitter.default();
  const langWasmPaths = isTest ? [process.cwd(), "wasm", `tree-sitter-${languageConfig}.wasm`] : [__dirname, "wasm", `tree-sitter-${languageConfig}.wasm`];
  parser.setLanguage(await import_web_tree_sitter.default.Language.load(import_path4.default.join(...langWasmPaths)));
  return parser;
}
var parsers = /* @__PURE__ */ new Map();
async function getParser(languageConfig) {
  let parser = parsers.get(languageConfig);
  if (!parser) {
    parser = await createParser(languageConfig);
    parsers.set(languageConfig, parser);
  }
  return parser;
}

// src/syntax/typeList.ts
var typeList = {
  tsx: [
    [
      "jsx_element",
      "jsx_self_closing_element",
      "for_statement",
      "for_in_statement",
      "if_statement",
      "while_statement",
      "do_statement",
      "switch_statement",
      "try_statement",
      "with_statement",
      "labeled_statement",
      "class_declaration",
      "abstract_class_declaration",
      "interface_declaration",
      "enum_declaration",
      "type_alias_declaration",
      "function_declaration",
      "generator_function_declaration",
      "ambient_declaration",
      "method_definition",
      "import_statement",
      "export_statement",
      "module"
    ],
    ["expression_statement", "lexical_declaration"]
  ],
  // https://github.com/tree-sitter/tree-sitter-python/blob/master/src/node-types.json
  python: [
    [
      "for_statement",
      "if_statement",
      "while_statement",
      "match_statement",
      "try_statement",
      "with_statement",
      "function_definition",
      "decorated_definition",
      "class_definition",
      "import_statement",
      "import_from_statement"
    ]
  ],
  // https://github.com/tree-sitter/tree-sitter-go/blob/master/src/node-types.json
  go: [
    [
      "for_statement",
      "if_statement",
      "expression_switch_statement",
      "type_switch_statement",
      "select_statement",
      "labeled_statement",
      "function_declaration",
      "method_declaration",
      "type_declaration",
      "import_declaration",
      "package_clause"
    ]
  ],
  // https://github.com/tree-sitter/tree-sitter-rust/blob/master/src/node-types.json
  rust: [
    [
      "for_expression",
      "if_expression",
      "while_expression",
      "loop_expression",
      "match_expression",
      "try_expression",
      "function_item",
      "type_item",
      "enum_item",
      "struct_item",
      "union_item",
      "trait_item",
      "impl_item",
      "use_declaration"
    ]
  ],
  // https://github.com/tree-sitter/tree-sitter-ruby/blob/master/src/node-types.json
  ruby: [
    [
      "for",
      "if",
      "unless",
      "while",
      "until",
      "case",
      "class",
      "singleton_class",
      "method",
      "singleton_method",
      "module"
    ]
  ]
};

// src/postprocess/limitScopeBySyntax.ts
var supportedLanguages = Object.keys(languagesConfigs);
function findLineBegin(text, position) {
  let lastNonBlankCharPos = position - 1;
  while (lastNonBlankCharPos >= 0 && text[lastNonBlankCharPos]?.match(/\s/)) {
    lastNonBlankCharPos--;
  }
  if (lastNonBlankCharPos < 0) {
    return 0;
  }
  const lineBegin = text.lastIndexOf("\n", lastNonBlankCharPos);
  if (lineBegin < 0) {
    return 0;
  }
  const line = text.slice(lineBegin + 1, position);
  const indentation = line.search(/\S/);
  return lineBegin + 1 + indentation;
}
function findLineEnd(text, position) {
  let firstNonBlankCharPos = position;
  while (firstNonBlankCharPos < text.length && text[firstNonBlankCharPos]?.match(/\s/)) {
    firstNonBlankCharPos++;
  }
  if (firstNonBlankCharPos >= text.length) {
    return text.length;
  }
  const lineEnd = text.indexOf("\n", firstNonBlankCharPos);
  if (lineEnd < 0) {
    return text.length;
  }
  return lineEnd;
}
function findScope(node, typeList2) {
  for (const types of typeList2) {
    let scope = node;
    while (scope) {
      if (types.includes(scope.type)) {
        return scope;
      }
      scope = scope.parent;
    }
  }
  return node;
}
function limitScopeBySyntax() {
  return async (input, context) => {
    const { position, text, language, prefix, suffix } = context;
    if (!supportedLanguages.includes(language)) {
      throw new Error(`Language ${language} is not supported`);
    }
    const languageConfig = languagesConfigs[language];
    const parser = await getParser(languageConfig);
    const updatedText = prefix + input + suffix;
    const updatedTree = parser.parse(updatedText);
    const lineBegin = findLineBegin(updatedText, position);
    const lineEnd = findLineEnd(updatedText, position);
    const scope = findScope(
      updatedTree.rootNode.namedDescendantForIndex(lineBegin, lineEnd),
      typeList[languageConfig] ?? []
    );
    if (scope.type == "ERROR") {
      throw new Error("Cannot determine syntax scope.");
    }
    if (scope.endIndex < position + input.length) {
      logger.debug(
        {
          languageConfig,
          text,
          updatedText,
          position,
          lineBegin,
          lineEnd,
          scope: { type: scope.type, start: scope.startIndex, end: scope.endIndex }
        },
        "Remove content out of syntax scope"
      );
      return input.slice(0, scope.endIndex - position);
    }
    return input;
  };
}

// src/postprocess/limitScope.ts
function limitScope(config) {
  return async (input, context) => {
    const preferSyntaxParser = !isBrowser && // syntax parser is not supported in browser yet
    config.experimentalSyntax;
    if (preferSyntaxParser) {
      try {
        return await limitScopeBySyntax()(input, context);
      } catch (error) {
        logger.debug({ error }, "Failed to limit scope by syntax parser");
      }
    }
    return limitScopeByIndentation(config["indentation"])(input, context);
  };
}

// src/postprocess/formatIndentation.ts
function detectIndentation(lines) {
  const matches = {
    "	": 0,
    "  ": 0,
    "    ": 0
  };
  for (const line of lines) {
    if (line.match(/^\t/)) {
      matches["	"]++;
    } else {
      const spaces = line.match(/^ */)?.[0].length ?? 0;
      if (spaces > 0) {
        if (spaces % 4 === 0) {
          matches["    "]++;
        }
        if (spaces % 2 === 0) {
          matches["  "]++;
        }
      }
    }
  }
  if (matches["	"] > 0) {
    return "	";
  }
  if (matches["  "] > matches["    "]) {
    return "  ";
  }
  if (matches["    "] > 0) {
    return "    ";
  }
  return null;
}
function getIndentLevel(line, indentation) {
  if (indentation === "	") {
    return line.match(/^\t*/)?.[0].length ?? 0;
  } else {
    const spaces = line.match(/^ */)?.[0].length ?? 0;
    return spaces / indentation.length;
  }
}
function formatIndentation() {
  return (input, context) => {
    const { prefixLines, suffixLines, currentLinePrefix, indentation } = context;
    const inputLines = splitLines(input);
    if (!indentation) {
      return input;
    }
    const prefixLinesForDetection = isBlank(currentLinePrefix) ? prefixLines.slice(0, prefixLines.length - 1) : prefixLines;
    if (prefixLines.length > 1 && detectIndentation(prefixLinesForDetection) !== null) {
      return input;
    }
    const suffixLinesForDetection = suffixLines.slice(1);
    if (suffixLines.length > 1 && detectIndentation(suffixLinesForDetection) !== null) {
      return input;
    }
    const inputLinesForDetection = inputLines.map((line, index) => {
      return index === 0 ? currentLinePrefix + line : line;
    });
    const inputIndentation = detectIndentation(inputLinesForDetection);
    if (inputIndentation === null || inputIndentation === indentation) {
      return input;
    }
    const formatted = inputLinesForDetection.map((line, index) => {
      const level = getIndentLevel(line, inputIndentation);
      if (level === 0) {
        return inputLines[index];
      }
      const rest = line.slice(inputIndentation.length * level);
      if (index === 0) {
        if (!isBlank(currentLinePrefix)) {
          return inputLines[0];
        } else {
          return indentation.repeat(level).slice(currentLinePrefix.length) + rest;
        }
      } else {
        return indentation.repeat(level) + rest;
      }
    });
    logger.debug({ prefixLines, suffixLines, inputLines, formatted }, "Format indentation.");
    return formatted.join("");
  };
}

// src/postprocess/trimSpace.ts
function trimSpace() {
  return (input, context) => {
    const { currentLinePrefix, currentLineSuffix } = context;
    let trimmedInput = input;
    if (!isBlank(currentLinePrefix) && currentLinePrefix.match(/\s$/)) {
      trimmedInput = trimmedInput.trimStart();
    }
    if (isBlank(currentLineSuffix) || !isBlank(currentLineSuffix) && currentLineSuffix.match(/^\s/)) {
      trimmedInput = trimmedInput.trimEnd();
    }
    return trimmedInput;
  };
}

// src/postprocess/trimMultiLineInSingleLineMode.ts
function trimMultiLineInSingleLineMode() {
  return (input, context) => {
    const inputLines = splitLines(input);
    if (context.mode === "fill-in-line" && inputLines.length > 1) {
      const suffix = context.currentLineSuffix.trimEnd();
      const inputLine = inputLines[0].trimEnd();
      if (inputLine.endsWith(suffix)) {
        const trimmedInputLine = inputLine.slice(0, -suffix.length);
        if (trimmedInputLine.length > 0) {
          logger.debug({ inputLines, trimmedInputLine }, "Trim content with multiple lines");
          return trimmedInputLine;
        }
      }
      logger.debug({ inputLines }, "Drop content with multiple lines");
      return null;
    }
    return input;
  };
}

// src/postprocess/dropDuplicated.ts
function dropDuplicated() {
  return (input, context) => {
    const { suffixLines } = context;
    const inputLines = splitLines(input);
    let inputIndex = 0;
    while (inputIndex < inputLines.length && isBlank(inputLines[inputIndex])) {
      inputIndex++;
    }
    let suffixIndex = 0;
    while (suffixIndex < suffixLines.length && isBlank(suffixLines[suffixIndex])) {
      suffixIndex++;
    }
    const lineCount = Math.min(3, inputLines.length - inputIndex, suffixLines.length - suffixIndex);
    if (lineCount < 1)
      return input;
    const inputToCompare = inputLines.slice(inputIndex, inputIndex + lineCount).join("").trim();
    const suffixToCompare = suffixLines.slice(suffixIndex, suffixIndex + lineCount).join("").trim();
    const threshold = Math.max(1, 0.05 * inputToCompare.length, 0.05 * suffixToCompare.length);
    const distance = calcDistance(inputToCompare, suffixToCompare);
    if (distance <= threshold) {
      logger.debug(
        { inputLines, suffixLines, inputToCompare, suffixToCompare, distance, threshold },
        "Drop completion due to duplicated."
      );
      return null;
    }
    return input;
  };
}

// src/postprocess/dropBlank.ts
function dropBlank() {
  return (input) => {
    return isBlank(input) ? null : input;
  };
}

// src/postprocess/calculateReplaceRangeByBracketStack.ts
function calculateReplaceRangeByBracketStack(choice, context) {
  const { currentLineSuffix } = context;
  const suffixText = currentLineSuffix.trimEnd();
  if (isBlank(suffixText)) {
    return choice;
  }
  const completionText = choice.text.slice(context.position - choice.replaceRange.start);
  const unpaired = findUnpairedAutoClosingChars(completionText).join("");
  if (isBlank(unpaired)) {
    return choice;
  }
  if (suffixText.startsWith(unpaired)) {
    choice.replaceRange.end = context.position + unpaired.length;
    logger.trace(
      { context, completion: choice.text, range: choice.replaceRange, unpaired },
      "Adjust replace range by bracket stack"
    );
  } else if (unpaired.startsWith(suffixText)) {
    choice.replaceRange.end = context.position + suffixText.length;
    logger.trace(
      { context, completion: choice.text, range: choice.replaceRange, unpaired },
      "Adjust replace range by bracket stack"
    );
  }
  return choice;
}

// src/postprocess/calculateReplaceRangeBySyntax.ts
var supportedLanguages2 = Object.keys(languagesConfigs);
async function calculateReplaceRangeBySyntax(choice, context) {
  const { position, prefix, suffix, prefixLines, currentLinePrefix, currentLineSuffix, language } = context;
  const suffixText = currentLineSuffix.trimEnd();
  if (isBlank(suffixText)) {
    return choice;
  }
  if (!supportedLanguages2.includes(language)) {
    throw new Error(`Language ${language} is not supported`);
  }
  const languageConfig = languagesConfigs[language];
  const parser = await getParser(languageConfig);
  const completionText = choice.text.slice(position - choice.replaceRange.start);
  const completionLines = splitLines(completionText);
  let replaceLength = 0;
  let tree = parser.parse(prefix + completionText + suffix);
  let node = tree.rootNode.namedDescendantForIndex(
    prefix.length + completionText.length,
    prefix.length + completionText.length + suffixText.length - replaceLength
  );
  while (node.hasError() && replaceLength < suffixText.length) {
    replaceLength++;
    const row = prefixLines.length - 1 + completionLines.length - 1;
    let column = completionLines[completionLines.length - 1]?.length ?? 0;
    if (completionLines.length == 1) {
      column += currentLinePrefix.length;
    }
    tree.edit({
      startIndex: prefix.length + completionText.length,
      oldEndIndex: prefix.length + completionText.length + 1,
      newEndIndex: prefix.length + completionText.length,
      startPosition: { row, column },
      oldEndPosition: { row, column: column + 1 },
      newEndPosition: { row, column }
    });
    tree = parser.parse(prefix + completionText + suffix.slice(replaceLength), tree);
    node = tree.rootNode.namedDescendantForIndex(
      prefix.length + completionText.length,
      prefix.length + completionText.length + suffixText.length - replaceLength
    );
  }
  if (node.hasError()) {
    throw new Error("Syntax error when parsing completion");
  }
  choice.replaceRange.end = position + replaceLength;
  logger.trace({ context, completion: choice.text, range: choice.replaceRange }, "Adjust replace range by syntax");
  return choice;
}

// src/postprocess/calculateReplaceRange.ts
function calculateReplaceRange(config) {
  return async (choice, context) => {
    const preferSyntaxParser = !isBrowser && // syntax parser is not supported in browser yet
    config.experimentalSyntax;
    if (preferSyntaxParser) {
      try {
        return await calculateReplaceRangeBySyntax(choice, context);
      } catch (error) {
        logger.debug({ error }, "Failed to calculate replace range by syntax parser");
      }
    }
    return calculateReplaceRangeByBracketStack(choice, context);
  };
}

// src/postprocess/index.ts
async function preCacheProcess(context, _, response) {
  return Promise.resolve(response).then(applyFilter(trimMultiLineInSingleLineMode(), context)).then(applyFilter(removeLineEndsWithRepetition(), context)).then(applyFilter(dropDuplicated(), context)).then(applyFilter(trimSpace(), context)).then(applyFilter(dropBlank(), context));
}
async function postCacheProcess(context, config, response) {
  return Promise.resolve(response).then(applyFilter(removeRepetitiveBlocks(), context)).then(applyFilter(removeRepetitiveLines(), context)).then(applyFilter(limitScope(config["limitScope"]), context)).then(applyFilter(removeDuplicatedBlockClosingLine(), context)).then(applyFilter(formatIndentation(), context)).then(applyFilter(dropDuplicated(), context)).then(applyFilter(trimSpace(), context)).then(applyFilter(dropBlank(), context)).then(applyChoiceFilter(calculateReplaceRange(config["calculateReplaceRange"]), context));
}

// src/AnonymousUsageLogger.ts
var import_os4 = __toESM(require("os"));
var import_openapi_fetch2 = __toESM(require("openapi-fetch"));
var import_dot_prop2 = require("dot-prop");
var import_uuid = require("uuid");

// package.json
var name = "tabby-agent";
var version = "1.3.1";

// src/AnonymousUsageLogger.ts
var AnonymousUsageLogger = class {
  constructor() {
    this.anonymousUsageTrackingApi = (0, import_openapi_fetch2.default)({ baseUrl: "https://app.tabbyml.com/api" });
    this.logger = rootLogger.child({ component: "AnonymousUsage" });
    this.systemData = {
      agent: `${name}, ${version}`,
      browser: isBrowser ? navigator?.userAgent || "browser" : void 0,
      node: isBrowser ? void 0 : `${process.version} ${process.platform} ${import_os4.default.arch()} ${import_os4.default.release()}`
    };
    this.sessionProperties = {};
    this.userProperties = {};
    this.userPropertiesUpdated = false;
    this.emittedUniqueEvent = [];
    this.disabled = false;
  }
  async init(options2) {
    this.dataStore = options2?.dataStore || dataStore;
    if (this.dataStore) {
      try {
        await this.dataStore.load();
      } catch (error) {
        this.logger.debug({ error }, "Error when loading anonymousId");
      }
      if (typeof this.dataStore.data["anonymousId"] === "string") {
        this.anonymousId = this.dataStore.data["anonymousId"];
      } else {
        this.anonymousId = (0, import_uuid.v4)();
        this.dataStore.data["anonymousId"] = this.anonymousId;
        try {
          await this.dataStore.save();
        } catch (error) {
          this.logger.debug({ error }, "Error when saving anonymousId");
        }
      }
    } else {
      this.anonymousId = (0, import_uuid.v4)();
    }
  }
  /**
   * Set properties to be sent with every event in this session.
   */
  setSessionProperties(key, value) {
    (0, import_dot_prop2.setProperty)(this.sessionProperties, key, value);
  }
  /**
   * Set properties which will be bind to the user.
   */
  setUserProperties(key, value) {
    (0, import_dot_prop2.setProperty)(this.userProperties, key, value);
    this.userPropertiesUpdated = true;
  }
  async uniqueEvent(event, data = {}) {
    await this.event(event, data, true);
  }
  async event(event, data = {}, unique = false) {
    if (this.disabled || !this.anonymousId) {
      return;
    }
    if (unique && this.emittedUniqueEvent.includes(event)) {
      return;
    }
    if (unique) {
      this.emittedUniqueEvent.push(event);
    }
    const properties = {
      ...this.systemData,
      ...this.sessionProperties,
      ...data
    };
    if (this.userPropertiesUpdated) {
      (0, import_dot_prop2.setProperty)(properties, "$set", this.userProperties);
      this.userPropertiesUpdated = false;
    }
    try {
      await this.anonymousUsageTrackingApi.POST("/usage", {
        body: {
          distinctId: this.anonymousId,
          event,
          properties
        }
      });
    } catch (error) {
      this.logger.error({ error }, "Error when sending anonymous usage data");
    }
  }
};

// src/CompletionProviderStats.ts
var import_stats_logscale = require("stats-logscale");
var Average = class {
  constructor() {
    this.sum = 0;
    this.quantity = 0;
  }
  add(value) {
    this.sum += value;
    this.quantity += 1;
  }
  mean() {
    if (this.quantity === 0) {
      return void 0;
    }
    return this.sum / this.quantity;
  }
  count() {
    return this.quantity;
  }
};
var Windowed = class {
  constructor(maxSize) {
    this.values = [];
    this.maxSize = maxSize;
  }
  add(value) {
    this.values.push(value);
    if (this.values.length > this.maxSize) {
      this.values.shift();
    }
  }
  getValues() {
    return this.values;
  }
};
var CompletionProviderStats = class {
  constructor() {
    this.config = {
      windowSize: 10,
      checks: {
        disable: false,
        // Mark status as healthy if the latency is less than the threshold for each latest windowSize requests.
        healthy: { windowSize: 1, latency: 3e3 },
        // If there is at least {count} requests, and the average response time is higher than the {latency}, show warning
        slowResponseTime: { latency: 5e3, count: 1 },
        // If there is at least {count} timeouts, and the timeout rate is higher than the {rate}, show warning
        highTimeoutRate: { rate: 0.5, count: 1 }
      }
    };
    this.autoCompletionCount = 0;
    this.manualCompletionCount = 0;
    this.cacheHitCount = 0;
    this.cacheMissCount = 0;
    this.eventMap = /* @__PURE__ */ new Map();
    this.completionRequestLatencyStats = new import_stats_logscale.Univariate();
    this.completionRequestCanceledStats = new Average();
    this.completionRequestTimeoutCount = 0;
    this.recentCompletionRequestLatencies = new Windowed(this.config.windowSize);
  }
  add(value) {
    const { triggerMode, cacheHit, aborted, requestSent, requestLatency, requestCanceled, requestTimeout } = value;
    if (!aborted) {
      if (triggerMode === "auto") {
        this.autoCompletionCount += 1;
      } else {
        this.manualCompletionCount += 1;
      }
      if (cacheHit) {
        this.cacheHitCount += 1;
      } else {
        this.cacheMissCount += 1;
      }
    }
    if (requestSent) {
      if (requestCanceled) {
        this.completionRequestCanceledStats.add(requestLatency);
      } else if (requestTimeout) {
        this.completionRequestTimeoutCount += 1;
      } else {
        this.completionRequestLatencyStats.add(requestLatency);
      }
      if (!requestCanceled) {
        this.recentCompletionRequestLatencies.add(requestLatency);
      }
    }
  }
  addEvent(event) {
    const count = this.eventMap.get(event) || 0;
    this.eventMap.set(event, count + 1);
  }
  reset() {
    this.autoCompletionCount = 0;
    this.manualCompletionCount = 0;
    this.cacheHitCount = 0;
    this.cacheMissCount = 0;
    this.eventMap = /* @__PURE__ */ new Map();
    this.completionRequestLatencyStats = new import_stats_logscale.Univariate();
    this.completionRequestCanceledStats = new Average();
    this.completionRequestTimeoutCount = 0;
  }
  resetWindowed() {
    this.recentCompletionRequestLatencies = new Windowed(this.config.windowSize);
  }
  // stats for anonymous usage report
  stats() {
    const eventCount = Object.fromEntries(
      Array.from(this.eventMap.entries()).map(([key, value]) => ["count_" + key, value])
    );
    return {
      completion: {
        count_auto: this.autoCompletionCount,
        count_manual: this.manualCompletionCount,
        cache_hit: this.cacheHitCount,
        cache_miss: this.cacheMissCount,
        ...eventCount
      },
      completion_request: {
        count: this.completionRequestLatencyStats.count(),
        latency_avg: this.completionRequestLatencyStats.mean(),
        latency_p50: this.completionRequestLatencyStats.percentile(50),
        latency_p95: this.completionRequestLatencyStats.percentile(95),
        latency_p99: this.completionRequestLatencyStats.percentile(99)
      },
      completion_request_canceled: {
        count: this.completionRequestCanceledStats.count(),
        latency_avg: this.completionRequestCanceledStats.mean()
      },
      completion_request_timeout: {
        count: this.completionRequestTimeoutCount
      }
    };
  }
  // stats for "highTimeoutRate" | "slowResponseTime" warning
  windowed() {
    const latencies = this.recentCompletionRequestLatencies.getValues();
    const timeouts = latencies.filter((latency) => Number.isNaN(latency));
    const responses = latencies.filter((latency) => !Number.isNaN(latency));
    const averageResponseTime = responses.reduce((acc, latency) => acc + latency, 0) / responses.length;
    return {
      values: latencies,
      stats: {
        total: latencies.length,
        timeouts: timeouts.length,
        responses: responses.length,
        averageResponseTime
      }
    };
  }
  check(windowed) {
    if (this.config.checks.disable) {
      return null;
    }
    const config = this.config.checks;
    const {
      values: latencies,
      stats: { total, timeouts, responses, averageResponseTime }
    } = windowed;
    if (latencies.slice(-Math.min(this.config.windowSize, config.healthy.windowSize)).every((latency) => latency < config.healthy.latency)) {
      return "healthy";
    }
    if (timeouts / total > config.highTimeoutRate.rate && timeouts >= config.highTimeoutRate.count) {
      return "highTimeoutRate";
    }
    if (averageResponseTime > config.slowResponseTime.latency && responses >= config.slowResponseTime.count) {
      return "slowResponseTime";
    }
    return null;
  }
};

// src/TabbyAgent.ts
var TabbyAgent = class _TabbyAgent extends import_events4.EventEmitter {
  constructor() {
    super();
    this.logger = rootLogger.child({ component: "TabbyAgent" });
    this.anonymousUsageLogger = new AnonymousUsageLogger();
    this.config = defaultAgentConfig;
    this.userConfig = {};
    // config from `~/.tabby-client/agent/config.toml`
    this.clientConfig = {};
    // config from `initialize` and `updateConfig` method
    this.status = "notInitialized";
    this.issues = [];
    this.completionCache = new CompletionCache();
    this.completionDebounce = new CompletionDebounce();
    this.completionProviderStats = new CompletionProviderStats();
    this.tryingConnectTimer = setInterval(async () => {
      if (this.status === "disconnected") {
        this.logger.debug("Trying to connect...");
        await this.healthCheck();
      }
    }, _TabbyAgent.tryConnectInterval);
    this.submitStatsTimer = setInterval(async () => {
      await this.submitStats();
    }, _TabbyAgent.submitStatsInterval);
  }
  static {
    this.tryConnectInterval = 1e3 * 30;
  }
  static {
    this.submitStatsInterval = 1e3 * 60 * 60 * 24;
  }
  async applyConfig() {
    const oldConfig = this.config;
    const oldStatus = this.status;
    this.config = (0, import_deepmerge_ts.deepmerge)(defaultAgentConfig, this.userConfig, this.clientConfig);
    allLoggers.forEach((logger2) => logger2.level = this.config.logs.level);
    this.anonymousUsageLogger.disabled = this.config.anonymousUsageTracking.disable;
    if (isBlank(this.config.server.token) && this.config.server.requestHeaders["Authorization"] === void 0) {
      if (this.config.server.endpoint !== this.auth?.endpoint) {
        this.auth = new Auth(this.config.server.endpoint);
        await this.auth.init({ dataStore: this.dataStore });
        this.auth.on("updated", () => {
          this.setupApi();
        });
      }
    } else {
      this.auth = void 0;
    }
    if (!(0, import_deep_equal3.default)(oldConfig.server, this.config.server)) {
      this.serverHealthState = void 0;
      this.completionProviderStats.resetWindowed();
      this.popIssue("slowCompletionResponseTime");
      this.popIssue("highCompletionTimeoutRate");
      this.popIssue("connectionFailed");
      this.connectionErrorMessage = void 0;
    }
    await this.setupApi();
    if (!(0, import_deep_equal3.default)(oldConfig.server, this.config.server)) {
      if (oldStatus === "unauthorized" && this.status === "unauthorized") {
        this.emitAuthRequired();
      }
    }
    const event = { event: "configUpdated", config: this.config };
    this.logger.debug({ event }, "Config updated");
    super.emit("configUpdated", event);
  }
  async setupApi() {
    const auth = !isBlank(this.config.server.token) ? `Bearer ${this.config.server.token}` : this.auth?.token ? `Bearer ${this.auth.token}` : void 0;
    this.api = (0, import_openapi_fetch3.default)({
      baseUrl: this.config.server.endpoint.replace(/\/+$/, ""),
      // remove trailing slash
      headers: {
        Authorization: auth,
        ...this.config.server.requestHeaders
      }
    });
    await this.healthCheck();
  }
  changeStatus(status) {
    if (this.status != status) {
      this.status = status;
      const event = { event: "statusChanged", status };
      this.logger.debug({ event }, "Status changed");
      super.emit("statusChanged", event);
      if (this.status === "unauthorized") {
        this.emitAuthRequired();
      }
    }
  }
  issueFromName(issueName) {
    switch (issueName) {
      case "highCompletionTimeoutRate":
        return {
          name: "highCompletionTimeoutRate",
          completionResponseStats: this.completionProviderStats.windowed().stats
        };
      case "slowCompletionResponseTime":
        return {
          name: "slowCompletionResponseTime",
          completionResponseStats: this.completionProviderStats.windowed().stats
        };
      case "connectionFailed":
        return {
          name: "connectionFailed",
          message: this.connectionErrorMessage
        };
    }
  }
  pushIssue(issue) {
    if (!this.issues.includes(issue)) {
      this.issues.push(issue);
      this.logger.debug({ issue }, "Issues Pushed");
      this.emitIssueUpdated();
    }
  }
  popIssue(issue) {
    const index = this.issues.indexOf(issue);
    if (index >= 0) {
      this.issues.splice(index, 1);
      this.logger.debug({ issue }, "Issues Popped");
      this.emitIssueUpdated();
    }
  }
  emitAuthRequired() {
    const event = { event: "authRequired", server: this.config.server };
    super.emit("authRequired", event);
  }
  emitIssueUpdated() {
    const event = { event: "issuesUpdated", issues: this.issues };
    super.emit("issuesUpdated", event);
  }
  async submitStats() {
    const stats = this.completionProviderStats.stats();
    if (stats.completion_request.count > 0) {
      await this.anonymousUsageLogger.event("AgentStats", { stats });
      this.completionProviderStats.reset();
      this.logger.debug({ stats }, "Stats submitted");
    }
  }
  createAbortSignal(options2) {
    const timeout = Math.min(2147483647, options2?.timeout || this.config.server.requestTimeout);
    return abortSignalFromAnyOf([AbortSignal.timeout(timeout), options2?.signal]);
  }
  async healthCheck(options2) {
    const requestId = (0, import_uuid2.v4)();
    const requestPath = "/v1/health";
    const requestUrl = this.config.server.endpoint + requestPath;
    const requestOptions = {
      signal: this.createAbortSignal({ signal: options2?.signal })
    };
    try {
      if (!this.api) {
        throw new Error("http client not initialized");
      }
      this.logger.debug({ requestId, requestOptions, url: requestUrl }, "Health check request");
      let response;
      if (options2?.method === "POST") {
        response = await this.api.POST(requestPath, requestOptions);
      } else {
        response = await this.api.GET(requestPath, requestOptions);
      }
      if (response.error || !response.response.ok) {
        throw new HttpError(response.response);
      }
      this.logger.debug({ requestId, response }, "Health check response");
      this.changeStatus("ready");
      this.popIssue("connectionFailed");
      this.connectionErrorMessage = void 0;
      const healthState = response.data;
      if (typeof healthState === "object" && healthState["model"] !== void 0 && healthState["device"] !== void 0) {
        this.serverHealthState = healthState;
        this.anonymousUsageLogger.uniqueEvent("AgentConnected", healthState);
      }
    } catch (error) {
      this.serverHealthState = void 0;
      if (error instanceof HttpError && error.status == 405 && options2?.method !== "POST") {
        return await this.healthCheck({ method: "POST" });
      } else if (error instanceof HttpError && [401, 403].includes(error.status)) {
        this.logger.debug({ requestId, error }, "Health check error: unauthorized");
        this.changeStatus("unauthorized");
      } else {
        if (isTimeoutError(error)) {
          this.logger.debug({ requestId, error }, "Health check error: timeout");
          this.connectionErrorMessage = `GET ${requestUrl}: Timed out.`;
        } else if (isCanceledError(error)) {
          this.logger.debug({ requestId, error }, "Health check error: canceled");
          this.connectionErrorMessage = `GET ${requestUrl}: Canceled.`;
        } else {
          this.logger.error({ requestId, error }, "Health check error: unknown error");
          const message = error instanceof Error ? errorToString(error) : JSON.stringify(error);
          this.connectionErrorMessage = `GET ${requestUrl}: Request failed: 
${message}`;
        }
        this.pushIssue("connectionFailed");
        this.changeStatus("disconnected");
      }
    }
  }
  createSegments(context) {
    const maxPrefixLines = this.config.completion.prompt.maxPrefixLines;
    const maxSuffixLines = this.config.completion.prompt.maxSuffixLines;
    const { prefixLines, suffixLines } = context;
    const prefix = prefixLines.slice(Math.max(prefixLines.length - maxPrefixLines, 0)).join("");
    let suffix;
    if (this.config.completion.prompt.experimentalStripAutoClosingCharacters && context.mode !== "fill-in-line") {
      suffix = "\n" + suffixLines.slice(1, maxSuffixLines).join("");
    } else {
      suffix = suffixLines.slice(0, maxSuffixLines).join("");
    }
    let clipboard = void 0;
    const clipboardConfig = this.config.completion.prompt.clipboard;
    if (context.clipboard.length >= clipboardConfig.minChars && context.clipboard.length <= clipboardConfig.maxChars) {
      clipboard = context.clipboard;
    }
    return { prefix, suffix, clipboard };
  }
  async initialize(options2) {
    this.dataStore = options2?.dataStore;
    await this.anonymousUsageLogger.init({ dataStore: this.dataStore });
    if (options2.clientProperties) {
      const { user: userProp, session: sessionProp } = options2.clientProperties;
      allLoggers.forEach((logger2) => logger2.setBindings?.({ ...sessionProp }));
      if (sessionProp) {
        Object.entries(sessionProp).forEach(([key, value]) => {
          this.anonymousUsageLogger.setSessionProperties(key, value);
        });
      }
      if (userProp) {
        Object.entries(userProp).forEach(([key, value]) => {
          this.anonymousUsageLogger.setUserProperties(key, value);
        });
      }
    }
    if (configFile) {
      await configFile.load();
      this.userConfig = configFile.config;
      configFile.on("updated", async (config) => {
        this.userConfig = config;
        await this.applyConfig();
      });
      configFile.watch();
    }
    if (options2.config) {
      this.clientConfig = options2.config;
    }
    await this.applyConfig();
    await this.anonymousUsageLogger.uniqueEvent("AgentInitialized");
    this.logger.debug({ options: options2 }, "Initialized");
    return this.status !== "notInitialized";
  }
  async finalize() {
    if (this.status === "finalized") {
      return false;
    }
    await this.submitStats();
    if (this.tryingConnectTimer) {
      clearInterval(this.tryingConnectTimer);
    }
    if (this.submitStatsTimer) {
      clearInterval(this.submitStatsTimer);
    }
    this.changeStatus("finalized");
    return true;
  }
  async updateClientProperties(type, key, value) {
    switch (type) {
      case "session":
        allLoggers.forEach((logger2) => logger2.setBindings?.((0, import_dot_prop3.setProperty)({}, key, value)));
        this.anonymousUsageLogger.setSessionProperties(key, value);
        break;
      case "user":
        this.anonymousUsageLogger.setUserProperties(key, value);
        break;
    }
    return true;
  }
  async updateConfig(key, value) {
    const current = (0, import_dot_prop3.getProperty)(this.clientConfig, key);
    if (!(0, import_deep_equal3.default)(current, value)) {
      if (value === void 0) {
        (0, import_dot_prop3.deleteProperty)(this.clientConfig, key);
      } else {
        (0, import_dot_prop3.setProperty)(this.clientConfig, key, value);
      }
      await this.applyConfig();
    }
    return true;
  }
  async clearConfig(key) {
    return await this.updateConfig(key, void 0);
  }
  getConfig() {
    return this.config;
  }
  getStatus() {
    return this.status;
  }
  getIssues() {
    return this.issues;
  }
  getIssueDetail(options2) {
    const issues = this.getIssues();
    if (options2.index !== void 0 && options2.index < issues.length) {
      return this.issueFromName(issues[options2.index]);
    } else if (options2.name !== void 0 && this.issues.includes(options2.name)) {
      return this.issueFromName(options2.name);
    } else {
      return null;
    }
  }
  getServerHealthState() {
    return this.serverHealthState ?? null;
  }
  async requestAuthUrl(options2) {
    if (this.status === "notInitialized") {
      throw new Error("Agent is not initialized");
    }
    await this.healthCheck(options2);
    if (this.status !== "unauthorized" || !this.auth) {
      return null;
    } else {
      return await this.auth.requestAuthUrl(options2);
    }
  }
  async waitForAuthToken(code, options2) {
    if (this.status === "notInitialized") {
      throw new Error("Agent is not initialized");
    }
    if (this.status !== "unauthorized" || !this.auth) {
      return;
    }
    await this.auth.pollingToken(code, options2);
    await this.setupApi();
  }
  async provideCompletions(request, options2) {
    if (this.status === "notInitialized") {
      throw new Error("Agent is not initialized");
    }
    this.logger.trace({ request }, "Call provideCompletions");
    if (this.nonParallelProvideCompletionAbortController) {
      this.nonParallelProvideCompletionAbortController.abort();
    }
    this.nonParallelProvideCompletionAbortController = new AbortController();
    const signal = abortSignalFromAnyOf([this.nonParallelProvideCompletionAbortController.signal, options2?.signal]);
    let completionResponse;
    let stats = {
      triggerMode: request.manually ? "manual" : "auto",
      cacheHit: false,
      aborted: false,
      requestSent: false,
      requestLatency: 0,
      requestCanceled: false,
      requestTimeout: false
    };
    let requestStartedAt;
    const context = new CompletionContext(request);
    try {
      if (this.completionCache.has(context)) {
        stats.cacheHit = true;
        this.logger.debug({ context }, "Completion cache hit");
        await this.completionDebounce.debounce(
          {
            request,
            config: this.config.completion.debounce,
            responseTime: 0
          },
          { signal }
        );
        completionResponse = this.completionCache.get(context);
      } else {
        stats.cacheHit = false;
        const segments = this.createSegments(context);
        if (isBlank(segments.prefix)) {
          stats = void 0;
          this.logger.debug("Segment prefix is blank, returning empty completion response");
          completionResponse = {
            id: "agent-" + (0, import_uuid2.v4)(),
            choices: []
          };
        } else {
          await this.completionDebounce.debounce(
            {
              request,
              config: this.config.completion.debounce,
              responseTime: this.completionProviderStats.windowed().stats.averageResponseTime
            },
            options2
          );
          const requestId = (0, import_uuid2.v4)();
          stats.requestSent = true;
          requestStartedAt = performance.now();
          try {
            if (!this.api) {
              throw new Error("http client not initialized");
            }
            const requestPath = "/v1/completions";
            const requestOptions = {
              body: {
                language: request.language,
                segments,
                user: this.auth?.user
              },
              signal: this.createAbortSignal({ signal })
            };
            this.logger.debug(
              { requestId, requestOptions, url: this.config.server.endpoint + requestPath },
              "Completion request"
            );
            const response = await this.api.POST(requestPath, requestOptions);
            if (response.error || !response.response.ok) {
              throw new HttpError(response.response);
            }
            this.logger.debug({ requestId, response }, "Completion response");
            const responseData = response.data;
            stats.requestLatency = performance.now() - requestStartedAt;
            completionResponse = {
              id: responseData.id,
              choices: responseData.choices.map((choice) => {
                return {
                  index: choice.index,
                  text: choice.text,
                  replaceRange: {
                    start: request.position,
                    end: request.position
                  }
                };
              })
            };
          } catch (error) {
            if (isCanceledError(error)) {
              this.logger.debug({ requestId, error }, "Completion request canceled");
              stats.requestCanceled = true;
              stats.requestLatency = performance.now() - requestStartedAt;
            } else if (isTimeoutError(error)) {
              this.logger.debug({ requestId, error }, "Completion request timeout");
              stats.requestTimeout = true;
              stats.requestLatency = NaN;
            } else {
              this.logger.error({ requestId, error }, "Completion request failed with unknown error");
              this.healthCheck();
            }
            throw error;
          }
          completionResponse = await preCacheProcess(context, this.config.postprocess, completionResponse);
          if (signal.aborted) {
            throw signal.reason;
          }
          this.completionCache.buildCache(context, JSON.parse(JSON.stringify(completionResponse)));
        }
      }
      completionResponse = await postCacheProcess(context, this.config.postprocess, completionResponse);
      if (signal.aborted) {
        throw signal.reason;
      }
    } catch (error) {
      if (isCanceledError(error) || isTimeoutError(error)) {
        if (stats) {
          stats.aborted = true;
        }
      } else {
        stats = void 0;
      }
      throw error;
    } finally {
      if (stats) {
        this.completionProviderStats.add(stats);
        if (stats.requestSent && !stats.requestCanceled) {
          const windowedStats = this.completionProviderStats.windowed();
          const checkResult = this.completionProviderStats.check(windowedStats);
          switch (checkResult) {
            case "healthy":
              this.popIssue("slowCompletionResponseTime");
              this.popIssue("highCompletionTimeoutRate");
              break;
            case "highTimeoutRate":
              this.popIssue("slowCompletionResponseTime");
              this.pushIssue("highCompletionTimeoutRate");
              break;
            case "slowResponseTime":
              this.popIssue("highCompletionTimeoutRate");
              this.pushIssue("slowCompletionResponseTime");
              break;
          }
        }
      }
    }
    this.logger.trace({ context, completionResponse }, "Return from provideCompletions");
    return completionResponse;
  }
  async postEvent(request, options2) {
    if (this.status === "notInitialized") {
      throw new Error("Agent is not initialized");
    }
    this.completionProviderStats.addEvent(request.type);
    const requestId = (0, import_uuid2.v4)();
    try {
      if (!this.api) {
        throw new Error("http client not initialized");
      }
      const requestPath = "/v1/events";
      const requestOptions = {
        body: request,
        params: {
          query: {
            select_kind: request.select_kind
          }
        },
        signal: this.createAbortSignal(options2),
        parseAs: "text"
      };
      this.logger.debug({ requestId, requestOptions, url: this.config.server.endpoint + requestPath }, "Event request");
      const response = await this.api.POST(requestPath, requestOptions);
      if (response.error || !response.response.ok) {
        throw new HttpError(response.response);
      }
      this.logger.debug({ requestId, response }, "Event response");
      return true;
    } catch (error) {
      if (isTimeoutError(error)) {
        this.logger.debug({ requestId, error }, "Event request timeout");
      } else if (isCanceledError(error)) {
        this.logger.debug({ requestId, error }, "Event request canceled");
      } else {
        this.logger.error({ requestId, error }, "Event request failed with unknown error");
      }
      return false;
    }
  }
};

// src/Agent.ts
var agentEventNames = [
  "statusChanged",
  "configUpdated",
  "authRequired",
  "issuesUpdated"
];
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  TabbyAgent,
  agentEventNames
});
//# sourceMappingURL=index.js.map