#!/usr/bin/env node
'use strict';

var events = require('events');
var DO = require('crypto');
var Vx = require('path');
var oT = require('os');
var m3 = require('readline');

function _interopDefault (e) { return e && e.__esModule ? e : { default: e }; }

var DO__default = /*#__PURE__*/_interopDefault(DO);
var Vx__default = /*#__PURE__*/_interopDefault(Vx);
var oT__default = /*#__PURE__*/_interopDefault(oT);
var m3__default = /*#__PURE__*/_interopDefault(m3);

/**
 * Tabby Agent
 * https://github.com/tabbyml/tabby/tree/main/clients/tabby-agent
 * Copyright (c) 2023-2024 TabbyML, Inc.
 * Licensed under the Apache License 2.0.
 */
var SO=Object.create;var Bo=Object.defineProperty;var EO=Object.getOwnPropertyDescriptor;var RO=Object.getOwnPropertyNames;var CO=Object.getPrototypeOf,xO=Object.prototype.hasOwnProperty;var oe=(t=>typeof require<"u"?require:typeof Proxy<"u"?new Proxy(t,{get:(e,r)=>(typeof require<"u"?require:e)[r]}):t)(function(t){if(typeof require<"u")return require.apply(this,arguments);throw Error('Dynamic require of "'+t+'" is not supported')});var TO=(t,e)=>()=>(t&&(e=t(t=0)),e);var A=(t,e)=>()=>(e||t((e={exports:{}}).exports,e),e.exports),AO=(t,e)=>{for(var r in e)Bo(t,r,{get:e[r],enumerable:!0});},Gg=(t,e,r,n)=>{if(e&&typeof e=="object"||typeof e=="function")for(let i of RO(e))!xO.call(t,i)&&i!==r&&Bo(t,i,{get:()=>e[i],enumerable:!(n=EO(e,i))||n.enumerable});return t};var $t=(t,e,r)=>(r=t!=null?SO(CO(t)):{},Gg(e||!t||!t.__esModule?Bo(r,"default",{value:t,enumerable:!0}):r,t)),PO=t=>Gg(Bo({},"__esModule",{value:!0}),t);var vl=A((Jz,Jg)=>{var Zg=Object.prototype.toString;Jg.exports=function(e){var r=Zg.call(e),n=r==="[object Arguments]";return n||(n=r!=="[object Array]"&&e!==null&&typeof e=="object"&&typeof e.length=="number"&&e.length>=0&&Zg.call(e.callee)==="[object Function]"),n};});var s_=A((Yz,i_)=>{var n_;Object.keys||(Ts=Object.prototype.hasOwnProperty,wl=Object.prototype.toString,Yg=vl(),Sl=Object.prototype.propertyIsEnumerable,Xg=!Sl.call({toString:null},"toString"),Qg=Sl.call(function(){},"prototype"),As=["toString","toLocaleString","valueOf","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","constructor"],Vo=function(t){var e=t.constructor;return e&&e.prototype===t},e_={$applicationCache:!0,$console:!0,$external:!0,$frame:!0,$frameElement:!0,$frames:!0,$innerHeight:!0,$innerWidth:!0,$onmozfullscreenchange:!0,$onmozfullscreenerror:!0,$outerHeight:!0,$outerWidth:!0,$pageXOffset:!0,$pageYOffset:!0,$parent:!0,$scrollLeft:!0,$scrollTop:!0,$scrollX:!0,$scrollY:!0,$self:!0,$webkitIndexedDB:!0,$webkitStorageInfo:!0,$window:!0},t_=function(){if(typeof window>"u")return !1;for(var t in window)try{if(!e_["$"+t]&&Ts.call(window,t)&&window[t]!==null&&typeof window[t]=="object")try{Vo(window[t]);}catch{return !0}}catch{return !0}return !1}(),r_=function(t){if(typeof window>"u"||!t_)return Vo(t);try{return Vo(t)}catch{return !1}},n_=function(e){var r=e!==null&&typeof e=="object",n=wl.call(e)==="[object Function]",i=Yg(e),s=r&&wl.call(e)==="[object String]",o=[];if(!r&&!n&&!i)throw new TypeError("Object.keys called on a non-object");var a=Qg&&n;if(s&&e.length>0&&!Ts.call(e,0))for(var l=0;l<e.length;++l)o.push(String(l));if(i&&e.length>0)for(var d=0;d<e.length;++d)o.push(String(d));else for(var c in e)!(a&&c==="prototype")&&Ts.call(e,c)&&o.push(String(c));if(Xg)for(var p=r_(e),m=0;m<As.length;++m)!(p&&As[m]==="constructor")&&Ts.call(e,As[m])&&o.push(As[m]);return o});var Ts,wl,Yg,Sl,Xg,Qg,As,Vo,e_,t_,r_;i_.exports=n_;});var Ko=A((Xz,u_)=>{var kO=Array.prototype.slice,MO=vl(),o_=Object.keys,Go=o_?function(e){return o_(e)}:s_(),a_=Object.keys;Go.shim=function(){if(Object.keys){var e=function(){var r=Object.keys(arguments);return r&&r.length===arguments.length}(1,2);e||(Object.keys=function(n){return MO(n)?a_(kO.call(n)):a_(n)});}else Object.keys=Go;return Object.keys||Go};u_.exports=Go;});var Zo=A((Qz,c_)=>{c_.exports=function(){if(typeof Symbol!="function"||typeof Object.getOwnPropertySymbols!="function")return !1;if(typeof Symbol.iterator=="symbol")return !0;var e={},r=Symbol("test"),n=Object(r);if(typeof r=="string"||Object.prototype.toString.call(r)!=="[object Symbol]"||Object.prototype.toString.call(n)!=="[object Symbol]")return !1;var i=42;e[r]=i;for(r in e)return !1;if(typeof Object.keys=="function"&&Object.keys(e).length!==0||typeof Object.getOwnPropertyNames=="function"&&Object.getOwnPropertyNames(e).length!==0)return !1;var s=Object.getOwnPropertySymbols(e);if(s.length!==1||s[0]!==r||!Object.prototype.propertyIsEnumerable.call(e,r))return !1;if(typeof Object.getOwnPropertyDescriptor=="function"){var o=Object.getOwnPropertyDescriptor(e,r);if(o.value!==i||o.enumerable!==!0)return !1}return !0};});var El=A((e6,f_)=>{var l_=typeof Symbol<"u"&&Symbol,FO=Zo();f_.exports=function(){return typeof l_!="function"||typeof Symbol!="function"||typeof l_("foo")!="symbol"||typeof Symbol("bar")!="symbol"?!1:FO()};});var p_=A((t6,h_)=>{var d_={foo:{}},NO=Object;h_.exports=function(){return {__proto__:d_}.foo===d_.foo&&!({__proto__:null}instanceof NO)};});var __=A((r6,g_)=>{var qO="Function.prototype.bind called on incompatible ",LO=Object.prototype.toString,$O=Math.max,jO="[object Function]",m_=function(e,r){for(var n=[],i=0;i<e.length;i+=1)n[i]=e[i];for(var s=0;s<r.length;s+=1)n[s+e.length]=r[s];return n},HO=function(e,r){for(var n=[],i=r||0,s=0;i<e.length;i+=1,s+=1)n[s]=e[i];return n},WO=function(t,e){for(var r="",n=0;n<t.length;n+=1)r+=t[n],n+1<t.length&&(r+=e);return r};g_.exports=function(e){var r=this;if(typeof r!="function"||LO.apply(r)!==jO)throw new TypeError(qO+r);for(var n=HO(arguments,1),i,s=function(){if(this instanceof i){var c=r.apply(this,m_(n,arguments));return Object(c)===c?c:this}return r.apply(e,m_(n,arguments))},o=$O(0,r.length-n.length),a=[],l=0;l<o;l++)a[l]="$"+l;if(i=Function("binder","return function ("+WO(a,",")+"){ return binder.apply(this,arguments); }")(s),r.prototype){var d=function(){};d.prototype=r.prototype,i.prototype=new d,d.prototype=null;}return i};});var Jo=A((n6,y_)=>{var BO=__();y_.exports=Function.prototype.bind||BO;});var v_=A((i6,b_)=>{var UO=Function.prototype.call,zO=Object.prototype.hasOwnProperty,VO=Jo();b_.exports=VO.call(UO,zO);});var Ar=A((s6,C_)=>{var De,xi=SyntaxError,R_=Function,Ci=TypeError,Rl=function(t){try{return R_('"use strict"; return ('+t+").constructor;")()}catch{}},Vn=Object.getOwnPropertyDescriptor;var Cl=function(){throw new Ci},GO=Vn?function(){try{return Cl}catch{try{return Vn(arguments,"callee").get}catch{return Cl}}}():Cl,Ei=El()(),KO=p_()(),gt=Object.getPrototypeOf||(KO?function(t){return t.__proto__}:null),Ri={},ZO=typeof Uint8Array>"u"||!gt?De:gt(Uint8Array),Gn={"%AggregateError%":typeof AggregateError>"u"?De:AggregateError,"%Array%":Array,"%ArrayBuffer%":typeof ArrayBuffer>"u"?De:ArrayBuffer,"%ArrayIteratorPrototype%":Ei&&gt?gt([][Symbol.iterator]()):De,"%AsyncFromSyncIteratorPrototype%":De,"%AsyncFunction%":Ri,"%AsyncGenerator%":Ri,"%AsyncGeneratorFunction%":Ri,"%AsyncIteratorPrototype%":Ri,"%Atomics%":typeof Atomics>"u"?De:Atomics,"%BigInt%":typeof BigInt>"u"?De:BigInt,"%BigInt64Array%":typeof BigInt64Array>"u"?De:BigInt64Array,"%BigUint64Array%":typeof BigUint64Array>"u"?De:BigUint64Array,"%Boolean%":Boolean,"%DataView%":typeof DataView>"u"?De:DataView,"%Date%":Date,"%decodeURI%":decodeURI,"%decodeURIComponent%":decodeURIComponent,"%encodeURI%":encodeURI,"%encodeURIComponent%":encodeURIComponent,"%Error%":Error,"%eval%":eval,"%EvalError%":EvalError,"%Float32Array%":typeof Float32Array>"u"?De:Float32Array,"%Float64Array%":typeof Float64Array>"u"?De:Float64Array,"%FinalizationRegistry%":typeof FinalizationRegistry>"u"?De:FinalizationRegistry,"%Function%":R_,"%GeneratorFunction%":Ri,"%Int8Array%":typeof Int8Array>"u"?De:Int8Array,"%Int16Array%":typeof Int16Array>"u"?De:Int16Array,"%Int32Array%":typeof Int32Array>"u"?De:Int32Array,"%isFinite%":isFinite,"%isNaN%":isNaN,"%IteratorPrototype%":Ei&&gt?gt(gt([][Symbol.iterator]())):De,"%JSON%":typeof JSON=="object"?JSON:De,"%Map%":typeof Map>"u"?De:Map,"%MapIteratorPrototype%":typeof Map>"u"||!Ei||!gt?De:gt(new Map()[Symbol.iterator]()),"%Math%":Math,"%Number%":Number,"%Object%":Object,"%parseFloat%":parseFloat,"%parseInt%":parseInt,"%Promise%":typeof Promise>"u"?De:Promise,"%Proxy%":typeof Proxy>"u"?De:Proxy,"%RangeError%":RangeError,"%ReferenceError%":ReferenceError,"%Reflect%":typeof Reflect>"u"?De:Reflect,"%RegExp%":RegExp,"%Set%":typeof Set>"u"?De:Set,"%SetIteratorPrototype%":typeof Set>"u"||!Ei||!gt?De:gt(new Set()[Symbol.iterator]()),"%SharedArrayBuffer%":typeof SharedArrayBuffer>"u"?De:SharedArrayBuffer,"%String%":String,"%StringIteratorPrototype%":Ei&&gt?gt(""[Symbol.iterator]()):De,"%Symbol%":Ei?Symbol:De,"%SyntaxError%":xi,"%ThrowTypeError%":GO,"%TypedArray%":ZO,"%TypeError%":Ci,"%Uint8Array%":typeof Uint8Array>"u"?De:Uint8Array,"%Uint8ClampedArray%":typeof Uint8ClampedArray>"u"?De:Uint8ClampedArray,"%Uint16Array%":typeof Uint16Array>"u"?De:Uint16Array,"%Uint32Array%":typeof Uint32Array>"u"?De:Uint32Array,"%URIError%":URIError,"%WeakMap%":typeof WeakMap>"u"?De:WeakMap,"%WeakRef%":typeof WeakRef>"u"?De:WeakRef,"%WeakSet%":typeof WeakSet>"u"?De:WeakSet};var JO=function t(e){var r;if(e==="%AsyncFunction%")r=Rl("async function () {}");else if(e==="%GeneratorFunction%")r=Rl("function* () {}");else if(e==="%AsyncGeneratorFunction%")r=Rl("async function* () {}");else if(e==="%AsyncGenerator%"){var n=t("%AsyncGeneratorFunction%");n&&(r=n.prototype);}else if(e==="%AsyncIteratorPrototype%"){var i=t("%AsyncGenerator%");i&&gt&&(r=gt(i.prototype));}return Gn[e]=r,r},S_={"%ArrayBufferPrototype%":["ArrayBuffer","prototype"],"%ArrayPrototype%":["Array","prototype"],"%ArrayProto_entries%":["Array","prototype","entries"],"%ArrayProto_forEach%":["Array","prototype","forEach"],"%ArrayProto_keys%":["Array","prototype","keys"],"%ArrayProto_values%":["Array","prototype","values"],"%AsyncFunctionPrototype%":["AsyncFunction","prototype"],"%AsyncGenerator%":["AsyncGeneratorFunction","prototype"],"%AsyncGeneratorPrototype%":["AsyncGeneratorFunction","prototype","prototype"],"%BooleanPrototype%":["Boolean","prototype"],"%DataViewPrototype%":["DataView","prototype"],"%DatePrototype%":["Date","prototype"],"%ErrorPrototype%":["Error","prototype"],"%EvalErrorPrototype%":["EvalError","prototype"],"%Float32ArrayPrototype%":["Float32Array","prototype"],"%Float64ArrayPrototype%":["Float64Array","prototype"],"%FunctionPrototype%":["Function","prototype"],"%Generator%":["GeneratorFunction","prototype"],"%GeneratorPrototype%":["GeneratorFunction","prototype","prototype"],"%Int8ArrayPrototype%":["Int8Array","prototype"],"%Int16ArrayPrototype%":["Int16Array","prototype"],"%Int32ArrayPrototype%":["Int32Array","prototype"],"%JSONParse%":["JSON","parse"],"%JSONStringify%":["JSON","stringify"],"%MapPrototype%":["Map","prototype"],"%NumberPrototype%":["Number","prototype"],"%ObjectPrototype%":["Object","prototype"],"%ObjProto_toString%":["Object","prototype","toString"],"%ObjProto_valueOf%":["Object","prototype","valueOf"],"%PromisePrototype%":["Promise","prototype"],"%PromiseProto_then%":["Promise","prototype","then"],"%Promise_all%":["Promise","all"],"%Promise_reject%":["Promise","reject"],"%Promise_resolve%":["Promise","resolve"],"%RangeErrorPrototype%":["RangeError","prototype"],"%ReferenceErrorPrototype%":["ReferenceError","prototype"],"%RegExpPrototype%":["RegExp","prototype"],"%SetPrototype%":["Set","prototype"],"%SharedArrayBufferPrototype%":["SharedArrayBuffer","prototype"],"%StringPrototype%":["String","prototype"],"%SymbolPrototype%":["Symbol","prototype"],"%SyntaxErrorPrototype%":["SyntaxError","prototype"],"%TypedArrayPrototype%":["TypedArray","prototype"],"%TypeErrorPrototype%":["TypeError","prototype"],"%Uint8ArrayPrototype%":["Uint8Array","prototype"],"%Uint8ClampedArrayPrototype%":["Uint8ClampedArray","prototype"],"%Uint16ArrayPrototype%":["Uint16Array","prototype"],"%Uint32ArrayPrototype%":["Uint32Array","prototype"],"%URIErrorPrototype%":["URIError","prototype"],"%WeakMapPrototype%":["WeakMap","prototype"],"%WeakSetPrototype%":["WeakSet","prototype"]},Ps=Jo(),Yo=v_(),YO=Ps.call(Function.call,Array.prototype.concat),XO=Ps.call(Function.apply,Array.prototype.splice),E_=Ps.call(Function.call,String.prototype.replace),Xo=Ps.call(Function.call,String.prototype.slice),QO=Ps.call(Function.call,RegExp.prototype.exec),eI=/[^%.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|%$))/g,tI=/\\(\\)?/g,rI=function(e){var r=Xo(e,0,1),n=Xo(e,-1);if(r==="%"&&n!=="%")throw new xi("invalid intrinsic syntax, expected closing `%`");if(n==="%"&&r!=="%")throw new xi("invalid intrinsic syntax, expected opening `%`");var i=[];return E_(e,eI,function(s,o,a,l){i[i.length]=a?E_(l,tI,"$1"):o||s;}),i},nI=function(e,r){var n=e,i;if(Yo(S_,n)&&(i=S_[n],n="%"+i[0]+"%"),Yo(Gn,n)){var s=Gn[n];if(s===Ri&&(s=JO(n)),typeof s>"u"&&!r)throw new Ci("intrinsic "+e+" exists, but is not available. Please file an issue!");return {alias:i,name:n,value:s}}throw new xi("intrinsic "+e+" does not exist!")};C_.exports=function(e,r){if(typeof e!="string"||e.length===0)throw new Ci("intrinsic name must be a non-empty string");if(arguments.length>1&&typeof r!="boolean")throw new Ci('"allowMissing" argument must be a boolean');if(QO(/^%?[^%]*%?$/,e)===null)throw new xi("`%` may not be present anywhere but at the beginning and end of the intrinsic name");var n=rI(e),i=n.length>0?n[0]:"",s=nI("%"+i+"%",r),o=s.name,a=s.value,l=!1,d=s.alias;d&&(i=d[0],XO(n,YO([0,1],d)));for(var c=1,p=!0;c<n.length;c+=1){var m=n[c],_=Xo(m,0,1),w=Xo(m,-1);if((_==='"'||_==="'"||_==="`"||w==='"'||w==="'"||w==="`")&&_!==w)throw new xi("property names with quotes must have matching quotes");if((m==="constructor"||!p)&&(l=!0),i+="."+m,o="%"+i+"%",Yo(Gn,o))a=Gn[o];else if(a!=null){if(!(m in a)){if(!r)throw new Ci("base intrinsic for "+e+" exists, but the property is not available.");return}if(Vn&&c+1>=n.length){var E=Vn(a,m);p=!!E,p&&"get"in E&&!("originalValue"in E.get)?a=E.get:a=a[m];}else p=Yo(a,m),a=a[m];p&&!l&&(Gn[o]=a);}}return a};});var Ds=A((o6,x_)=>{var iI=Ar(),xl=iI("%Object.defineProperty%",!0),Tl=function(){if(xl)try{return xl({},"a",{value:1}),!0}catch{return !1}return !1};Tl.hasArrayLengthDefineBug=function(){if(!Tl())return null;try{return xl([],"length",{value:1}).length!==1}catch{return !0}};x_.exports=Tl;});var ea=A((a6,T_)=>{var sI=Ar(),Qo=sI("%Object.getOwnPropertyDescriptor%",!0);if(Qo)try{Qo([],"length");}catch{Qo=null;}T_.exports=Qo;});var ta=A((u6,P_)=>{var oI=Ds()(),Al=Ar(),Os=oI&&Al("%Object.defineProperty%",!0);if(Os)try{Os({},"a",{value:1});}catch{Os=!1;}var aI=Al("%SyntaxError%"),Ti=Al("%TypeError%"),A_=ea();P_.exports=function(e,r,n){if(!e||typeof e!="object"&&typeof e!="function")throw new Ti("`obj` must be an object or a function`");if(typeof r!="string"&&typeof r!="symbol")throw new Ti("`property` must be a string or a symbol`");if(arguments.length>3&&typeof arguments[3]!="boolean"&&arguments[3]!==null)throw new Ti("`nonEnumerable`, if provided, must be a boolean or null");if(arguments.length>4&&typeof arguments[4]!="boolean"&&arguments[4]!==null)throw new Ti("`nonWritable`, if provided, must be a boolean or null");if(arguments.length>5&&typeof arguments[5]!="boolean"&&arguments[5]!==null)throw new Ti("`nonConfigurable`, if provided, must be a boolean or null");if(arguments.length>6&&typeof arguments[6]!="boolean")throw new Ti("`loose`, if provided, must be a boolean");var i=arguments.length>3?arguments[3]:null,s=arguments.length>4?arguments[4]:null,o=arguments.length>5?arguments[5]:null,a=arguments.length>6?arguments[6]:!1,l=!!A_&&A_(e,r);if(Os)Os(e,r,{configurable:o===null&&l?l.configurable:!o,enumerable:i===null&&l?l.enumerable:!i,value:n,writable:s===null&&l?l.writable:!s});else if(a||!i&&!s&&!o)e[r]=n;else throw new aI("This environment does not support defining a property as non-configurable, non-writable, or non-enumerable.")};});var gn=A((c6,k_)=>{var uI=Ko(),cI=typeof Symbol=="function"&&typeof Symbol("foo")=="symbol",lI=Object.prototype.toString,fI=Array.prototype.concat,D_=ta(),dI=function(t){return typeof t=="function"&&lI.call(t)==="[object Function]"},O_=Ds()(),hI=function(t,e,r,n){if(e in t){if(n===!0){if(t[e]===r)return}else if(!dI(n)||!n())return}O_?D_(t,e,r,!0):D_(t,e,r);},I_=function(t,e){var r=arguments.length>2?arguments[2]:{},n=uI(e);cI&&(n=fI.call(n,Object.getOwnPropertySymbols(e)));for(var i=0;i<n.length;i+=1)hI(t,n[i],e[n[i]],r[n[i]]);};I_.supportsDescriptors=!!O_;k_.exports=I_;});var $_=A((l6,L_)=>{var q_=Ar(),M_=ta(),pI=Ds()(),F_=ea(),N_=q_("%TypeError%"),mI=q_("%Math.floor%");L_.exports=function(e,r){if(typeof e!="function")throw new N_("`fn` is not a function");if(typeof r!="number"||r<0||r>4294967295||mI(r)!==r)throw new N_("`length` must be a positive 32-bit integer");var n=arguments.length>2&&!!arguments[2],i=!0,s=!0;if("length"in e&&F_){var o=F_(e,"length");o&&!o.configurable&&(i=!1),o&&!o.writable&&(s=!1);}return (i||s||!n)&&(pI?M_(e,"length",r,!0,!0):M_(e,"length",r)),e};});var Kn=A((f6,ra)=>{var Pl=Jo(),Ai=Ar(),gI=$_(),_I=Ai("%TypeError%"),H_=Ai("%Function.prototype.apply%"),W_=Ai("%Function.prototype.call%"),B_=Ai("%Reflect.apply%",!0)||Pl.call(W_,H_),Is=Ai("%Object.defineProperty%",!0),yI=Ai("%Math.max%");if(Is)try{Is({},"a",{value:1});}catch{Is=null;}ra.exports=function(e){if(typeof e!="function")throw new _I("a function is required");var r=B_(Pl,W_,arguments);return gI(r,1+yI(0,e.length-(arguments.length-1)),!0)};var j_=function(){return B_(Pl,H_,arguments)};Is?Is(ra.exports,"apply",{value:j_}):ra.exports.apply=j_;});var mr=A((d6,V_)=>{var U_=Ar(),z_=Kn(),bI=z_(U_("String.prototype.indexOf"));V_.exports=function(e,r){var n=U_(e,!!r);return typeof n=="function"&&bI(e,".prototype.")>-1?z_(n):n};});var Dl=A((h6,Y_)=>{var vI=Ko(),Z_=Zo()(),J_=mr(),G_=Object,wI=J_("Array.prototype.push"),K_=J_("Object.prototype.propertyIsEnumerable"),SI=Z_?Object.getOwnPropertySymbols:null;Y_.exports=function(e,r){if(e==null)throw new TypeError("target must be an object");var n=G_(e);if(arguments.length===1)return n;for(var i=1;i<arguments.length;++i){var s=G_(arguments[i]),o=vI(s),a=Z_&&(Object.getOwnPropertySymbols||SI);if(a)for(var l=a(s),d=0;d<l.length;++d){var c=l[d];K_(s,c)&&wI(o,c);}for(var p=0;p<o.length;++p){var m=o[p];if(K_(s,m)){var _=s[m];n[m]=_;}}}return n};});var Il=A((p6,X_)=>{var Ol=Dl(),EI=function(){if(!Object.assign)return !1;for(var t="abcdefghijklmnopqrst",e=t.split(""),r={},n=0;n<e.length;++n)r[e[n]]=e[n];var i=Object.assign({},r),s="";for(var o in i)s+=o;return t!==s},RI=function(){if(!Object.assign||!Object.preventExtensions)return !1;var t=Object.preventExtensions({1:2});try{Object.assign(t,"xy");}catch{return t[1]==="y"}return !1};X_.exports=function(){return !Object.assign||EI()||RI()?Ol:Object.assign};});var ey=A((m6,Q_)=>{var CI=gn(),xI=Il();Q_.exports=function(){var e=xI();return CI(Object,{assign:e},{assign:function(){return Object.assign!==e}}),e};});var iy=A((g6,ny)=>{var TI=gn(),AI=Kn(),PI=Dl(),ty=Il(),DI=ey(),OI=AI.apply(ty()),ry=function(e,r){return OI(Object,arguments)};TI(ry,{getPolyfill:ty,implementation:PI,shim:DI});ny.exports=ry;});var oy=A((_6,sy)=>{var Ms=function(){return typeof function(){}.name=="string"},ks=Object.getOwnPropertyDescriptor;Ms.functionsHaveConfigurableNames=function(){if(!Ms()||!ks)return !1;var e=ks(function(){},"name");return !!e&&!!e.configurable};var II=Function.prototype.bind;Ms.boundFunctionsHaveNames=function(){return Ms()&&typeof II=="function"&&function(){}.bind().name!==""};sy.exports=Ms;});var cy=A((y6,uy)=>{var ay=ta(),kI=Ds()(),MI=oy().functionsHaveConfigurableNames(),FI=TypeError;uy.exports=function(e,r){if(typeof e!="function")throw new FI("`fn` is not a function");var n=arguments.length>2&&!!arguments[2];return (!n||MI)&&(kI?ay(e,"name",r,!0,!0):ay(e,"name",r)),e};});var kl=A((b6,ly)=>{var NI=cy(),qI=Object,LI=TypeError;ly.exports=NI(function(){if(this!=null&&this!==qI(this))throw new LI("RegExp.prototype.flags getter called on non-object");var e="";return this.hasIndices&&(e+="d"),this.global&&(e+="g"),this.ignoreCase&&(e+="i"),this.multiline&&(e+="m"),this.dotAll&&(e+="s"),this.unicode&&(e+="u"),this.unicodeSets&&(e+="v"),this.sticky&&(e+="y"),e},"get flags",!0);});var Ml=A((v6,fy)=>{var $I=kl(),jI=gn().supportsDescriptors,HI=Object.getOwnPropertyDescriptor;fy.exports=function(){if(jI&&/a/mig.flags==="gim"){var e=HI(RegExp.prototype,"flags");if(e&&typeof e.get=="function"&&typeof RegExp.prototype.dotAll=="boolean"&&typeof RegExp.prototype.hasIndices=="boolean"){var r="",n={};if(Object.defineProperty(n,"hasIndices",{get:function(){r+="d";}}),Object.defineProperty(n,"sticky",{get:function(){r+="y";}}),r==="dy")return e.get}}return $I};});var py=A((w6,hy)=>{var WI=gn().supportsDescriptors,BI=Ml(),UI=Object.getOwnPropertyDescriptor,zI=Object.defineProperty,VI=TypeError,dy=Object.getPrototypeOf,GI=/a/;hy.exports=function(){if(!WI||!dy)throw new VI("RegExp.prototype.flags requires a true ES5 environment that supports property descriptors");var e=BI(),r=dy(GI),n=UI(r,"flags");return (!n||n.get!==e)&&zI(r,"flags",{configurable:!0,enumerable:!1,get:e}),e};});var yy=A((S6,_y)=>{var KI=gn(),ZI=Kn(),JI=kl(),my=Ml(),YI=py(),gy=ZI(my());KI(gy,{getPolyfill:my,implementation:JI,shim:YI});_y.exports=gy;});var wy=A((E6,vy)=>{var by=Symbol.iterator;vy.exports=function(e){if(e!=null&&typeof e[by]<"u")return e[by]()};});var Ey=A((R6,Sy)=>{Sy.exports=oe("util").inspect;});var By=A((C6,Wy)=>{var Ul=typeof Map=="function"&&Map.prototype,Fl=Object.getOwnPropertyDescriptor&&Ul?Object.getOwnPropertyDescriptor(Map.prototype,"size"):null,ia=Ul&&Fl&&typeof Fl.get=="function"?Fl.get:null,Ry=Ul&&Map.prototype.forEach,zl=typeof Set=="function"&&Set.prototype,Nl=Object.getOwnPropertyDescriptor&&zl?Object.getOwnPropertyDescriptor(Set.prototype,"size"):null,sa=zl&&Nl&&typeof Nl.get=="function"?Nl.get:null,Cy=zl&&Set.prototype.forEach,XI=typeof WeakMap=="function"&&WeakMap.prototype,Ns=XI?WeakMap.prototype.has:null,QI=typeof WeakSet=="function"&&WeakSet.prototype,qs=QI?WeakSet.prototype.has:null,ek=typeof WeakRef=="function"&&WeakRef.prototype,xy=ek?WeakRef.prototype.deref:null,tk=Boolean.prototype.valueOf,rk=Object.prototype.toString,nk=Function.prototype.toString,ik=String.prototype.match,Vl=String.prototype.slice,yn=String.prototype.replace,sk=String.prototype.toUpperCase,Ty=String.prototype.toLowerCase,Ny=RegExp.prototype.test,Ay=Array.prototype.concat,$r=Array.prototype.join,ok=Array.prototype.slice,Py=Math.floor,$l=typeof BigInt=="function"?BigInt.prototype.valueOf:null,ql=Object.getOwnPropertySymbols,jl=typeof Symbol=="function"&&typeof Symbol.iterator=="symbol"?Symbol.prototype.toString:null,Pi=typeof Symbol=="function"&&typeof Symbol.iterator=="object",Dt=typeof Symbol=="function"&&Symbol.toStringTag&&(typeof Symbol.toStringTag===Pi||!0)?Symbol.toStringTag:null,qy=Object.prototype.propertyIsEnumerable,Dy=(typeof Reflect=="function"?Reflect.getPrototypeOf:Object.getPrototypeOf)||([].__proto__===Array.prototype?function(t){return t.__proto__}:null);function Oy(t,e){if(t===1/0||t===-1/0||t!==t||t&&t>-1e3&&t<1e3||Ny.call(/e/,e))return e;var r=/[0-9](?=(?:[0-9]{3})+(?![0-9]))/g;if(typeof t=="number"){var n=t<0?-Py(-t):Py(t);if(n!==t){var i=String(n),s=Vl.call(e,i.length+1);return yn.call(i,r,"$&_")+"."+yn.call(yn.call(s,/([0-9]{3})/g,"$&_"),/_$/,"")}}return yn.call(e,r,"$&_")}var Hl=Ey(),Iy=Hl.custom,ky=$y(Iy)?Iy:null;Wy.exports=function t(e,r,n,i){var s=r||{};if(_n(s,"quoteStyle")&&s.quoteStyle!=="single"&&s.quoteStyle!=="double")throw new TypeError('option "quoteStyle" must be "single" or "double"');if(_n(s,"maxStringLength")&&(typeof s.maxStringLength=="number"?s.maxStringLength<0&&s.maxStringLength!==1/0:s.maxStringLength!==null))throw new TypeError('option "maxStringLength", if provided, must be a positive integer, Infinity, or `null`');var o=_n(s,"customInspect")?s.customInspect:!0;if(typeof o!="boolean"&&o!=="symbol")throw new TypeError("option \"customInspect\", if provided, must be `true`, `false`, or `'symbol'`");if(_n(s,"indent")&&s.indent!==null&&s.indent!=="	"&&!(parseInt(s.indent,10)===s.indent&&s.indent>0))throw new TypeError('option "indent" must be "\\t", an integer > 0, or `null`');if(_n(s,"numericSeparator")&&typeof s.numericSeparator!="boolean")throw new TypeError('option "numericSeparator", if provided, must be `true` or `false`');var a=s.numericSeparator;if(typeof e>"u")return "undefined";if(e===null)return "null";if(typeof e=="boolean")return e?"true":"false";if(typeof e=="string")return Hy(e,s);if(typeof e=="number"){if(e===0)return 1/0/e>0?"0":"-0";var l=String(e);return a?Oy(e,l):l}if(typeof e=="bigint"){var d=String(e)+"n";return a?Oy(e,d):d}var c=typeof s.depth>"u"?5:s.depth;if(typeof n>"u"&&(n=0),n>=c&&c>0&&typeof e=="object")return Wl(e)?"[Array]":"[Object]";var p=Rk(s,n);if(typeof i>"u")i=[];else if(jy(i,e)>=0)return "[Circular]";function m(ae,ye,q){if(ye&&(i=ok.call(i),i.push(ye)),q){var W={depth:s.depth};return _n(s,"quoteStyle")&&(W.quoteStyle=s.quoteStyle),t(ae,W,n+1,i)}return t(ae,s,n+1,i)}if(typeof e=="function"&&!My(e)){var _=mk(e),w=na(e,m);return "[Function"+(_?": "+_:" (anonymous)")+"]"+(w.length>0?" { "+$r.call(w,", ")+" }":"")}if($y(e)){var E=Pi?yn.call(String(e),/^(Symbol\(.*\))_[^)]*$/,"$1"):jl.call(e);return typeof e=="object"&&!Pi?Fs(E):E}if(wk(e)){for(var P="<"+Ty.call(String(e.nodeName)),D=e.attributes||[],g=0;g<D.length;g++)P+=" "+D[g].name+"="+Ly(ak(D[g].value),"double",s);return P+=">",e.childNodes&&e.childNodes.length&&(P+="..."),P+="</"+Ty.call(String(e.nodeName))+">",P}if(Wl(e)){if(e.length===0)return "[]";var S=na(e,m);return p&&!Ek(S)?"["+Bl(S,p)+"]":"[ "+$r.call(S,", ")+" ]"}if(ck(e)){var I=na(e,m);return !("cause"in Error.prototype)&&"cause"in e&&!qy.call(e,"cause")?"{ ["+String(e)+"] "+$r.call(Ay.call("[cause]: "+m(e.cause),I),", ")+" }":I.length===0?"["+String(e)+"]":"{ ["+String(e)+"] "+$r.call(I,", ")+" }"}if(typeof e=="object"&&o){if(ky&&typeof e[ky]=="function"&&Hl)return Hl(e,{depth:c-n});if(o!=="symbol"&&typeof e.inspect=="function")return e.inspect()}if(gk(e)){var L=[];return Ry&&Ry.call(e,function(ae,ye){L.push(m(ye,e,!0)+" => "+m(ae,e));}),Fy("Map",ia.call(e),L,p)}if(bk(e)){var Z=[];return Cy&&Cy.call(e,function(ae){Z.push(m(ae,e));}),Fy("Set",sa.call(e),Z,p)}if(_k(e))return Ll("WeakMap");if(vk(e))return Ll("WeakSet");if(yk(e))return Ll("WeakRef");if(fk(e))return Fs(m(Number(e)));if(hk(e))return Fs(m($l.call(e)));if(dk(e))return Fs(tk.call(e));if(lk(e))return Fs(m(String(e)));if(typeof window<"u"&&e===window)return "{ [object Window] }";if(e===global)return "{ [object globalThis] }";if(!uk(e)&&!My(e)){var K=na(e,m),U=Dy?Dy(e)===Object.prototype:e instanceof Object||e.constructor===Object,B=e instanceof Object?"":"null prototype",Q=!U&&Dt&&Object(e)===e&&Dt in e?Vl.call(bn(e),8,-1):B?"Object":"",N=U||typeof e.constructor!="function"?"":e.constructor.name?e.constructor.name+" ":"",te=N+(Q||B?"["+$r.call(Ay.call([],Q||[],B||[]),": ")+"] ":"");return K.length===0?te+"{}":p?te+"{"+Bl(K,p)+"}":te+"{ "+$r.call(K,", ")+" }"}return String(e)};function Ly(t,e,r){var n=(r.quoteStyle||e)==="double"?'"':"'";return n+t+n}function ak(t){return yn.call(String(t),/"/g,"&quot;")}function Wl(t){return bn(t)==="[object Array]"&&(!Dt||!(typeof t=="object"&&Dt in t))}function uk(t){return bn(t)==="[object Date]"&&(!Dt||!(typeof t=="object"&&Dt in t))}function My(t){return bn(t)==="[object RegExp]"&&(!Dt||!(typeof t=="object"&&Dt in t))}function ck(t){return bn(t)==="[object Error]"&&(!Dt||!(typeof t=="object"&&Dt in t))}function lk(t){return bn(t)==="[object String]"&&(!Dt||!(typeof t=="object"&&Dt in t))}function fk(t){return bn(t)==="[object Number]"&&(!Dt||!(typeof t=="object"&&Dt in t))}function dk(t){return bn(t)==="[object Boolean]"&&(!Dt||!(typeof t=="object"&&Dt in t))}function $y(t){if(Pi)return t&&typeof t=="object"&&t instanceof Symbol;if(typeof t=="symbol")return !0;if(!t||typeof t!="object"||!jl)return !1;try{return jl.call(t),!0}catch{}return !1}function hk(t){if(!t||typeof t!="object"||!$l)return !1;try{return $l.call(t),!0}catch{}return !1}var pk=Object.prototype.hasOwnProperty||function(t){return t in this};function _n(t,e){return pk.call(t,e)}function bn(t){return rk.call(t)}function mk(t){if(t.name)return t.name;var e=ik.call(nk.call(t),/^function\s*([\w$]+)/);return e?e[1]:null}function jy(t,e){if(t.indexOf)return t.indexOf(e);for(var r=0,n=t.length;r<n;r++)if(t[r]===e)return r;return -1}function gk(t){if(!ia||!t||typeof t!="object")return !1;try{ia.call(t);try{sa.call(t);}catch{return !0}return t instanceof Map}catch{}return !1}function _k(t){if(!Ns||!t||typeof t!="object")return !1;try{Ns.call(t,Ns);try{qs.call(t,qs);}catch{return !0}return t instanceof WeakMap}catch{}return !1}function yk(t){if(!xy||!t||typeof t!="object")return !1;try{return xy.call(t),!0}catch{}return !1}function bk(t){if(!sa||!t||typeof t!="object")return !1;try{sa.call(t);try{ia.call(t);}catch{return !0}return t instanceof Set}catch{}return !1}function vk(t){if(!qs||!t||typeof t!="object")return !1;try{qs.call(t,qs);try{Ns.call(t,Ns);}catch{return !0}return t instanceof WeakSet}catch{}return !1}function wk(t){return !t||typeof t!="object"?!1:typeof HTMLElement<"u"&&t instanceof HTMLElement?!0:typeof t.nodeName=="string"&&typeof t.getAttribute=="function"}function Hy(t,e){if(t.length>e.maxStringLength){var r=t.length-e.maxStringLength,n="... "+r+" more character"+(r>1?"s":"");return Hy(Vl.call(t,0,e.maxStringLength),e)+n}var i=yn.call(yn.call(t,/(['\\])/g,"\\$1"),/[\x00-\x1f]/g,Sk);return Ly(i,"single",e)}function Sk(t){var e=t.charCodeAt(0),r={8:"b",9:"t",10:"n",12:"f",13:"r"}[e];return r?"\\"+r:"\\x"+(e<16?"0":"")+sk.call(e.toString(16))}function Fs(t){return "Object("+t+")"}function Ll(t){return t+" { ? }"}function Fy(t,e,r,n){var i=n?Bl(r,n):$r.call(r,", ");return t+" ("+e+") {"+i+"}"}function Ek(t){for(var e=0;e<t.length;e++)if(jy(t[e],`
`)>=0)return !1;return !0}function Rk(t,e){var r;if(t.indent==="	")r="	";else if(typeof t.indent=="number"&&t.indent>0)r=$r.call(Array(t.indent+1)," ");else return null;return {base:r,prev:$r.call(Array(e+1),r)}}function Bl(t,e){if(t.length===0)return "";var r=`
`+e.prev+e.base;return r+$r.call(t,","+r)+`
`+e.prev}function na(t,e){var r=Wl(t),n=[];if(r){n.length=t.length;for(var i=0;i<t.length;i++)n[i]=_n(t,i)?e(t[i],t):"";}var s=typeof ql=="function"?ql(t):[],o;if(Pi){o={};for(var a=0;a<s.length;a++)o["$"+s[a]]=s[a];}for(var l in t)_n(t,l)&&(r&&String(Number(l))===l&&l<t.length||Pi&&o["$"+l]instanceof Symbol||(Ny.call(/[^\w$]/,l)?n.push(e(l,t)+": "+e(t[l],t)):n.push(l+": "+e(t[l],t))));if(typeof ql=="function")for(var d=0;d<s.length;d++)qy.call(t,s[d])&&n.push("["+e(s[d])+"]: "+e(t[s[d]],t));return n}});var zy=A((x6,Uy)=>{var Gl=Ar(),Di=mr(),Ck=By(),xk=Gl("%TypeError%"),oa=Gl("%WeakMap%",!0),aa=Gl("%Map%",!0),Tk=Di("WeakMap.prototype.get",!0),Ak=Di("WeakMap.prototype.set",!0),Pk=Di("WeakMap.prototype.has",!0),Dk=Di("Map.prototype.get",!0),Ok=Di("Map.prototype.set",!0),Ik=Di("Map.prototype.has",!0),Kl=function(t,e){for(var r=t,n;(n=r.next)!==null;r=n)if(n.key===e)return r.next=n.next,n.next=t.next,t.next=n,n},kk=function(t,e){var r=Kl(t,e);return r&&r.value},Mk=function(t,e,r){var n=Kl(t,e);n?n.value=r:t.next={key:e,next:t.next,value:r};},Fk=function(t,e){return !!Kl(t,e)};Uy.exports=function(){var e,r,n,i={assert:function(s){if(!i.has(s))throw new xk("Side channel does not contain "+Ck(s))},get:function(s){if(oa&&s&&(typeof s=="object"||typeof s=="function")){if(e)return Tk(e,s)}else if(aa){if(r)return Dk(r,s)}else if(n)return kk(n,s)},has:function(s){if(oa&&s&&(typeof s=="object"||typeof s=="function")){if(e)return Pk(e,s)}else if(aa){if(r)return Ik(r,s)}else if(n)return Fk(n,s);return !1},set:function(s,o){oa&&s&&(typeof s=="object"||typeof s=="function")?(e||(e=new oa),Ak(e,s,o)):aa?(r||(r=new aa),Ok(r,s,o)):(n||(n={key:{},next:null}),Mk(n,s,o));}};return i};});var Zl=A((T6,Gy)=>{var Vy=function(t){return t!==t};Gy.exports=function(e,r){return e===0&&r===0?1/e===1/r:!!(e===r||Vy(e)&&Vy(r))};});var Jl=A((A6,Ky)=>{var Nk=Zl();Ky.exports=function(){return typeof Object.is=="function"?Object.is:Nk};});var Jy=A((P6,Zy)=>{var qk=Jl(),Lk=gn();Zy.exports=function(){var e=qk();return Lk(Object,{is:e},{is:function(){return Object.is!==e}}),e};});var eb=A((D6,Qy)=>{var $k=gn(),jk=Kn(),Hk=Zl(),Yy=Jl(),Wk=Jy(),Xy=jk(Yy(),Object);$k(Xy,{getPolyfill:Yy,implementation:Hk,shim:Wk});Qy.exports=Xy;});var vn=A((O6,tb)=>{var Bk=Zo();tb.exports=function(){return Bk()&&!!Symbol.toStringTag};});var ib=A((I6,nb)=>{var Uk=vn()(),zk=mr(),Yl=zk("Object.prototype.toString"),ua=function(e){return Uk&&e&&typeof e=="object"&&Symbol.toStringTag in e?!1:Yl(e)==="[object Arguments]"},rb=function(e){return ua(e)?!0:e!==null&&typeof e=="object"&&typeof e.length=="number"&&e.length>=0&&Yl(e)!=="[object Array]"&&Yl(e.callee)==="[object Function]"},Vk=function(){return ua(arguments)}();ua.isLegacyArguments=rb;nb.exports=Vk?ua:rb;});var ob=A((k6,sb)=>{var Gk={}.toString;sb.exports=Array.isArray||function(t){return Gk.call(t)=="[object Array]"};});var lb=A((M6,cb)=>{var ub=Function.prototype.toString,Oi=typeof Reflect=="object"&&Reflect!==null&&Reflect.apply,Ql,ca;if(typeof Oi=="function"&&typeof Object.defineProperty=="function")try{Ql=Object.defineProperty({},"length",{get:function(){throw ca}}),ca={},Oi(function(){throw 42},null,Ql);}catch(t){t!==ca&&(Oi=null);}else Oi=null;var Kk=/^\s*class\b/,ef=function(e){try{var r=ub.call(e);return Kk.test(r)}catch{return !1}},Xl=function(e){try{return ef(e)?!1:(ub.call(e),!0)}catch{return !1}},la=Object.prototype.toString,Zk="[object Object]",Jk="[object Function]",Yk="[object GeneratorFunction]",Xk="[object HTMLAllCollection]",Qk="[object HTML document.all class]",eM="[object HTMLCollection]",tM=typeof Symbol=="function"&&!!Symbol.toStringTag,rM=!(0 in[,]),tf=function(){return !1};typeof document=="object"&&(ab=document.all,la.call(ab)===la.call(document.all)&&(tf=function(e){if((rM||!e)&&(typeof e>"u"||typeof e=="object"))try{var r=la.call(e);return (r===Xk||r===Qk||r===eM||r===Zk)&&e("")==null}catch{}return !1}));var ab;cb.exports=Oi?function(e){if(tf(e))return !0;if(!e||typeof e!="function"&&typeof e!="object")return !1;try{Oi(e,null,Ql);}catch(r){if(r!==ca)return !1}return !ef(e)&&Xl(e)}:function(e){if(tf(e))return !0;if(!e||typeof e!="function"&&typeof e!="object")return !1;if(tM)return Xl(e);if(ef(e))return !1;var r=la.call(e);return r!==Jk&&r!==Yk&&!/^\[object HTML/.test(r)?!1:Xl(e)};});var hb=A((F6,db)=>{var nM=lb(),iM=Object.prototype.toString,fb=Object.prototype.hasOwnProperty,sM=function(e,r,n){for(var i=0,s=e.length;i<s;i++)fb.call(e,i)&&(n==null?r(e[i],i,e):r.call(n,e[i],i,e));},oM=function(e,r,n){for(var i=0,s=e.length;i<s;i++)n==null?r(e.charAt(i),i,e):r.call(n,e.charAt(i),i,e);},aM=function(e,r,n){for(var i in e)fb.call(e,i)&&(n==null?r(e[i],i,e):r.call(n,e[i],i,e));},uM=function(e,r,n){if(!nM(r))throw new TypeError("iterator must be a function");var i;arguments.length>=3&&(i=n),iM.call(e)==="[object Array]"?sM(e,r,i):typeof e=="string"?oM(e,r,i):aM(e,r,i);};db.exports=uM;});var mb=A((N6,pb)=>{var rf=["BigInt64Array","BigUint64Array","Float32Array","Float64Array","Int16Array","Int32Array","Int8Array","Uint16Array","Uint32Array","Uint8Array","Uint8ClampedArray"],cM=typeof globalThis>"u"?global:globalThis;pb.exports=function(){for(var e=[],r=0;r<rf.length;r++)typeof cM[rf[r]]=="function"&&(e[e.length]=rf[r]);return e};});var uf=A((q6,bb)=>{var da=hb(),lM=mb(),gb=Kn(),of=mr(),fa=ea(),fM=of("Object.prototype.toString"),yb=vn()(),_b=typeof globalThis>"u"?global:globalThis,sf=lM(),af=of("String.prototype.slice"),nf=Object.getPrototypeOf,dM=of("Array.prototype.indexOf",!0)||function(e,r){for(var n=0;n<e.length;n+=1)if(e[n]===r)return n;return -1},ha={__proto__:null};yb&&fa&&nf?da(sf,function(t){var e=new _b[t];if(Symbol.toStringTag in e){var r=nf(e),n=fa(r,Symbol.toStringTag);if(!n){var i=nf(r);n=fa(i,Symbol.toStringTag);}ha["$"+t]=gb(n.get);}}):da(sf,function(t){var e=new _b[t],r=e.slice||e.set;r&&(ha["$"+t]=gb(r));});var hM=function(e){var r=!1;return da(ha,function(n,i){if(!r)try{"$"+n(e)===i&&(r=af(i,1));}catch{}}),r},pM=function(e){var r=!1;return da(ha,function(n,i){if(!r)try{n(e),r=af(i,1);}catch{}}),r};bb.exports=function(e){if(!e||typeof e!="object")return !1;if(!yb){var r=af(fM(e),8,-1);return dM(sf,r)>-1?r:r!=="Object"?!1:pM(e)}return fa?hM(e):null};});var wb=A((L6,vb)=>{var mM=uf();vb.exports=function(e){return !!mM(e)};});var cf=A(($6,Tb)=>{var gM=Kn(),_M=mr(),xb=Ar(),yM=wb(),Sb=xb("ArrayBuffer",!0),Eb=xb("Float32Array",!0),pa=_M("ArrayBuffer.prototype.byteLength",!0),Rb=Sb&&!pa&&new Sb().slice,Cb=Rb&&gM(Rb);Tb.exports=pa||Cb?function(e){if(!e||typeof e!="object")return !1;try{return pa?pa(e):Cb(e,0),!0}catch{return !1}}:Eb?function(e){try{return new Eb(e).buffer===e&&!yM(e)}catch(r){return typeof e=="object"&&r.name==="RangeError"}}:function(e){return !1};});var Pb=A((j6,Ab)=>{var bM=Date.prototype.getDay,vM=function(e){try{return bM.call(e),!0}catch{return !1}},wM=Object.prototype.toString,SM="[object Date]",EM=vn()();Ab.exports=function(e){return typeof e!="object"||e===null?!1:EM?vM(e):wM.call(e)===SM};});var Mb=A((H6,kb)=>{var lf=mr(),Db=vn()(),Ob,Ib,ff,df;Db&&(Ob=lf("Object.prototype.hasOwnProperty"),Ib=lf("RegExp.prototype.exec"),ff={},ma=function(){throw ff},df={toString:ma,valueOf:ma},typeof Symbol.toPrimitive=="symbol"&&(df[Symbol.toPrimitive]=ma));var ma,RM=lf("Object.prototype.toString"),CM=Object.getOwnPropertyDescriptor,xM="[object RegExp]";kb.exports=Db?function(e){if(!e||typeof e!="object")return !1;var r=CM(e,"lastIndex"),n=r&&Ob(r,"value");if(!n)return !1;try{Ib(e,df);}catch(i){return i===ff}}:function(e){return !e||typeof e!="object"&&typeof e!="function"?!1:RM(e)===xM};});var qb=A((W6,Nb)=>{var TM=mr(),Fb=TM("SharedArrayBuffer.prototype.byteLength",!0);Nb.exports=Fb?function(e){if(!e||typeof e!="object")return !1;try{return Fb(e),!0}catch{return !1}}:function(e){return !1};});var $b=A((B6,Lb)=>{var AM=String.prototype.valueOf,PM=function(e){try{return AM.call(e),!0}catch{return !1}},DM=Object.prototype.toString,OM="[object String]",IM=vn()();Lb.exports=function(e){return typeof e=="string"?!0:typeof e!="object"?!1:IM?PM(e):DM.call(e)===OM};});var Hb=A((U6,jb)=>{var kM=Number.prototype.toString,MM=function(e){try{return kM.call(e),!0}catch{return !1}},FM=Object.prototype.toString,NM="[object Number]",qM=vn()();jb.exports=function(e){return typeof e=="number"?!0:typeof e!="object"?!1:qM?MM(e):FM.call(e)===NM};});var Ub=A((z6,Bb)=>{var Wb=mr(),LM=Wb("Boolean.prototype.toString"),$M=Wb("Object.prototype.toString"),jM=function(e){try{return LM(e),!0}catch{return !1}},HM="[object Boolean]",WM=vn()();Bb.exports=function(e){return typeof e=="boolean"?!0:e===null||typeof e!="object"?!1:WM&&Symbol.toStringTag in e?jM(e):$M(e)===HM};});var Kb=A((V6,hf)=>{var BM=Object.prototype.toString,UM=El()();UM?(zb=Symbol.prototype.toString,Vb=/^Symbol\(.*\)$/,Gb=function(e){return typeof e.valueOf()!="symbol"?!1:Vb.test(zb.call(e))},hf.exports=function(e){if(typeof e=="symbol")return !0;if(BM.call(e)!=="[object Symbol]")return !1;try{return Gb(e)}catch{return !1}}):hf.exports=function(e){return !1};var zb,Vb,Gb;});var Yb=A((G6,Jb)=>{var Zb=typeof BigInt<"u"&&BigInt;Jb.exports=function(){return typeof Zb=="function"&&typeof BigInt=="function"&&typeof Zb(42)=="bigint"&&typeof BigInt(42)=="bigint"};});var ev=A((K6,pf)=>{var zM=Yb()();zM?(Xb=BigInt.prototype.valueOf,Qb=function(e){try{return Xb.call(e),!0}catch{}return !1},pf.exports=function(e){return e===null||typeof e>"u"||typeof e=="boolean"||typeof e=="string"||typeof e=="number"||typeof e=="symbol"||typeof e=="function"?!1:typeof e=="bigint"?!0:Qb(e)}):pf.exports=function(e){return !1};var Xb,Qb;});var rv=A((Z6,tv)=>{var VM=$b(),GM=Hb(),KM=Ub(),ZM=Kb(),JM=ev();tv.exports=function(e){if(e==null||typeof e!="object"&&typeof e!="function")return null;if(VM(e))return "String";if(GM(e))return "Number";if(KM(e))return "Boolean";if(ZM(e))return "Symbol";if(JM(e))return "BigInt"};});var ov=A((J6,sv)=>{var mf=typeof Map=="function"&&Map.prototype?Map:null,YM=typeof Set=="function"&&Set.prototype?Set:null,ga;mf||(ga=function(e){return !1});var iv=mf?Map.prototype.has:null,nv=YM?Set.prototype.has:null;!ga&&!iv&&(ga=function(e){return !1});sv.exports=ga||function(e){if(!e||typeof e!="object")return !1;try{if(iv.call(e),nv)try{nv.call(e);}catch{return !0}return e instanceof mf}catch{}return !1};});var lv=A((Y6,cv)=>{var XM=typeof Map=="function"&&Map.prototype?Map:null,gf=typeof Set=="function"&&Set.prototype?Set:null,_a;gf||(_a=function(e){return !1});var av=XM?Map.prototype.has:null,uv=gf?Set.prototype.has:null;!_a&&!uv&&(_a=function(e){return !1});cv.exports=_a||function(e){if(!e||typeof e!="object")return !1;try{if(uv.call(e),av)try{av.call(e);}catch{return !0}return e instanceof gf}catch{}return !1};});var hv=A((X6,dv)=>{var ya=typeof WeakMap=="function"&&WeakMap.prototype?WeakMap:null,fv=typeof WeakSet=="function"&&WeakSet.prototype?WeakSet:null,ba;ya||(ba=function(e){return !1});var yf=ya?ya.prototype.has:null,_f=fv?fv.prototype.has:null;!ba&&!yf&&(ba=function(e){return !1});dv.exports=ba||function(e){if(!e||typeof e!="object")return !1;try{if(yf.call(e,yf),_f)try{_f.call(e,_f);}catch{return !0}return e instanceof ya}catch{}return !1};});var mv=A((Q6,vf)=>{var QM=Ar(),pv=mr(),eF=QM("%WeakSet%",!0),bf=pv("WeakSet.prototype.has",!0);bf?(va=pv("WeakMap.prototype.has",!0),vf.exports=function(e){if(!e||typeof e!="object")return !1;try{if(bf(e,bf),va)try{va(e,va);}catch{return !0}return e instanceof eF}catch{}return !1}):vf.exports=function(e){return !1};var va;});var _v=A((e9,gv)=>{var tF=ov(),rF=lv(),nF=hv(),iF=mv();gv.exports=function(e){if(e&&typeof e=="object"){if(tF(e))return "Map";if(rF(e))return "Set";if(nF(e))return "WeakMap";if(iF(e))return "WeakSet"}return !1};});var vv=A((t9,bv)=>{var sF=mr(),yv=sF("ArrayBuffer.prototype.byteLength",!0),oF=cf();bv.exports=function(e){return oF(e)?yv?yv(e):e.byteLength:NaN};});var xa=A((r9,Uv)=>{var Hv=iy(),jr=mr(),wv=yy(),aF=Ar(),Ii=wy(),uF=zy(),Sv=eb(),Ev=ib(),Rv=ob(),Cv=cf(),xv=Pb(),Tv=Mb(),Av=qb(),Pv=Ko(),Dv=rv(),Ov=_v(),Iv=uf(),kv=vv(),Mv=jr("SharedArrayBuffer.prototype.byteLength",!0),Fv=jr("Date.prototype.getTime"),wf=Object.getPrototypeOf,Nv=jr("Object.prototype.toString"),Sa=aF("%Set%",!0),Sf=jr("Map.prototype.has",!0),Ea=jr("Map.prototype.get",!0),qv=jr("Map.prototype.size",!0),Ra=jr("Set.prototype.add",!0),Wv=jr("Set.prototype.delete",!0),Ca=jr("Set.prototype.has",!0),wa=jr("Set.prototype.size",!0);function Lv(t,e,r,n){for(var i=Ii(t),s;(s=i.next())&&!s.done;)if(Pr(e,s.value,r,n))return Wv(t,s.value),!0;return !1}function Bv(t){if(typeof t>"u")return null;if(typeof t!="object")return typeof t=="symbol"?!1:typeof t=="string"||typeof t=="number"?+t==+t:!0}function cF(t,e,r,n,i,s){var o=Bv(r);if(o!=null)return o;var a=Ea(e,o),l=Hv({},i,{strict:!1});return typeof a>"u"&&!Sf(e,o)||!Pr(n,a,l,s)?!1:!Sf(t,o)&&Pr(n,a,l,s)}function lF(t,e,r){var n=Bv(r);return n??(Ca(e,n)&&!Ca(t,n))}function $v(t,e,r,n,i,s){for(var o=Ii(t),a,l;(a=o.next())&&!a.done;)if(l=a.value,Pr(r,l,i,s)&&Pr(n,Ea(e,l),i,s))return Wv(t,l),!0;return !1}function Pr(t,e,r,n){var i=r||{};if(i.strict?Sv(t,e):t===e)return !0;var s=Dv(t),o=Dv(e);if(s!==o)return !1;if(!t||!e||typeof t!="object"&&typeof e!="object")return i.strict?Sv(t,e):t==e;var a=n.has(t),l=n.has(e),d;if(a&&l){if(n.get(t)===n.get(e))return !0}else d={};return a||n.set(t,d),l||n.set(e,d),hF(t,e,i,n)}function jv(t){return !t||typeof t!="object"||typeof t.length!="number"||typeof t.copy!="function"||typeof t.slice!="function"||t.length>0&&typeof t[0]!="number"?!1:!!(t.constructor&&t.constructor.isBuffer&&t.constructor.isBuffer(t))}function fF(t,e,r,n){if(wa(t)!==wa(e))return !1;for(var i=Ii(t),s=Ii(e),o,a,l;(o=i.next())&&!o.done;)if(o.value&&typeof o.value=="object")l||(l=new Sa),Ra(l,o.value);else if(!Ca(e,o.value)){if(r.strict||!lF(t,e,o.value))return !1;l||(l=new Sa),Ra(l,o.value);}if(l){for(;(a=s.next())&&!a.done;)if(a.value&&typeof a.value=="object"){if(!Lv(l,a.value,r.strict,n))return !1}else if(!r.strict&&!Ca(t,a.value)&&!Lv(l,a.value,r.strict,n))return !1;return wa(l)===0}return !0}function dF(t,e,r,n){if(qv(t)!==qv(e))return !1;for(var i=Ii(t),s=Ii(e),o,a,l,d,c,p;(o=i.next())&&!o.done;)if(d=o.value[0],c=o.value[1],d&&typeof d=="object")l||(l=new Sa),Ra(l,d);else if(p=Ea(e,d),typeof p>"u"&&!Sf(e,d)||!Pr(c,p,r,n)){if(r.strict||!cF(t,e,d,c,r,n))return !1;l||(l=new Sa),Ra(l,d);}if(l){for(;(a=s.next())&&!a.done;)if(d=a.value[0],p=a.value[1],d&&typeof d=="object"){if(!$v(l,t,d,p,r,n))return !1}else if(!r.strict&&(!t.has(d)||!Pr(Ea(t,d),p,r,n))&&!$v(l,t,d,p,Hv({},r,{strict:!1}),n))return !1;return wa(l)===0}return !0}function hF(t,e,r,n){var i,s;if(typeof t!=typeof e||t==null||e==null||Nv(t)!==Nv(e)||Ev(t)!==Ev(e))return !1;var o=Rv(t),a=Rv(e);if(o!==a)return !1;var l=t instanceof Error,d=e instanceof Error;if(l!==d||(l||d)&&(t.name!==e.name||t.message!==e.message))return !1;var c=Tv(t),p=Tv(e);if(c!==p||(c||p)&&(t.source!==e.source||wv(t)!==wv(e)))return !1;var m=xv(t),_=xv(e);if(m!==_||(m||_)&&Fv(t)!==Fv(e)||r.strict&&wf&&wf(t)!==wf(e))return !1;var w=Iv(t),E=Iv(e);if(w!==E)return !1;if(w||E){if(t.length!==e.length)return !1;for(i=0;i<t.length;i++)if(t[i]!==e[i])return !1;return !0}var P=jv(t),D=jv(e);if(P!==D)return !1;if(P||D){if(t.length!==e.length)return !1;for(i=0;i<t.length;i++)if(t[i]!==e[i])return !1;return !0}var g=Cv(t),S=Cv(e);if(g!==S)return !1;if(g||S)return kv(t)!==kv(e)?!1:typeof Uint8Array=="function"&&Pr(new Uint8Array(t),new Uint8Array(e),r,n);var I=Av(t),L=Av(e);if(I!==L)return !1;if(I||L)return Mv(t)!==Mv(e)?!1:typeof Uint8Array=="function"&&Pr(new Uint8Array(t),new Uint8Array(e),r,n);if(typeof t!=typeof e)return !1;var Z=Pv(t),K=Pv(e);if(Z.length!==K.length)return !1;for(Z.sort(),K.sort(),i=Z.length-1;i>=0;i--)if(Z[i]!=K[i])return !1;for(i=Z.length-1;i>=0;i--)if(s=Z[i],!Pr(t[s],e[s],r,n))return !1;var U=Ov(t),B=Ov(e);return U!==B?!1:U==="Set"||B==="Set"?fF(t,e,r,n):U==="Map"?dF(t,e,r,n):!0}Uv.exports=function(e,r,n){return Pr(e,r,n,uF())};});var ew={};AO(ew,{closest:()=>NF,distance:()=>Qv});var Qr,MF,FF,Qv,NF,tw=TO(()=>{Qr=new Uint32Array(65536),MF=(t,e)=>{let r=t.length,n=e.length,i=1<<r-1,s=-1,o=0,a=r,l=r;for(;l--;)Qr[t.charCodeAt(l)]|=1<<l;for(l=0;l<n;l++){let d=Qr[e.charCodeAt(l)],c=d|o;d|=(d&s)+s^s,o|=~(d|s),s&=d,o&i&&a++,s&i&&a--,o=o<<1|1,s=s<<1|~(c|o),o&=c;}for(l=r;l--;)Qr[t.charCodeAt(l)]=0;return a},FF=(t,e)=>{let r=e.length,n=t.length,i=[],s=[],o=Math.ceil(r/32),a=Math.ceil(n/32);for(let w=0;w<o;w++)s[w]=-1,i[w]=0;let l=0;for(;l<a-1;l++){let w=0,E=-1,P=l*32,D=Math.min(32,n)+P;for(let g=P;g<D;g++)Qr[t.charCodeAt(g)]|=1<<g;for(let g=0;g<r;g++){let S=Qr[e.charCodeAt(g)],I=s[g/32|0]>>>g&1,L=i[g/32|0]>>>g&1,Z=S|w,K=((S|L)&E)+E^E|S|L,U=w|~(K|E),B=E&K;U>>>31^I&&(s[g/32|0]^=1<<g),B>>>31^L&&(i[g/32|0]^=1<<g),U=U<<1|I,B=B<<1|L,E=B|~(Z|U),w=U&Z;}for(let g=P;g<D;g++)Qr[t.charCodeAt(g)]=0;}let d=0,c=-1,p=l*32,m=Math.min(32,n-p)+p;for(let w=p;w<m;w++)Qr[t.charCodeAt(w)]|=1<<w;let _=n;for(let w=0;w<r;w++){let E=Qr[e.charCodeAt(w)],P=s[w/32|0]>>>w&1,D=i[w/32|0]>>>w&1,g=E|d,S=((E|D)&c)+c^c|E|D,I=d|~(S|c),L=c&S;_+=I>>>n-1&1,_-=L>>>n-1&1,I>>>31^P&&(s[w/32|0]^=1<<w),L>>>31^D&&(i[w/32|0]^=1<<w),I=I<<1|P,L=L<<1|D,c=L|~(g|I),d=I&g;}for(let w=p;w<m;w++)Qr[t.charCodeAt(w)]=0;return _},Qv=(t,e)=>{if(t.length<e.length){let r=e;e=t,t=r;}return e.length===0?t.length:t.length<=32?MF(t,e):FF(t,e)},NF=(t,e)=>{let r=1/0,n=0;for(let i=0;i<e.length;i++){let s=Qv(t,e[i]);s<r&&(r=s,n=i);}return e[n]};});var rw=A((Tf,$s)=>{(function(){var t;try{t=typeof Intl<"u"&&typeof Intl.Collator<"u"?Intl.Collator("generic",{sensitivity:"base"}):null;}catch{console.log("Collator could not be initialized and wouldn't be used");}var e=(tw(),PO(ew)),r=[],n=[],i={get:function(s,o,a){var l=a&&t&&a.useCollator;if(l){var d=s.length,c=o.length;if(d===0)return c;if(c===0)return d;var p,m,_,w,E;for(_=0;_<c;++_)r[_]=_,n[_]=o.charCodeAt(_);r[c]=c;var P;for(_=0;_<d;++_){for(m=_+1,w=0;w<c;++w)p=m,P=t.compare(s.charAt(_),String.fromCharCode(n[w]))===0,m=r[w]+(P?0:1),E=p+1,m>E&&(m=E),E=r[w+1]+1,m>E&&(m=E),r[w]=p;r[w]=m;}return m}return e.distance(s,o)}};typeof define<"u"&&define!==null&&define.amd?define(function(){return i}):typeof $s<"u"&&$s!==null&&typeof Tf<"u"&&$s.exports===Tf?$s.exports=i:typeof self<"u"&&typeof self.postMessage=="function"&&typeof self.importScripts=="function"?self.Levenshtein=i:typeof window<"u"&&window!==null&&(window.Levenshtein=i);})();});var _t=A(If=>{If.fromCallback=function(t){return Object.defineProperty(function(...e){if(typeof e[e.length-1]=="function")t.apply(this,e);else return new Promise((r,n)=>{e.push((i,s)=>i!=null?n(i):r(s)),t.apply(this,e);})},"name",{value:t.name})};If.fromPromise=function(t){return Object.defineProperty(function(...e){let r=e[e.length-1];if(typeof r!="function")return t.apply(this,e);e.pop(),t.apply(this,e).then(n=>r(null,n),r);},"name",{value:t.name})};});var aw=A((l9,ow)=>{var Sn=oe("constants"),$F=process.cwd,ka=null,jF=process.env.GRACEFUL_FS_PLATFORM||process.platform;process.cwd=function(){return ka||(ka=$F.call(process)),ka};try{process.cwd();}catch{}typeof process.chdir=="function"&&(kf=process.chdir,process.chdir=function(t){ka=null,kf.call(process,t);},Object.setPrototypeOf&&Object.setPrototypeOf(process.chdir,kf));var kf;ow.exports=HF;function HF(t){Sn.hasOwnProperty("O_SYMLINK")&&process.version.match(/^v0\.6\.[0-2]|^v0\.5\./)&&e(t),t.lutimes||r(t),t.chown=s(t.chown),t.fchown=s(t.fchown),t.lchown=s(t.lchown),t.chmod=n(t.chmod),t.fchmod=n(t.fchmod),t.lchmod=n(t.lchmod),t.chownSync=o(t.chownSync),t.fchownSync=o(t.fchownSync),t.lchownSync=o(t.lchownSync),t.chmodSync=i(t.chmodSync),t.fchmodSync=i(t.fchmodSync),t.lchmodSync=i(t.lchmodSync),t.stat=a(t.stat),t.fstat=a(t.fstat),t.lstat=a(t.lstat),t.statSync=l(t.statSync),t.fstatSync=l(t.fstatSync),t.lstatSync=l(t.lstatSync),t.chmod&&!t.lchmod&&(t.lchmod=function(c,p,m){m&&process.nextTick(m);},t.lchmodSync=function(){}),t.chown&&!t.lchown&&(t.lchown=function(c,p,m,_){_&&process.nextTick(_);},t.lchownSync=function(){}),jF==="win32"&&(t.rename=typeof t.rename!="function"?t.rename:function(c){function p(m,_,w){var E=Date.now(),P=0;c(m,_,function D(g){if(g&&(g.code==="EACCES"||g.code==="EPERM"||g.code==="EBUSY")&&Date.now()-E<6e4){setTimeout(function(){t.stat(_,function(S,I){S&&S.code==="ENOENT"?c(m,_,D):w(g);});},P),P<100&&(P+=10);return}w&&w(g);});}return Object.setPrototypeOf&&Object.setPrototypeOf(p,c),p}(t.rename)),t.read=typeof t.read!="function"?t.read:function(c){function p(m,_,w,E,P,D){var g;if(D&&typeof D=="function"){var S=0;g=function(I,L,Z){if(I&&I.code==="EAGAIN"&&S<10)return S++,c.call(t,m,_,w,E,P,g);D.apply(this,arguments);};}return c.call(t,m,_,w,E,P,g)}return Object.setPrototypeOf&&Object.setPrototypeOf(p,c),p}(t.read),t.readSync=typeof t.readSync!="function"?t.readSync:function(c){return function(p,m,_,w,E){for(var P=0;;)try{return c.call(t,p,m,_,w,E)}catch(D){if(D.code==="EAGAIN"&&P<10){P++;continue}throw D}}}(t.readSync);function e(c){c.lchmod=function(p,m,_){c.open(p,Sn.O_WRONLY|Sn.O_SYMLINK,m,function(w,E){if(w){_&&_(w);return}c.fchmod(E,m,function(P){c.close(E,function(D){_&&_(P||D);});});});},c.lchmodSync=function(p,m){var _=c.openSync(p,Sn.O_WRONLY|Sn.O_SYMLINK,m),w=!0,E;try{E=c.fchmodSync(_,m),w=!1;}finally{if(w)try{c.closeSync(_);}catch{}else c.closeSync(_);}return E};}function r(c){Sn.hasOwnProperty("O_SYMLINK")&&c.futimes?(c.lutimes=function(p,m,_,w){c.open(p,Sn.O_SYMLINK,function(E,P){if(E){w&&w(E);return}c.futimes(P,m,_,function(D){c.close(P,function(g){w&&w(D||g);});});});},c.lutimesSync=function(p,m,_){var w=c.openSync(p,Sn.O_SYMLINK),E,P=!0;try{E=c.futimesSync(w,m,_),P=!1;}finally{if(P)try{c.closeSync(w);}catch{}else c.closeSync(w);}return E}):c.futimes&&(c.lutimes=function(p,m,_,w){w&&process.nextTick(w);},c.lutimesSync=function(){});}function n(c){return c&&function(p,m,_){return c.call(t,p,m,function(w){d(w)&&(w=null),_&&_.apply(this,arguments);})}}function i(c){return c&&function(p,m){try{return c.call(t,p,m)}catch(_){if(!d(_))throw _}}}function s(c){return c&&function(p,m,_,w){return c.call(t,p,m,_,function(E){d(E)&&(E=null),w&&w.apply(this,arguments);})}}function o(c){return c&&function(p,m,_){try{return c.call(t,p,m,_)}catch(w){if(!d(w))throw w}}}function a(c){return c&&function(p,m,_){typeof m=="function"&&(_=m,m=null);function w(E,P){P&&(P.uid<0&&(P.uid+=4294967296),P.gid<0&&(P.gid+=4294967296)),_&&_.apply(this,arguments);}return m?c.call(t,p,m,w):c.call(t,p,w)}}function l(c){return c&&function(p,m){var _=m?c.call(t,p,m):c.call(t,p);return _&&(_.uid<0&&(_.uid+=4294967296),_.gid<0&&(_.gid+=4294967296)),_}}function d(c){if(!c||c.code==="ENOSYS")return !0;var p=!process.getuid||process.getuid()!==0;return !!(p&&(c.code==="EINVAL"||c.code==="EPERM"))}}});var lw=A((f9,cw)=>{var uw=oe("stream").Stream;cw.exports=WF;function WF(t){return {ReadStream:e,WriteStream:r};function e(n,i){if(!(this instanceof e))return new e(n,i);uw.call(this);var s=this;this.path=n,this.fd=null,this.readable=!0,this.paused=!1,this.flags="r",this.mode=438,this.bufferSize=64*1024,i=i||{};for(var o=Object.keys(i),a=0,l=o.length;a<l;a++){var d=o[a];this[d]=i[d];}if(this.encoding&&this.setEncoding(this.encoding),this.start!==void 0){if(typeof this.start!="number")throw TypeError("start must be a Number");if(this.end===void 0)this.end=1/0;else if(typeof this.end!="number")throw TypeError("end must be a Number");if(this.start>this.end)throw new Error("start must be <= end");this.pos=this.start;}if(this.fd!==null){process.nextTick(function(){s._read();});return}t.open(this.path,this.flags,this.mode,function(c,p){if(c){s.emit("error",c),s.readable=!1;return}s.fd=p,s.emit("open",p),s._read();});}function r(n,i){if(!(this instanceof r))return new r(n,i);uw.call(this),this.path=n,this.fd=null,this.writable=!0,this.flags="w",this.encoding="binary",this.mode=438,this.bytesWritten=0,i=i||{};for(var s=Object.keys(i),o=0,a=s.length;o<a;o++){var l=s[o];this[l]=i[l];}if(this.start!==void 0){if(typeof this.start!="number")throw TypeError("start must be a Number");if(this.start<0)throw new Error("start must be >= zero");this.pos=this.start;}this.busy=!1,this._queue=[],this.fd===null&&(this._open=t.open,this._queue.push([this._open,this.path,this.flags,this.mode,void 0]),this.flush());}}});var dw=A((d9,fw)=>{fw.exports=UF;var BF=Object.getPrototypeOf||function(t){return t.__proto__};function UF(t){if(t===null||typeof t!="object")return t;if(t instanceof Object)var e={__proto__:BF(t)};else var e=Object.create(null);return Object.getOwnPropertyNames(t).forEach(function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r));}),e}});var Fi=A((h9,Nf)=>{var it=oe("fs"),zF=aw(),VF=lw(),GF=dw(),Ma=oe("util"),Tt,Na;typeof Symbol=="function"&&typeof Symbol.for=="function"?(Tt=Symbol.for("graceful-fs.queue"),Na=Symbol.for("graceful-fs.previous")):(Tt="___graceful-fs.queue",Na="___graceful-fs.previous");function KF(){}function mw(t,e){Object.defineProperty(t,Tt,{get:function(){return e}});}var Yn=KF;Ma.debuglog?Yn=Ma.debuglog("gfs4"):/\bgfs4\b/i.test(process.env.NODE_DEBUG||"")&&(Yn=function(){var t=Ma.format.apply(Ma,arguments);t="GFS4: "+t.split(/\n/).join(`
GFS4: `),console.error(t);});it[Tt]||(hw=global[Tt]||[],mw(it,hw),it.close=function(t){function e(r,n){return t.call(it,r,function(i){i||pw(),typeof n=="function"&&n.apply(this,arguments);})}return Object.defineProperty(e,Na,{value:t}),e}(it.close),it.closeSync=function(t){function e(r){t.apply(it,arguments),pw();}return Object.defineProperty(e,Na,{value:t}),e}(it.closeSync),/\bgfs4\b/i.test(process.env.NODE_DEBUG||"")&&process.on("exit",function(){Yn(it[Tt]),oe("assert").equal(it[Tt].length,0);}));var hw;global[Tt]||mw(global,it[Tt]);Nf.exports=Mf(GF(it));process.env.TEST_GRACEFUL_FS_GLOBAL_PATCH&&!it.__patched&&(Nf.exports=Mf(it),it.__patched=!0);function Mf(t){zF(t),t.gracefulify=Mf,t.createReadStream=L,t.createWriteStream=Z;var e=t.readFile;t.readFile=r;function r(B,Q,N){return typeof Q=="function"&&(N=Q,Q=null),te(B,Q,N);function te(ae,ye,q,W){return e(ae,ye,function(me){me&&(me.code==="EMFILE"||me.code==="ENFILE")?Mi([te,[ae,ye,q],me,W||Date.now(),Date.now()]):typeof q=="function"&&q.apply(this,arguments);})}}var n=t.writeFile;t.writeFile=i;function i(B,Q,N,te){return typeof N=="function"&&(te=N,N=null),ae(B,Q,N,te);function ae(ye,q,W,me,pe){return n(ye,q,W,function(we){we&&(we.code==="EMFILE"||we.code==="ENFILE")?Mi([ae,[ye,q,W,me],we,pe||Date.now(),Date.now()]):typeof me=="function"&&me.apply(this,arguments);})}}var s=t.appendFile;s&&(t.appendFile=o);function o(B,Q,N,te){return typeof N=="function"&&(te=N,N=null),ae(B,Q,N,te);function ae(ye,q,W,me,pe){return s(ye,q,W,function(we){we&&(we.code==="EMFILE"||we.code==="ENFILE")?Mi([ae,[ye,q,W,me],we,pe||Date.now(),Date.now()]):typeof me=="function"&&me.apply(this,arguments);})}}var a=t.copyFile;a&&(t.copyFile=l);function l(B,Q,N,te){return typeof N=="function"&&(te=N,N=0),ae(B,Q,N,te);function ae(ye,q,W,me,pe){return a(ye,q,W,function(we){we&&(we.code==="EMFILE"||we.code==="ENFILE")?Mi([ae,[ye,q,W,me],we,pe||Date.now(),Date.now()]):typeof me=="function"&&me.apply(this,arguments);})}}var d=t.readdir;t.readdir=p;var c=/^v[0-5]\./;function p(B,Q,N){typeof Q=="function"&&(N=Q,Q=null);var te=c.test(process.version)?function(q,W,me,pe){return d(q,ae(q,W,me,pe))}:function(q,W,me,pe){return d(q,W,ae(q,W,me,pe))};return te(B,Q,N);function ae(ye,q,W,me){return function(pe,we){pe&&(pe.code==="EMFILE"||pe.code==="ENFILE")?Mi([te,[ye,q,W],pe,me||Date.now(),Date.now()]):(we&&we.sort&&we.sort(),typeof W=="function"&&W.call(this,pe,we));}}}if(process.version.substr(0,4)==="v0.8"){var m=VF(t);D=m.ReadStream,S=m.WriteStream;}var _=t.ReadStream;_&&(D.prototype=Object.create(_.prototype),D.prototype.open=g);var w=t.WriteStream;w&&(S.prototype=Object.create(w.prototype),S.prototype.open=I),Object.defineProperty(t,"ReadStream",{get:function(){return D},set:function(B){D=B;},enumerable:!0,configurable:!0}),Object.defineProperty(t,"WriteStream",{get:function(){return S},set:function(B){S=B;},enumerable:!0,configurable:!0});var E=D;Object.defineProperty(t,"FileReadStream",{get:function(){return E},set:function(B){E=B;},enumerable:!0,configurable:!0});var P=S;Object.defineProperty(t,"FileWriteStream",{get:function(){return P},set:function(B){P=B;},enumerable:!0,configurable:!0});function D(B,Q){return this instanceof D?(_.apply(this,arguments),this):D.apply(Object.create(D.prototype),arguments)}function g(){var B=this;U(B.path,B.flags,B.mode,function(Q,N){Q?(B.autoClose&&B.destroy(),B.emit("error",Q)):(B.fd=N,B.emit("open",N),B.read());});}function S(B,Q){return this instanceof S?(w.apply(this,arguments),this):S.apply(Object.create(S.prototype),arguments)}function I(){var B=this;U(B.path,B.flags,B.mode,function(Q,N){Q?(B.destroy(),B.emit("error",Q)):(B.fd=N,B.emit("open",N));});}function L(B,Q){return new t.ReadStream(B,Q)}function Z(B,Q){return new t.WriteStream(B,Q)}var K=t.open;t.open=U;function U(B,Q,N,te){return typeof N=="function"&&(te=N,N=null),ae(B,Q,N,te);function ae(ye,q,W,me,pe){return K(ye,q,W,function(we,Xe){we&&(we.code==="EMFILE"||we.code==="ENFILE")?Mi([ae,[ye,q,W,me],we,pe||Date.now(),Date.now()]):typeof me=="function"&&me.apply(this,arguments);})}}return t}function Mi(t){Yn("ENQUEUE",t[0].name,t[1]),it[Tt].push(t),Ff();}var Fa;function pw(){for(var t=Date.now(),e=0;e<it[Tt].length;++e)it[Tt][e].length>2&&(it[Tt][e][3]=t,it[Tt][e][4]=t);Ff();}function Ff(){if(clearTimeout(Fa),Fa=void 0,it[Tt].length!==0){var t=it[Tt].shift(),e=t[0],r=t[1],n=t[2],i=t[3],s=t[4];if(i===void 0)Yn("RETRY",e.name,r),e.apply(null,r);else if(Date.now()-i>=6e4){Yn("TIMEOUT",e.name,r);var o=r.pop();typeof o=="function"&&o.call(null,n);}else {var a=Date.now()-s,l=Math.max(s-i,1),d=Math.min(l*1.2,100);a>=d?(Yn("RETRY",e.name,r),e.apply(null,r.concat([i]))):it[Tt].push(t);}Fa===void 0&&(Fa=setTimeout(Ff,0));}}});var Wt=A(tn=>{var gw=_t().fromCallback,Ht=Fi(),ZF=["access","appendFile","chmod","chown","close","copyFile","fchmod","fchown","fdatasync","fstat","fsync","ftruncate","futimes","lchmod","lchown","link","lstat","mkdir","mkdtemp","open","opendir","readdir","readFile","readlink","realpath","rename","rm","rmdir","stat","symlink","truncate","unlink","utimes","writeFile"].filter(t=>typeof Ht[t]=="function");Object.assign(tn,Ht);ZF.forEach(t=>{tn[t]=gw(Ht[t]);});tn.exists=function(t,e){return typeof e=="function"?Ht.exists(t,e):new Promise(r=>Ht.exists(t,r))};tn.read=function(t,e,r,n,i,s){return typeof s=="function"?Ht.read(t,e,r,n,i,s):new Promise((o,a)=>{Ht.read(t,e,r,n,i,(l,d,c)=>{if(l)return a(l);o({bytesRead:d,buffer:c});});})};tn.write=function(t,e,...r){return typeof r[r.length-1]=="function"?Ht.write(t,e,...r):new Promise((n,i)=>{Ht.write(t,e,...r,(s,o,a)=>{if(s)return i(s);n({bytesWritten:o,buffer:a});});})};tn.readv=function(t,e,...r){return typeof r[r.length-1]=="function"?Ht.readv(t,e,...r):new Promise((n,i)=>{Ht.readv(t,e,...r,(s,o,a)=>{if(s)return i(s);n({bytesRead:o,buffers:a});});})};tn.writev=function(t,e,...r){return typeof r[r.length-1]=="function"?Ht.writev(t,e,...r):new Promise((n,i)=>{Ht.writev(t,e,...r,(s,o,a)=>{if(s)return i(s);n({bytesWritten:o,buffers:a});});})};typeof Ht.realpath.native=="function"?tn.realpath.native=gw(Ht.realpath.native):process.emitWarning("fs.realpath.native is not a function. Is fs being monkey-patched?","Warning","fs-extra-WARN0003");});var yw=A((m9,_w)=>{var JF=oe("path");_w.exports.checkPath=function(e){if(process.platform==="win32"&&/[<>:"|?*]/.test(e.replace(JF.parse(e).root,""))){let n=new Error(`Path contains invalid characters: ${e}`);throw n.code="EINVAL",n}};});var Sw=A((g9,qf)=>{var bw=Wt(),{checkPath:vw}=yw(),ww=t=>{let e={mode:511};return typeof t=="number"?t:{...e,...t}.mode};qf.exports.makeDir=async(t,e)=>(vw(t),bw.mkdir(t,{mode:ww(e),recursive:!0}));qf.exports.makeDirSync=(t,e)=>(vw(t),bw.mkdirSync(t,{mode:ww(e),recursive:!0}));});var Dr=A((_9,Ew)=>{var YF=_t().fromPromise,{makeDir:XF,makeDirSync:Lf}=Sw(),$f=YF(XF);Ew.exports={mkdirs:$f,mkdirsSync:Lf,mkdirp:$f,mkdirpSync:Lf,ensureDir:$f,ensureDirSync:Lf};});var En=A((y9,Cw)=>{var QF=_t().fromPromise,Rw=Wt();function eN(t){return Rw.access(t).then(()=>!0).catch(()=>!1)}Cw.exports={pathExists:QF(eN),pathExistsSync:Rw.existsSync};});var jf=A((b9,xw)=>{var Ni=Wt(),tN=_t().fromPromise;async function rN(t,e,r){let n=await Ni.open(t,"r+"),i=null;try{await Ni.futimes(n,e,r);}finally{try{await Ni.close(n);}catch(s){i=s;}}if(i)throw i}function nN(t,e,r){let n=Ni.openSync(t,"r+");return Ni.futimesSync(n,e,r),Ni.closeSync(n)}xw.exports={utimesMillis:tN(rN),utimesMillisSync:nN};});var Xn=A((v9,Dw)=>{var qi=Wt(),yt=oe("path"),Tw=_t().fromPromise;function iN(t,e,r){let n=r.dereference?i=>qi.stat(i,{bigint:!0}):i=>qi.lstat(i,{bigint:!0});return Promise.all([n(t),n(e).catch(i=>{if(i.code==="ENOENT")return null;throw i})]).then(([i,s])=>({srcStat:i,destStat:s}))}function sN(t,e,r){let n,i=r.dereference?o=>qi.statSync(o,{bigint:!0}):o=>qi.lstatSync(o,{bigint:!0}),s=i(t);try{n=i(e);}catch(o){if(o.code==="ENOENT")return {srcStat:s,destStat:null};throw o}return {srcStat:s,destStat:n}}async function oN(t,e,r,n){let{srcStat:i,destStat:s}=await iN(t,e,n);if(s){if(Ws(i,s)){let o=yt.basename(t),a=yt.basename(e);if(r==="move"&&o!==a&&o.toLowerCase()===a.toLowerCase())return {srcStat:i,destStat:s,isChangingCase:!0};throw new Error("Source and destination must not be the same.")}if(i.isDirectory()&&!s.isDirectory())throw new Error(`Cannot overwrite non-directory '${e}' with directory '${t}'.`);if(!i.isDirectory()&&s.isDirectory())throw new Error(`Cannot overwrite directory '${e}' with non-directory '${t}'.`)}if(i.isDirectory()&&Hf(t,e))throw new Error(qa(t,e,r));return {srcStat:i,destStat:s}}function aN(t,e,r,n){let{srcStat:i,destStat:s}=sN(t,e,n);if(s){if(Ws(i,s)){let o=yt.basename(t),a=yt.basename(e);if(r==="move"&&o!==a&&o.toLowerCase()===a.toLowerCase())return {srcStat:i,destStat:s,isChangingCase:!0};throw new Error("Source and destination must not be the same.")}if(i.isDirectory()&&!s.isDirectory())throw new Error(`Cannot overwrite non-directory '${e}' with directory '${t}'.`);if(!i.isDirectory()&&s.isDirectory())throw new Error(`Cannot overwrite directory '${e}' with non-directory '${t}'.`)}if(i.isDirectory()&&Hf(t,e))throw new Error(qa(t,e,r));return {srcStat:i,destStat:s}}async function Aw(t,e,r,n){let i=yt.resolve(yt.dirname(t)),s=yt.resolve(yt.dirname(r));if(s===i||s===yt.parse(s).root)return;let o;try{o=await qi.stat(s,{bigint:!0});}catch(a){if(a.code==="ENOENT")return;throw a}if(Ws(e,o))throw new Error(qa(t,r,n));return Aw(t,e,s,n)}function Pw(t,e,r,n){let i=yt.resolve(yt.dirname(t)),s=yt.resolve(yt.dirname(r));if(s===i||s===yt.parse(s).root)return;let o;try{o=qi.statSync(s,{bigint:!0});}catch(a){if(a.code==="ENOENT")return;throw a}if(Ws(e,o))throw new Error(qa(t,r,n));return Pw(t,e,s,n)}function Ws(t,e){return e.ino&&e.dev&&e.ino===t.ino&&e.dev===t.dev}function Hf(t,e){let r=yt.resolve(t).split(yt.sep).filter(i=>i),n=yt.resolve(e).split(yt.sep).filter(i=>i);return r.every((i,s)=>n[s]===i)}function qa(t,e,r){return `Cannot ${r} '${t}' to a subdirectory of itself, '${e}'.`}Dw.exports={checkPaths:Tw(oN),checkPathsSync:aN,checkParentPaths:Tw(Aw),checkParentPathsSync:Pw,isSrcSubdir:Hf,areIdentical:Ws};});var Fw=A((w9,Mw)=>{var Ot=Wt(),Bs=oe("path"),{mkdirs:uN}=Dr(),{pathExists:cN}=En(),{utimesMillis:lN}=jf(),Us=Xn();async function fN(t,e,r={}){typeof r=="function"&&(r={filter:r}),r.clobber="clobber"in r?!!r.clobber:!0,r.overwrite="overwrite"in r?!!r.overwrite:r.clobber,r.preserveTimestamps&&process.arch==="ia32"&&process.emitWarning(`Using the preserveTimestamps option in 32-bit node is not recommended;

	see https://github.com/jprichardson/node-fs-extra/issues/269`,"Warning","fs-extra-WARN0001");let{srcStat:n,destStat:i}=await Us.checkPaths(t,e,"copy",r);if(await Us.checkParentPaths(t,n,e,"copy"),!await Iw(t,e,r))return;let o=Bs.dirname(e);await cN(o)||await uN(o),await kw(i,t,e,r);}async function Iw(t,e,r){return r.filter?r.filter(t,e):!0}async function kw(t,e,r,n){let s=await(n.dereference?Ot.stat:Ot.lstat)(e);if(s.isDirectory())return mN(s,t,e,r,n);if(s.isFile()||s.isCharacterDevice()||s.isBlockDevice())return dN(s,t,e,r,n);if(s.isSymbolicLink())return gN(t,e,r,n);throw s.isSocket()?new Error(`Cannot copy a socket file: ${e}`):s.isFIFO()?new Error(`Cannot copy a FIFO pipe: ${e}`):new Error(`Unknown file: ${e}`)}async function dN(t,e,r,n,i){if(!e)return Ow(t,r,n,i);if(i.overwrite)return await Ot.unlink(n),Ow(t,r,n,i);if(i.errorOnExist)throw new Error(`'${n}' already exists`)}async function Ow(t,e,r,n){if(await Ot.copyFile(e,r),n.preserveTimestamps){hN(t.mode)&&await pN(r,t.mode);let i=await Ot.stat(e);await lN(r,i.atime,i.mtime);}return Ot.chmod(r,t.mode)}function hN(t){return (t&128)===0}function pN(t,e){return Ot.chmod(t,e|128)}async function mN(t,e,r,n,i){e||await Ot.mkdir(n);let s=await Ot.readdir(r);await Promise.all(s.map(async o=>{let a=Bs.join(r,o),l=Bs.join(n,o);if(!await Iw(a,l,i))return;let{destStat:c}=await Us.checkPaths(a,l,"copy",i);return kw(c,a,l,i)})),e||await Ot.chmod(n,t.mode);}async function gN(t,e,r,n){let i=await Ot.readlink(e);if(n.dereference&&(i=Bs.resolve(process.cwd(),i)),!t)return Ot.symlink(i,r);let s=null;try{s=await Ot.readlink(r);}catch(o){if(o.code==="EINVAL"||o.code==="UNKNOWN")return Ot.symlink(i,r);throw o}if(n.dereference&&(s=Bs.resolve(process.cwd(),s)),Us.isSrcSubdir(i,s))throw new Error(`Cannot copy '${i}' to a subdirectory of itself, '${s}'.`);if(Us.isSrcSubdir(s,i))throw new Error(`Cannot overwrite '${s}' with '${i}'.`);return await Ot.unlink(r),Ot.symlink(i,r)}Mw.exports=fN;});var jw=A((S9,$w)=>{var Bt=Fi(),zs=oe("path"),_N=Dr().mkdirsSync,yN=jf().utimesMillisSync,Vs=Xn();function bN(t,e,r){typeof r=="function"&&(r={filter:r}),r=r||{},r.clobber="clobber"in r?!!r.clobber:!0,r.overwrite="overwrite"in r?!!r.overwrite:r.clobber,r.preserveTimestamps&&process.arch==="ia32"&&process.emitWarning(`Using the preserveTimestamps option in 32-bit node is not recommended;

	see https://github.com/jprichardson/node-fs-extra/issues/269`,"Warning","fs-extra-WARN0002");let{srcStat:n,destStat:i}=Vs.checkPathsSync(t,e,"copy",r);if(Vs.checkParentPathsSync(t,n,e,"copy"),r.filter&&!r.filter(t,e))return;let s=zs.dirname(e);return Bt.existsSync(s)||_N(s),Nw(i,t,e,r)}function Nw(t,e,r,n){let s=(n.dereference?Bt.statSync:Bt.lstatSync)(e);if(s.isDirectory())return xN(s,t,e,r,n);if(s.isFile()||s.isCharacterDevice()||s.isBlockDevice())return vN(s,t,e,r,n);if(s.isSymbolicLink())return PN(t,e,r,n);throw s.isSocket()?new Error(`Cannot copy a socket file: ${e}`):s.isFIFO()?new Error(`Cannot copy a FIFO pipe: ${e}`):new Error(`Unknown file: ${e}`)}function vN(t,e,r,n,i){return e?wN(t,r,n,i):qw(t,r,n,i)}function wN(t,e,r,n){if(n.overwrite)return Bt.unlinkSync(r),qw(t,e,r,n);if(n.errorOnExist)throw new Error(`'${r}' already exists`)}function qw(t,e,r,n){return Bt.copyFileSync(e,r),n.preserveTimestamps&&SN(t.mode,e,r),Wf(r,t.mode)}function SN(t,e,r){return EN(t)&&RN(r,t),CN(e,r)}function EN(t){return (t&128)===0}function RN(t,e){return Wf(t,e|128)}function Wf(t,e){return Bt.chmodSync(t,e)}function CN(t,e){let r=Bt.statSync(t);return yN(e,r.atime,r.mtime)}function xN(t,e,r,n,i){return e?Lw(r,n,i):TN(t.mode,r,n,i)}function TN(t,e,r,n){return Bt.mkdirSync(r),Lw(e,r,n),Wf(r,t)}function Lw(t,e,r){Bt.readdirSync(t).forEach(n=>AN(n,t,e,r));}function AN(t,e,r,n){let i=zs.join(e,t),s=zs.join(r,t);if(n.filter&&!n.filter(i,s))return;let{destStat:o}=Vs.checkPathsSync(i,s,"copy",n);return Nw(o,i,s,n)}function PN(t,e,r,n){let i=Bt.readlinkSync(e);if(n.dereference&&(i=zs.resolve(process.cwd(),i)),t){let s;try{s=Bt.readlinkSync(r);}catch(o){if(o.code==="EINVAL"||o.code==="UNKNOWN")return Bt.symlinkSync(i,r);throw o}if(n.dereference&&(s=zs.resolve(process.cwd(),s)),Vs.isSrcSubdir(i,s))throw new Error(`Cannot copy '${i}' to a subdirectory of itself, '${s}'.`);if(Vs.isSrcSubdir(s,i))throw new Error(`Cannot overwrite '${s}' with '${i}'.`);return DN(i,r)}else return Bt.symlinkSync(i,r)}function DN(t,e){return Bt.unlinkSync(e),Bt.symlinkSync(t,e)}$w.exports=bN;});var La=A((E9,Hw)=>{var ON=_t().fromPromise;Hw.exports={copy:ON(Fw()),copySync:jw()};});var Gs=A((R9,Bw)=>{var Ww=Fi(),IN=_t().fromCallback;function kN(t,e){Ww.rm(t,{recursive:!0,force:!0},e);}function MN(t){Ww.rmSync(t,{recursive:!0,force:!0});}Bw.exports={remove:IN(kN),removeSync:MN};});var Yw=A((C9,Jw)=>{var FN=_t().fromPromise,Vw=Wt(),Gw=oe("path"),Kw=Dr(),Zw=Gs(),Uw=FN(async function(e){let r;try{r=await Vw.readdir(e);}catch{return Kw.mkdirs(e)}return Promise.all(r.map(n=>Zw.remove(Gw.join(e,n))))});function zw(t){let e;try{e=Vw.readdirSync(t);}catch{return Kw.mkdirsSync(t)}e.forEach(r=>{r=Gw.join(t,r),Zw.removeSync(r);});}Jw.exports={emptyDirSync:zw,emptydirSync:zw,emptyDir:Uw,emptydir:Uw};});var tS=A((x9,eS)=>{var NN=_t().fromPromise,Xw=oe("path"),rn=Wt(),Qw=Dr();async function qN(t){let e;try{e=await rn.stat(t);}catch{}if(e&&e.isFile())return;let r=Xw.dirname(t),n=null;try{n=await rn.stat(r);}catch(i){if(i.code==="ENOENT"){await Qw.mkdirs(r),await rn.writeFile(t,"");return}else throw i}n.isDirectory()?await rn.writeFile(t,""):await rn.readdir(r);}function LN(t){let e;try{e=rn.statSync(t);}catch{}if(e&&e.isFile())return;let r=Xw.dirname(t);try{rn.statSync(r).isDirectory()||rn.readdirSync(r);}catch(n){if(n&&n.code==="ENOENT")Qw.mkdirsSync(r);else throw n}rn.writeFileSync(t,"");}eS.exports={createFile:NN(qN),createFileSync:LN};});var oS=A((T9,sS)=>{var $N=_t().fromPromise,rS=oe("path"),Rn=Wt(),nS=Dr(),{pathExists:jN}=En(),{areIdentical:iS}=Xn();async function HN(t,e){let r;try{r=await Rn.lstat(e);}catch{}let n;try{n=await Rn.lstat(t);}catch(o){throw o.message=o.message.replace("lstat","ensureLink"),o}if(r&&iS(n,r))return;let i=rS.dirname(e);await jN(i)||await nS.mkdirs(i),await Rn.link(t,e);}function WN(t,e){let r;try{r=Rn.lstatSync(e);}catch{}try{let s=Rn.lstatSync(t);if(r&&iS(s,r))return}catch(s){throw s.message=s.message.replace("lstat","ensureLink"),s}let n=rS.dirname(e);return Rn.existsSync(n)||nS.mkdirsSync(n),Rn.linkSync(t,e)}sS.exports={createLink:$N(HN),createLinkSync:WN};});var uS=A((A9,aS)=>{var Cn=oe("path"),Ks=Wt(),{pathExists:BN}=En(),UN=_t().fromPromise;async function zN(t,e){if(Cn.isAbsolute(t)){try{await Ks.lstat(t);}catch(s){throw s.message=s.message.replace("lstat","ensureSymlink"),s}return {toCwd:t,toDst:t}}let r=Cn.dirname(e),n=Cn.join(r,t);if(await BN(n))return {toCwd:n,toDst:t};try{await Ks.lstat(t);}catch(s){throw s.message=s.message.replace("lstat","ensureSymlink"),s}return {toCwd:t,toDst:Cn.relative(r,t)}}function VN(t,e){if(Cn.isAbsolute(t)){if(!Ks.existsSync(t))throw new Error("absolute srcpath does not exist");return {toCwd:t,toDst:t}}let r=Cn.dirname(e),n=Cn.join(r,t);if(Ks.existsSync(n))return {toCwd:n,toDst:t};if(!Ks.existsSync(t))throw new Error("relative srcpath does not exist");return {toCwd:t,toDst:Cn.relative(r,t)}}aS.exports={symlinkPaths:UN(zN),symlinkPathsSync:VN};});var fS=A((P9,lS)=>{var cS=Wt(),GN=_t().fromPromise;async function KN(t,e){if(e)return e;let r;try{r=await cS.lstat(t);}catch{return "file"}return r&&r.isDirectory()?"dir":"file"}function ZN(t,e){if(e)return e;let r;try{r=cS.lstatSync(t);}catch{return "file"}return r&&r.isDirectory()?"dir":"file"}lS.exports={symlinkType:GN(KN),symlinkTypeSync:ZN};});var mS=A((D9,pS)=>{var JN=_t().fromPromise,dS=oe("path"),Wr=Wt(),{mkdirs:YN,mkdirsSync:XN}=Dr(),{symlinkPaths:QN,symlinkPathsSync:eq}=uS(),{symlinkType:tq,symlinkTypeSync:rq}=fS(),{pathExists:nq}=En(),{areIdentical:hS}=Xn();async function iq(t,e,r){let n;try{n=await Wr.lstat(e);}catch{}if(n&&n.isSymbolicLink()){let[a,l]=await Promise.all([Wr.stat(t),Wr.stat(e)]);if(hS(a,l))return}let i=await QN(t,e);t=i.toDst;let s=await tq(i.toCwd,r),o=dS.dirname(e);return await nq(o)||await YN(o),Wr.symlink(t,e,s)}function sq(t,e,r){let n;try{n=Wr.lstatSync(e);}catch{}if(n&&n.isSymbolicLink()){let a=Wr.statSync(t),l=Wr.statSync(e);if(hS(a,l))return}let i=eq(t,e);t=i.toDst,r=rq(i.toCwd,r);let s=dS.dirname(e);return Wr.existsSync(s)||XN(s),Wr.symlinkSync(t,e,r)}pS.exports={createSymlink:JN(iq),createSymlinkSync:sq};});var ES=A((O9,SS)=>{var{createFile:gS,createFileSync:_S}=tS(),{createLink:yS,createLinkSync:bS}=oS(),{createSymlink:vS,createSymlinkSync:wS}=mS();SS.exports={createFile:gS,createFileSync:_S,ensureFile:gS,ensureFileSync:_S,createLink:yS,createLinkSync:bS,ensureLink:yS,ensureLinkSync:bS,createSymlink:vS,createSymlinkSync:wS,ensureSymlink:vS,ensureSymlinkSync:wS};});var $a=A((I9,RS)=>{function oq(t,{EOL:e=`
`,finalEOL:r=!0,replacer:n=null,spaces:i}={}){let s=r?e:"";return JSON.stringify(t,n,i).replace(/\n/g,e)+s}function aq(t){return Buffer.isBuffer(t)&&(t=t.toString("utf8")),t.replace(/^\uFEFF/,"")}RS.exports={stringify:oq,stripBom:aq};});var AS=A((k9,TS)=>{var Li;try{Li=Fi();}catch{Li=oe("fs");}var ja=_t(),{stringify:CS,stripBom:xS}=$a();async function uq(t,e={}){typeof e=="string"&&(e={encoding:e});let r=e.fs||Li,n="throws"in e?e.throws:!0,i=await ja.fromCallback(r.readFile)(t,e);i=xS(i);let s;try{s=JSON.parse(i,e?e.reviver:null);}catch(o){if(n)throw o.message=`${t}: ${o.message}`,o;return null}return s}var cq=ja.fromPromise(uq);function lq(t,e={}){typeof e=="string"&&(e={encoding:e});let r=e.fs||Li,n="throws"in e?e.throws:!0;try{let i=r.readFileSync(t,e);return i=xS(i),JSON.parse(i,e.reviver)}catch(i){if(n)throw i.message=`${t}: ${i.message}`,i;return null}}async function fq(t,e,r={}){let n=r.fs||Li,i=CS(e,r);await ja.fromCallback(n.writeFile)(t,i,r);}var dq=ja.fromPromise(fq);function hq(t,e,r={}){let n=r.fs||Li,i=CS(e,r);return n.writeFileSync(t,i,r)}var pq={readFile:cq,readFileSync:lq,writeFile:dq,writeFileSync:hq};TS.exports=pq;});var DS=A((M9,PS)=>{var Ha=AS();PS.exports={readJson:Ha.readFile,readJsonSync:Ha.readFileSync,writeJson:Ha.writeFile,writeJsonSync:Ha.writeFileSync};});var Wa=A((F9,kS)=>{var mq=_t().fromPromise,Bf=Wt(),OS=oe("path"),IS=Dr(),gq=En().pathExists;async function _q(t,e,r="utf-8"){let n=OS.dirname(t);return await gq(n)||await IS.mkdirs(n),Bf.writeFile(t,e,r)}function yq(t,...e){let r=OS.dirname(t);Bf.existsSync(r)||IS.mkdirsSync(r),Bf.writeFileSync(t,...e);}kS.exports={outputFile:mq(_q),outputFileSync:yq};});var NS=A((N9,MS)=>{var{stringify:bq}=$a(),{outputFile:vq}=Wa();async function wq(t,e,r={}){let n=bq(e,r);await vq(t,n,r);}MS.exports=wq;});var LS=A((q9,qS)=>{var{stringify:Sq}=$a(),{outputFileSync:Eq}=Wa();function Rq(t,e,r){let n=Sq(e,r);Eq(t,n,r);}qS.exports=Rq;});var jS=A((L9,$S)=>{var Cq=_t().fromPromise,Ut=DS();Ut.outputJson=Cq(NS());Ut.outputJsonSync=LS();Ut.outputJSON=Ut.outputJson;Ut.outputJSONSync=Ut.outputJsonSync;Ut.writeJSON=Ut.writeJson;Ut.writeJSONSync=Ut.writeJsonSync;Ut.readJSON=Ut.readJson;Ut.readJSONSync=Ut.readJsonSync;$S.exports=Ut;});var zS=A(($9,US)=>{var xq=Wt(),HS=oe("path"),{copy:Tq}=La(),{remove:BS}=Gs(),{mkdirp:Aq}=Dr(),{pathExists:Pq}=En(),WS=Xn();async function Dq(t,e,r={}){let n=r.overwrite||r.clobber||!1,{srcStat:i,isChangingCase:s=!1}=await WS.checkPaths(t,e,"move",r);await WS.checkParentPaths(t,i,e,"move");let o=HS.dirname(e);return HS.parse(o).root!==o&&await Aq(o),Oq(t,e,n,s)}async function Oq(t,e,r,n){if(!n){if(r)await BS(e);else if(await Pq(e))throw new Error("dest already exists.")}try{await xq.rename(t,e);}catch(i){if(i.code!=="EXDEV")throw i;await Iq(t,e,r);}}async function Iq(t,e,r){return await Tq(t,e,{overwrite:r,errorOnExist:!0,preserveTimestamps:!0}),BS(t)}US.exports=Dq;});var JS=A((j9,ZS)=>{var GS=Fi(),zf=oe("path"),kq=La().copySync,KS=Gs().removeSync,Mq=Dr().mkdirpSync,VS=Xn();function Fq(t,e,r){r=r||{};let n=r.overwrite||r.clobber||!1,{srcStat:i,isChangingCase:s=!1}=VS.checkPathsSync(t,e,"move",r);return VS.checkParentPathsSync(t,i,e,"move"),Nq(e)||Mq(zf.dirname(e)),qq(t,e,n,s)}function Nq(t){let e=zf.dirname(t);return zf.parse(e).root===e}function qq(t,e,r,n){if(n)return Uf(t,e,r);if(r)return KS(e),Uf(t,e,r);if(GS.existsSync(e))throw new Error("dest already exists.");return Uf(t,e,r)}function Uf(t,e,r){try{GS.renameSync(t,e);}catch(n){if(n.code!=="EXDEV")throw n;return Lq(t,e,r)}}function Lq(t,e,r){return kq(t,e,{overwrite:r,errorOnExist:!0,preserveTimestamps:!0}),KS(t)}ZS.exports=Fq;});var XS=A((H9,YS)=>{var $q=_t().fromPromise;YS.exports={move:$q(zS()),moveSync:JS()};});var Vf=A((W9,QS)=>{QS.exports={...Wt(),...La(),...Yw(),...ES(),...jS(),...Dr(),...XS(),...Wa(),...En(),...Gs()};});var Zs=A((B9,iE)=>{var jq=oe("path"),Br="\\\\/",eE=`[^${Br}]`,nn="\\.",Hq="\\+",Wq="\\?",Ba="\\/",Bq="(?=.)",tE="[^/]",Gf=`(?:${Ba}|$)`,rE=`(?:^|${Ba})`,Kf=`${nn}{1,2}${Gf}`,Uq=`(?!${nn})`,zq=`(?!${rE}${Kf})`,Vq=`(?!${nn}{0,1}${Gf})`,Gq=`(?!${Kf})`,Kq=`[^.${Ba}]`,Zq=`${tE}*?`,nE={DOT_LITERAL:nn,PLUS_LITERAL:Hq,QMARK_LITERAL:Wq,SLASH_LITERAL:Ba,ONE_CHAR:Bq,QMARK:tE,END_ANCHOR:Gf,DOTS_SLASH:Kf,NO_DOT:Uq,NO_DOTS:zq,NO_DOT_SLASH:Vq,NO_DOTS_SLASH:Gq,QMARK_NO_DOT:Kq,STAR:Zq,START_ANCHOR:rE},Jq={...nE,SLASH_LITERAL:`[${Br}]`,QMARK:eE,STAR:`${eE}*?`,DOTS_SLASH:`${nn}{1,2}(?:[${Br}]|$)`,NO_DOT:`(?!${nn})`,NO_DOTS:`(?!(?:^|[${Br}])${nn}{1,2}(?:[${Br}]|$))`,NO_DOT_SLASH:`(?!${nn}{0,1}(?:[${Br}]|$))`,NO_DOTS_SLASH:`(?!${nn}{1,2}(?:[${Br}]|$))`,QMARK_NO_DOT:`[^.${Br}]`,START_ANCHOR:`(?:^|[${Br}])`,END_ANCHOR:`(?:[${Br}]|$)`},Yq={alnum:"a-zA-Z0-9",alpha:"a-zA-Z",ascii:"\\x00-\\x7F",blank:" \\t",cntrl:"\\x00-\\x1F\\x7F",digit:"0-9",graph:"\\x21-\\x7E",lower:"a-z",print:"\\x20-\\x7E ",punct:"\\-!\"#$%&'()\\*+,./:;<=>?@[\\]^_`{|}~",space:" \\t\\r\\n\\v\\f",upper:"A-Z",word:"A-Za-z0-9_",xdigit:"A-Fa-f0-9"};iE.exports={MAX_LENGTH:1024*64,POSIX_REGEX_SOURCE:Yq,REGEX_BACKSLASH:/\\(?![*+?^${}(|)[\]])/g,REGEX_NON_SPECIAL_CHARS:/^[^@![\].,$*+?^{}()|\\/]+/,REGEX_SPECIAL_CHARS:/[-*+?.^${}(|)[\]]/,REGEX_SPECIAL_CHARS_BACKREF:/(\\?)((\W)(\3*))/g,REGEX_SPECIAL_CHARS_GLOBAL:/([-*+?.^${}(|)[\]])/g,REGEX_REMOVE_BACKSLASH:/(?:\[.*?[^\\]\]|\\(?=.))/g,REPLACEMENTS:{"***":"*","**/**":"**","**/**/**":"**"},CHAR_0:48,CHAR_9:57,CHAR_UPPERCASE_A:65,CHAR_LOWERCASE_A:97,CHAR_UPPERCASE_Z:90,CHAR_LOWERCASE_Z:122,CHAR_LEFT_PARENTHESES:40,CHAR_RIGHT_PARENTHESES:41,CHAR_ASTERISK:42,CHAR_AMPERSAND:38,CHAR_AT:64,CHAR_BACKWARD_SLASH:92,CHAR_CARRIAGE_RETURN:13,CHAR_CIRCUMFLEX_ACCENT:94,CHAR_COLON:58,CHAR_COMMA:44,CHAR_DOT:46,CHAR_DOUBLE_QUOTE:34,CHAR_EQUAL:61,CHAR_EXCLAMATION_MARK:33,CHAR_FORM_FEED:12,CHAR_FORWARD_SLASH:47,CHAR_GRAVE_ACCENT:96,CHAR_HASH:35,CHAR_HYPHEN_MINUS:45,CHAR_LEFT_ANGLE_BRACKET:60,CHAR_LEFT_CURLY_BRACE:123,CHAR_LEFT_SQUARE_BRACKET:91,CHAR_LINE_FEED:10,CHAR_NO_BREAK_SPACE:160,CHAR_PERCENT:37,CHAR_PLUS:43,CHAR_QUESTION_MARK:63,CHAR_RIGHT_ANGLE_BRACKET:62,CHAR_RIGHT_CURLY_BRACE:125,CHAR_RIGHT_SQUARE_BRACKET:93,CHAR_SEMICOLON:59,CHAR_SINGLE_QUOTE:39,CHAR_SPACE:32,CHAR_TAB:9,CHAR_UNDERSCORE:95,CHAR_VERTICAL_LINE:124,CHAR_ZERO_WIDTH_NOBREAK_SPACE:65279,SEP:jq.sep,extglobChars(t){return {"!":{type:"negate",open:"(?:(?!(?:",close:`))${t.STAR})`},"?":{type:"qmark",open:"(?:",close:")?"},"+":{type:"plus",open:"(?:",close:")+"},"*":{type:"star",open:"(?:",close:")*"},"@":{type:"at",open:"(?:",close:")"}}},globChars(t){return t===!0?Jq:nE}};});var Ua=A(Gt=>{var Xq=oe("path"),Qq=process.platform==="win32",{REGEX_BACKSLASH:eL,REGEX_REMOVE_BACKSLASH:tL,REGEX_SPECIAL_CHARS:rL,REGEX_SPECIAL_CHARS_GLOBAL:nL}=Zs();Gt.isObject=t=>t!==null&&typeof t=="object"&&!Array.isArray(t);Gt.hasRegexChars=t=>rL.test(t);Gt.isRegexChar=t=>t.length===1&&Gt.hasRegexChars(t);Gt.escapeRegex=t=>t.replace(nL,"\\$1");Gt.toPosixSlashes=t=>t.replace(eL,"/");Gt.removeBackslashes=t=>t.replace(tL,e=>e==="\\"?"":e);Gt.supportsLookbehinds=()=>{let t=process.version.slice(1).split(".").map(Number);return t.length===3&&t[0]>=9||t[0]===8&&t[1]>=10};Gt.isWindows=t=>t&&typeof t.windows=="boolean"?t.windows:Qq===!0||Xq.sep==="\\";Gt.escapeLast=(t,e,r)=>{let n=t.lastIndexOf(e,r);return n===-1?t:t[n-1]==="\\"?Gt.escapeLast(t,e,n-1):`${t.slice(0,n)}\\${t.slice(n)}`};Gt.removePrefix=(t,e={})=>{let r=t;return r.startsWith("./")&&(r=r.slice(2),e.prefix="./"),r};Gt.wrapOutput=(t,e={},r={})=>{let n=r.contains?"":"^",i=r.contains?"":"$",s=`${n}(?:${t})${i}`;return e.negated===!0&&(s=`(?:^(?!${s}).*$)`),s};});var dE=A((z9,fE)=>{var sE=Ua(),{CHAR_ASTERISK:Zf,CHAR_AT:iL,CHAR_BACKWARD_SLASH:Js,CHAR_COMMA:sL,CHAR_DOT:Jf,CHAR_EXCLAMATION_MARK:Yf,CHAR_FORWARD_SLASH:lE,CHAR_LEFT_CURLY_BRACE:Xf,CHAR_LEFT_PARENTHESES:Qf,CHAR_LEFT_SQUARE_BRACKET:oL,CHAR_PLUS:aL,CHAR_QUESTION_MARK:oE,CHAR_RIGHT_CURLY_BRACE:uL,CHAR_RIGHT_PARENTHESES:aE,CHAR_RIGHT_SQUARE_BRACKET:cL}=Zs(),uE=t=>t===lE||t===Js,cE=t=>{t.isPrefix!==!0&&(t.depth=t.isGlobstar?1/0:1);},lL=(t,e)=>{let r=e||{},n=t.length-1,i=r.parts===!0||r.scanToEnd===!0,s=[],o=[],a=[],l=t,d=-1,c=0,p=0,m=!1,_=!1,w=!1,E=!1,P=!1,D=!1,g=!1,S=!1,I=!1,L=!1,Z=0,K,U,B={value:"",depth:0,isGlob:!1},Q=()=>d>=n,N=()=>l.charCodeAt(d+1),te=()=>(K=U,l.charCodeAt(++d));for(;d<n;){U=te();let me;if(U===Js){g=B.backslashes=!0,U=te(),U===Xf&&(D=!0);continue}if(D===!0||U===Xf){for(Z++;Q()!==!0&&(U=te());){if(U===Js){g=B.backslashes=!0,te();continue}if(U===Xf){Z++;continue}if(D!==!0&&U===Jf&&(U=te())===Jf){if(m=B.isBrace=!0,w=B.isGlob=!0,L=!0,i===!0)continue;break}if(D!==!0&&U===sL){if(m=B.isBrace=!0,w=B.isGlob=!0,L=!0,i===!0)continue;break}if(U===uL&&(Z--,Z===0)){D=!1,m=B.isBrace=!0,L=!0;break}}if(i===!0)continue;break}if(U===lE){if(s.push(d),o.push(B),B={value:"",depth:0,isGlob:!1},L===!0)continue;if(K===Jf&&d===c+1){c+=2;continue}p=d+1;continue}if(r.noext!==!0&&(U===aL||U===iL||U===Zf||U===oE||U===Yf)===!0&&N()===Qf){if(w=B.isGlob=!0,E=B.isExtglob=!0,L=!0,U===Yf&&d===c&&(I=!0),i===!0){for(;Q()!==!0&&(U=te());){if(U===Js){g=B.backslashes=!0,U=te();continue}if(U===aE){w=B.isGlob=!0,L=!0;break}}continue}break}if(U===Zf){if(K===Zf&&(P=B.isGlobstar=!0),w=B.isGlob=!0,L=!0,i===!0)continue;break}if(U===oE){if(w=B.isGlob=!0,L=!0,i===!0)continue;break}if(U===oL){for(;Q()!==!0&&(me=te());){if(me===Js){g=B.backslashes=!0,te();continue}if(me===cL){_=B.isBracket=!0,w=B.isGlob=!0,L=!0;break}}if(i===!0)continue;break}if(r.nonegate!==!0&&U===Yf&&d===c){S=B.negated=!0,c++;continue}if(r.noparen!==!0&&U===Qf){if(w=B.isGlob=!0,i===!0){for(;Q()!==!0&&(U=te());){if(U===Qf){g=B.backslashes=!0,U=te();continue}if(U===aE){L=!0;break}}continue}break}if(w===!0){if(L=!0,i===!0)continue;break}}r.noext===!0&&(E=!1,w=!1);let ae=l,ye="",q="";c>0&&(ye=l.slice(0,c),l=l.slice(c),p-=c),ae&&w===!0&&p>0?(ae=l.slice(0,p),q=l.slice(p)):w===!0?(ae="",q=l):ae=l,ae&&ae!==""&&ae!=="/"&&ae!==l&&uE(ae.charCodeAt(ae.length-1))&&(ae=ae.slice(0,-1)),r.unescape===!0&&(q&&(q=sE.removeBackslashes(q)),ae&&g===!0&&(ae=sE.removeBackslashes(ae)));let W={prefix:ye,input:t,start:c,base:ae,glob:q,isBrace:m,isBracket:_,isGlob:w,isExtglob:E,isGlobstar:P,negated:S,negatedExtglob:I};if(r.tokens===!0&&(W.maxDepth=0,uE(U)||o.push(B),W.tokens=o),r.parts===!0||r.tokens===!0){let me;for(let pe=0;pe<s.length;pe++){let we=me?me+1:c,Xe=s[pe],Ke=t.slice(we,Xe);r.tokens&&(pe===0&&c!==0?(o[pe].isPrefix=!0,o[pe].value=ye):o[pe].value=Ke,cE(o[pe]),W.maxDepth+=o[pe].depth),(pe!==0||Ke!=="")&&a.push(Ke),me=Xe;}if(me&&me+1<t.length){let pe=t.slice(me+1);a.push(pe),r.tokens&&(o[o.length-1].value=pe,cE(o[o.length-1]),W.maxDepth+=o[o.length-1].depth);}W.slashes=s,W.parts=a;}return W};fE.exports=lL;});var mE=A((V9,pE)=>{var za=Zs(),or=Ua(),{MAX_LENGTH:Va,POSIX_REGEX_SOURCE:fL,REGEX_NON_SPECIAL_CHARS:dL,REGEX_SPECIAL_CHARS_BACKREF:hL,REPLACEMENTS:hE}=za,pL=(t,e)=>{if(typeof e.expandRange=="function")return e.expandRange(...t,e);t.sort();let r=`[${t.join("-")}]`;return r},$i=(t,e)=>`Missing ${t}: "${e}" - use "\\\\${e}" to match literal characters`,ed=(t,e)=>{if(typeof t!="string")throw new TypeError("Expected a string");t=hE[t]||t;let r={...e},n=typeof r.maxLength=="number"?Math.min(Va,r.maxLength):Va,i=t.length;if(i>n)throw new SyntaxError(`Input length: ${i}, exceeds maximum allowed length: ${n}`);let s={type:"bos",value:"",output:r.prepend||""},o=[s],a=r.capture?"":"?:",l=or.isWindows(e),d=za.globChars(l),c=za.extglobChars(d),{DOT_LITERAL:p,PLUS_LITERAL:m,SLASH_LITERAL:_,ONE_CHAR:w,DOTS_SLASH:E,NO_DOT:P,NO_DOT_SLASH:D,NO_DOTS_SLASH:g,QMARK:S,QMARK_NO_DOT:I,STAR:L,START_ANCHOR:Z}=d,K=ce=>`(${a}(?:(?!${Z}${ce.dot?E:p}).)*?)`,U=r.dot?"":P,B=r.dot?S:I,Q=r.bash===!0?K(r):L;r.capture&&(Q=`(${Q})`),typeof r.noext=="boolean"&&(r.noextglob=r.noext);let N={input:t,index:-1,start:0,dot:r.dot===!0,consumed:"",output:"",prefix:"",backtrack:!1,negated:!1,brackets:0,braces:0,parens:0,quotes:0,globstar:!1,tokens:o};t=or.removePrefix(t,N),i=t.length;let te=[],ae=[],ye=[],q=s,W,me=()=>N.index===i-1,pe=N.peek=(ce=1)=>t[N.index+ce],we=N.advance=()=>t[++N.index]||"",Xe=()=>t.slice(N.index+1),Ke=(ce="",Me=0)=>{N.consumed+=ce,N.index+=Me;},Pt=ce=>{N.output+=ce.output!=null?ce.output:ce.value,Ke(ce.value);},Lr=()=>{let ce=1;for(;pe()==="!"&&(pe(2)!=="("||pe(3)==="?");)we(),N.start++,ce++;return ce%2===0?!1:(N.negated=!0,N.start++,!0)},zt=ce=>{N[ce]++,ye.push(ce);},St=ce=>{N[ce]--,ye.pop();},Ce=ce=>{if(q.type==="globstar"){let Me=N.braces>0&&(ce.type==="comma"||ce.type==="brace"),ie=ce.extglob===!0||te.length&&(ce.type==="pipe"||ce.type==="paren");ce.type!=="slash"&&ce.type!=="paren"&&!Me&&!ie&&(N.output=N.output.slice(0,-q.output.length),q.type="star",q.value="*",q.output=Q,N.output+=q.output);}if(te.length&&ce.type!=="paren"&&(te[te.length-1].inner+=ce.value),(ce.value||ce.output)&&Pt(ce),q&&q.type==="text"&&ce.type==="text"){q.value+=ce.value,q.output=(q.output||"")+ce.value;return}ce.prev=q,o.push(ce),q=ce;},Cr=(ce,Me)=>{let ie={...c[Me],conditions:1,inner:""};ie.prev=q,ie.parens=N.parens,ie.output=N.output;let be=(r.capture?"(":"")+ie.open;zt("parens"),Ce({type:ce,value:Me,output:N.output?"":w}),Ce({type:"paren",extglob:!0,value:we(),output:be}),te.push(ie);},fn=ce=>{let Me=ce.close+(r.capture?")":""),ie;if(ce.type==="negate"){let be=Q;if(ce.inner&&ce.inner.length>1&&ce.inner.includes("/")&&(be=K(r)),(be!==Q||me()||/^\)+$/.test(Xe()))&&(Me=ce.close=`)$))${be}`),ce.inner.includes("*")&&(ie=Xe())&&/^\.[^\\/.]+$/.test(ie)){let $e=ed(ie,{...e,fastpaths:!1}).output;Me=ce.close=`)${$e})${be})`;}ce.prev.type==="bos"&&(N.negatedExtglob=!0);}Ce({type:"paren",extglob:!0,value:W,output:Me}),St("parens");};if(r.fastpaths!==!1&&!/(^[*!]|[/()[\]{}"])/.test(t)){let ce=!1,Me=t.replace(hL,(ie,be,$e,ot,He,fr)=>ot==="\\"?(ce=!0,ie):ot==="?"?be?be+ot+(He?S.repeat(He.length):""):fr===0?B+(He?S.repeat(He.length):""):S.repeat($e.length):ot==="."?p.repeat($e.length):ot==="*"?be?be+ot+(He?Q:""):Q:be?ie:`\\${ie}`);return ce===!0&&(r.unescape===!0?Me=Me.replace(/\\/g,""):Me=Me.replace(/\\+/g,ie=>ie.length%2===0?"\\\\":ie?"\\":"")),Me===t&&r.contains===!0?(N.output=t,N):(N.output=or.wrapOutput(Me,N,e),N)}for(;!me();){if(W=we(),W==="\0")continue;if(W==="\\"){let ie=pe();if(ie==="/"&&r.bash!==!0||ie==="."||ie===";")continue;if(!ie){W+="\\",Ce({type:"text",value:W});continue}let be=/^\\+/.exec(Xe()),$e=0;if(be&&be[0].length>2&&($e=be[0].length,N.index+=$e,$e%2!==0&&(W+="\\")),r.unescape===!0?W=we():W+=we(),N.brackets===0){Ce({type:"text",value:W});continue}}if(N.brackets>0&&(W!=="]"||q.value==="["||q.value==="[^")){if(r.posix!==!1&&W===":"){let ie=q.value.slice(1);if(ie.includes("[")&&(q.posix=!0,ie.includes(":"))){let be=q.value.lastIndexOf("["),$e=q.value.slice(0,be),ot=q.value.slice(be+2),He=fL[ot];if(He){q.value=$e+He,N.backtrack=!0,we(),!s.output&&o.indexOf(q)===1&&(s.output=w);continue}}}(W==="["&&pe()!==":"||W==="-"&&pe()==="]")&&(W=`\\${W}`),W==="]"&&(q.value==="["||q.value==="[^")&&(W=`\\${W}`),r.posix===!0&&W==="!"&&q.value==="["&&(W="^"),q.value+=W,Pt({value:W});continue}if(N.quotes===1&&W!=='"'){W=or.escapeRegex(W),q.value+=W,Pt({value:W});continue}if(W==='"'){N.quotes=N.quotes===1?0:1,r.keepQuotes===!0&&Ce({type:"text",value:W});continue}if(W==="("){zt("parens"),Ce({type:"paren",value:W});continue}if(W===")"){if(N.parens===0&&r.strictBrackets===!0)throw new SyntaxError($i("opening","("));let ie=te[te.length-1];if(ie&&N.parens===ie.parens+1){fn(te.pop());continue}Ce({type:"paren",value:W,output:N.parens?")":"\\)"}),St("parens");continue}if(W==="["){if(r.nobracket===!0||!Xe().includes("]")){if(r.nobracket!==!0&&r.strictBrackets===!0)throw new SyntaxError($i("closing","]"));W=`\\${W}`;}else zt("brackets");Ce({type:"bracket",value:W});continue}if(W==="]"){if(r.nobracket===!0||q&&q.type==="bracket"&&q.value.length===1){Ce({type:"text",value:W,output:`\\${W}`});continue}if(N.brackets===0){if(r.strictBrackets===!0)throw new SyntaxError($i("opening","["));Ce({type:"text",value:W,output:`\\${W}`});continue}St("brackets");let ie=q.value.slice(1);if(q.posix!==!0&&ie[0]==="^"&&!ie.includes("/")&&(W=`/${W}`),q.value+=W,Pt({value:W}),r.literalBrackets===!1||or.hasRegexChars(ie))continue;let be=or.escapeRegex(q.value);if(N.output=N.output.slice(0,-q.value.length),r.literalBrackets===!0){N.output+=be,q.value=be;continue}q.value=`(${a}${be}|${q.value})`,N.output+=q.value;continue}if(W==="{"&&r.nobrace!==!0){zt("braces");let ie={type:"brace",value:W,output:"(",outputIndex:N.output.length,tokensIndex:N.tokens.length};ae.push(ie),Ce(ie);continue}if(W==="}"){let ie=ae[ae.length-1];if(r.nobrace===!0||!ie){Ce({type:"text",value:W,output:W});continue}let be=")";if(ie.dots===!0){let $e=o.slice(),ot=[];for(let He=$e.length-1;He>=0&&(o.pop(),$e[He].type!=="brace");He--)$e[He].type!=="dots"&&ot.unshift($e[He].value);be=pL(ot,r),N.backtrack=!0;}if(ie.comma!==!0&&ie.dots!==!0){let $e=N.output.slice(0,ie.outputIndex),ot=N.tokens.slice(ie.tokensIndex);ie.value=ie.output="\\{",W=be="\\}",N.output=$e;for(let He of ot)N.output+=He.output||He.value;}Ce({type:"brace",value:W,output:be}),St("braces"),ae.pop();continue}if(W==="|"){te.length>0&&te[te.length-1].conditions++,Ce({type:"text",value:W});continue}if(W===","){let ie=W,be=ae[ae.length-1];be&&ye[ye.length-1]==="braces"&&(be.comma=!0,ie="|"),Ce({type:"comma",value:W,output:ie});continue}if(W==="/"){if(q.type==="dot"&&N.index===N.start+1){N.start=N.index+1,N.consumed="",N.output="",o.pop(),q=s;continue}Ce({type:"slash",value:W,output:_});continue}if(W==="."){if(N.braces>0&&q.type==="dot"){q.value==="."&&(q.output=p);let ie=ae[ae.length-1];q.type="dots",q.output+=W,q.value+=W,ie.dots=!0;continue}if(N.braces+N.parens===0&&q.type!=="bos"&&q.type!=="slash"){Ce({type:"text",value:W,output:p});continue}Ce({type:"dot",value:W,output:p});continue}if(W==="?"){if(!(q&&q.value==="(")&&r.noextglob!==!0&&pe()==="("&&pe(2)!=="?"){Cr("qmark",W);continue}if(q&&q.type==="paren"){let be=pe(),$e=W;if(be==="<"&&!or.supportsLookbehinds())throw new Error("Node.js v10 or higher is required for regex lookbehinds");(q.value==="("&&!/[!=<:]/.test(be)||be==="<"&&!/<([!=]|\w+>)/.test(Xe()))&&($e=`\\${W}`),Ce({type:"text",value:W,output:$e});continue}if(r.dot!==!0&&(q.type==="slash"||q.type==="bos")){Ce({type:"qmark",value:W,output:I});continue}Ce({type:"qmark",value:W,output:S});continue}if(W==="!"){if(r.noextglob!==!0&&pe()==="("&&(pe(2)!=="?"||!/[!=<:]/.test(pe(3)))){Cr("negate",W);continue}if(r.nonegate!==!0&&N.index===0){Lr();continue}}if(W==="+"){if(r.noextglob!==!0&&pe()==="("&&pe(2)!=="?"){Cr("plus",W);continue}if(q&&q.value==="("||r.regex===!1){Ce({type:"plus",value:W,output:m});continue}if(q&&(q.type==="bracket"||q.type==="paren"||q.type==="brace")||N.parens>0){Ce({type:"plus",value:W});continue}Ce({type:"plus",value:m});continue}if(W==="@"){if(r.noextglob!==!0&&pe()==="("&&pe(2)!=="?"){Ce({type:"at",extglob:!0,value:W,output:""});continue}Ce({type:"text",value:W});continue}if(W!=="*"){(W==="$"||W==="^")&&(W=`\\${W}`);let ie=dL.exec(Xe());ie&&(W+=ie[0],N.index+=ie[0].length),Ce({type:"text",value:W});continue}if(q&&(q.type==="globstar"||q.star===!0)){q.type="star",q.star=!0,q.value+=W,q.output=Q,N.backtrack=!0,N.globstar=!0,Ke(W);continue}let ce=Xe();if(r.noextglob!==!0&&/^\([^?]/.test(ce)){Cr("star",W);continue}if(q.type==="star"){if(r.noglobstar===!0){Ke(W);continue}let ie=q.prev,be=ie.prev,$e=ie.type==="slash"||ie.type==="bos",ot=be&&(be.type==="star"||be.type==="globstar");if(r.bash===!0&&(!$e||ce[0]&&ce[0]!=="/")){Ce({type:"star",value:W,output:""});continue}let He=N.braces>0&&(ie.type==="comma"||ie.type==="brace"),fr=te.length&&(ie.type==="pipe"||ie.type==="paren");if(!$e&&ie.type!=="paren"&&!He&&!fr){Ce({type:"star",value:W,output:""});continue}for(;ce.slice(0,3)==="/**";){let Nt=t[N.index+4];if(Nt&&Nt!=="/")break;ce=ce.slice(3),Ke("/**",3);}if(ie.type==="bos"&&me()){q.type="globstar",q.value+=W,q.output=K(r),N.output=q.output,N.globstar=!0,Ke(W);continue}if(ie.type==="slash"&&ie.prev.type!=="bos"&&!ot&&me()){N.output=N.output.slice(0,-(ie.output+q.output).length),ie.output=`(?:${ie.output}`,q.type="globstar",q.output=K(r)+(r.strictSlashes?")":"|$)"),q.value+=W,N.globstar=!0,N.output+=ie.output+q.output,Ke(W);continue}if(ie.type==="slash"&&ie.prev.type!=="bos"&&ce[0]==="/"){let Nt=ce[1]!==void 0?"|$":"";N.output=N.output.slice(0,-(ie.output+q.output).length),ie.output=`(?:${ie.output}`,q.type="globstar",q.output=`${K(r)}${_}|${_}${Nt})`,q.value+=W,N.output+=ie.output+q.output,N.globstar=!0,Ke(W+we()),Ce({type:"slash",value:"/",output:""});continue}if(ie.type==="bos"&&ce[0]==="/"){q.type="globstar",q.value+=W,q.output=`(?:^|${_}|${K(r)}${_})`,N.output=q.output,N.globstar=!0,Ke(W+we()),Ce({type:"slash",value:"/",output:""});continue}N.output=N.output.slice(0,-q.output.length),q.type="globstar",q.output=K(r),q.value+=W,N.output+=q.output,N.globstar=!0,Ke(W);continue}let Me={type:"star",value:W,output:Q};if(r.bash===!0){Me.output=".*?",(q.type==="bos"||q.type==="slash")&&(Me.output=U+Me.output),Ce(Me);continue}if(q&&(q.type==="bracket"||q.type==="paren")&&r.regex===!0){Me.output=W,Ce(Me);continue}(N.index===N.start||q.type==="slash"||q.type==="dot")&&(q.type==="dot"?(N.output+=D,q.output+=D):r.dot===!0?(N.output+=g,q.output+=g):(N.output+=U,q.output+=U),pe()!=="*"&&(N.output+=w,q.output+=w)),Ce(Me);}for(;N.brackets>0;){if(r.strictBrackets===!0)throw new SyntaxError($i("closing","]"));N.output=or.escapeLast(N.output,"["),St("brackets");}for(;N.parens>0;){if(r.strictBrackets===!0)throw new SyntaxError($i("closing",")"));N.output=or.escapeLast(N.output,"("),St("parens");}for(;N.braces>0;){if(r.strictBrackets===!0)throw new SyntaxError($i("closing","}"));N.output=or.escapeLast(N.output,"{"),St("braces");}if(r.strictSlashes!==!0&&(q.type==="star"||q.type==="bracket")&&Ce({type:"maybe_slash",value:"",output:`${_}?`}),N.backtrack===!0){N.output="";for(let ce of N.tokens)N.output+=ce.output!=null?ce.output:ce.value,ce.suffix&&(N.output+=ce.suffix);}return N};ed.fastpaths=(t,e)=>{let r={...e},n=typeof r.maxLength=="number"?Math.min(Va,r.maxLength):Va,i=t.length;if(i>n)throw new SyntaxError(`Input length: ${i}, exceeds maximum allowed length: ${n}`);t=hE[t]||t;let s=or.isWindows(e),{DOT_LITERAL:o,SLASH_LITERAL:a,ONE_CHAR:l,DOTS_SLASH:d,NO_DOT:c,NO_DOTS:p,NO_DOTS_SLASH:m,STAR:_,START_ANCHOR:w}=za.globChars(s),E=r.dot?p:c,P=r.dot?m:c,D=r.capture?"":"?:",g={negated:!1,prefix:""},S=r.bash===!0?".*?":_;r.capture&&(S=`(${S})`);let I=U=>U.noglobstar===!0?S:`(${D}(?:(?!${w}${U.dot?d:o}).)*?)`,L=U=>{switch(U){case"*":return `${E}${l}${S}`;case".*":return `${o}${l}${S}`;case"*.*":return `${E}${S}${o}${l}${S}`;case"*/*":return `${E}${S}${a}${l}${P}${S}`;case"**":return E+I(r);case"**/*":return `(?:${E}${I(r)}${a})?${P}${l}${S}`;case"**/*.*":return `(?:${E}${I(r)}${a})?${P}${S}${o}${l}${S}`;case"**/.*":return `(?:${E}${I(r)}${a})?${o}${l}${S}`;default:{let B=/^(.*?)\.(\w+)$/.exec(U);if(!B)return;let Q=L(B[1]);return Q?Q+o+B[2]:void 0}}},Z=or.removePrefix(t,g),K=L(Z);return K&&r.strictSlashes!==!0&&(K+=`${a}?`),K};pE.exports=ed;});var _E=A((G9,gE)=>{var mL=oe("path"),gL=dE(),td=mE(),rd=Ua(),_L=Zs(),yL=t=>t&&typeof t=="object"&&!Array.isArray(t),lt=(t,e,r=!1)=>{if(Array.isArray(t)){let c=t.map(m=>lt(m,e,r));return m=>{for(let _ of c){let w=_(m);if(w)return w}return !1}}let n=yL(t)&&t.tokens&&t.input;if(t===""||typeof t!="string"&&!n)throw new TypeError("Expected pattern to be a non-empty string");let i=e||{},s=rd.isWindows(e),o=n?lt.compileRe(t,e):lt.makeRe(t,e,!1,!0),a=o.state;delete o.state;let l=()=>!1;if(i.ignore){let c={...e,ignore:null,onMatch:null,onResult:null};l=lt(i.ignore,c,r);}let d=(c,p=!1)=>{let{isMatch:m,match:_,output:w}=lt.test(c,o,e,{glob:t,posix:s}),E={glob:t,state:a,regex:o,posix:s,input:c,output:w,match:_,isMatch:m};return typeof i.onResult=="function"&&i.onResult(E),m===!1?(E.isMatch=!1,p?E:!1):l(c)?(typeof i.onIgnore=="function"&&i.onIgnore(E),E.isMatch=!1,p?E:!1):(typeof i.onMatch=="function"&&i.onMatch(E),p?E:!0)};return r&&(d.state=a),d};lt.test=(t,e,r,{glob:n,posix:i}={})=>{if(typeof t!="string")throw new TypeError("Expected input to be a string");if(t==="")return {isMatch:!1,output:""};let s=r||{},o=s.format||(i?rd.toPosixSlashes:null),a=t===n,l=a&&o?o(t):t;return a===!1&&(l=o?o(t):t,a=l===n),(a===!1||s.capture===!0)&&(s.matchBase===!0||s.basename===!0?a=lt.matchBase(t,e,r,i):a=e.exec(l)),{isMatch:!!a,match:a,output:l}};lt.matchBase=(t,e,r,n=rd.isWindows(r))=>(e instanceof RegExp?e:lt.makeRe(e,r)).test(mL.basename(t));lt.isMatch=(t,e,r)=>lt(e,r)(t);lt.parse=(t,e)=>Array.isArray(t)?t.map(r=>lt.parse(r,e)):td(t,{...e,fastpaths:!1});lt.scan=(t,e)=>gL(t,e);lt.compileRe=(t,e,r=!1,n=!1)=>{if(r===!0)return t.output;let i=e||{},s=i.contains?"":"^",o=i.contains?"":"$",a=`${s}(?:${t.output})${o}`;t&&t.negated===!0&&(a=`^(?!${a}).*$`);let l=lt.toRegex(a,e);return n===!0&&(l.state=t),l};lt.makeRe=(t,e={},r=!1,n=!1)=>{if(!t||typeof t!="string")throw new TypeError("Expected a non-empty string");let i={negated:!1,fastpaths:!0};return e.fastpaths!==!1&&(t[0]==="."||t[0]==="*")&&(i.output=td.fastpaths(t,e)),i.output||(i=td(t,e)),lt.compileRe(i,e,r,n)};lt.toRegex=(t,e)=>{try{let r=e||{};return new RegExp(t,r.flags||(r.nocase?"i":""))}catch(r){if(e&&e.debug===!0)throw r;return /$^/}};lt.constants=_L;gE.exports=lt;});var nd=A((K9,yE)=>{yE.exports=_E();});var xE=A((Z9,CE)=>{var Xs=oe("fs"),{Readable:bL}=oe("stream"),Ys=oe("path"),{promisify:Ja}=oe("util"),id=nd(),vL=Ja(Xs.readdir),wL=Ja(Xs.stat),bE=Ja(Xs.lstat),SL=Ja(Xs.realpath),EL="!",EE="READDIRP_RECURSIVE_ERROR",RL=new Set(["ENOENT","EPERM","EACCES","ELOOP",EE]),sd="files",RE="directories",Ka="files_directories",Ga="all",vE=[sd,RE,Ka,Ga],CL=t=>RL.has(t.code),[wE,xL]=process.versions.node.split(".").slice(0,2).map(t=>Number.parseInt(t,10)),TL=process.platform==="win32"&&(wE>10||wE===10&&xL>=5),SE=t=>{if(t!==void 0){if(typeof t=="function")return t;if(typeof t=="string"){let e=id(t.trim());return r=>e(r.basename)}if(Array.isArray(t)){let e=[],r=[];for(let n of t){let i=n.trim();i.charAt(0)===EL?r.push(id(i.slice(1))):e.push(id(i));}return r.length>0?e.length>0?n=>e.some(i=>i(n.basename))&&!r.some(i=>i(n.basename)):n=>!r.some(i=>i(n.basename)):n=>e.some(i=>i(n.basename))}}},Za=class t extends bL{static get defaultOptions(){return {root:".",fileFilter:e=>!0,directoryFilter:e=>!0,type:sd,lstat:!1,depth:2147483648,alwaysStat:!1}}constructor(e={}){super({objectMode:!0,autoDestroy:!0,highWaterMark:e.highWaterMark||4096});let r={...t.defaultOptions,...e},{root:n,type:i}=r;this._fileFilter=SE(r.fileFilter),this._directoryFilter=SE(r.directoryFilter);let s=r.lstat?bE:wL;TL?this._stat=o=>s(o,{bigint:!0}):this._stat=s,this._maxDepth=r.depth,this._wantsDir=[RE,Ka,Ga].includes(i),this._wantsFile=[sd,Ka,Ga].includes(i),this._wantsEverything=i===Ga,this._root=Ys.resolve(n),this._isDirent="Dirent"in Xs&&!r.alwaysStat,this._statsProp=this._isDirent?"dirent":"stats",this._rdOptions={encoding:"utf8",withFileTypes:this._isDirent},this.parents=[this._exploreDir(n,1)],this.reading=!1,this.parent=void 0;}async _read(e){if(!this.reading){this.reading=!0;try{for(;!this.destroyed&&e>0;){let{path:r,depth:n,files:i=[]}=this.parent||{};if(i.length>0){let s=i.splice(0,e).map(o=>this._formatEntry(o,r));for(let o of await Promise.all(s)){if(this.destroyed)return;let a=await this._getEntryType(o);a==="directory"&&this._directoryFilter(o)?(n<=this._maxDepth&&this.parents.push(this._exploreDir(o.fullPath,n+1)),this._wantsDir&&(this.push(o),e--)):(a==="file"||this._includeAsFile(o))&&this._fileFilter(o)&&this._wantsFile&&(this.push(o),e--);}}else {let s=this.parents.pop();if(!s){this.push(null);break}if(this.parent=await s,this.destroyed)return}}}catch(r){this.destroy(r);}finally{this.reading=!1;}}}async _exploreDir(e,r){let n;try{n=await vL(e,this._rdOptions);}catch(i){this._onError(i);}return {files:n,depth:r,path:e}}async _formatEntry(e,r){let n;try{let i=this._isDirent?e.name:e,s=Ys.resolve(Ys.join(r,i));n={path:Ys.relative(this._root,s),fullPath:s,basename:i},n[this._statsProp]=this._isDirent?e:await this._stat(s);}catch(i){this._onError(i);}return n}_onError(e){CL(e)&&!this.destroyed?this.emit("warn",e):this.destroy(e);}async _getEntryType(e){let r=e&&e[this._statsProp];if(r){if(r.isFile())return "file";if(r.isDirectory())return "directory";if(r&&r.isSymbolicLink()){let n=e.fullPath;try{let i=await SL(n),s=await bE(i);if(s.isFile())return "file";if(s.isDirectory()){let o=i.length;if(n.startsWith(i)&&n.substr(o,1)===Ys.sep){let a=new Error(`Circular symlink detected: "${n}" points to "${i}"`);return a.code=EE,this._onError(a)}return "directory"}}catch(i){this._onError(i);}}}}_includeAsFile(e){let r=e&&e[this._statsProp];return r&&this._wantsEverything&&!r.isDirectory()}},ji=(t,e={})=>{let r=e.entryType||e.type;if(r==="both"&&(r=Ka),r&&(e.type=r),t){if(typeof t!="string")throw new TypeError("readdirp: root argument must be a string. Usage: readdirp(root, options)");if(r&&!vE.includes(r))throw new Error(`readdirp: Invalid type passed. Use one of ${vE.join(", ")}`)}else throw new Error("readdirp: root argument is required. Usage: readdirp(root, options)");return e.root=t,new Za(e)},AL=(t,e={})=>new Promise((r,n)=>{let i=[];ji(t,e).on("data",s=>i.push(s)).on("end",()=>r(i)).on("error",s=>n(s));});ji.promise=AL;ji.ReaddirpStream=Za;ji.default=ji;CE.exports=ji;});var od=A((J9,TE)=>{TE.exports=function(t,e){if(typeof t!="string")throw new TypeError("expected path to be a string");if(t==="\\"||t==="/")return "/";var r=t.length;if(r<=1)return t;var n="";if(r>4&&t[3]==="\\"){var i=t[2];(i==="?"||i===".")&&t.slice(0,2)==="\\\\"&&(t=t.slice(2),n="//");}var s=t.split(/[/\\]+/);return e!==!1&&s[s.length-1]===""&&s.pop(),n+s.join("/")};});var kE=A((OE,IE)=>{Object.defineProperty(OE,"__esModule",{value:!0});var DE=nd(),PL=od(),AE="!",DL={returnIndex:!1},OL=t=>Array.isArray(t)?t:[t],IL=(t,e)=>{if(typeof t=="function")return t;if(typeof t=="string"){let r=DE(t,e);return n=>t===n||r(n)}return t instanceof RegExp?r=>t.test(r):r=>!1},PE=(t,e,r,n)=>{let i=Array.isArray(r),s=i?r[0]:r;if(!i&&typeof s!="string")throw new TypeError("anymatch: second argument must be a string: got "+Object.prototype.toString.call(s));let o=PL(s,!1);for(let l=0;l<e.length;l++){let d=e[l];if(d(o))return n?-1:!1}let a=i&&[o].concat(r.slice(1));for(let l=0;l<t.length;l++){let d=t[l];if(i?d(...a):d(o))return n?l:!0}return n?-1:!1},ad=(t,e,r=DL)=>{if(t==null)throw new TypeError("anymatch: specify first argument");let n=typeof r=="boolean"?{returnIndex:r}:r,i=n.returnIndex||!1,s=OL(t),o=s.filter(l=>typeof l=="string"&&l.charAt(0)===AE).map(l=>l.slice(1)).map(l=>DE(l,n)),a=s.filter(l=>typeof l!="string"||typeof l=="string"&&l.charAt(0)!==AE).map(l=>IL(l,n));return e==null?(l,d=!1)=>PE(a,o,l,typeof d=="boolean"?d:!1):PE(a,o,e,i)};ad.default=ad;IE.exports=ad;});var FE=A((Y9,ME)=>{ME.exports=function(e){if(typeof e!="string"||e==="")return !1;for(var r;r=/(\\).|([@?!+*]\(.*\))/g.exec(e);){if(r[2])return !0;e=e.slice(r.index+r[0].length);}return !1};});var ud=A((X9,qE)=>{var kL=FE(),NE={"{":"}","(":")","[":"]"},ML=function(t){if(t[0]==="!")return !0;for(var e=0,r=-2,n=-2,i=-2,s=-2,o=-2;e<t.length;){if(t[e]==="*"||t[e+1]==="?"&&/[\].+)]/.test(t[e])||n!==-1&&t[e]==="["&&t[e+1]!=="]"&&(n<e&&(n=t.indexOf("]",e)),n>e&&(o===-1||o>n||(o=t.indexOf("\\",e),o===-1||o>n)))||i!==-1&&t[e]==="{"&&t[e+1]!=="}"&&(i=t.indexOf("}",e),i>e&&(o=t.indexOf("\\",e),o===-1||o>i))||s!==-1&&t[e]==="("&&t[e+1]==="?"&&/[:!=]/.test(t[e+2])&&t[e+3]!==")"&&(s=t.indexOf(")",e),s>e&&(o=t.indexOf("\\",e),o===-1||o>s))||r!==-1&&t[e]==="("&&t[e+1]!=="|"&&(r<e&&(r=t.indexOf("|",e)),r!==-1&&t[r+1]!==")"&&(s=t.indexOf(")",r),s>r&&(o=t.indexOf("\\",r),o===-1||o>s))))return !0;if(t[e]==="\\"){var a=t[e+1];e+=2;var l=NE[a];if(l){var d=t.indexOf(l,e);d!==-1&&(e=d+1);}if(t[e]==="!")return !0}else e++;}return !1},FL=function(t){if(t[0]==="!")return !0;for(var e=0;e<t.length;){if(/[*?{}()[\]]/.test(t[e]))return !0;if(t[e]==="\\"){var r=t[e+1];e+=2;var n=NE[r];if(n){var i=t.indexOf(n,e);i!==-1&&(e=i+1);}if(t[e]==="!")return !0}else e++;}return !1};qE.exports=function(e,r){if(typeof e!="string"||e==="")return !1;if(kL(e))return !0;var n=ML;return r&&r.strict===!1&&(n=FL),n(e)};});var $E=A((Q9,LE)=>{var NL=ud(),qL=oe("path").posix.dirname,LL=oe("os").platform()==="win32",cd="/",$L=/\\/g,jL=/[\{\[].*[\}\]]$/,HL=/(^|[^\\])([\{\[]|\([^\)]+$)/,WL=/\\([\!\*\?\|\[\]\(\)\{\}])/g;LE.exports=function(e,r){var n=Object.assign({flipBackslashes:!0},r);n.flipBackslashes&&LL&&e.indexOf(cd)<0&&(e=e.replace($L,cd)),jL.test(e)&&(e+=cd),e+="a";do e=qL(e);while(NL(e)||HL.test(e));return e.replace(WL,"$1")};});var Ya=A(gr=>{gr.isInteger=t=>typeof t=="number"?Number.isInteger(t):typeof t=="string"&&t.trim()!==""?Number.isInteger(Number(t)):!1;gr.find=(t,e)=>t.nodes.find(r=>r.type===e);gr.exceedsLimit=(t,e,r=1,n)=>n===!1||!gr.isInteger(t)||!gr.isInteger(e)?!1:(Number(e)-Number(t))/Number(r)>=n;gr.escapeNode=(t,e=0,r)=>{let n=t.nodes[e];n&&(r&&n.type===r||n.type==="open"||n.type==="close")&&n.escaped!==!0&&(n.value="\\"+n.value,n.escaped=!0);};gr.encloseBrace=t=>t.type!=="brace"||t.commas>>0+t.ranges>>0?!1:(t.invalid=!0,!0);gr.isInvalidBrace=t=>t.type!=="brace"?!1:t.invalid===!0||t.dollar?!0:!(t.commas>>0+t.ranges>>0)||t.open!==!0||t.close!==!0?(t.invalid=!0,!0):!1;gr.isOpenOrClose=t=>t.type==="open"||t.type==="close"?!0:t.open===!0||t.close===!0;gr.reduce=t=>t.reduce((e,r)=>(r.type==="text"&&e.push(r.value),r.type==="range"&&(r.type="text"),e),[]);gr.flatten=(...t)=>{let e=[],r=n=>{for(let i=0;i<n.length;i++){let s=n[i];Array.isArray(s)?r(s):s!==void 0&&e.push(s);}return e};return r(t),e};});var Xa=A((tV,HE)=>{var jE=Ya();HE.exports=(t,e={})=>{let r=(n,i={})=>{let s=e.escapeInvalid&&jE.isInvalidBrace(i),o=n.invalid===!0&&e.escapeInvalid===!0,a="";if(n.value)return (s||o)&&jE.isOpenOrClose(n)?"\\"+n.value:n.value;if(n.value)return n.value;if(n.nodes)for(let l of n.nodes)a+=r(l);return a};return r(t)};});var BE=A((rV,WE)=>{WE.exports=function(t){return typeof t=="number"?t-t===0:typeof t=="string"&&t.trim()!==""?Number.isFinite?Number.isFinite(+t):isFinite(+t):!1};});var XE=A((nV,YE)=>{var UE=BE(),Qn=(t,e,r)=>{if(UE(t)===!1)throw new TypeError("toRegexRange: expected the first argument to be a number");if(e===void 0||t===e)return String(t);if(UE(e)===!1)throw new TypeError("toRegexRange: expected the second argument to be a number.");let n={relaxZeros:!0,...r};typeof n.strictZeros=="boolean"&&(n.relaxZeros=n.strictZeros===!1);let i=String(n.relaxZeros),s=String(n.shorthand),o=String(n.capture),a=String(n.wrap),l=t+":"+e+"="+i+s+o+a;if(Qn.cache.hasOwnProperty(l))return Qn.cache[l].result;let d=Math.min(t,e),c=Math.max(t,e);if(Math.abs(d-c)===1){let E=t+"|"+e;return n.capture?`(${E})`:n.wrap===!1?E:`(?:${E})`}let p=JE(t)||JE(e),m={min:t,max:e,a:d,b:c},_=[],w=[];if(p&&(m.isPadded=p,m.maxLen=String(m.max).length),d<0){let E=c<0?Math.abs(c):1;w=zE(E,Math.abs(d),m,n),d=m.a=0;}return c>=0&&(_=zE(d,c,m,n)),m.negatives=w,m.positives=_,m.result=BL(w,_),n.capture===!0?m.result=`(${m.result})`:n.wrap!==!1&&_.length+w.length>1&&(m.result=`(?:${m.result})`),Qn.cache[l]=m,m.result};function BL(t,e,r){let n=ld(t,e,"-",!1)||[],i=ld(e,t,"",!1)||[],s=ld(t,e,"-?",!0)||[];return n.concat(s).concat(i).join("|")}function UL(t,e){let r=1,n=1,i=GE(t,r),s=new Set([e]);for(;t<=i&&i<=e;)s.add(i),r+=1,i=GE(t,r);for(i=KE(e+1,n)-1;t<i&&i<=e;)s.add(i),n+=1,i=KE(e+1,n)-1;return s=[...s],s.sort(GL),s}function zL(t,e,r){if(t===e)return {pattern:t,count:[],digits:0};let n=VL(t,e),i=n.length,s="",o=0;for(let a=0;a<i;a++){let[l,d]=n[a];l===d?s+=l:l!=="0"||d!=="9"?s+=KL(l,d):o++;}return o&&(s+=r.shorthand===!0?"\\d":"[0-9]"),{pattern:s,count:[o],digits:i}}function zE(t,e,r,n){let i=UL(t,e),s=[],o=t,a;for(let l=0;l<i.length;l++){let d=i[l],c=zL(String(o),String(d),n),p="";if(!r.isPadded&&a&&a.pattern===c.pattern){a.count.length>1&&a.count.pop(),a.count.push(c.count[0]),a.string=a.pattern+ZE(a.count),o=d+1;continue}r.isPadded&&(p=ZL(d,r,n)),c.string=p+c.pattern+ZE(c.count),s.push(c),o=d+1,a=c;}return s}function ld(t,e,r,n,i){let s=[];for(let o of t){let{string:a}=o;!n&&!VE(e,"string",a)&&s.push(r+a),n&&VE(e,"string",a)&&s.push(r+a);}return s}function VL(t,e){let r=[];for(let n=0;n<t.length;n++)r.push([t[n],e[n]]);return r}function GL(t,e){return t>e?1:e>t?-1:0}function VE(t,e,r){return t.some(n=>n[e]===r)}function GE(t,e){return Number(String(t).slice(0,-e)+"9".repeat(e))}function KE(t,e){return t-t%Math.pow(10,e)}function ZE(t){let[e=0,r=""]=t;return r||e>1?`{${e+(r?","+r:"")}}`:""}function KL(t,e,r){return `[${t}${e-t===1?"":"-"}${e}]`}function JE(t){return /^-?(0+)\d/.test(t)}function ZL(t,e,r){if(!e.isPadded)return t;let n=Math.abs(e.maxLen-String(t).length),i=r.relaxZeros!==!1;switch(n){case 0:return "";case 1:return i?"0?":"0";case 2:return i?"0{0,2}":"00";default:return i?`0{0,${n}}`:`0{${n}}`}}Qn.cache={};Qn.clearCache=()=>Qn.cache={};YE.exports=Qn;});var hd=A((iV,o0)=>{var JL=oe("util"),t0=XE(),QE=t=>t!==null&&typeof t=="object"&&!Array.isArray(t),YL=t=>e=>t===!0?Number(e):String(e),fd=t=>typeof t=="number"||typeof t=="string"&&t!=="",Qs=t=>Number.isInteger(+t),dd=t=>{let e=`${t}`,r=-1;if(e[0]==="-"&&(e=e.slice(1)),e==="0")return !1;for(;e[++r]==="0";);return r>0},XL=(t,e,r)=>typeof t=="string"||typeof e=="string"?!0:r.stringify===!0,QL=(t,e,r)=>{if(e>0){let n=t[0]==="-"?"-":"";n&&(t=t.slice(1)),t=n+t.padStart(n?e-1:e,"0");}return r===!1?String(t):t},e0=(t,e)=>{let r=t[0]==="-"?"-":"";for(r&&(t=t.slice(1),e--);t.length<e;)t="0"+t;return r?"-"+t:t},e2=(t,e)=>{t.negatives.sort((o,a)=>o<a?-1:o>a?1:0),t.positives.sort((o,a)=>o<a?-1:o>a?1:0);let r=e.capture?"":"?:",n="",i="",s;return t.positives.length&&(n=t.positives.join("|")),t.negatives.length&&(i=`-(${r}${t.negatives.join("|")})`),n&&i?s=`${n}|${i}`:s=n||i,e.wrap?`(${r}${s})`:s},r0=(t,e,r,n)=>{if(r)return t0(t,e,{wrap:!1,...n});let i=String.fromCharCode(t);if(t===e)return i;let s=String.fromCharCode(e);return `[${i}-${s}]`},n0=(t,e,r)=>{if(Array.isArray(t)){let n=r.wrap===!0,i=r.capture?"":"?:";return n?`(${i}${t.join("|")})`:t.join("|")}return t0(t,e,r)},i0=(...t)=>new RangeError("Invalid range arguments: "+JL.inspect(...t)),s0=(t,e,r)=>{if(r.strictRanges===!0)throw i0([t,e]);return []},t2=(t,e)=>{if(e.strictRanges===!0)throw new TypeError(`Expected step "${t}" to be a number`);return []},r2=(t,e,r=1,n={})=>{let i=Number(t),s=Number(e);if(!Number.isInteger(i)||!Number.isInteger(s)){if(n.strictRanges===!0)throw i0([t,e]);return []}i===0&&(i=0),s===0&&(s=0);let o=i>s,a=String(t),l=String(e),d=String(r);r=Math.max(Math.abs(r),1);let c=dd(a)||dd(l)||dd(d),p=c?Math.max(a.length,l.length,d.length):0,m=c===!1&&XL(t,e,n)===!1,_=n.transform||YL(m);if(n.toRegex&&r===1)return r0(e0(t,p),e0(e,p),!0,n);let w={negatives:[],positives:[]},E=g=>w[g<0?"negatives":"positives"].push(Math.abs(g)),P=[],D=0;for(;o?i>=s:i<=s;)n.toRegex===!0&&r>1?E(i):P.push(QL(_(i,D),p,m)),i=o?i-r:i+r,D++;return n.toRegex===!0?r>1?e2(w,n):n0(P,null,{wrap:!1,...n}):P},n2=(t,e,r=1,n={})=>{if(!Qs(t)&&t.length>1||!Qs(e)&&e.length>1)return s0(t,e,n);let i=n.transform||(m=>String.fromCharCode(m)),s=`${t}`.charCodeAt(0),o=`${e}`.charCodeAt(0),a=s>o,l=Math.min(s,o),d=Math.max(s,o);if(n.toRegex&&r===1)return r0(l,d,!1,n);let c=[],p=0;for(;a?s>=o:s<=o;)c.push(i(s,p)),s=a?s-r:s+r,p++;return n.toRegex===!0?n0(c,null,{wrap:!1,options:n}):c},Qa=(t,e,r,n={})=>{if(e==null&&fd(t))return [t];if(!fd(t)||!fd(e))return s0(t,e,n);if(typeof r=="function")return Qa(t,e,1,{transform:r});if(QE(r))return Qa(t,e,0,r);let i={...n};return i.capture===!0&&(i.wrap=!0),r=r||i.step||1,Qs(r)?Qs(t)&&Qs(e)?r2(t,e,r,i):n2(t,e,Math.max(Math.abs(r),1),i):r!=null&&!QE(r)?t2(r,i):Qa(t,e,1,r)};o0.exports=Qa;});var c0=A((sV,u0)=>{var i2=hd(),a0=Ya(),s2=(t,e={})=>{let r=(n,i={})=>{let s=a0.isInvalidBrace(i),o=n.invalid===!0&&e.escapeInvalid===!0,a=s===!0||o===!0,l=e.escapeInvalid===!0?"\\":"",d="";if(n.isOpen===!0||n.isClose===!0)return l+n.value;if(n.type==="open")return a?l+n.value:"(";if(n.type==="close")return a?l+n.value:")";if(n.type==="comma")return n.prev.type==="comma"?"":a?n.value:"|";if(n.value)return n.value;if(n.nodes&&n.ranges>0){let c=a0.reduce(n.nodes),p=i2(...c,{...e,wrap:!1,toRegex:!0});if(p.length!==0)return c.length>1&&p.length>1?`(${p})`:p}if(n.nodes)for(let c of n.nodes)d+=r(c,n);return d};return r(t)};u0.exports=s2;});var d0=A((oV,f0)=>{var o2=hd(),l0=Xa(),Hi=Ya(),ei=(t="",e="",r=!1)=>{let n=[];if(t=[].concat(t),e=[].concat(e),!e.length)return t;if(!t.length)return r?Hi.flatten(e).map(i=>`{${i}}`):e;for(let i of t)if(Array.isArray(i))for(let s of i)n.push(ei(s,e,r));else for(let s of e)r===!0&&typeof s=="string"&&(s=`{${s}}`),n.push(Array.isArray(s)?ei(i,s,r):i+s);return Hi.flatten(n)},a2=(t,e={})=>{let r=e.rangeLimit===void 0?1e3:e.rangeLimit,n=(i,s={})=>{i.queue=[];let o=s,a=s.queue;for(;o.type!=="brace"&&o.type!=="root"&&o.parent;)o=o.parent,a=o.queue;if(i.invalid||i.dollar){a.push(ei(a.pop(),l0(i,e)));return}if(i.type==="brace"&&i.invalid!==!0&&i.nodes.length===2){a.push(ei(a.pop(),["{}"]));return}if(i.nodes&&i.ranges>0){let p=Hi.reduce(i.nodes);if(Hi.exceedsLimit(...p,e.step,r))throw new RangeError("expanded array length exceeds range limit. Use options.rangeLimit to increase or disable the limit.");let m=o2(...p,e);m.length===0&&(m=l0(i,e)),a.push(ei(a.pop(),m)),i.nodes=[];return}let l=Hi.encloseBrace(i),d=i.queue,c=i;for(;c.type!=="brace"&&c.type!=="root"&&c.parent;)c=c.parent,d=c.queue;for(let p=0;p<i.nodes.length;p++){let m=i.nodes[p];if(m.type==="comma"&&i.type==="brace"){p===1&&d.push(""),d.push("");continue}if(m.type==="close"){a.push(ei(a.pop(),d,l));continue}if(m.value&&m.type!=="open"){d.push(ei(d.pop(),m.value));continue}m.nodes&&n(m,i);}return d};return Hi.flatten(n(t))};f0.exports=a2;});var p0=A((aV,h0)=>{h0.exports={MAX_LENGTH:1024*64,CHAR_0:"0",CHAR_9:"9",CHAR_UPPERCASE_A:"A",CHAR_LOWERCASE_A:"a",CHAR_UPPERCASE_Z:"Z",CHAR_LOWERCASE_Z:"z",CHAR_LEFT_PARENTHESES:"(",CHAR_RIGHT_PARENTHESES:")",CHAR_ASTERISK:"*",CHAR_AMPERSAND:"&",CHAR_AT:"@",CHAR_BACKSLASH:"\\",CHAR_BACKTICK:"`",CHAR_CARRIAGE_RETURN:"\r",CHAR_CIRCUMFLEX_ACCENT:"^",CHAR_COLON:":",CHAR_COMMA:",",CHAR_DOLLAR:"$",CHAR_DOT:".",CHAR_DOUBLE_QUOTE:'"',CHAR_EQUAL:"=",CHAR_EXCLAMATION_MARK:"!",CHAR_FORM_FEED:"\f",CHAR_FORWARD_SLASH:"/",CHAR_HASH:"#",CHAR_HYPHEN_MINUS:"-",CHAR_LEFT_ANGLE_BRACKET:"<",CHAR_LEFT_CURLY_BRACE:"{",CHAR_LEFT_SQUARE_BRACKET:"[",CHAR_LINE_FEED:`
`,CHAR_NO_BREAK_SPACE:"\xA0",CHAR_PERCENT:"%",CHAR_PLUS:"+",CHAR_QUESTION_MARK:"?",CHAR_RIGHT_ANGLE_BRACKET:">",CHAR_RIGHT_CURLY_BRACE:"}",CHAR_RIGHT_SQUARE_BRACKET:"]",CHAR_SEMICOLON:";",CHAR_SINGLE_QUOTE:"'",CHAR_SPACE:" ",CHAR_TAB:"	",CHAR_UNDERSCORE:"_",CHAR_VERTICAL_LINE:"|",CHAR_ZERO_WIDTH_NOBREAK_SPACE:"\uFEFF"};});var b0=A((uV,y0)=>{var u2=Xa(),{MAX_LENGTH:m0,CHAR_BACKSLASH:pd,CHAR_BACKTICK:c2,CHAR_COMMA:l2,CHAR_DOT:f2,CHAR_LEFT_PARENTHESES:d2,CHAR_RIGHT_PARENTHESES:h2,CHAR_LEFT_CURLY_BRACE:p2,CHAR_RIGHT_CURLY_BRACE:m2,CHAR_LEFT_SQUARE_BRACKET:g0,CHAR_RIGHT_SQUARE_BRACKET:_0,CHAR_DOUBLE_QUOTE:g2,CHAR_SINGLE_QUOTE:_2,CHAR_NO_BREAK_SPACE:y2,CHAR_ZERO_WIDTH_NOBREAK_SPACE:b2}=p0(),v2=(t,e={})=>{if(typeof t!="string")throw new TypeError("Expected a string");let r=e||{},n=typeof r.maxLength=="number"?Math.min(m0,r.maxLength):m0;if(t.length>n)throw new SyntaxError(`Input length (${t.length}), exceeds max characters (${n})`);let i={type:"root",input:t,nodes:[]},s=[i],o=i,a=i,l=0,d=t.length,c=0,p=0,m,w=()=>t[c++],E=P=>{if(P.type==="text"&&a.type==="dot"&&(a.type="text"),a&&a.type==="text"&&P.type==="text"){a.value+=P.value;return}return o.nodes.push(P),P.parent=o,P.prev=a,a=P,P};for(E({type:"bos"});c<d;)if(o=s[s.length-1],m=w(),!(m===b2||m===y2)){if(m===pd){E({type:"text",value:(e.keepEscaping?m:"")+w()});continue}if(m===_0){E({type:"text",value:"\\"+m});continue}if(m===g0){l++;let D;for(;c<d&&(D=w());){if(m+=D,D===g0){l++;continue}if(D===pd){m+=w();continue}if(D===_0&&(l--,l===0))break}E({type:"text",value:m});continue}if(m===d2){o=E({type:"paren",nodes:[]}),s.push(o),E({type:"text",value:m});continue}if(m===h2){if(o.type!=="paren"){E({type:"text",value:m});continue}o=s.pop(),E({type:"text",value:m}),o=s[s.length-1];continue}if(m===g2||m===_2||m===c2){let P=m,D;for(e.keepQuotes!==!0&&(m="");c<d&&(D=w());){if(D===pd){m+=D+w();continue}if(D===P){e.keepQuotes===!0&&(m+=D);break}m+=D;}E({type:"text",value:m});continue}if(m===p2){p++;let D={type:"brace",open:!0,close:!1,dollar:a.value&&a.value.slice(-1)==="$"||o.dollar===!0,depth:p,commas:0,ranges:0,nodes:[]};o=E(D),s.push(o),E({type:"open",value:m});continue}if(m===m2){if(o.type!=="brace"){E({type:"text",value:m});continue}let P="close";o=s.pop(),o.close=!0,E({type:P,value:m}),p--,o=s[s.length-1];continue}if(m===l2&&p>0){if(o.ranges>0){o.ranges=0;let P=o.nodes.shift();o.nodes=[P,{type:"text",value:u2(o)}];}E({type:"comma",value:m}),o.commas++;continue}if(m===f2&&p>0&&o.commas===0){let P=o.nodes;if(p===0||P.length===0){E({type:"text",value:m});continue}if(a.type==="dot"){if(o.range=[],a.value+=m,a.type="range",o.nodes.length!==3&&o.nodes.length!==5){o.invalid=!0,o.ranges=0,a.type="text";continue}o.ranges++,o.args=[];continue}if(a.type==="range"){P.pop();let D=P[P.length-1];D.value+=a.value+m,a=D,o.ranges--;continue}E({type:"dot",value:m});continue}E({type:"text",value:m});}do if(o=s.pop(),o.type!=="root"){o.nodes.forEach(g=>{g.nodes||(g.type==="open"&&(g.isOpen=!0),g.type==="close"&&(g.isClose=!0),g.nodes||(g.type="text"),g.invalid=!0);});let P=s[s.length-1],D=P.nodes.indexOf(o);P.nodes.splice(D,1,...o.nodes);}while(s.length>0);return E({type:"eos"}),i};y0.exports=v2;});var S0=A((cV,w0)=>{var v0=Xa(),w2=c0(),S2=d0(),E2=b0(),ar=(t,e={})=>{let r=[];if(Array.isArray(t))for(let n of t){let i=ar.create(n,e);Array.isArray(i)?r.push(...i):r.push(i);}else r=[].concat(ar.create(t,e));return e&&e.expand===!0&&e.nodupes===!0&&(r=[...new Set(r)]),r};ar.parse=(t,e={})=>E2(t,e);ar.stringify=(t,e={})=>v0(typeof t=="string"?ar.parse(t,e):t,e);ar.compile=(t,e={})=>(typeof t=="string"&&(t=ar.parse(t,e)),w2(t,e));ar.expand=(t,e={})=>{typeof t=="string"&&(t=ar.parse(t,e));let r=S2(t,e);return e.noempty===!0&&(r=r.filter(Boolean)),e.nodupes===!0&&(r=[...new Set(r)]),r};ar.create=(t,e={})=>t===""||t.length<3?[t]:e.expand!==!0?ar.compile(t,e):ar.expand(t,e);w0.exports=ar;});var E0=A((lV,R2)=>{R2.exports=["3dm","3ds","3g2","3gp","7z","a","aac","adp","ai","aif","aiff","alz","ape","apk","appimage","ar","arj","asf","au","avi","bak","baml","bh","bin","bk","bmp","btif","bz2","bzip2","cab","caf","cgm","class","cmx","cpio","cr2","cur","dat","dcm","deb","dex","djvu","dll","dmg","dng","doc","docm","docx","dot","dotm","dra","DS_Store","dsk","dts","dtshd","dvb","dwg","dxf","ecelp4800","ecelp7470","ecelp9600","egg","eol","eot","epub","exe","f4v","fbs","fh","fla","flac","flatpak","fli","flv","fpx","fst","fvt","g3","gh","gif","graffle","gz","gzip","h261","h263","h264","icns","ico","ief","img","ipa","iso","jar","jpeg","jpg","jpgv","jpm","jxr","key","ktx","lha","lib","lvp","lz","lzh","lzma","lzo","m3u","m4a","m4v","mar","mdi","mht","mid","midi","mj2","mka","mkv","mmr","mng","mobi","mov","movie","mp3","mp4","mp4a","mpeg","mpg","mpga","mxu","nef","npx","numbers","nupkg","o","odp","ods","odt","oga","ogg","ogv","otf","ott","pages","pbm","pcx","pdb","pdf","pea","pgm","pic","png","pnm","pot","potm","potx","ppa","ppam","ppm","pps","ppsm","ppsx","ppt","pptm","pptx","psd","pya","pyc","pyo","pyv","qt","rar","ras","raw","resources","rgb","rip","rlc","rmf","rmvb","rpm","rtf","rz","s3m","s7z","scpt","sgi","shar","snap","sil","sketch","slk","smv","snk","so","stl","suo","sub","swf","tar","tbz","tbz2","tga","tgz","thmx","tif","tiff","tlz","ttc","ttf","txz","udf","uvh","uvi","uvm","uvp","uvs","uvu","viv","vob","war","wav","wax","wbmp","wdp","weba","webm","webp","whl","wim","wm","wma","wmv","wmx","woff","woff2","wrm","wvx","xbm","xif","xla","xlam","xls","xlsb","xlsm","xlsx","xlt","xltm","xltx","xm","xmind","xpi","xpm","xwd","xz","z","zip","zipx"];});var C0=A((fV,R0)=>{R0.exports=E0();});var T0=A((dV,x0)=>{var C2=oe("path"),x2=C0(),T2=new Set(x2);x0.exports=t=>T2.has(C2.extname(t).slice(1).toLowerCase());});var eu=A(ge=>{var{sep:A2}=oe("path"),{platform:md}=process,P2=oe("os");ge.EV_ALL="all";ge.EV_READY="ready";ge.EV_ADD="add";ge.EV_CHANGE="change";ge.EV_ADD_DIR="addDir";ge.EV_UNLINK="unlink";ge.EV_UNLINK_DIR="unlinkDir";ge.EV_RAW="raw";ge.EV_ERROR="error";ge.STR_DATA="data";ge.STR_END="end";ge.STR_CLOSE="close";ge.FSEVENT_CREATED="created";ge.FSEVENT_MODIFIED="modified";ge.FSEVENT_DELETED="deleted";ge.FSEVENT_MOVED="moved";ge.FSEVENT_CLONED="cloned";ge.FSEVENT_UNKNOWN="unknown";ge.FSEVENT_TYPE_FILE="file";ge.FSEVENT_TYPE_DIRECTORY="directory";ge.FSEVENT_TYPE_SYMLINK="symlink";ge.KEY_LISTENERS="listeners";ge.KEY_ERR="errHandlers";ge.KEY_RAW="rawEmitters";ge.HANDLER_KEYS=[ge.KEY_LISTENERS,ge.KEY_ERR,ge.KEY_RAW];ge.DOT_SLASH=`.${A2}`;ge.BACK_SLASH_RE=/\\/g;ge.DOUBLE_SLASH_RE=/\/\//;ge.SLASH_OR_BACK_SLASH_RE=/[/\\]/;ge.DOT_RE=/\..*\.(sw[px])$|~$|\.subl.*\.tmp/;ge.REPLACER_RE=/^\.[/\\]/;ge.SLASH="/";ge.SLASH_SLASH="//";ge.BRACE_START="{";ge.BANG="!";ge.ONE_DOT=".";ge.TWO_DOTS="..";ge.STAR="*";ge.GLOBSTAR="**";ge.ROOT_GLOBSTAR="/**/*";ge.SLASH_GLOBSTAR="/**";ge.DIR_SUFFIX="Dir";ge.ANYMATCH_OPTS={dot:!0};ge.STRING_TYPE="string";ge.FUNCTION_TYPE="function";ge.EMPTY_STR="";ge.EMPTY_FN=()=>{};ge.IDENTITY_FN=t=>t;ge.isWindows=md==="win32";ge.isMacos=md==="darwin";ge.isLinux=md==="linux";ge.isIBMi=P2.type()==="OS400";});var k0=A((pV,I0)=>{var sn=oe("fs"),bt=oe("path"),{promisify:no}=oe("util"),D2=T0(),{isWindows:O2,isLinux:I2,EMPTY_FN:k2,EMPTY_STR:M2,KEY_LISTENERS:Wi,KEY_ERR:gd,KEY_RAW:eo,HANDLER_KEYS:F2,EV_CHANGE:ru,EV_ADD:tu,EV_ADD_DIR:N2,EV_ERROR:P0,STR_DATA:q2,STR_END:L2,BRACE_START:$2,STAR:j2}=eu(),H2="watch",W2=no(sn.open),D0=no(sn.stat),B2=no(sn.lstat),U2=no(sn.close),_d=no(sn.realpath),z2={lstat:B2,stat:D0},bd=(t,e)=>{t instanceof Set?t.forEach(e):e(t);},to=(t,e,r)=>{let n=t[e];n instanceof Set||(t[e]=n=new Set([n])),n.add(r);},V2=t=>e=>{let r=t[e];r instanceof Set?r.clear():delete t[e];},ro=(t,e,r)=>{let n=t[e];n instanceof Set?n.delete(r):n===r&&delete t[e];},O0=t=>t instanceof Set?t.size===0:!t,nu=new Map;function A0(t,e,r,n,i){let s=(o,a)=>{r(t),i(o,a,{watchedPath:t}),a&&t!==a&&iu(bt.resolve(t,a),Wi,bt.join(t,a));};try{return sn.watch(t,e,s)}catch(o){n(o);}}var iu=(t,e,r,n,i)=>{let s=nu.get(t);s&&bd(s[e],o=>{o(r,n,i);});},G2=(t,e,r,n)=>{let{listener:i,errHandler:s,rawEmitter:o}=n,a=nu.get(e),l;if(!r.persistent)return l=A0(t,r,i,s,o),l.close.bind(l);if(a)to(a,Wi,i),to(a,gd,s),to(a,eo,o);else {if(l=A0(t,r,iu.bind(null,e,Wi),s,iu.bind(null,e,eo)),!l)return;l.on(P0,async d=>{let c=iu.bind(null,e,gd);if(a.watcherUnusable=!0,O2&&d.code==="EPERM")try{let p=await W2(t,"r");await U2(p),c(d);}catch{}else c(d);}),a={listeners:i,errHandlers:s,rawEmitters:o,watcher:l},nu.set(e,a);}return ()=>{ro(a,Wi,i),ro(a,gd,s),ro(a,eo,o),O0(a.listeners)&&(a.watcher.close(),nu.delete(e),F2.forEach(V2(a)),a.watcher=void 0,Object.freeze(a));}},yd=new Map,K2=(t,e,r,n)=>{let {listener:i,rawEmitter:s}=n,o=yd.get(e),d=o&&o.options;return d&&(d.persistent<r.persistent||d.interval>r.interval)&&(sn.unwatchFile(e),o=void 0),o?(to(o,Wi,i),to(o,eo,s)):(o={listeners:i,rawEmitters:s,options:r,watcher:sn.watchFile(e,r,(c,p)=>{bd(o.rawEmitters,_=>{_(ru,e,{curr:c,prev:p});});let m=c.mtimeMs;(c.size!==p.size||m>p.mtimeMs||m===0)&&bd(o.listeners,_=>_(t,c));})},yd.set(e,o)),()=>{ro(o,Wi,i),ro(o,eo,s),O0(o.listeners)&&(yd.delete(e),sn.unwatchFile(e),o.options=o.watcher=void 0,Object.freeze(o));}},vd=class{constructor(e){this.fsw=e,this._boundHandleError=r=>e._handleError(r);}_watchWithNodeFs(e,r){let n=this.fsw.options,i=bt.dirname(e),s=bt.basename(e);this.fsw._getWatchedDir(i).add(s);let a=bt.resolve(e),l={persistent:n.persistent};r||(r=k2);let d;return n.usePolling?(l.interval=n.enableBinaryInterval&&D2(s)?n.binaryInterval:n.interval,d=K2(e,a,l,{listener:r,rawEmitter:this.fsw._emitRaw})):d=G2(e,a,l,{listener:r,errHandler:this._boundHandleError,rawEmitter:this.fsw._emitRaw}),d}_handleFile(e,r,n){if(this.fsw.closed)return;let i=bt.dirname(e),s=bt.basename(e),o=this.fsw._getWatchedDir(i),a=r;if(o.has(s))return;let l=async(c,p)=>{if(this.fsw._throttle(H2,e,5)){if(!p||p.mtimeMs===0)try{let m=await D0(e);if(this.fsw.closed)return;let _=m.atimeMs,w=m.mtimeMs;(!_||_<=w||w!==a.mtimeMs)&&this.fsw._emit(ru,e,m),I2&&a.ino!==m.ino?(this.fsw._closeFile(c),a=m,this.fsw._addPathCloser(c,this._watchWithNodeFs(e,l))):a=m;}catch{this.fsw._remove(i,s);}else if(o.has(s)){let m=p.atimeMs,_=p.mtimeMs;(!m||m<=_||_!==a.mtimeMs)&&this.fsw._emit(ru,e,p),a=p;}}},d=this._watchWithNodeFs(e,l);if(!(n&&this.fsw.options.ignoreInitial)&&this.fsw._isntIgnored(e)){if(!this.fsw._throttle(tu,e,0))return;this.fsw._emit(tu,e,r);}return d}async _handleSymlink(e,r,n,i){if(this.fsw.closed)return;let s=e.fullPath,o=this.fsw._getWatchedDir(r);if(!this.fsw.options.followSymlinks){this.fsw._incrReadyCount();let a;try{a=await _d(n);}catch{return this.fsw._emitReady(),!0}return this.fsw.closed?void 0:(o.has(i)?this.fsw._symlinkPaths.get(s)!==a&&(this.fsw._symlinkPaths.set(s,a),this.fsw._emit(ru,n,e.stats)):(o.add(i),this.fsw._symlinkPaths.set(s,a),this.fsw._emit(tu,n,e.stats)),this.fsw._emitReady(),!0)}if(this.fsw._symlinkPaths.has(s))return !0;this.fsw._symlinkPaths.set(s,!0);}_handleRead(e,r,n,i,s,o,a){if(e=bt.join(e,M2),!n.hasGlob&&(a=this.fsw._throttle("readdir",e,1e3),!a))return;let l=this.fsw._getWatchedDir(n.path),d=new Set,c=this.fsw._readdirp(e,{fileFilter:p=>n.filterPath(p),directoryFilter:p=>n.filterDir(p),depth:0}).on(q2,async p=>{if(this.fsw.closed){c=void 0;return}let m=p.path,_=bt.join(e,m);if(d.add(m),!(p.stats.isSymbolicLink()&&await this._handleSymlink(p,e,_,m))){if(this.fsw.closed){c=void 0;return}(m===i||!i&&!l.has(m))&&(this.fsw._incrReadyCount(),_=bt.join(s,bt.relative(s,_)),this._addToNodeFs(_,r,n,o+1));}}).on(P0,this._boundHandleError);return new Promise(p=>c.once(L2,()=>{if(this.fsw.closed){c=void 0;return}let m=a?a.clear():!1;p(),l.getChildren().filter(_=>_!==e&&!d.has(_)&&(!n.hasGlob||n.filterPath({fullPath:bt.resolve(e,_)}))).forEach(_=>{this.fsw._remove(e,_);}),c=void 0,m&&this._handleRead(e,!1,n,i,s,o,a);}))}async _handleDir(e,r,n,i,s,o,a){let l=this.fsw._getWatchedDir(bt.dirname(e)),d=l.has(bt.basename(e));!(n&&this.fsw.options.ignoreInitial)&&!s&&!d&&(!o.hasGlob||o.globFilter(e))&&this.fsw._emit(N2,e,r),l.add(bt.basename(e)),this.fsw._getWatchedDir(e);let c,p,m=this.fsw.options.depth;if((m==null||i<=m)&&!this.fsw._symlinkPaths.has(a)){if(!s&&(await this._handleRead(e,n,o,s,e,i,c),this.fsw.closed))return;p=this._watchWithNodeFs(e,(_,w)=>{w&&w.mtimeMs===0||this._handleRead(_,!1,o,s,e,i,c);});}return p}async _addToNodeFs(e,r,n,i,s){let o=this.fsw._emitReady;if(this.fsw._isIgnored(e)||this.fsw.closed)return o(),!1;let a=this.fsw._getWatchHelpers(e,i);!a.hasGlob&&n&&(a.hasGlob=n.hasGlob,a.globFilter=n.globFilter,a.filterPath=l=>n.filterPath(l),a.filterDir=l=>n.filterDir(l));try{let l=await z2[a.statMethod](a.watchPath);if(this.fsw.closed)return;if(this.fsw._isIgnored(a.watchPath,l))return o(),!1;let d=this.fsw.options.followSymlinks&&!e.includes(j2)&&!e.includes($2),c;if(l.isDirectory()){let p=bt.resolve(e),m=d?await _d(e):e;if(this.fsw.closed||(c=await this._handleDir(a.watchPath,l,r,i,s,a,m),this.fsw.closed))return;p!==m&&m!==void 0&&this.fsw._symlinkPaths.set(p,m);}else if(l.isSymbolicLink()){let p=d?await _d(e):e;if(this.fsw.closed)return;let m=bt.dirname(a.watchPath);if(this.fsw._getWatchedDir(m).add(a.watchPath),this.fsw._emit(tu,a.watchPath,l),c=await this._handleDir(m,l,r,i,e,a,p),this.fsw.closed)return;p!==void 0&&this.fsw._symlinkPaths.set(bt.resolve(e),p);}else c=this._handleFile(a.watchPath,l,r);return o(),this.fsw._addPathCloser(e,c),!1}catch(l){if(this.fsw._handleError(l))return o(),e}}};I0.exports=vd;});var j0=A((mV,Ad)=>{var xd=oe("fs"),vt=oe("path"),{promisify:Td}=oe("util"),Bi;try{Bi=oe("fsevents");}catch(t){process.env.CHOKIDAR_PRINT_FSEVENTS_REQUIRE_ERROR&&console.error(t);}if(Bi){let t=process.version.match(/v(\d+)\.(\d+)/);if(t&&t[1]&&t[2]){let e=Number.parseInt(t[1],10),r=Number.parseInt(t[2],10);e===8&&r<16&&(Bi=void 0);}}var{EV_ADD:wd,EV_CHANGE:Z2,EV_ADD_DIR:M0,EV_UNLINK:su,EV_ERROR:J2,STR_DATA:Y2,STR_END:X2,FSEVENT_CREATED:Q2,FSEVENT_MODIFIED:e$,FSEVENT_DELETED:t$,FSEVENT_MOVED:r$,FSEVENT_UNKNOWN:n$,FSEVENT_TYPE_FILE:i$,FSEVENT_TYPE_DIRECTORY:io,FSEVENT_TYPE_SYMLINK:$0,ROOT_GLOBSTAR:F0,DIR_SUFFIX:s$,DOT_SLASH:N0,FUNCTION_TYPE:Sd,EMPTY_FN:o$,IDENTITY_FN:a$}=eu(),u$=t=>isNaN(t)?{}:{depth:t},Rd=Td(xd.stat),c$=Td(xd.lstat),q0=Td(xd.realpath),l$={stat:Rd,lstat:c$},ti=new Map,f$=10,d$=new Set([69888,70400,71424,72704,73472,131328,131840,262912]),h$=(t,e)=>({stop:Bi.watch(t,e)});function p$(t,e,r,n){let i=vt.extname(e)?vt.dirname(e):e,s=vt.dirname(i),o=ti.get(i);m$(s)&&(i=s);let a=vt.resolve(t),l=a!==e,d=(p,m,_)=>{l&&(p=p.replace(e,a)),(p===a||!p.indexOf(a+vt.sep))&&r(p,m,_);},c=!1;for(let p of ti.keys())if(e.indexOf(vt.resolve(p)+vt.sep)===0){i=p,o=ti.get(i),c=!0;break}return o||c?o.listeners.add(d):(o={listeners:new Set([d]),rawEmitter:n,watcher:h$(i,(p,m)=>{if(!o.listeners.size)return;let _=Bi.getInfo(p,m);o.listeners.forEach(w=>{w(p,m,_);}),o.rawEmitter(_.event,p,_);})},ti.set(i,o)),()=>{let p=o.listeners;if(p.delete(d),!p.size&&(ti.delete(i),o.watcher))return o.watcher.stop().then(()=>{o.rawEmitter=o.watcher=void 0,Object.freeze(o);})}}var m$=t=>{let e=0;for(let r of ti.keys())if(r.indexOf(t)===0&&(e++,e>=f$))return !0;return !1},g$=()=>Bi&&ti.size<128,Ed=(t,e)=>{let r=0;for(;!t.indexOf(e)&&(t=vt.dirname(t))!==e;)r++;return r},L0=(t,e)=>t.type===io&&e.isDirectory()||t.type===$0&&e.isSymbolicLink()||t.type===i$&&e.isFile(),Cd=class{constructor(e){this.fsw=e;}checkIgnored(e,r){let n=this.fsw._ignoredPaths;if(this.fsw._isIgnored(e,r))return n.add(e),r&&r.isDirectory()&&n.add(e+F0),!0;n.delete(e),n.delete(e+F0);}addOrChange(e,r,n,i,s,o,a,l){let d=s.has(o)?Z2:wd;this.handleEvent(d,e,r,n,i,s,o,a,l);}async checkExists(e,r,n,i,s,o,a,l){try{let d=await Rd(e);if(this.fsw.closed)return;L0(a,d)?this.addOrChange(e,r,n,i,s,o,a,l):this.handleEvent(su,e,r,n,i,s,o,a,l);}catch(d){d.code==="EACCES"?this.addOrChange(e,r,n,i,s,o,a,l):this.handleEvent(su,e,r,n,i,s,o,a,l);}}handleEvent(e,r,n,i,s,o,a,l,d){if(!(this.fsw.closed||this.checkIgnored(r)))if(e===su){let c=l.type===io;(c||o.has(a))&&this.fsw._remove(s,a,c);}else {if(e===wd){if(l.type===io&&this.fsw._getWatchedDir(r),l.type===$0&&d.followSymlinks){let p=d.depth===void 0?void 0:Ed(n,i)+1;return this._addToFsEvents(r,!1,!0,p)}this.fsw._getWatchedDir(s).add(a);}let c=l.type===io?e+s$:e;this.fsw._emit(c,r),c===M0&&this._addToFsEvents(r,!1,!0);}}_watchWithFsEvents(e,r,n,i){if(this.fsw.closed||this.fsw._isIgnored(e))return;let s=this.fsw.options,a=p$(e,r,async(l,d,c)=>{if(this.fsw.closed||s.depth!==void 0&&Ed(l,r)>s.depth)return;let p=n(vt.join(e,vt.relative(e,l)));if(i&&!i(p))return;let m=vt.dirname(p),_=vt.basename(p),w=this.fsw._getWatchedDir(c.type===io?p:m);if(d$.has(d)||c.event===n$)if(typeof s.ignored===Sd){let E;try{E=await Rd(p);}catch{}if(this.fsw.closed||this.checkIgnored(p,E))return;L0(c,E)?this.addOrChange(p,l,r,m,w,_,c,s):this.handleEvent(su,p,l,r,m,w,_,c,s);}else this.checkExists(p,l,r,m,w,_,c,s);else switch(c.event){case Q2:case e$:return this.addOrChange(p,l,r,m,w,_,c,s);case t$:case r$:return this.checkExists(p,l,r,m,w,_,c,s)}},this.fsw._emitRaw);return this.fsw._emitReady(),a}async _handleFsEventsSymlink(e,r,n,i){if(!(this.fsw.closed||this.fsw._symlinkPaths.has(r))){this.fsw._symlinkPaths.set(r,!0),this.fsw._incrReadyCount();try{let s=await q0(e);if(this.fsw.closed)return;if(this.fsw._isIgnored(s))return this.fsw._emitReady();this.fsw._incrReadyCount(),this._addToFsEvents(s||e,o=>{let a=e;return s&&s!==N0?a=o.replace(s,e):o!==N0&&(a=vt.join(e,o)),n(a)},!1,i);}catch(s){if(this.fsw._handleError(s))return this.fsw._emitReady()}}}emitAdd(e,r,n,i,s){let o=n(e),a=r.isDirectory(),l=this.fsw._getWatchedDir(vt.dirname(o)),d=vt.basename(o);a&&this.fsw._getWatchedDir(o),!l.has(d)&&(l.add(d),(!i.ignoreInitial||s===!0)&&this.fsw._emit(a?M0:wd,o,r));}initWatch(e,r,n,i){if(this.fsw.closed)return;let s=this._watchWithFsEvents(n.watchPath,vt.resolve(e||n.watchPath),i,n.globFilter);this.fsw._addPathCloser(r,s);}async _addToFsEvents(e,r,n,i){if(this.fsw.closed)return;let s=this.fsw.options,o=typeof r===Sd?r:a$,a=this.fsw._getWatchHelpers(e);try{let l=await l$[a.statMethod](a.watchPath);if(this.fsw.closed)return;if(this.fsw._isIgnored(a.watchPath,l))throw null;if(l.isDirectory()){if(a.globFilter||this.emitAdd(o(e),l,o,s,n),i&&i>s.depth)return;this.fsw._readdirp(a.watchPath,{fileFilter:d=>a.filterPath(d),directoryFilter:d=>a.filterDir(d),...u$(s.depth-(i||0))}).on(Y2,d=>{if(this.fsw.closed||d.stats.isDirectory()&&!a.filterPath(d))return;let c=vt.join(a.watchPath,d.path),{fullPath:p}=d;if(a.followSymlinks&&d.stats.isSymbolicLink()){let m=s.depth===void 0?void 0:Ed(c,vt.resolve(a.watchPath))+1;this._handleFsEventsSymlink(c,p,o,m);}else this.emitAdd(c,d.stats,o,s,n);}).on(J2,o$).on(X2,()=>{this.fsw._emitReady();});}else this.emitAdd(a.watchPath,l,o,s,n),this.fsw._emitReady();}catch(l){(!l||this.fsw._handleError(l))&&(this.fsw._emitReady(),this.fsw._emitReady());}if(s.persistent&&n!==!0)if(typeof r===Sd)this.initWatch(void 0,e,a,o);else {let l;try{l=await q0(a.watchPath);}catch{}this.initWatch(l,e,a,o);}}};Ad.exports=Cd;Ad.exports.canUse=g$;});var Ud=A(Bd=>{var{EventEmitter:_$}=oe("events"),Hd=oe("fs"),Ue=oe("path"),{promisify:G0}=oe("util"),y$=xE(),Md=kE().default,b$=$E(),Pd=ud(),v$=S0(),w$=od(),S$=k0(),H0=j0(),{EV_ALL:Dd,EV_READY:E$,EV_ADD:ou,EV_CHANGE:so,EV_UNLINK:W0,EV_ADD_DIR:R$,EV_UNLINK_DIR:C$,EV_RAW:x$,EV_ERROR:Od,STR_CLOSE:T$,STR_END:A$,BACK_SLASH_RE:P$,DOUBLE_SLASH_RE:B0,SLASH_OR_BACK_SLASH_RE:D$,DOT_RE:O$,REPLACER_RE:I$,SLASH:Id,SLASH_SLASH:k$,BRACE_START:M$,BANG:Fd,ONE_DOT:K0,TWO_DOTS:F$,GLOBSTAR:N$,SLASH_GLOBSTAR:kd,ANYMATCH_OPTS:Nd,STRING_TYPE:Wd,FUNCTION_TYPE:q$,EMPTY_STR:qd,EMPTY_FN:L$,isWindows:$$,isMacos:j$,isIBMi:H$}=eu(),W$=G0(Hd.stat),B$=G0(Hd.readdir),Ld=(t=[])=>Array.isArray(t)?t:[t],Z0=(t,e=[])=>(t.forEach(r=>{Array.isArray(r)?Z0(r,e):e.push(r);}),e),U0=t=>{let e=Z0(Ld(t));if(!e.every(r=>typeof r===Wd))throw new TypeError(`Non-string provided as watch path: ${e}`);return e.map(J0)},z0=t=>{let e=t.replace(P$,Id),r=!1;for(e.startsWith(k$)&&(r=!0);e.match(B0);)e=e.replace(B0,Id);return r&&(e=Id+e),e},J0=t=>z0(Ue.normalize(z0(t))),V0=(t=qd)=>e=>typeof e!==Wd?e:J0(Ue.isAbsolute(e)?e:Ue.join(t,e)),U$=(t,e)=>Ue.isAbsolute(t)?t:t.startsWith(Fd)?Fd+Ue.join(e,t.slice(1)):Ue.join(e,t),Or=(t,e)=>t[e]===void 0,$d=class{constructor(e,r){this.path=e,this._removeWatcher=r,this.items=new Set;}add(e){let{items:r}=this;r&&e!==K0&&e!==F$&&r.add(e);}async remove(e){let{items:r}=this;if(!r||(r.delete(e),r.size>0))return;let n=this.path;try{await B$(n);}catch{this._removeWatcher&&this._removeWatcher(Ue.dirname(n),Ue.basename(n));}}has(e){let{items:r}=this;if(r)return r.has(e)}getChildren(){let{items:e}=this;if(e)return [...e.values()]}dispose(){this.items.clear(),delete this.path,delete this._removeWatcher,delete this.items,Object.freeze(this);}},z$="stat",V$="lstat",jd=class{constructor(e,r,n,i){this.fsw=i,this.path=e=e.replace(I$,qd),this.watchPath=r,this.fullWatchPath=Ue.resolve(r),this.hasGlob=r!==e,e===qd&&(this.hasGlob=!1),this.globSymlink=this.hasGlob&&n?void 0:!1,this.globFilter=this.hasGlob?Md(e,void 0,Nd):!1,this.dirParts=this.getDirParts(e),this.dirParts.forEach(s=>{s.length>1&&s.pop();}),this.followSymlinks=n,this.statMethod=n?z$:V$;}checkGlobSymlink(e){return this.globSymlink===void 0&&(this.globSymlink=e.fullParentDir===this.fullWatchPath?!1:{realPath:e.fullParentDir,linkPath:this.fullWatchPath}),this.globSymlink?e.fullPath.replace(this.globSymlink.realPath,this.globSymlink.linkPath):e.fullPath}entryPath(e){return Ue.join(this.watchPath,Ue.relative(this.watchPath,this.checkGlobSymlink(e)))}filterPath(e){let{stats:r}=e;if(r&&r.isSymbolicLink())return this.filterDir(e);let n=this.entryPath(e);return (this.hasGlob&&typeof this.globFilter===q$?this.globFilter(n):!0)&&this.fsw._isntIgnored(n,r)&&this.fsw._hasReadPermissions(r)}getDirParts(e){if(!this.hasGlob)return [];let r=[];return (e.includes(M$)?v$.expand(e):[e]).forEach(i=>{r.push(Ue.relative(this.watchPath,i).split(D$));}),r}filterDir(e){if(this.hasGlob){let r=this.getDirParts(this.checkGlobSymlink(e)),n=!1;this.unmatchedGlob=!this.dirParts.some(i=>i.every((s,o)=>(s===N$&&(n=!0),n||!r[0][o]||Md(s,r[0][o],Nd))));}return !this.unmatchedGlob&&this.fsw._isntIgnored(this.entryPath(e),e.stats)}},au=class extends _${constructor(e){super();let r={};e&&Object.assign(r,e),this._watched=new Map,this._closers=new Map,this._ignoredPaths=new Set,this._throttled=new Map,this._symlinkPaths=new Map,this._streams=new Set,this.closed=!1,Or(r,"persistent")&&(r.persistent=!0),Or(r,"ignoreInitial")&&(r.ignoreInitial=!1),Or(r,"ignorePermissionErrors")&&(r.ignorePermissionErrors=!1),Or(r,"interval")&&(r.interval=100),Or(r,"binaryInterval")&&(r.binaryInterval=300),Or(r,"disableGlobbing")&&(r.disableGlobbing=!1),r.enableBinaryInterval=r.binaryInterval!==r.interval,Or(r,"useFsEvents")&&(r.useFsEvents=!r.usePolling),H0.canUse()||(r.useFsEvents=!1),Or(r,"usePolling")&&!r.useFsEvents&&(r.usePolling=j$),H$&&(r.usePolling=!0);let i=process.env.CHOKIDAR_USEPOLLING;if(i!==void 0){let l=i.toLowerCase();l==="false"||l==="0"?r.usePolling=!1:l==="true"||l==="1"?r.usePolling=!0:r.usePolling=!!l;}let s=process.env.CHOKIDAR_INTERVAL;s&&(r.interval=Number.parseInt(s,10)),Or(r,"atomic")&&(r.atomic=!r.usePolling&&!r.useFsEvents),r.atomic&&(this._pendingUnlinks=new Map),Or(r,"followSymlinks")&&(r.followSymlinks=!0),Or(r,"awaitWriteFinish")&&(r.awaitWriteFinish=!1),r.awaitWriteFinish===!0&&(r.awaitWriteFinish={});let o=r.awaitWriteFinish;o&&(o.stabilityThreshold||(o.stabilityThreshold=2e3),o.pollInterval||(o.pollInterval=100),this._pendingWrites=new Map),r.ignored&&(r.ignored=Ld(r.ignored));let a=0;this._emitReady=()=>{a++,a>=this._readyCount&&(this._emitReady=L$,this._readyEmitted=!0,process.nextTick(()=>this.emit(E$)));},this._emitRaw=(...l)=>this.emit(x$,...l),this._readyEmitted=!1,this.options=r,r.useFsEvents?this._fsEventsHandler=new H0(this):this._nodeFsHandler=new S$(this),Object.freeze(r);}add(e,r,n){let{cwd:i,disableGlobbing:s}=this.options;this.closed=!1;let o=U0(e);return i&&(o=o.map(a=>{let l=U$(a,i);return s||!Pd(a)?l:w$(l)})),o=o.filter(a=>a.startsWith(Fd)?(this._ignoredPaths.add(a.slice(1)),!1):(this._ignoredPaths.delete(a),this._ignoredPaths.delete(a+kd),this._userIgnored=void 0,!0)),this.options.useFsEvents&&this._fsEventsHandler?(this._readyCount||(this._readyCount=o.length),this.options.persistent&&(this._readyCount*=2),o.forEach(a=>this._fsEventsHandler._addToFsEvents(a))):(this._readyCount||(this._readyCount=0),this._readyCount+=o.length,Promise.all(o.map(async a=>{let l=await this._nodeFsHandler._addToNodeFs(a,!n,0,0,r);return l&&this._emitReady(),l})).then(a=>{this.closed||a.filter(l=>l).forEach(l=>{this.add(Ue.dirname(l),Ue.basename(r||l));});})),this}unwatch(e){if(this.closed)return this;let r=U0(e),{cwd:n}=this.options;return r.forEach(i=>{!Ue.isAbsolute(i)&&!this._closers.has(i)&&(n&&(i=Ue.join(n,i)),i=Ue.resolve(i)),this._closePath(i),this._ignoredPaths.add(i),this._watched.has(i)&&this._ignoredPaths.add(i+kd),this._userIgnored=void 0;}),this}close(){if(this.closed)return this._closePromise;this.closed=!0,this.removeAllListeners();let e=[];return this._closers.forEach(r=>r.forEach(n=>{let i=n();i instanceof Promise&&e.push(i);})),this._streams.forEach(r=>r.destroy()),this._userIgnored=void 0,this._readyCount=0,this._readyEmitted=!1,this._watched.forEach(r=>r.dispose()),["closers","watched","streams","symlinkPaths","throttled"].forEach(r=>{this[`_${r}`].clear();}),this._closePromise=e.length?Promise.all(e).then(()=>{}):Promise.resolve(),this._closePromise}getWatched(){let e={};return this._watched.forEach((r,n)=>{let i=this.options.cwd?Ue.relative(this.options.cwd,n):n;e[i||K0]=r.getChildren().sort();}),e}emitWithAll(e,r){this.emit(...r),e!==Od&&this.emit(Dd,...r);}async _emit(e,r,n,i,s){if(this.closed)return;let o=this.options;$$&&(r=Ue.normalize(r)),o.cwd&&(r=Ue.relative(o.cwd,r));let a=[e,r];s!==void 0?a.push(n,i,s):i!==void 0?a.push(n,i):n!==void 0&&a.push(n);let l=o.awaitWriteFinish,d;if(l&&(d=this._pendingWrites.get(r)))return d.lastChange=new Date,this;if(o.atomic){if(e===W0)return this._pendingUnlinks.set(r,a),setTimeout(()=>{this._pendingUnlinks.forEach((c,p)=>{this.emit(...c),this.emit(Dd,...c),this._pendingUnlinks.delete(p);});},typeof o.atomic=="number"?o.atomic:100),this;e===ou&&this._pendingUnlinks.has(r)&&(e=a[0]=so,this._pendingUnlinks.delete(r));}if(l&&(e===ou||e===so)&&this._readyEmitted){let c=(p,m)=>{p?(e=a[0]=Od,a[1]=p,this.emitWithAll(e,a)):m&&(a.length>2?a[2]=m:a.push(m),this.emitWithAll(e,a));};return this._awaitWriteFinish(r,l.stabilityThreshold,e,c),this}if(e===so&&!this._throttle(so,r,50))return this;if(o.alwaysStat&&n===void 0&&(e===ou||e===R$||e===so)){let c=o.cwd?Ue.join(o.cwd,r):r,p;try{p=await W$(c);}catch{}if(!p||this.closed)return;a.push(p);}return this.emitWithAll(e,a),this}_handleError(e){let r=e&&e.code;return e&&r!=="ENOENT"&&r!=="ENOTDIR"&&(!this.options.ignorePermissionErrors||r!=="EPERM"&&r!=="EACCES")&&this.emit(Od,e),e||this.closed}_throttle(e,r,n){this._throttled.has(e)||this._throttled.set(e,new Map);let i=this._throttled.get(e),s=i.get(r);if(s)return s.count++,!1;let o,a=()=>{let d=i.get(r),c=d?d.count:0;return i.delete(r),clearTimeout(o),d&&clearTimeout(d.timeoutObject),c};o=setTimeout(a,n);let l={timeoutObject:o,clear:a,count:0};return i.set(r,l),l}_incrReadyCount(){return this._readyCount++}_awaitWriteFinish(e,r,n,i){let s,o=e;this.options.cwd&&!Ue.isAbsolute(e)&&(o=Ue.join(this.options.cwd,e));let a=new Date,l=d=>{Hd.stat(o,(c,p)=>{if(c||!this._pendingWrites.has(e)){c&&c.code!=="ENOENT"&&i(c);return}let m=Number(new Date);d&&p.size!==d.size&&(this._pendingWrites.get(e).lastChange=m);let _=this._pendingWrites.get(e);m-_.lastChange>=r?(this._pendingWrites.delete(e),i(void 0,p)):s=setTimeout(l,this.options.awaitWriteFinish.pollInterval,p);});};this._pendingWrites.has(e)||(this._pendingWrites.set(e,{lastChange:a,cancelWait:()=>(this._pendingWrites.delete(e),clearTimeout(s),n)}),s=setTimeout(l,this.options.awaitWriteFinish.pollInterval));}_getGlobIgnored(){return [...this._ignoredPaths.values()]}_isIgnored(e,r){if(this.options.atomic&&O$.test(e))return !0;if(!this._userIgnored){let{cwd:n}=this.options,i=this.options.ignored,s=i&&i.map(V0(n)),o=Ld(s).filter(l=>typeof l===Wd&&!Pd(l)).map(l=>l+kd),a=this._getGlobIgnored().map(V0(n)).concat(s,o);this._userIgnored=Md(a,void 0,Nd);}return this._userIgnored([e,r])}_isntIgnored(e,r){return !this._isIgnored(e,r)}_getWatchHelpers(e,r){let n=r||this.options.disableGlobbing||!Pd(e)?e:b$(e),i=this.options.followSymlinks;return new jd(e,n,i,this)}_getWatchedDir(e){this._boundRemove||(this._boundRemove=this._remove.bind(this));let r=Ue.resolve(e);return this._watched.has(r)||this._watched.set(r,new $d(r,this._boundRemove)),this._watched.get(r)}_hasReadPermissions(e){if(this.options.ignorePermissionErrors)return !0;let n=(e&&Number.parseInt(e.mode,10))&511;return !!(4&Number.parseInt(n.toString(8)[0],10))}_remove(e,r,n){let i=Ue.join(e,r),s=Ue.resolve(i);if(n=n??(this._watched.has(i)||this._watched.has(s)),!this._throttle("remove",i,100))return;!n&&!this.options.useFsEvents&&this._watched.size===1&&this.add(e,r,!0),this._getWatchedDir(i).getChildren().forEach(m=>this._remove(i,m));let l=this._getWatchedDir(e),d=l.has(r);l.remove(r),this._symlinkPaths.has(s)&&this._symlinkPaths.delete(s);let c=i;if(this.options.cwd&&(c=Ue.relative(this.options.cwd,i)),this.options.awaitWriteFinish&&this._pendingWrites.has(c)&&this._pendingWrites.get(c).cancelWait()===ou)return;this._watched.delete(i),this._watched.delete(s);let p=n?C$:W0;d&&!this._isIgnored(i)&&this._emit(p,i),this.options.useFsEvents||this._closePath(i);}_closePath(e){this._closeFile(e);let r=Ue.dirname(e);this._getWatchedDir(r).remove(Ue.basename(e));}_closeFile(e){let r=this._closers.get(e);r&&(r.forEach(n=>n()),this._closers.delete(e));}_addPathCloser(e,r){if(!r)return;let n=this._closers.get(e);n||(n=[],this._closers.set(e,n)),n.push(r);}_readdirp(e,r){if(this.closed)return;let n={type:Dd,alwaysStat:!0,lstat:!0,...r},i=y$(e,n);return this._streams.add(i),i.once(T$,()=>{i=void 0;}),i.once(A$,()=>{i&&(this._streams.delete(i),i=void 0);}),i}};Bd.FSWatcher=au;var G$=(t,e)=>{let r=new au(e);return r.add(t),r};Bd.watch=G$;});var Zd=A((EV,rR)=>{var oo=t=>t&&typeof t.message=="string",Kd=t=>{if(!t)return;let e=t.cause;if(typeof e=="function"){let r=t.cause();return oo(r)?r:void 0}else return oo(e)?e:void 0},eR=(t,e)=>{if(!oo(t))return "";let r=t.stack||"";if(e.has(t))return r+`
causes have become circular...`;let n=Kd(t);return n?(e.add(t),r+`
caused by: `+eR(n,e)):r},Y$=t=>eR(t,new Set),tR=(t,e,r)=>{if(!oo(t))return "";let n=r?"":t.message||"";if(e.has(t))return n+": ...";let i=Kd(t);if(i){e.add(t);let s=typeof t.cause=="function";return n+(s?"":": ")+tR(i,e,s)}else return n},X$=t=>tR(t,new Set);rR.exports={isErrorLike:oo,getErrorCause:Kd,stackWithCauses:Y$,messageWithCauses:X$};});var Jd=A((RV,iR)=>{var Q$=Symbol("circular-ref-tag"),uu=Symbol("pino-raw-err-ref"),nR=Object.create({},{type:{enumerable:!0,writable:!0,value:void 0},message:{enumerable:!0,writable:!0,value:void 0},stack:{enumerable:!0,writable:!0,value:void 0},aggregateErrors:{enumerable:!0,writable:!0,value:void 0},raw:{enumerable:!1,get:function(){return this[uu]},set:function(t){this[uu]=t;}}});Object.defineProperty(nR,uu,{writable:!0,value:{}});iR.exports={pinoErrProto:nR,pinoErrorSymbols:{seen:Q$,rawSymbol:uu}};});var aR=A((CV,oR)=>{oR.exports=Xd;var{messageWithCauses:ej,stackWithCauses:tj,isErrorLike:sR}=Zd(),{pinoErrProto:rj,pinoErrorSymbols:nj}=Jd(),{seen:Yd}=nj,{toString:ij}=Object.prototype;function Xd(t){if(!sR(t))return t;t[Yd]=void 0;let e=Object.create(rj);e.type=ij.call(t.constructor)==="[object Function]"?t.constructor.name:t.name,e.message=ej(t),e.stack=tj(t),Array.isArray(t.errors)&&(e.aggregateErrors=t.errors.map(r=>Xd(r)));for(let r in t)if(e[r]===void 0){let n=t[r];sR(n)?r!=="cause"&&!Object.prototype.hasOwnProperty.call(n,Yd)&&(e[r]=Xd(n)):e[r]=n;}return delete t[Yd],e.raw=t,e}});var cR=A((xV,uR)=>{uR.exports=lu;var{isErrorLike:Qd}=Zd(),{pinoErrProto:sj,pinoErrorSymbols:oj}=Jd(),{seen:cu}=oj,{toString:aj}=Object.prototype;function lu(t){if(!Qd(t))return t;t[cu]=void 0;let e=Object.create(sj);e.type=aj.call(t.constructor)==="[object Function]"?t.constructor.name:t.name,e.message=t.message,e.stack=t.stack,Array.isArray(t.errors)&&(e.aggregateErrors=t.errors.map(r=>lu(r))),Qd(t.cause)&&!Object.prototype.hasOwnProperty.call(t.cause,cu)&&(e.cause=lu(t.cause));for(let r in t)if(e[r]===void 0){let n=t[r];Qd(n)?Object.prototype.hasOwnProperty.call(n,cu)||(e[r]=lu(n)):e[r]=n;}return delete t[cu],e.raw=t,e}});var hR=A((TV,dR)=>{dR.exports={mapHttpRequest:uj,reqSerializer:fR};var eh=Symbol("pino-raw-req-ref"),lR=Object.create({},{id:{enumerable:!0,writable:!0,value:""},method:{enumerable:!0,writable:!0,value:""},url:{enumerable:!0,writable:!0,value:""},query:{enumerable:!0,writable:!0,value:""},params:{enumerable:!0,writable:!0,value:""},headers:{enumerable:!0,writable:!0,value:{}},remoteAddress:{enumerable:!0,writable:!0,value:""},remotePort:{enumerable:!0,writable:!0,value:""},raw:{enumerable:!1,get:function(){return this[eh]},set:function(t){this[eh]=t;}}});Object.defineProperty(lR,eh,{writable:!0,value:{}});function fR(t){let e=t.info||t.socket,r=Object.create(lR);if(r.id=typeof t.id=="function"?t.id():t.id||(t.info?t.info.id:void 0),r.method=t.method,t.originalUrl)r.url=t.originalUrl;else {let n=t.path;r.url=typeof n=="string"?n:t.url?t.url.path||t.url:void 0;}return t.query&&(r.query=t.query),t.params&&(r.params=t.params),r.headers=t.headers,r.remoteAddress=e&&e.remoteAddress,r.remotePort=e&&e.remotePort,r.raw=t.raw||t,r}function uj(t){return {req:fR(t)}}});var _R=A((AV,gR)=>{gR.exports={mapHttpResponse:cj,resSerializer:mR};var th=Symbol("pino-raw-res-ref"),pR=Object.create({},{statusCode:{enumerable:!0,writable:!0,value:0},headers:{enumerable:!0,writable:!0,value:""},raw:{enumerable:!1,get:function(){return this[th]},set:function(t){this[th]=t;}}});Object.defineProperty(pR,th,{writable:!0,value:{}});function mR(t){let e=Object.create(pR);return e.statusCode=t.headersSent?t.statusCode:null,e.headers=t.getHeaders?t.getHeaders():t._headers,e.raw=t,e}function cj(t){return {res:mR(t)}}});var nh=A((PV,yR)=>{var rh=aR(),lj=cR(),fu=hR(),du=_R();yR.exports={err:rh,errWithCause:lj,mapHttpRequest:fu.mapHttpRequest,mapHttpResponse:du.mapHttpResponse,req:fu.reqSerializer,res:du.resSerializer,wrapErrorSerializer:function(e){return e===rh?e:function(n){return e(rh(n))}},wrapRequestSerializer:function(e){return e===fu.reqSerializer?e:function(n){return e(fu.reqSerializer(n))}},wrapResponseSerializer:function(e){return e===du.resSerializer?e:function(n){return e(du.resSerializer(n))}}};});var ih=A((DV,bR)=>{function fj(t,e){return e}bR.exports=function(){let e=Error.prepareStackTrace;Error.prepareStackTrace=fj;let r=new Error().stack;if(Error.prepareStackTrace=e,!Array.isArray(r))return;let n=r.slice(2),i=[];for(let s of n)s&&i.push(s.getFileName());return i};});var wR=A((OV,vR)=>{vR.exports=dj;function dj(t={}){let{ERR_PATHS_MUST_BE_STRINGS:e=()=>"fast-redact - Paths must be (non-empty) strings",ERR_INVALID_PATH:r=n=>`fast-redact \u2013 Invalid path (${n})`}=t;return function({paths:i}){i.forEach(s=>{if(typeof s!="string")throw Error(e());try{if(/〇/.test(s))throw Error();let o=(s[0]==="["?"":".")+s.replace(/^\*/,"\u3007").replace(/\.\*/g,".\u3007").replace(/\[\*\]/g,"[\u3007]");if(/\n|\r|;/.test(o)||/\/\*/.test(o))throw Error();Function(`
            'use strict'
            const o = new Proxy({}, { get: () => o, set: () => { throw Error() } });
            const \u3007 = null;
            o${o}
            if ([o${o}].length !== 1) throw Error()`)();}catch{throw Error(r(s))}});}}});var hu=A((IV,SR)=>{SR.exports=/[^.[\]]+|\[((?:.)*?)\]/g;});var RR=A((kV,ER)=>{var hj=hu();ER.exports=pj;function pj({paths:t}){let e=[];var r=0;let n=t.reduce(function(i,s,o){var a=s.match(hj).map(c=>c.replace(/'|"|`/g,""));let l=s[0]==="[";a=a.map(c=>c[0]==="["?c.substr(1,c.length-2):c);let d=a.indexOf("*");if(d>-1){let c=a.slice(0,d),p=c.join("."),m=a.slice(d+1,a.length),_=m.length>0;r++,e.push({before:c,beforeStr:p,after:m,nested:_});}else i[s]={path:a,val:void 0,precensored:!1,circle:"",escPath:JSON.stringify(s),leadingBracket:l};return i},{});return {wildcards:e,wcLen:r,secret:n}}});var xR=A((MV,CR)=>{var mj=hu();CR.exports=gj;function gj({secret:t,serialize:e,wcLen:r,strict:n,isCensorFct:i,censorFctTakesPath:s},o){let a=Function("o",`
    if (typeof o !== 'object' || o == null) {
      ${vj(n,e)}
    }
    const { censor, secret } = this
    ${_j(t,i,s)}
    this.compileRestore()
    ${yj(r>0,i,s)}
    ${bj(e)}
  `).bind(o);return e===!1&&(a.restore=l=>o.restore(l)),a}function _j(t,e,r){return Object.keys(t).map(n=>{let{escPath:i,leadingBracket:s,path:o}=t[n],a=s?1:0,l=s?"":".",d=[];for(var c;(c=mj.exec(n))!==null;){let[,w]=c,{index:E,input:P}=c;E>a&&d.push(P.substring(0,E-(w?0:1)));}var p=d.map(w=>`o${l}${w}`).join(" && ");p.length===0?p+=`o${l}${n} != null`:p+=` && o${l}${n} != null`;let m=`
      switch (true) {
        ${d.reverse().map(w=>`
          case o${l}${w} === censor:
            secret[${i}].circle = ${JSON.stringify(w)}
            break
        `).join(`
`)}
      }
    `,_=r?`val, ${JSON.stringify(o)}`:"val";return `
      if (${p}) {
        const val = o${l}${n}
        if (val === censor) {
          secret[${i}].precensored = true
        } else {
          secret[${i}].val = val
          o${l}${n} = ${e?`censor(${_})`:"censor"}
          ${m}
        }
      }
    `}).join(`
`)}function yj(t,e,r){return t===!0?`
    {
      const { wildcards, wcLen, groupRedact, nestedRedact } = this
      for (var i = 0; i < wcLen; i++) {
        const { before, beforeStr, after, nested } = wildcards[i]
        if (nested === true) {
          secret[beforeStr] = secret[beforeStr] || []
          nestedRedact(secret[beforeStr], o, before, after, censor, ${e}, ${r})
        } else secret[beforeStr] = groupRedact(o, before, censor, ${e}, ${r})
      }
    }
  `:""}function bj(t){return t===!1?"return o":`
    var s = this.serialize(o)
    this.restore(o)
    return s
  `}function vj(t,e){return t===!0?"throw Error('fast-redact: primitives cannot be redacted')":e===!1?"return o":"return this.serialize(o)"}});var oh=A((FV,PR)=>{PR.exports={groupRedact:Sj,groupRestore:wj,nestedRedact:Rj,nestedRestore:Ej};function wj({keys:t,values:e,target:r}){if(r==null)return;let n=t.length;for(var i=0;i<n;i++){let s=t[i];r[s]=e[i];}}function Sj(t,e,r,n,i){let s=TR(t,e);if(s==null)return {keys:null,values:null,target:null,flat:!0};let o=Object.keys(s),a=o.length,l=e.length,d=i?[...e]:void 0,c=new Array(a);for(var p=0;p<a;p++){let m=o[p];c[p]=s[m],i?(d[l]=m,s[m]=r(s[m],d)):n?s[m]=r(s[m]):s[m]=r;}return {keys:o,values:c,target:s,flat:!0}}function Ej(t){for(let e=0;e<t.length;e++){let{target:r,path:n,value:i}=t[e],s=r;for(let o=n.length-1;o>0;o--)s=s[n[o]];s[n[0]]=i;}}function Rj(t,e,r,n,i,s,o){let a=TR(e,r);if(a==null)return;let l=Object.keys(a),d=l.length;for(var c=0;c<d;c++){let p=l[c];Cj(t,a,p,r,n,i,s,o);}return t}function sh(t,e){return t!=null?"hasOwn"in Object?Object.hasOwn(t,e):Object.prototype.hasOwnProperty.call(t,e):!1}function Cj(t,e,r,n,i,s,o,a){let l=i.length,d=l-1,c=r;var p=-1,m,_,w,P=null,D,g,S=!1,I=0,L=0,Z=xj();if(w=m=e[r],typeof m=="object"){for(;m!=null&&++p<l&&(L+=1,r=i[p],!(r!=="*"&&!P&&!(typeof m=="object"&&r in m)));)if(!(r==="*"&&(P==="*"&&(S=!0),P=r,p!==d))){if(P){let U=Object.keys(m);for(var K=0;K<U.length;K++){let B=U[K];if(g=m[B],D=r==="*",S)Z=on(Z,B,L),I=p,w=AR(g,I-1,r,n,i,s,o,a,c,m,_,w,D,B,p,d,Z,t,e[c],L+1);else if(D||typeof g=="object"&&g!==null&&r in g){if(D?w=g:w=g[r],_=p!==d?w:o?a?s(w,[...n,c,...i]):s(w):s,D){let Q=ao(on(Z,B,L),w,e[c]);t.push(Q),m[B]=_;}else if(g[r]!==_)if(_===void 0&&s!==void 0||sh(g,r)&&_===w)Z=on(Z,B,L);else {Z=on(Z,B,L);let Q=ao(on(Z,r,L+1),w,e[c]);t.push(Q),g[r]=_;}}}P=null;}else {if(w=m[r],Z=on(Z,r,L),_=p!==d?w:o?a?s(w,[...n,c,...i]):s(w):s,!(sh(m,r)&&_===w||_===void 0&&s!==void 0)){let U=ao(Z,w,e[c]);t.push(U),m[r]=_;}m=m[r];}if(typeof m!="object")break}}}function TR(t,e){for(var r=-1,n=e.length,i=t;i!=null&&++r<n;)i=i[e[r]];return i}function AR(t,e,r,n,i,s,o,a,l,d,c,p,m,_,w,E,P,D,g,S){if(e===0&&(m||typeof t=="object"&&t!==null&&r in t)){if(m?p=t:p=t[r],c=w!==E?p:o?a?s(p,[...n,l,...i]):s(p):s,m){let I=ao(P,p,g);D.push(I),d[_]=c;}else if(t[r]!==c){if(!(c===void 0&&s!==void 0||sh(t,r)&&c===p)){let I=ao(on(P,r,S+1),p,g);D.push(I),t[r]=c;}}}for(let I in t)typeof t[I]=="object"&&(P=on(P,I,S),AR(t[I],e-1,r,n,i,s,o,a,l,d,c,p,m,_,w,E,P,D,g,S+1));}function xj(){return {parent:null,key:null,children:[],depth:0}}function on(t,e,r){if(t.depth===r)return on(t.parent,e,r);var n={parent:t,key:e,depth:r,children:[]};return t.children.push(n),n}function ao(t,e,r){let n=t,i=[];do i.push(n.key),n=n.parent;while(n.parent!=null);return {path:i,value:e,target:r}}});var OR=A((NV,DR)=>{var{groupRestore:Tj,nestedRestore:Aj}=oh();DR.exports=Pj;function Pj({secret:t,wcLen:e}){return function(){if(this.restore)return;let n=Object.keys(t),i=Dj(t,n),s=e>0,o=s?{secret:t,groupRestore:Tj,nestedRestore:Aj}:{secret:t};this.restore=Function("o",Oj(i,n,s)).bind(o);}}function Dj(t,e){return e.map(r=>{let{circle:n,escPath:i,leadingBracket:s}=t[r],a=n?`o.${n} = secret[${i}].val`:`o${s?"":"."}${r} = secret[${i}].val`,l=`secret[${i}].val = undefined`;return `
      if (secret[${i}].val !== undefined) {
        try { ${a} } catch (e) {}
        ${l}
      }
    `}).join("")}function Oj(t,e,r){return `
    const secret = this.secret
    ${r===!0?`
    const keys = Object.keys(secret)
    const len = keys.length
    for (var i = len - 1; i >= ${e.length}; i--) {
      const k = keys[i]
      const o = secret[k]
      if (o.flat === true) this.groupRestore(o)
      else this.nestedRestore(o)
      secret[k] = null
    }
  `:""}
    ${t}
    return o
  `}});var kR=A((qV,IR)=>{IR.exports=Ij;function Ij(t){let{secret:e,censor:r,compileRestore:n,serialize:i,groupRedact:s,nestedRedact:o,wildcards:a,wcLen:l}=t,d=[{secret:e,censor:r,compileRestore:n}];return i!==!1&&d.push({serialize:i}),l>0&&d.push({groupRedact:s,nestedRedact:o,wildcards:a,wcLen:l}),Object.assign(...d)}});var NR=A((LV,FR)=>{var MR=wR(),kj=RR(),Mj=xR(),Fj=OR(),{groupRedact:Nj,nestedRedact:qj}=oh(),Lj=kR(),$j=hu(),jj=MR(),ah=t=>t;ah.restore=ah;var Hj="[REDACTED]";uh.rx=$j;uh.validator=MR;FR.exports=uh;function uh(t={}){let e=Array.from(new Set(t.paths||[])),r="serialize"in t&&(t.serialize===!1||typeof t.serialize=="function")?t.serialize:JSON.stringify,n=t.remove;if(n===!0&&r!==JSON.stringify)throw Error("fast-redact \u2013 remove option may only be set when serializer is JSON.stringify");let i=n===!0?void 0:"censor"in t?t.censor:Hj,s=typeof i=="function",o=s&&i.length>1;if(e.length===0)return r||ah;jj({paths:e,serialize:r,censor:i});let{wildcards:a,wcLen:l,secret:d}=kj({paths:e,censor:i}),c=Fj({secret:d,wcLen:l}),p="strict"in t?t.strict:!0;return Mj({secret:d,wcLen:l,serialize:r,strict:p,isCensorFct:s,censorFctTakesPath:o},Lj({secret:d,censor:i,compileRestore:c,serialize:r,groupRedact:Nj,nestedRedact:qj,wildcards:a,wcLen:l}))}});var Ui=A(($V,qR)=>{var Wj=Symbol("pino.setLevel"),Bj=Symbol("pino.getLevel"),Uj=Symbol("pino.levelVal"),zj=Symbol("pino.useLevelLabels"),Vj=Symbol("pino.useOnlyCustomLevels"),Gj=Symbol("pino.mixin"),Kj=Symbol("pino.lsCache"),Zj=Symbol("pino.chindings"),Jj=Symbol("pino.asJson"),Yj=Symbol("pino.write"),Xj=Symbol("pino.redactFmt"),Qj=Symbol("pino.time"),eH=Symbol("pino.timeSliceIndex"),tH=Symbol("pino.stream"),rH=Symbol("pino.stringify"),nH=Symbol("pino.stringifySafe"),iH=Symbol("pino.stringifiers"),sH=Symbol("pino.end"),oH=Symbol("pino.formatOpts"),aH=Symbol("pino.messageKey"),uH=Symbol("pino.errorKey"),cH=Symbol("pino.nestedKey"),lH=Symbol("pino.nestedKeyStr"),fH=Symbol("pino.mixinMergeStrategy"),dH=Symbol("pino.msgPrefix"),hH=Symbol("pino.wildcardFirst"),pH=Symbol.for("pino.serializers"),mH=Symbol.for("pino.formatters"),gH=Symbol.for("pino.hooks"),_H=Symbol.for("pino.metadata");qR.exports={setLevelSym:Wj,getLevelSym:Bj,levelValSym:Uj,useLevelLabelsSym:zj,mixinSym:Gj,lsCacheSym:Kj,chindingsSym:Zj,asJsonSym:Jj,writeSym:Yj,serializersSym:pH,redactFmtSym:Xj,timeSym:Qj,timeSliceIndexSym:eH,streamSym:tH,stringifySym:rH,stringifySafeSym:nH,stringifiersSym:iH,endSym:sH,formatOptsSym:oH,messageKeySym:aH,errorKeySym:uH,nestedKeySym:cH,wildcardFirstSym:hH,needsMetadataGsym:_H,useOnlyCustomLevelsSym:Vj,formattersSym:mH,hooksSym:gH,nestedKeyStrSym:lH,mixinMergeStrategySym:fH,msgPrefixSym:dH};});var fh=A((jV,HR)=>{var lh=NR(),{redactFmtSym:yH,wildcardFirstSym:pu}=Ui(),{rx:ch,validator:bH}=lh,LR=bH({ERR_PATHS_MUST_BE_STRINGS:()=>"pino \u2013 redacted paths must be strings",ERR_INVALID_PATH:t=>`pino \u2013 redact paths array contains an invalid path (${t})`}),$R="[Redacted]",jR=!1;function vH(t,e){let{paths:r,censor:n}=wH(t),i=r.reduce((a,l)=>{ch.lastIndex=0;let d=ch.exec(l),c=ch.exec(l),p=d[1]!==void 0?d[1].replace(/^(?:"|'|`)(.*)(?:"|'|`)$/,"$1"):d[0];if(p==="*"&&(p=pu),c===null)return a[p]=null,a;if(a[p]===null)return a;let{index:m}=c,_=`${l.substr(m,l.length-1)}`;return a[p]=a[p]||[],p!==pu&&a[p].length===0&&a[p].push(...a[pu]||[]),p===pu&&Object.keys(a).forEach(function(w){a[w]&&a[w].push(_);}),a[p].push(_),a},{}),s={[yH]:lh({paths:r,censor:n,serialize:e,strict:jR})},o=(...a)=>e(typeof n=="function"?n(...a):n);return [...Object.keys(i),...Object.getOwnPropertySymbols(i)].reduce((a,l)=>{if(i[l]===null)a[l]=d=>o(d,[l]);else {let d=typeof n=="function"?(c,p)=>n(c,[l,...p]):n;a[l]=lh({paths:i[l],censor:d,serialize:e,strict:jR});}return a},s)}function wH(t){if(Array.isArray(t))return t={paths:t,censor:$R},LR(t),t;let{paths:e,censor:r=$R,remove:n}=t;if(Array.isArray(e)===!1)throw Error("pino \u2013 redact must contain an array of strings");return n===!0&&(r=void 0),LR({paths:e,censor:r}),{paths:e,censor:r}}HR.exports=vH;});var BR=A((HV,WR)=>{var SH=()=>"",EH=()=>`,"time":${Date.now()}`,RH=()=>`,"time":${Math.round(Date.now()/1e3)}`,CH=()=>`,"time":"${new Date(Date.now()).toISOString()}"`;WR.exports={nullTime:SH,epochTime:EH,unixTime:RH,isoTime:CH};});var zR=A((WV,UR)=>{function xH(t){try{return JSON.stringify(t)}catch{return '"[Circular]"'}}UR.exports=TH;function TH(t,e,r){var n=r&&r.stringify||xH,i=1;if(typeof t=="object"&&t!==null){var s=e.length+i;if(s===1)return t;var o=new Array(s);o[0]=n(t);for(var a=1;a<s;a++)o[a]=n(e[a]);return o.join(" ")}if(typeof t!="string")return t;var l=e.length;if(l===0)return t;for(var d="",c=1-i,p=-1,m=t&&t.length||0,_=0;_<m;){if(t.charCodeAt(_)===37&&_+1<m){switch(p=p>-1?p:0,t.charCodeAt(_+1)){case 100:case 102:if(c>=l||e[c]==null)break;p<_&&(d+=t.slice(p,_)),d+=Number(e[c]),p=_+2,_++;break;case 105:if(c>=l||e[c]==null)break;p<_&&(d+=t.slice(p,_)),d+=Math.floor(Number(e[c])),p=_+2,_++;break;case 79:case 111:case 106:if(c>=l||e[c]===void 0)break;p<_&&(d+=t.slice(p,_));var w=typeof e[c];if(w==="string"){d+="'"+e[c]+"'",p=_+2,_++;break}if(w==="function"){d+=e[c].name||"<anonymous>",p=_+2,_++;break}d+=n(e[c]),p=_+2,_++;break;case 115:if(c>=l)break;p<_&&(d+=t.slice(p,_)),d+=String(e[c]),p=_+2,_++;break;case 37:p<_&&(d+=t.slice(p,_)),d+="%",p=_+2,_++,c--;break}++c;}++_;}return p===-1?t:(p<m&&(d+=t.slice(p)),d)}});var hh=A((BV,dh)=>{if(typeof SharedArrayBuffer<"u"&&typeof Atomics<"u"){let e=function(r){if((r>0&&r<1/0)===!1)throw typeof r!="number"&&typeof r!="bigint"?TypeError("sleep: ms must be a number"):RangeError("sleep: ms must be a number that is greater than 0 but less than Infinity");Atomics.wait(t,0,0,Number(r));},t=new Int32Array(new SharedArrayBuffer(4));dh.exports=e;}else {let t=function(e){if((e>0&&e<1/0)===!1)throw typeof e!="number"&&typeof e!="bigint"?TypeError("sleep: ms must be a number"):RangeError("sleep: ms must be a number that is greater than 0 but less than Infinity");};dh.exports=t;}});var QR=A((UV,XR)=>{var ft=oe("fs"),AH=oe("events"),PH=oe("util").inherits,VR=oe("path"),ph=hh(),mu=100,gu=Buffer.allocUnsafe(0),DH=16*1024,GR="buffer",KR="utf8";function ZR(t,e){e._opening=!0,e._writing=!0,e._asyncDrainScheduled=!1;function r(s,o){if(s){e._reopening=!1,e._writing=!1,e._opening=!1,e.sync?process.nextTick(()=>{e.listenerCount("error")>0&&e.emit("error",s);}):e.emit("error",s);return}e.fd=o,e.file=t,e._reopening=!1,e._opening=!1,e._writing=!1,e.sync?process.nextTick(()=>e.emit("ready")):e.emit("ready"),!(e._reopening||e.destroyed)&&(!e._writing&&e._len>e.minLength||e._flushPending)&&e._actualWrite();}let n=e.append?"a":"w",i=e.mode;if(e.sync)try{e.mkdir&&ft.mkdirSync(VR.dirname(t),{recursive:!0});let s=ft.openSync(t,n,i);r(null,s);}catch(s){throw r(s),s}else e.mkdir?ft.mkdir(VR.dirname(t),{recursive:!0},s=>{if(s)return r(s);ft.open(t,n,i,r);}):ft.open(t,n,i,r);}function Ir(t){if(!(this instanceof Ir))return new Ir(t);let{fd:e,dest:r,minLength:n,maxLength:i,maxWrite:s,sync:o,append:a=!0,mkdir:l,retryEAGAIN:d,fsync:c,contentMode:p,mode:m}=t||{};e=e||r,this._len=0,this.fd=-1,this._bufs=[],this._lens=[],this._writing=!1,this._ending=!1,this._reopening=!1,this._asyncDrainScheduled=!1,this._flushPending=!1,this._hwm=Math.max(n||0,16387),this.file=null,this.destroyed=!1,this.minLength=n||0,this.maxLength=i||0,this.maxWrite=s||DH,this.sync=o||!1,this.writable=!0,this._fsync=c||!1,this.append=a||!1,this.mode=m,this.retryEAGAIN=d||(()=>!0),this.mkdir=l||!1;let _,w;if(p===GR)this._writingBuf=gu,this.write=kH,this.flush=FH,this.flushSync=qH,this._actualWrite=$H,_=()=>ft.writeSync(this.fd,this._writingBuf),w=()=>ft.write(this.fd,this._writingBuf,this.release);else if(p===void 0||p===KR)this._writingBuf="",this.write=IH,this.flush=MH,this.flushSync=NH,this._actualWrite=LH,_=()=>ft.writeSync(this.fd,this._writingBuf,"utf8"),w=()=>ft.write(this.fd,this._writingBuf,"utf8",this.release);else throw new Error(`SonicBoom supports "${KR}" and "${GR}", but passed ${p}`);if(typeof e=="number")this.fd=e,process.nextTick(()=>this.emit("ready"));else if(typeof e=="string")ZR(e,this);else throw new Error("SonicBoom supports only file descriptors and files");if(this.minLength>=this.maxWrite)throw new Error(`minLength should be smaller than maxWrite (${this.maxWrite})`);this.release=(E,P)=>{if(E){if((E.code==="EAGAIN"||E.code==="EBUSY")&&this.retryEAGAIN(E,this._writingBuf.length,this._len-this._writingBuf.length))if(this.sync)try{ph(mu),this.release(void 0,0);}catch(g){this.release(g);}else setTimeout(w,mu);else this._writing=!1,this.emit("error",E);return}if(this.emit("write",P),this._len-=P,this._len<0&&(this._len=0),this._writingBuf=this._writingBuf.slice(P),this._writingBuf.length){if(!this.sync){w();return}try{do{let g=_();this._len-=g,this._writingBuf=this._writingBuf.slice(g);}while(this._writingBuf.length)}catch(g){this.release(g);return}}this._fsync&&ft.fsyncSync(this.fd);let D=this._len;this._reopening?(this._writing=!1,this._reopening=!1,this.reopen()):D>this.minLength?this._actualWrite():this._ending?D>0?this._actualWrite():(this._writing=!1,_u(this)):(this._writing=!1,this.sync?this._asyncDrainScheduled||(this._asyncDrainScheduled=!0,process.nextTick(OH,this)):this.emit("drain"));},this.on("newListener",function(E){E==="drain"&&(this._asyncDrainScheduled=!1);});}function OH(t){t.listenerCount("drain")>0&&(t._asyncDrainScheduled=!1,t.emit("drain"));}PH(Ir,AH);function JR(t,e){return t.length===0?gu:t.length===1?t[0]:Buffer.concat(t,e)}function IH(t){if(this.destroyed)throw new Error("SonicBoom destroyed");let e=this._len+t.length,r=this._bufs;return this.maxLength&&e>this.maxLength?(this.emit("drop",t),this._len<this._hwm):(r.length===0||r[r.length-1].length+t.length>this.maxWrite?r.push(""+t):r[r.length-1]+=t,this._len=e,!this._writing&&this._len>=this.minLength&&this._actualWrite(),this._len<this._hwm)}function kH(t){if(this.destroyed)throw new Error("SonicBoom destroyed");let e=this._len+t.length,r=this._bufs,n=this._lens;return this.maxLength&&e>this.maxLength?(this.emit("drop",t),this._len<this._hwm):(r.length===0||n[n.length-1]+t.length>this.maxWrite?(r.push([t]),n.push(t.length)):(r[r.length-1].push(t),n[n.length-1]+=t.length),this._len=e,!this._writing&&this._len>=this.minLength&&this._actualWrite(),this._len<this._hwm)}function YR(t){this._flushPending=!0;let e=()=>{this._fsync?(this._flushPending=!1,t()):ft.fsync(this.fd,n=>{this._flushPending=!1,t(n);}),this.off("error",r);},r=n=>{this._flushPending=!1,t(n),this.off("drain",e);};this.once("drain",e),this.once("error",r);}function MH(t){if(t!=null&&typeof t!="function")throw new Error("flush cb must be a function");if(this.destroyed){let e=new Error("SonicBoom destroyed");if(t){t(e);return}throw e}if(this.minLength<=0){t?.();return}t&&YR.call(this,t),!this._writing&&(this._bufs.length===0&&this._bufs.push(""),this._actualWrite());}function FH(t){if(t!=null&&typeof t!="function")throw new Error("flush cb must be a function");if(this.destroyed){let e=new Error("SonicBoom destroyed");if(t){t(e);return}throw e}if(this.minLength<=0){t?.();return}t&&YR.call(this,t),!this._writing&&(this._bufs.length===0&&(this._bufs.push([]),this._lens.push(0)),this._actualWrite());}Ir.prototype.reopen=function(t){if(this.destroyed)throw new Error("SonicBoom destroyed");if(this._opening){this.once("ready",()=>{this.reopen(t);});return}if(this._ending)return;if(!this.file)throw new Error("Unable to reopen a file descriptor, you must pass a file to SonicBoom");if(this._reopening=!0,this._writing)return;let e=this.fd;this.once("ready",()=>{e!==this.fd&&ft.close(e,r=>{if(r)return this.emit("error",r)});}),ZR(t||this.file,this);};Ir.prototype.end=function(){if(this.destroyed)throw new Error("SonicBoom destroyed");if(this._opening){this.once("ready",()=>{this.end();});return}this._ending||(this._ending=!0,!this._writing&&(this._len>0&&this.fd>=0?this._actualWrite():_u(this)));};function NH(){if(this.destroyed)throw new Error("SonicBoom destroyed");if(this.fd<0)throw new Error("sonic boom is not ready yet");!this._writing&&this._writingBuf.length>0&&(this._bufs.unshift(this._writingBuf),this._writingBuf="");let t="";for(;this._bufs.length||t;){t.length<=0&&(t=this._bufs[0]);try{let e=ft.writeSync(this.fd,t,"utf8");t=t.slice(e),this._len=Math.max(this._len-e,0),t.length<=0&&this._bufs.shift();}catch(e){if((e.code==="EAGAIN"||e.code==="EBUSY")&&!this.retryEAGAIN(e,t.length,this._len-t.length))throw e;ph(mu);}}try{ft.fsyncSync(this.fd);}catch{}}function qH(){if(this.destroyed)throw new Error("SonicBoom destroyed");if(this.fd<0)throw new Error("sonic boom is not ready yet");!this._writing&&this._writingBuf.length>0&&(this._bufs.unshift([this._writingBuf]),this._writingBuf=gu);let t=gu;for(;this._bufs.length||t.length;){t.length<=0&&(t=JR(this._bufs[0],this._lens[0]));try{let e=ft.writeSync(this.fd,t);t=t.subarray(e),this._len=Math.max(this._len-e,0),t.length<=0&&(this._bufs.shift(),this._lens.shift());}catch(e){if((e.code==="EAGAIN"||e.code==="EBUSY")&&!this.retryEAGAIN(e,t.length,this._len-t.length))throw e;ph(mu);}}}Ir.prototype.destroy=function(){this.destroyed||_u(this);};function LH(){let t=this.release;if(this._writing=!0,this._writingBuf=this._writingBuf||this._bufs.shift()||"",this.sync)try{let e=ft.writeSync(this.fd,this._writingBuf,"utf8");t(null,e);}catch(e){t(e);}else ft.write(this.fd,this._writingBuf,"utf8",t);}function $H(){let t=this.release;if(this._writing=!0,this._writingBuf=this._writingBuf.length?this._writingBuf:JR(this._bufs.shift(),this._lens.shift()),this.sync)try{let e=ft.writeSync(this.fd,this._writingBuf);t(null,e);}catch(e){t(e);}else ft.write(this.fd,this._writingBuf,t);}function _u(t){if(t.fd===-1){t.once("ready",_u.bind(null,t));return}t.destroyed=!0,t._bufs=[],t._lens=[],ft.fsync(t.fd,e);function e(){t.fd!==1&&t.fd!==2?ft.close(t.fd,r):r();}function r(n){if(n){t.emit("error",n);return}t._ending&&!t._writing&&t.emit("finish"),t.emit("close");}}Ir.SonicBoom=Ir;Ir.default=Ir;XR.exports=Ir;});var mh=A((zV,iC)=>{var kr={exit:[],beforeExit:[]},eC={exit:WH,beforeExit:BH},zi;function jH(){zi===void 0&&(zi=new FinalizationRegistry(UH));}function HH(t){kr[t].length>0||process.on(t,eC[t]);}function tC(t){kr[t].length>0||(process.removeListener(t,eC[t]),kr.exit.length===0&&kr.beforeExit.length===0&&(zi=void 0));}function WH(){rC("exit");}function BH(){rC("beforeExit");}function rC(t){for(let e of kr[t]){let r=e.deref(),n=e.fn;r!==void 0&&n(r,t);}kr[t]=[];}function UH(t){for(let e of ["exit","beforeExit"]){let r=kr[e].indexOf(t);kr[e].splice(r,r+1),tC(e);}}function nC(t,e,r){if(e===void 0)throw new Error("the object can't be undefined");HH(t);let n=new WeakRef(e);n.fn=r,jH(),zi.register(e,n),kr[t].push(n);}function zH(t,e){nC("exit",t,e);}function VH(t,e){nC("beforeExit",t,e);}function GH(t){if(zi!==void 0){zi.unregister(t);for(let e of ["exit","beforeExit"])kr[e]=kr[e].filter(r=>{let n=r.deref();return n&&n!==t}),tC(e);}}iC.exports={register:zH,registerBeforeExit:VH,unregister:GH};});var sC=A((VV,KH)=>{KH.exports={name:"thread-stream",version:"2.4.1",description:"A streaming way to send data to a Node.js Worker Thread",main:"index.js",types:"index.d.ts",dependencies:{"real-require":"^0.2.0"},devDependencies:{"@types/node":"^20.1.0","@types/tap":"^15.0.0",desm:"^1.3.0",fastbench:"^1.0.1",husky:"^8.0.1","pino-elasticsearch":"^6.0.0","sonic-boom":"^3.0.0",standard:"^17.0.0",tap:"^16.2.0","ts-node":"^10.8.0",typescript:"^4.7.2","why-is-node-running":"^2.2.2"},scripts:{test:"standard && npm run transpile && tap test/*.test.*js && tap --ts test/*.test.*ts","test:ci":"standard && npm run transpile && npm run test:ci:js && npm run test:ci:ts","test:ci:js":'tap --no-check-coverage --coverage-report=lcovonly "test/**/*.test.*js"',"test:ci:ts":'tap --ts --no-check-coverage --coverage-report=lcovonly "test/**/*.test.*ts"',"test:yarn":'npm run transpile && tap "test/**/*.test.js" --no-check-coverage',transpile:"sh ./test/ts/transpile.sh",prepare:"husky install"},standard:{ignore:["test/ts/**/*"]},repository:{type:"git",url:"git+https://github.com/mcollina/thread-stream.git"},keywords:["worker","thread","threads","stream"],author:"Matteo Collina <hello@matteocollina.com>",license:"MIT",bugs:{url:"https://github.com/mcollina/thread-stream/issues"},homepage:"https://github.com/mcollina/thread-stream#readme"};});var aC=A((GV,oC)=>{function ZH(t,e,r,n,i){let s=Date.now()+n,o=Atomics.load(t,e);if(o===r){i(null,"ok");return}let a=o,l=d=>{Date.now()>s?i(null,"timed-out"):setTimeout(()=>{a=o,o=Atomics.load(t,e),o===a?l(d>=1e3?1e3:d*2):o===r?i(null,"ok"):i(null,"not-equal");},d);};l(1);}function JH(t,e,r,n,i){let s=Date.now()+n,o=Atomics.load(t,e);if(o!==r){i(null,"ok");return}let a=l=>{Date.now()>s?i(null,"timed-out"):setTimeout(()=>{o=Atomics.load(t,e),o!==r?i(null,"ok"):a(l>=1e3?1e3:l*2);},l);};a(1);}oC.exports={wait:ZH,waitDiff:JH};});var cC=A((KV,uC)=>{uC.exports={WRITE_INDEX:4,READ_INDEX:8};});var pC=A((ZV,hC)=>{var{version:YH}=sC(),{EventEmitter:XH}=oe("events"),{Worker:QH}=oe("worker_threads"),{join:eW}=oe("path"),{pathToFileURL:tW}=oe("url"),{wait:rW}=aC(),{WRITE_INDEX:Kt,READ_INDEX:Ur}=cC(),nW=oe("buffer"),iW=oe("assert"),Y=Symbol("kImpl"),sW=nW.constants.MAX_STRING_LENGTH,uo=class{constructor(e){this._value=e;}deref(){return this._value}},bu=class{register(){}unregister(){}},oW=process.env.NODE_V8_COVERAGE?bu:global.FinalizationRegistry||bu,aW=process.env.NODE_V8_COVERAGE?uo:global.WeakRef||uo,lC=new oW(t=>{t.exited||t.terminate();});function uW(t,e){let{filename:r,workerData:n}=e,s=("__bundlerPathsOverrides"in globalThis?globalThis.__bundlerPathsOverrides:{})["thread-stream-worker"]||eW(__dirname,"lib","worker.js"),o=new QH(s,{...e.workerOpts,trackUnmanagedFds:!1,workerData:{filename:r.indexOf("file://")===0?r:tW(r).href,dataBuf:t[Y].dataBuf,stateBuf:t[Y].stateBuf,workerData:{$context:{threadStreamVersion:YH},...n}}});return o.stream=new uo(t),o.on("message",cW),o.on("exit",dC),lC.register(t,o),o}function fC(t){iW(!t[Y].sync),t[Y].needDrain&&(t[Y].needDrain=!1,t.emit("drain"));}function yu(t){let e=Atomics.load(t[Y].state,Kt),r=t[Y].data.length-e;if(r>0){if(t[Y].buf.length===0){t[Y].flushing=!1,t[Y].ending?vh(t):t[Y].needDrain&&process.nextTick(fC,t);return}let n=t[Y].buf.slice(0,r),i=Buffer.byteLength(n);i<=r?(t[Y].buf=t[Y].buf.slice(r),vu(t,n,yu.bind(null,t))):t.flush(()=>{if(!t.destroyed){for(Atomics.store(t[Y].state,Ur,0),Atomics.store(t[Y].state,Kt,0);i>t[Y].data.length;)r=r/2,n=t[Y].buf.slice(0,r),i=Buffer.byteLength(n);t[Y].buf=t[Y].buf.slice(r),vu(t,n,yu.bind(null,t));}});}else if(r===0){if(e===0&&t[Y].buf.length===0)return;t.flush(()=>{Atomics.store(t[Y].state,Ur,0),Atomics.store(t[Y].state,Kt,0),yu(t);});}else zr(t,new Error("overwritten"));}function cW(t){let e=this.stream.deref();if(e===void 0){this.exited=!0,this.terminate();return}switch(t.code){case"READY":this.stream=new aW(e),e.flush(()=>{e[Y].ready=!0,e.emit("ready");});break;case"ERROR":zr(e,t.err);break;case"EVENT":Array.isArray(t.args)?e.emit(t.name,...t.args):e.emit(t.name,t.args);break;case"WARNING":process.emitWarning(t.err);break;default:zr(e,new Error("this should not happen: "+t.code));}}function dC(t){let e=this.stream.deref();e!==void 0&&(lC.unregister(e),e.worker.exited=!0,e.worker.off("exit",dC),zr(e,t!==0?new Error("the worker thread exited"):null));}var _h=class extends XH{constructor(e={}){if(super(),e.bufferSize<4)throw new Error("bufferSize must at least fit a 4-byte utf-8 char");this[Y]={},this[Y].stateBuf=new SharedArrayBuffer(128),this[Y].state=new Int32Array(this[Y].stateBuf),this[Y].dataBuf=new SharedArrayBuffer(e.bufferSize||4*1024*1024),this[Y].data=Buffer.from(this[Y].dataBuf),this[Y].sync=e.sync||!1,this[Y].ending=!1,this[Y].ended=!1,this[Y].needDrain=!1,this[Y].destroyed=!1,this[Y].flushing=!1,this[Y].ready=!1,this[Y].finished=!1,this[Y].errored=null,this[Y].closed=!1,this[Y].buf="",this.worker=uW(this,e);}write(e){if(this[Y].destroyed)return yh(this,new Error("the worker has exited")),!1;if(this[Y].ending)return yh(this,new Error("the worker is ending")),!1;if(this[Y].flushing&&this[Y].buf.length+e.length>=sW)try{gh(this),this[Y].flushing=!0;}catch(r){return zr(this,r),!1}if(this[Y].buf+=e,this[Y].sync)try{return gh(this),!0}catch(r){return zr(this,r),!1}return this[Y].flushing||(this[Y].flushing=!0,setImmediate(yu,this)),this[Y].needDrain=this[Y].data.length-this[Y].buf.length-Atomics.load(this[Y].state,Kt)<=0,!this[Y].needDrain}end(){this[Y].destroyed||(this[Y].ending=!0,vh(this));}flush(e){if(this[Y].destroyed){typeof e=="function"&&process.nextTick(e,new Error("the worker has exited"));return}let r=Atomics.load(this[Y].state,Kt);rW(this[Y].state,Ur,r,1/0,(n,i)=>{if(n){zr(this,n),process.nextTick(e,n);return}if(i==="not-equal"){this.flush(e);return}process.nextTick(e);});}flushSync(){this[Y].destroyed||(gh(this),bh(this));}unref(){this.worker.unref();}ref(){this.worker.ref();}get ready(){return this[Y].ready}get destroyed(){return this[Y].destroyed}get closed(){return this[Y].closed}get writable(){return !this[Y].destroyed&&!this[Y].ending}get writableEnded(){return this[Y].ending}get writableFinished(){return this[Y].finished}get writableNeedDrain(){return this[Y].needDrain}get writableObjectMode(){return !1}get writableErrored(){return this[Y].errored}};function yh(t,e){setImmediate(()=>{t.emit("error",e);});}function zr(t,e){t[Y].destroyed||(t[Y].destroyed=!0,e&&(t[Y].errored=e,yh(t,e)),t.worker.exited?setImmediate(()=>{t[Y].closed=!0,t.emit("close");}):t.worker.terminate().catch(()=>{}).then(()=>{t[Y].closed=!0,t.emit("close");}));}function vu(t,e,r){let n=Atomics.load(t[Y].state,Kt),i=Buffer.byteLength(e);return t[Y].data.write(e,n),Atomics.store(t[Y].state,Kt,n+i),Atomics.notify(t[Y].state,Kt),r(),!0}function vh(t){if(!(t[Y].ended||!t[Y].ending||t[Y].flushing)){t[Y].ended=!0;try{t.flushSync();let e=Atomics.load(t[Y].state,Ur);Atomics.store(t[Y].state,Kt,-1),Atomics.notify(t[Y].state,Kt);let r=0;for(;e!==-1;){if(Atomics.wait(t[Y].state,Ur,e,1e3),e=Atomics.load(t[Y].state,Ur),e===-2){zr(t,new Error("end() failed"));return}if(++r===10){zr(t,new Error("end() took too long (10s)"));return}}process.nextTick(()=>{t[Y].finished=!0,t.emit("finish");});}catch(e){zr(t,e);}}}function gh(t){let e=()=>{t[Y].ending?vh(t):t[Y].needDrain&&process.nextTick(fC,t);};for(t[Y].flushing=!1;t[Y].buf.length!==0;){let r=Atomics.load(t[Y].state,Kt),n=t[Y].data.length-r;if(n===0){bh(t),Atomics.store(t[Y].state,Ur,0),Atomics.store(t[Y].state,Kt,0);continue}else if(n<0)throw new Error("overwritten");let i=t[Y].buf.slice(0,n),s=Buffer.byteLength(i);if(s<=n)t[Y].buf=t[Y].buf.slice(n),vu(t,i,e);else {for(bh(t),Atomics.store(t[Y].state,Ur,0),Atomics.store(t[Y].state,Kt,0);s>t[Y].buf.length;)n=n/2,i=t[Y].buf.slice(0,n),s=Buffer.byteLength(i);t[Y].buf=t[Y].buf.slice(n),vu(t,i,e);}}}function bh(t){if(t[Y].flushing)throw new Error("unable to flush while flushing");let e=Atomics.load(t[Y].state,Kt),r=0;for(;;){let n=Atomics.load(t[Y].state,Ur);if(n===-2)throw Error("_flushSync failed");if(n!==e)Atomics.wait(t[Y].state,Ur,n,1e3);else break;if(++r===10)throw new Error("_flushSync took too long (10s)")}}hC.exports=_h;});var Eh=A((JV,mC)=>{var{createRequire:lW}=oe("module"),fW=ih(),{join:wh,isAbsolute:dW,sep:hW}=oe("path"),pW=hh(),Sh=mh(),mW=pC();function gW(t){Sh.register(t,yW),Sh.registerBeforeExit(t,bW),t.on("close",function(){Sh.unregister(t);});}function _W(t,e,r){let n=new mW({filename:t,workerData:e,workerOpts:r});n.on("ready",i),n.on("close",function(){process.removeListener("exit",s);}),process.on("exit",s);function i(){process.removeListener("exit",s),n.unref(),r.autoEnd!==!1&&gW(n);}function s(){n.closed||(n.flushSync(),pW(100),n.end());}return n}function yW(t){t.ref(),t.flushSync(),t.end(),t.once("close",function(){t.unref();});}function bW(t){t.flushSync();}function vW(t){let{pipeline:e,targets:r,levels:n,dedupe:i,options:s={},worker:o={},caller:a=fW()}=t,l=typeof a=="string"?[a]:a,d="__bundlerPathsOverrides"in globalThis?globalThis.__bundlerPathsOverrides:{},c=t.target;if(c&&r)throw new Error("only one of target or targets can be specified");return r?(c=d["pino-worker"]||wh(__dirname,"worker.js"),s.targets=r.map(m=>({...m,target:p(m.target)}))):e&&(c=d["pino-pipeline-worker"]||wh(__dirname,"worker-pipeline.js"),s.targets=e.map(m=>({...m,target:p(m.target)}))),n&&(s.levels=n),i&&(s.dedupe=i),_W(p(c),s,o);function p(m){if(m=d[m]||m,dW(m)||m.indexOf("file://")===0)return m;if(m==="pino/file")return wh(__dirname,"..","file.js");let _;for(let w of l)try{let E=w==="node:repl"?process.cwd()+hW:w;_=lW(E).resolve(m);break}catch{continue}if(!_)throw new Error(`unable to determine transport target for "${m}"`);return _}}mC.exports=vW;});var Eu=A((YV,xC)=>{var gC=zR(),{mapHttpRequest:wW,mapHttpResponse:SW}=nh(),Ch=QR(),_C=mh(),{lsCacheSym:EW,chindingsSym:vC,writeSym:yC,serializersSym:wC,formatOptsSym:bC,endSym:RW,stringifiersSym:SC,stringifySym:EC,stringifySafeSym:xh,wildcardFirstSym:RC,nestedKeySym:CW,formattersSym:CC,messageKeySym:xW,errorKeySym:TW,nestedKeyStrSym:AW,msgPrefixSym:wu}=Ui(),{isMainThread:PW}=oe("worker_threads"),DW=Eh();function Vi(){}function OW(t,e){if(!e)return r;return function(...i){e.call(this,i,r,t);};function r(n,...i){if(typeof n=="object"){let s=n;n!==null&&(n.method&&n.headers&&n.socket?n=wW(n):typeof n.setHeader=="function"&&(n=SW(n)));let o;s===null&&i.length===0?o=[null]:(s=i.shift(),o=i),typeof this[wu]=="string"&&s!==void 0&&s!==null&&(s=this[wu]+s),this[yC](n,gC(s,o,this[bC]),t);}else {let s=n===void 0?i.shift():n;typeof this[wu]=="string"&&s!==void 0&&s!==null&&(s=this[wu]+s),this[yC](null,gC(s,i,this[bC]),t);}}}function Rh(t){let e="",r=0,n=!1,i=255,s=t.length;if(s>100)return JSON.stringify(t);for(var o=0;o<s&&i>=32;o++)i=t.charCodeAt(o),(i===34||i===92)&&(e+=t.slice(r,o)+"\\",r=o,n=!0);return n?e+=t.slice(r):e=t,i<32?JSON.stringify(t):'"'+e+'"'}function IW(t,e,r,n){let i=this[EC],s=this[xh],o=this[SC],a=this[RW],l=this[vC],d=this[wC],c=this[CC],p=this[xW],m=this[TW],_=this[EW][r]+n;_=_+l;let w;c.log&&(t=c.log(t));let E=o[RC],P="";for(let g in t)if(w=t[g],Object.prototype.hasOwnProperty.call(t,g)&&w!==void 0){d[g]?w=d[g](w):g===m&&d.err&&(w=d.err(w));let S=o[g]||E;switch(typeof w){case"undefined":case"function":continue;case"number":Number.isFinite(w)===!1&&(w=null);case"boolean":S&&(w=S(w));break;case"string":w=(S||Rh)(w);break;default:w=(S||i)(w,s);}if(w===void 0)continue;let I=Rh(g);P+=","+I+":"+w;}let D="";if(e!==void 0){w=d[p]?d[p](e):e;let g=o[p]||E;switch(typeof w){case"function":break;case"number":Number.isFinite(w)===!1&&(w=null);case"boolean":g&&(w=g(w)),D=',"'+p+'":'+w;break;case"string":w=(g||Rh)(w),D=',"'+p+'":'+w;break;default:w=(g||i)(w,s),D=',"'+p+'":'+w;}}return this[CW]&&P?_+this[AW]+P.slice(1)+"}"+D+a:_+P+D+a}function kW(t,e){let r,n=t[vC],i=t[EC],s=t[xh],o=t[SC],a=o[RC],l=t[wC],d=t[CC].bindings;e=d(e);for(let c in e)if(r=e[c],(c!=="level"&&c!=="serializers"&&c!=="formatters"&&c!=="customLevels"&&e.hasOwnProperty(c)&&r!==void 0)===!0){if(r=l[c]?l[c](r):r,r=(o[c]||a||i)(r,s),r===void 0)continue;n+=',"'+c+'":'+r;}return n}function MW(t){return t.write!==t.constructor.prototype.write}var FW=process.env.NODE_V8_COVERAGE||process.env.V8_COVERAGE;function Su(t){let e=new Ch(t);return e.on("error",r),!FW&&!t.sync&&PW&&(_C.register(e,NW),e.on("close",function(){_C.unregister(e);})),e;function r(n){if(n.code==="EPIPE"){e.write=Vi,e.end=Vi,e.flushSync=Vi,e.destroy=Vi;return}e.removeListener("error",r),e.emit("error",n);}}function NW(t,e){t.destroyed||(e==="beforeExit"?(t.flush(),t.on("drain",function(){t.end();})):t.flushSync());}function qW(t){return function(r,n,i={},s){if(typeof i=="string")s=Su({dest:i}),i={};else if(typeof s=="string"){if(i&&i.transport)throw Error("only one of option.transport or stream can be specified");s=Su({dest:s});}else if(i instanceof Ch||i.writable||i._writableState)s=i,i={};else if(i.transport){if(i.transport instanceof Ch||i.transport.writable||i.transport._writableState)throw Error("option.transport do not allow stream, please pass to option directly. e.g. pino(transport)");if(i.transport.targets&&i.transport.targets.length&&i.formatters&&typeof i.formatters.level=="function")throw Error("option.transport.targets do not allow custom level formatters");let l;i.customLevels&&(l=i.useOnlyCustomLevels?i.customLevels:Object.assign({},i.levels,i.customLevels)),s=DW({caller:n,...i.transport,levels:l});}if(i=Object.assign({},t,i),i.serializers=Object.assign({},t.serializers,i.serializers),i.formatters=Object.assign({},t.formatters,i.formatters),i.prettyPrint)throw new Error("prettyPrint option is no longer supported, see the pino-pretty package (https://github.com/pinojs/pino-pretty)");let{enabled:o,onChild:a}=i;return o===!1&&(i.level="silent"),a||(i.onChild=Vi),s||(MW(process.stdout)?s=process.stdout:s=Su({fd:process.stdout.fd||1})),{opts:i,stream:s}}}function LW(t,e){try{return JSON.stringify(t)}catch{try{return (e||this[xh])(t)}catch{return '"[unable to serialize, circular reference is too complex to analyze]"'}}}function $W(t,e,r){return {level:t,bindings:e,log:r}}function jW(t){let e=Number(t);return typeof t=="string"&&Number.isFinite(e)?e:t===void 0?1:t}xC.exports={noop:Vi,buildSafeSonicBoom:Su,asChindings:kW,asJson:IW,genLog:OW,createArgsNormalizer:qW,stringify:LW,buildFormatters:$W,normalizeDestFileDescriptor:jW};});var Ru=A((XV,AC)=>{var{lsCacheSym:HW,levelValSym:Th,useOnlyCustomLevelsSym:WW,streamSym:BW,formattersSym:UW,hooksSym:zW}=Ui(),{noop:VW,genLog:ni}=Eu(),Mr={trace:10,debug:20,info:30,warn:40,error:50,fatal:60},TC={fatal:t=>{let e=ni(Mr.fatal,t);return function(...r){let n=this[BW];if(e.call(this,...r),typeof n.flushSync=="function")try{n.flushSync();}catch{}}},error:t=>ni(Mr.error,t),warn:t=>ni(Mr.warn,t),info:t=>ni(Mr.info,t),debug:t=>ni(Mr.debug,t),trace:t=>ni(Mr.trace,t)},Ah=Object.keys(Mr).reduce((t,e)=>(t[Mr[e]]=e,t),{}),GW=Object.keys(Ah).reduce((t,e)=>(t[e]='{"level":'+Number(e),t),{});function KW(t){let e=t[UW].level,{labels:r}=t.levels,n={};for(let i in r){let s=e(r[i],Number(i));n[i]=JSON.stringify(s).slice(0,-1);}return t[HW]=n,t}function ZW(t,e){if(e)return !1;switch(t){case"fatal":case"error":case"warn":case"info":case"debug":case"trace":return !0;default:return !1}}function JW(t){let{labels:e,values:r}=this.levels;if(typeof t=="number"){if(e[t]===void 0)throw Error("unknown level value"+t);t=e[t];}if(r[t]===void 0)throw Error("unknown level "+t);let n=this[Th],i=this[Th]=r[t],s=this[WW],o=this[zW].logMethod;for(let a in r){if(i>r[a]){this[a]=VW;continue}this[a]=ZW(a,s)?TC[a](o):ni(r[a],o);}this.emit("level-change",t,i,e[n],n,this);}function YW(t){let{levels:e,levelVal:r}=this;return e&&e.labels?e.labels[r]:""}function XW(t){let{values:e}=this.levels,r=e[t];return r!==void 0&&r>=this[Th]}function QW(t=null,e=!1){let r=t?Object.keys(t).reduce((s,o)=>(s[t[o]]=o,s),{}):null,n=Object.assign(Object.create(Object.prototype,{Infinity:{value:"silent"}}),e?null:Ah,r),i=Object.assign(Object.create(Object.prototype,{silent:{value:1/0}}),e?null:Mr,t);return {labels:n,values:i}}function eB(t,e,r){if(typeof t=="number"){if(![].concat(Object.keys(e||{}).map(s=>e[s]),r?[]:Object.keys(Ah).map(s=>+s),1/0).includes(t))throw Error(`default level:${t} must be included in custom levels`);return}let n=Object.assign(Object.create(Object.prototype,{silent:{value:1/0}}),r?null:Mr,e);if(!(t in n))throw Error(`default level:${t} must be included in custom levels`)}function tB(t,e){let{labels:r,values:n}=t;for(let i in e){if(i in n)throw Error("levels cannot be overridden");if(e[i]in r)throw Error("pre-existing level values cannot be used for new levels")}}AC.exports={initialLsCache:GW,genLsCache:KW,levelMethods:TC,getLevel:YW,setLevel:JW,isLevelEnabled:XW,mappings:QW,levels:Mr,assertNoLevelCollisions:tB,assertDefaultLevelFound:eB};});var Ph=A((QV,PC)=>{PC.exports={version:"8.17.1"};});var jC=A((t8,$C)=>{var{EventEmitter:rB}=oe("events"),{lsCacheSym:nB,levelValSym:iB,setLevelSym:Oh,getLevelSym:DC,chindingsSym:Ih,parsedChindingsSym:sB,mixinSym:oB,asJsonSym:FC,writeSym:aB,mixinMergeStrategySym:uB,timeSym:cB,timeSliceIndexSym:lB,streamSym:NC,serializersSym:ii,formattersSym:Dh,errorKeySym:fB,messageKeySym:dB,useOnlyCustomLevelsSym:hB,needsMetadataGsym:pB,redactFmtSym:mB,stringifySym:gB,formatOptsSym:_B,stringifiersSym:yB,msgPrefixSym:OC}=Ui(),{getLevel:bB,setLevel:vB,isLevelEnabled:wB,mappings:SB,initialLsCache:EB,genLsCache:RB,assertNoLevelCollisions:CB}=Ru(),{asChindings:qC,asJson:xB,buildFormatters:IC,stringify:kC}=Eu(),{version:TB}=Ph(),AB=fh(),PB=class{},LC={constructor:PB,child:DB,bindings:OB,setBindings:IB,flush:NB,isLevelEnabled:wB,version:TB,get level(){return this[DC]()},set level(t){this[Oh](t);},get levelVal(){return this[iB]},set levelVal(t){throw Error("levelVal is read-only")},[nB]:EB,[aB]:MB,[FC]:xB,[DC]:bB,[Oh]:vB};Object.setPrototypeOf(LC,rB.prototype);$C.exports=function(){return Object.create(LC)};var MC=t=>t;function DB(t,e){if(!t)throw Error("missing bindings for child Pino");e=e||{};let r=this[ii],n=this[Dh],i=Object.create(this);if(e.hasOwnProperty("serializers")===!0){i[ii]=Object.create(null);for(let c in r)i[ii][c]=r[c];let l=Object.getOwnPropertySymbols(r);for(var s=0;s<l.length;s++){let c=l[s];i[ii][c]=r[c];}for(let c in e.serializers)i[ii][c]=e.serializers[c];let d=Object.getOwnPropertySymbols(e.serializers);for(var o=0;o<d.length;o++){let c=d[o];i[ii][c]=e.serializers[c];}}else i[ii]=r;if(e.hasOwnProperty("formatters")){let{level:l,bindings:d,log:c}=e.formatters;i[Dh]=IC(l||n.level,d||MC,c||n.log);}else i[Dh]=IC(n.level,MC,n.log);if(e.hasOwnProperty("customLevels")===!0&&(CB(this.levels,e.customLevels),i.levels=SB(e.customLevels,i[hB]),RB(i)),typeof e.redact=="object"&&e.redact!==null||Array.isArray(e.redact)){i.redact=e.redact;let l=AB(i.redact,kC),d={stringify:l[mB]};i[gB]=kC,i[yB]=l,i[_B]=d;}typeof e.msgPrefix=="string"&&(i[OC]=(this[OC]||"")+e.msgPrefix),i[Ih]=qC(i,t);let a=e.level||this.level;return i[Oh](a),this.onChild(i),i}function OB(){let e=`{${this[Ih].substr(1)}}`,r=JSON.parse(e);return delete r.pid,delete r.hostname,r}function IB(t){let e=qC(this,t);this[Ih]=e,delete this[sB];}function kB(t,e){return Object.assign(e,t)}function MB(t,e,r){let n=this[cB](),i=this[oB],s=this[fB],o=this[dB],a=this[uB]||kB,l;t==null?l={}:t instanceof Error?(l={[s]:t},e===void 0&&(e=t.message)):(l=t,e===void 0&&t[o]===void 0&&t[s]&&(e=t[s].message)),i&&(l=a(l,i(l,r,this)));let d=this[FC](l,e,r,n),c=this[NC];c[pB]===!0&&(c.lastLevel=r,c.lastObj=l,c.lastMsg=e,c.lastTime=n.slice(this[lB]),c.lastLogger=this),c.write(d);}function FB(){}function NB(t){if(t!=null&&typeof t!="function")throw Error("callback must be a function");let e=this[NC];typeof e.flush=="function"?e.flush(t||FB):t&&t();}});var zC=A((Nh,UC)=>{var{hasOwnProperty:Cu}=Object.prototype,oi=Fh();oi.configure=Fh;oi.stringify=oi;oi.default=oi;Nh.stringify=oi;Nh.configure=Fh;UC.exports=oi;var qB=/[\u0000-\u001f\u0022\u005c\ud800-\udfff]|[\ud800-\udbff](?![\udc00-\udfff])|(?:[^\ud800-\udbff]|^)[\udc00-\udfff]/;function xn(t){return t.length<5e3&&!qB.test(t)?`"${t}"`:JSON.stringify(t)}function kh(t){if(t.length>200)return t.sort();for(let e=1;e<t.length;e++){let r=t[e],n=e;for(;n!==0&&t[n-1]>r;)t[n]=t[n-1],n--;t[n]=r;}return t}var LB=Object.getOwnPropertyDescriptor(Object.getPrototypeOf(Object.getPrototypeOf(new Int8Array)),Symbol.toStringTag).get;function Mh(t){return LB.call(t)!==void 0&&t.length!==0}function HC(t,e,r){t.length<r&&(r=t.length);let n=e===","?"":" ",i=`"0":${n}${t[0]}`;for(let s=1;s<r;s++)i+=`${e}"${s}":${n}${t[s]}`;return i}function $B(t){if(Cu.call(t,"circularValue")){let e=t.circularValue;if(typeof e=="string")return `"${e}"`;if(e==null)return e;if(e===Error||e===TypeError)return {toString(){throw new TypeError("Converting circular structure to JSON")}};throw new TypeError('The "circularValue" argument must be of type string or the value null or undefined')}return '"[Circular]"'}function WC(t,e){let r;if(Cu.call(t,e)&&(r=t[e],typeof r!="boolean"))throw new TypeError(`The "${e}" argument must be of type boolean`);return r===void 0?!0:r}function BC(t,e){let r;if(Cu.call(t,e)){if(r=t[e],typeof r!="number")throw new TypeError(`The "${e}" argument must be of type number`);if(!Number.isInteger(r))throw new TypeError(`The "${e}" argument must be an integer`);if(r<1)throw new RangeError(`The "${e}" argument must be >= 1`)}return r===void 0?1/0:r}function si(t){return t===1?"1 item":`${t} items`}function jB(t){let e=new Set;for(let r of t)(typeof r=="string"||typeof r=="number")&&e.add(String(r));return e}function HB(t){if(Cu.call(t,"strict")){let e=t.strict;if(typeof e!="boolean")throw new TypeError('The "strict" argument must be of type boolean');if(e)return r=>{let n=`Object can not safely be stringified. Received type ${typeof r}`;throw typeof r!="function"&&(n+=` (${r.toString()})`),new Error(n)}}}function Fh(t){t={...t};let e=HB(t);e&&(t.bigint===void 0&&(t.bigint=!1),"circularValue"in t||(t.circularValue=Error));let r=$B(t),n=WC(t,"bigint"),i=WC(t,"deterministic"),s=BC(t,"maximumDepth"),o=BC(t,"maximumBreadth");function a(m,_,w,E,P,D){let g=_[m];switch(typeof g=="object"&&g!==null&&typeof g.toJSON=="function"&&(g=g.toJSON(m)),g=E.call(_,m,g),typeof g){case"string":return xn(g);case"object":{if(g===null)return "null";if(w.indexOf(g)!==-1)return r;let S="",I=",",L=D;if(Array.isArray(g)){if(g.length===0)return "[]";if(s<w.length+1)return '"[Array]"';w.push(g),P!==""&&(D+=P,S+=`
${D}`,I=`,
${D}`);let N=Math.min(g.length,o),te=0;for(;te<N-1;te++){let ye=a(String(te),g,w,E,P,D);S+=ye!==void 0?ye:"null",S+=I;}let ae=a(String(te),g,w,E,P,D);if(S+=ae!==void 0?ae:"null",g.length-1>o){let ye=g.length-o-1;S+=`${I}"... ${si(ye)} not stringified"`;}return P!==""&&(S+=`
${L}`),w.pop(),`[${S}]`}let Z=Object.keys(g),K=Z.length;if(K===0)return "{}";if(s<w.length+1)return '"[Object]"';let U="",B="";P!==""&&(D+=P,I=`,
${D}`,U=" ");let Q=Math.min(K,o);i&&!Mh(g)&&(Z=kh(Z)),w.push(g);for(let N=0;N<Q;N++){let te=Z[N],ae=a(te,g,w,E,P,D);ae!==void 0&&(S+=`${B}${xn(te)}:${U}${ae}`,B=I);}if(K>o){let N=K-o;S+=`${B}"...":${U}"${si(N)} not stringified"`,B=I;}return P!==""&&B.length>1&&(S=`
${D}${S}
${L}`),w.pop(),`{${S}}`}case"number":return isFinite(g)?String(g):e?e(g):"null";case"boolean":return g===!0?"true":"false";case"undefined":return;case"bigint":if(n)return String(g);default:return e?e(g):void 0}}function l(m,_,w,E,P,D){switch(typeof _=="object"&&_!==null&&typeof _.toJSON=="function"&&(_=_.toJSON(m)),typeof _){case"string":return xn(_);case"object":{if(_===null)return "null";if(w.indexOf(_)!==-1)return r;let g=D,S="",I=",";if(Array.isArray(_)){if(_.length===0)return "[]";if(s<w.length+1)return '"[Array]"';w.push(_),P!==""&&(D+=P,S+=`
${D}`,I=`,
${D}`);let K=Math.min(_.length,o),U=0;for(;U<K-1;U++){let Q=l(String(U),_[U],w,E,P,D);S+=Q!==void 0?Q:"null",S+=I;}let B=l(String(U),_[U],w,E,P,D);if(S+=B!==void 0?B:"null",_.length-1>o){let Q=_.length-o-1;S+=`${I}"... ${si(Q)} not stringified"`;}return P!==""&&(S+=`
${g}`),w.pop(),`[${S}]`}w.push(_);let L="";P!==""&&(D+=P,I=`,
${D}`,L=" ");let Z="";for(let K of E){let U=l(K,_[K],w,E,P,D);U!==void 0&&(S+=`${Z}${xn(K)}:${L}${U}`,Z=I);}return P!==""&&Z.length>1&&(S=`
${D}${S}
${g}`),w.pop(),`{${S}}`}case"number":return isFinite(_)?String(_):e?e(_):"null";case"boolean":return _===!0?"true":"false";case"undefined":return;case"bigint":if(n)return String(_);default:return e?e(_):void 0}}function d(m,_,w,E,P){switch(typeof _){case"string":return xn(_);case"object":{if(_===null)return "null";if(typeof _.toJSON=="function"){if(_=_.toJSON(m),typeof _!="object")return d(m,_,w,E,P);if(_===null)return "null"}if(w.indexOf(_)!==-1)return r;let D=P;if(Array.isArray(_)){if(_.length===0)return "[]";if(s<w.length+1)return '"[Array]"';w.push(_),P+=E;let U=`
${P}`,B=`,
${P}`,Q=Math.min(_.length,o),N=0;for(;N<Q-1;N++){let ae=d(String(N),_[N],w,E,P);U+=ae!==void 0?ae:"null",U+=B;}let te=d(String(N),_[N],w,E,P);if(U+=te!==void 0?te:"null",_.length-1>o){let ae=_.length-o-1;U+=`${B}"... ${si(ae)} not stringified"`;}return U+=`
${D}`,w.pop(),`[${U}]`}let g=Object.keys(_),S=g.length;if(S===0)return "{}";if(s<w.length+1)return '"[Object]"';P+=E;let I=`,
${P}`,L="",Z="",K=Math.min(S,o);Mh(_)&&(L+=HC(_,I,o),g=g.slice(_.length),K-=_.length,Z=I),i&&(g=kh(g)),w.push(_);for(let U=0;U<K;U++){let B=g[U],Q=d(B,_[B],w,E,P);Q!==void 0&&(L+=`${Z}${xn(B)}: ${Q}`,Z=I);}if(S>o){let U=S-o;L+=`${Z}"...": "${si(U)} not stringified"`,Z=I;}return Z!==""&&(L=`
${P}${L}
${D}`),w.pop(),`{${L}}`}case"number":return isFinite(_)?String(_):e?e(_):"null";case"boolean":return _===!0?"true":"false";case"undefined":return;case"bigint":if(n)return String(_);default:return e?e(_):void 0}}function c(m,_,w){switch(typeof _){case"string":return xn(_);case"object":{if(_===null)return "null";if(typeof _.toJSON=="function"){if(_=_.toJSON(m),typeof _!="object")return c(m,_,w);if(_===null)return "null"}if(w.indexOf(_)!==-1)return r;let E="";if(Array.isArray(_)){if(_.length===0)return "[]";if(s<w.length+1)return '"[Array]"';w.push(_);let I=Math.min(_.length,o),L=0;for(;L<I-1;L++){let K=c(String(L),_[L],w);E+=K!==void 0?K:"null",E+=",";}let Z=c(String(L),_[L],w);if(E+=Z!==void 0?Z:"null",_.length-1>o){let K=_.length-o-1;E+=`,"... ${si(K)} not stringified"`;}return w.pop(),`[${E}]`}let P=Object.keys(_),D=P.length;if(D===0)return "{}";if(s<w.length+1)return '"[Object]"';let g="",S=Math.min(D,o);Mh(_)&&(E+=HC(_,",",o),P=P.slice(_.length),S-=_.length,g=","),i&&(P=kh(P)),w.push(_);for(let I=0;I<S;I++){let L=P[I],Z=c(L,_[L],w);Z!==void 0&&(E+=`${g}${xn(L)}:${Z}`,g=",");}if(D>o){let I=D-o;E+=`${g}"...":"${si(I)} not stringified"`;}return w.pop(),`{${E}}`}case"number":return isFinite(_)?String(_):e?e(_):"null";case"boolean":return _===!0?"true":"false";case"undefined":return;case"bigint":if(n)return String(_);default:return e?e(_):void 0}}function p(m,_,w){if(arguments.length>1){let E="";if(typeof w=="number"?E=" ".repeat(Math.min(w,10)):typeof w=="string"&&(E=w.slice(0,10)),_!=null){if(typeof _=="function")return a("",{"":m},[],_,E,"");if(Array.isArray(_))return l("",m,[],jB(_),E,"")}if(E.length!==0)return d("",m,[],E,"")}return c("",m,[])}return p}});var KC=A((r8,GC)=>{var qh=Symbol.for("pino.metadata"),{levels:VC}=Ru(),WB=VC.info;function BB(t,e){let r=0;t=t||[],e=e||{dedupe:!1};let n=Object.create(VC);n.silent=1/0,e.levels&&typeof e.levels=="object"&&Object.keys(e.levels).forEach(c=>{n[c]=e.levels[c];});let i={write:s,add:a,flushSync:o,end:l,minLevel:0,streams:[],clone:d,[qh]:!0,streamLevels:n};return Array.isArray(t)?t.forEach(a,i):a.call(i,t),t=null,i;function s(c){let p,m=this.lastLevel,{streams:_}=this,w=0,E;for(let P=zB(_.length,e.dedupe);GB(P,_.length,e.dedupe);P=VB(P,e.dedupe))if(p=_[P],p.level<=m){if(w!==0&&w!==p.level)break;if(E=p.stream,E[qh]){let{lastTime:D,lastMsg:g,lastObj:S,lastLogger:I}=this;E.lastLevel=m,E.lastTime=D,E.lastMsg=g,E.lastObj=S,E.lastLogger=I;}E.write(c),e.dedupe&&(w=p.level);}else if(!e.dedupe)break}function o(){for(let{stream:c}of this.streams)typeof c.flushSync=="function"&&c.flushSync();}function a(c){if(!c)return i;let p=typeof c.write=="function"||c.stream,m=c.write?c:c.stream;if(!p)throw Error("stream object needs to implement either StreamEntry or DestinationStream interface");let{streams:_,streamLevels:w}=this,E;typeof c.levelVal=="number"?E=c.levelVal:typeof c.level=="string"?E=w[c.level]:typeof c.level=="number"?E=c.level:E=WB;let P={stream:m,level:E,levelVal:void 0,id:r++};return _.unshift(P),_.sort(UB),this.minLevel=_[0].level,i}function l(){for(let{stream:c}of this.streams)typeof c.flushSync=="function"&&c.flushSync(),c.end();}function d(c){let p=new Array(this.streams.length);for(let m=0;m<p.length;m++)p[m]={level:c,stream:this.streams[m].stream};return {write:s,add:a,minLevel:c,streams:p,clone:d,flushSync:o,[qh]:!0}}}function UB(t,e){return t.level-e.level}function zB(t,e){return e?t-1:0}function VB(t,e){return e?t-1:t+1}function GB(t,e,r){return r?t>=0:t<e}GC.exports=BB;});var ax=A((n8,yr)=>{var KB=oe("os"),rx=nh(),ZB=ih(),JB=fh(),nx=BR(),YB=jC(),ix=Ui(),{configure:XB}=zC(),{assertDefaultLevelFound:QB,mappings:sx,genLsCache:eU,levels:tU}=Ru(),{createArgsNormalizer:rU,asChindings:nU,buildSafeSonicBoom:ZC,buildFormatters:iU,stringify:Lh,normalizeDestFileDescriptor:JC,noop:sU}=Eu(),{version:oU}=Ph(),{chindingsSym:YC,redactFmtSym:aU,serializersSym:XC,timeSym:uU,timeSliceIndexSym:cU,streamSym:lU,stringifySym:QC,stringifySafeSym:$h,stringifiersSym:ex,setLevelSym:fU,endSym:dU,formatOptsSym:hU,messageKeySym:pU,errorKeySym:mU,nestedKeySym:gU,mixinSym:_U,useOnlyCustomLevelsSym:yU,formattersSym:tx,hooksSym:bU,nestedKeyStrSym:vU,mixinMergeStrategySym:wU,msgPrefixSym:SU}=ix,{epochTime:ox,nullTime:EU}=nx,{pid:RU}=process,CU=KB.hostname(),xU=rx.err,TU={level:"info",levels:tU,messageKey:"msg",errorKey:"err",nestedKey:null,enabled:!0,base:{pid:RU,hostname:CU},serializers:Object.assign(Object.create(null),{err:xU}),formatters:Object.assign(Object.create(null),{bindings(t){return t},level(t,e){return {level:e}}}),hooks:{logMethod:void 0},timestamp:ox,name:void 0,redact:null,customLevels:null,useOnlyCustomLevels:!1,depthLimit:5,edgeLimit:100},AU=rU(TU),PU=Object.assign(Object.create(null),rx);function jh(...t){let e={},{opts:r,stream:n}=AU(e,ZB(),...t),{redact:i,crlf:s,serializers:o,timestamp:a,messageKey:l,errorKey:d,nestedKey:c,base:p,name:m,level:_,customLevels:w,mixin:E,mixinMergeStrategy:P,useOnlyCustomLevels:D,formatters:g,hooks:S,depthLimit:I,edgeLimit:L,onChild:Z,msgPrefix:K}=r,U=XB({maximumDepth:I,maximumBreadth:L}),B=iU(g.level,g.bindings,g.log),Q=Lh.bind({[$h]:U}),N=i?JB(i,Q):{},te=i?{stringify:N[aU]}:{stringify:Q},ae="}"+(s?`\r
`:`
`),ye=nU.bind(null,{[YC]:"",[XC]:o,[ex]:N,[QC]:Lh,[$h]:U,[tx]:B}),q="";p!==null&&(m===void 0?q=ye(p):q=ye(Object.assign({},p,{name:m})));let W=a instanceof Function?a:a?ox:EU,me=W().indexOf(":")+1;if(D&&!w)throw Error("customLevels is required if useOnlyCustomLevels is set true");if(E&&typeof E!="function")throw Error(`Unknown mixin type "${typeof E}" - expected "function"`);if(K&&typeof K!="string")throw Error(`Unknown msgPrefix type "${typeof K}" - expected "string"`);QB(_,w,D);let pe=sx(w,D);return Object.assign(e,{levels:pe,[yU]:D,[lU]:n,[uU]:W,[cU]:me,[QC]:Lh,[$h]:U,[ex]:N,[dU]:ae,[hU]:te,[pU]:l,[mU]:d,[gU]:c,[vU]:c?`,${JSON.stringify(c)}:{`:"",[XC]:o,[_U]:E,[wU]:P,[YC]:q,[tx]:B,[bU]:S,silent:sU,onChild:Z,[SU]:K}),Object.setPrototypeOf(e,YB()),eU(e),e[fU](_),e}yr.exports=jh;yr.exports.destination=(t=process.stdout.fd)=>typeof t=="object"?(t.dest=JC(t.dest||process.stdout.fd),ZC(t)):ZC({dest:JC(t),minLength:0});yr.exports.transport=Eh();yr.exports.multistream=KC();yr.exports.levels=sx();yr.exports.stdSerializers=PU;yr.exports.stdTimeFunctions=Object.assign({},nx);yr.exports.symbols=ix;yr.exports.version=oU;yr.exports.default=jh;yr.exports.pino=jh;});var co=A(Tn=>{Object.defineProperty(Tn,"__esModule",{value:!0});Tn.Frequency=Tn.KeepLogFiles=void 0;(function(t){t[t.days=1]="days",t[t.fileCount=2]="fileCount";})(Tn.KeepLogFiles||(Tn.KeepLogFiles={}));(function(t){t[t.daily=1]="daily",t[t.minutes=2]="minutes",t[t.hours=3]="hours",t[t.date=4]="date",t[t.none=5]="none";})(Tn.Frequency||(Tn.Frequency={}));});var cx=A(Wh=>{Object.defineProperty(Wh,"__esModule",{value:!0});var ux=co(),Hh=class{static fileStreamRotatorOptions(e){return Object.assign(Object.assign({},{filename:"",verbose:!1,end_stream:!1,utc:!1,create_symlink:!1,symlink_name:"current.log"}),e)}static fileOptions(e){return Object.assign(Object.assign({},{flags:"a"}),e)}static auditSettings(e){let r={keepSettings:{type:ux.KeepLogFiles.fileCount,amount:10},auditFilename:"audit.json",hashType:"md5",extension:"",files:[]};return Object.assign(Object.assign({},r),e)}static rotationSettings(e){let r={filename:"",frequency:ux.Frequency.none,utc:!1};return Object.assign(Object.assign({},r),e)}static extractParam(e,r=!0){let n=e.toString().match(/(\w)$/),i={number:0};n?.length==2&&(i.letter=n[1].toLowerCase());let s=e.toString().match(/^(\d+)/);return s?.length==2&&(i.number=Number(s[1])),i}};Wh.default=Hh;});var xu=A(Gi=>{Object.defineProperty(Gi,"__esModule",{value:!0});Gi.Logger=Gi.makeDirectory=void 0;var IU=oe("fs"),kU=oe("path");function MU(t){if(t.trim()!==""){var e=kU.dirname(t);try{IU.mkdirSync(e,{recursive:!0});}catch(r){if(r.code!=="EEXIST")throw r}}}Gi.makeDirectory=MU;var Bh=class t{constructor(){this.isVerbose=!1,this.allowDebug=!1;}static getInstance(e,r){return t.instance||(t.instance=new t,t.instance.isVerbose=e??!1,t.instance.allowDebug=r??!1),t.instance}static verbose(...e){t.getInstance().isVerbose&&console.log.apply(null,[new Date,"[FileStreamRotator:VERBOSE]",...e]);}static log(...e){console.log.apply(null,[new Date,"[FileStreamRotator]",...e]);}static debug(...e){t.getInstance().allowDebug&&console.debug.apply(null,[new Date,"[FileStreamRotator:DEBUG]",...e]);}};Gi.Logger=Bh;});var fx=A(zh=>{Object.defineProperty(zh,"__esModule",{value:!0});var lx=oe("fs"),ur=co(),ai=xu(),Uh=class t{constructor(e,r){var n;switch(this.currentSize=0,this.lastDate="",this.fileIndx=0,this.settings=e,this.settings.frequency){case ur.Frequency.hours:this.settings.amount&&this.settings.amount<13?this.settings.amount&&this.settings.amount>0||(this.settings.amount=1):this.settings.amount=12,this.isFormatValidForHour()||(ai.Logger.log("Date format not suitable for X hours rotation. Changing date format to 'YMDHm'"),this.settings.format="YMDHm");break;case ur.Frequency.minutes:this.settings.amount&&this.settings.amount<31?this.settings.amount&&this.settings.amount>0||(this.settings.amount=1):this.settings.amount=30,this.isFormatValidForMinutes()||(this.settings.format="YMDHm",ai.Logger.log("Date format not suitable for X minutes rotation. Changing date format to 'YMDHm'"));break;case ur.Frequency.daily:this.isFormatValidForDaily()||(this.settings.format="YMD",ai.Logger.log("Date format not suitable for daily rotation. Changing date format to 'YMD'"));break}if(this.settings.frequency!==ur.Frequency.none&&!this.settings.filename.match("%DATE%")&&(this.settings.filename+=".%DATE%",ai.Logger.log("Appending date to the end of the filename")),this.lastDate=this.getDateString(),this.settings.maxSize&&r){let s=new Date(r.date),o=(n=this.settings.extension)!==null&&n!==void 0?n:"";if(ai.Logger.debug(this.getDateString(s)==this.getDateString(new Date),this.getDateString(s),this.getDateString(new Date)),this.getDateString(s)==this.getDateString(new Date)){let a=r.name.match(RegExp("(\\d+)"+o.replace(/[.*+?^${}()|[\]\\]/g,"\\$&")));a&&(this.fileIndx=Number(a[1]));var i=this.getSizeForFile(this.getNewFilename());i&&(this.currentSize=i),this.lastDate=this.getDateString(s),ai.Logger.debug("LOADED LAST ENTRY",this.currentSize,this.lastDate,this.fileIndx);}else {var i=this.getSizeForFile(this.getNewFilename());i&&(this.currentSize=i),ai.Logger.debug("CURRENT FILE:",this.getNewFilename(),this.currentSize);}}}getSizeForFile(e){try{if(lx.existsSync(e)){var r=lx.statSync(this.getNewFilename());if(r)return r.size}}catch{return}}hasMaxSizeReached(){return this.settings.maxSize?this.currentSize>this.settings.maxSize:!1}shouldRotate(){let e=this.hasMaxSizeReached();switch(this.settings.frequency){case ur.Frequency.none:return e;case ur.Frequency.hours:case ur.Frequency.minutes:case ur.Frequency.date:case ur.Frequency.daily:default:let r=this.getDateString();return this.lastDate!=r?!0:e}}isFormatValidForDaily(){let e=new Date(2022,2,20,1,2,3),r=new Date(2022,2,20,23,55,45),n=new Date(2022,2,21,2,55,45);return this.getDateString(e)===this.getDateString(r)&&this.getDateString(e)!==this.getDateString(n)}isFormatValidForHour(){if(!this.settings.amount||this.settings.frequency!=ur.Frequency.hours)return !1;let e=new Date(2022,2,20,1,2,3),r=new Date(2022,2,20,2+this.settings.amount,55,45);return this.getDateString(e)!==this.getDateString(r)}isFormatValidForMinutes(){if(!this.settings.amount||this.settings.frequency!=ur.Frequency.minutes)return !1;let e=new Date(2022,2,20,1,2,3),r=new Date(2022,2,20,1,2+this.settings.amount,45);return this.getDateString(e)!==this.getDateString(r)}getDateString(e){let r=e||new Date,n=t.getDateComponents(r,this.settings.utc),i=this.settings.format;if(i){switch(this.settings.frequency){case ur.Frequency.hours:if(this.settings.amount){var s=Math.floor(n.hour/this.settings.amount)*this.settings.amount;n.hour=s,n.minute=0,n.second=0;}case ur.Frequency.minutes:if(this.settings.amount){var o=Math.floor(n.minute/this.settings.amount)*this.settings.amount;n.minute=o,n.second=0;}}return i?.replace(/D+/,n.day.toString().padStart(2,"0")).replace(/M+/,n.month.toString().padStart(2,"0")).replace(/Y+/,n.year.toString()).replace(/H+/,n.hour.toString().padStart(2,"0")).replace(/m+/,n.minute.toString().padStart(2,"0")).replace(/s+/,n.second.toString().padStart(2,"0")).replace(/A+/,n.hour>11?"PM":"AM")}return ""}getFilename(e,r){return e.replace("%DATE%",this.lastDate)+(this.settings.maxSize||this.fileIndx>0?"."+this.fileIndx:"")+(r||"")}getNewFilename(){return this.getFilename(this.settings.filename,this.settings.extension)}addBytes(e){this.currentSize+=e;}rotate(e=!1){return e?(this.fileIndx+=1,this.currentSize=0,this.lastDate=this.getDateString()):this.shouldRotate()&&(this.hasMaxSizeReached()?this.fileIndx+=1:this.fileIndx=0,this.currentSize=0,this.lastDate=this.getDateString()),this.getNewFilename()}static getDateComponents(e,r){return r?{day:e.getUTCDate(),month:e.getUTCMonth()+1,year:e.getUTCFullYear(),hour:e.getUTCHours(),minute:e.getUTCMinutes(),second:e.getUTCSeconds(),utc:r,source:e}:{day:e.getDate(),month:e.getMonth()+1,year:e.getFullYear(),hour:e.getHours(),minute:e.getMinutes(),second:e.getSeconds(),utc:r,source:e}}static createDate(e,r){return new Date(e.year,e.month,e.day,e.hour,e.minute,e.second)}};zh.default=Uh;});var dx=A(Kh=>{Object.defineProperty(Kh,"__esModule",{value:!0});var Tu=oe("fs"),FU=oe("path"),NU=co(),Vr=xu(),Vh=oe("crypto"),Gh=class{constructor(e,r){this.config=e,this.emitter=r,this.loadLog();}loadLog(){var e;if(!this.config.keepSettings||((e=this.config.keepSettings)===null||e===void 0?void 0:e.amount)==0||!this.config.auditFilename||this.config.auditFilename==""){Vr.Logger.verbose("no existing audit settings found",this.config);return}try{let r=FU.resolve(this.config.auditFilename),n=JSON.parse(Tu.readFileSync(r,{encoding:"utf-8"}));this.config.files=n.files;}catch(r){if(r.code!=="ENOENT"){Vr.Logger.log("Failed to load config file",r);return}}}writeLog(){if(this.config.auditFilename)try{(0, Vr.makeDirectory)(this.config.auditFilename),Tu.writeFileSync(this.config.auditFilename,JSON.stringify(this.config,null,4));}catch(e){Vr.Logger.verbose("ERROR: Failed to store log audit",e);}}addLog(e){var r;if(!this.config.keepSettings||((r=this.config.keepSettings)===null||r===void 0?void 0:r.amount)==0||!this.config.auditFilename||this.config.auditFilename==""){Vr.Logger.verbose("audit log missing");return}if(this.config.files.findIndex(s=>s.name===e)!==-1){Vr.Logger.debug("file already in the log",e);return}var n=Date.now();if(this.config.files.push({date:n,name:e,hash:Vh.createHash(this.config.hashType).update(e+"LOG_FILE"+n).digest("hex")}),Vr.Logger.debug(`added file ${e} to log`),this.config.keepSettings&&this.config.keepSettings.amount){if(this.config.keepSettings.type==NU.KeepLogFiles.days){let s=Date.now()-86400*this.config.keepSettings.amount*1e3,o=this.config.files.filter(a=>{if(a.date>=s)return !0;this.removeLog(a);});this.config.files=o;}else if(this.config.files.length>this.config.keepSettings.amount){var i=this.config.files.splice(-this.config.keepSettings.amount);this.config.files.length>0&&this.config.files.filter(s=>(this.removeLog(s),!1)),this.config.files=i;}}this.writeLog();}removeLog(e){if(e.hash===Vh.createHash(this.config.hashType).update(e.name+"LOG_FILE"+e.date).digest("hex"))try{Tu.existsSync(e.name)&&(Vr.Logger.debug("removing log file",e.name),Tu.unlinkSync(e.name),this.emitter.emit("logRemoved",e.name));}catch{Vr.Logger.verbose("Could not remove old log file: ",e.name);}else Vr.Logger.debug("incorrect hash",e.name,e.hash,Vh.createHash(this.config.hashType).update(e.name+"LOG_FILE"+e.date).digest("hex"));}};Kh.default=Gh;});var px=A(Yh=>{Object.defineProperty(Yh,"__esModule",{value:!0});var qU=oe("stream"),Ki=oe("fs"),Zh=oe("path"),an=co(),un=cx(),hx=fx(),LU=dx(),lo=xu(),Jh=class t extends qU.EventEmitter{constructor(e,r=!1){var n,i;super(),this.config={},this.config=this.parseOptions(e),lo.Logger.getInstance(e.verbose,r),this.auditManager=new LU.default((n=this.config.auditSettings)!==null&&n!==void 0?n:un.default.auditSettings({}),this);let s=this.auditManager.config.files.slice(-1).shift();this.rotator=new hx.default((i=this.config.rotationSettings)!==null&&i!==void 0?i:un.default.rotationSettings({}),s),this.rotate();}static getStream(e){return new t(e)}parseOptions(e){var r,n,i,s;let o={};o.options=un.default.fileStreamRotatorOptions(e),o.fileOptions=un.default.fileOptions((r=e.file_options)!==null&&r!==void 0?r:{});let a=un.default.auditSettings({});if(e.audit_file&&(a.auditFilename=e.audit_file),e.audit_hash_type&&(a.hashType=e.audit_hash_type),e.extension&&(a.extension=e.extension),e.max_logs){let d=un.default.extractParam(e.max_logs);a.keepSettings={type:((n=d.letter)===null||n===void 0?void 0:n.toLowerCase())=="d"?an.KeepLogFiles.days:an.KeepLogFiles.fileCount,amount:d.number};}switch(o.auditSettings=a,o.rotationSettings=un.default.rotationSettings({filename:e.filename,extension:e.extension}),e.date_format&&!e.frequency?o.rotationSettings.frequency=an.Frequency.date:o.rotationSettings.frequency=an.Frequency.none,e.date_format&&(o.rotationSettings.format=e.date_format),o.rotationSettings.utc=(i=e.utc)!==null&&i!==void 0?i:!1,e.frequency){case"daily":o.rotationSettings.frequency=an.Frequency.daily;break;case"custom":case"date":o.rotationSettings.frequency=an.Frequency.date;break;case"test":o.rotationSettings.frequency=an.Frequency.minutes,o.rotationSettings.amount=1;break;default:if(e.frequency){let d=un.default.extractParam(e.frequency);!((s=d.letter)===null||s===void 0)&&s.match(/^([mh])$/)&&(o.rotationSettings.frequency=d.letter=="h"?an.Frequency.hours:an.Frequency.minutes,o.rotationSettings.amount=d.number);}}if(e.size){let d=un.default.extractParam(e.size);switch(d.letter){case"k":o.rotationSettings.maxSize=d.number*1024;break;case"m":o.rotationSettings.maxSize=d.number*1024*1024;break;case"g":o.rotationSettings.maxSize=d.number*1024*1024*1024;break}}this.rotator=new hx.default(o.rotationSettings);this.rotator.getNewFilename();return o}rotate(e=!1){var r;let n=this.currentFile;this.rotator.rotate(e),this.currentFile=this.rotator.getNewFilename(),this.currentFile!=n&&(this.fs&&(((r=this.config.options)===null||r===void 0?void 0:r.end_stream)===!0?this.fs.end():this.fs.destroy()),n&&this.auditManager.addLog(n),this.createNewLog(this.currentFile),this.emit("new",this.currentFile),this.emit("rotate",n,this.currentFile,e));}createNewLog(e){var r;(0, lo.makeDirectory)(e),this.auditManager.addLog(e);let n={};this.config.fileOptions&&(n=this.config.fileOptions),this.fs=Ki.createWriteStream(e,n),this.bubbleEvents(this.fs,e),!((r=this.config.options)===null||r===void 0)&&r.create_symlink&&this.createCurrentSymLink(e);}write(e,r){this.fs&&(this.rotator.shouldRotate()&&this.rotate(),this.fs.write(e,r??"utf8"),this.rotator.addBytes(Buffer.byteLength(e,r)),this.rotator.hasMaxSizeReached()&&this.rotate());}end(e){this.fs&&(this.fs.end(e),this.fs=void 0);}bubbleEvents(e,r){e.on("close",()=>{this.emit("close");}),e.on("finish",()=>{this.emit("finish");}),e.on("error",n=>{this.emit("error",n);}),e.on("open",n=>{this.emit("open",r);});}createCurrentSymLink(e){var r,n;if(!e)return;let i=(n=(r=this.config.options)===null||r===void 0?void 0:r.symlink_name)!==null&&n!==void 0?n:"current.log",s=Zh.dirname(e),o=Zh.basename(e),a=s+Zh.sep+i;try{if(Ki.existsSync(a)){if(Ki.lstatSync(a).isSymbolicLink()){Ki.unlinkSync(a),Ki.symlinkSync(o,a);return}lo.Logger.verbose("Could not create symlink file as file with the same name exists: ",a);}else Ki.symlinkSync(o,a);}catch(l){lo.Logger.verbose("[Could not create symlink file: ",a," -> ",o),lo.Logger.debug("error creating sym link",a,l);}}test(){return {config:this.config,rotator:this.rotator}}};Yh.default=Jh;});var mx=A(Au=>{Object.defineProperty(Au,"__esModule",{value:!0});Au.getStream=void 0;var $U=px();function jU(t){return new $U.default(t)}Au.getStream=jU;});var vx=A((R8,bx)=>{bx.exports=function(){function t(n,i){function s(){this.constructor=n;}s.prototype=i.prototype,n.prototype=new s;}function e(n,i,s,o,a,l){this.message=n,this.expected=i,this.found=s,this.offset=o,this.line=a,this.column=l,this.name="SyntaxError";}t(e,Error);function r(n){var i=arguments.length>1?arguments[1]:{},s={},o={start:xg},a=xg,d=function(){return zg},c=s,p="#",m={type:"literal",value:"#",description:'"#"'},_=void 0,w={type:"any",description:"any character"},E="[",P={type:"literal",value:"[",description:'"["'},D="]",g={type:"literal",value:"]",description:'"]"'},S=function(u){gl(Ct("ObjectPath",u,Et,Rt));},I=function(u){gl(Ct("ArrayPath",u,Et,Rt));},L=function(u,h){return u.concat(h)},Z=function(u){return [u]},K=function(u){return u},U=".",B={type:"literal",value:".",description:'"."'},Q="=",N={type:"literal",value:"=",description:'"="'},te=function(u,h){gl(Ct("Assign",h,Et,Rt,u));},ae=function(u){return u.join("")},ye=function(u){return u.value},q='"""',W={type:"literal",value:'"""',description:'"\\"\\"\\""'},me=null,pe=function(u){return Ct("String",u.join(""),Et,Rt)},we='"',Xe={type:"literal",value:'"',description:'"\\""'},Ke="'''",Pt={type:"literal",value:"'''",description:`"'''"`},Lr="'",zt={type:"literal",value:"'",description:`"'"`},St=function(u){return u},Ce=function(u){return u},Cr="\\",fn={type:"literal",value:"\\",description:'"\\\\"'},ce=function(){return ""},Me="e",ie={type:"literal",value:"e",description:'"e"'},be="E",$e={type:"literal",value:"E",description:'"E"'},ot=function(u,h){return Ct("Float",parseFloat(u+"e"+h),Et,Rt)},He=function(u){return Ct("Float",parseFloat(u),Et,Rt)},fr="+",Nt={type:"literal",value:"+",description:'"+"'},Hn=function(u){return u.join("")},qt="-",Vt={type:"literal",value:"-",description:'"-"'},Wn=function(u){return "-"+u.join("")},yi=function(u){return Ct("Integer",parseInt(u,10),Et,Rt)},tr="true",Bn={type:"literal",value:"true",description:'"true"'},Un=function(){return Ct("Boolean",!0,Et,Rt)},Yr="false",zn={type:"literal",value:"false",description:'"false"'},xr=function(){return Ct("Boolean",!1,Et,Rt)},k=function(){return Ct("Array",[],Et,Rt)},G=function(u){return Ct("Array",u?[u]:[],Et,Rt)},se=function(u){return Ct("Array",u,Et,Rt)},fe=function(u,h){return Ct("Array",u.concat(h),Et,Rt)},qe=function(u){return u},ke=",",ze={type:"literal",value:",",description:'","'},Ze="{",Te={type:"literal",value:"{",description:'"{"'},We="}",Ie={type:"literal",value:"}",description:'"}"'},et=function(u){return Ct("InlineTable",u,Et,Rt)},ut=function(u,h){return Ct("InlineTableValue",h,Et,Rt,u)},Lt=function(u){return "."+u},bi=function(u){return u.join("")},dn=":",hn={type:"literal",value:":",description:'":"'},Ss=function(u){return u.join("")},Es="T",No={type:"literal",value:"T",description:'"T"'},j="Z",v={type:"literal",value:"Z",description:'"Z"'},M=function(u,h){return Ct("Date",new Date(u+"T"+h+"Z"),Et,Rt)},F=function(u,h){return Ct("Date",new Date(u+"T"+h),Et,Rt)},R=/^[ \t]/,y={type:"class",value:"[ \\t]",description:"[ \\t]"},$=`
`,J={type:"literal",value:`
`,description:'"\\n"'},Ee="\r",tt={type:"literal",value:"\r",description:'"\\r"'},Ve=/^[0-9a-f]/i,rr={type:"class",value:"[0-9a-f]i",description:"[0-9a-f]i"},nr=/^[0-9]/,Tr={type:"class",value:"[0-9]",description:"[0-9]"},Pe="_",pn={type:"literal",value:"_",description:'"_"'},vi=function(){return ""},qo=/^[A-Za-z0-9_\-]/,L1={type:"class",value:"[A-Za-z0-9_\\-]",description:"[A-Za-z0-9_\\-]"},$1=function(u){return u.join("")},gg='\\"',j1={type:"literal",value:'\\"',description:'"\\\\\\""'},H1=function(){return '"'},_g="\\\\",W1={type:"literal",value:"\\\\",description:'"\\\\\\\\"'},B1=function(){return "\\"},yg="\\b",U1={type:"literal",value:"\\b",description:'"\\\\b"'},z1=function(){return "\b"},bg="\\t",V1={type:"literal",value:"\\t",description:'"\\\\t"'},G1=function(){return "	"},vg="\\n",K1={type:"literal",value:"\\n",description:'"\\\\n"'},Z1=function(){return `
`},wg="\\f",J1={type:"literal",value:"\\f",description:'"\\\\f"'},Y1=function(){return "\f"},Sg="\\r",X1={type:"literal",value:"\\r",description:'"\\\\r"'},Q1=function(){return "\r"},Eg="\\U",eO={type:"literal",value:"\\U",description:'"\\\\U"'},Rg=function(u){return vO(u.join(""))},Cg="\\u",tO={type:"literal",value:"\\u",description:'"\\\\u"'},f=0,de=0,Rs=0,ll={line:1,column:1,seenCR:!1},Lo=0,fl=[],X=0,ee={},$o;if("startRule"in i){if(!(i.startRule in o))throw new Error(`Can't start parsing from rule "`+i.startRule+'".');a=o[i.startRule];}function Et(){return dl(de).line}function Rt(){return dl(de).column}function dl(u){function h(b,x,O){var H,V;for(H=x;H<O;H++)V=n.charAt(H),V===`
`?(b.seenCR||b.line++,b.column=1,b.seenCR=!1):V==="\r"||V==="\u2028"||V==="\u2029"?(b.line++,b.column=1,b.seenCR=!0):(b.column++,b.seenCR=!1);}return Rs!==u&&(Rs>u&&(Rs=0,ll={line:1,column:1,seenCR:!1}),h(ll,Rs,u),Rs=u),ll}function re(u){f<Lo||(f>Lo&&(Lo=f,fl=[]),fl.push(u));}function hl(u,h,b){function x(le){var Se=1;for(le.sort(function(Be,Fe){return Be.description<Fe.description?-1:Be.description>Fe.description?1:0});Se<le.length;)le[Se-1]===le[Se]?le.splice(Se,1):Se++;}function O(le,Se){function Be(Si){function mn(sr){return sr.charCodeAt(0).toString(16).toUpperCase()}return Si.replace(/\\/g,"\\\\").replace(/"/g,'\\"').replace(/\x08/g,"\\b").replace(/\t/g,"\\t").replace(/\n/g,"\\n").replace(/\f/g,"\\f").replace(/\r/g,"\\r").replace(/[\x00-\x07\x0B\x0E\x0F]/g,function(sr){return "\\x0"+mn(sr)}).replace(/[\x10-\x1F\x80-\xFF]/g,function(sr){return "\\x"+mn(sr)}).replace(/[\u0180-\u0FFF]/g,function(sr){return "\\u0"+mn(sr)}).replace(/[\u1080-\uFFFF]/g,function(sr){return "\\u"+mn(sr)})}var Fe=new Array(le.length),nt,ct,ir;for(ir=0;ir<le.length;ir++)Fe[ir]=le[ir].description;return nt=le.length>1?Fe.slice(0,-1).join(", ")+" or "+Fe[le.length-1]:Fe[0],ct=Se?'"'+Be(Se)+'"':"end of input","Expected "+nt+" but "+ct+" found."}var H=dl(b),V=b<n.length?n.charAt(b):null;return h!==null&&x(h),new e(u!==null?u:O(h,V),h,V,b,H.line,H.column)}function xg(){var u,h,b,x=f*49+0,O=ee[x];if(O)return f=O.nextPos,O.result;for(u=f,h=[],b=Tg();b!==s;)h.push(b),b=Tg();return h!==s&&(de=u,h=d()),u=h,ee[x]={nextPos:f,result:u},u}function Tg(){var u,h,b,x,O,H,V,le=f*49+1,Se=ee[le];if(Se)return f=Se.nextPos,Se.result;for(u=f,h=[],b=he();b!==s;)h.push(b),b=he();if(h!==s)if(b=rO(),b!==s){for(x=[],O=he();O!==s;)x.push(O),O=he();if(x!==s){for(O=[],H=jo();H!==s;)O.push(H),H=jo();if(O!==s){if(H=[],V=hr(),V!==s)for(;V!==s;)H.push(V),V=hr();else H=c;H===s&&(H=Wo()),H!==s?(h=[h,b,x,O,H],u=h):(f=u,u=c);}else f=u,u=c;}else f=u,u=c;}else f=u,u=c;else f=u,u=c;if(u===s){if(u=f,h=[],b=he(),b!==s)for(;b!==s;)h.push(b),b=he();else h=c;if(h!==s){if(b=[],x=hr(),x!==s)for(;x!==s;)b.push(x),x=hr();else b=c;b===s&&(b=Wo()),b!==s?(h=[h,b],u=h):(f=u,u=c);}else f=u,u=c;u===s&&(u=hr());}return ee[le]={nextPos:f,result:u},u}function rO(){var u,h=f*49+2,b=ee[h];return b?(f=b.nextPos,b.result):(u=jo(),u===s&&(u=nO(),u===s&&(u=iO(),u===s&&(u=sO()))),ee[h]={nextPos:f,result:u},u)}function jo(){var u,h,b,x,O,H,V=f*49+3,le=ee[V];if(le)return f=le.nextPos,le.result;if(u=f,n.charCodeAt(f)===35?(h=p,f++):(h=s,X===0&&re(m)),h!==s){for(b=[],x=f,O=f,X++,H=hr(),H===s&&(H=Wo()),X--,H===s?O=_:(f=O,O=c),O!==s?(n.length>f?(H=n.charAt(f),f++):(H=s,X===0&&re(w)),H!==s?(O=[O,H],x=O):(f=x,x=c)):(f=x,x=c);x!==s;)b.push(x),x=f,O=f,X++,H=hr(),H===s&&(H=Wo()),X--,H===s?O=_:(f=O,O=c),O!==s?(n.length>f?(H=n.charAt(f),f++):(H=s,X===0&&re(w)),H!==s?(O=[O,H],x=O):(f=x,x=c)):(f=x,x=c);b!==s?(h=[h,b],u=h):(f=u,u=c);}else f=u,u=c;return ee[V]={nextPos:f,result:u},u}function nO(){var u,h,b,x,O,H,V=f*49+4,le=ee[V];if(le)return f=le.nextPos,le.result;if(u=f,n.charCodeAt(f)===91?(h=E,f++):(h=s,X===0&&re(P)),h!==s){for(b=[],x=he();x!==s;)b.push(x),x=he();if(b!==s)if(x=Ag(),x!==s){for(O=[],H=he();H!==s;)O.push(H),H=he();O!==s?(n.charCodeAt(f)===93?(H=D,f++):(H=s,X===0&&re(g)),H!==s?(de=u,h=S(x),u=h):(f=u,u=c)):(f=u,u=c);}else f=u,u=c;else f=u,u=c;}else f=u,u=c;return ee[V]={nextPos:f,result:u},u}function iO(){var u,h,b,x,O,H,V,le,Se=f*49+5,Be=ee[Se];if(Be)return f=Be.nextPos,Be.result;if(u=f,n.charCodeAt(f)===91?(h=E,f++):(h=s,X===0&&re(P)),h!==s)if(n.charCodeAt(f)===91?(b=E,f++):(b=s,X===0&&re(P)),b!==s){for(x=[],O=he();O!==s;)x.push(O),O=he();if(x!==s)if(O=Ag(),O!==s){for(H=[],V=he();V!==s;)H.push(V),V=he();H!==s?(n.charCodeAt(f)===93?(V=D,f++):(V=s,X===0&&re(g)),V!==s?(n.charCodeAt(f)===93?(le=D,f++):(le=s,X===0&&re(g)),le!==s?(de=u,h=I(O),u=h):(f=u,u=c)):(f=u,u=c)):(f=u,u=c);}else f=u,u=c;else f=u,u=c;}else f=u,u=c;else f=u,u=c;return ee[Se]={nextPos:f,result:u},u}function Ag(){var u,h,b,x=f*49+6,O=ee[x];if(O)return f=O.nextPos,O.result;if(u=f,h=[],b=Dg(),b!==s)for(;b!==s;)h.push(b),b=Dg();else h=c;return h!==s?(b=Pg(),b!==s?(de=u,h=L(h,b),u=h):(f=u,u=c)):(f=u,u=c),u===s&&(u=f,h=Pg(),h!==s&&(de=u,h=Z(h)),u=h),ee[x]={nextPos:f,result:u},u}function Pg(){var u,h,b,x,O,H=f*49+7,V=ee[H];if(V)return f=V.nextPos,V.result;for(u=f,h=[],b=he();b!==s;)h.push(b),b=he();if(h!==s)if(b=Cs(),b!==s){for(x=[],O=he();O!==s;)x.push(O),O=he();x!==s?(de=u,h=K(b),u=h):(f=u,u=c);}else f=u,u=c;else f=u,u=c;if(u===s){for(u=f,h=[],b=he();b!==s;)h.push(b),b=he();if(h!==s)if(b=pl(),b!==s){for(x=[],O=he();O!==s;)x.push(O),O=he();x!==s?(de=u,h=K(b),u=h):(f=u,u=c);}else f=u,u=c;else f=u,u=c;}return ee[H]={nextPos:f,result:u},u}function Dg(){var u,h,b,x,O,H,V,le=f*49+8,Se=ee[le];if(Se)return f=Se.nextPos,Se.result;for(u=f,h=[],b=he();b!==s;)h.push(b),b=he();if(h!==s)if(b=Cs(),b!==s){for(x=[],O=he();O!==s;)x.push(O),O=he();if(x!==s)if(n.charCodeAt(f)===46?(O=U,f++):(O=s,X===0&&re(B)),O!==s){for(H=[],V=he();V!==s;)H.push(V),V=he();H!==s?(de=u,h=K(b),u=h):(f=u,u=c);}else f=u,u=c;else f=u,u=c;}else f=u,u=c;else f=u,u=c;if(u===s){for(u=f,h=[],b=he();b!==s;)h.push(b),b=he();if(h!==s)if(b=pl(),b!==s){for(x=[],O=he();O!==s;)x.push(O),O=he();if(x!==s)if(n.charCodeAt(f)===46?(O=U,f++):(O=s,X===0&&re(B)),O!==s){for(H=[],V=he();V!==s;)H.push(V),V=he();H!==s?(de=u,h=K(b),u=h):(f=u,u=c);}else f=u,u=c;else f=u,u=c;}else f=u,u=c;else f=u,u=c;}return ee[le]={nextPos:f,result:u},u}function sO(){var u,h,b,x,O,H,V=f*49+9,le=ee[V];if(le)return f=le.nextPos,le.result;if(u=f,h=Cs(),h!==s){for(b=[],x=he();x!==s;)b.push(x),x=he();if(b!==s)if(n.charCodeAt(f)===61?(x=Q,f++):(x=s,X===0&&re(N)),x!==s){for(O=[],H=he();H!==s;)O.push(H),H=he();O!==s?(H=wi(),H!==s?(de=u,h=te(h,H),u=h):(f=u,u=c)):(f=u,u=c);}else f=u,u=c;else f=u,u=c;}else f=u,u=c;if(u===s)if(u=f,h=pl(),h!==s){for(b=[],x=he();x!==s;)b.push(x),x=he();if(b!==s)if(n.charCodeAt(f)===61?(x=Q,f++):(x=s,X===0&&re(N)),x!==s){for(O=[],H=he();H!==s;)O.push(H),H=he();O!==s?(H=wi(),H!==s?(de=u,h=te(h,H),u=h):(f=u,u=c)):(f=u,u=c);}else f=u,u=c;else f=u,u=c;}else f=u,u=c;return ee[V]={nextPos:f,result:u},u}function Cs(){var u,h,b,x=f*49+10,O=ee[x];if(O)return f=O.nextPos,O.result;if(u=f,h=[],b=Bg(),b!==s)for(;b!==s;)h.push(b),b=Bg();else h=c;return h!==s&&(de=u,h=ae(h)),u=h,ee[x]={nextPos:f,result:u},u}function pl(){var u,h,b=f*49+11,x=ee[b];return x?(f=x.nextPos,x.result):(u=f,h=Og(),h!==s&&(de=u,h=ye(h)),u=h,u===s&&(u=f,h=Ig(),h!==s&&(de=u,h=ye(h)),u=h),ee[b]={nextPos:f,result:u},u)}function wi(){var u,h=f*49+12,b=ee[h];return b?(f=b.nextPos,b.result):(u=oO(),u===s&&(u=_O(),u===s&&(u=lO(),u===s&&(u=fO(),u===s&&(u=dO(),u===s&&(u=hO(),u===s&&(u=pO())))))),ee[h]={nextPos:f,result:u},u)}function oO(){var u,h=f*49+13,b=ee[h];return b?(f=b.nextPos,b.result):(u=aO(),u===s&&(u=Og(),u===s&&(u=uO(),u===s&&(u=Ig()))),ee[h]={nextPos:f,result:u},u)}function aO(){var u,h,b,x,O,H=f*49+14,V=ee[H];if(V)return f=V.nextPos,V.result;if(u=f,n.substr(f,3)===q?(h=q,f+=3):(h=s,X===0&&re(W)),h!==s)if(b=hr(),b===s&&(b=me),b!==s){for(x=[],O=Fg();O!==s;)x.push(O),O=Fg();x!==s?(n.substr(f,3)===q?(O=q,f+=3):(O=s,X===0&&re(W)),O!==s?(de=u,h=pe(x),u=h):(f=u,u=c)):(f=u,u=c);}else f=u,u=c;else f=u,u=c;return ee[H]={nextPos:f,result:u},u}function Og(){var u,h,b,x,O=f*49+15,H=ee[O];if(H)return f=H.nextPos,H.result;if(u=f,n.charCodeAt(f)===34?(h=we,f++):(h=s,X===0&&re(Xe)),h!==s){for(b=[],x=kg();x!==s;)b.push(x),x=kg();b!==s?(n.charCodeAt(f)===34?(x=we,f++):(x=s,X===0&&re(Xe)),x!==s?(de=u,h=pe(b),u=h):(f=u,u=c)):(f=u,u=c);}else f=u,u=c;return ee[O]={nextPos:f,result:u},u}function uO(){var u,h,b,x,O,H=f*49+16,V=ee[H];if(V)return f=V.nextPos,V.result;if(u=f,n.substr(f,3)===Ke?(h=Ke,f+=3):(h=s,X===0&&re(Pt)),h!==s)if(b=hr(),b===s&&(b=me),b!==s){for(x=[],O=Ng();O!==s;)x.push(O),O=Ng();x!==s?(n.substr(f,3)===Ke?(O=Ke,f+=3):(O=s,X===0&&re(Pt)),O!==s?(de=u,h=pe(x),u=h):(f=u,u=c)):(f=u,u=c);}else f=u,u=c;else f=u,u=c;return ee[H]={nextPos:f,result:u},u}function Ig(){var u,h,b,x,O=f*49+17,H=ee[O];if(H)return f=H.nextPos,H.result;if(u=f,n.charCodeAt(f)===39?(h=Lr,f++):(h=s,X===0&&re(zt)),h!==s){for(b=[],x=Mg();x!==s;)b.push(x),x=Mg();b!==s?(n.charCodeAt(f)===39?(x=Lr,f++):(x=s,X===0&&re(zt)),x!==s?(de=u,h=pe(b),u=h):(f=u,u=c)):(f=u,u=c);}else f=u,u=c;return ee[O]={nextPos:f,result:u},u}function kg(){var u,h,b,x=f*49+18,O=ee[x];return O?(f=O.nextPos,O.result):(u=Ug(),u===s&&(u=f,h=f,X++,n.charCodeAt(f)===34?(b=we,f++):(b=s,X===0&&re(Xe)),X--,b===s?h=_:(f=h,h=c),h!==s?(n.length>f?(b=n.charAt(f),f++):(b=s,X===0&&re(w)),b!==s?(de=u,h=St(b),u=h):(f=u,u=c)):(f=u,u=c)),ee[x]={nextPos:f,result:u},u)}function Mg(){var u,h,b,x=f*49+19,O=ee[x];return O?(f=O.nextPos,O.result):(u=f,h=f,X++,n.charCodeAt(f)===39?(b=Lr,f++):(b=s,X===0&&re(zt)),X--,b===s?h=_:(f=h,h=c),h!==s?(n.length>f?(b=n.charAt(f),f++):(b=s,X===0&&re(w)),b!==s?(de=u,h=St(b),u=h):(f=u,u=c)):(f=u,u=c),ee[x]={nextPos:f,result:u},u)}function Fg(){var u,h,b,x=f*49+20,O=ee[x];return O?(f=O.nextPos,O.result):(u=Ug(),u===s&&(u=cO(),u===s&&(u=f,h=f,X++,n.substr(f,3)===q?(b=q,f+=3):(b=s,X===0&&re(W)),X--,b===s?h=_:(f=h,h=c),h!==s?(n.length>f?(b=n.charAt(f),f++):(b=s,X===0&&re(w)),b!==s?(de=u,h=Ce(b),u=h):(f=u,u=c)):(f=u,u=c))),ee[x]={nextPos:f,result:u},u)}function cO(){var u,h,b,x,O,H=f*49+21,V=ee[H];if(V)return f=V.nextPos,V.result;if(u=f,n.charCodeAt(f)===92?(h=Cr,f++):(h=s,X===0&&re(fn)),h!==s)if(b=hr(),b!==s){for(x=[],O=Wg();O!==s;)x.push(O),O=Wg();x!==s?(de=u,h=ce(),u=h):(f=u,u=c);}else f=u,u=c;else f=u,u=c;return ee[H]={nextPos:f,result:u},u}function Ng(){var u,h,b,x=f*49+22,O=ee[x];return O?(f=O.nextPos,O.result):(u=f,h=f,X++,n.substr(f,3)===Ke?(b=Ke,f+=3):(b=s,X===0&&re(Pt)),X--,b===s?h=_:(f=h,h=c),h!==s?(n.length>f?(b=n.charAt(f),f++):(b=s,X===0&&re(w)),b!==s?(de=u,h=St(b),u=h):(f=u,u=c)):(f=u,u=c),ee[x]={nextPos:f,result:u},u)}function lO(){var u,h,b,x,O=f*49+23,H=ee[O];return H?(f=H.nextPos,H.result):(u=f,h=qg(),h===s&&(h=ml()),h!==s?(n.charCodeAt(f)===101?(b=Me,f++):(b=s,X===0&&re(ie)),b===s&&(n.charCodeAt(f)===69?(b=be,f++):(b=s,X===0&&re($e))),b!==s?(x=ml(),x!==s?(de=u,h=ot(h,x),u=h):(f=u,u=c)):(f=u,u=c)):(f=u,u=c),u===s&&(u=f,h=qg(),h!==s&&(de=u,h=He(h)),u=h),ee[O]={nextPos:f,result:u},u)}function qg(){var u,h,b,x,O,H,V=f*49+24,le=ee[V];return le?(f=le.nextPos,le.result):(u=f,n.charCodeAt(f)===43?(h=fr,f++):(h=s,X===0&&re(Nt)),h===s&&(h=me),h!==s?(b=f,x=xs(),x!==s?(n.charCodeAt(f)===46?(O=U,f++):(O=s,X===0&&re(B)),O!==s?(H=xs(),H!==s?(x=[x,O,H],b=x):(f=b,b=c)):(f=b,b=c)):(f=b,b=c),b!==s?(de=u,h=Hn(b),u=h):(f=u,u=c)):(f=u,u=c),u===s&&(u=f,n.charCodeAt(f)===45?(h=qt,f++):(h=s,X===0&&re(Vt)),h!==s?(b=f,x=xs(),x!==s?(n.charCodeAt(f)===46?(O=U,f++):(O=s,X===0&&re(B)),O!==s?(H=xs(),H!==s?(x=[x,O,H],b=x):(f=b,b=c)):(f=b,b=c)):(f=b,b=c),b!==s?(de=u,h=Wn(b),u=h):(f=u,u=c)):(f=u,u=c)),ee[V]={nextPos:f,result:u},u)}function fO(){var u,h,b=f*49+25,x=ee[b];return x?(f=x.nextPos,x.result):(u=f,h=ml(),h!==s&&(de=u,h=yi(h)),u=h,ee[b]={nextPos:f,result:u},u)}function ml(){var u,h,b,x,O,H=f*49+26,V=ee[H];if(V)return f=V.nextPos,V.result;if(u=f,n.charCodeAt(f)===43?(h=fr,f++):(h=s,X===0&&re(Nt)),h===s&&(h=me),h!==s){if(b=[],x=je(),x!==s)for(;x!==s;)b.push(x),x=je();else b=c;b!==s?(x=f,X++,n.charCodeAt(f)===46?(O=U,f++):(O=s,X===0&&re(B)),X--,O===s?x=_:(f=x,x=c),x!==s?(de=u,h=Hn(b),u=h):(f=u,u=c)):(f=u,u=c);}else f=u,u=c;if(u===s)if(u=f,n.charCodeAt(f)===45?(h=qt,f++):(h=s,X===0&&re(Vt)),h!==s){if(b=[],x=je(),x!==s)for(;x!==s;)b.push(x),x=je();else b=c;b!==s?(x=f,X++,n.charCodeAt(f)===46?(O=U,f++):(O=s,X===0&&re(B)),X--,O===s?x=_:(f=x,x=c),x!==s?(de=u,h=Wn(b),u=h):(f=u,u=c)):(f=u,u=c);}else f=u,u=c;return ee[H]={nextPos:f,result:u},u}function dO(){var u,h,b=f*49+27,x=ee[b];return x?(f=x.nextPos,x.result):(u=f,n.substr(f,4)===tr?(h=tr,f+=4):(h=s,X===0&&re(Bn)),h!==s&&(de=u,h=Un()),u=h,u===s&&(u=f,n.substr(f,5)===Yr?(h=Yr,f+=5):(h=s,X===0&&re(zn)),h!==s&&(de=u,h=xr()),u=h),ee[b]={nextPos:f,result:u},u)}function hO(){var u,h,b,x,O,H=f*49+28,V=ee[H];if(V)return f=V.nextPos,V.result;if(u=f,n.charCodeAt(f)===91?(h=E,f++):(h=s,X===0&&re(P)),h!==s){for(b=[],x=dr();x!==s;)b.push(x),x=dr();b!==s?(n.charCodeAt(f)===93?(x=D,f++):(x=s,X===0&&re(g)),x!==s?(de=u,h=k(),u=h):(f=u,u=c)):(f=u,u=c);}else f=u,u=c;if(u===s&&(u=f,n.charCodeAt(f)===91?(h=E,f++):(h=s,X===0&&re(P)),h!==s?(b=Lg(),b===s&&(b=me),b!==s?(n.charCodeAt(f)===93?(x=D,f++):(x=s,X===0&&re(g)),x!==s?(de=u,h=G(b),u=h):(f=u,u=c)):(f=u,u=c)):(f=u,u=c),u===s)){if(u=f,n.charCodeAt(f)===91?(h=E,f++):(h=s,X===0&&re(P)),h!==s){if(b=[],x=Ho(),x!==s)for(;x!==s;)b.push(x),x=Ho();else b=c;b!==s?(n.charCodeAt(f)===93?(x=D,f++):(x=s,X===0&&re(g)),x!==s?(de=u,h=se(b),u=h):(f=u,u=c)):(f=u,u=c);}else f=u,u=c;if(u===s)if(u=f,n.charCodeAt(f)===91?(h=E,f++):(h=s,X===0&&re(P)),h!==s){if(b=[],x=Ho(),x!==s)for(;x!==s;)b.push(x),x=Ho();else b=c;b!==s?(x=Lg(),x!==s?(n.charCodeAt(f)===93?(O=D,f++):(O=s,X===0&&re(g)),O!==s?(de=u,h=fe(b,x),u=h):(f=u,u=c)):(f=u,u=c)):(f=u,u=c);}else f=u,u=c;}return ee[H]={nextPos:f,result:u},u}function Lg(){var u,h,b,x,O,H=f*49+29,V=ee[H];if(V)return f=V.nextPos,V.result;for(u=f,h=[],b=dr();b!==s;)h.push(b),b=dr();if(h!==s)if(b=wi(),b!==s){for(x=[],O=dr();O!==s;)x.push(O),O=dr();x!==s?(de=u,h=qe(b),u=h):(f=u,u=c);}else f=u,u=c;else f=u,u=c;return ee[H]={nextPos:f,result:u},u}function Ho(){var u,h,b,x,O,H,V,le=f*49+30,Se=ee[le];if(Se)return f=Se.nextPos,Se.result;for(u=f,h=[],b=dr();b!==s;)h.push(b),b=dr();if(h!==s)if(b=wi(),b!==s){for(x=[],O=dr();O!==s;)x.push(O),O=dr();if(x!==s)if(n.charCodeAt(f)===44?(O=ke,f++):(O=s,X===0&&re(ze)),O!==s){for(H=[],V=dr();V!==s;)H.push(V),V=dr();H!==s?(de=u,h=qe(b),u=h):(f=u,u=c);}else f=u,u=c;else f=u,u=c;}else f=u,u=c;else f=u,u=c;return ee[le]={nextPos:f,result:u},u}function dr(){var u,h=f*49+31,b=ee[h];return b?(f=b.nextPos,b.result):(u=he(),u===s&&(u=hr(),u===s&&(u=jo())),ee[h]={nextPos:f,result:u},u)}function pO(){var u,h,b,x,O,H,V=f*49+32,le=ee[V];if(le)return f=le.nextPos,le.result;if(u=f,n.charCodeAt(f)===123?(h=Ze,f++):(h=s,X===0&&re(Te)),h!==s){for(b=[],x=he();x!==s;)b.push(x),x=he();if(b!==s){for(x=[],O=$g();O!==s;)x.push(O),O=$g();if(x!==s){for(O=[],H=he();H!==s;)O.push(H),H=he();O!==s?(n.charCodeAt(f)===125?(H=We,f++):(H=s,X===0&&re(Ie)),H!==s?(de=u,h=et(x),u=h):(f=u,u=c)):(f=u,u=c);}else f=u,u=c;}else f=u,u=c;}else f=u,u=c;return ee[V]={nextPos:f,result:u},u}function $g(){var u,h,b,x,O,H,V,le,Se,Be,Fe,nt=f*49+33,ct=ee[nt];if(ct)return f=ct.nextPos,ct.result;for(u=f,h=[],b=he();b!==s;)h.push(b),b=he();if(h!==s)if(b=Cs(),b!==s){for(x=[],O=he();O!==s;)x.push(O),O=he();if(x!==s)if(n.charCodeAt(f)===61?(O=Q,f++):(O=s,X===0&&re(N)),O!==s){for(H=[],V=he();V!==s;)H.push(V),V=he();if(H!==s)if(V=wi(),V!==s){for(le=[],Se=he();Se!==s;)le.push(Se),Se=he();if(le!==s)if(n.charCodeAt(f)===44?(Se=ke,f++):(Se=s,X===0&&re(ze)),Se!==s){for(Be=[],Fe=he();Fe!==s;)Be.push(Fe),Fe=he();Be!==s?(de=u,h=ut(b,V),u=h):(f=u,u=c);}else f=u,u=c;else f=u,u=c;}else f=u,u=c;else f=u,u=c;}else f=u,u=c;else f=u,u=c;}else f=u,u=c;else f=u,u=c;if(u===s){for(u=f,h=[],b=he();b!==s;)h.push(b),b=he();if(h!==s)if(b=Cs(),b!==s){for(x=[],O=he();O!==s;)x.push(O),O=he();if(x!==s)if(n.charCodeAt(f)===61?(O=Q,f++):(O=s,X===0&&re(N)),O!==s){for(H=[],V=he();V!==s;)H.push(V),V=he();H!==s?(V=wi(),V!==s?(de=u,h=ut(b,V),u=h):(f=u,u=c)):(f=u,u=c);}else f=u,u=c;else f=u,u=c;}else f=u,u=c;else f=u,u=c;}return ee[nt]={nextPos:f,result:u},u}function jg(){var u,h,b,x=f*49+34,O=ee[x];return O?(f=O.nextPos,O.result):(u=f,n.charCodeAt(f)===46?(h=U,f++):(h=s,X===0&&re(B)),h!==s?(b=xs(),b!==s?(de=u,h=Lt(b),u=h):(f=u,u=c)):(f=u,u=c),ee[x]={nextPos:f,result:u},u)}function Hg(){var u,h,b,x,O,H,V,le,Se,Be,Fe,nt,ct=f*49+35,ir=ee[ct];return ir?(f=ir.nextPos,ir.result):(u=f,h=f,b=je(),b!==s?(x=je(),x!==s?(O=je(),O!==s?(H=je(),H!==s?(n.charCodeAt(f)===45?(V=qt,f++):(V=s,X===0&&re(Vt)),V!==s?(le=je(),le!==s?(Se=je(),Se!==s?(n.charCodeAt(f)===45?(Be=qt,f++):(Be=s,X===0&&re(Vt)),Be!==s?(Fe=je(),Fe!==s?(nt=je(),nt!==s?(b=[b,x,O,H,V,le,Se,Be,Fe,nt],h=b):(f=h,h=c)):(f=h,h=c)):(f=h,h=c)):(f=h,h=c)):(f=h,h=c)):(f=h,h=c)):(f=h,h=c)):(f=h,h=c)):(f=h,h=c)):(f=h,h=c),h!==s&&(de=u,h=bi(h)),u=h,ee[ct]={nextPos:f,result:u},u)}function mO(){var u,h,b,x,O,H,V,le,Se,Be,Fe,nt=f*49+36,ct=ee[nt];return ct?(f=ct.nextPos,ct.result):(u=f,h=f,b=je(),b!==s?(x=je(),x!==s?(n.charCodeAt(f)===58?(O=dn,f++):(O=s,X===0&&re(hn)),O!==s?(H=je(),H!==s?(V=je(),V!==s?(n.charCodeAt(f)===58?(le=dn,f++):(le=s,X===0&&re(hn)),le!==s?(Se=je(),Se!==s?(Be=je(),Be!==s?(Fe=jg(),Fe===s&&(Fe=me),Fe!==s?(b=[b,x,O,H,V,le,Se,Be,Fe],h=b):(f=h,h=c)):(f=h,h=c)):(f=h,h=c)):(f=h,h=c)):(f=h,h=c)):(f=h,h=c)):(f=h,h=c)):(f=h,h=c)):(f=h,h=c),h!==s&&(de=u,h=Ss(h)),u=h,ee[nt]={nextPos:f,result:u},u)}function gO(){var u,h,b,x,O,H,V,le,Se,Be,Fe,nt,ct,ir,Si,mn,sr,Vg=f*49+37,_l=ee[Vg];return _l?(f=_l.nextPos,_l.result):(u=f,h=f,b=je(),b!==s?(x=je(),x!==s?(n.charCodeAt(f)===58?(O=dn,f++):(O=s,X===0&&re(hn)),O!==s?(H=je(),H!==s?(V=je(),V!==s?(n.charCodeAt(f)===58?(le=dn,f++):(le=s,X===0&&re(hn)),le!==s?(Se=je(),Se!==s?(Be=je(),Be!==s?(Fe=jg(),Fe===s&&(Fe=me),Fe!==s?(n.charCodeAt(f)===45?(nt=qt,f++):(nt=s,X===0&&re(Vt)),nt===s&&(n.charCodeAt(f)===43?(nt=fr,f++):(nt=s,X===0&&re(Nt))),nt!==s?(ct=je(),ct!==s?(ir=je(),ir!==s?(n.charCodeAt(f)===58?(Si=dn,f++):(Si=s,X===0&&re(hn)),Si!==s?(mn=je(),mn!==s?(sr=je(),sr!==s?(b=[b,x,O,H,V,le,Se,Be,Fe,nt,ct,ir,Si,mn,sr],h=b):(f=h,h=c)):(f=h,h=c)):(f=h,h=c)):(f=h,h=c)):(f=h,h=c)):(f=h,h=c)):(f=h,h=c)):(f=h,h=c)):(f=h,h=c)):(f=h,h=c)):(f=h,h=c)):(f=h,h=c)):(f=h,h=c)):(f=h,h=c)):(f=h,h=c),h!==s&&(de=u,h=Ss(h)),u=h,ee[Vg]={nextPos:f,result:u},u)}function _O(){var u,h,b,x,O,H=f*49+38,V=ee[H];return V?(f=V.nextPos,V.result):(u=f,h=Hg(),h!==s?(n.charCodeAt(f)===84?(b=Es,f++):(b=s,X===0&&re(No)),b!==s?(x=mO(),x!==s?(n.charCodeAt(f)===90?(O=j,f++):(O=s,X===0&&re(v)),O!==s?(de=u,h=M(h,x),u=h):(f=u,u=c)):(f=u,u=c)):(f=u,u=c)):(f=u,u=c),u===s&&(u=f,h=Hg(),h!==s?(n.charCodeAt(f)===84?(b=Es,f++):(b=s,X===0&&re(No)),b!==s?(x=gO(),x!==s?(de=u,h=F(h,x),u=h):(f=u,u=c)):(f=u,u=c)):(f=u,u=c)),ee[H]={nextPos:f,result:u},u)}function he(){var u,h=f*49+39,b=ee[h];return b?(f=b.nextPos,b.result):(R.test(n.charAt(f))?(u=n.charAt(f),f++):(u=s,X===0&&re(y)),ee[h]={nextPos:f,result:u},u)}function hr(){var u,h,b,x=f*49+40,O=ee[x];return O?(f=O.nextPos,O.result):(n.charCodeAt(f)===10?(u=$,f++):(u=s,X===0&&re(J)),u===s&&(u=f,n.charCodeAt(f)===13?(h=Ee,f++):(h=s,X===0&&re(tt)),h!==s?(n.charCodeAt(f)===10?(b=$,f++):(b=s,X===0&&re(J)),b!==s?(h=[h,b],u=h):(f=u,u=c)):(f=u,u=c)),ee[x]={nextPos:f,result:u},u)}function Wg(){var u,h=f*49+41,b=ee[h];return b?(f=b.nextPos,b.result):(u=hr(),u===s&&(u=he()),ee[h]={nextPos:f,result:u},u)}function Wo(){var u,h,b=f*49+42,x=ee[b];return x?(f=x.nextPos,x.result):(u=f,X++,n.length>f?(h=n.charAt(f),f++):(h=s,X===0&&re(w)),X--,h===s?u=_:(f=u,u=c),ee[b]={nextPos:f,result:u},u)}function pr(){var u,h=f*49+43,b=ee[h];return b?(f=b.nextPos,b.result):(Ve.test(n.charAt(f))?(u=n.charAt(f),f++):(u=s,X===0&&re(rr)),ee[h]={nextPos:f,result:u},u)}function je(){var u,h,b=f*49+44,x=ee[b];return x?(f=x.nextPos,x.result):(nr.test(n.charAt(f))?(u=n.charAt(f),f++):(u=s,X===0&&re(Tr)),u===s&&(u=f,n.charCodeAt(f)===95?(h=Pe,f++):(h=s,X===0&&re(pn)),h!==s&&(de=u,h=vi()),u=h),ee[b]={nextPos:f,result:u},u)}function Bg(){var u,h=f*49+45,b=ee[h];return b?(f=b.nextPos,b.result):(qo.test(n.charAt(f))?(u=n.charAt(f),f++):(u=s,X===0&&re(L1)),ee[h]={nextPos:f,result:u},u)}function xs(){var u,h,b,x=f*49+46,O=ee[x];if(O)return f=O.nextPos,O.result;if(u=f,h=[],b=je(),b!==s)for(;b!==s;)h.push(b),b=je();else h=c;return h!==s&&(de=u,h=$1(h)),u=h,ee[x]={nextPos:f,result:u},u}function Ug(){var u,h,b=f*49+47,x=ee[b];return x?(f=x.nextPos,x.result):(u=f,n.substr(f,2)===gg?(h=gg,f+=2):(h=s,X===0&&re(j1)),h!==s&&(de=u,h=H1()),u=h,u===s&&(u=f,n.substr(f,2)===_g?(h=_g,f+=2):(h=s,X===0&&re(W1)),h!==s&&(de=u,h=B1()),u=h,u===s&&(u=f,n.substr(f,2)===yg?(h=yg,f+=2):(h=s,X===0&&re(U1)),h!==s&&(de=u,h=z1()),u=h,u===s&&(u=f,n.substr(f,2)===bg?(h=bg,f+=2):(h=s,X===0&&re(V1)),h!==s&&(de=u,h=G1()),u=h,u===s&&(u=f,n.substr(f,2)===vg?(h=vg,f+=2):(h=s,X===0&&re(K1)),h!==s&&(de=u,h=Z1()),u=h,u===s&&(u=f,n.substr(f,2)===wg?(h=wg,f+=2):(h=s,X===0&&re(J1)),h!==s&&(de=u,h=Y1()),u=h,u===s&&(u=f,n.substr(f,2)===Sg?(h=Sg,f+=2):(h=s,X===0&&re(X1)),h!==s&&(de=u,h=Q1()),u=h,u===s&&(u=yO()))))))),ee[b]={nextPos:f,result:u},u)}function yO(){var u,h,b,x,O,H,V,le,Se,Be,Fe,nt=f*49+48,ct=ee[nt];return ct?(f=ct.nextPos,ct.result):(u=f,n.substr(f,2)===Eg?(h=Eg,f+=2):(h=s,X===0&&re(eO)),h!==s?(b=f,x=pr(),x!==s?(O=pr(),O!==s?(H=pr(),H!==s?(V=pr(),V!==s?(le=pr(),le!==s?(Se=pr(),Se!==s?(Be=pr(),Be!==s?(Fe=pr(),Fe!==s?(x=[x,O,H,V,le,Se,Be,Fe],b=x):(f=b,b=c)):(f=b,b=c)):(f=b,b=c)):(f=b,b=c)):(f=b,b=c)):(f=b,b=c)):(f=b,b=c)):(f=b,b=c),b!==s?(de=u,h=Rg(b),u=h):(f=u,u=c)):(f=u,u=c),u===s&&(u=f,n.substr(f,2)===Cg?(h=Cg,f+=2):(h=s,X===0&&re(tO)),h!==s?(b=f,x=pr(),x!==s?(O=pr(),O!==s?(H=pr(),H!==s?(V=pr(),V!==s?(x=[x,O,H,V],b=x):(f=b,b=c)):(f=b,b=c)):(f=b,b=c)):(f=b,b=c),b!==s?(de=u,h=Rg(b),u=h):(f=u,u=c)):(f=u,u=c)),ee[nt]={nextPos:f,result:u},u)}var zg=[];function bO(u,h,b){var x=new Error(u);throw x.line=h,x.column=b,x}function gl(u){zg.push(u);}function Ct(u,h,b,x,O){var H={type:u,value:h,line:b(),column:x()};return O&&(H.key=O),H}function vO(u,h,b){var x=parseInt("0x"+u);if(!isFinite(x)||Math.floor(x)!=x||x<0||x>1114111||x>55295&&x<57344)bO("Invalid Unicode escape code: "+u,h,b);else return wO(x)}function wO(){var u=16384,h=[],b,x,O=-1,H=arguments.length;if(!H)return "";for(var V="";++O<H;){var le=Number(arguments[O]);le<=65535?h.push(le):(le-=65536,b=(le>>10)+55296,x=le%1024+56320,h.push(b,x)),(O+1==H||h.length>u)&&(V+=String.fromCharCode.apply(null,h),h.length=0);}return V}if($o=a(),$o!==s&&f===n.length)return $o;throw $o!==s&&f<n.length&&re({type:"end",description:"end of input"}),hl(null,fl,Lo)}return {SyntaxError:e,parse:r}}();});var Sx=A((C8,wx)=>{function UU(t){var e=[],r=[],n="",i=Object.create(null),s=i;return a(t);function a(g){for(var S,I=0;I<g.length;I++)switch(S=g[I],S.type){case"Assign":d(S);break;case"ObjectPath":_(S);break;case"ArrayPath":w(S);break}return i}function l(g,S,I){var L=new Error(g);throw L.line=S,L.column=I,L}function d(g){var S=g.key,I=g.value,L=g.line,Z=g.column,K;n?K=n+"."+S:K=S,typeof s[S]<"u"&&l("Cannot redefine existing key '"+K+"'.",L,Z),s[S]=p(I),c(K)||(e.push(K),r.push(K));}function c(g){return e.indexOf(g)!==-1}function p(g){return g.type==="Array"?P(g.value):g.type==="InlineTable"?m(g.value):g.value}function m(g){for(var S=Object.create(null),I=0;I<g.length;I++){var L=g[I];L.value.type==="InlineTable"?S[L.key]=m(L.value.value):L.type==="InlineTableValue"&&(S[L.key]=p(L.value));}return S}function _(g){var S=g.value,I=S.map(D).join("."),L=g.line,Z=g.column;c(I)&&l("Cannot redefine existing key '"+S+"'.",L,Z),e.push(I),s=E(i,S,Object.create(null),L,Z),n=S;}function w(g){var S=g.value,I=S.map(D).join("."),L=g.line,Z=g.column;if(c(I)||e.push(I),e=e.filter(function(U){return U.indexOf(I)!==0}),e.push(I),s=E(i,S,[],L,Z),n=I,s instanceof Array){var K=Object.create(null);s.push(K),s=K;}else l("Cannot redefine existing key '"+S+"'.",L,Z);}function E(g,S,I,L,Z){for(var K=[],U="",B=S.join("."),Q=g,N=0;N<S.length;N++){var te=S[N];K.push(te),U=K.join("."),typeof Q[te]>"u"?N===S.length-1?Q[te]=I:Q[te]=Object.create(null):N!==S.length-1&&r.indexOf(U)>-1&&l("Cannot redefine existing key '"+U+"'.",L,Z),Q=Q[te],Q instanceof Array&&Q.length&&N<S.length-1&&(Q=Q[Q.length-1]);}return Q}function P(g){for(var S=null,I=0;I<g.length;I++){var L=g[I];S===null?S=L.type:L.type!==S&&l("Cannot add value of type "+L.type+" to array of type "+S+".",L.line,L.column);}return g.map(p)}function D(g){return g.indexOf(".")>-1?'"'+g+'"':g}}wx.exports={compile:UU};});var Rx=A((x8,Ex)=>{var zU=vx(),VU=Sx();Ex.exports={parse:function(t){var e=zU.parse(t.toString());return VU.compile(e)}};});var Lx=A((ui,qx)=>{var sp=oe("crypto");ui=qx.exports=mo;function mo(t,e){return e=Fx(t,e),e3(t,e)}ui.sha1=function(t){return mo(t)};ui.keys=function(t){return mo(t,{excludeValues:!0,algorithm:"sha1",encoding:"hex"})};ui.MD5=function(t){return mo(t,{algorithm:"md5",encoding:"hex"})};ui.keysMD5=function(t){return mo(t,{algorithm:"md5",encoding:"hex",excludeValues:!0})};var Yi=sp.getHashes?sp.getHashes().slice():["sha1","md5"];Yi.push("passthrough");var kx=["buffer","hex","binary","base64"];function Fx(t,e){e=e||{};var r={};if(r.algorithm=e.algorithm||"sha1",r.encoding=e.encoding||"hex",r.excludeValues=!!e.excludeValues,r.algorithm=r.algorithm.toLowerCase(),r.encoding=r.encoding.toLowerCase(),r.ignoreUnknown=e.ignoreUnknown===!0,r.respectType=e.respectType!==!1,r.respectFunctionNames=e.respectFunctionNames!==!1,r.respectFunctionProperties=e.respectFunctionProperties!==!1,r.unorderedArrays=e.unorderedArrays===!0,r.unorderedSets=e.unorderedSets!==!1,r.unorderedObjects=e.unorderedObjects!==!1,r.replacer=e.replacer||void 0,r.excludeKeys=e.excludeKeys||void 0,typeof t>"u")throw new Error("Object argument required.");for(var n=0;n<Yi.length;++n)Yi[n].toLowerCase()===r.algorithm.toLowerCase()&&(r.algorithm=Yi[n]);if(Yi.indexOf(r.algorithm)===-1)throw new Error('Algorithm "'+r.algorithm+'"  not supported. supported values: '+Yi.join(", "));if(kx.indexOf(r.encoding)===-1&&r.algorithm!=="passthrough")throw new Error('Encoding "'+r.encoding+'"  not supported. supported values: '+kx.join(", "));return r}function Mx(t){if(typeof t!="function")return !1;var e=/^function\s+\w*\s*\(\s*\)\s*{\s+\[native code\]\s+}$/i;return e.exec(Function.prototype.toString.call(t))!=null}function e3(t,e){var r;e.algorithm!=="passthrough"?r=sp.createHash(e.algorithm):r=new Nx,typeof r.write>"u"&&(r.write=r.update,r.end=r.update);var n=op(e,r);if(n.dispatch(t),r.update||r.end(""),r.digest)return r.digest(e.encoding==="buffer"?void 0:e.encoding);var i=r.read();return e.encoding==="buffer"?i:i.toString(e.encoding)}ui.writeToStream=function(t,e,r){return typeof r>"u"&&(r=e,e={}),e=Fx(t,e),op(e,r).dispatch(t)};function op(t,e,r){r=r||[];var n=function(i){return e.update?e.update(i,"utf8"):e.write(i,"utf8")};return {dispatch:function(i){t.replacer&&(i=t.replacer(i));var s=typeof i;return i===null&&(s="null"),this["_"+s](i)},_object:function(i){var s=/\[object (.*)\]/i,o=Object.prototype.toString.call(i),a=s.exec(o);a?a=a[1]:a="unknown:["+o+"]",a=a.toLowerCase();var l=null;if((l=r.indexOf(i))>=0)return this.dispatch("[CIRCULAR:"+l+"]");if(r.push(i),typeof Buffer<"u"&&Buffer.isBuffer&&Buffer.isBuffer(i))return n("buffer:"),n(i);if(a!=="object"&&a!=="function"&&a!=="asyncfunction")if(this["_"+a])this["_"+a](i);else {if(t.ignoreUnknown)return n("["+a+"]");throw new Error('Unknown object type "'+a+'"')}else {var d=Object.keys(i);t.unorderedObjects&&(d=d.sort()),t.respectType!==!1&&!Mx(i)&&d.splice(0,0,"prototype","__proto__","constructor"),t.excludeKeys&&(d=d.filter(function(p){return !t.excludeKeys(p)})),n("object:"+d.length+":");var c=this;return d.forEach(function(p){c.dispatch(p),n(":"),t.excludeValues||c.dispatch(i[p]),n(",");})}},_array:function(i,s){s=typeof s<"u"?s:t.unorderedArrays!==!1;var o=this;if(n("array:"+i.length+":"),!s||i.length<=1)return i.forEach(function(d){return o.dispatch(d)});var a=[],l=i.map(function(d){var c=new Nx,p=r.slice(),m=op(t,c,p);return m.dispatch(d),a=a.concat(p.slice(r.length)),c.read().toString()});return r=r.concat(a),l.sort(),this._array(l,!1)},_date:function(i){return n("date:"+i.toJSON())},_symbol:function(i){return n("symbol:"+i.toString())},_error:function(i){return n("error:"+i.toString())},_boolean:function(i){return n("bool:"+i.toString())},_string:function(i){n("string:"+i.length+":"),n(i.toString());},_function:function(i){n("fn:"),Mx(i)?this.dispatch("[native]"):this.dispatch(i.toString()),t.respectFunctionNames!==!1&&this.dispatch("function-name:"+String(i.name)),t.respectFunctionProperties&&this._object(i);},_number:function(i){return n("number:"+i.toString())},_xml:function(i){return n("xml:"+i.toString())},_null:function(){return n("Null")},_undefined:function(){return n("Undefined")},_regexp:function(i){return n("regex:"+i.toString())},_uint8array:function(i){return n("uint8array:"),this.dispatch(Array.prototype.slice.call(i))},_uint8clampedarray:function(i){return n("uint8clampedarray:"),this.dispatch(Array.prototype.slice.call(i))},_int8array:function(i){return n("int8array:"),this.dispatch(Array.prototype.slice.call(i))},_uint16array:function(i){return n("uint16array:"),this.dispatch(Array.prototype.slice.call(i))},_int16array:function(i){return n("int16array:"),this.dispatch(Array.prototype.slice.call(i))},_uint32array:function(i){return n("uint32array:"),this.dispatch(Array.prototype.slice.call(i))},_int32array:function(i){return n("int32array:"),this.dispatch(Array.prototype.slice.call(i))},_float32array:function(i){return n("float32array:"),this.dispatch(Array.prototype.slice.call(i))},_float64array:function(i){return n("float64array:"),this.dispatch(Array.prototype.slice.call(i))},_arraybuffer:function(i){return n("arraybuffer:"),this.dispatch(new Uint8Array(i))},_url:function(i){return n("url:"+i.toString())},_map:function(i){n("map:");var s=Array.from(i);return this._array(s,t.unorderedSets!==!1)},_set:function(i){n("set:");var s=Array.from(i);return this._array(s,t.unorderedSets!==!1)},_file:function(i){return n("file:"),this.dispatch([i.name,i.size,i.type,i.lastModfied])},_blob:function(){if(t.ignoreUnknown)return n("[blob]");throw Error(`Hashing Blob objects is currently not supported
(see https://github.com/puleos/object-hash/issues/26)
Use "options.replacer" or "options.ignoreUnknown"
`)},_domwindow:function(){return n("domwindow")},_bigint:function(i){return n("bigint:"+i.toString())},_process:function(){return n("process")},_timer:function(){return n("timer")},_pipe:function(){return n("pipe")},_tcp:function(){return n("tcp")},_udp:function(){return n("udp")},_tty:function(){return n("tty")},_statwatcher:function(){return n("statwatcher")},_securecontext:function(){return n("securecontext")},_connection:function(){return n("connection")},_zlib:function(){return n("zlib")},_context:function(){return n("context")},_nodescript:function(){return n("nodescript")},_httpparser:function(){return n("httpparser")},_dataview:function(){return n("dataview")},_signal:function(){return n("signal")},_fsevent:function(){return n("fsevent")},_tlswrap:function(){return n("tlswrap")}}}function Nx(){return {buf:"",write:function(t){this.buf+=t;},end:function(t){this.buf+=t;},read:function(){return this.buf}}}});var zx=A((exports,module)=>{var Module=Module!==void 0?Module:{},TreeSitter=function(){var initPromise,document=typeof window=="object"?{currentScript:window.document.currentScript}:null;class Parser{constructor(){this.initialize();}initialize(){throw new Error("cannot construct a Parser before calling `init()`")}static init(moduleOptions){return initPromise||(Module=Object.assign({},Module,moduleOptions),initPromise=new Promise(resolveInitPromise=>{var moduleOverrides=Object.assign({},Module),arguments_=[],thisProgram="./this.program",quit_=(t,e)=>{throw e},ENVIRONMENT_IS_WEB=typeof window=="object",ENVIRONMENT_IS_WORKER=typeof importScripts=="function",ENVIRONMENT_IS_NODE=typeof process=="object"&&typeof process.versions=="object"&&typeof process.versions.node=="string",scriptDirectory="",read_,readAsync,readBinary;function locateFile(t){return Module.locateFile?Module.locateFile(t,scriptDirectory):scriptDirectory+t}function logExceptionOnExit(t){t instanceof ExitStatus||err("exiting due to exception: "+t);}if(ENVIRONMENT_IS_NODE){var fs=oe("fs"),nodePath=oe("path");scriptDirectory=ENVIRONMENT_IS_WORKER?nodePath.dirname(scriptDirectory)+"/":__dirname+"/",read_=(t,e)=>(t=isFileURI(t)?new URL(t):nodePath.normalize(t),fs.readFileSync(t,e?void 0:"utf8")),readBinary=t=>{var e=read_(t,!0);return e.buffer||(e=new Uint8Array(e)),e},readAsync=(t,e,r)=>{t=isFileURI(t)?new URL(t):nodePath.normalize(t),fs.readFile(t,function(n,i){n?r(n):e(i.buffer);});},process.argv.length>1&&(thisProgram=process.argv[1].replace(/\\/g,"/")),arguments_=process.argv.slice(2),typeof module<"u"&&(module.exports=Module),quit_=(t,e)=>{if(keepRuntimeAlive())throw process.exitCode=t,e;logExceptionOnExit(e),process.exit(t);},Module.inspect=function(){return "[Emscripten Module object]"};}else (ENVIRONMENT_IS_WEB||ENVIRONMENT_IS_WORKER)&&(ENVIRONMENT_IS_WORKER?scriptDirectory=self.location.href:document!==void 0&&document.currentScript&&(scriptDirectory=document.currentScript.src),scriptDirectory=scriptDirectory.indexOf("blob:")!==0?scriptDirectory.substr(0,scriptDirectory.replace(/[?#].*/,"").lastIndexOf("/")+1):"",read_=t=>{var e=new XMLHttpRequest;return e.open("GET",t,!1),e.send(null),e.responseText},ENVIRONMENT_IS_WORKER&&(readBinary=t=>{var e=new XMLHttpRequest;return e.open("GET",t,!1),e.responseType="arraybuffer",e.send(null),new Uint8Array(e.response)}),readAsync=(t,e,r)=>{var n=new XMLHttpRequest;n.open("GET",t,!0),n.responseType="arraybuffer",n.onload=()=>{n.status==200||n.status==0&&n.response?e(n.response):r();},n.onerror=r,n.send(null);},t=>document.title=t);Module.print||console.log.bind(console);var err=Module.printErr||console.warn.bind(console);Object.assign(Module,moduleOverrides),moduleOverrides=null,Module.arguments&&(arguments_=Module.arguments),Module.thisProgram&&(thisProgram=Module.thisProgram),Module.quit&&(quit_=Module.quit);var STACK_ALIGN=16,dynamicLibraries=Module.dynamicLibraries||[],wasmBinary;Module.wasmBinary&&(wasmBinary=Module.wasmBinary);var noExitRuntime=Module.noExitRuntime||!0,wasmMemory;typeof WebAssembly!="object"&&abort("no native wasm support detected");var ABORT=!1,EXITSTATUS,UTF8Decoder=typeof TextDecoder<"u"?new TextDecoder("utf8"):void 0,buffer,HEAP8,HEAPU8,HEAP16,HEAP32,HEAPU32,HEAPF32,HEAPF64;function UTF8ArrayToString(t,e,r){for(var n=e+r,i=e;t[i]&&!(i>=n);)++i;if(i-e>16&&t.buffer&&UTF8Decoder)return UTF8Decoder.decode(t.subarray(e,i));for(var s="";e<i;){var o=t[e++];if(128&o){var a=63&t[e++];if((224&o)!=192){var l=63&t[e++];if((o=(240&o)==224?(15&o)<<12|a<<6|l:(7&o)<<18|a<<12|l<<6|63&t[e++])<65536)s+=String.fromCharCode(o);else {var d=o-65536;s+=String.fromCharCode(55296|d>>10,56320|1023&d);}}else s+=String.fromCharCode((31&o)<<6|a);}else s+=String.fromCharCode(o);}return s}function UTF8ToString(t,e){return t?UTF8ArrayToString(HEAPU8,t,e):""}function stringToUTF8Array(t,e,r,n){if(!(n>0))return 0;for(var i=r,s=r+n-1,o=0;o<t.length;++o){var a=t.charCodeAt(o);if(a>=55296&&a<=57343&&(a=65536+((1023&a)<<10)|1023&t.charCodeAt(++o)),a<=127){if(r>=s)break;e[r++]=a;}else if(a<=2047){if(r+1>=s)break;e[r++]=192|a>>6,e[r++]=128|63&a;}else if(a<=65535){if(r+2>=s)break;e[r++]=224|a>>12,e[r++]=128|a>>6&63,e[r++]=128|63&a;}else {if(r+3>=s)break;e[r++]=240|a>>18,e[r++]=128|a>>12&63,e[r++]=128|a>>6&63,e[r++]=128|63&a;}}return e[r]=0,r-i}function stringToUTF8(t,e,r){return stringToUTF8Array(t,HEAPU8,e,r)}function lengthBytesUTF8(t){for(var e=0,r=0;r<t.length;++r){var n=t.charCodeAt(r);n<=127?e++:n<=2047?e+=2:n>=55296&&n<=57343?(e+=4,++r):e+=3;}return e}function updateGlobalBufferAndViews(t){buffer=t,Module.HEAP8=HEAP8=new Int8Array(t),Module.HEAP16=HEAP16=new Int16Array(t),Module.HEAP32=HEAP32=new Int32Array(t),Module.HEAPU8=HEAPU8=new Uint8Array(t),Module.HEAPU16=new Uint16Array(t),Module.HEAPU32=HEAPU32=new Uint32Array(t),Module.HEAPF32=HEAPF32=new Float32Array(t),Module.HEAPF64=HEAPF64=new Float64Array(t);}var INITIAL_MEMORY=Module.INITIAL_MEMORY||33554432;wasmMemory=Module.wasmMemory?Module.wasmMemory:new WebAssembly.Memory({initial:INITIAL_MEMORY/65536,maximum:32768}),wasmMemory&&(buffer=wasmMemory.buffer),INITIAL_MEMORY=buffer.byteLength,updateGlobalBufferAndViews(buffer);var wasmTable=new WebAssembly.Table({initial:20,element:"anyfunc"}),__ATPRERUN__=[],__ATINIT__=[],__ATMAIN__=[],__ATPOSTRUN__=[],__RELOC_FUNCS__=[],runtimeInitialized=!1;function keepRuntimeAlive(){return noExitRuntime}function preRun(){if(Module.preRun)for(typeof Module.preRun=="function"&&(Module.preRun=[Module.preRun]);Module.preRun.length;)addOnPreRun(Module.preRun.shift());callRuntimeCallbacks(__ATPRERUN__);}function initRuntime(){runtimeInitialized=!0,callRuntimeCallbacks(__RELOC_FUNCS__),callRuntimeCallbacks(__ATINIT__);}function preMain(){callRuntimeCallbacks(__ATMAIN__);}function postRun(){if(Module.postRun)for(typeof Module.postRun=="function"&&(Module.postRun=[Module.postRun]);Module.postRun.length;)addOnPostRun(Module.postRun.shift());callRuntimeCallbacks(__ATPOSTRUN__);}function addOnPreRun(t){__ATPRERUN__.unshift(t);}function addOnInit(t){__ATINIT__.unshift(t);}function addOnPostRun(t){__ATPOSTRUN__.unshift(t);}var runDependencies=0,dependenciesFulfilled=null;function addRunDependency(t){runDependencies++,Module.monitorRunDependencies&&Module.monitorRunDependencies(runDependencies);}function removeRunDependency(t){if(runDependencies--,Module.monitorRunDependencies&&Module.monitorRunDependencies(runDependencies),runDependencies==0&&(dependenciesFulfilled)){var e=dependenciesFulfilled;dependenciesFulfilled=null,e();}}function abort(t){throw Module.onAbort&&Module.onAbort(t),err(t="Aborted("+t+")"),ABORT=!0,EXITSTATUS=1,t+=". Build with -sASSERTIONS for more info.",new WebAssembly.RuntimeError(t)}var dataURIPrefix="data:application/octet-stream;base64,",wasmBinaryFile,tempDouble,tempI64;function isDataURI(t){return t.startsWith(dataURIPrefix)}function isFileURI(t){return t.startsWith("file://")}function getBinary(t){try{if(t==wasmBinaryFile&&wasmBinary)return new Uint8Array(wasmBinary);if(readBinary)return readBinary(t);throw "both async and sync fetching of the wasm failed"}catch(e){abort(e);}}function getBinaryPromise(){if(!wasmBinary&&(ENVIRONMENT_IS_WEB||ENVIRONMENT_IS_WORKER)){if(typeof fetch=="function"&&!isFileURI(wasmBinaryFile))return fetch(wasmBinaryFile,{credentials:"same-origin"}).then(function(t){if(!t.ok)throw "failed to load wasm binary file at '"+wasmBinaryFile+"'";return t.arrayBuffer()}).catch(function(){return getBinary(wasmBinaryFile)});if(readAsync)return new Promise(function(t,e){readAsync(wasmBinaryFile,function(r){t(new Uint8Array(r));},e);})}return Promise.resolve().then(function(){return getBinary(wasmBinaryFile)})}function createWasm(){var t={env:asmLibraryArg,wasi_snapshot_preview1:asmLibraryArg,"GOT.mem":new Proxy(asmLibraryArg,GOTHandler),"GOT.func":new Proxy(asmLibraryArg,GOTHandler)};function e(i,s){var o=i.exports;o=relocateExports(o,1024);var a=getDylinkMetadata(s);a.neededDynlibs&&(dynamicLibraries=a.neededDynlibs.concat(dynamicLibraries)),mergeLibSymbols(o),Module.asm=o,addOnInit(Module.asm.__wasm_call_ctors),__RELOC_FUNCS__.push(Module.asm.__wasm_apply_data_relocs),removeRunDependency();}function r(i){e(i.instance,i.module);}function n(i){return getBinaryPromise().then(function(s){return WebAssembly.instantiate(s,t)}).then(function(s){return s}).then(i,function(s){err("failed to asynchronously prepare wasm: "+s),abort(s);})}if(addRunDependency(),Module.instantiateWasm)try{return Module.instantiateWasm(t,e)}catch(i){return err("Module.instantiateWasm callback failed with error: "+i),!1}return wasmBinary||typeof WebAssembly.instantiateStreaming!="function"||isDataURI(wasmBinaryFile)||isFileURI(wasmBinaryFile)||ENVIRONMENT_IS_NODE||typeof fetch!="function"?n(r):fetch(wasmBinaryFile,{credentials:"same-origin"}).then(function(i){return WebAssembly.instantiateStreaming(i,t).then(r,function(s){return err("wasm streaming compile failed: "+s),err("falling back to ArrayBuffer instantiation"),n(r)})}),{}}wasmBinaryFile="tree-sitter.wasm",isDataURI(wasmBinaryFile)||(wasmBinaryFile=locateFile(wasmBinaryFile));function ExitStatus(t){this.name="ExitStatus",this.message="Program terminated with exit("+t+")",this.status=t;}var GOT={},CurrentModuleWeakSymbols=new Set([]),GOTHandler={get:function(t,e){var r=GOT[e];return r||(r=GOT[e]=new WebAssembly.Global({value:"i32",mutable:!0})),CurrentModuleWeakSymbols.has(e)||(r.required=!0),r}};function callRuntimeCallbacks(t){for(;t.length>0;)t.shift()(Module);}function getDylinkMetadata(t){var e=0,r=0;function n(){for(var D=0,g=1;;){var S=t[e++];if(D+=(127&S)*g,g*=128,!(128&S))break}return D}function i(){var D=n();return UTF8ArrayToString(t,(e+=D)-D,D)}function s(D,g){if(D)throw new Error(g)}var o="dylink.0";if(t instanceof WebAssembly.Module){var a=WebAssembly.Module.customSections(t,o);a.length===0&&(o="dylink",a=WebAssembly.Module.customSections(t,o)),s(a.length===0,"need dylink section"),r=(t=new Uint8Array(a[0])).length;}else {s(new Uint32Array(new Uint8Array(t.subarray(0,24)).buffer)[0]!=1836278016,"need to see wasm magic number"),s(t[8]!==0,"need the dylink section to be first"),e=9;var l=n();r=e+l,o=i();}var d={neededDynlibs:[],tlsExports:new Set,weakImports:new Set};if(o=="dylink"){d.memorySize=n(),d.memoryAlign=n(),d.tableSize=n(),d.tableAlign=n();for(var c=n(),p=0;p<c;++p){var m=i();d.neededDynlibs.push(m);}}else for(s(o!=="dylink.0");e<r;){var _=t[e++],w=n();if(_===1)d.memorySize=n(),d.memoryAlign=n(),d.tableSize=n(),d.tableAlign=n();else if(_===2)for(c=n(),p=0;p<c;++p)m=i(),d.neededDynlibs.push(m);else if(_===3)for(var E=n();E--;){var P=i();256&n()&&d.tlsExports.add(P);}else if(_===4)for(E=n();E--;)i(),P=i(),(3&n())==1&&d.weakImports.add(P);else e+=w;}return d}function getValue(t,e="i8"){switch(e.endsWith("*")&&(e="*"),e){case"i1":case"i8":return HEAP8[t>>0];case"i16":return HEAP16[t>>1];case"i32":case"i64":return HEAP32[t>>2];case"float":return HEAPF32[t>>2];case"double":return HEAPF64[t>>3];case"*":return HEAPU32[t>>2];default:abort("invalid type for getValue: "+e);}return null}function asmjsMangle(t){return t.indexOf("dynCall_")==0||["stackAlloc","stackSave","stackRestore","getTempRet0","setTempRet0"].includes(t)?t:"_"+t}function mergeLibSymbols(t,e){for(var r in t)if(t.hasOwnProperty(r)){asmLibraryArg.hasOwnProperty(r)||(asmLibraryArg[r]=t[r]);var n=asmjsMangle(r);Module.hasOwnProperty(n)||(Module[n]=t[r]),r=="__main_argc_argv"&&(Module._main=t[r]);}}var LDSO={loadedLibsByName:{},loadedLibsByHandle:{}};function dynCallLegacy(t,e,r){var n=Module["dynCall_"+t];return r&&r.length?n.apply(null,[e].concat(r)):n.call(null,e)}var wasmTableMirror=[];function getWasmTableEntry(t){var e=wasmTableMirror[t];return e||(t>=wasmTableMirror.length&&(wasmTableMirror.length=t+1),wasmTableMirror[t]=e=wasmTable.get(t)),e}function dynCall(t,e,r){return t.includes("j")?dynCallLegacy(t,e,r):getWasmTableEntry(e).apply(null,r)}function createInvokeFunction(t){return function(){var e=stackSave();try{return dynCall(t,arguments[0],Array.prototype.slice.call(arguments,1))}catch(r){if(stackRestore(e),r!==r+0)throw r;_setThrew(1,0);}}}var ___heap_base=78144;function zeroMemory(t,e){return HEAPU8.fill(0,t,t+e),t}function getMemory(t){if(runtimeInitialized)return zeroMemory(_malloc(t),t);var e=___heap_base,r=e+t+15&-16;return ___heap_base=r,GOT.__heap_base.value=r,e}function isInternalSym(t){return ["__cpp_exception","__c_longjmp","__wasm_apply_data_relocs","__dso_handle","__tls_size","__tls_align","__set_stack_limits","_emscripten_tls_init","__wasm_init_tls","__wasm_call_ctors","__start_em_asm","__stop_em_asm"].includes(t)}function uleb128Encode(t,e){t<128?e.push(t):e.push(t%128|128,t>>7);}function sigToWasmTypes(t){for(var e={i:"i32",j:"i32",f:"f32",d:"f64",p:"i32"},r={parameters:[],results:t[0]=="v"?[]:[e[t[0]]]},n=1;n<t.length;++n)r.parameters.push(e[t[n]]),t[n]==="j"&&r.parameters.push("i32");return r}function generateFuncType(t,e){var r=t.slice(0,1),n=t.slice(1),i={i:127,p:127,j:126,f:125,d:124};e.push(96),uleb128Encode(n.length,e);for(var s=0;s<n.length;++s)e.push(i[n[s]]);r=="v"?e.push(0):e.push(1,i[r]);}function convertJsFunctionToWasm(t,e){if(typeof WebAssembly.Function=="function")return new WebAssembly.Function(sigToWasmTypes(e),t);var r=[1];generateFuncType(e,r);var n=[0,97,115,109,1,0,0,0,1];uleb128Encode(r.length,n),n.push.apply(n,r),n.push(2,7,1,1,101,1,102,0,0,7,5,1,1,102,0,0);var i=new WebAssembly.Module(new Uint8Array(n));return new WebAssembly.Instance(i,{e:{f:t}}).exports.f}function updateTableMap(t,e){if(functionsInTableMap)for(var r=t;r<t+e;r++){var n=getWasmTableEntry(r);n&&functionsInTableMap.set(n,r);}}var functionsInTableMap=void 0,freeTableIndexes=[];function getEmptyTableSlot(){if(freeTableIndexes.length)return freeTableIndexes.pop();try{wasmTable.grow(1);}catch(t){throw t instanceof RangeError?"Unable to grow wasm table. Set ALLOW_TABLE_GROWTH.":t}return wasmTable.length-1}function setWasmTableEntry(t,e){wasmTable.set(t,e),wasmTableMirror[t]=wasmTable.get(t);}function addFunction(t,e){if(functionsInTableMap||(functionsInTableMap=new WeakMap,updateTableMap(0,wasmTable.length)),functionsInTableMap.has(t))return functionsInTableMap.get(t);var r=getEmptyTableSlot();try{setWasmTableEntry(r,t);}catch(n){if(!(n instanceof TypeError))throw n;setWasmTableEntry(r,convertJsFunctionToWasm(t,e));}return functionsInTableMap.set(t,r),r}function updateGOT(t,e){for(var r in t)if(!isInternalSym(r)){var n=t[r];r.startsWith("orig$")&&(r=r.split("$")[1],e=!0),GOT[r]||(GOT[r]=new WebAssembly.Global({value:"i32",mutable:!0})),(e||GOT[r].value==0)&&(typeof n=="function"?GOT[r].value=addFunction(n):typeof n=="number"?GOT[r].value=n:err("unhandled export type for `"+r+"`: "+typeof n));}}function relocateExports(t,e,r){var n={};for(var i in t){var s=t[i];typeof s=="object"&&(s=s.value),typeof s=="number"&&(s+=e),n[i]=s;}return updateGOT(n,r),n}function resolveGlobalSymbol(t,e){var r;return e&&(r=asmLibraryArg["orig$"+t]),r||(r=asmLibraryArg[t])&&r.stub&&(r=void 0),r||(r=Module[asmjsMangle(t)]),!r&&t.startsWith("invoke_")&&(r=createInvokeFunction(t.split("_")[1])),r}function alignMemory(t,e){return Math.ceil(t/e)*e}function loadWebAssemblyModule(binary,flags,handle){var metadata=getDylinkMetadata(binary);function loadModule(){var firstLoad=!handle||!HEAP8[handle+12>>0];if(firstLoad){var memAlign=Math.pow(2,metadata.memoryAlign);memAlign=Math.max(memAlign,STACK_ALIGN);var memoryBase=metadata.memorySize?alignMemory(getMemory(metadata.memorySize+memAlign),memAlign):0,tableBase=metadata.tableSize?wasmTable.length:0;handle&&(HEAP8[handle+12>>0]=1,HEAPU32[handle+16>>2]=memoryBase,HEAP32[handle+20>>2]=metadata.memorySize,HEAPU32[handle+24>>2]=tableBase,HEAP32[handle+28>>2]=metadata.tableSize);}else memoryBase=HEAPU32[handle+16>>2],tableBase=HEAPU32[handle+24>>2];var tableGrowthNeeded=tableBase+metadata.tableSize-wasmTable.length,moduleExports;function resolveSymbol(t){var e=resolveGlobalSymbol(t,!1);return e||(e=moduleExports[t]),e}tableGrowthNeeded>0&&wasmTable.grow(tableGrowthNeeded);var proxyHandler={get:function(t,e){switch(e){case"__memory_base":return memoryBase;case"__table_base":return tableBase}if(e in asmLibraryArg)return asmLibraryArg[e];var r;return e in t||(t[e]=function(){return r||(r=resolveSymbol(e)),r.apply(null,arguments)}),t[e]}},proxy=new Proxy({},proxyHandler),info={"GOT.mem":new Proxy({},GOTHandler),"GOT.func":new Proxy({},GOTHandler),env:proxy,wasi_snapshot_preview1:proxy};function postInstantiation(instance){function addEmAsm(addr,body){for(var args=[],arity=0;arity<16&&body.indexOf("$"+arity)!=-1;arity++)args.push("$"+arity);args=args.join(",");var func="("+args+" ) => { "+body+"};";eval(func);}if(updateTableMap(tableBase,metadata.tableSize),moduleExports=relocateExports(instance.exports,memoryBase),flags.allowUndefined||reportUndefinedSymbols(),"__start_em_asm"in moduleExports)for(var start=moduleExports.__start_em_asm,stop=moduleExports.__stop_em_asm;start<stop;){var jsString=UTF8ToString(start);addEmAsm(start,jsString),start=HEAPU8.indexOf(0,start)+1;}var applyRelocs=moduleExports.__wasm_apply_data_relocs;applyRelocs&&(runtimeInitialized?applyRelocs():__RELOC_FUNCS__.push(applyRelocs));var init=moduleExports.__wasm_call_ctors;return init&&(runtimeInitialized?init():__ATINIT__.push(init)),moduleExports}if(flags.loadAsync){if(binary instanceof WebAssembly.Module){var instance=new WebAssembly.Instance(binary,info);return Promise.resolve(postInstantiation(instance))}return WebAssembly.instantiate(binary,info).then(function(t){return postInstantiation(t.instance)})}var module=binary instanceof WebAssembly.Module?binary:new WebAssembly.Module(binary),instance=new WebAssembly.Instance(module,info);return postInstantiation(instance)}return CurrentModuleWeakSymbols=metadata.weakImports,flags.loadAsync?metadata.neededDynlibs.reduce(function(t,e){return t.then(function(){return loadDynamicLibrary(e,flags)})},Promise.resolve()).then(function(){return loadModule()}):(metadata.neededDynlibs.forEach(function(t){loadDynamicLibrary(t,flags);}),loadModule())}function loadDynamicLibrary(t,e,r){e=e||{global:!0,nodelete:!0};var n=LDSO.loadedLibsByName[t];if(n)return e.global&&!n.global&&(n.global=!0,n.module!=="loading"&&mergeLibSymbols(n.module)),e.nodelete&&n.refcount!==1/0&&(n.refcount=1/0),n.refcount++,r&&(LDSO.loadedLibsByHandle[r]=n),!e.loadAsync||Promise.resolve(!0);function i(a){if(e.fs&&e.fs.findObject(a)){var l=e.fs.readFile(a,{encoding:"binary"});return l instanceof Uint8Array||(l=new Uint8Array(l)),e.loadAsync?Promise.resolve(l):l}if(a=locateFile(a),e.loadAsync)return new Promise(function(d,c){readAsync(a,p=>d(new Uint8Array(p)),c);});if(!readBinary)throw new Error(a+": file not found, and synchronous loading of external files is not available");return readBinary(a)}function s(){if(typeof preloadedWasm<"u"&&preloadedWasm[t]){var a=preloadedWasm[t];return e.loadAsync?Promise.resolve(a):a}return e.loadAsync?i(t).then(function(l){return loadWebAssemblyModule(l,e,r)}):loadWebAssemblyModule(i(t),e,r)}function o(a){n.global&&mergeLibSymbols(a),n.module=a;}return n={refcount:e.nodelete?1/0:1,name:t,module:"loading",global:e.global},LDSO.loadedLibsByName[t]=n,r&&(LDSO.loadedLibsByHandle[r]=n),e.loadAsync?s().then(function(a){return o(a),!0}):(o(s()),!0)}function reportUndefinedSymbols(){for(var t in GOT)if(GOT[t].value==0){var e=resolveGlobalSymbol(t,!0);if(!e&&!GOT[t].required)continue;if(typeof e=="function")GOT[t].value=addFunction(e,e.sig);else {if(typeof e!="number")throw new Error("bad export type for `"+t+"`: "+typeof e);GOT[t].value=e;}}}function preloadDylibs(){dynamicLibraries.length?(addRunDependency(),dynamicLibraries.reduce(function(t,e){return t.then(function(){return loadDynamicLibrary(e,{loadAsync:!0,global:!0,nodelete:!0,allowUndefined:!0})})},Promise.resolve()).then(function(){reportUndefinedSymbols(),removeRunDependency();})):reportUndefinedSymbols();}function setValue(t,e,r="i8"){switch(r.endsWith("*")&&(r="*"),r){case"i1":case"i8":HEAP8[t>>0]=e;break;case"i16":HEAP16[t>>1]=e;break;case"i32":HEAP32[t>>2]=e;break;case"i64":tempI64=[e>>>0,(tempDouble=e,+Math.abs(tempDouble)>=1?tempDouble>0?(0|Math.min(+Math.floor(tempDouble/4294967296),4294967295))>>>0:~~+Math.ceil((tempDouble-+(~~tempDouble>>>0))/4294967296)>>>0:0)],HEAP32[t>>2]=tempI64[0],HEAP32[t+4>>2]=tempI64[1];break;case"float":HEAPF32[t>>2]=e;break;case"double":HEAPF64[t>>3]=e;break;case"*":HEAPU32[t>>2]=e;break;default:abort("invalid type for setValue: "+r);}}var ___memory_base=new WebAssembly.Global({value:"i32",mutable:!1},1024),___stack_pointer=new WebAssembly.Global({value:"i32",mutable:!0},78144),___table_base=new WebAssembly.Global({value:"i32",mutable:!1},1),nowIsMonotonic=!0,_emscripten_get_now;function __emscripten_get_now_is_monotonic(){return nowIsMonotonic}function _abort(){abort("");}function _emscripten_memcpy_big(t,e,r){HEAPU8.copyWithin(t,e,e+r);}function getHeapMax(){return 2147483648}function emscripten_realloc_buffer(t){try{return wasmMemory.grow(t-buffer.byteLength+65535>>>16),updateGlobalBufferAndViews(wasmMemory.buffer),1}catch{}}function _emscripten_resize_heap(t){var e=HEAPU8.length;t>>>=0;var r=getHeapMax();if(t>r)return !1;for(var n=1;n<=4;n*=2){var i=e*(1+.2/n);if(i=Math.min(i,t+100663296),emscripten_realloc_buffer(Math.min(r,(s=Math.max(t,i))+((o=65536)-s%o)%o)))return !0}var s,o;return !1}__emscripten_get_now_is_monotonic.sig="i",Module._abort=_abort,_abort.sig="v",_emscripten_get_now=ENVIRONMENT_IS_NODE?()=>{var t=process.hrtime();return 1e3*t[0]+t[1]/1e6}:()=>performance.now(),_emscripten_get_now.sig="d",_emscripten_memcpy_big.sig="vppp",_emscripten_resize_heap.sig="ip";var SYSCALLS={DEFAULT_POLLMASK:5,calculateAt:function(t,e,r){if(PATH.isAbs(e))return e;var n;if(t===-100?n=FS.cwd():n=SYSCALLS.getStreamFromFD(t).path,e.length==0){if(!r)throw new FS.ErrnoError(44);return n}return PATH.join2(n,e)},doStat:function(t,e,r){try{var n=t(e);}catch(a){if(a&&a.node&&PATH.normalize(e)!==PATH.normalize(FS.getPath(a.node)))return -54;throw a}HEAP32[r>>2]=n.dev,HEAP32[r+8>>2]=n.ino,HEAP32[r+12>>2]=n.mode,HEAPU32[r+16>>2]=n.nlink,HEAP32[r+20>>2]=n.uid,HEAP32[r+24>>2]=n.gid,HEAP32[r+28>>2]=n.rdev,tempI64=[n.size>>>0,(tempDouble=n.size,+Math.abs(tempDouble)>=1?tempDouble>0?(0|Math.min(+Math.floor(tempDouble/4294967296),4294967295))>>>0:~~+Math.ceil((tempDouble-+(~~tempDouble>>>0))/4294967296)>>>0:0)],HEAP32[r+40>>2]=tempI64[0],HEAP32[r+44>>2]=tempI64[1],HEAP32[r+48>>2]=4096,HEAP32[r+52>>2]=n.blocks;var i=n.atime.getTime(),s=n.mtime.getTime(),o=n.ctime.getTime();return tempI64=[Math.floor(i/1e3)>>>0,(tempDouble=Math.floor(i/1e3),+Math.abs(tempDouble)>=1?tempDouble>0?(0|Math.min(+Math.floor(tempDouble/4294967296),4294967295))>>>0:~~+Math.ceil((tempDouble-+(~~tempDouble>>>0))/4294967296)>>>0:0)],HEAP32[r+56>>2]=tempI64[0],HEAP32[r+60>>2]=tempI64[1],HEAPU32[r+64>>2]=i%1e3*1e3,tempI64=[Math.floor(s/1e3)>>>0,(tempDouble=Math.floor(s/1e3),+Math.abs(tempDouble)>=1?tempDouble>0?(0|Math.min(+Math.floor(tempDouble/4294967296),4294967295))>>>0:~~+Math.ceil((tempDouble-+(~~tempDouble>>>0))/4294967296)>>>0:0)],HEAP32[r+72>>2]=tempI64[0],HEAP32[r+76>>2]=tempI64[1],HEAPU32[r+80>>2]=s%1e3*1e3,tempI64=[Math.floor(o/1e3)>>>0,(tempDouble=Math.floor(o/1e3),+Math.abs(tempDouble)>=1?tempDouble>0?(0|Math.min(+Math.floor(tempDouble/4294967296),4294967295))>>>0:~~+Math.ceil((tempDouble-+(~~tempDouble>>>0))/4294967296)>>>0:0)],HEAP32[r+88>>2]=tempI64[0],HEAP32[r+92>>2]=tempI64[1],HEAPU32[r+96>>2]=o%1e3*1e3,tempI64=[n.ino>>>0,(tempDouble=n.ino,+Math.abs(tempDouble)>=1?tempDouble>0?(0|Math.min(+Math.floor(tempDouble/4294967296),4294967295))>>>0:~~+Math.ceil((tempDouble-+(~~tempDouble>>>0))/4294967296)>>>0:0)],HEAP32[r+104>>2]=tempI64[0],HEAP32[r+108>>2]=tempI64[1],0},doMsync:function(t,e,r,n,i){if(!FS.isFile(e.node.mode))throw new FS.ErrnoError(43);if(2&n)return 0;var s=HEAPU8.slice(t,t+r);FS.msync(e,s,i,r,n);},varargs:void 0,get:function(){return SYSCALLS.varargs+=4,HEAP32[SYSCALLS.varargs-4>>2]},getStr:function(t){return UTF8ToString(t)},getStreamFromFD:function(t){var e=FS.getStream(t);if(!e)throw new FS.ErrnoError(8);return e}};function _proc_exit(t){EXITSTATUS=t,keepRuntimeAlive()||(Module.onExit&&Module.onExit(t),ABORT=!0),quit_(t,new ExitStatus(t));}function exitJS(t,e){EXITSTATUS=t,_proc_exit(t);}_proc_exit.sig="vi";var _exit=exitJS;function _fd_close(t){try{var e=SYSCALLS.getStreamFromFD(t);return FS.close(e),0}catch(r){if(typeof FS>"u"||!(r instanceof FS.ErrnoError))throw r;return r.errno}}function convertI32PairToI53Checked(t,e){return e+2097152>>>0<4194305-!!t?(t>>>0)+4294967296*e:NaN}function _fd_seek(t,e,r,n,i){try{var s=convertI32PairToI53Checked(e,r);if(isNaN(s))return 61;var o=SYSCALLS.getStreamFromFD(t);return FS.llseek(o,s,n),tempI64=[o.position>>>0,(tempDouble=o.position,+Math.abs(tempDouble)>=1?tempDouble>0?(0|Math.min(+Math.floor(tempDouble/4294967296),4294967295))>>>0:~~+Math.ceil((tempDouble-+(~~tempDouble>>>0))/4294967296)>>>0:0)],HEAP32[i>>2]=tempI64[0],HEAP32[i+4>>2]=tempI64[1],o.getdents&&s===0&&n===0&&(o.getdents=null),0}catch(a){if(typeof FS>"u"||!(a instanceof FS.ErrnoError))throw a;return a.errno}}function doWritev(t,e,r,n){for(var i=0,s=0;s<r;s++){var o=HEAPU32[e>>2],a=HEAPU32[e+4>>2];e+=8;var l=FS.write(t,HEAP8,o,a,n);if(l<0)return -1;i+=l,n!==void 0&&(n+=l);}return i}function _fd_write(t,e,r,n){try{var i=doWritev(SYSCALLS.getStreamFromFD(t),e,r);return HEAPU32[n>>2]=i,0}catch(s){if(typeof FS>"u"||!(s instanceof FS.ErrnoError))throw s;return s.errno}}function _tree_sitter_log_callback(t,e){if(currentLogCallback){let r=UTF8ToString(e);currentLogCallback(r,t!==0);}}function _tree_sitter_parse_callback(t,e,r,n,i){var s=currentParseCallback(e,{row:r,column:n});typeof s=="string"?(setValue(i,s.length,"i32"),stringToUTF16(s,t,10240)):setValue(i,0,"i32");}function handleException(t){if(t instanceof ExitStatus||t=="unwind")return EXITSTATUS;quit_(1,t);}function allocateUTF8OnStack(t){var e=lengthBytesUTF8(t)+1,r=stackAlloc(e);return stringToUTF8Array(t,HEAP8,r,e),r}function stringToUTF16(t,e,r){if(r===void 0&&(r=2147483647),r<2)return 0;for(var n=e,i=(r-=2)<2*t.length?r/2:t.length,s=0;s<i;++s){var o=t.charCodeAt(s);HEAP16[e>>1]=o,e+=2;}return HEAP16[e>>1]=0,e-n}function AsciiToString(t){for(var e="";;){var r=HEAPU8[t++>>0];if(!r)return e;e+=String.fromCharCode(r);}}_exit.sig="vi",_fd_close.sig="ii",_fd_seek.sig="iijip",_fd_write.sig="iippp";var asmLibraryArg={__heap_base:___heap_base,__indirect_function_table:wasmTable,__memory_base:___memory_base,__stack_pointer:___stack_pointer,__table_base:___table_base,_emscripten_get_now_is_monotonic:__emscripten_get_now_is_monotonic,abort:_abort,emscripten_get_now:_emscripten_get_now,emscripten_memcpy_big:_emscripten_memcpy_big,emscripten_resize_heap:_emscripten_resize_heap,exit:_exit,fd_close:_fd_close,fd_seek:_fd_seek,fd_write:_fd_write,memory:wasmMemory,tree_sitter_log_callback:_tree_sitter_log_callback,tree_sitter_parse_callback:_tree_sitter_parse_callback};createWasm();Module.___wasm_call_ctors=function(){return (Module.___wasm_call_ctors=Module.asm.__wasm_call_ctors).apply(null,arguments)};Module.___wasm_apply_data_relocs=function(){return (Module.___wasm_apply_data_relocs=Module.asm.__wasm_apply_data_relocs).apply(null,arguments)};var _malloc=Module._malloc=function(){return (_malloc=Module._malloc=Module.asm.malloc).apply(null,arguments)};Module._calloc=function(){return (Module._calloc=Module.asm.calloc).apply(null,arguments)};Module._realloc=function(){return (Module._realloc=Module.asm.realloc).apply(null,arguments)};Module._free=function(){return (Module._free=Module.asm.free).apply(null,arguments)};Module._ts_language_symbol_count=function(){return (Module._ts_language_symbol_count=Module.asm.ts_language_symbol_count).apply(null,arguments)};Module._ts_language_version=function(){return (Module._ts_language_version=Module.asm.ts_language_version).apply(null,arguments)};Module._ts_language_field_count=function(){return (Module._ts_language_field_count=Module.asm.ts_language_field_count).apply(null,arguments)};Module._ts_language_symbol_name=function(){return (Module._ts_language_symbol_name=Module.asm.ts_language_symbol_name).apply(null,arguments)};Module._ts_language_symbol_for_name=function(){return (Module._ts_language_symbol_for_name=Module.asm.ts_language_symbol_for_name).apply(null,arguments)};Module._ts_language_symbol_type=function(){return (Module._ts_language_symbol_type=Module.asm.ts_language_symbol_type).apply(null,arguments)};Module._ts_language_field_name_for_id=function(){return (Module._ts_language_field_name_for_id=Module.asm.ts_language_field_name_for_id).apply(null,arguments)};Module._memset=function(){return (Module._memset=Module.asm.memset).apply(null,arguments)};Module._memcpy=function(){return (Module._memcpy=Module.asm.memcpy).apply(null,arguments)};Module._ts_parser_delete=function(){return (Module._ts_parser_delete=Module.asm.ts_parser_delete).apply(null,arguments)};Module._ts_parser_reset=function(){return (Module._ts_parser_reset=Module.asm.ts_parser_reset).apply(null,arguments)};Module._ts_parser_set_language=function(){return (Module._ts_parser_set_language=Module.asm.ts_parser_set_language).apply(null,arguments)};Module._ts_parser_timeout_micros=function(){return (Module._ts_parser_timeout_micros=Module.asm.ts_parser_timeout_micros).apply(null,arguments)};Module._ts_parser_set_timeout_micros=function(){return (Module._ts_parser_set_timeout_micros=Module.asm.ts_parser_set_timeout_micros).apply(null,arguments)};Module._memmove=function(){return (Module._memmove=Module.asm.memmove).apply(null,arguments)};Module._memcmp=function(){return (Module._memcmp=Module.asm.memcmp).apply(null,arguments)};Module._ts_query_new=function(){return (Module._ts_query_new=Module.asm.ts_query_new).apply(null,arguments)};Module._ts_query_delete=function(){return (Module._ts_query_delete=Module.asm.ts_query_delete).apply(null,arguments)};Module._iswspace=function(){return (Module._iswspace=Module.asm.iswspace).apply(null,arguments)};Module._iswalnum=function(){return (Module._iswalnum=Module.asm.iswalnum).apply(null,arguments)};Module._ts_query_pattern_count=function(){return (Module._ts_query_pattern_count=Module.asm.ts_query_pattern_count).apply(null,arguments)};Module._ts_query_capture_count=function(){return (Module._ts_query_capture_count=Module.asm.ts_query_capture_count).apply(null,arguments)};Module._ts_query_string_count=function(){return (Module._ts_query_string_count=Module.asm.ts_query_string_count).apply(null,arguments)};Module._ts_query_capture_name_for_id=function(){return (Module._ts_query_capture_name_for_id=Module.asm.ts_query_capture_name_for_id).apply(null,arguments)};Module._ts_query_string_value_for_id=function(){return (Module._ts_query_string_value_for_id=Module.asm.ts_query_string_value_for_id).apply(null,arguments)};Module._ts_query_predicates_for_pattern=function(){return (Module._ts_query_predicates_for_pattern=Module.asm.ts_query_predicates_for_pattern).apply(null,arguments)};Module._ts_tree_copy=function(){return (Module._ts_tree_copy=Module.asm.ts_tree_copy).apply(null,arguments)};Module._ts_tree_delete=function(){return (Module._ts_tree_delete=Module.asm.ts_tree_delete).apply(null,arguments)};Module._ts_init=function(){return (Module._ts_init=Module.asm.ts_init).apply(null,arguments)};Module._ts_parser_new_wasm=function(){return (Module._ts_parser_new_wasm=Module.asm.ts_parser_new_wasm).apply(null,arguments)};Module._ts_parser_enable_logger_wasm=function(){return (Module._ts_parser_enable_logger_wasm=Module.asm.ts_parser_enable_logger_wasm).apply(null,arguments)};Module._ts_parser_parse_wasm=function(){return (Module._ts_parser_parse_wasm=Module.asm.ts_parser_parse_wasm).apply(null,arguments)};Module._ts_language_type_is_named_wasm=function(){return (Module._ts_language_type_is_named_wasm=Module.asm.ts_language_type_is_named_wasm).apply(null,arguments)};Module._ts_language_type_is_visible_wasm=function(){return (Module._ts_language_type_is_visible_wasm=Module.asm.ts_language_type_is_visible_wasm).apply(null,arguments)};Module._ts_tree_root_node_wasm=function(){return (Module._ts_tree_root_node_wasm=Module.asm.ts_tree_root_node_wasm).apply(null,arguments)};Module._ts_tree_edit_wasm=function(){return (Module._ts_tree_edit_wasm=Module.asm.ts_tree_edit_wasm).apply(null,arguments)};Module._ts_tree_get_changed_ranges_wasm=function(){return (Module._ts_tree_get_changed_ranges_wasm=Module.asm.ts_tree_get_changed_ranges_wasm).apply(null,arguments)};Module._ts_tree_cursor_new_wasm=function(){return (Module._ts_tree_cursor_new_wasm=Module.asm.ts_tree_cursor_new_wasm).apply(null,arguments)};Module._ts_tree_cursor_delete_wasm=function(){return (Module._ts_tree_cursor_delete_wasm=Module.asm.ts_tree_cursor_delete_wasm).apply(null,arguments)};Module._ts_tree_cursor_reset_wasm=function(){return (Module._ts_tree_cursor_reset_wasm=Module.asm.ts_tree_cursor_reset_wasm).apply(null,arguments)};Module._ts_tree_cursor_goto_first_child_wasm=function(){return (Module._ts_tree_cursor_goto_first_child_wasm=Module.asm.ts_tree_cursor_goto_first_child_wasm).apply(null,arguments)};Module._ts_tree_cursor_goto_next_sibling_wasm=function(){return (Module._ts_tree_cursor_goto_next_sibling_wasm=Module.asm.ts_tree_cursor_goto_next_sibling_wasm).apply(null,arguments)};Module._ts_tree_cursor_goto_parent_wasm=function(){return (Module._ts_tree_cursor_goto_parent_wasm=Module.asm.ts_tree_cursor_goto_parent_wasm).apply(null,arguments)};Module._ts_tree_cursor_current_node_type_id_wasm=function(){return (Module._ts_tree_cursor_current_node_type_id_wasm=Module.asm.ts_tree_cursor_current_node_type_id_wasm).apply(null,arguments)};Module._ts_tree_cursor_current_node_is_named_wasm=function(){return (Module._ts_tree_cursor_current_node_is_named_wasm=Module.asm.ts_tree_cursor_current_node_is_named_wasm).apply(null,arguments)};Module._ts_tree_cursor_current_node_is_missing_wasm=function(){return (Module._ts_tree_cursor_current_node_is_missing_wasm=Module.asm.ts_tree_cursor_current_node_is_missing_wasm).apply(null,arguments)};Module._ts_tree_cursor_current_node_id_wasm=function(){return (Module._ts_tree_cursor_current_node_id_wasm=Module.asm.ts_tree_cursor_current_node_id_wasm).apply(null,arguments)};Module._ts_tree_cursor_start_position_wasm=function(){return (Module._ts_tree_cursor_start_position_wasm=Module.asm.ts_tree_cursor_start_position_wasm).apply(null,arguments)};Module._ts_tree_cursor_end_position_wasm=function(){return (Module._ts_tree_cursor_end_position_wasm=Module.asm.ts_tree_cursor_end_position_wasm).apply(null,arguments)};Module._ts_tree_cursor_start_index_wasm=function(){return (Module._ts_tree_cursor_start_index_wasm=Module.asm.ts_tree_cursor_start_index_wasm).apply(null,arguments)};Module._ts_tree_cursor_end_index_wasm=function(){return (Module._ts_tree_cursor_end_index_wasm=Module.asm.ts_tree_cursor_end_index_wasm).apply(null,arguments)};Module._ts_tree_cursor_current_field_id_wasm=function(){return (Module._ts_tree_cursor_current_field_id_wasm=Module.asm.ts_tree_cursor_current_field_id_wasm).apply(null,arguments)};Module._ts_tree_cursor_current_node_wasm=function(){return (Module._ts_tree_cursor_current_node_wasm=Module.asm.ts_tree_cursor_current_node_wasm).apply(null,arguments)};Module._ts_node_symbol_wasm=function(){return (Module._ts_node_symbol_wasm=Module.asm.ts_node_symbol_wasm).apply(null,arguments)};Module._ts_node_child_count_wasm=function(){return (Module._ts_node_child_count_wasm=Module.asm.ts_node_child_count_wasm).apply(null,arguments)};Module._ts_node_named_child_count_wasm=function(){return (Module._ts_node_named_child_count_wasm=Module.asm.ts_node_named_child_count_wasm).apply(null,arguments)};Module._ts_node_child_wasm=function(){return (Module._ts_node_child_wasm=Module.asm.ts_node_child_wasm).apply(null,arguments)};Module._ts_node_named_child_wasm=function(){return (Module._ts_node_named_child_wasm=Module.asm.ts_node_named_child_wasm).apply(null,arguments)};Module._ts_node_child_by_field_id_wasm=function(){return (Module._ts_node_child_by_field_id_wasm=Module.asm.ts_node_child_by_field_id_wasm).apply(null,arguments)};Module._ts_node_next_sibling_wasm=function(){return (Module._ts_node_next_sibling_wasm=Module.asm.ts_node_next_sibling_wasm).apply(null,arguments)};Module._ts_node_prev_sibling_wasm=function(){return (Module._ts_node_prev_sibling_wasm=Module.asm.ts_node_prev_sibling_wasm).apply(null,arguments)};Module._ts_node_next_named_sibling_wasm=function(){return (Module._ts_node_next_named_sibling_wasm=Module.asm.ts_node_next_named_sibling_wasm).apply(null,arguments)};Module._ts_node_prev_named_sibling_wasm=function(){return (Module._ts_node_prev_named_sibling_wasm=Module.asm.ts_node_prev_named_sibling_wasm).apply(null,arguments)};Module._ts_node_parent_wasm=function(){return (Module._ts_node_parent_wasm=Module.asm.ts_node_parent_wasm).apply(null,arguments)};Module._ts_node_descendant_for_index_wasm=function(){return (Module._ts_node_descendant_for_index_wasm=Module.asm.ts_node_descendant_for_index_wasm).apply(null,arguments)};Module._ts_node_named_descendant_for_index_wasm=function(){return (Module._ts_node_named_descendant_for_index_wasm=Module.asm.ts_node_named_descendant_for_index_wasm).apply(null,arguments)};Module._ts_node_descendant_for_position_wasm=function(){return (Module._ts_node_descendant_for_position_wasm=Module.asm.ts_node_descendant_for_position_wasm).apply(null,arguments)};Module._ts_node_named_descendant_for_position_wasm=function(){return (Module._ts_node_named_descendant_for_position_wasm=Module.asm.ts_node_named_descendant_for_position_wasm).apply(null,arguments)};Module._ts_node_start_point_wasm=function(){return (Module._ts_node_start_point_wasm=Module.asm.ts_node_start_point_wasm).apply(null,arguments)};Module._ts_node_end_point_wasm=function(){return (Module._ts_node_end_point_wasm=Module.asm.ts_node_end_point_wasm).apply(null,arguments)};Module._ts_node_start_index_wasm=function(){return (Module._ts_node_start_index_wasm=Module.asm.ts_node_start_index_wasm).apply(null,arguments)};Module._ts_node_end_index_wasm=function(){return (Module._ts_node_end_index_wasm=Module.asm.ts_node_end_index_wasm).apply(null,arguments)};Module._ts_node_to_string_wasm=function(){return (Module._ts_node_to_string_wasm=Module.asm.ts_node_to_string_wasm).apply(null,arguments)};Module._ts_node_children_wasm=function(){return (Module._ts_node_children_wasm=Module.asm.ts_node_children_wasm).apply(null,arguments)};Module._ts_node_named_children_wasm=function(){return (Module._ts_node_named_children_wasm=Module.asm.ts_node_named_children_wasm).apply(null,arguments)};Module._ts_node_descendants_of_type_wasm=function(){return (Module._ts_node_descendants_of_type_wasm=Module.asm.ts_node_descendants_of_type_wasm).apply(null,arguments)};Module._ts_node_is_named_wasm=function(){return (Module._ts_node_is_named_wasm=Module.asm.ts_node_is_named_wasm).apply(null,arguments)};Module._ts_node_has_changes_wasm=function(){return (Module._ts_node_has_changes_wasm=Module.asm.ts_node_has_changes_wasm).apply(null,arguments)};Module._ts_node_has_error_wasm=function(){return (Module._ts_node_has_error_wasm=Module.asm.ts_node_has_error_wasm).apply(null,arguments)};Module._ts_node_is_missing_wasm=function(){return (Module._ts_node_is_missing_wasm=Module.asm.ts_node_is_missing_wasm).apply(null,arguments)};Module._ts_query_matches_wasm=function(){return (Module._ts_query_matches_wasm=Module.asm.ts_query_matches_wasm).apply(null,arguments)};Module._ts_query_captures_wasm=function(){return (Module._ts_query_captures_wasm=Module.asm.ts_query_captures_wasm).apply(null,arguments)};Module.___cxa_atexit=function(){return (Module.___cxa_atexit=Module.asm.__cxa_atexit).apply(null,arguments)};Module._iswdigit=function(){return (Module._iswdigit=Module.asm.iswdigit).apply(null,arguments)};Module._iswalpha=function(){return (Module._iswalpha=Module.asm.iswalpha).apply(null,arguments)};Module._iswlower=function(){return (Module._iswlower=Module.asm.iswlower).apply(null,arguments)};Module._memchr=function(){return (Module._memchr=Module.asm.memchr).apply(null,arguments)};Module._strlen=function(){return (Module._strlen=Module.asm.strlen).apply(null,arguments)};Module._towupper=function(){return (Module._towupper=Module.asm.towupper).apply(null,arguments)};var _setThrew=Module._setThrew=function(){return (_setThrew=Module._setThrew=Module.asm.setThrew).apply(null,arguments)},stackSave=Module.stackSave=function(){return (stackSave=Module.stackSave=Module.asm.stackSave).apply(null,arguments)},stackRestore=Module.stackRestore=function(){return (stackRestore=Module.stackRestore=Module.asm.stackRestore).apply(null,arguments)},stackAlloc=Module.stackAlloc=function(){return (stackAlloc=Module.stackAlloc=Module.asm.stackAlloc).apply(null,arguments)};Module.__Znwm=function(){return (Module.__Znwm=Module.asm._Znwm).apply(null,arguments)};Module.__ZdlPv=function(){return (Module.__ZdlPv=Module.asm._ZdlPv).apply(null,arguments)};Module.__ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev=function(){return (Module.__ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev=Module.asm._ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev).apply(null,arguments)};Module.__ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9__grow_byEmmmmmm=function(){return (Module.__ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9__grow_byEmmmmmm=Module.asm._ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9__grow_byEmmmmmm).apply(null,arguments)};Module.__ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcm=function(){return (Module.__ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcm=Module.asm._ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcm).apply(null,arguments)};Module.__ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEm=function(){return (Module.__ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEm=Module.asm._ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEm).apply(null,arguments)};Module.__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4copyEPcmm=function(){return (Module.__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4copyEPcmm=Module.asm._ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4copyEPcmm).apply(null,arguments)};Module.__ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc=function(){return (Module.__ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc=Module.asm._ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc).apply(null,arguments)};Module.__ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev=function(){return (Module.__ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev=Module.asm._ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev).apply(null,arguments)};Module.__ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9push_backEw=function(){return (Module.__ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9push_backEw=Module.asm._ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9push_backEw).apply(null,arguments)};Module.__ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6resizeEmw=function(){return (Module.__ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6resizeEmw=Module.asm._ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6resizeEmw).apply(null,arguments)};Module.dynCall_jiji=function(){return (Module.dynCall_jiji=Module.asm.dynCall_jiji).apply(null,arguments)};Module._orig$ts_parser_timeout_micros=function(){return (Module._orig$ts_parser_timeout_micros=Module.asm.orig$ts_parser_timeout_micros).apply(null,arguments)};Module._orig$ts_parser_set_timeout_micros=function(){return (Module._orig$ts_parser_set_timeout_micros=Module.asm.orig$ts_parser_set_timeout_micros).apply(null,arguments)};var calledRun;function callMain(t){var e=Module._main;if(e){(t=t||[]).unshift(thisProgram);var r=t.length,n=stackAlloc(4*(r+1)),i=n>>2;t.forEach(o=>{HEAP32[i++]=allocateUTF8OnStack(o);}),HEAP32[i]=0;try{var s=e(r,n);return exitJS(s),s}catch(o){return handleException(o)}}}Module.AsciiToString=AsciiToString,Module.stringToUTF16=stringToUTF16,dependenciesFulfilled=function t(){calledRun||run(),calledRun||(dependenciesFulfilled=t);};var dylibsLoaded=!1;function run(t){function e(){calledRun||(calledRun=!0,Module.calledRun=!0,ABORT||(initRuntime(),preMain(),Module.onRuntimeInitialized&&Module.onRuntimeInitialized(),shouldRunNow&&callMain(t),postRun()));}t=t||arguments_,runDependencies>0||!dylibsLoaded&&(preloadDylibs(),dylibsLoaded=!0,runDependencies>0)||(preRun(),runDependencies>0||(Module.setStatus?(Module.setStatus("Running..."),setTimeout(function(){setTimeout(function(){Module.setStatus("");},1),e();},1)):e()));}if(Module.preInit)for(typeof Module.preInit=="function"&&(Module.preInit=[Module.preInit]);Module.preInit.length>0;)Module.preInit.pop()();var shouldRunNow=!0;Module.noInitialRun&&(shouldRunNow=!1),run();let C=Module,INTERNAL={},SIZE_OF_INT=4,SIZE_OF_NODE=5*SIZE_OF_INT,SIZE_OF_POINT=2*SIZE_OF_INT,SIZE_OF_RANGE=2*SIZE_OF_INT+2*SIZE_OF_POINT,ZERO_POINT={row:0,column:0},QUERY_WORD_REGEX=/[\w-.]*/g,PREDICATE_STEP_TYPE_CAPTURE=1,PREDICATE_STEP_TYPE_STRING=2,LANGUAGE_FUNCTION_REGEX=/^_?tree_sitter_\w+/;var VERSION,MIN_COMPATIBLE_VERSION,TRANSFER_BUFFER,currentParseCallback,currentLogCallback;class ParserImpl{static init(){TRANSFER_BUFFER=C._ts_init(),VERSION=getValue(TRANSFER_BUFFER,"i32"),MIN_COMPATIBLE_VERSION=getValue(TRANSFER_BUFFER+SIZE_OF_INT,"i32");}initialize(){C._ts_parser_new_wasm(),this[0]=getValue(TRANSFER_BUFFER,"i32"),this[1]=getValue(TRANSFER_BUFFER+SIZE_OF_INT,"i32");}delete(){C._ts_parser_delete(this[0]),C._free(this[1]),this[0]=0,this[1]=0;}setLanguage(e){let r;if(e){if(e.constructor!==Language)throw new Error("Argument must be a Language");{r=e[0];let n=C._ts_language_version(r);if(n<MIN_COMPATIBLE_VERSION||VERSION<n)throw new Error(`Incompatible language version ${n}. Compatibility range ${MIN_COMPATIBLE_VERSION} through ${VERSION}.`)}}else r=0,e=null;return this.language=e,C._ts_parser_set_language(this[0],r),this}getLanguage(){return this.language}parse(e,r,n){if(typeof e=="string")currentParseCallback=(l,d,c)=>e.slice(l,c);else {if(typeof e!="function")throw new Error("Argument must be a string or a function");currentParseCallback=e;}this.logCallback?(currentLogCallback=this.logCallback,C._ts_parser_enable_logger_wasm(this[0],1)):(currentLogCallback=null,C._ts_parser_enable_logger_wasm(this[0],0));let i=0,s=0;if(n&&n.includedRanges){i=n.includedRanges.length,s=C._calloc(i,SIZE_OF_RANGE);let l=s;for(let d=0;d<i;d++)marshalRange(l,n.includedRanges[d]),l+=SIZE_OF_RANGE;}let o=C._ts_parser_parse_wasm(this[0],this[1],r?r[0]:0,s,i);if(!o)throw currentParseCallback=null,currentLogCallback=null,new Error("Parsing failed");let a=new Tree(INTERNAL,o,this.language,currentParseCallback);return currentParseCallback=null,currentLogCallback=null,a}reset(){C._ts_parser_reset(this[0]);}setTimeoutMicros(e){C._ts_parser_set_timeout_micros(this[0],e);}getTimeoutMicros(){return C._ts_parser_timeout_micros(this[0])}setLogger(e){if(e){if(typeof e!="function")throw new Error("Logger callback must be a function")}else e=null;return this.logCallback=e,this}getLogger(){return this.logCallback}}class Tree{constructor(e,r,n,i){assertInternal(e),this[0]=r,this.language=n,this.textCallback=i;}copy(){let e=C._ts_tree_copy(this[0]);return new Tree(INTERNAL,e,this.language,this.textCallback)}delete(){C._ts_tree_delete(this[0]),this[0]=0;}edit(e){marshalEdit(e),C._ts_tree_edit_wasm(this[0]);}get rootNode(){return C._ts_tree_root_node_wasm(this[0]),unmarshalNode(this)}getLanguage(){return this.language}walk(){return this.rootNode.walk()}getChangedRanges(e){if(e.constructor!==Tree)throw new TypeError("Argument must be a Tree");C._ts_tree_get_changed_ranges_wasm(this[0],e[0]);let r=getValue(TRANSFER_BUFFER,"i32"),n=getValue(TRANSFER_BUFFER+SIZE_OF_INT,"i32"),i=new Array(r);if(r>0){let s=n;for(let o=0;o<r;o++)i[o]=unmarshalRange(s),s+=SIZE_OF_RANGE;C._free(n);}return i}}class Node{constructor(e,r){assertInternal(e),this.tree=r;}get typeId(){return marshalNode(this),C._ts_node_symbol_wasm(this.tree[0])}get type(){return this.tree.language.types[this.typeId]||"ERROR"}get endPosition(){return marshalNode(this),C._ts_node_end_point_wasm(this.tree[0]),unmarshalPoint(TRANSFER_BUFFER)}get endIndex(){return marshalNode(this),C._ts_node_end_index_wasm(this.tree[0])}get text(){return getText(this.tree,this.startIndex,this.endIndex)}isNamed(){return marshalNode(this),C._ts_node_is_named_wasm(this.tree[0])===1}hasError(){return marshalNode(this),C._ts_node_has_error_wasm(this.tree[0])===1}hasChanges(){return marshalNode(this),C._ts_node_has_changes_wasm(this.tree[0])===1}isMissing(){return marshalNode(this),C._ts_node_is_missing_wasm(this.tree[0])===1}equals(e){return this.id===e.id}child(e){return marshalNode(this),C._ts_node_child_wasm(this.tree[0],e),unmarshalNode(this.tree)}namedChild(e){return marshalNode(this),C._ts_node_named_child_wasm(this.tree[0],e),unmarshalNode(this.tree)}childForFieldId(e){return marshalNode(this),C._ts_node_child_by_field_id_wasm(this.tree[0],e),unmarshalNode(this.tree)}childForFieldName(e){let r=this.tree.language.fields.indexOf(e);if(r!==-1)return this.childForFieldId(r)}get childCount(){return marshalNode(this),C._ts_node_child_count_wasm(this.tree[0])}get namedChildCount(){return marshalNode(this),C._ts_node_named_child_count_wasm(this.tree[0])}get firstChild(){return this.child(0)}get firstNamedChild(){return this.namedChild(0)}get lastChild(){return this.child(this.childCount-1)}get lastNamedChild(){return this.namedChild(this.namedChildCount-1)}get children(){if(!this._children){marshalNode(this),C._ts_node_children_wasm(this.tree[0]);let e=getValue(TRANSFER_BUFFER,"i32"),r=getValue(TRANSFER_BUFFER+SIZE_OF_INT,"i32");if(this._children=new Array(e),e>0){let n=r;for(let i=0;i<e;i++)this._children[i]=unmarshalNode(this.tree,n),n+=SIZE_OF_NODE;C._free(r);}}return this._children}get namedChildren(){if(!this._namedChildren){marshalNode(this),C._ts_node_named_children_wasm(this.tree[0]);let e=getValue(TRANSFER_BUFFER,"i32"),r=getValue(TRANSFER_BUFFER+SIZE_OF_INT,"i32");if(this._namedChildren=new Array(e),e>0){let n=r;for(let i=0;i<e;i++)this._namedChildren[i]=unmarshalNode(this.tree,n),n+=SIZE_OF_NODE;C._free(r);}}return this._namedChildren}descendantsOfType(e,r,n){Array.isArray(e)||(e=[e]),r||(r=ZERO_POINT),n||(n=ZERO_POINT);let i=[],s=this.tree.language.types;for(let c=0,p=s.length;c<p;c++)e.includes(s[c])&&i.push(c);let o=C._malloc(SIZE_OF_INT*i.length);for(let c=0,p=i.length;c<p;c++)setValue(o+c*SIZE_OF_INT,i[c],"i32");marshalNode(this),C._ts_node_descendants_of_type_wasm(this.tree[0],o,i.length,r.row,r.column,n.row,n.column);let a=getValue(TRANSFER_BUFFER,"i32"),l=getValue(TRANSFER_BUFFER+SIZE_OF_INT,"i32"),d=new Array(a);if(a>0){let c=l;for(let p=0;p<a;p++)d[p]=unmarshalNode(this.tree,c),c+=SIZE_OF_NODE;}return C._free(l),C._free(o),d}get nextSibling(){return marshalNode(this),C._ts_node_next_sibling_wasm(this.tree[0]),unmarshalNode(this.tree)}get previousSibling(){return marshalNode(this),C._ts_node_prev_sibling_wasm(this.tree[0]),unmarshalNode(this.tree)}get nextNamedSibling(){return marshalNode(this),C._ts_node_next_named_sibling_wasm(this.tree[0]),unmarshalNode(this.tree)}get previousNamedSibling(){return marshalNode(this),C._ts_node_prev_named_sibling_wasm(this.tree[0]),unmarshalNode(this.tree)}get parent(){return marshalNode(this),C._ts_node_parent_wasm(this.tree[0]),unmarshalNode(this.tree)}descendantForIndex(e,r=e){if(typeof e!="number"||typeof r!="number")throw new Error("Arguments must be numbers");marshalNode(this);let n=TRANSFER_BUFFER+SIZE_OF_NODE;return setValue(n,e,"i32"),setValue(n+SIZE_OF_INT,r,"i32"),C._ts_node_descendant_for_index_wasm(this.tree[0]),unmarshalNode(this.tree)}namedDescendantForIndex(e,r=e){if(typeof e!="number"||typeof r!="number")throw new Error("Arguments must be numbers");marshalNode(this);let n=TRANSFER_BUFFER+SIZE_OF_NODE;return setValue(n,e,"i32"),setValue(n+SIZE_OF_INT,r,"i32"),C._ts_node_named_descendant_for_index_wasm(this.tree[0]),unmarshalNode(this.tree)}descendantForPosition(e,r=e){if(!isPoint(e)||!isPoint(r))throw new Error("Arguments must be {row, column} objects");marshalNode(this);let n=TRANSFER_BUFFER+SIZE_OF_NODE;return marshalPoint(n,e),marshalPoint(n+SIZE_OF_POINT,r),C._ts_node_descendant_for_position_wasm(this.tree[0]),unmarshalNode(this.tree)}namedDescendantForPosition(e,r=e){if(!isPoint(e)||!isPoint(r))throw new Error("Arguments must be {row, column} objects");marshalNode(this);let n=TRANSFER_BUFFER+SIZE_OF_NODE;return marshalPoint(n,e),marshalPoint(n+SIZE_OF_POINT,r),C._ts_node_named_descendant_for_position_wasm(this.tree[0]),unmarshalNode(this.tree)}walk(){return marshalNode(this),C._ts_tree_cursor_new_wasm(this.tree[0]),new TreeCursor(INTERNAL,this.tree)}toString(){marshalNode(this);let e=C._ts_node_to_string_wasm(this.tree[0]),r=AsciiToString(e);return C._free(e),r}}class TreeCursor{constructor(e,r){assertInternal(e),this.tree=r,unmarshalTreeCursor(this);}delete(){marshalTreeCursor(this),C._ts_tree_cursor_delete_wasm(this.tree[0]),this[0]=this[1]=this[2]=0;}reset(e){marshalNode(e),marshalTreeCursor(this,TRANSFER_BUFFER+SIZE_OF_NODE),C._ts_tree_cursor_reset_wasm(this.tree[0]),unmarshalTreeCursor(this);}get nodeType(){return this.tree.language.types[this.nodeTypeId]||"ERROR"}get nodeTypeId(){return marshalTreeCursor(this),C._ts_tree_cursor_current_node_type_id_wasm(this.tree[0])}get nodeId(){return marshalTreeCursor(this),C._ts_tree_cursor_current_node_id_wasm(this.tree[0])}get nodeIsNamed(){return marshalTreeCursor(this),C._ts_tree_cursor_current_node_is_named_wasm(this.tree[0])===1}get nodeIsMissing(){return marshalTreeCursor(this),C._ts_tree_cursor_current_node_is_missing_wasm(this.tree[0])===1}get nodeText(){marshalTreeCursor(this);let e=C._ts_tree_cursor_start_index_wasm(this.tree[0]),r=C._ts_tree_cursor_end_index_wasm(this.tree[0]);return getText(this.tree,e,r)}get startPosition(){return marshalTreeCursor(this),C._ts_tree_cursor_start_position_wasm(this.tree[0]),unmarshalPoint(TRANSFER_BUFFER)}get endPosition(){return marshalTreeCursor(this),C._ts_tree_cursor_end_position_wasm(this.tree[0]),unmarshalPoint(TRANSFER_BUFFER)}get startIndex(){return marshalTreeCursor(this),C._ts_tree_cursor_start_index_wasm(this.tree[0])}get endIndex(){return marshalTreeCursor(this),C._ts_tree_cursor_end_index_wasm(this.tree[0])}currentNode(){return marshalTreeCursor(this),C._ts_tree_cursor_current_node_wasm(this.tree[0]),unmarshalNode(this.tree)}currentFieldId(){return marshalTreeCursor(this),C._ts_tree_cursor_current_field_id_wasm(this.tree[0])}currentFieldName(){return this.tree.language.fields[this.currentFieldId()]}gotoFirstChild(){marshalTreeCursor(this);let e=C._ts_tree_cursor_goto_first_child_wasm(this.tree[0]);return unmarshalTreeCursor(this),e===1}gotoNextSibling(){marshalTreeCursor(this);let e=C._ts_tree_cursor_goto_next_sibling_wasm(this.tree[0]);return unmarshalTreeCursor(this),e===1}gotoParent(){marshalTreeCursor(this);let e=C._ts_tree_cursor_goto_parent_wasm(this.tree[0]);return unmarshalTreeCursor(this),e===1}}class Language{constructor(e,r){assertInternal(e),this[0]=r,this.types=new Array(C._ts_language_symbol_count(this[0]));for(let n=0,i=this.types.length;n<i;n++)C._ts_language_symbol_type(this[0],n)<2&&(this.types[n]=UTF8ToString(C._ts_language_symbol_name(this[0],n)));this.fields=new Array(C._ts_language_field_count(this[0])+1);for(let n=0,i=this.fields.length;n<i;n++){let s=C._ts_language_field_name_for_id(this[0],n);this.fields[n]=s!==0?UTF8ToString(s):null;}}get version(){return C._ts_language_version(this[0])}get fieldCount(){return this.fields.length-1}fieldIdForName(e){let r=this.fields.indexOf(e);return r!==-1?r:null}fieldNameForId(e){return this.fields[e]||null}idForNodeType(e,r){let n=lengthBytesUTF8(e),i=C._malloc(n+1);stringToUTF8(e,i,n+1);let s=C._ts_language_symbol_for_name(this[0],i,n,r);return C._free(i),s||null}get nodeTypeCount(){return C._ts_language_symbol_count(this[0])}nodeTypeForId(e){let r=C._ts_language_symbol_name(this[0],e);return r?UTF8ToString(r):null}nodeTypeIsNamed(e){return !!C._ts_language_type_is_named_wasm(this[0],e)}nodeTypeIsVisible(e){return !!C._ts_language_type_is_visible_wasm(this[0],e)}query(e){let r=lengthBytesUTF8(e),n=C._malloc(r+1);stringToUTF8(e,n,r+1);let i=C._ts_query_new(this[0],n,r,TRANSFER_BUFFER,TRANSFER_BUFFER+SIZE_OF_INT);if(!i){let E=getValue(TRANSFER_BUFFER+SIZE_OF_INT,"i32"),P=UTF8ToString(n,getValue(TRANSFER_BUFFER,"i32")).length,D=e.substr(P,100).split(`
`)[0],g,S=D.match(QUERY_WORD_REGEX)[0];switch(E){case 2:g=new RangeError(`Bad node name '${S}'`);break;case 3:g=new RangeError(`Bad field name '${S}'`);break;case 4:g=new RangeError(`Bad capture name @${S}`);break;case 5:g=new TypeError(`Bad pattern structure at offset ${P}: '${D}'...`),S="";break;default:g=new SyntaxError(`Bad syntax at offset ${P}: '${D}'...`),S="";}throw g.index=P,g.length=S.length,C._free(n),g}let s=C._ts_query_string_count(i),o=C._ts_query_capture_count(i),a=C._ts_query_pattern_count(i),l=new Array(o),d=new Array(s);for(let E=0;E<o;E++){let P=C._ts_query_capture_name_for_id(i,E,TRANSFER_BUFFER),D=getValue(TRANSFER_BUFFER,"i32");l[E]=UTF8ToString(P,D);}for(let E=0;E<s;E++){let P=C._ts_query_string_value_for_id(i,E,TRANSFER_BUFFER),D=getValue(TRANSFER_BUFFER,"i32");d[E]=UTF8ToString(P,D);}let c=new Array(a),p=new Array(a),m=new Array(a),_=new Array(a),w=new Array(a);for(let E=0;E<a;E++){let P=C._ts_query_predicates_for_pattern(i,E,TRANSFER_BUFFER),D=getValue(TRANSFER_BUFFER,"i32");_[E]=[],w[E]=[];let g=[],S=P;for(let I=0;I<D;I++){let L=getValue(S,"i32");S+=SIZE_OF_INT;let Z=getValue(S,"i32");if(S+=SIZE_OF_INT,L===PREDICATE_STEP_TYPE_CAPTURE)g.push({type:"capture",name:l[Z]});else if(L===PREDICATE_STEP_TYPE_STRING)g.push({type:"string",value:d[Z]});else if(g.length>0){if(g[0].type!=="string")throw new Error("Predicates must begin with a literal value");let K=g[0].value,U=!0;switch(K){case"not-eq?":U=!1;case"eq?":if(g.length!==3)throw new Error("Wrong number of arguments to `#eq?` predicate. Expected 2, got "+(g.length-1));if(g[1].type!=="capture")throw new Error(`First argument of \`#eq?\` predicate must be a capture. Got "${g[1].value}"`);if(g[2].type==="capture"){let te=g[1].name,ae=g[2].name;w[E].push(function(ye){let q,W;for(let me of ye)me.name===te&&(q=me.node),me.name===ae&&(W=me.node);return q===void 0||W===void 0||q.text===W.text===U});}else {let te=g[1].name,ae=g[2].value;w[E].push(function(ye){for(let q of ye)if(q.name===te)return q.node.text===ae===U;return !0});}break;case"not-match?":U=!1;case"match?":if(g.length!==3)throw new Error(`Wrong number of arguments to \`#match?\` predicate. Expected 2, got ${g.length-1}.`);if(g[1].type!=="capture")throw new Error(`First argument of \`#match?\` predicate must be a capture. Got "${g[1].value}".`);if(g[2].type!=="string")throw new Error(`Second argument of \`#match?\` predicate must be a string. Got @${g[2].value}.`);let B=g[1].name,Q=new RegExp(g[2].value);w[E].push(function(te){for(let ae of te)if(ae.name===B)return Q.test(ae.node.text)===U;return !0});break;case"set!":if(g.length<2||g.length>3)throw new Error(`Wrong number of arguments to \`#set!\` predicate. Expected 1 or 2. Got ${g.length-1}.`);if(g.some(te=>te.type!=="string"))throw new Error('Arguments to `#set!` predicate must be a strings.".');c[E]||(c[E]={}),c[E][g[1].value]=g[2]?g[2].value:null;break;case"is?":case"is-not?":if(g.length<2||g.length>3)throw new Error(`Wrong number of arguments to \`#${K}\` predicate. Expected 1 or 2. Got ${g.length-1}.`);if(g.some(te=>te.type!=="string"))throw new Error(`Arguments to \`#${K}\` predicate must be a strings.".`);let N=K==="is?"?p:m;N[E]||(N[E]={}),N[E][g[1].value]=g[2]?g[2].value:null;break;default:_[E].push({operator:K,operands:g.slice(1)});}g.length=0;}}Object.freeze(c[E]),Object.freeze(p[E]),Object.freeze(m[E]);}return C._free(n),new Query(INTERNAL,i,l,w,_,Object.freeze(c),Object.freeze(p),Object.freeze(m))}static load(e){let r;if(e instanceof Uint8Array)r=Promise.resolve(e);else {let i=e;if(typeof process<"u"&&process.versions&&process.versions.node){let s=oe("fs");r=Promise.resolve(s.readFileSync(i));}else r=fetch(i).then(s=>s.arrayBuffer().then(o=>{if(s.ok)return new Uint8Array(o);{let a=new TextDecoder("utf-8").decode(o);throw new Error(`Language.load failed with status ${s.status}.

${a}`)}}));}let n=typeof loadSideModule=="function"?loadSideModule:loadWebAssemblyModule;return r.then(i=>n(i,{loadAsync:!0})).then(i=>{let s=Object.keys(i),o=s.find(l=>LANGUAGE_FUNCTION_REGEX.test(l)&&!l.includes("external_scanner_"));o||console.log(`Couldn't find language function in WASM file. Symbols:
${JSON.stringify(s,null,2)}`);let a=i[o]();return new Language(INTERNAL,a)})}}class Query{constructor(e,r,n,i,s,o,a,l){assertInternal(e),this[0]=r,this.captureNames=n,this.textPredicates=i,this.predicates=s,this.setProperties=o,this.assertedProperties=a,this.refutedProperties=l,this.exceededMatchLimit=!1;}delete(){C._ts_query_delete(this[0]),this[0]=0;}matches(e,r,n,i){r||(r=ZERO_POINT),n||(n=ZERO_POINT),i||(i={});let s=i.matchLimit;if(s===void 0)s=0;else if(typeof s!="number")throw new Error("Arguments must be numbers");marshalNode(e),C._ts_query_matches_wasm(this[0],e.tree[0],r.row,r.column,n.row,n.column,s);let o=getValue(TRANSFER_BUFFER,"i32"),a=getValue(TRANSFER_BUFFER+SIZE_OF_INT,"i32"),l=getValue(TRANSFER_BUFFER+2*SIZE_OF_INT,"i32"),d=new Array(o);this.exceededMatchLimit=!!l;let c=0,p=a;for(let m=0;m<o;m++){let _=getValue(p,"i32");p+=SIZE_OF_INT;let w=getValue(p,"i32");p+=SIZE_OF_INT;let E=new Array(w);if(p=unmarshalCaptures(this,e.tree,p,E),this.textPredicates[_].every(P=>P(E))){d[c++]={pattern:_,captures:E};let P=this.setProperties[_];P&&(d[m].setProperties=P);let D=this.assertedProperties[_];D&&(d[m].assertedProperties=D);let g=this.refutedProperties[_];g&&(d[m].refutedProperties=g);}}return d.length=c,C._free(a),d}captures(e,r,n,i){r||(r=ZERO_POINT),n||(n=ZERO_POINT),i||(i={});let s=i.matchLimit;if(s===void 0)s=0;else if(typeof s!="number")throw new Error("Arguments must be numbers");marshalNode(e),C._ts_query_captures_wasm(this[0],e.tree[0],r.row,r.column,n.row,n.column,s);let o=getValue(TRANSFER_BUFFER,"i32"),a=getValue(TRANSFER_BUFFER+SIZE_OF_INT,"i32"),l=getValue(TRANSFER_BUFFER+2*SIZE_OF_INT,"i32"),d=[];this.exceededMatchLimit=!!l;let c=[],p=a;for(let m=0;m<o;m++){let _=getValue(p,"i32");p+=SIZE_OF_INT;let w=getValue(p,"i32");p+=SIZE_OF_INT;let E=getValue(p,"i32");if(p+=SIZE_OF_INT,c.length=w,p=unmarshalCaptures(this,e.tree,p,c),this.textPredicates[_].every(P=>P(c))){let P=c[E],D=this.setProperties[_];D&&(P.setProperties=D);let g=this.assertedProperties[_];g&&(P.assertedProperties=g);let S=this.refutedProperties[_];S&&(P.refutedProperties=S),d.push(P);}}return C._free(a),d}predicatesForPattern(e){return this.predicates[e]}didExceedMatchLimit(){return this.exceededMatchLimit}}function getText(t,e,r){let n=r-e,i=t.textCallback(e,null,r);for(e+=i.length;e<r;){let s=t.textCallback(e,null,r);if(!(s&&s.length>0))break;e+=s.length,i+=s;}return e>r&&(i=i.slice(0,n)),i}function unmarshalCaptures(t,e,r,n){for(let i=0,s=n.length;i<s;i++){let o=getValue(r,"i32"),a=unmarshalNode(e,r+=SIZE_OF_INT);r+=SIZE_OF_NODE,n[i]={name:t.captureNames[o],node:a};}return r}function assertInternal(t){if(t!==INTERNAL)throw new Error("Illegal constructor")}function isPoint(t){return t&&typeof t.row=="number"&&typeof t.column=="number"}function marshalNode(t){let e=TRANSFER_BUFFER;setValue(e,t.id,"i32"),e+=SIZE_OF_INT,setValue(e,t.startIndex,"i32"),e+=SIZE_OF_INT,setValue(e,t.startPosition.row,"i32"),e+=SIZE_OF_INT,setValue(e,t.startPosition.column,"i32"),e+=SIZE_OF_INT,setValue(e,t[0],"i32");}function unmarshalNode(t,e=TRANSFER_BUFFER){let r=getValue(e,"i32");if(r===0)return null;let n=getValue(e+=SIZE_OF_INT,"i32"),i=getValue(e+=SIZE_OF_INT,"i32"),s=getValue(e+=SIZE_OF_INT,"i32"),o=getValue(e+=SIZE_OF_INT,"i32"),a=new Node(INTERNAL,t);return a.id=r,a.startIndex=n,a.startPosition={row:i,column:s},a[0]=o,a}function marshalTreeCursor(t,e=TRANSFER_BUFFER){setValue(e+0*SIZE_OF_INT,t[0],"i32"),setValue(e+1*SIZE_OF_INT,t[1],"i32"),setValue(e+2*SIZE_OF_INT,t[2],"i32");}function unmarshalTreeCursor(t){t[0]=getValue(TRANSFER_BUFFER+0*SIZE_OF_INT,"i32"),t[1]=getValue(TRANSFER_BUFFER+1*SIZE_OF_INT,"i32"),t[2]=getValue(TRANSFER_BUFFER+2*SIZE_OF_INT,"i32");}function marshalPoint(t,e){setValue(t,e.row,"i32"),setValue(t+SIZE_OF_INT,e.column,"i32");}function unmarshalPoint(t){return {row:getValue(t,"i32"),column:getValue(t+SIZE_OF_INT,"i32")}}function marshalRange(t,e){marshalPoint(t,e.startPosition),marshalPoint(t+=SIZE_OF_POINT,e.endPosition),setValue(t+=SIZE_OF_POINT,e.startIndex,"i32"),setValue(t+=SIZE_OF_INT,e.endIndex,"i32"),t+=SIZE_OF_INT;}function unmarshalRange(t){let e={};return e.startPosition=unmarshalPoint(t),t+=SIZE_OF_POINT,e.endPosition=unmarshalPoint(t),t+=SIZE_OF_POINT,e.startIndex=getValue(t,"i32"),t+=SIZE_OF_INT,e.endIndex=getValue(t,"i32"),e}function marshalEdit(t){let e=TRANSFER_BUFFER;marshalPoint(e,t.startPosition),e+=SIZE_OF_POINT,marshalPoint(e,t.oldEndPosition),e+=SIZE_OF_POINT,marshalPoint(e,t.newEndPosition),e+=SIZE_OF_POINT,setValue(e,t.startIndex,"i32"),e+=SIZE_OF_INT,setValue(e,t.oldEndIndex,"i32"),e+=SIZE_OF_INT,setValue(e,t.newEndIndex,"i32"),e+=SIZE_OF_INT;}for(let t of Object.getOwnPropertyNames(ParserImpl.prototype))Object.defineProperty(Parser.prototype,t,{value:ParserImpl.prototype[t],enumerable:!1,writable:!1});Parser.Language=Language,Module.onRuntimeInitialized=()=>{ParserImpl.init(),resolveInitPromise();};}))}}return Parser}();typeof exports=="object"&&(module.exports=TreeSitter);});var pp=A((D5,aT)=>{var hp=class{constructor(e={}){let r=e.base||1.001,n=e.precision||1e-9;if(!(r>1)||!(r<1.5))throw new Error("base must be a number between 1 and 1.5");if(r+=1e-9,r=2**(1/Math.ceil(Math.log(2)/Math.log(r))),r===1)throw new Error("base too close to 1");n=Number.parseFloat(""+n);let i=Math.ceil(1/(r-1)),s=n*i;this._thresh=s,this._precision=n,this._base=r;}getBase(){return this._base}getPrecision(){return this._precision}round(e){if(typeof e!="number"&&(e=Number.parseFloat(e)),Number.isNaN(e))throw new Error("Attempt to round a non-numeric value: "+e);return e<0?-this.round(-e):e<this._thresh?Math.round(e/this._precision)*this._precision:this._thresh*this._base**Math.round(Math.log(e/this._thresh)/Math.log(this._base))}upper(e){return e<0?-this.lower(-e):(e=this.round(e),e<this._thresh?e+this._precision/2:e*Math.sqrt(this._base))}lower(e){return e<0?-this.upper(-e):(e=this.round(e),e<=this._thresh?e-this._precision/2:e/Math.sqrt(this._base))}shorten(e,r){return e===void 0?e:r===void 0?yo(this.lower(e),this.upper(e)):yo(e,r)}};function yo(t,e,r=10){if(t===e)return t;if(t*e<=0)return 0;if(e<0)return -yo(-e,-t,r);if(t>e)return yo(e,t,r);let n=-Math.floor(Math.log(e-t)/Math.log(r));for(;Math.ceil(t*r**n)<=Math.floor(e*r**n);)n--;return n++,n>=0?Math.ceil(t*r**n)/r**n:Math.ceil(t/r**-n)*r**-n}aT.exports={Binning:hp,shorten:yo};});var cT=A((O5,uT)=>{var{Binning:d3}=pp(),h3="stats-logscale/univariate@1.0",bo=class t extends d3{constructor(e={}){super(e),this.storage=new Map,this._count=0,this._cache={},this.neat=new vo(this),e.bins&&this.addWeighted(e.bins);}add(...e){return this._cache={},e.forEach(r=>{let n=this.round(r),i=this.storage.get(n)??0;this.storage.set(n,i+1),this._count++;}),this}addWeighted(e){return this._cache={},e.forEach(r=>{let n=r[0],i=Number.parseFloat(r[1]);if(Number.isNaN(i))throw new Error("Attempt to provide a non-numeric weight");let s=this.round(n),o=(this.storage.get(s)??0)+i;o<=0?(this.storage.delete(s),this._count+=i-o):(this.storage.set(s,o),this._count+=i);}),this}toJSON(){return {version:h3,precision:this.getPrecision(),base:this.getBase(),bins:this.getBins()}}clone(e={}){let r=this.getBins(e);return e.transform&&(r=r.map(n=>[e.transform(n[0]),n[1]])),new t({precision:e.precision??this.getPrecision(),base:e.base??this.getBase(),bins:r})}getBins(e){if(this._cache.data||(this._cache.data=[...this.storage].sort((a,l)=>a[0]-l[0])),!e)return this._cache.data;let r=Math.max(e.min??-1/0,this.percentile(e.ltrim??0)),n=Math.min(e.max??1/0,this.percentile(100-(e.rtrim??0)));if(!e.winsorize)return this._cache.data.filter(a=>a[0]>=r&&a[0]<=n);let i=[this.round(r),0],s=[this.round(n),0],o=[i];for(let[a,l]of this._cache.data)a<=i[0]?i[1]+=l:a>=s[0]?s[1]+=l:o.push([a,l]);return s[1]>0&&o.push(s),o}count(){return this._count}min(){let e=this.getBins();return this.lower(e[0][0])}max(){let e=this.getBins();return this.upper(e[e.length-1][0])}sumOf(e){let r=0;return [...this.storage].forEach(n=>{r+=n[1]*e(n[0]);}),r}E(e){return this._count?this.sumOf(e)/this._count:void 0}mean(){return this._count?this.sumOf(e=>e)/this._count:void 0}stdev(){if(this._count<2)return;let e=this.mean();return Math.sqrt(this.sumOf(r=>(r-e)*(r-e))/(this._count-1))}skewness(){let e=this.count();return e<3?void 0:e*e/((e-1)*(e-2))*this.momentStd(3)}kurtosis(){let e=this.count();if(e<4)return;let r=e*e*(e+1)/((e-1)*(e-2)*(e-3)),n=(e-1)*(e-1)/((e-2)*(e-3));return this.momentStd(4)*r-3*n}moment(e,r){if(!Number.isInteger(e))throw new Error("Cannot calculate non-integer moment (did you mean momentAbs?)");return r===void 0&&(r=this.mean()),this.E(n=>(n-r)**e)}momentAbs(e=1,r){return r===void 0&&(r=this.mean()),this.E(n=>Math.abs(n-r)**e)}momentStd(e){return this.moment(e)/this.stdev()**e}quantile(e){let r=e*this._count,n=this._cumulative(),i=0,s=n.length;for(;i+1<s;){let l=Math.floor((s+i)/2);n[l][1]>=r?s=l:i=l;}let o=this.lower(n[i][0]),a=this.upper(n[i][0])-o;return o+a*(r-n[i][1])/(n[i][2]-n[i][1])}percentile(e){return this.quantile(e/100)}median(){return this.quantile(.5)}cdf(e){return this._rawCdf(e)/this._count}_rawCdf(e){let r=this._cumulative(),n=this.round(e),i=0,s=r.length;for(;i<s;){let l=Math.floor((s+i)/2);r[l][0]<n?i=l+1:s=l;}if(i>=r.length)return this._count;let o=i>0?r[i-1][2]:0,a=n!==r[i][0]?0:(r[i][2]-r[i][1])*(e-this.lower(e))/(this.upper(e)-this.lower(e));return o+a}histogram(e={}){if(!this._count)return [];let r=this.min(),n=this.max(),i=e.count||10,s=[],o=r,a=(n-r)/i;for(let l=0;l<i;l++)s.push([this._rawCdf(o+a),o,o+=a]);for(let l=s.length;l-- >1;)s[l][0]-=s[l-1][0];if(s[0][0]-=this._rawCdf(r),e.scale){let l=0;for(let d=0;d<s.length;d++)l<s[d][0]&&(l=s[d][0]);for(let d=0;d<s.length;d++)s[d][0]=s[d][0]*e.scale/l;}return s}_cumulative(){if(!this._cache.cumulative){let e=this.getBins(),r=[],n=0;for(let i=0;i<e.length;i++)r.push([e[i][0],n,n+=e[i][1]]);this._cache.cumulative=r;}return this._cache.cumulative}};["cdf+","kurtosis","max","mean","min","moment+","momentAbs+","momentStd+","quantile+","skewness","stdev"].forEach(t=>{let e=!!t.match(/\+/);e&&(t=t.replace("+",""));let r=bo.prototype[t];if(typeof r!="function")throw new Error('method "'+t+'" is cached but never defined');bo.prototype[t]=e?function(...n){if(this._count===0)return;this._cache[t]===void 0&&(this._cache[t]={});let i=n.join(":");return this._cache[t][i]===void 0&&(this._cache[t][i]=r.apply(this,n)),this._cache[t][i]}:function(){if(this._count!==0)return this._cache[t]===void 0&&(this._cache[t]=r.apply(this)),this._cache[t]};});var vo=class{constructor(e){this._main=e;}min(){if(!this._main._count)return;let e=this._main.getBins();return this._main.shorten(e[0][0])}max(){if(!this._main._count)return;let e=this._main.getBins();return this._main.shorten(e[e.length-1][0])}};["E","kurtosis","mean","median","moment","momentAbs","momentStd","percentile","quantile","skewness","stdev","sumOf"].forEach(t=>{vo.prototype[t]=function(e){return this._main.shorten(this._main[t](e))};});["cdf","count"].forEach(t=>{vo.prototype[t]=function(e){return this._main[t](e)};});uT.exports={Univariate:bo};});var lT=A((I5,mp)=>{(()=>{let{Binning:t}=pp(),{Univariate:e}=cT(),r={Binning:t,Univariate:e};typeof window<"u"&&(window.logstat=r),typeof mp=="object"&&(mp.exports=r);})();});var Uu=A(pt=>{Object.defineProperty(pt,"__esModule",{value:!0});pt.thenable=pt.typedArray=pt.stringArray=pt.array=pt.func=pt.error=pt.number=pt.string=pt.boolean=void 0;function g3(t){return t===!0||t===!1}pt.boolean=g3;function dT(t){return typeof t=="string"||t instanceof String}pt.string=dT;function _3(t){return typeof t=="number"||t instanceof Number}pt.number=_3;function y3(t){return t instanceof Error}pt.error=y3;function hT(t){return typeof t=="function"}pt.func=hT;function pT(t){return Array.isArray(t)}pt.array=pT;function b3(t){return pT(t)&&t.every(e=>dT(e))}pt.stringArray=b3;function v3(t,e){return Array.isArray(t)&&t.every(e)}pt.typedArray=v3;function w3(t){return t&&hT(t.then)}pt.thenable=w3;});var Qi=A(It=>{Object.defineProperty(It,"__esModule",{value:!0});It.stringArray=It.array=It.func=It.error=It.number=It.string=It.boolean=void 0;function S3(t){return t===!0||t===!1}It.boolean=S3;function mT(t){return typeof t=="string"||t instanceof String}It.string=mT;function E3(t){return typeof t=="number"||t instanceof Number}It.number=E3;function R3(t){return t instanceof Error}It.error=R3;function C3(t){return typeof t=="function"}It.func=C3;function gT(t){return Array.isArray(t)}It.array=gT;function x3(t){return gT(t)&&t.every(e=>mT(e))}It.stringArray=x3;});var Hp=A(_e=>{Object.defineProperty(_e,"__esModule",{value:!0});_e.Message=_e.NotificationType9=_e.NotificationType8=_e.NotificationType7=_e.NotificationType6=_e.NotificationType5=_e.NotificationType4=_e.NotificationType3=_e.NotificationType2=_e.NotificationType1=_e.NotificationType0=_e.NotificationType=_e.RequestType9=_e.RequestType8=_e.RequestType7=_e.RequestType6=_e.RequestType5=_e.RequestType4=_e.RequestType3=_e.RequestType2=_e.RequestType1=_e.RequestType=_e.RequestType0=_e.AbstractMessageSignature=_e.ParameterStructures=_e.ResponseError=_e.ErrorCodes=void 0;var li=Qi(),_p;(function(t){t.ParseError=-32700,t.InvalidRequest=-32600,t.MethodNotFound=-32601,t.InvalidParams=-32602,t.InternalError=-32603,t.jsonrpcReservedErrorRangeStart=-32099,t.serverErrorStart=-32099,t.MessageWriteError=-32099,t.MessageReadError=-32098,t.PendingResponseRejected=-32097,t.ConnectionInactive=-32096,t.ServerNotInitialized=-32002,t.UnknownErrorCode=-32001,t.jsonrpcReservedErrorRangeEnd=-32e3,t.serverErrorEnd=-32e3;})(_p||(_e.ErrorCodes=_p={}));var yp=class t extends Error{constructor(e,r,n){super(r),this.code=li.number(e)?e:_p.UnknownErrorCode,this.data=n,Object.setPrototypeOf(this,t.prototype);}toJson(){let e={code:this.code,message:this.message};return this.data!==void 0&&(e.data=this.data),e}};_e.ResponseError=yp;var Jt=class t{constructor(e){this.kind=e;}static is(e){return e===t.auto||e===t.byName||e===t.byPosition}toString(){return this.kind}};_e.ParameterStructures=Jt;Jt.auto=new Jt("auto");Jt.byPosition=new Jt("byPosition");Jt.byName=new Jt("byName");var Qe=class{constructor(e,r){this.method=e,this.numberOfParams=r;}get parameterStructures(){return Jt.auto}};_e.AbstractMessageSignature=Qe;var bp=class extends Qe{constructor(e){super(e,0);}};_e.RequestType0=bp;var vp=class extends Qe{constructor(e,r=Jt.auto){super(e,1),this._parameterStructures=r;}get parameterStructures(){return this._parameterStructures}};_e.RequestType=vp;var wp=class extends Qe{constructor(e,r=Jt.auto){super(e,1),this._parameterStructures=r;}get parameterStructures(){return this._parameterStructures}};_e.RequestType1=wp;var Sp=class extends Qe{constructor(e){super(e,2);}};_e.RequestType2=Sp;var Ep=class extends Qe{constructor(e){super(e,3);}};_e.RequestType3=Ep;var Rp=class extends Qe{constructor(e){super(e,4);}};_e.RequestType4=Rp;var Cp=class extends Qe{constructor(e){super(e,5);}};_e.RequestType5=Cp;var xp=class extends Qe{constructor(e){super(e,6);}};_e.RequestType6=xp;var Tp=class extends Qe{constructor(e){super(e,7);}};_e.RequestType7=Tp;var Ap=class extends Qe{constructor(e){super(e,8);}};_e.RequestType8=Ap;var Pp=class extends Qe{constructor(e){super(e,9);}};_e.RequestType9=Pp;var Dp=class extends Qe{constructor(e,r=Jt.auto){super(e,1),this._parameterStructures=r;}get parameterStructures(){return this._parameterStructures}};_e.NotificationType=Dp;var Op=class extends Qe{constructor(e){super(e,0);}};_e.NotificationType0=Op;var Ip=class extends Qe{constructor(e,r=Jt.auto){super(e,1),this._parameterStructures=r;}get parameterStructures(){return this._parameterStructures}};_e.NotificationType1=Ip;var kp=class extends Qe{constructor(e){super(e,2);}};_e.NotificationType2=kp;var Mp=class extends Qe{constructor(e){super(e,3);}};_e.NotificationType3=Mp;var Fp=class extends Qe{constructor(e){super(e,4);}};_e.NotificationType4=Fp;var Np=class extends Qe{constructor(e){super(e,5);}};_e.NotificationType5=Np;var qp=class extends Qe{constructor(e){super(e,6);}};_e.NotificationType6=qp;var Lp=class extends Qe{constructor(e){super(e,7);}};_e.NotificationType7=Lp;var $p=class extends Qe{constructor(e){super(e,8);}};_e.NotificationType8=$p;var jp=class extends Qe{constructor(e){super(e,9);}};_e.NotificationType9=jp;var _T;(function(t){function e(i){let s=i;return s&&li.string(s.method)&&(li.string(s.id)||li.number(s.id))}t.isRequest=e;function r(i){let s=i;return s&&li.string(s.method)&&i.id===void 0}t.isNotification=r;function n(i){let s=i;return s&&(s.result!==void 0||!!s.error)&&(li.string(s.id)||li.number(s.id)||s.id===null)}t.isResponse=n;})(_T||(_e.Message=_T={}));});var Bp=A(Pn=>{var yT;Object.defineProperty(Pn,"__esModule",{value:!0});Pn.LRUCache=Pn.LinkedMap=Pn.Touch=void 0;var kt;(function(t){t.None=0,t.First=1,t.AsOld=t.First,t.Last=2,t.AsNew=t.Last;})(kt||(Pn.Touch=kt={}));var zu=class{constructor(){this[yT]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0;}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++;}isEmpty(){return !this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(e){return this._map.has(e)}get(e,r=kt.None){let n=this._map.get(e);if(n)return r!==kt.None&&this.touch(n,r),n.value}set(e,r,n=kt.None){let i=this._map.get(e);if(i)i.value=r,n!==kt.None&&this.touch(i,n);else {switch(i={key:e,value:r,next:void 0,previous:void 0},n){case kt.None:this.addItemLast(i);break;case kt.First:this.addItemFirst(i);break;case kt.Last:this.addItemLast(i);break;default:this.addItemLast(i);break}this._map.set(e,i),this._size++;}return this}delete(e){return !!this.remove(e)}remove(e){let r=this._map.get(e);if(r)return this._map.delete(e),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");let e=this._head;return this._map.delete(e.key),this.removeItem(e),this._size--,e.value}forEach(e,r){let n=this._state,i=this._head;for(;i;){if(r?e.bind(r)(i.value,i.key,this):e(i.value,i.key,this),this._state!==n)throw new Error("LinkedMap got modified during iteration.");i=i.next;}}keys(){let e=this._state,r=this._head,n={[Symbol.iterator]:()=>n,next:()=>{if(this._state!==e)throw new Error("LinkedMap got modified during iteration.");if(r){let i={value:r.key,done:!1};return r=r.next,i}else return {value:void 0,done:!0}}};return n}values(){let e=this._state,r=this._head,n={[Symbol.iterator]:()=>n,next:()=>{if(this._state!==e)throw new Error("LinkedMap got modified during iteration.");if(r){let i={value:r.value,done:!1};return r=r.next,i}else return {value:void 0,done:!0}}};return n}entries(){let e=this._state,r=this._head,n={[Symbol.iterator]:()=>n,next:()=>{if(this._state!==e)throw new Error("LinkedMap got modified during iteration.");if(r){let i={value:[r.key,r.value],done:!1};return r=r.next,i}else return {value:void 0,done:!0}}};return n}[(yT=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(e){if(e>=this.size)return;if(e===0){this.clear();return}let r=this._head,n=this.size;for(;r&&n>e;)this._map.delete(r.key),r=r.next,n--;this._head=r,this._size=n,r&&(r.previous=void 0),this._state++;}addItemFirst(e){if(!this._head&&!this._tail)this._tail=e;else if(this._head)e.next=this._head,this._head.previous=e;else throw new Error("Invalid list");this._head=e,this._state++;}addItemLast(e){if(!this._head&&!this._tail)this._head=e;else if(this._tail)e.previous=this._tail,this._tail.next=e;else throw new Error("Invalid list");this._tail=e,this._state++;}removeItem(e){if(e===this._head&&e===this._tail)this._head=void 0,this._tail=void 0;else if(e===this._head){if(!e.next)throw new Error("Invalid list");e.next.previous=void 0,this._head=e.next;}else if(e===this._tail){if(!e.previous)throw new Error("Invalid list");e.previous.next=void 0,this._tail=e.previous;}else {let r=e.next,n=e.previous;if(!r||!n)throw new Error("Invalid list");r.previous=n,n.next=r;}e.next=void 0,e.previous=void 0,this._state++;}touch(e,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==kt.First&&r!==kt.Last)){if(r===kt.First){if(e===this._head)return;let n=e.next,i=e.previous;e===this._tail?(i.next=void 0,this._tail=i):(n.previous=i,i.next=n),e.previous=void 0,e.next=this._head,this._head.previous=e,this._head=e,this._state++;}else if(r===kt.Last){if(e===this._tail)return;let n=e.next,i=e.previous;e===this._head?(n.previous=void 0,this._head=n):(n.previous=i,i.next=n),e.next=void 0,e.previous=this._tail,this._tail.next=e,this._tail=e,this._state++;}}}toJSON(){let e=[];return this.forEach((r,n)=>{e.push([n,r]);}),e}fromJSON(e){this.clear();for(let[r,n]of e)this.set(r,n);}};Pn.LinkedMap=zu;var Wp=class extends zu{constructor(e,r=1){super(),this._limit=e,this._ratio=Math.min(Math.max(0,r),1);}get limit(){return this._limit}set limit(e){this._limit=e,this.checkTrim();}get ratio(){return this._ratio}set ratio(e){this._ratio=Math.min(Math.max(0,e),1),this.checkTrim();}get(e,r=kt.AsNew){return super.get(e,r)}peek(e){return super.get(e,kt.None)}set(e,r){return super.set(e,r,kt.Last),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio));}};Pn.LRUCache=Wp;});var vT=A(Vu=>{Object.defineProperty(Vu,"__esModule",{value:!0});Vu.Disposable=void 0;var bT;(function(t){function e(r){return {dispose:r}}t.create=e;})(bT||(Vu.Disposable=bT={}));});var Dn=A(Vp=>{Object.defineProperty(Vp,"__esModule",{value:!0});var Up;function zp(){if(Up===void 0)throw new Error("No runtime abstraction layer installed");return Up}(function(t){function e(r){if(r===void 0)throw new Error("No runtime abstraction layer provided");Up=r;}t.install=e;})(zp||(zp={}));Vp.default=zp;});var ts=A(es=>{Object.defineProperty(es,"__esModule",{value:!0});es.Emitter=es.Event=void 0;var T3=Dn(),wT;(function(t){let e={dispose(){}};t.None=function(){return e};})(wT||(es.Event=wT={}));var Gp=class{add(e,r=null,n){this._callbacks||(this._callbacks=[],this._contexts=[]),this._callbacks.push(e),this._contexts.push(r),Array.isArray(n)&&n.push({dispose:()=>this.remove(e,r)});}remove(e,r=null){if(!this._callbacks)return;let n=!1;for(let i=0,s=this._callbacks.length;i<s;i++)if(this._callbacks[i]===e)if(this._contexts[i]===r){this._callbacks.splice(i,1),this._contexts.splice(i,1);return}else n=!0;if(n)throw new Error("When adding a listener with a context, you should remove it with the same context")}invoke(...e){if(!this._callbacks)return [];let r=[],n=this._callbacks.slice(0),i=this._contexts.slice(0);for(let s=0,o=n.length;s<o;s++)try{r.push(n[s].apply(i[s],e));}catch(a){(0, T3.default)().console.error(a);}return r}isEmpty(){return !this._callbacks||this._callbacks.length===0}dispose(){this._callbacks=void 0,this._contexts=void 0;}},Gu=class t{constructor(e){this._options=e;}get event(){return this._event||(this._event=(e,r,n)=>{this._callbacks||(this._callbacks=new Gp),this._options&&this._options.onFirstListenerAdd&&this._callbacks.isEmpty()&&this._options.onFirstListenerAdd(this),this._callbacks.add(e,r);let i={dispose:()=>{this._callbacks&&(this._callbacks.remove(e,r),i.dispose=t._noop,this._options&&this._options.onLastListenerRemove&&this._callbacks.isEmpty()&&this._options.onLastListenerRemove(this));}};return Array.isArray(n)&&n.push(i),i}),this._event}fire(e){this._callbacks&&this._callbacks.invoke.call(this._callbacks,e);}dispose(){this._callbacks&&(this._callbacks.dispose(),this._callbacks=void 0);}};es.Emitter=Gu;Gu._noop=function(){};});var Ju=A(rs=>{Object.defineProperty(rs,"__esModule",{value:!0});rs.CancellationTokenSource=rs.CancellationToken=void 0;var A3=Dn(),P3=Qi(),Kp=ts(),Ku;(function(t){t.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:Kp.Event.None}),t.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:Kp.Event.None});function e(r){let n=r;return n&&(n===t.None||n===t.Cancelled||P3.boolean(n.isCancellationRequested)&&!!n.onCancellationRequested)}t.is=e;})(Ku||(rs.CancellationToken=Ku={}));var D3=Object.freeze(function(t,e){let r=(0, A3.default)().timer.setTimeout(t.bind(e),0);return {dispose(){r.dispose();}}}),Zu=class{constructor(){this._isCancelled=!1;}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()));}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?D3:(this._emitter||(this._emitter=new Kp.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=void 0);}},Zp=class{get token(){return this._token||(this._token=new Zu),this._token}cancel(){this._token?this._token.cancel():this._token=Ku.Cancelled;}dispose(){this._token?this._token instanceof Zu&&this._token.dispose():this._token=Ku.None;}};rs.CancellationTokenSource=Zp;});var ST=A(ns=>{Object.defineProperty(ns,"__esModule",{value:!0});ns.SharedArrayReceiverStrategy=ns.SharedArraySenderStrategy=void 0;var O3=Ju(),wo;(function(t){t.Continue=0,t.Cancelled=1;})(wo||(wo={}));var Jp=class{constructor(){this.buffers=new Map;}enableCancellation(e){if(e.id===null)return;let r=new SharedArrayBuffer(4),n=new Int32Array(r,0,1);n[0]=wo.Continue,this.buffers.set(e.id,r),e.$cancellationData=r;}async sendCancellation(e,r){let n=this.buffers.get(r);if(n===void 0)return;let i=new Int32Array(n,0,1);Atomics.store(i,0,wo.Cancelled);}cleanup(e){this.buffers.delete(e);}dispose(){this.buffers.clear();}};ns.SharedArraySenderStrategy=Jp;var Yp=class{constructor(e){this.data=new Int32Array(e,0,1);}get isCancellationRequested(){return Atomics.load(this.data,0)===wo.Cancelled}get onCancellationRequested(){throw new Error("Cancellation over SharedArrayBuffer doesn't support cancellation events")}},Xp=class{constructor(e){this.token=new Yp(e);}cancel(){}dispose(){}},Qp=class{constructor(){this.kind="request";}createCancellationTokenSource(e){let r=e.$cancellationData;return r===void 0?new O3.CancellationTokenSource:new Xp(r)}};ns.SharedArrayReceiverStrategy=Qp;});var tm=A(Yu=>{Object.defineProperty(Yu,"__esModule",{value:!0});Yu.Semaphore=void 0;var I3=Dn(),em=class{constructor(e=1){if(e<=0)throw new Error("Capacity must be greater than 0");this._capacity=e,this._active=0,this._waiting=[];}lock(e){return new Promise((r,n)=>{this._waiting.push({thunk:e,resolve:r,reject:n}),this.runNext();})}get active(){return this._active}runNext(){this._waiting.length===0||this._active===this._capacity||(0, I3.default)().timer.setImmediate(()=>this.doRunNext());}doRunNext(){if(this._waiting.length===0||this._active===this._capacity)return;let e=this._waiting.shift();if(this._active++,this._active>this._capacity)throw new Error("To many thunks active");try{let r=e.thunk();r instanceof Promise?r.then(n=>{this._active--,e.resolve(n),this.runNext();},n=>{this._active--,e.reject(n),this.runNext();}):(this._active--,e.resolve(r),this.runNext());}catch(r){this._active--,e.reject(r),this.runNext();}}};Yu.Semaphore=em;});var RT=A(On=>{Object.defineProperty(On,"__esModule",{value:!0});On.ReadableStreamMessageReader=On.AbstractMessageReader=On.MessageReader=void 0;var nm=Dn(),is=Qi(),rm=ts(),k3=tm(),ET;(function(t){function e(r){let n=r;return n&&is.func(n.listen)&&is.func(n.dispose)&&is.func(n.onError)&&is.func(n.onClose)&&is.func(n.onPartialMessage)}t.is=e;})(ET||(On.MessageReader=ET={}));var Xu=class{constructor(){this.errorEmitter=new rm.Emitter,this.closeEmitter=new rm.Emitter,this.partialMessageEmitter=new rm.Emitter;}dispose(){this.errorEmitter.dispose(),this.closeEmitter.dispose();}get onError(){return this.errorEmitter.event}fireError(e){this.errorEmitter.fire(this.asError(e));}get onClose(){return this.closeEmitter.event}fireClose(){this.closeEmitter.fire(void 0);}get onPartialMessage(){return this.partialMessageEmitter.event}firePartialMessage(e){this.partialMessageEmitter.fire(e);}asError(e){return e instanceof Error?e:new Error(`Reader received error. Reason: ${is.string(e.message)?e.message:"unknown"}`)}};On.AbstractMessageReader=Xu;var im;(function(t){function e(r){let n,s,o=new Map,a,l=new Map;if(r===void 0||typeof r=="string")n=r??"utf-8";else {if(n=r.charset??"utf-8",r.contentDecoder!==void 0&&(s=r.contentDecoder,o.set(s.name,s)),r.contentDecoders!==void 0)for(let d of r.contentDecoders)o.set(d.name,d);if(r.contentTypeDecoder!==void 0&&(a=r.contentTypeDecoder,l.set(a.name,a)),r.contentTypeDecoders!==void 0)for(let d of r.contentTypeDecoders)l.set(d.name,d);}return a===void 0&&(a=(0, nm.default)().applicationJson.decoder,l.set(a.name,a)),{charset:n,contentDecoder:s,contentDecoders:o,contentTypeDecoder:a,contentTypeDecoders:l}}t.fromOptions=e;})(im||(im={}));var sm=class extends Xu{constructor(e,r){super(),this.readable=e,this.options=im.fromOptions(r),this.buffer=(0, nm.default)().messageBuffer.create(this.options.charset),this._partialMessageTimeout=1e4,this.nextMessageLength=-1,this.messageToken=0,this.readSemaphore=new k3.Semaphore(1);}set partialMessageTimeout(e){this._partialMessageTimeout=e;}get partialMessageTimeout(){return this._partialMessageTimeout}listen(e){this.nextMessageLength=-1,this.messageToken=0,this.partialMessageTimer=void 0,this.callback=e;let r=this.readable.onData(n=>{this.onData(n);});return this.readable.onError(n=>this.fireError(n)),this.readable.onClose(()=>this.fireClose()),r}onData(e){try{for(this.buffer.append(e);;){if(this.nextMessageLength===-1){let n=this.buffer.tryReadHeaders(!0);if(!n)return;let i=n.get("content-length");if(!i){this.fireError(new Error(`Header must provide a Content-Length property.
${JSON.stringify(Object.fromEntries(n))}`));return}let s=parseInt(i);if(isNaN(s)){this.fireError(new Error(`Content-Length value must be a number. Got ${i}`));return}this.nextMessageLength=s;}let r=this.buffer.tryReadBody(this.nextMessageLength);if(r===void 0){this.setPartialMessageTimer();return}this.clearPartialMessageTimer(),this.nextMessageLength=-1,this.readSemaphore.lock(async()=>{let n=this.options.contentDecoder!==void 0?await this.options.contentDecoder.decode(r):r,i=await this.options.contentTypeDecoder.decode(n,this.options);this.callback(i);}).catch(n=>{this.fireError(n);});}}catch(r){this.fireError(r);}}clearPartialMessageTimer(){this.partialMessageTimer&&(this.partialMessageTimer.dispose(),this.partialMessageTimer=void 0);}setPartialMessageTimer(){this.clearPartialMessageTimer(),!(this._partialMessageTimeout<=0)&&(this.partialMessageTimer=(0, nm.default)().timer.setTimeout((e,r)=>{this.partialMessageTimer=void 0,e===this.messageToken&&(this.firePartialMessage({messageToken:e,waitingTime:r}),this.setPartialMessageTimer());},this._partialMessageTimeout,this.messageToken,this._partialMessageTimeout));}};On.ReadableStreamMessageReader=sm;});var PT=A(In=>{Object.defineProperty(In,"__esModule",{value:!0});In.WriteableStreamMessageWriter=In.AbstractMessageWriter=In.MessageWriter=void 0;var CT=Dn(),So=Qi(),M3=tm(),xT=ts(),F3="Content-Length: ",TT=`\r
`,AT;(function(t){function e(r){let n=r;return n&&So.func(n.dispose)&&So.func(n.onClose)&&So.func(n.onError)&&So.func(n.write)}t.is=e;})(AT||(In.MessageWriter=AT={}));var Qu=class{constructor(){this.errorEmitter=new xT.Emitter,this.closeEmitter=new xT.Emitter;}dispose(){this.errorEmitter.dispose(),this.closeEmitter.dispose();}get onError(){return this.errorEmitter.event}fireError(e,r,n){this.errorEmitter.fire([this.asError(e),r,n]);}get onClose(){return this.closeEmitter.event}fireClose(){this.closeEmitter.fire(void 0);}asError(e){return e instanceof Error?e:new Error(`Writer received error. Reason: ${So.string(e.message)?e.message:"unknown"}`)}};In.AbstractMessageWriter=Qu;var om;(function(t){function e(r){return r===void 0||typeof r=="string"?{charset:r??"utf-8",contentTypeEncoder:(0, CT.default)().applicationJson.encoder}:{charset:r.charset??"utf-8",contentEncoder:r.contentEncoder,contentTypeEncoder:r.contentTypeEncoder??(0, CT.default)().applicationJson.encoder}}t.fromOptions=e;})(om||(om={}));var am=class extends Qu{constructor(e,r){super(),this.writable=e,this.options=om.fromOptions(r),this.errorCount=0,this.writeSemaphore=new M3.Semaphore(1),this.writable.onError(n=>this.fireError(n)),this.writable.onClose(()=>this.fireClose());}async write(e){return this.writeSemaphore.lock(async()=>this.options.contentTypeEncoder.encode(e,this.options).then(n=>this.options.contentEncoder!==void 0?this.options.contentEncoder.encode(n):n).then(n=>{let i=[];return i.push(F3,n.byteLength.toString(),TT),i.push(TT),this.doWrite(e,i,n)},n=>{throw this.fireError(n),n}))}async doWrite(e,r,n){try{return await this.writable.write(r.join(""),"ascii"),this.writable.write(n)}catch(i){return this.handleError(i,e),Promise.reject(i)}}handleError(e,r){this.errorCount++,this.fireError(e,r,this.errorCount);}end(){this.writable.end();}};In.WriteableStreamMessageWriter=am;});var DT=A(ec=>{Object.defineProperty(ec,"__esModule",{value:!0});ec.AbstractMessageBuffer=void 0;var N3=13,q3=10,L3=`\r
`,um=class{constructor(e="utf-8"){this._encoding=e,this._chunks=[],this._totalLength=0;}get encoding(){return this._encoding}append(e){let r=typeof e=="string"?this.fromString(e,this._encoding):e;this._chunks.push(r),this._totalLength+=r.byteLength;}tryReadHeaders(e=!1){if(this._chunks.length===0)return;let r=0,n=0,i=0,s=0;e:for(;n<this._chunks.length;){let d=this._chunks[n];for(i=0;i<d.length;){switch(d[i]){case N3:switch(r){case 0:r=1;break;case 2:r=3;break;default:r=0;}break;case q3:switch(r){case 1:r=2;break;case 3:r=4,i++;break e;default:r=0;}break;default:r=0;}i++;}s+=d.byteLength,n++;}if(r!==4)return;let o=this._read(s+i),a=new Map,l=this.toString(o,"ascii").split(L3);if(l.length<2)return a;for(let d=0;d<l.length-2;d++){let c=l[d],p=c.indexOf(":");if(p===-1)throw new Error(`Message header must separate key and value using ':'
${c}`);let m=c.substr(0,p),_=c.substr(p+1).trim();a.set(e?m.toLowerCase():m,_);}return a}tryReadBody(e){if(!(this._totalLength<e))return this._read(e)}get numberOfBytes(){return this._totalLength}_read(e){if(e===0)return this.emptyBuffer();if(e>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===e){let s=this._chunks[0];return this._chunks.shift(),this._totalLength-=e,this.asNative(s)}if(this._chunks[0].byteLength>e){let s=this._chunks[0],o=this.asNative(s,e);return this._chunks[0]=s.slice(e),this._totalLength-=e,o}let r=this.allocNative(e),n=0,i=0;for(;e>0;){let s=this._chunks[i];if(s.byteLength>e){let o=s.slice(0,e);r.set(o,n),n+=e,this._chunks[i]=s.slice(e),this._totalLength-=e,e-=e;}else r.set(s,n),n+=s.byteLength,this._chunks.shift(),this._totalLength-=s.byteLength,e-=s.byteLength;}return r}};ec.AbstractMessageBuffer=um;});var FT=A(xe=>{Object.defineProperty(xe,"__esModule",{value:!0});xe.createMessageConnection=xe.ConnectionOptions=xe.MessageStrategy=xe.CancellationStrategy=xe.CancellationSenderStrategy=xe.CancellationReceiverStrategy=xe.RequestCancellationReceiverStrategy=xe.IdCancellationReceiverStrategy=xe.ConnectionStrategy=xe.ConnectionError=xe.ConnectionErrors=xe.LogTraceNotification=xe.SetTraceNotification=xe.TraceFormat=xe.TraceValues=xe.Trace=xe.NullLogger=xe.ProgressType=xe.ProgressToken=void 0;var OT=Dn(),st=Qi(),ve=Hp(),IT=Bp(),Eo=ts(),cm=Ju(),xo;(function(t){t.type=new ve.NotificationType("$/cancelRequest");})(xo||(xo={}));var lm;(function(t){function e(r){return typeof r=="string"||typeof r=="number"}t.is=e;})(lm||(xe.ProgressToken=lm={}));var Ro;(function(t){t.type=new ve.NotificationType("$/progress");})(Ro||(Ro={}));var fm=class{constructor(){}};xe.ProgressType=fm;var dm;(function(t){function e(r){return st.func(r)}t.is=e;})(dm||(dm={}));xe.NullLogger=Object.freeze({error:()=>{},warn:()=>{},info:()=>{},log:()=>{}});var Le;(function(t){t[t.Off=0]="Off",t[t.Messages=1]="Messages",t[t.Compact=2]="Compact",t[t.Verbose=3]="Verbose";})(Le||(xe.Trace=Le={}));var kT;(function(t){t.Off="off",t.Messages="messages",t.Compact="compact",t.Verbose="verbose";})(kT||(xe.TraceValues=kT={}));(function(t){function e(n){if(!st.string(n))return t.Off;switch(n=n.toLowerCase(),n){case"off":return t.Off;case"messages":return t.Messages;case"compact":return t.Compact;case"verbose":return t.Verbose;default:return t.Off}}t.fromString=e;function r(n){switch(n){case t.Off:return "off";case t.Messages:return "messages";case t.Compact:return "compact";case t.Verbose:return "verbose";default:return "off"}}t.toString=r;})(Le||(xe.Trace=Le={}));var cr;(function(t){t.Text="text",t.JSON="json";})(cr||(xe.TraceFormat=cr={}));(function(t){function e(r){return st.string(r)?(r=r.toLowerCase(),r==="json"?t.JSON:t.Text):t.Text}t.fromString=e;})(cr||(xe.TraceFormat=cr={}));var hm;(function(t){t.type=new ve.NotificationType("$/setTrace");})(hm||(xe.SetTraceNotification=hm={}));var tc;(function(t){t.type=new ve.NotificationType("$/logTrace");})(tc||(xe.LogTraceNotification=tc={}));var Co;(function(t){t[t.Closed=1]="Closed",t[t.Disposed=2]="Disposed",t[t.AlreadyListening=3]="AlreadyListening";})(Co||(xe.ConnectionErrors=Co={}));var ss=class t extends Error{constructor(e,r){super(r),this.code=e,Object.setPrototypeOf(this,t.prototype);}};xe.ConnectionError=ss;var pm;(function(t){function e(r){let n=r;return n&&st.func(n.cancelUndispatched)}t.is=e;})(pm||(xe.ConnectionStrategy=pm={}));var rc;(function(t){function e(r){let n=r;return n&&(n.kind===void 0||n.kind==="id")&&st.func(n.createCancellationTokenSource)&&(n.dispose===void 0||st.func(n.dispose))}t.is=e;})(rc||(xe.IdCancellationReceiverStrategy=rc={}));var mm;(function(t){function e(r){let n=r;return n&&n.kind==="request"&&st.func(n.createCancellationTokenSource)&&(n.dispose===void 0||st.func(n.dispose))}t.is=e;})(mm||(xe.RequestCancellationReceiverStrategy=mm={}));var nc;(function(t){t.Message=Object.freeze({createCancellationTokenSource(r){return new cm.CancellationTokenSource}});function e(r){return rc.is(r)||mm.is(r)}t.is=e;})(nc||(xe.CancellationReceiverStrategy=nc={}));var ic;(function(t){t.Message=Object.freeze({sendCancellation(r,n){return r.sendNotification(xo.type,{id:n})},cleanup(r){}});function e(r){let n=r;return n&&st.func(n.sendCancellation)&&st.func(n.cleanup)}t.is=e;})(ic||(xe.CancellationSenderStrategy=ic={}));var sc;(function(t){t.Message=Object.freeze({receiver:nc.Message,sender:ic.Message});function e(r){let n=r;return n&&nc.is(n.receiver)&&ic.is(n.sender)}t.is=e;})(sc||(xe.CancellationStrategy=sc={}));var oc;(function(t){function e(r){let n=r;return n&&st.func(n.handleMessage)}t.is=e;})(oc||(xe.MessageStrategy=oc={}));var MT;(function(t){function e(r){let n=r;return n&&(sc.is(n.cancellationStrategy)||pm.is(n.connectionStrategy)||oc.is(n.messageStrategy))}t.is=e;})(MT||(xe.ConnectionOptions=MT={}));var Fr;(function(t){t[t.New=1]="New",t[t.Listening=2]="Listening",t[t.Closed=3]="Closed",t[t.Disposed=4]="Disposed";})(Fr||(Fr={}));function $3(t,e,r,n){let i=r!==void 0?r:xe.NullLogger,s=0,o=0,a=0,l="2.0",d,c=new Map,p,m=new Map,_=new Map,w,E=new IT.LinkedMap,P=new Map,D=new Set,g=new Map,S=Le.Off,I=cr.Text,L,Z=Fr.New,K=new Eo.Emitter,U=new Eo.Emitter,B=new Eo.Emitter,Q=new Eo.Emitter,N=new Eo.Emitter,te=n&&n.cancellationStrategy?n.cancellationStrategy:sc.Message;function ae(k){if(k===null)throw new Error("Can't send requests with id null since the response can't be correlated.");return "req-"+k.toString()}function ye(k){return k===null?"res-unknown-"+(++a).toString():"res-"+k.toString()}function q(){return "not-"+(++o).toString()}function W(k,G){ve.Message.isRequest(G)?k.set(ae(G.id),G):ve.Message.isResponse(G)?k.set(ye(G.id),G):k.set(q(),G);}function me(k){}function pe(){return Z===Fr.Listening}function we(){return Z===Fr.Closed}function Xe(){return Z===Fr.Disposed}function Ke(){(Z===Fr.New||Z===Fr.Listening)&&(Z=Fr.Closed,U.fire(void 0));}function Pt(k){K.fire([k,void 0,void 0]);}function Lr(k){K.fire(k);}t.onClose(Ke),t.onError(Pt),e.onClose(Ke),e.onError(Lr);function zt(){w||E.size===0||(w=(0, OT.default)().timer.setImmediate(()=>{w=void 0,Ce();}));}function St(k){ve.Message.isRequest(k)?fn(k):ve.Message.isNotification(k)?Me(k):ve.Message.isResponse(k)?ce(k):ie(k);}function Ce(){if(E.size===0)return;let k=E.shift();try{let G=n?.messageStrategy;oc.is(G)?G.handleMessage(k,St):St(k);}finally{zt();}}let Cr=k=>{try{if(ve.Message.isNotification(k)&&k.method===xo.type.method){let G=k.params.id,se=ae(G),fe=E.get(se);if(ve.Message.isRequest(fe)){let ke=n?.connectionStrategy,ze=ke&&ke.cancelUndispatched?ke.cancelUndispatched(fe,me):void 0;if(ze&&(ze.error!==void 0||ze.result!==void 0)){E.delete(se),g.delete(G),ze.id=fe.id,He(ze,k.method,Date.now()),e.write(ze).catch(()=>i.error("Sending response for canceled message failed."));return}}let qe=g.get(G);if(qe!==void 0){qe.cancel(),Nt(k);return}else D.add(G);}W(E,k);}finally{zt();}};function fn(k){if(Xe())return;function G(Te,We,Ie){let et={jsonrpc:l,id:k.id};Te instanceof ve.ResponseError?et.error=Te.toJson():et.result=Te===void 0?null:Te,He(et,We,Ie),e.write(et).catch(()=>i.error("Sending response failed."));}function se(Te,We,Ie){let et={jsonrpc:l,id:k.id,error:Te.toJson()};He(et,We,Ie),e.write(et).catch(()=>i.error("Sending response failed."));}function fe(Te,We,Ie){Te===void 0&&(Te=null);let et={jsonrpc:l,id:k.id,result:Te};He(et,We,Ie),e.write(et).catch(()=>i.error("Sending response failed."));}fr(k);let qe=c.get(k.method),ke,ze;qe&&(ke=qe.type,ze=qe.handler);let Ze=Date.now();if(ze||d){let Te=k.id??String(Date.now()),We=rc.is(te.receiver)?te.receiver.createCancellationTokenSource(Te):te.receiver.createCancellationTokenSource(k);k.id!==null&&D.has(k.id)&&We.cancel(),k.id!==null&&g.set(Te,We);try{let Ie;if(ze)if(k.params===void 0){if(ke!==void 0&&ke.numberOfParams!==0){se(new ve.ResponseError(ve.ErrorCodes.InvalidParams,`Request ${k.method} defines ${ke.numberOfParams} params but received none.`),k.method,Ze);return}Ie=ze(We.token);}else if(Array.isArray(k.params)){if(ke!==void 0&&ke.parameterStructures===ve.ParameterStructures.byName){se(new ve.ResponseError(ve.ErrorCodes.InvalidParams,`Request ${k.method} defines parameters by name but received parameters by position`),k.method,Ze);return}Ie=ze(...k.params,We.token);}else {if(ke!==void 0&&ke.parameterStructures===ve.ParameterStructures.byPosition){se(new ve.ResponseError(ve.ErrorCodes.InvalidParams,`Request ${k.method} defines parameters by position but received parameters by name`),k.method,Ze);return}Ie=ze(k.params,We.token);}else d&&(Ie=d(k.method,k.params,We.token));let et=Ie;Ie?et.then?et.then(ut=>{g.delete(Te),G(ut,k.method,Ze);},ut=>{g.delete(Te),ut instanceof ve.ResponseError?se(ut,k.method,Ze):ut&&st.string(ut.message)?se(new ve.ResponseError(ve.ErrorCodes.InternalError,`Request ${k.method} failed with message: ${ut.message}`),k.method,Ze):se(new ve.ResponseError(ve.ErrorCodes.InternalError,`Request ${k.method} failed unexpectedly without providing any details.`),k.method,Ze);}):(g.delete(Te),G(Ie,k.method,Ze)):(g.delete(Te),fe(Ie,k.method,Ze));}catch(Ie){g.delete(Te),Ie instanceof ve.ResponseError?G(Ie,k.method,Ze):Ie&&st.string(Ie.message)?se(new ve.ResponseError(ve.ErrorCodes.InternalError,`Request ${k.method} failed with message: ${Ie.message}`),k.method,Ze):se(new ve.ResponseError(ve.ErrorCodes.InternalError,`Request ${k.method} failed unexpectedly without providing any details.`),k.method,Ze);}}else se(new ve.ResponseError(ve.ErrorCodes.MethodNotFound,`Unhandled method ${k.method}`),k.method,Ze);}function ce(k){if(!Xe())if(k.id===null)k.error?i.error(`Received response message without id: Error is: 
${JSON.stringify(k.error,void 0,4)}`):i.error("Received response message without id. No further error information provided.");else {let G=k.id,se=P.get(G);if(Hn(k,se),se!==void 0){P.delete(G);try{if(k.error){let fe=k.error;se.reject(new ve.ResponseError(fe.code,fe.message,fe.data));}else if(k.result!==void 0)se.resolve(k.result);else throw new Error("Should never happen.")}catch(fe){fe.message?i.error(`Response handler '${se.method}' failed with message: ${fe.message}`):i.error(`Response handler '${se.method}' failed unexpectedly.`);}}}}function Me(k){if(Xe())return;let G,se;if(k.method===xo.type.method){let fe=k.params.id;D.delete(fe),Nt(k);return}else {let fe=m.get(k.method);fe&&(se=fe.handler,G=fe.type);}if(se||p)try{if(Nt(k),se)if(k.params===void 0)G!==void 0&&G.numberOfParams!==0&&G.parameterStructures!==ve.ParameterStructures.byName&&i.error(`Notification ${k.method} defines ${G.numberOfParams} params but received none.`),se();else if(Array.isArray(k.params)){let fe=k.params;k.method===Ro.type.method&&fe.length===2&&lm.is(fe[0])?se({token:fe[0],value:fe[1]}):(G!==void 0&&(G.parameterStructures===ve.ParameterStructures.byName&&i.error(`Notification ${k.method} defines parameters by name but received parameters by position`),G.numberOfParams!==k.params.length&&i.error(`Notification ${k.method} defines ${G.numberOfParams} params but received ${fe.length} arguments`)),se(...fe));}else G!==void 0&&G.parameterStructures===ve.ParameterStructures.byPosition&&i.error(`Notification ${k.method} defines parameters by position but received parameters by name`),se(k.params);else p&&p(k.method,k.params);}catch(fe){fe.message?i.error(`Notification handler '${k.method}' failed with message: ${fe.message}`):i.error(`Notification handler '${k.method}' failed unexpectedly.`);}else B.fire(k);}function ie(k){if(!k){i.error("Received empty message.");return}i.error(`Received message which is neither a response nor a notification message:
${JSON.stringify(k,null,4)}`);let G=k;if(st.string(G.id)||st.number(G.id)){let se=G.id,fe=P.get(se);fe&&fe.reject(new Error("The received response has neither a result nor an error property."));}}function be(k){if(k!=null)switch(S){case Le.Verbose:return JSON.stringify(k,null,4);case Le.Compact:return JSON.stringify(k);default:return}}function $e(k){if(!(S===Le.Off||!L))if(I===cr.Text){let G;(S===Le.Verbose||S===Le.Compact)&&k.params&&(G=`Params: ${be(k.params)}

`),L.log(`Sending request '${k.method} - (${k.id})'.`,G);}else qt("send-request",k);}function ot(k){if(!(S===Le.Off||!L))if(I===cr.Text){let G;(S===Le.Verbose||S===Le.Compact)&&(k.params?G=`Params: ${be(k.params)}

`:G=`No parameters provided.

`),L.log(`Sending notification '${k.method}'.`,G);}else qt("send-notification",k);}function He(k,G,se){if(!(S===Le.Off||!L))if(I===cr.Text){let fe;(S===Le.Verbose||S===Le.Compact)&&(k.error&&k.error.data?fe=`Error data: ${be(k.error.data)}

`:k.result?fe=`Result: ${be(k.result)}

`:k.error===void 0&&(fe=`No result returned.

`)),L.log(`Sending response '${G} - (${k.id})'. Processing request took ${Date.now()-se}ms`,fe);}else qt("send-response",k);}function fr(k){if(!(S===Le.Off||!L))if(I===cr.Text){let G;(S===Le.Verbose||S===Le.Compact)&&k.params&&(G=`Params: ${be(k.params)}

`),L.log(`Received request '${k.method} - (${k.id})'.`,G);}else qt("receive-request",k);}function Nt(k){if(!(S===Le.Off||!L||k.method===tc.type.method))if(I===cr.Text){let G;(S===Le.Verbose||S===Le.Compact)&&(k.params?G=`Params: ${be(k.params)}

`:G=`No parameters provided.

`),L.log(`Received notification '${k.method}'.`,G);}else qt("receive-notification",k);}function Hn(k,G){if(!(S===Le.Off||!L))if(I===cr.Text){let se;if((S===Le.Verbose||S===Le.Compact)&&(k.error&&k.error.data?se=`Error data: ${be(k.error.data)}

`:k.result?se=`Result: ${be(k.result)}

`:k.error===void 0&&(se=`No result returned.

`)),G){let fe=k.error?` Request failed: ${k.error.message} (${k.error.code}).`:"";L.log(`Received response '${G.method} - (${k.id})' in ${Date.now()-G.timerStart}ms.${fe}`,se);}else L.log(`Received response ${k.id} without active response promise.`,se);}else qt("receive-response",k);}function qt(k,G){if(!L||S===Le.Off)return;let se={isLSPMessage:!0,type:k,message:G,timestamp:Date.now()};L.log(se);}function Vt(){if(we())throw new ss(Co.Closed,"Connection is closed.");if(Xe())throw new ss(Co.Disposed,"Connection is disposed.")}function Wn(){if(pe())throw new ss(Co.AlreadyListening,"Connection is already listening")}function yi(){if(!pe())throw new Error("Call listen() first.")}function tr(k){return k===void 0?null:k}function Bn(k){if(k!==null)return k}function Un(k){return k!=null&&!Array.isArray(k)&&typeof k=="object"}function Yr(k,G){switch(k){case ve.ParameterStructures.auto:return Un(G)?Bn(G):[tr(G)];case ve.ParameterStructures.byName:if(!Un(G))throw new Error("Received parameters by name but param is not an object literal.");return Bn(G);case ve.ParameterStructures.byPosition:return [tr(G)];default:throw new Error(`Unknown parameter structure ${k.toString()}`)}}function zn(k,G){let se,fe=k.numberOfParams;switch(fe){case 0:se=void 0;break;case 1:se=Yr(k.parameterStructures,G[0]);break;default:se=[];for(let qe=0;qe<G.length&&qe<fe;qe++)se.push(tr(G[qe]));if(G.length<fe)for(let qe=G.length;qe<fe;qe++)se.push(null);break}return se}let xr={sendNotification:(k,...G)=>{Vt();let se,fe;if(st.string(k)){se=k;let ke=G[0],ze=0,Ze=ve.ParameterStructures.auto;ve.ParameterStructures.is(ke)&&(ze=1,Ze=ke);let Te=G.length,We=Te-ze;switch(We){case 0:fe=void 0;break;case 1:fe=Yr(Ze,G[ze]);break;default:if(Ze===ve.ParameterStructures.byName)throw new Error(`Received ${We} parameters for 'by Name' notification parameter structure.`);fe=G.slice(ze,Te).map(Ie=>tr(Ie));break}}else {let ke=G;se=k.method,fe=zn(k,ke);}let qe={jsonrpc:l,method:se,params:fe};return ot(qe),e.write(qe).catch(ke=>{throw i.error("Sending notification failed."),ke})},onNotification:(k,G)=>{Vt();let se;return st.func(k)?p=k:G&&(st.string(k)?(se=k,m.set(k,{type:void 0,handler:G})):(se=k.method,m.set(k.method,{type:k,handler:G}))),{dispose:()=>{se!==void 0?m.delete(se):p=void 0;}}},onProgress:(k,G,se)=>{if(_.has(G))throw new Error(`Progress handler for token ${G} already registered`);return _.set(G,se),{dispose:()=>{_.delete(G);}}},sendProgress:(k,G,se)=>xr.sendNotification(Ro.type,{token:G,value:se}),onUnhandledProgress:Q.event,sendRequest:(k,...G)=>{Vt(),yi();let se,fe,qe;if(st.string(k)){se=k;let Te=G[0],We=G[G.length-1],Ie=0,et=ve.ParameterStructures.auto;ve.ParameterStructures.is(Te)&&(Ie=1,et=Te);let ut=G.length;cm.CancellationToken.is(We)&&(ut=ut-1,qe=We);let Lt=ut-Ie;switch(Lt){case 0:fe=void 0;break;case 1:fe=Yr(et,G[Ie]);break;default:if(et===ve.ParameterStructures.byName)throw new Error(`Received ${Lt} parameters for 'by Name' request parameter structure.`);fe=G.slice(Ie,ut).map(bi=>tr(bi));break}}else {let Te=G;se=k.method,fe=zn(k,Te);let We=k.numberOfParams;qe=cm.CancellationToken.is(Te[We])?Te[We]:void 0;}let ke=s++,ze;qe&&(ze=qe.onCancellationRequested(()=>{let Te=te.sender.sendCancellation(xr,ke);return Te===void 0?(i.log(`Received no promise from cancellation strategy when cancelling id ${ke}`),Promise.resolve()):Te.catch(()=>{i.log(`Sending cancellation messages for id ${ke} failed`);})}));let Ze={jsonrpc:l,id:ke,method:se,params:fe};return $e(Ze),typeof te.sender.enableCancellation=="function"&&te.sender.enableCancellation(Ze),new Promise(async(Te,We)=>{let Ie=Lt=>{Te(Lt),te.sender.cleanup(ke),ze?.dispose();},et=Lt=>{We(Lt),te.sender.cleanup(ke),ze?.dispose();},ut={method:se,timerStart:Date.now(),resolve:Ie,reject:et};try{await e.write(Ze),P.set(ke,ut);}catch(Lt){throw i.error("Sending request failed."),ut.reject(new ve.ResponseError(ve.ErrorCodes.MessageWriteError,Lt.message?Lt.message:"Unknown reason")),Lt}})},onRequest:(k,G)=>{Vt();let se=null;return dm.is(k)?(se=void 0,d=k):st.string(k)?(se=null,G!==void 0&&(se=k,c.set(k,{handler:G,type:void 0}))):G!==void 0&&(se=k.method,c.set(k.method,{type:k,handler:G})),{dispose:()=>{se!==null&&(se!==void 0?c.delete(se):d=void 0);}}},hasPendingResponse:()=>P.size>0,trace:async(k,G,se)=>{let fe=!1,qe=cr.Text;se!==void 0&&(st.boolean(se)?fe=se:(fe=se.sendNotification||!1,qe=se.traceFormat||cr.Text)),S=k,I=qe,S===Le.Off?L=void 0:L=G,fe&&!we()&&!Xe()&&await xr.sendNotification(hm.type,{value:Le.toString(k)});},onError:K.event,onClose:U.event,onUnhandledNotification:B.event,onDispose:N.event,end:()=>{e.end();},dispose:()=>{if(Xe())return;Z=Fr.Disposed,N.fire(void 0);let k=new ve.ResponseError(ve.ErrorCodes.PendingResponseRejected,"Pending response rejected since connection got disposed");for(let G of P.values())G.reject(k);P=new Map,g=new Map,D=new Set,E=new IT.LinkedMap,st.func(e.dispose)&&e.dispose(),st.func(t.dispose)&&t.dispose();},listen:()=>{Vt(),Wn(),Z=Fr.Listening,t.listen(Cr);},inspect:()=>{(0, OT.default)().console.log("inspect");}};return xr.onNotification(tc.type,k=>{if(S===Le.Off||!L)return;let G=S===Le.Verbose||S===Le.Compact;L.log(k.message,G?k.verbose:void 0);}),xr.onNotification(Ro.type,k=>{let G=_.get(k.token);G?G(k.value):Q.fire(k);}),xr}xe.createMessageConnection=$3;});var ac=A(z=>{Object.defineProperty(z,"__esModule",{value:!0});z.ProgressType=z.ProgressToken=z.createMessageConnection=z.NullLogger=z.ConnectionOptions=z.ConnectionStrategy=z.AbstractMessageBuffer=z.WriteableStreamMessageWriter=z.AbstractMessageWriter=z.MessageWriter=z.ReadableStreamMessageReader=z.AbstractMessageReader=z.MessageReader=z.SharedArrayReceiverStrategy=z.SharedArraySenderStrategy=z.CancellationToken=z.CancellationTokenSource=z.Emitter=z.Event=z.Disposable=z.LRUCache=z.Touch=z.LinkedMap=z.ParameterStructures=z.NotificationType9=z.NotificationType8=z.NotificationType7=z.NotificationType6=z.NotificationType5=z.NotificationType4=z.NotificationType3=z.NotificationType2=z.NotificationType1=z.NotificationType0=z.NotificationType=z.ErrorCodes=z.ResponseError=z.RequestType9=z.RequestType8=z.RequestType7=z.RequestType6=z.RequestType5=z.RequestType4=z.RequestType3=z.RequestType2=z.RequestType1=z.RequestType0=z.RequestType=z.Message=z.RAL=void 0;z.MessageStrategy=z.CancellationStrategy=z.CancellationSenderStrategy=z.CancellationReceiverStrategy=z.ConnectionError=z.ConnectionErrors=z.LogTraceNotification=z.SetTraceNotification=z.TraceFormat=z.TraceValues=z.Trace=void 0;var Ye=Hp();Object.defineProperty(z,"Message",{enumerable:!0,get:function(){return Ye.Message}});Object.defineProperty(z,"RequestType",{enumerable:!0,get:function(){return Ye.RequestType}});Object.defineProperty(z,"RequestType0",{enumerable:!0,get:function(){return Ye.RequestType0}});Object.defineProperty(z,"RequestType1",{enumerable:!0,get:function(){return Ye.RequestType1}});Object.defineProperty(z,"RequestType2",{enumerable:!0,get:function(){return Ye.RequestType2}});Object.defineProperty(z,"RequestType3",{enumerable:!0,get:function(){return Ye.RequestType3}});Object.defineProperty(z,"RequestType4",{enumerable:!0,get:function(){return Ye.RequestType4}});Object.defineProperty(z,"RequestType5",{enumerable:!0,get:function(){return Ye.RequestType5}});Object.defineProperty(z,"RequestType6",{enumerable:!0,get:function(){return Ye.RequestType6}});Object.defineProperty(z,"RequestType7",{enumerable:!0,get:function(){return Ye.RequestType7}});Object.defineProperty(z,"RequestType8",{enumerable:!0,get:function(){return Ye.RequestType8}});Object.defineProperty(z,"RequestType9",{enumerable:!0,get:function(){return Ye.RequestType9}});Object.defineProperty(z,"ResponseError",{enumerable:!0,get:function(){return Ye.ResponseError}});Object.defineProperty(z,"ErrorCodes",{enumerable:!0,get:function(){return Ye.ErrorCodes}});Object.defineProperty(z,"NotificationType",{enumerable:!0,get:function(){return Ye.NotificationType}});Object.defineProperty(z,"NotificationType0",{enumerable:!0,get:function(){return Ye.NotificationType0}});Object.defineProperty(z,"NotificationType1",{enumerable:!0,get:function(){return Ye.NotificationType1}});Object.defineProperty(z,"NotificationType2",{enumerable:!0,get:function(){return Ye.NotificationType2}});Object.defineProperty(z,"NotificationType3",{enumerable:!0,get:function(){return Ye.NotificationType3}});Object.defineProperty(z,"NotificationType4",{enumerable:!0,get:function(){return Ye.NotificationType4}});Object.defineProperty(z,"NotificationType5",{enumerable:!0,get:function(){return Ye.NotificationType5}});Object.defineProperty(z,"NotificationType6",{enumerable:!0,get:function(){return Ye.NotificationType6}});Object.defineProperty(z,"NotificationType7",{enumerable:!0,get:function(){return Ye.NotificationType7}});Object.defineProperty(z,"NotificationType8",{enumerable:!0,get:function(){return Ye.NotificationType8}});Object.defineProperty(z,"NotificationType9",{enumerable:!0,get:function(){return Ye.NotificationType9}});Object.defineProperty(z,"ParameterStructures",{enumerable:!0,get:function(){return Ye.ParameterStructures}});var gm=Bp();Object.defineProperty(z,"LinkedMap",{enumerable:!0,get:function(){return gm.LinkedMap}});Object.defineProperty(z,"LRUCache",{enumerable:!0,get:function(){return gm.LRUCache}});Object.defineProperty(z,"Touch",{enumerable:!0,get:function(){return gm.Touch}});var j3=vT();Object.defineProperty(z,"Disposable",{enumerable:!0,get:function(){return j3.Disposable}});var NT=ts();Object.defineProperty(z,"Event",{enumerable:!0,get:function(){return NT.Event}});Object.defineProperty(z,"Emitter",{enumerable:!0,get:function(){return NT.Emitter}});var qT=Ju();Object.defineProperty(z,"CancellationTokenSource",{enumerable:!0,get:function(){return qT.CancellationTokenSource}});Object.defineProperty(z,"CancellationToken",{enumerable:!0,get:function(){return qT.CancellationToken}});var LT=ST();Object.defineProperty(z,"SharedArraySenderStrategy",{enumerable:!0,get:function(){return LT.SharedArraySenderStrategy}});Object.defineProperty(z,"SharedArrayReceiverStrategy",{enumerable:!0,get:function(){return LT.SharedArrayReceiverStrategy}});var _m=RT();Object.defineProperty(z,"MessageReader",{enumerable:!0,get:function(){return _m.MessageReader}});Object.defineProperty(z,"AbstractMessageReader",{enumerable:!0,get:function(){return _m.AbstractMessageReader}});Object.defineProperty(z,"ReadableStreamMessageReader",{enumerable:!0,get:function(){return _m.ReadableStreamMessageReader}});var ym=PT();Object.defineProperty(z,"MessageWriter",{enumerable:!0,get:function(){return ym.MessageWriter}});Object.defineProperty(z,"AbstractMessageWriter",{enumerable:!0,get:function(){return ym.AbstractMessageWriter}});Object.defineProperty(z,"WriteableStreamMessageWriter",{enumerable:!0,get:function(){return ym.WriteableStreamMessageWriter}});var H3=DT();Object.defineProperty(z,"AbstractMessageBuffer",{enumerable:!0,get:function(){return H3.AbstractMessageBuffer}});var At=FT();Object.defineProperty(z,"ConnectionStrategy",{enumerable:!0,get:function(){return At.ConnectionStrategy}});Object.defineProperty(z,"ConnectionOptions",{enumerable:!0,get:function(){return At.ConnectionOptions}});Object.defineProperty(z,"NullLogger",{enumerable:!0,get:function(){return At.NullLogger}});Object.defineProperty(z,"createMessageConnection",{enumerable:!0,get:function(){return At.createMessageConnection}});Object.defineProperty(z,"ProgressToken",{enumerable:!0,get:function(){return At.ProgressToken}});Object.defineProperty(z,"ProgressType",{enumerable:!0,get:function(){return At.ProgressType}});Object.defineProperty(z,"Trace",{enumerable:!0,get:function(){return At.Trace}});Object.defineProperty(z,"TraceValues",{enumerable:!0,get:function(){return At.TraceValues}});Object.defineProperty(z,"TraceFormat",{enumerable:!0,get:function(){return At.TraceFormat}});Object.defineProperty(z,"SetTraceNotification",{enumerable:!0,get:function(){return At.SetTraceNotification}});Object.defineProperty(z,"LogTraceNotification",{enumerable:!0,get:function(){return At.LogTraceNotification}});Object.defineProperty(z,"ConnectionErrors",{enumerable:!0,get:function(){return At.ConnectionErrors}});Object.defineProperty(z,"ConnectionError",{enumerable:!0,get:function(){return At.ConnectionError}});Object.defineProperty(z,"CancellationReceiverStrategy",{enumerable:!0,get:function(){return At.CancellationReceiverStrategy}});Object.defineProperty(z,"CancellationSenderStrategy",{enumerable:!0,get:function(){return At.CancellationSenderStrategy}});Object.defineProperty(z,"CancellationStrategy",{enumerable:!0,get:function(){return At.CancellationStrategy}});Object.defineProperty(z,"MessageStrategy",{enumerable:!0,get:function(){return At.MessageStrategy}});var W3=Dn();z.RAL=W3.default;});var HT=A(Sm=>{Object.defineProperty(Sm,"__esModule",{value:!0});var $T=oe("util"),cn=ac(),uc=class t extends cn.AbstractMessageBuffer{constructor(e="utf-8"){super(e);}emptyBuffer(){return t.emptyBuffer}fromString(e,r){return Buffer.from(e,r)}toString(e,r){return e instanceof Buffer?e.toString(r):new $T.TextDecoder(r).decode(e)}asNative(e,r){return r===void 0?e instanceof Buffer?e:Buffer.from(e):e instanceof Buffer?e.slice(0,r):Buffer.from(e,0,r)}allocNative(e){return Buffer.allocUnsafe(e)}};uc.emptyBuffer=Buffer.allocUnsafe(0);var bm=class{constructor(e){this.stream=e;}onClose(e){return this.stream.on("close",e),cn.Disposable.create(()=>this.stream.off("close",e))}onError(e){return this.stream.on("error",e),cn.Disposable.create(()=>this.stream.off("error",e))}onEnd(e){return this.stream.on("end",e),cn.Disposable.create(()=>this.stream.off("end",e))}onData(e){return this.stream.on("data",e),cn.Disposable.create(()=>this.stream.off("data",e))}},vm=class{constructor(e){this.stream=e;}onClose(e){return this.stream.on("close",e),cn.Disposable.create(()=>this.stream.off("close",e))}onError(e){return this.stream.on("error",e),cn.Disposable.create(()=>this.stream.off("error",e))}onEnd(e){return this.stream.on("end",e),cn.Disposable.create(()=>this.stream.off("end",e))}write(e,r){return new Promise((n,i)=>{let s=o=>{o==null?n():i(o);};typeof e=="string"?this.stream.write(e,r,s):this.stream.write(e,s);})}end(){this.stream.end();}},jT=Object.freeze({messageBuffer:Object.freeze({create:t=>new uc(t)}),applicationJson:Object.freeze({encoder:Object.freeze({name:"application/json",encode:(t,e)=>{try{return Promise.resolve(Buffer.from(JSON.stringify(t,void 0,0),e.charset))}catch(r){return Promise.reject(r)}}}),decoder:Object.freeze({name:"application/json",decode:(t,e)=>{try{return t instanceof Buffer?Promise.resolve(JSON.parse(t.toString(e.charset))):Promise.resolve(JSON.parse(new $T.TextDecoder(e.charset).decode(t)))}catch(r){return Promise.reject(r)}}})}),stream:Object.freeze({asReadableStream:t=>new bm(t),asWritableStream:t=>new vm(t)}),console,timer:Object.freeze({setTimeout(t,e,...r){let n=setTimeout(t,e,...r);return {dispose:()=>clearTimeout(n)}},setImmediate(t,...e){let r=setImmediate(t,...e);return {dispose:()=>clearImmediate(r)}},setInterval(t,e,...r){let n=setInterval(t,e,...r);return {dispose:()=>clearInterval(n)}}})});function wm(){return jT}(function(t){function e(){cn.RAL.install(jT);}t.install=e;})(wm||(wm={}));Sm.default=wm;});var hi=A(Oe=>{var B3=Oe&&Oe.__createBinding||(Object.create?function(t,e,r,n){n===void 0&&(n=r);var i=Object.getOwnPropertyDescriptor(e,r);(!i||("get"in i?!e.__esModule:i.writable||i.configurable))&&(i={enumerable:!0,get:function(){return e[r]}}),Object.defineProperty(t,n,i);}:function(t,e,r,n){n===void 0&&(n=r),t[n]=e[r];}),U3=Oe&&Oe.__exportStar||function(t,e){for(var r in t)r!=="default"&&!Object.prototype.hasOwnProperty.call(e,r)&&B3(e,t,r);};Object.defineProperty(Oe,"__esModule",{value:!0});Oe.createMessageConnection=Oe.createServerSocketTransport=Oe.createClientSocketTransport=Oe.createServerPipeTransport=Oe.createClientPipeTransport=Oe.generateRandomPipeName=Oe.StreamMessageWriter=Oe.StreamMessageReader=Oe.SocketMessageWriter=Oe.SocketMessageReader=Oe.PortMessageWriter=Oe.PortMessageReader=Oe.IPCMessageWriter=Oe.IPCMessageReader=void 0;var os=HT();os.default.install();var WT=oe("path"),z3=oe("os"),V3=oe("crypto"),fc=oe("net"),lr=ac();U3(ac(),Oe);var Em=class extends lr.AbstractMessageReader{constructor(e){super(),this.process=e;let r=this.process;r.on("error",n=>this.fireError(n)),r.on("close",()=>this.fireClose());}listen(e){return this.process.on("message",e),lr.Disposable.create(()=>this.process.off("message",e))}};Oe.IPCMessageReader=Em;var Rm=class extends lr.AbstractMessageWriter{constructor(e){super(),this.process=e,this.errorCount=0;let r=this.process;r.on("error",n=>this.fireError(n)),r.on("close",()=>this.fireClose);}write(e){try{return typeof this.process.send=="function"&&this.process.send(e,void 0,void 0,r=>{r?(this.errorCount++,this.handleError(r,e)):this.errorCount=0;}),Promise.resolve()}catch(r){return this.handleError(r,e),Promise.reject(r)}}handleError(e,r){this.errorCount++,this.fireError(e,r,this.errorCount);}end(){}};Oe.IPCMessageWriter=Rm;var Cm=class extends lr.AbstractMessageReader{constructor(e){super(),this.onData=new lr.Emitter,e.on("close",()=>this.fireClose),e.on("error",r=>this.fireError(r)),e.on("message",r=>{this.onData.fire(r);});}listen(e){return this.onData.event(e)}};Oe.PortMessageReader=Cm;var xm=class extends lr.AbstractMessageWriter{constructor(e){super(),this.port=e,this.errorCount=0,e.on("close",()=>this.fireClose()),e.on("error",r=>this.fireError(r));}write(e){try{return this.port.postMessage(e),Promise.resolve()}catch(r){return this.handleError(r,e),Promise.reject(r)}}handleError(e,r){this.errorCount++,this.fireError(e,r,this.errorCount);}end(){}};Oe.PortMessageWriter=xm;var fi=class extends lr.ReadableStreamMessageReader{constructor(e,r="utf-8"){super((0, os.default)().stream.asReadableStream(e),r);}};Oe.SocketMessageReader=fi;var di=class extends lr.WriteableStreamMessageWriter{constructor(e,r){super((0, os.default)().stream.asWritableStream(e),r),this.socket=e;}dispose(){super.dispose(),this.socket.destroy();}};Oe.SocketMessageWriter=di;var cc=class extends lr.ReadableStreamMessageReader{constructor(e,r){super((0, os.default)().stream.asReadableStream(e),r);}};Oe.StreamMessageReader=cc;var lc=class extends lr.WriteableStreamMessageWriter{constructor(e,r){super((0, os.default)().stream.asWritableStream(e),r);}};Oe.StreamMessageWriter=lc;var BT=process.env.XDG_RUNTIME_DIR,G3=new Map([["linux",107],["darwin",103]]);function K3(){let t=(0, V3.randomBytes)(21).toString("hex");if(process.platform==="win32")return `\\\\.\\pipe\\vscode-jsonrpc-${t}-sock`;let e;BT?e=WT.join(BT,`vscode-ipc-${t}.sock`):e=WT.join(z3.tmpdir(),`vscode-${t}.sock`);let r=G3.get(process.platform);return r!==void 0&&e.length>r&&(0, os.default)().console.warn(`WARNING: IPC handle "${e}" is longer than ${r} characters.`),e}Oe.generateRandomPipeName=K3;function Z3(t,e="utf-8"){let r,n=new Promise((i,s)=>{r=i;});return new Promise((i,s)=>{let o=(0, fc.createServer)(a=>{o.close(),r([new fi(a,e),new di(a,e)]);});o.on("error",s),o.listen(t,()=>{o.removeListener("error",s),i({onConnected:()=>n});});})}Oe.createClientPipeTransport=Z3;function J3(t,e="utf-8"){let r=(0, fc.createConnection)(t);return [new fi(r,e),new di(r,e)]}Oe.createServerPipeTransport=J3;function Y3(t,e="utf-8"){let r,n=new Promise((i,s)=>{r=i;});return new Promise((i,s)=>{let o=(0, fc.createServer)(a=>{o.close(),r([new fi(a,e),new di(a,e)]);});o.on("error",s),o.listen(t,"127.0.0.1",()=>{o.removeListener("error",s),i({onConnected:()=>n});});})}Oe.createClientSocketTransport=Y3;function X3(t,e="utf-8"){let r=(0, fc.createConnection)(t,"127.0.0.1");return [new fi(r,e),new di(r,e)]}Oe.createServerSocketTransport=X3;function Q3(t){let e=t;return e.read!==void 0&&e.addListener!==void 0}function e4(t){let e=t;return e.write!==void 0&&e.addListener!==void 0}function t4(t,e,r,n){r||(r=lr.NullLogger);let i=Q3(t)?new cc(t):t,s=e4(e)?new lc(e):e;return lr.ConnectionStrategy.is(n)&&(n={connectionStrategy:n}),(0, lr.createMessageConnection)(i,s,r,n)}Oe.createMessageConnection=t4;});var Tm=A((xK,UT)=>{UT.exports=hi();});var hc=A((zT,dc)=>{(function(t){if(typeof dc=="object"&&typeof dc.exports=="object"){var e=t(oe,zT);e!==void 0&&(dc.exports=e);}else typeof define=="function"&&define.amd&&define(["require","exports"],t);})(function(t,e){Object.defineProperty(e,"__esModule",{value:!0}),e.TextDocument=e.EOL=e.WorkspaceFolder=e.InlineCompletionContext=e.SelectedCompletionInfo=e.InlineCompletionTriggerKind=e.InlineCompletionList=e.InlineCompletionItem=e.StringValue=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.SemanticTokens=e.SemanticTokenModifiers=e.SemanticTokenTypes=e.SelectionRange=e.DocumentLink=e.FormattingOptions=e.CodeLens=e.CodeAction=e.CodeActionContext=e.CodeActionTriggerKind=e.CodeActionKind=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.SignatureInformation=e.ParameterInformation=e.Hover=e.MarkedString=e.CompletionList=e.CompletionItem=e.CompletionItemLabelDetails=e.InsertTextMode=e.InsertReplaceEdit=e.CompletionItemTag=e.InsertTextFormat=e.CompletionItemKind=e.MarkupContent=e.MarkupKind=e.TextDocumentItem=e.OptionalVersionedTextDocumentIdentifier=e.VersionedTextDocumentIdentifier=e.TextDocumentIdentifier=e.WorkspaceChange=e.WorkspaceEdit=e.DeleteFile=e.RenameFile=e.CreateFile=e.TextDocumentEdit=e.AnnotatedTextEdit=e.ChangeAnnotationIdentifier=e.ChangeAnnotation=e.TextEdit=e.Command=e.Diagnostic=e.CodeDescription=e.DiagnosticTag=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.FoldingRange=e.FoldingRangeKind=e.ColorPresentation=e.ColorInformation=e.Color=e.LocationLink=e.Location=e.Range=e.Position=e.uinteger=e.integer=e.URI=e.DocumentUri=void 0;var r;(function(v){function M(F){return typeof F=="string"}v.is=M;})(r||(e.DocumentUri=r={}));var n;(function(v){function M(F){return typeof F=="string"}v.is=M;})(n||(e.URI=n={}));var i;(function(v){v.MIN_VALUE=-2147483648,v.MAX_VALUE=2147483647;function M(F){return typeof F=="number"&&v.MIN_VALUE<=F&&F<=v.MAX_VALUE}v.is=M;})(i||(e.integer=i={}));var s;(function(v){v.MIN_VALUE=0,v.MAX_VALUE=2147483647;function M(F){return typeof F=="number"&&v.MIN_VALUE<=F&&F<=v.MAX_VALUE}v.is=M;})(s||(e.uinteger=s={}));var o;(function(v){function M(R,y){return R===Number.MAX_VALUE&&(R=s.MAX_VALUE),y===Number.MAX_VALUE&&(y=s.MAX_VALUE),{line:R,character:y}}v.create=M;function F(R){var y=R;return j.objectLiteral(y)&&j.uinteger(y.line)&&j.uinteger(y.character)}v.is=F;})(o||(e.Position=o={}));var a;(function(v){function M(R,y,$,J){if(j.uinteger(R)&&j.uinteger(y)&&j.uinteger($)&&j.uinteger(J))return {start:o.create(R,y),end:o.create($,J)};if(o.is(R)&&o.is(y))return {start:R,end:y};throw new Error("Range#create called with invalid arguments[".concat(R,", ").concat(y,", ").concat($,", ").concat(J,"]"))}v.create=M;function F(R){var y=R;return j.objectLiteral(y)&&o.is(y.start)&&o.is(y.end)}v.is=F;})(a||(e.Range=a={}));var l;(function(v){function M(R,y){return {uri:R,range:y}}v.create=M;function F(R){var y=R;return j.objectLiteral(y)&&a.is(y.range)&&(j.string(y.uri)||j.undefined(y.uri))}v.is=F;})(l||(e.Location=l={}));var d;(function(v){function M(R,y,$,J){return {targetUri:R,targetRange:y,targetSelectionRange:$,originSelectionRange:J}}v.create=M;function F(R){var y=R;return j.objectLiteral(y)&&a.is(y.targetRange)&&j.string(y.targetUri)&&a.is(y.targetSelectionRange)&&(a.is(y.originSelectionRange)||j.undefined(y.originSelectionRange))}v.is=F;})(d||(e.LocationLink=d={}));var c;(function(v){function M(R,y,$,J){return {red:R,green:y,blue:$,alpha:J}}v.create=M;function F(R){var y=R;return j.objectLiteral(y)&&j.numberRange(y.red,0,1)&&j.numberRange(y.green,0,1)&&j.numberRange(y.blue,0,1)&&j.numberRange(y.alpha,0,1)}v.is=F;})(c||(e.Color=c={}));var p;(function(v){function M(R,y){return {range:R,color:y}}v.create=M;function F(R){var y=R;return j.objectLiteral(y)&&a.is(y.range)&&c.is(y.color)}v.is=F;})(p||(e.ColorInformation=p={}));var m;(function(v){function M(R,y,$){return {label:R,textEdit:y,additionalTextEdits:$}}v.create=M;function F(R){var y=R;return j.objectLiteral(y)&&j.string(y.label)&&(j.undefined(y.textEdit)||L.is(y))&&(j.undefined(y.additionalTextEdits)||j.typedArray(y.additionalTextEdits,L.is))}v.is=F;})(m||(e.ColorPresentation=m={}));var _;(function(v){v.Comment="comment",v.Imports="imports",v.Region="region";})(_||(e.FoldingRangeKind=_={}));var w;(function(v){function M(R,y,$,J,Ee,tt){var Ve={startLine:R,endLine:y};return j.defined($)&&(Ve.startCharacter=$),j.defined(J)&&(Ve.endCharacter=J),j.defined(Ee)&&(Ve.kind=Ee),j.defined(tt)&&(Ve.collapsedText=tt),Ve}v.create=M;function F(R){var y=R;return j.objectLiteral(y)&&j.uinteger(y.startLine)&&j.uinteger(y.startLine)&&(j.undefined(y.startCharacter)||j.uinteger(y.startCharacter))&&(j.undefined(y.endCharacter)||j.uinteger(y.endCharacter))&&(j.undefined(y.kind)||j.string(y.kind))}v.is=F;})(w||(e.FoldingRange=w={}));var E;(function(v){function M(R,y){return {location:R,message:y}}v.create=M;function F(R){var y=R;return j.defined(y)&&l.is(y.location)&&j.string(y.message)}v.is=F;})(E||(e.DiagnosticRelatedInformation=E={}));var P;(function(v){v.Error=1,v.Warning=2,v.Information=3,v.Hint=4;})(P||(e.DiagnosticSeverity=P={}));var D;(function(v){v.Unnecessary=1,v.Deprecated=2;})(D||(e.DiagnosticTag=D={}));var g;(function(v){function M(F){var R=F;return j.objectLiteral(R)&&j.string(R.href)}v.is=M;})(g||(e.CodeDescription=g={}));var S;(function(v){function M(R,y,$,J,Ee,tt){var Ve={range:R,message:y};return j.defined($)&&(Ve.severity=$),j.defined(J)&&(Ve.code=J),j.defined(Ee)&&(Ve.source=Ee),j.defined(tt)&&(Ve.relatedInformation=tt),Ve}v.create=M;function F(R){var y,$=R;return j.defined($)&&a.is($.range)&&j.string($.message)&&(j.number($.severity)||j.undefined($.severity))&&(j.integer($.code)||j.string($.code)||j.undefined($.code))&&(j.undefined($.codeDescription)||j.string((y=$.codeDescription)===null||y===void 0?void 0:y.href))&&(j.string($.source)||j.undefined($.source))&&(j.undefined($.relatedInformation)||j.typedArray($.relatedInformation,E.is))}v.is=F;})(S||(e.Diagnostic=S={}));var I;(function(v){function M(R,y){for(var $=[],J=2;J<arguments.length;J++)$[J-2]=arguments[J];var Ee={title:R,command:y};return j.defined($)&&$.length>0&&(Ee.arguments=$),Ee}v.create=M;function F(R){var y=R;return j.defined(y)&&j.string(y.title)&&j.string(y.command)}v.is=F;})(I||(e.Command=I={}));var L;(function(v){function M($,J){return {range:$,newText:J}}v.replace=M;function F($,J){return {range:{start:$,end:$},newText:J}}v.insert=F;function R($){return {range:$,newText:""}}v.del=R;function y($){var J=$;return j.objectLiteral(J)&&j.string(J.newText)&&a.is(J.range)}v.is=y;})(L||(e.TextEdit=L={}));var Z;(function(v){function M(R,y,$){var J={label:R};return y!==void 0&&(J.needsConfirmation=y),$!==void 0&&(J.description=$),J}v.create=M;function F(R){var y=R;return j.objectLiteral(y)&&j.string(y.label)&&(j.boolean(y.needsConfirmation)||y.needsConfirmation===void 0)&&(j.string(y.description)||y.description===void 0)}v.is=F;})(Z||(e.ChangeAnnotation=Z={}));var K;(function(v){function M(F){var R=F;return j.string(R)}v.is=M;})(K||(e.ChangeAnnotationIdentifier=K={}));var U;(function(v){function M($,J,Ee){return {range:$,newText:J,annotationId:Ee}}v.replace=M;function F($,J,Ee){return {range:{start:$,end:$},newText:J,annotationId:Ee}}v.insert=F;function R($,J){return {range:$,newText:"",annotationId:J}}v.del=R;function y($){var J=$;return L.is(J)&&(Z.is(J.annotationId)||K.is(J.annotationId))}v.is=y;})(U||(e.AnnotatedTextEdit=U={}));var B;(function(v){function M(R,y){return {textDocument:R,edits:y}}v.create=M;function F(R){var y=R;return j.defined(y)&&we.is(y.textDocument)&&Array.isArray(y.edits)}v.is=F;})(B||(e.TextDocumentEdit=B={}));var Q;(function(v){function M(R,y,$){var J={kind:"create",uri:R};return y!==void 0&&(y.overwrite!==void 0||y.ignoreIfExists!==void 0)&&(J.options=y),$!==void 0&&(J.annotationId=$),J}v.create=M;function F(R){var y=R;return y&&y.kind==="create"&&j.string(y.uri)&&(y.options===void 0||(y.options.overwrite===void 0||j.boolean(y.options.overwrite))&&(y.options.ignoreIfExists===void 0||j.boolean(y.options.ignoreIfExists)))&&(y.annotationId===void 0||K.is(y.annotationId))}v.is=F;})(Q||(e.CreateFile=Q={}));var N;(function(v){function M(R,y,$,J){var Ee={kind:"rename",oldUri:R,newUri:y};return $!==void 0&&($.overwrite!==void 0||$.ignoreIfExists!==void 0)&&(Ee.options=$),J!==void 0&&(Ee.annotationId=J),Ee}v.create=M;function F(R){var y=R;return y&&y.kind==="rename"&&j.string(y.oldUri)&&j.string(y.newUri)&&(y.options===void 0||(y.options.overwrite===void 0||j.boolean(y.options.overwrite))&&(y.options.ignoreIfExists===void 0||j.boolean(y.options.ignoreIfExists)))&&(y.annotationId===void 0||K.is(y.annotationId))}v.is=F;})(N||(e.RenameFile=N={}));var te;(function(v){function M(R,y,$){var J={kind:"delete",uri:R};return y!==void 0&&(y.recursive!==void 0||y.ignoreIfNotExists!==void 0)&&(J.options=y),$!==void 0&&(J.annotationId=$),J}v.create=M;function F(R){var y=R;return y&&y.kind==="delete"&&j.string(y.uri)&&(y.options===void 0||(y.options.recursive===void 0||j.boolean(y.options.recursive))&&(y.options.ignoreIfNotExists===void 0||j.boolean(y.options.ignoreIfNotExists)))&&(y.annotationId===void 0||K.is(y.annotationId))}v.is=F;})(te||(e.DeleteFile=te={}));var ae;(function(v){function M(F){var R=F;return R&&(R.changes!==void 0||R.documentChanges!==void 0)&&(R.documentChanges===void 0||R.documentChanges.every(function(y){return j.string(y.kind)?Q.is(y)||N.is(y)||te.is(y):B.is(y)}))}v.is=M;})(ae||(e.WorkspaceEdit=ae={}));var ye=function(){function v(M,F){this.edits=M,this.changeAnnotations=F;}return v.prototype.insert=function(M,F,R){var y,$;if(R===void 0?y=L.insert(M,F):K.is(R)?($=R,y=U.insert(M,F,R)):(this.assertChangeAnnotations(this.changeAnnotations),$=this.changeAnnotations.manage(R),y=U.insert(M,F,$)),this.edits.push(y),$!==void 0)return $},v.prototype.replace=function(M,F,R){var y,$;if(R===void 0?y=L.replace(M,F):K.is(R)?($=R,y=U.replace(M,F,R)):(this.assertChangeAnnotations(this.changeAnnotations),$=this.changeAnnotations.manage(R),y=U.replace(M,F,$)),this.edits.push(y),$!==void 0)return $},v.prototype.delete=function(M,F){var R,y;if(F===void 0?R=L.del(M):K.is(F)?(y=F,R=U.del(M,F)):(this.assertChangeAnnotations(this.changeAnnotations),y=this.changeAnnotations.manage(F),R=U.del(M,y)),this.edits.push(R),y!==void 0)return y},v.prototype.add=function(M){this.edits.push(M);},v.prototype.all=function(){return this.edits},v.prototype.clear=function(){this.edits.splice(0,this.edits.length);},v.prototype.assertChangeAnnotations=function(M){if(M===void 0)throw new Error("Text edit change is not configured to manage change annotations.")},v}(),q=function(){function v(M){this._annotations=M===void 0?Object.create(null):M,this._counter=0,this._size=0;}return v.prototype.all=function(){return this._annotations},Object.defineProperty(v.prototype,"size",{get:function(){return this._size},enumerable:!1,configurable:!0}),v.prototype.manage=function(M,F){var R;if(K.is(M)?R=M:(R=this.nextId(),F=M),this._annotations[R]!==void 0)throw new Error("Id ".concat(R," is already in use."));if(F===void 0)throw new Error("No annotation provided for id ".concat(R));return this._annotations[R]=F,this._size++,R},v.prototype.nextId=function(){return this._counter++,this._counter.toString()},v}(),W=function(){function v(M){var F=this;this._textEditChanges=Object.create(null),M!==void 0?(this._workspaceEdit=M,M.documentChanges?(this._changeAnnotations=new q(M.changeAnnotations),M.changeAnnotations=this._changeAnnotations.all(),M.documentChanges.forEach(function(R){if(B.is(R)){var y=new ye(R.edits,F._changeAnnotations);F._textEditChanges[R.textDocument.uri]=y;}})):M.changes&&Object.keys(M.changes).forEach(function(R){var y=new ye(M.changes[R]);F._textEditChanges[R]=y;})):this._workspaceEdit={};}return Object.defineProperty(v.prototype,"edit",{get:function(){return this.initDocumentChanges(),this._changeAnnotations!==void 0&&(this._changeAnnotations.size===0?this._workspaceEdit.changeAnnotations=void 0:this._workspaceEdit.changeAnnotations=this._changeAnnotations.all()),this._workspaceEdit},enumerable:!1,configurable:!0}),v.prototype.getTextEditChange=function(M){if(we.is(M)){if(this.initDocumentChanges(),this._workspaceEdit.documentChanges===void 0)throw new Error("Workspace edit is not configured for document changes.");var F={uri:M.uri,version:M.version},R=this._textEditChanges[F.uri];if(!R){var y=[],$={textDocument:F,edits:y};this._workspaceEdit.documentChanges.push($),R=new ye(y,this._changeAnnotations),this._textEditChanges[F.uri]=R;}return R}else {if(this.initChanges(),this._workspaceEdit.changes===void 0)throw new Error("Workspace edit is not configured for normal text edit changes.");var R=this._textEditChanges[M];if(!R){var y=[];this._workspaceEdit.changes[M]=y,R=new ye(y),this._textEditChanges[M]=R;}return R}},v.prototype.initDocumentChanges=function(){this._workspaceEdit.documentChanges===void 0&&this._workspaceEdit.changes===void 0&&(this._changeAnnotations=new q,this._workspaceEdit.documentChanges=[],this._workspaceEdit.changeAnnotations=this._changeAnnotations.all());},v.prototype.initChanges=function(){this._workspaceEdit.documentChanges===void 0&&this._workspaceEdit.changes===void 0&&(this._workspaceEdit.changes=Object.create(null));},v.prototype.createFile=function(M,F,R){if(this.initDocumentChanges(),this._workspaceEdit.documentChanges===void 0)throw new Error("Workspace edit is not configured for document changes.");var y;Z.is(F)||K.is(F)?y=F:R=F;var $,J;if(y===void 0?$=Q.create(M,R):(J=K.is(y)?y:this._changeAnnotations.manage(y),$=Q.create(M,R,J)),this._workspaceEdit.documentChanges.push($),J!==void 0)return J},v.prototype.renameFile=function(M,F,R,y){if(this.initDocumentChanges(),this._workspaceEdit.documentChanges===void 0)throw new Error("Workspace edit is not configured for document changes.");var $;Z.is(R)||K.is(R)?$=R:y=R;var J,Ee;if($===void 0?J=N.create(M,F,y):(Ee=K.is($)?$:this._changeAnnotations.manage($),J=N.create(M,F,y,Ee)),this._workspaceEdit.documentChanges.push(J),Ee!==void 0)return Ee},v.prototype.deleteFile=function(M,F,R){if(this.initDocumentChanges(),this._workspaceEdit.documentChanges===void 0)throw new Error("Workspace edit is not configured for document changes.");var y;Z.is(F)||K.is(F)?y=F:R=F;var $,J;if(y===void 0?$=te.create(M,R):(J=K.is(y)?y:this._changeAnnotations.manage(y),$=te.create(M,R,J)),this._workspaceEdit.documentChanges.push($),J!==void 0)return J},v}();e.WorkspaceChange=W;var me;(function(v){function M(R){return {uri:R}}v.create=M;function F(R){var y=R;return j.defined(y)&&j.string(y.uri)}v.is=F;})(me||(e.TextDocumentIdentifier=me={}));var pe;(function(v){function M(R,y){return {uri:R,version:y}}v.create=M;function F(R){var y=R;return j.defined(y)&&j.string(y.uri)&&j.integer(y.version)}v.is=F;})(pe||(e.VersionedTextDocumentIdentifier=pe={}));var we;(function(v){function M(R,y){return {uri:R,version:y}}v.create=M;function F(R){var y=R;return j.defined(y)&&j.string(y.uri)&&(y.version===null||j.integer(y.version))}v.is=F;})(we||(e.OptionalVersionedTextDocumentIdentifier=we={}));var Xe;(function(v){function M(R,y,$,J){return {uri:R,languageId:y,version:$,text:J}}v.create=M;function F(R){var y=R;return j.defined(y)&&j.string(y.uri)&&j.string(y.languageId)&&j.integer(y.version)&&j.string(y.text)}v.is=F;})(Xe||(e.TextDocumentItem=Xe={}));var Ke;(function(v){v.PlainText="plaintext",v.Markdown="markdown";function M(F){var R=F;return R===v.PlainText||R===v.Markdown}v.is=M;})(Ke||(e.MarkupKind=Ke={}));var Pt;(function(v){function M(F){var R=F;return j.objectLiteral(F)&&Ke.is(R.kind)&&j.string(R.value)}v.is=M;})(Pt||(e.MarkupContent=Pt={}));var Lr;(function(v){v.Text=1,v.Method=2,v.Function=3,v.Constructor=4,v.Field=5,v.Variable=6,v.Class=7,v.Interface=8,v.Module=9,v.Property=10,v.Unit=11,v.Value=12,v.Enum=13,v.Keyword=14,v.Snippet=15,v.Color=16,v.File=17,v.Reference=18,v.Folder=19,v.EnumMember=20,v.Constant=21,v.Struct=22,v.Event=23,v.Operator=24,v.TypeParameter=25;})(Lr||(e.CompletionItemKind=Lr={}));var zt;(function(v){v.PlainText=1,v.Snippet=2;})(zt||(e.InsertTextFormat=zt={}));var St;(function(v){v.Deprecated=1;})(St||(e.CompletionItemTag=St={}));var Ce;(function(v){function M(R,y,$){return {newText:R,insert:y,replace:$}}v.create=M;function F(R){var y=R;return y&&j.string(y.newText)&&a.is(y.insert)&&a.is(y.replace)}v.is=F;})(Ce||(e.InsertReplaceEdit=Ce={}));var Cr;(function(v){v.asIs=1,v.adjustIndentation=2;})(Cr||(e.InsertTextMode=Cr={}));var fn;(function(v){function M(F){var R=F;return R&&(j.string(R.detail)||R.detail===void 0)&&(j.string(R.description)||R.description===void 0)}v.is=M;})(fn||(e.CompletionItemLabelDetails=fn={}));var ce;(function(v){function M(F){return {label:F}}v.create=M;})(ce||(e.CompletionItem=ce={}));var Me;(function(v){function M(F,R){return {items:F||[],isIncomplete:!!R}}v.create=M;})(Me||(e.CompletionList=Me={}));var ie;(function(v){function M(R){return R.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}v.fromPlainText=M;function F(R){var y=R;return j.string(y)||j.objectLiteral(y)&&j.string(y.language)&&j.string(y.value)}v.is=F;})(ie||(e.MarkedString=ie={}));var be;(function(v){function M(F){var R=F;return !!R&&j.objectLiteral(R)&&(Pt.is(R.contents)||ie.is(R.contents)||j.typedArray(R.contents,ie.is))&&(F.range===void 0||a.is(F.range))}v.is=M;})(be||(e.Hover=be={}));var $e;(function(v){function M(F,R){return R?{label:F,documentation:R}:{label:F}}v.create=M;})($e||(e.ParameterInformation=$e={}));var ot;(function(v){function M(F,R){for(var y=[],$=2;$<arguments.length;$++)y[$-2]=arguments[$];var J={label:F};return j.defined(R)&&(J.documentation=R),j.defined(y)?J.parameters=y:J.parameters=[],J}v.create=M;})(ot||(e.SignatureInformation=ot={}));var He;(function(v){v.Text=1,v.Read=2,v.Write=3;})(He||(e.DocumentHighlightKind=He={}));var fr;(function(v){function M(F,R){var y={range:F};return j.number(R)&&(y.kind=R),y}v.create=M;})(fr||(e.DocumentHighlight=fr={}));var Nt;(function(v){v.File=1,v.Module=2,v.Namespace=3,v.Package=4,v.Class=5,v.Method=6,v.Property=7,v.Field=8,v.Constructor=9,v.Enum=10,v.Interface=11,v.Function=12,v.Variable=13,v.Constant=14,v.String=15,v.Number=16,v.Boolean=17,v.Array=18,v.Object=19,v.Key=20,v.Null=21,v.EnumMember=22,v.Struct=23,v.Event=24,v.Operator=25,v.TypeParameter=26;})(Nt||(e.SymbolKind=Nt={}));var Hn;(function(v){v.Deprecated=1;})(Hn||(e.SymbolTag=Hn={}));var qt;(function(v){function M(F,R,y,$,J){var Ee={name:F,kind:R,location:{uri:$,range:y}};return J&&(Ee.containerName=J),Ee}v.create=M;})(qt||(e.SymbolInformation=qt={}));var Vt;(function(v){function M(F,R,y,$){return $!==void 0?{name:F,kind:R,location:{uri:y,range:$}}:{name:F,kind:R,location:{uri:y}}}v.create=M;})(Vt||(e.WorkspaceSymbol=Vt={}));var Wn;(function(v){function M(R,y,$,J,Ee,tt){var Ve={name:R,detail:y,kind:$,range:J,selectionRange:Ee};return tt!==void 0&&(Ve.children=tt),Ve}v.create=M;function F(R){var y=R;return y&&j.string(y.name)&&j.number(y.kind)&&a.is(y.range)&&a.is(y.selectionRange)&&(y.detail===void 0||j.string(y.detail))&&(y.deprecated===void 0||j.boolean(y.deprecated))&&(y.children===void 0||Array.isArray(y.children))&&(y.tags===void 0||Array.isArray(y.tags))}v.is=F;})(Wn||(e.DocumentSymbol=Wn={}));var yi;(function(v){v.Empty="",v.QuickFix="quickfix",v.Refactor="refactor",v.RefactorExtract="refactor.extract",v.RefactorInline="refactor.inline",v.RefactorRewrite="refactor.rewrite",v.Source="source",v.SourceOrganizeImports="source.organizeImports",v.SourceFixAll="source.fixAll";})(yi||(e.CodeActionKind=yi={}));var tr;(function(v){v.Invoked=1,v.Automatic=2;})(tr||(e.CodeActionTriggerKind=tr={}));var Bn;(function(v){function M(R,y,$){var J={diagnostics:R};return y!=null&&(J.only=y),$!=null&&(J.triggerKind=$),J}v.create=M;function F(R){var y=R;return j.defined(y)&&j.typedArray(y.diagnostics,S.is)&&(y.only===void 0||j.typedArray(y.only,j.string))&&(y.triggerKind===void 0||y.triggerKind===tr.Invoked||y.triggerKind===tr.Automatic)}v.is=F;})(Bn||(e.CodeActionContext=Bn={}));var Un;(function(v){function M(R,y,$){var J={title:R},Ee=!0;return typeof y=="string"?(Ee=!1,J.kind=y):I.is(y)?J.command=y:J.edit=y,Ee&&$!==void 0&&(J.kind=$),J}v.create=M;function F(R){var y=R;return y&&j.string(y.title)&&(y.diagnostics===void 0||j.typedArray(y.diagnostics,S.is))&&(y.kind===void 0||j.string(y.kind))&&(y.edit!==void 0||y.command!==void 0)&&(y.command===void 0||I.is(y.command))&&(y.isPreferred===void 0||j.boolean(y.isPreferred))&&(y.edit===void 0||ae.is(y.edit))}v.is=F;})(Un||(e.CodeAction=Un={}));var Yr;(function(v){function M(R,y){var $={range:R};return j.defined(y)&&($.data=y),$}v.create=M;function F(R){var y=R;return j.defined(y)&&a.is(y.range)&&(j.undefined(y.command)||I.is(y.command))}v.is=F;})(Yr||(e.CodeLens=Yr={}));var zn;(function(v){function M(R,y){return {tabSize:R,insertSpaces:y}}v.create=M;function F(R){var y=R;return j.defined(y)&&j.uinteger(y.tabSize)&&j.boolean(y.insertSpaces)}v.is=F;})(zn||(e.FormattingOptions=zn={}));var xr;(function(v){function M(R,y,$){return {range:R,target:y,data:$}}v.create=M;function F(R){var y=R;return j.defined(y)&&a.is(y.range)&&(j.undefined(y.target)||j.string(y.target))}v.is=F;})(xr||(e.DocumentLink=xr={}));var k;(function(v){function M(R,y){return {range:R,parent:y}}v.create=M;function F(R){var y=R;return j.objectLiteral(y)&&a.is(y.range)&&(y.parent===void 0||v.is(y.parent))}v.is=F;})(k||(e.SelectionRange=k={}));var G;(function(v){v.namespace="namespace",v.type="type",v.class="class",v.enum="enum",v.interface="interface",v.struct="struct",v.typeParameter="typeParameter",v.parameter="parameter",v.variable="variable",v.property="property",v.enumMember="enumMember",v.event="event",v.function="function",v.method="method",v.macro="macro",v.keyword="keyword",v.modifier="modifier",v.comment="comment",v.string="string",v.number="number",v.regexp="regexp",v.operator="operator",v.decorator="decorator";})(G||(e.SemanticTokenTypes=G={}));var se;(function(v){v.declaration="declaration",v.definition="definition",v.readonly="readonly",v.static="static",v.deprecated="deprecated",v.abstract="abstract",v.async="async",v.modification="modification",v.documentation="documentation",v.defaultLibrary="defaultLibrary";})(se||(e.SemanticTokenModifiers=se={}));var fe;(function(v){function M(F){var R=F;return j.objectLiteral(R)&&(R.resultId===void 0||typeof R.resultId=="string")&&Array.isArray(R.data)&&(R.data.length===0||typeof R.data[0]=="number")}v.is=M;})(fe||(e.SemanticTokens=fe={}));var qe;(function(v){function M(R,y){return {range:R,text:y}}v.create=M;function F(R){var y=R;return y!=null&&a.is(y.range)&&j.string(y.text)}v.is=F;})(qe||(e.InlineValueText=qe={}));var ke;(function(v){function M(R,y,$){return {range:R,variableName:y,caseSensitiveLookup:$}}v.create=M;function F(R){var y=R;return y!=null&&a.is(y.range)&&j.boolean(y.caseSensitiveLookup)&&(j.string(y.variableName)||y.variableName===void 0)}v.is=F;})(ke||(e.InlineValueVariableLookup=ke={}));var ze;(function(v){function M(R,y){return {range:R,expression:y}}v.create=M;function F(R){var y=R;return y!=null&&a.is(y.range)&&(j.string(y.expression)||y.expression===void 0)}v.is=F;})(ze||(e.InlineValueEvaluatableExpression=ze={}));var Ze;(function(v){function M(R,y){return {frameId:R,stoppedLocation:y}}v.create=M;function F(R){var y=R;return j.defined(y)&&a.is(R.stoppedLocation)}v.is=F;})(Ze||(e.InlineValueContext=Ze={}));var Te;(function(v){v.Type=1,v.Parameter=2;function M(F){return F===1||F===2}v.is=M;})(Te||(e.InlayHintKind=Te={}));var We;(function(v){function M(R){return {value:R}}v.create=M;function F(R){var y=R;return j.objectLiteral(y)&&(y.tooltip===void 0||j.string(y.tooltip)||Pt.is(y.tooltip))&&(y.location===void 0||l.is(y.location))&&(y.command===void 0||I.is(y.command))}v.is=F;})(We||(e.InlayHintLabelPart=We={}));var Ie;(function(v){function M(R,y,$){var J={position:R,label:y};return $!==void 0&&(J.kind=$),J}v.create=M;function F(R){var y=R;return j.objectLiteral(y)&&o.is(y.position)&&(j.string(y.label)||j.typedArray(y.label,We.is))&&(y.kind===void 0||Te.is(y.kind))&&y.textEdits===void 0||j.typedArray(y.textEdits,L.is)&&(y.tooltip===void 0||j.string(y.tooltip)||Pt.is(y.tooltip))&&(y.paddingLeft===void 0||j.boolean(y.paddingLeft))&&(y.paddingRight===void 0||j.boolean(y.paddingRight))}v.is=F;})(Ie||(e.InlayHint=Ie={}));var et;(function(v){function M(F){return {kind:"snippet",value:F}}v.createSnippet=M;})(et||(e.StringValue=et={}));var ut;(function(v){function M(F,R,y,$){return {insertText:F,filterText:R,range:y,command:$}}v.create=M;})(ut||(e.InlineCompletionItem=ut={}));var Lt;(function(v){function M(F){return {items:F}}v.create=M;})(Lt||(e.InlineCompletionList=Lt={}));var bi;(function(v){v.Invoked=0,v.Automatic=1;})(bi||(e.InlineCompletionTriggerKind=bi={}));var dn;(function(v){function M(F,R){return {range:F,text:R}}v.create=M;})(dn||(e.SelectedCompletionInfo=dn={}));var hn;(function(v){function M(F,R){return {triggerKind:F,selectedCompletionInfo:R}}v.create=M;})(hn||(e.InlineCompletionContext=hn={}));var Ss;((function(v){function M(F){var R=F;return j.objectLiteral(R)&&n.is(R.uri)&&j.string(R.name)}v.is=M;}))(Ss||(e.WorkspaceFolder=Ss={})),e.EOL=[`
`,`\r
`,"\r"];var Es;(function(v){function M($,J,Ee,tt){return new No($,J,Ee,tt)}v.create=M;function F($){var J=$;return !!(j.defined(J)&&j.string(J.uri)&&(j.undefined(J.languageId)||j.string(J.languageId))&&j.uinteger(J.lineCount)&&j.func(J.getText)&&j.func(J.positionAt)&&j.func(J.offsetAt))}v.is=F;function R($,J){for(var Ee=$.getText(),tt=y(J,function(pn,vi){var qo=pn.range.start.line-vi.range.start.line;return qo===0?pn.range.start.character-vi.range.start.character:qo}),Ve=Ee.length,rr=tt.length-1;rr>=0;rr--){var nr=tt[rr],Tr=$.offsetAt(nr.range.start),Pe=$.offsetAt(nr.range.end);if(Pe<=Ve)Ee=Ee.substring(0,Tr)+nr.newText+Ee.substring(Pe,Ee.length);else throw new Error("Overlapping edit");Ve=Tr;}return Ee}v.applyEdits=R;function y($,J){if($.length<=1)return $;var Ee=$.length/2|0,tt=$.slice(0,Ee),Ve=$.slice(Ee);y(tt,J),y(Ve,J);for(var rr=0,nr=0,Tr=0;rr<tt.length&&nr<Ve.length;){var Pe=J(tt[rr],Ve[nr]);Pe<=0?$[Tr++]=tt[rr++]:$[Tr++]=Ve[nr++];}for(;rr<tt.length;)$[Tr++]=tt[rr++];for(;nr<Ve.length;)$[Tr++]=Ve[nr++];return $}})(Es||(e.TextDocument=Es={}));var No=function(){function v(M,F,R,y){this._uri=M,this._languageId=F,this._version=R,this._content=y,this._lineOffsets=void 0;}return Object.defineProperty(v.prototype,"uri",{get:function(){return this._uri},enumerable:!1,configurable:!0}),Object.defineProperty(v.prototype,"languageId",{get:function(){return this._languageId},enumerable:!1,configurable:!0}),Object.defineProperty(v.prototype,"version",{get:function(){return this._version},enumerable:!1,configurable:!0}),v.prototype.getText=function(M){if(M){var F=this.offsetAt(M.start),R=this.offsetAt(M.end);return this._content.substring(F,R)}return this._content},v.prototype.update=function(M,F){this._content=M.text,this._version=F,this._lineOffsets=void 0;},v.prototype.getLineOffsets=function(){if(this._lineOffsets===void 0){for(var M=[],F=this._content,R=!0,y=0;y<F.length;y++){R&&(M.push(y),R=!1);var $=F.charAt(y);R=$==="\r"||$===`
`,$==="\r"&&y+1<F.length&&F.charAt(y+1)===`
`&&y++;}R&&F.length>0&&M.push(F.length),this._lineOffsets=M;}return this._lineOffsets},v.prototype.positionAt=function(M){M=Math.max(Math.min(M,this._content.length),0);var F=this.getLineOffsets(),R=0,y=F.length;if(y===0)return o.create(0,M);for(;R<y;){var $=Math.floor((R+y)/2);F[$]>M?y=$:R=$+1;}var J=R-1;return o.create(J,M-F[J])},v.prototype.offsetAt=function(M){var F=this.getLineOffsets();if(M.line>=F.length)return this._content.length;if(M.line<0)return 0;var R=F[M.line],y=M.line+1<F.length?F[M.line+1]:this._content.length;return Math.max(Math.min(R+M.character,y),R)},Object.defineProperty(v.prototype,"lineCount",{get:function(){return this.getLineOffsets().length},enumerable:!1,configurable:!0}),v}(),j;(function(v){var M=Object.prototype.toString;function F(Pe){return typeof Pe<"u"}v.defined=F;function R(Pe){return typeof Pe>"u"}v.undefined=R;function y(Pe){return Pe===!0||Pe===!1}v.boolean=y;function $(Pe){return M.call(Pe)==="[object String]"}v.string=$;function J(Pe){return M.call(Pe)==="[object Number]"}v.number=J;function Ee(Pe,pn,vi){return M.call(Pe)==="[object Number]"&&pn<=Pe&&Pe<=vi}v.numberRange=Ee;function tt(Pe){return M.call(Pe)==="[object Number]"&&-2147483648<=Pe&&Pe<=2147483647}v.integer=tt;function Ve(Pe){return M.call(Pe)==="[object Number]"&&0<=Pe&&Pe<=2147483647}v.uinteger=Ve;function rr(Pe){return M.call(Pe)==="[object Function]"}v.func=rr;function nr(Pe){return Pe!==null&&typeof Pe=="object"}v.objectLiteral=nr;function Tr(Pe,pn){return Array.isArray(Pe)&&Pe.every(pn)}v.typedArray=Tr;})(j||(j={}));});});var rt=A(Yt=>{Object.defineProperty(Yt,"__esModule",{value:!0});Yt.ProtocolNotificationType=Yt.ProtocolNotificationType0=Yt.ProtocolRequestType=Yt.ProtocolRequestType0=Yt.RegistrationType=Yt.MessageDirection=void 0;var as=hi(),VT;(function(t){t.clientToServer="clientToServer",t.serverToClient="serverToClient",t.both="both";})(VT||(Yt.MessageDirection=VT={}));var Am=class{constructor(e){this.method=e;}};Yt.RegistrationType=Am;var Pm=class extends as.RequestType0{constructor(e){super(e);}};Yt.ProtocolRequestType0=Pm;var Dm=class extends as.RequestType{constructor(e){super(e,as.ParameterStructures.byName);}};Yt.ProtocolRequestType=Dm;var Om=class extends as.NotificationType0{constructor(e){super(e);}};Yt.ProtocolNotificationType0=Om;var Im=class extends as.NotificationType{constructor(e){super(e,as.ParameterStructures.byName);}};Yt.ProtocolNotificationType=Im;});var pc=A(mt=>{Object.defineProperty(mt,"__esModule",{value:!0});mt.objectLiteral=mt.typedArray=mt.stringArray=mt.array=mt.func=mt.error=mt.number=mt.string=mt.boolean=void 0;function r4(t){return t===!0||t===!1}mt.boolean=r4;function GT(t){return typeof t=="string"||t instanceof String}mt.string=GT;function n4(t){return typeof t=="number"||t instanceof Number}mt.number=n4;function i4(t){return t instanceof Error}mt.error=i4;function s4(t){return typeof t=="function"}mt.func=s4;function KT(t){return Array.isArray(t)}mt.array=KT;function o4(t){return KT(t)&&t.every(e=>GT(e))}mt.stringArray=o4;function a4(t,e){return Array.isArray(t)&&t.every(e)}mt.typedArray=a4;function u4(t){return t!==null&&typeof t=="object"}mt.objectLiteral=u4;});var YT=A(mc=>{Object.defineProperty(mc,"__esModule",{value:!0});mc.ImplementationRequest=void 0;var ZT=rt(),JT;(function(t){t.method="textDocument/implementation",t.messageDirection=ZT.MessageDirection.clientToServer,t.type=new ZT.ProtocolRequestType(t.method);})(JT||(mc.ImplementationRequest=JT={}));});var eA=A(gc=>{Object.defineProperty(gc,"__esModule",{value:!0});gc.TypeDefinitionRequest=void 0;var XT=rt(),QT;(function(t){t.method="textDocument/typeDefinition",t.messageDirection=XT.MessageDirection.clientToServer,t.type=new XT.ProtocolRequestType(t.method);})(QT||(gc.TypeDefinitionRequest=QT={}));});var nA=A(us=>{Object.defineProperty(us,"__esModule",{value:!0});us.DidChangeWorkspaceFoldersNotification=us.WorkspaceFoldersRequest=void 0;var _c=rt(),tA;(function(t){t.method="workspace/workspaceFolders",t.messageDirection=_c.MessageDirection.serverToClient,t.type=new _c.ProtocolRequestType0(t.method);})(tA||(us.WorkspaceFoldersRequest=tA={}));var rA;(function(t){t.method="workspace/didChangeWorkspaceFolders",t.messageDirection=_c.MessageDirection.clientToServer,t.type=new _c.ProtocolNotificationType(t.method);})(rA||(us.DidChangeWorkspaceFoldersNotification=rA={}));});var oA=A(yc=>{Object.defineProperty(yc,"__esModule",{value:!0});yc.ConfigurationRequest=void 0;var iA=rt(),sA;(function(t){t.method="workspace/configuration",t.messageDirection=iA.MessageDirection.serverToClient,t.type=new iA.ProtocolRequestType(t.method);})(sA||(yc.ConfigurationRequest=sA={}));});var cA=A(cs=>{Object.defineProperty(cs,"__esModule",{value:!0});cs.ColorPresentationRequest=cs.DocumentColorRequest=void 0;var bc=rt(),aA;(function(t){t.method="textDocument/documentColor",t.messageDirection=bc.MessageDirection.clientToServer,t.type=new bc.ProtocolRequestType(t.method);})(aA||(cs.DocumentColorRequest=aA={}));var uA;(function(t){t.method="textDocument/colorPresentation",t.messageDirection=bc.MessageDirection.clientToServer,t.type=new bc.ProtocolRequestType(t.method);})(uA||(cs.ColorPresentationRequest=uA={}));});var dA=A(ls=>{Object.defineProperty(ls,"__esModule",{value:!0});ls.FoldingRangeRefreshRequest=ls.FoldingRangeRequest=void 0;var vc=rt(),lA;(function(t){t.method="textDocument/foldingRange",t.messageDirection=vc.MessageDirection.clientToServer,t.type=new vc.ProtocolRequestType(t.method);})(lA||(ls.FoldingRangeRequest=lA={}));var fA;(function(t){t.method="workspace/foldingRange/refresh",t.messageDirection=vc.MessageDirection.serverToClient,t.type=new vc.ProtocolRequestType0(t.method);})(fA||(ls.FoldingRangeRefreshRequest=fA={}));});var mA=A(wc=>{Object.defineProperty(wc,"__esModule",{value:!0});wc.DeclarationRequest=void 0;var hA=rt(),pA;(function(t){t.method="textDocument/declaration",t.messageDirection=hA.MessageDirection.clientToServer,t.type=new hA.ProtocolRequestType(t.method);})(pA||(wc.DeclarationRequest=pA={}));});var yA=A(Sc=>{Object.defineProperty(Sc,"__esModule",{value:!0});Sc.SelectionRangeRequest=void 0;var gA=rt(),_A;(function(t){t.method="textDocument/selectionRange",t.messageDirection=gA.MessageDirection.clientToServer,t.type=new gA.ProtocolRequestType(t.method);})(_A||(Sc.SelectionRangeRequest=_A={}));});var SA=A(kn=>{Object.defineProperty(kn,"__esModule",{value:!0});kn.WorkDoneProgressCancelNotification=kn.WorkDoneProgressCreateRequest=kn.WorkDoneProgress=void 0;var c4=hi(),Ec=rt(),bA;(function(t){t.type=new c4.ProgressType;function e(r){return r===t.type}t.is=e;})(bA||(kn.WorkDoneProgress=bA={}));var vA;(function(t){t.method="window/workDoneProgress/create",t.messageDirection=Ec.MessageDirection.serverToClient,t.type=new Ec.ProtocolRequestType(t.method);})(vA||(kn.WorkDoneProgressCreateRequest=vA={}));var wA;(function(t){t.method="window/workDoneProgress/cancel",t.messageDirection=Ec.MessageDirection.clientToServer,t.type=new Ec.ProtocolNotificationType(t.method);})(wA||(kn.WorkDoneProgressCancelNotification=wA={}));});var xA=A(Mn=>{Object.defineProperty(Mn,"__esModule",{value:!0});Mn.CallHierarchyOutgoingCallsRequest=Mn.CallHierarchyIncomingCallsRequest=Mn.CallHierarchyPrepareRequest=void 0;var ds=rt(),EA;(function(t){t.method="textDocument/prepareCallHierarchy",t.messageDirection=ds.MessageDirection.clientToServer,t.type=new ds.ProtocolRequestType(t.method);})(EA||(Mn.CallHierarchyPrepareRequest=EA={}));var RA;(function(t){t.method="callHierarchy/incomingCalls",t.messageDirection=ds.MessageDirection.clientToServer,t.type=new ds.ProtocolRequestType(t.method);})(RA||(Mn.CallHierarchyIncomingCallsRequest=RA={}));var CA;(function(t){t.method="callHierarchy/outgoingCalls",t.messageDirection=ds.MessageDirection.clientToServer,t.type=new ds.ProtocolRequestType(t.method);})(CA||(Mn.CallHierarchyOutgoingCallsRequest=CA={}));});var IA=A(Xt=>{Object.defineProperty(Xt,"__esModule",{value:!0});Xt.SemanticTokensRefreshRequest=Xt.SemanticTokensRangeRequest=Xt.SemanticTokensDeltaRequest=Xt.SemanticTokensRequest=Xt.SemanticTokensRegistrationType=Xt.TokenFormat=void 0;var ln=rt(),TA;(function(t){t.Relative="relative";})(TA||(Xt.TokenFormat=TA={}));var To;(function(t){t.method="textDocument/semanticTokens",t.type=new ln.RegistrationType(t.method);})(To||(Xt.SemanticTokensRegistrationType=To={}));var AA;(function(t){t.method="textDocument/semanticTokens/full",t.messageDirection=ln.MessageDirection.clientToServer,t.type=new ln.ProtocolRequestType(t.method),t.registrationMethod=To.method;})(AA||(Xt.SemanticTokensRequest=AA={}));var PA;(function(t){t.method="textDocument/semanticTokens/full/delta",t.messageDirection=ln.MessageDirection.clientToServer,t.type=new ln.ProtocolRequestType(t.method),t.registrationMethod=To.method;})(PA||(Xt.SemanticTokensDeltaRequest=PA={}));var DA;(function(t){t.method="textDocument/semanticTokens/range",t.messageDirection=ln.MessageDirection.clientToServer,t.type=new ln.ProtocolRequestType(t.method),t.registrationMethod=To.method;})(DA||(Xt.SemanticTokensRangeRequest=DA={}));var OA;(function(t){t.method="workspace/semanticTokens/refresh",t.messageDirection=ln.MessageDirection.serverToClient,t.type=new ln.ProtocolRequestType0(t.method);})(OA||(Xt.SemanticTokensRefreshRequest=OA={}));});var FA=A(Rc=>{Object.defineProperty(Rc,"__esModule",{value:!0});Rc.ShowDocumentRequest=void 0;var kA=rt(),MA;(function(t){t.method="window/showDocument",t.messageDirection=kA.MessageDirection.serverToClient,t.type=new kA.ProtocolRequestType(t.method);})(MA||(Rc.ShowDocumentRequest=MA={}));});var LA=A(Cc=>{Object.defineProperty(Cc,"__esModule",{value:!0});Cc.LinkedEditingRangeRequest=void 0;var NA=rt(),qA;(function(t){t.method="textDocument/linkedEditingRange",t.messageDirection=NA.MessageDirection.clientToServer,t.type=new NA.ProtocolRequestType(t.method);})(qA||(Cc.LinkedEditingRangeRequest=qA={}));});var VA=A(Mt=>{Object.defineProperty(Mt,"__esModule",{value:!0});Mt.WillDeleteFilesRequest=Mt.DidDeleteFilesNotification=Mt.DidRenameFilesNotification=Mt.WillRenameFilesRequest=Mt.DidCreateFilesNotification=Mt.WillCreateFilesRequest=Mt.FileOperationPatternKind=void 0;var br=rt(),$A;(function(t){t.file="file",t.folder="folder";})($A||(Mt.FileOperationPatternKind=$A={}));var jA;(function(t){t.method="workspace/willCreateFiles",t.messageDirection=br.MessageDirection.clientToServer,t.type=new br.ProtocolRequestType(t.method);})(jA||(Mt.WillCreateFilesRequest=jA={}));var HA;(function(t){t.method="workspace/didCreateFiles",t.messageDirection=br.MessageDirection.clientToServer,t.type=new br.ProtocolNotificationType(t.method);})(HA||(Mt.DidCreateFilesNotification=HA={}));var WA;(function(t){t.method="workspace/willRenameFiles",t.messageDirection=br.MessageDirection.clientToServer,t.type=new br.ProtocolRequestType(t.method);})(WA||(Mt.WillRenameFilesRequest=WA={}));var BA;(function(t){t.method="workspace/didRenameFiles",t.messageDirection=br.MessageDirection.clientToServer,t.type=new br.ProtocolNotificationType(t.method);})(BA||(Mt.DidRenameFilesNotification=BA={}));var UA;(function(t){t.method="workspace/didDeleteFiles",t.messageDirection=br.MessageDirection.clientToServer,t.type=new br.ProtocolNotificationType(t.method);})(UA||(Mt.DidDeleteFilesNotification=UA={}));var zA;(function(t){t.method="workspace/willDeleteFiles",t.messageDirection=br.MessageDirection.clientToServer,t.type=new br.ProtocolRequestType(t.method);})(zA||(Mt.WillDeleteFilesRequest=zA={}));});var YA=A(Fn=>{Object.defineProperty(Fn,"__esModule",{value:!0});Fn.MonikerRequest=Fn.MonikerKind=Fn.UniquenessLevel=void 0;var GA=rt(),KA;(function(t){t.document="document",t.project="project",t.group="group",t.scheme="scheme",t.global="global";})(KA||(Fn.UniquenessLevel=KA={}));var ZA;(function(t){t.$import="import",t.$export="export",t.local="local";})(ZA||(Fn.MonikerKind=ZA={}));var JA;(function(t){t.method="textDocument/moniker",t.messageDirection=GA.MessageDirection.clientToServer,t.type=new GA.ProtocolRequestType(t.method);})(JA||(Fn.MonikerRequest=JA={}));});var tP=A(Nn=>{Object.defineProperty(Nn,"__esModule",{value:!0});Nn.TypeHierarchySubtypesRequest=Nn.TypeHierarchySupertypesRequest=Nn.TypeHierarchyPrepareRequest=void 0;var hs=rt(),XA;(function(t){t.method="textDocument/prepareTypeHierarchy",t.messageDirection=hs.MessageDirection.clientToServer,t.type=new hs.ProtocolRequestType(t.method);})(XA||(Nn.TypeHierarchyPrepareRequest=XA={}));var QA;(function(t){t.method="typeHierarchy/supertypes",t.messageDirection=hs.MessageDirection.clientToServer,t.type=new hs.ProtocolRequestType(t.method);})(QA||(Nn.TypeHierarchySupertypesRequest=QA={}));var eP;(function(t){t.method="typeHierarchy/subtypes",t.messageDirection=hs.MessageDirection.clientToServer,t.type=new hs.ProtocolRequestType(t.method);})(eP||(Nn.TypeHierarchySubtypesRequest=eP={}));});var iP=A(ps=>{Object.defineProperty(ps,"__esModule",{value:!0});ps.InlineValueRefreshRequest=ps.InlineValueRequest=void 0;var xc=rt(),rP;(function(t){t.method="textDocument/inlineValue",t.messageDirection=xc.MessageDirection.clientToServer,t.type=new xc.ProtocolRequestType(t.method);})(rP||(ps.InlineValueRequest=rP={}));var nP;(function(t){t.method="workspace/inlineValue/refresh",t.messageDirection=xc.MessageDirection.serverToClient,t.type=new xc.ProtocolRequestType0(t.method);})(nP||(ps.InlineValueRefreshRequest=nP={}));});var uP=A(qn=>{Object.defineProperty(qn,"__esModule",{value:!0});qn.InlayHintRefreshRequest=qn.InlayHintResolveRequest=qn.InlayHintRequest=void 0;var ms=rt(),sP;(function(t){t.method="textDocument/inlayHint",t.messageDirection=ms.MessageDirection.clientToServer,t.type=new ms.ProtocolRequestType(t.method);})(sP||(qn.InlayHintRequest=sP={}));var oP;(function(t){t.method="inlayHint/resolve",t.messageDirection=ms.MessageDirection.clientToServer,t.type=new ms.ProtocolRequestType(t.method);})(oP||(qn.InlayHintResolveRequest=oP={}));var aP;(function(t){t.method="workspace/inlayHint/refresh",t.messageDirection=ms.MessageDirection.serverToClient,t.type=new ms.ProtocolRequestType0(t.method);})(aP||(qn.InlayHintRefreshRequest=aP={}));});var mP=A(vr=>{Object.defineProperty(vr,"__esModule",{value:!0});vr.DiagnosticRefreshRequest=vr.WorkspaceDiagnosticRequest=vr.DocumentDiagnosticRequest=vr.DocumentDiagnosticReportKind=vr.DiagnosticServerCancellationData=void 0;var pP=hi(),l4=pc(),gs=rt(),cP;(function(t){function e(r){let n=r;return n&&l4.boolean(n.retriggerRequest)}t.is=e;})(cP||(vr.DiagnosticServerCancellationData=cP={}));var lP;(function(t){t.Full="full",t.Unchanged="unchanged";})(lP||(vr.DocumentDiagnosticReportKind=lP={}));var fP;(function(t){t.method="textDocument/diagnostic",t.messageDirection=gs.MessageDirection.clientToServer,t.type=new gs.ProtocolRequestType(t.method),t.partialResult=new pP.ProgressType;})(fP||(vr.DocumentDiagnosticRequest=fP={}));var dP;(function(t){t.method="workspace/diagnostic",t.messageDirection=gs.MessageDirection.clientToServer,t.type=new gs.ProtocolRequestType(t.method),t.partialResult=new pP.ProgressType;})(dP||(vr.WorkspaceDiagnosticRequest=dP={}));var hP;(function(t){t.method="workspace/diagnostic/refresh",t.messageDirection=gs.MessageDirection.serverToClient,t.type=new gs.ProtocolRequestType0(t.method);})(hP||(vr.DiagnosticRefreshRequest=hP={}));});var SP=A(at=>{Object.defineProperty(at,"__esModule",{value:!0});at.DidCloseNotebookDocumentNotification=at.DidSaveNotebookDocumentNotification=at.DidChangeNotebookDocumentNotification=at.NotebookCellArrayChange=at.DidOpenNotebookDocumentNotification=at.NotebookDocumentSyncRegistrationType=at.NotebookDocument=at.NotebookCell=at.ExecutionSummary=at.NotebookCellKind=void 0;var Ao=hc(),Nr=pc(),Gr=rt(),km;(function(t){t.Markup=1,t.Code=2;function e(r){return r===1||r===2}t.is=e;})(km||(at.NotebookCellKind=km={}));var Mm;(function(t){function e(i,s){let o={executionOrder:i};return (s===!0||s===!1)&&(o.success=s),o}t.create=e;function r(i){let s=i;return Nr.objectLiteral(s)&&Ao.uinteger.is(s.executionOrder)&&(s.success===void 0||Nr.boolean(s.success))}t.is=r;function n(i,s){return i===s?!0:i==null||s===null||s===void 0?!1:i.executionOrder===s.executionOrder&&i.success===s.success}t.equals=n;})(Mm||(at.ExecutionSummary=Mm={}));var Tc;(function(t){function e(s,o){return {kind:s,document:o}}t.create=e;function r(s){let o=s;return Nr.objectLiteral(o)&&km.is(o.kind)&&Ao.DocumentUri.is(o.document)&&(o.metadata===void 0||Nr.objectLiteral(o.metadata))}t.is=r;function n(s,o){let a=new Set;return s.document!==o.document&&a.add("document"),s.kind!==o.kind&&a.add("kind"),s.executionSummary!==o.executionSummary&&a.add("executionSummary"),(s.metadata!==void 0||o.metadata!==void 0)&&!i(s.metadata,o.metadata)&&a.add("metadata"),(s.executionSummary!==void 0||o.executionSummary!==void 0)&&!Mm.equals(s.executionSummary,o.executionSummary)&&a.add("executionSummary"),a}t.diff=n;function i(s,o){if(s===o)return !0;if(s==null||o===null||o===void 0||typeof s!=typeof o||typeof s!="object")return !1;let a=Array.isArray(s),l=Array.isArray(o);if(a!==l)return !1;if(a&&l){if(s.length!==o.length)return !1;for(let d=0;d<s.length;d++)if(!i(s[d],o[d]))return !1}if(Nr.objectLiteral(s)&&Nr.objectLiteral(o)){let d=Object.keys(s),c=Object.keys(o);if(d.length!==c.length||(d.sort(),c.sort(),!i(d,c)))return !1;for(let p=0;p<d.length;p++){let m=d[p];if(!i(s[m],o[m]))return !1}}return !0}})(Tc||(at.NotebookCell=Tc={}));var gP;(function(t){function e(n,i,s,o){return {uri:n,notebookType:i,version:s,cells:o}}t.create=e;function r(n){let i=n;return Nr.objectLiteral(i)&&Nr.string(i.uri)&&Ao.integer.is(i.version)&&Nr.typedArray(i.cells,Tc.is)}t.is=r;})(gP||(at.NotebookDocument=gP={}));var _s;(function(t){t.method="notebookDocument/sync",t.messageDirection=Gr.MessageDirection.clientToServer,t.type=new Gr.RegistrationType(t.method);})(_s||(at.NotebookDocumentSyncRegistrationType=_s={}));var _P;(function(t){t.method="notebookDocument/didOpen",t.messageDirection=Gr.MessageDirection.clientToServer,t.type=new Gr.ProtocolNotificationType(t.method),t.registrationMethod=_s.method;})(_P||(at.DidOpenNotebookDocumentNotification=_P={}));var yP;(function(t){function e(n){let i=n;return Nr.objectLiteral(i)&&Ao.uinteger.is(i.start)&&Ao.uinteger.is(i.deleteCount)&&(i.cells===void 0||Nr.typedArray(i.cells,Tc.is))}t.is=e;function r(n,i,s){let o={start:n,deleteCount:i};return s!==void 0&&(o.cells=s),o}t.create=r;})(yP||(at.NotebookCellArrayChange=yP={}));var bP;(function(t){t.method="notebookDocument/didChange",t.messageDirection=Gr.MessageDirection.clientToServer,t.type=new Gr.ProtocolNotificationType(t.method),t.registrationMethod=_s.method;})(bP||(at.DidChangeNotebookDocumentNotification=bP={}));var vP;(function(t){t.method="notebookDocument/didSave",t.messageDirection=Gr.MessageDirection.clientToServer,t.type=new Gr.ProtocolNotificationType(t.method),t.registrationMethod=_s.method;})(vP||(at.DidSaveNotebookDocumentNotification=vP={}));var wP;(function(t){t.method="notebookDocument/didClose",t.messageDirection=Gr.MessageDirection.clientToServer,t.type=new Gr.ProtocolNotificationType(t.method),t.registrationMethod=_s.method;})(wP||(at.DidCloseNotebookDocumentNotification=wP={}));});var CP=A(Ac=>{Object.defineProperty(Ac,"__esModule",{value:!0});Ac.InlineCompletionRequest=void 0;var EP=rt(),RP;(function(t){t.method="textDocument/inlineCompletion",t.messageDirection=EP.MessageDirection.clientToServer,t.type=new EP.ProtocolRequestType(t.method);})(RP||(Ac.InlineCompletionRequest=RP={}));});var LD=A(T=>{Object.defineProperty(T,"__esModule",{value:!0});T.WorkspaceSymbolRequest=T.CodeActionResolveRequest=T.CodeActionRequest=T.DocumentSymbolRequest=T.DocumentHighlightRequest=T.ReferencesRequest=T.DefinitionRequest=T.SignatureHelpRequest=T.SignatureHelpTriggerKind=T.HoverRequest=T.CompletionResolveRequest=T.CompletionRequest=T.CompletionTriggerKind=T.PublishDiagnosticsNotification=T.WatchKind=T.RelativePattern=T.FileChangeType=T.DidChangeWatchedFilesNotification=T.WillSaveTextDocumentWaitUntilRequest=T.WillSaveTextDocumentNotification=T.TextDocumentSaveReason=T.DidSaveTextDocumentNotification=T.DidCloseTextDocumentNotification=T.DidChangeTextDocumentNotification=T.TextDocumentContentChangeEvent=T.DidOpenTextDocumentNotification=T.TextDocumentSyncKind=T.TelemetryEventNotification=T.LogMessageNotification=T.ShowMessageRequest=T.ShowMessageNotification=T.MessageType=T.DidChangeConfigurationNotification=T.ExitNotification=T.ShutdownRequest=T.InitializedNotification=T.InitializeErrorCodes=T.InitializeRequest=T.WorkDoneProgressOptions=T.TextDocumentRegistrationOptions=T.StaticRegistrationOptions=T.PositionEncodingKind=T.FailureHandlingKind=T.ResourceOperationKind=T.UnregistrationRequest=T.RegistrationRequest=T.DocumentSelector=T.NotebookCellTextDocumentFilter=T.NotebookDocumentFilter=T.TextDocumentFilter=void 0;T.MonikerRequest=T.MonikerKind=T.UniquenessLevel=T.WillDeleteFilesRequest=T.DidDeleteFilesNotification=T.WillRenameFilesRequest=T.DidRenameFilesNotification=T.WillCreateFilesRequest=T.DidCreateFilesNotification=T.FileOperationPatternKind=T.LinkedEditingRangeRequest=T.ShowDocumentRequest=T.SemanticTokensRegistrationType=T.SemanticTokensRefreshRequest=T.SemanticTokensRangeRequest=T.SemanticTokensDeltaRequest=T.SemanticTokensRequest=T.TokenFormat=T.CallHierarchyPrepareRequest=T.CallHierarchyOutgoingCallsRequest=T.CallHierarchyIncomingCallsRequest=T.WorkDoneProgressCancelNotification=T.WorkDoneProgressCreateRequest=T.WorkDoneProgress=T.SelectionRangeRequest=T.DeclarationRequest=T.FoldingRangeRefreshRequest=T.FoldingRangeRequest=T.ColorPresentationRequest=T.DocumentColorRequest=T.ConfigurationRequest=T.DidChangeWorkspaceFoldersNotification=T.WorkspaceFoldersRequest=T.TypeDefinitionRequest=T.ImplementationRequest=T.ApplyWorkspaceEditRequest=T.ExecuteCommandRequest=T.PrepareRenameRequest=T.RenameRequest=T.PrepareSupportDefaultBehavior=T.DocumentOnTypeFormattingRequest=T.DocumentRangesFormattingRequest=T.DocumentRangeFormattingRequest=T.DocumentFormattingRequest=T.DocumentLinkResolveRequest=T.DocumentLinkRequest=T.CodeLensRefreshRequest=T.CodeLensResolveRequest=T.CodeLensRequest=T.WorkspaceSymbolResolveRequest=void 0;T.InlineCompletionRequest=T.DidCloseNotebookDocumentNotification=T.DidSaveNotebookDocumentNotification=T.DidChangeNotebookDocumentNotification=T.NotebookCellArrayChange=T.DidOpenNotebookDocumentNotification=T.NotebookDocumentSyncRegistrationType=T.NotebookDocument=T.NotebookCell=T.ExecutionSummary=T.NotebookCellKind=T.DiagnosticRefreshRequest=T.WorkspaceDiagnosticRequest=T.DocumentDiagnosticRequest=T.DocumentDiagnosticReportKind=T.DiagnosticServerCancellationData=T.InlayHintRefreshRequest=T.InlayHintResolveRequest=T.InlayHintRequest=T.InlineValueRefreshRequest=T.InlineValueRequest=T.TypeHierarchySupertypesRequest=T.TypeHierarchySubtypesRequest=T.TypeHierarchyPrepareRequest=void 0;var ne=rt(),xP=hc(),wt=pc(),f4=YT();Object.defineProperty(T,"ImplementationRequest",{enumerable:!0,get:function(){return f4.ImplementationRequest}});var d4=eA();Object.defineProperty(T,"TypeDefinitionRequest",{enumerable:!0,get:function(){return d4.TypeDefinitionRequest}});var MD=nA();Object.defineProperty(T,"WorkspaceFoldersRequest",{enumerable:!0,get:function(){return MD.WorkspaceFoldersRequest}});Object.defineProperty(T,"DidChangeWorkspaceFoldersNotification",{enumerable:!0,get:function(){return MD.DidChangeWorkspaceFoldersNotification}});var h4=oA();Object.defineProperty(T,"ConfigurationRequest",{enumerable:!0,get:function(){return h4.ConfigurationRequest}});var FD=cA();Object.defineProperty(T,"DocumentColorRequest",{enumerable:!0,get:function(){return FD.DocumentColorRequest}});Object.defineProperty(T,"ColorPresentationRequest",{enumerable:!0,get:function(){return FD.ColorPresentationRequest}});var ND=dA();Object.defineProperty(T,"FoldingRangeRequest",{enumerable:!0,get:function(){return ND.FoldingRangeRequest}});Object.defineProperty(T,"FoldingRangeRefreshRequest",{enumerable:!0,get:function(){return ND.FoldingRangeRefreshRequest}});var p4=mA();Object.defineProperty(T,"DeclarationRequest",{enumerable:!0,get:function(){return p4.DeclarationRequest}});var m4=yA();Object.defineProperty(T,"SelectionRangeRequest",{enumerable:!0,get:function(){return m4.SelectionRangeRequest}});var $m=SA();Object.defineProperty(T,"WorkDoneProgress",{enumerable:!0,get:function(){return $m.WorkDoneProgress}});Object.defineProperty(T,"WorkDoneProgressCreateRequest",{enumerable:!0,get:function(){return $m.WorkDoneProgressCreateRequest}});Object.defineProperty(T,"WorkDoneProgressCancelNotification",{enumerable:!0,get:function(){return $m.WorkDoneProgressCancelNotification}});var jm=xA();Object.defineProperty(T,"CallHierarchyIncomingCallsRequest",{enumerable:!0,get:function(){return jm.CallHierarchyIncomingCallsRequest}});Object.defineProperty(T,"CallHierarchyOutgoingCallsRequest",{enumerable:!0,get:function(){return jm.CallHierarchyOutgoingCallsRequest}});Object.defineProperty(T,"CallHierarchyPrepareRequest",{enumerable:!0,get:function(){return jm.CallHierarchyPrepareRequest}});var ys=IA();Object.defineProperty(T,"TokenFormat",{enumerable:!0,get:function(){return ys.TokenFormat}});Object.defineProperty(T,"SemanticTokensRequest",{enumerable:!0,get:function(){return ys.SemanticTokensRequest}});Object.defineProperty(T,"SemanticTokensDeltaRequest",{enumerable:!0,get:function(){return ys.SemanticTokensDeltaRequest}});Object.defineProperty(T,"SemanticTokensRangeRequest",{enumerable:!0,get:function(){return ys.SemanticTokensRangeRequest}});Object.defineProperty(T,"SemanticTokensRefreshRequest",{enumerable:!0,get:function(){return ys.SemanticTokensRefreshRequest}});Object.defineProperty(T,"SemanticTokensRegistrationType",{enumerable:!0,get:function(){return ys.SemanticTokensRegistrationType}});var g4=FA();Object.defineProperty(T,"ShowDocumentRequest",{enumerable:!0,get:function(){return g4.ShowDocumentRequest}});var _4=LA();Object.defineProperty(T,"LinkedEditingRangeRequest",{enumerable:!0,get:function(){return _4.LinkedEditingRangeRequest}});var pi=VA();Object.defineProperty(T,"FileOperationPatternKind",{enumerable:!0,get:function(){return pi.FileOperationPatternKind}});Object.defineProperty(T,"DidCreateFilesNotification",{enumerable:!0,get:function(){return pi.DidCreateFilesNotification}});Object.defineProperty(T,"WillCreateFilesRequest",{enumerable:!0,get:function(){return pi.WillCreateFilesRequest}});Object.defineProperty(T,"DidRenameFilesNotification",{enumerable:!0,get:function(){return pi.DidRenameFilesNotification}});Object.defineProperty(T,"WillRenameFilesRequest",{enumerable:!0,get:function(){return pi.WillRenameFilesRequest}});Object.defineProperty(T,"DidDeleteFilesNotification",{enumerable:!0,get:function(){return pi.DidDeleteFilesNotification}});Object.defineProperty(T,"WillDeleteFilesRequest",{enumerable:!0,get:function(){return pi.WillDeleteFilesRequest}});var Hm=YA();Object.defineProperty(T,"UniquenessLevel",{enumerable:!0,get:function(){return Hm.UniquenessLevel}});Object.defineProperty(T,"MonikerKind",{enumerable:!0,get:function(){return Hm.MonikerKind}});Object.defineProperty(T,"MonikerRequest",{enumerable:!0,get:function(){return Hm.MonikerRequest}});var Wm=tP();Object.defineProperty(T,"TypeHierarchyPrepareRequest",{enumerable:!0,get:function(){return Wm.TypeHierarchyPrepareRequest}});Object.defineProperty(T,"TypeHierarchySubtypesRequest",{enumerable:!0,get:function(){return Wm.TypeHierarchySubtypesRequest}});Object.defineProperty(T,"TypeHierarchySupertypesRequest",{enumerable:!0,get:function(){return Wm.TypeHierarchySupertypesRequest}});var qD=iP();Object.defineProperty(T,"InlineValueRequest",{enumerable:!0,get:function(){return qD.InlineValueRequest}});Object.defineProperty(T,"InlineValueRefreshRequest",{enumerable:!0,get:function(){return qD.InlineValueRefreshRequest}});var Bm=uP();Object.defineProperty(T,"InlayHintRequest",{enumerable:!0,get:function(){return Bm.InlayHintRequest}});Object.defineProperty(T,"InlayHintResolveRequest",{enumerable:!0,get:function(){return Bm.InlayHintResolveRequest}});Object.defineProperty(T,"InlayHintRefreshRequest",{enumerable:!0,get:function(){return Bm.InlayHintRefreshRequest}});var Po=mP();Object.defineProperty(T,"DiagnosticServerCancellationData",{enumerable:!0,get:function(){return Po.DiagnosticServerCancellationData}});Object.defineProperty(T,"DocumentDiagnosticReportKind",{enumerable:!0,get:function(){return Po.DocumentDiagnosticReportKind}});Object.defineProperty(T,"DocumentDiagnosticRequest",{enumerable:!0,get:function(){return Po.DocumentDiagnosticRequest}});Object.defineProperty(T,"WorkspaceDiagnosticRequest",{enumerable:!0,get:function(){return Po.WorkspaceDiagnosticRequest}});Object.defineProperty(T,"DiagnosticRefreshRequest",{enumerable:!0,get:function(){return Po.DiagnosticRefreshRequest}});var Kr=SP();Object.defineProperty(T,"NotebookCellKind",{enumerable:!0,get:function(){return Kr.NotebookCellKind}});Object.defineProperty(T,"ExecutionSummary",{enumerable:!0,get:function(){return Kr.ExecutionSummary}});Object.defineProperty(T,"NotebookCell",{enumerable:!0,get:function(){return Kr.NotebookCell}});Object.defineProperty(T,"NotebookDocument",{enumerable:!0,get:function(){return Kr.NotebookDocument}});Object.defineProperty(T,"NotebookDocumentSyncRegistrationType",{enumerable:!0,get:function(){return Kr.NotebookDocumentSyncRegistrationType}});Object.defineProperty(T,"DidOpenNotebookDocumentNotification",{enumerable:!0,get:function(){return Kr.DidOpenNotebookDocumentNotification}});Object.defineProperty(T,"NotebookCellArrayChange",{enumerable:!0,get:function(){return Kr.NotebookCellArrayChange}});Object.defineProperty(T,"DidChangeNotebookDocumentNotification",{enumerable:!0,get:function(){return Kr.DidChangeNotebookDocumentNotification}});Object.defineProperty(T,"DidSaveNotebookDocumentNotification",{enumerable:!0,get:function(){return Kr.DidSaveNotebookDocumentNotification}});Object.defineProperty(T,"DidCloseNotebookDocumentNotification",{enumerable:!0,get:function(){return Kr.DidCloseNotebookDocumentNotification}});var y4=CP();Object.defineProperty(T,"InlineCompletionRequest",{enumerable:!0,get:function(){return y4.InlineCompletionRequest}});var Fm;(function(t){function e(r){let n=r;return wt.string(n)||wt.string(n.language)||wt.string(n.scheme)||wt.string(n.pattern)}t.is=e;})(Fm||(T.TextDocumentFilter=Fm={}));var Nm;(function(t){function e(r){let n=r;return wt.objectLiteral(n)&&(wt.string(n.notebookType)||wt.string(n.scheme)||wt.string(n.pattern))}t.is=e;})(Nm||(T.NotebookDocumentFilter=Nm={}));var qm;(function(t){function e(r){let n=r;return wt.objectLiteral(n)&&(wt.string(n.notebook)||Nm.is(n.notebook))&&(n.language===void 0||wt.string(n.language))}t.is=e;})(qm||(T.NotebookCellTextDocumentFilter=qm={}));var Lm;(function(t){function e(r){if(!Array.isArray(r))return !1;for(let n of r)if(!wt.string(n)&&!Fm.is(n)&&!qm.is(n))return !1;return !0}t.is=e;})(Lm||(T.DocumentSelector=Lm={}));var TP;(function(t){t.method="client/registerCapability",t.messageDirection=ne.MessageDirection.serverToClient,t.type=new ne.ProtocolRequestType(t.method);})(TP||(T.RegistrationRequest=TP={}));var AP;(function(t){t.method="client/unregisterCapability",t.messageDirection=ne.MessageDirection.serverToClient,t.type=new ne.ProtocolRequestType(t.method);})(AP||(T.UnregistrationRequest=AP={}));var PP;(function(t){t.Create="create",t.Rename="rename",t.Delete="delete";})(PP||(T.ResourceOperationKind=PP={}));var DP;(function(t){t.Abort="abort",t.Transactional="transactional",t.TextOnlyTransactional="textOnlyTransactional",t.Undo="undo";})(DP||(T.FailureHandlingKind=DP={}));var OP;(function(t){t.UTF8="utf-8",t.UTF16="utf-16",t.UTF32="utf-32";})(OP||(T.PositionEncodingKind=OP={}));var IP;(function(t){function e(r){let n=r;return n&&wt.string(n.id)&&n.id.length>0}t.hasId=e;})(IP||(T.StaticRegistrationOptions=IP={}));var kP;(function(t){function e(r){let n=r;return n&&(n.documentSelector===null||Lm.is(n.documentSelector))}t.is=e;})(kP||(T.TextDocumentRegistrationOptions=kP={}));var MP;(function(t){function e(n){let i=n;return wt.objectLiteral(i)&&(i.workDoneProgress===void 0||wt.boolean(i.workDoneProgress))}t.is=e;function r(n){let i=n;return i&&wt.boolean(i.workDoneProgress)}t.hasWorkDoneProgress=r;})(MP||(T.WorkDoneProgressOptions=MP={}));var FP;(function(t){t.method="initialize",t.messageDirection=ne.MessageDirection.clientToServer,t.type=new ne.ProtocolRequestType(t.method);})(FP||(T.InitializeRequest=FP={}));var NP;(function(t){t.unknownProtocolVersion=1;})(NP||(T.InitializeErrorCodes=NP={}));var qP;(function(t){t.method="initialized",t.messageDirection=ne.MessageDirection.clientToServer,t.type=new ne.ProtocolNotificationType(t.method);})(qP||(T.InitializedNotification=qP={}));var LP;(function(t){t.method="shutdown",t.messageDirection=ne.MessageDirection.clientToServer,t.type=new ne.ProtocolRequestType0(t.method);})(LP||(T.ShutdownRequest=LP={}));var $P;(function(t){t.method="exit",t.messageDirection=ne.MessageDirection.clientToServer,t.type=new ne.ProtocolNotificationType0(t.method);})($P||(T.ExitNotification=$P={}));var jP;(function(t){t.method="workspace/didChangeConfiguration",t.messageDirection=ne.MessageDirection.clientToServer,t.type=new ne.ProtocolNotificationType(t.method);})(jP||(T.DidChangeConfigurationNotification=jP={}));var HP;(function(t){t.Error=1,t.Warning=2,t.Info=3,t.Log=4,t.Debug=5;})(HP||(T.MessageType=HP={}));var WP;(function(t){t.method="window/showMessage",t.messageDirection=ne.MessageDirection.serverToClient,t.type=new ne.ProtocolNotificationType(t.method);})(WP||(T.ShowMessageNotification=WP={}));var BP;(function(t){t.method="window/showMessageRequest",t.messageDirection=ne.MessageDirection.serverToClient,t.type=new ne.ProtocolRequestType(t.method);})(BP||(T.ShowMessageRequest=BP={}));var UP;(function(t){t.method="window/logMessage",t.messageDirection=ne.MessageDirection.serverToClient,t.type=new ne.ProtocolNotificationType(t.method);})(UP||(T.LogMessageNotification=UP={}));var zP;(function(t){t.method="telemetry/event",t.messageDirection=ne.MessageDirection.serverToClient,t.type=new ne.ProtocolNotificationType(t.method);})(zP||(T.TelemetryEventNotification=zP={}));var VP;(function(t){t.None=0,t.Full=1,t.Incremental=2;})(VP||(T.TextDocumentSyncKind=VP={}));var GP;(function(t){t.method="textDocument/didOpen",t.messageDirection=ne.MessageDirection.clientToServer,t.type=new ne.ProtocolNotificationType(t.method);})(GP||(T.DidOpenTextDocumentNotification=GP={}));var KP;(function(t){function e(n){let i=n;return i!=null&&typeof i.text=="string"&&i.range!==void 0&&(i.rangeLength===void 0||typeof i.rangeLength=="number")}t.isIncremental=e;function r(n){let i=n;return i!=null&&typeof i.text=="string"&&i.range===void 0&&i.rangeLength===void 0}t.isFull=r;})(KP||(T.TextDocumentContentChangeEvent=KP={}));var ZP;(function(t){t.method="textDocument/didChange",t.messageDirection=ne.MessageDirection.clientToServer,t.type=new ne.ProtocolNotificationType(t.method);})(ZP||(T.DidChangeTextDocumentNotification=ZP={}));var JP;(function(t){t.method="textDocument/didClose",t.messageDirection=ne.MessageDirection.clientToServer,t.type=new ne.ProtocolNotificationType(t.method);})(JP||(T.DidCloseTextDocumentNotification=JP={}));var YP;(function(t){t.method="textDocument/didSave",t.messageDirection=ne.MessageDirection.clientToServer,t.type=new ne.ProtocolNotificationType(t.method);})(YP||(T.DidSaveTextDocumentNotification=YP={}));var XP;(function(t){t.Manual=1,t.AfterDelay=2,t.FocusOut=3;})(XP||(T.TextDocumentSaveReason=XP={}));var QP;(function(t){t.method="textDocument/willSave",t.messageDirection=ne.MessageDirection.clientToServer,t.type=new ne.ProtocolNotificationType(t.method);})(QP||(T.WillSaveTextDocumentNotification=QP={}));var eD;(function(t){t.method="textDocument/willSaveWaitUntil",t.messageDirection=ne.MessageDirection.clientToServer,t.type=new ne.ProtocolRequestType(t.method);})(eD||(T.WillSaveTextDocumentWaitUntilRequest=eD={}));var tD;(function(t){t.method="workspace/didChangeWatchedFiles",t.messageDirection=ne.MessageDirection.clientToServer,t.type=new ne.ProtocolNotificationType(t.method);})(tD||(T.DidChangeWatchedFilesNotification=tD={}));var rD;(function(t){t.Created=1,t.Changed=2,t.Deleted=3;})(rD||(T.FileChangeType=rD={}));var nD;(function(t){function e(r){let n=r;return wt.objectLiteral(n)&&(xP.URI.is(n.baseUri)||xP.WorkspaceFolder.is(n.baseUri))&&wt.string(n.pattern)}t.is=e;})(nD||(T.RelativePattern=nD={}));var iD;(function(t){t.Create=1,t.Change=2,t.Delete=4;})(iD||(T.WatchKind=iD={}));var sD;(function(t){t.method="textDocument/publishDiagnostics",t.messageDirection=ne.MessageDirection.serverToClient,t.type=new ne.ProtocolNotificationType(t.method);})(sD||(T.PublishDiagnosticsNotification=sD={}));var oD;(function(t){t.Invoked=1,t.TriggerCharacter=2,t.TriggerForIncompleteCompletions=3;})(oD||(T.CompletionTriggerKind=oD={}));var aD;(function(t){t.method="textDocument/completion",t.messageDirection=ne.MessageDirection.clientToServer,t.type=new ne.ProtocolRequestType(t.method);})(aD||(T.CompletionRequest=aD={}));var uD;(function(t){t.method="completionItem/resolve",t.messageDirection=ne.MessageDirection.clientToServer,t.type=new ne.ProtocolRequestType(t.method);})(uD||(T.CompletionResolveRequest=uD={}));var cD;(function(t){t.method="textDocument/hover",t.messageDirection=ne.MessageDirection.clientToServer,t.type=new ne.ProtocolRequestType(t.method);})(cD||(T.HoverRequest=cD={}));var lD;(function(t){t.Invoked=1,t.TriggerCharacter=2,t.ContentChange=3;})(lD||(T.SignatureHelpTriggerKind=lD={}));var fD;(function(t){t.method="textDocument/signatureHelp",t.messageDirection=ne.MessageDirection.clientToServer,t.type=new ne.ProtocolRequestType(t.method);})(fD||(T.SignatureHelpRequest=fD={}));var dD;(function(t){t.method="textDocument/definition",t.messageDirection=ne.MessageDirection.clientToServer,t.type=new ne.ProtocolRequestType(t.method);})(dD||(T.DefinitionRequest=dD={}));var hD;(function(t){t.method="textDocument/references",t.messageDirection=ne.MessageDirection.clientToServer,t.type=new ne.ProtocolRequestType(t.method);})(hD||(T.ReferencesRequest=hD={}));var pD;(function(t){t.method="textDocument/documentHighlight",t.messageDirection=ne.MessageDirection.clientToServer,t.type=new ne.ProtocolRequestType(t.method);})(pD||(T.DocumentHighlightRequest=pD={}));var mD;(function(t){t.method="textDocument/documentSymbol",t.messageDirection=ne.MessageDirection.clientToServer,t.type=new ne.ProtocolRequestType(t.method);})(mD||(T.DocumentSymbolRequest=mD={}));var gD;(function(t){t.method="textDocument/codeAction",t.messageDirection=ne.MessageDirection.clientToServer,t.type=new ne.ProtocolRequestType(t.method);})(gD||(T.CodeActionRequest=gD={}));var _D;(function(t){t.method="codeAction/resolve",t.messageDirection=ne.MessageDirection.clientToServer,t.type=new ne.ProtocolRequestType(t.method);})(_D||(T.CodeActionResolveRequest=_D={}));var yD;(function(t){t.method="workspace/symbol",t.messageDirection=ne.MessageDirection.clientToServer,t.type=new ne.ProtocolRequestType(t.method);})(yD||(T.WorkspaceSymbolRequest=yD={}));var bD;(function(t){t.method="workspaceSymbol/resolve",t.messageDirection=ne.MessageDirection.clientToServer,t.type=new ne.ProtocolRequestType(t.method);})(bD||(T.WorkspaceSymbolResolveRequest=bD={}));var vD;(function(t){t.method="textDocument/codeLens",t.messageDirection=ne.MessageDirection.clientToServer,t.type=new ne.ProtocolRequestType(t.method);})(vD||(T.CodeLensRequest=vD={}));var wD;(function(t){t.method="codeLens/resolve",t.messageDirection=ne.MessageDirection.clientToServer,t.type=new ne.ProtocolRequestType(t.method);})(wD||(T.CodeLensResolveRequest=wD={}));var SD;(function(t){t.method="workspace/codeLens/refresh",t.messageDirection=ne.MessageDirection.serverToClient,t.type=new ne.ProtocolRequestType0(t.method);})(SD||(T.CodeLensRefreshRequest=SD={}));var ED;(function(t){t.method="textDocument/documentLink",t.messageDirection=ne.MessageDirection.clientToServer,t.type=new ne.ProtocolRequestType(t.method);})(ED||(T.DocumentLinkRequest=ED={}));var RD;(function(t){t.method="documentLink/resolve",t.messageDirection=ne.MessageDirection.clientToServer,t.type=new ne.ProtocolRequestType(t.method);})(RD||(T.DocumentLinkResolveRequest=RD={}));var CD;(function(t){t.method="textDocument/formatting",t.messageDirection=ne.MessageDirection.clientToServer,t.type=new ne.ProtocolRequestType(t.method);})(CD||(T.DocumentFormattingRequest=CD={}));var xD;(function(t){t.method="textDocument/rangeFormatting",t.messageDirection=ne.MessageDirection.clientToServer,t.type=new ne.ProtocolRequestType(t.method);})(xD||(T.DocumentRangeFormattingRequest=xD={}));var TD;(function(t){t.method="textDocument/rangesFormatting",t.messageDirection=ne.MessageDirection.clientToServer,t.type=new ne.ProtocolRequestType(t.method);})(TD||(T.DocumentRangesFormattingRequest=TD={}));var AD;(function(t){t.method="textDocument/onTypeFormatting",t.messageDirection=ne.MessageDirection.clientToServer,t.type=new ne.ProtocolRequestType(t.method);})(AD||(T.DocumentOnTypeFormattingRequest=AD={}));var PD;(function(t){t.Identifier=1;})(PD||(T.PrepareSupportDefaultBehavior=PD={}));var DD;(function(t){t.method="textDocument/rename",t.messageDirection=ne.MessageDirection.clientToServer,t.type=new ne.ProtocolRequestType(t.method);})(DD||(T.RenameRequest=DD={}));var OD;(function(t){t.method="textDocument/prepareRename",t.messageDirection=ne.MessageDirection.clientToServer,t.type=new ne.ProtocolRequestType(t.method);})(OD||(T.PrepareRenameRequest=OD={}));var ID;(function(t){t.method="workspace/executeCommand",t.messageDirection=ne.MessageDirection.clientToServer,t.type=new ne.ProtocolRequestType(t.method);})(ID||(T.ExecuteCommandRequest=ID={}));var kD;(function(t){t.method="workspace/applyEdit",t.messageDirection=ne.MessageDirection.serverToClient,t.type=new ne.ProtocolRequestType("workspace/applyEdit");})(kD||(T.ApplyWorkspaceEditRequest=kD={}));});var jD=A(Pc=>{Object.defineProperty(Pc,"__esModule",{value:!0});Pc.createProtocolConnection=void 0;var $D=hi();function b4(t,e,r,n){return $D.ConnectionStrategy.is(n)&&(n={connectionStrategy:n}),(0, $D.createMessageConnection)(t,e,r,n)}Pc.createProtocolConnection=b4;});var WD=A(Qt=>{var v4=Qt&&Qt.__createBinding||(Object.create?function(t,e,r,n){n===void 0&&(n=r);var i=Object.getOwnPropertyDescriptor(e,r);(!i||("get"in i?!e.__esModule:i.writable||i.configurable))&&(i={enumerable:!0,get:function(){return e[r]}}),Object.defineProperty(t,n,i);}:function(t,e,r,n){n===void 0&&(n=r),t[n]=e[r];}),Dc=Qt&&Qt.__exportStar||function(t,e){for(var r in t)r!=="default"&&!Object.prototype.hasOwnProperty.call(e,r)&&v4(e,t,r);};Object.defineProperty(Qt,"__esModule",{value:!0});Qt.LSPErrorCodes=Qt.createProtocolConnection=void 0;Dc(hi(),Qt);Dc(hc(),Qt);Dc(rt(),Qt);Dc(LD(),Qt);var w4=jD();Object.defineProperty(Qt,"createProtocolConnection",{enumerable:!0,get:function(){return w4.createProtocolConnection}});var HD;(function(t){t.lspReservedErrorRangeStart=-32899,t.RequestFailed=-32803,t.ServerCancelled=-32802,t.ContentModified=-32801,t.RequestCancelled=-32800,t.lspReservedErrorRangeEnd=-32800;})(HD||(Qt.LSPErrorCodes=HD={}));});var dt=A(Zr=>{var S4=Zr&&Zr.__createBinding||(Object.create?function(t,e,r,n){n===void 0&&(n=r);var i=Object.getOwnPropertyDescriptor(e,r);(!i||("get"in i?!e.__esModule:i.writable||i.configurable))&&(i={enumerable:!0,get:function(){return e[r]}}),Object.defineProperty(t,n,i);}:function(t,e,r,n){n===void 0&&(n=r),t[n]=e[r];}),BD=Zr&&Zr.__exportStar||function(t,e){for(var r in t)r!=="default"&&!Object.prototype.hasOwnProperty.call(e,r)&&S4(e,t,r);};Object.defineProperty(Zr,"__esModule",{value:!0});Zr.createProtocolConnection=void 0;var E4=Tm();BD(Tm(),Zr);BD(WD(),Zr);function R4(t,e,r,n){return (0, E4.createMessageConnection)(t,e,r,n)}Zr.createProtocolConnection=R4;});var Um=A(wr=>{Object.defineProperty(wr,"__esModule",{value:!0});wr.generateUuid=wr.parse=wr.isUUID=wr.v4=wr.empty=void 0;var Do=class{constructor(e){this._value=e;}asHex(){return this._value}equals(e){return this.asHex()===e.asHex()}},Oo=class t extends Do{static _oneOf(e){return e[Math.floor(e.length*Math.random())]}static _randomHex(){return t._oneOf(t._chars)}constructor(){super([t._randomHex(),t._randomHex(),t._randomHex(),t._randomHex(),t._randomHex(),t._randomHex(),t._randomHex(),t._randomHex(),"-",t._randomHex(),t._randomHex(),t._randomHex(),t._randomHex(),"-","4",t._randomHex(),t._randomHex(),t._randomHex(),"-",t._oneOf(t._timeHighBits),t._randomHex(),t._randomHex(),t._randomHex(),"-",t._randomHex(),t._randomHex(),t._randomHex(),t._randomHex(),t._randomHex(),t._randomHex(),t._randomHex(),t._randomHex(),t._randomHex(),t._randomHex(),t._randomHex(),t._randomHex()].join(""));}};Oo._chars=["0","1","2","3","4","5","6","6","7","8","9","a","b","c","d","e","f"];Oo._timeHighBits=["8","9","a","b"];wr.empty=new Do("00000000-0000-0000-0000-000000000000");function UD(){return new Oo}wr.v4=UD;var C4=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function zD(t){return C4.test(t)}wr.isUUID=zD;function x4(t){if(!zD(t))throw new Error("invalid uuid");return new Do(t)}wr.parse=x4;function T4(){return UD().asHex()}wr.generateUuid=T4;});var VD=A($n=>{Object.defineProperty($n,"__esModule",{value:!0});$n.attachPartialResult=$n.ProgressFeature=$n.attachWorkDone=void 0;var Ln=dt(),A4=Um(),mi=class t{constructor(e,r){this._connection=e,this._token=r,t.Instances.set(this._token,this);}begin(e,r,n,i){let s={kind:"begin",title:e,percentage:r,message:n,cancellable:i};this._connection.sendProgress(Ln.WorkDoneProgress.type,this._token,s);}report(e,r){let n={kind:"report"};typeof e=="number"?(n.percentage=e,r!==void 0&&(n.message=r)):n.message=e,this._connection.sendProgress(Ln.WorkDoneProgress.type,this._token,n);}done(){t.Instances.delete(this._token),this._connection.sendProgress(Ln.WorkDoneProgress.type,this._token,{kind:"end"});}};mi.Instances=new Map;var Oc=class extends mi{constructor(e,r){super(e,r),this._source=new Ln.CancellationTokenSource;}get token(){return this._source.token}done(){this._source.dispose(),super.done();}cancel(){this._source.cancel();}},Io=class{constructor(){}begin(){}report(){}done(){}},Ic=class extends Io{constructor(){super(),this._source=new Ln.CancellationTokenSource;}get token(){return this._source.token}done(){this._source.dispose();}cancel(){this._source.cancel();}};function P4(t,e){if(e===void 0||e.workDoneToken===void 0)return new Io;let r=e.workDoneToken;return delete e.workDoneToken,new mi(t,r)}$n.attachWorkDone=P4;var D4=t=>class extends t{constructor(){super(),this._progressSupported=!1;}initialize(e){super.initialize(e),e?.window?.workDoneProgress===!0&&(this._progressSupported=!0,this.connection.onNotification(Ln.WorkDoneProgressCancelNotification.type,r=>{let n=mi.Instances.get(r.token);(n instanceof Oc||n instanceof Ic)&&n.cancel();}));}attachWorkDoneProgress(e){return e===void 0?new Io:new mi(this.connection,e)}createWorkDoneProgress(){if(this._progressSupported){let e=(0, A4.generateUuid)();return this.connection.sendRequest(Ln.WorkDoneProgressCreateRequest.type,{token:e}).then(()=>new Oc(this.connection,e))}else return Promise.resolve(new Ic)}};$n.ProgressFeature=D4;var zm;(function(t){t.type=new Ln.ProgressType;})(zm||(zm={}));var Vm=class{constructor(e,r){this._connection=e,this._token=r;}report(e){this._connection.sendProgress(zm.type,this._token,e);}};function O4(t,e){if(e===void 0||e.partialResultToken===void 0)return;let r=e.partialResultToken;return delete e.partialResultToken,new Vm(t,r)}$n.attachPartialResult=O4;});var GD=A(kc=>{Object.defineProperty(kc,"__esModule",{value:!0});kc.ConfigurationFeature=void 0;var I4=dt(),k4=Uu(),M4=t=>class extends t{getConfiguration(e){return e?k4.string(e)?this._getConfiguration({section:e}):this._getConfiguration(e):this._getConfiguration({})}_getConfiguration(e){let r={items:Array.isArray(e)?e:[e]};return this.connection.sendRequest(I4.ConfigurationRequest.type,r).then(n=>Array.isArray(n)?Array.isArray(e)?n:n[0]:Array.isArray(e)?[]:null)}};kc.ConfigurationFeature=M4;});var KD=A(Fc=>{Object.defineProperty(Fc,"__esModule",{value:!0});Fc.WorkspaceFoldersFeature=void 0;var Mc=dt(),F4=t=>class extends t{constructor(){super(),this._notificationIsAutoRegistered=!1;}initialize(e){super.initialize(e);let r=e.workspace;r&&r.workspaceFolders&&(this._onDidChangeWorkspaceFolders=new Mc.Emitter,this.connection.onNotification(Mc.DidChangeWorkspaceFoldersNotification.type,n=>{this._onDidChangeWorkspaceFolders.fire(n.event);}));}fillServerCapabilities(e){super.fillServerCapabilities(e);let r=e.workspace?.workspaceFolders?.changeNotifications;this._notificationIsAutoRegistered=r===!0||typeof r=="string";}getWorkspaceFolders(){return this.connection.sendRequest(Mc.WorkspaceFoldersRequest.type)}get onDidChangeWorkspaceFolders(){if(!this._onDidChangeWorkspaceFolders)throw new Error("Client doesn't support sending workspace folder change events.");return !this._notificationIsAutoRegistered&&!this._unregistration&&(this._unregistration=this.connection.client.register(Mc.DidChangeWorkspaceFoldersNotification.type)),this._onDidChangeWorkspaceFolders.event}};Fc.WorkspaceFoldersFeature=F4;});var ZD=A(Nc=>{Object.defineProperty(Nc,"__esModule",{value:!0});Nc.CallHierarchyFeature=void 0;var Gm=dt(),N4=t=>class extends t{get callHierarchy(){return {onPrepare:e=>this.connection.onRequest(Gm.CallHierarchyPrepareRequest.type,(r,n)=>e(r,n,this.attachWorkDoneProgress(r),void 0)),onIncomingCalls:e=>{let r=Gm.CallHierarchyIncomingCallsRequest.type;return this.connection.onRequest(r,(n,i)=>e(n,i,this.attachWorkDoneProgress(n),this.attachPartialResultProgress(r,n)))},onOutgoingCalls:e=>{let r=Gm.CallHierarchyOutgoingCallsRequest.type;return this.connection.onRequest(r,(n,i)=>e(n,i,this.attachWorkDoneProgress(n),this.attachPartialResultProgress(r,n)))}}}};Nc.CallHierarchyFeature=N4;});var Zm=A(jn=>{Object.defineProperty(jn,"__esModule",{value:!0});jn.SemanticTokensBuilder=jn.SemanticTokensDiff=jn.SemanticTokensFeature=void 0;var qc=dt(),q4=t=>class extends t{get semanticTokens(){return {refresh:()=>this.connection.sendRequest(qc.SemanticTokensRefreshRequest.type),on:e=>{let r=qc.SemanticTokensRequest.type;return this.connection.onRequest(r,(n,i)=>e(n,i,this.attachWorkDoneProgress(n),this.attachPartialResultProgress(r,n)))},onDelta:e=>{let r=qc.SemanticTokensDeltaRequest.type;return this.connection.onRequest(r,(n,i)=>e(n,i,this.attachWorkDoneProgress(n),this.attachPartialResultProgress(r,n)))},onRange:e=>{let r=qc.SemanticTokensRangeRequest.type;return this.connection.onRequest(r,(n,i)=>e(n,i,this.attachWorkDoneProgress(n),this.attachPartialResultProgress(r,n)))}}}};jn.SemanticTokensFeature=q4;var Lc=class{constructor(e,r){this.originalSequence=e,this.modifiedSequence=r;}computeDiff(){let e=this.originalSequence.length,r=this.modifiedSequence.length,n=0;for(;n<r&&n<e&&this.originalSequence[n]===this.modifiedSequence[n];)n++;if(n<r&&n<e){let i=e-1,s=r-1;for(;i>=n&&s>=n&&this.originalSequence[i]===this.modifiedSequence[s];)i--,s--;(i<n||s<n)&&(i++,s++);let o=i-n+1,a=this.modifiedSequence.slice(n,s+1);return a.length===1&&a[0]===this.originalSequence[i]?[{start:n,deleteCount:o-1}]:[{start:n,deleteCount:o,data:a}]}else return n<r?[{start:n,deleteCount:0,data:this.modifiedSequence.slice(n)}]:n<e?[{start:n,deleteCount:e-n}]:[]}};jn.SemanticTokensDiff=Lc;var Km=class{constructor(){this._prevData=void 0,this.initialize();}initialize(){this._id=Date.now(),this._prevLine=0,this._prevChar=0,this._data=[],this._dataLen=0;}push(e,r,n,i,s){let o=e,a=r;this._dataLen>0&&(o-=this._prevLine,o===0&&(a-=this._prevChar)),this._data[this._dataLen++]=o,this._data[this._dataLen++]=a,this._data[this._dataLen++]=n,this._data[this._dataLen++]=i,this._data[this._dataLen++]=s,this._prevLine=e,this._prevChar=r;}get id(){return this._id.toString()}previousResult(e){this.id===e&&(this._prevData=this._data),this.initialize();}build(){return this._prevData=void 0,{resultId:this.id,data:this._data}}canBuildEdits(){return this._prevData!==void 0}buildEdits(){return this._prevData!==void 0?{resultId:this.id,edits:new Lc(this._prevData,this._data).computeDiff()}:this.build()}};jn.SemanticTokensBuilder=Km;});var JD=A($c=>{Object.defineProperty($c,"__esModule",{value:!0});$c.ShowDocumentFeature=void 0;var L4=dt(),$4=t=>class extends t{showDocument(e){return this.connection.sendRequest(L4.ShowDocumentRequest.type,e)}};$c.ShowDocumentFeature=$4;});var YD=A(jc=>{Object.defineProperty(jc,"__esModule",{value:!0});jc.FileOperationsFeature=void 0;var bs=dt(),j4=t=>class extends t{onDidCreateFiles(e){return this.connection.onNotification(bs.DidCreateFilesNotification.type,r=>{e(r);})}onDidRenameFiles(e){return this.connection.onNotification(bs.DidRenameFilesNotification.type,r=>{e(r);})}onDidDeleteFiles(e){return this.connection.onNotification(bs.DidDeleteFilesNotification.type,r=>{e(r);})}onWillCreateFiles(e){return this.connection.onRequest(bs.WillCreateFilesRequest.type,(r,n)=>e(r,n))}onWillRenameFiles(e){return this.connection.onRequest(bs.WillRenameFilesRequest.type,(r,n)=>e(r,n))}onWillDeleteFiles(e){return this.connection.onRequest(bs.WillDeleteFilesRequest.type,(r,n)=>e(r,n))}};jc.FileOperationsFeature=j4;});var XD=A(Hc=>{Object.defineProperty(Hc,"__esModule",{value:!0});Hc.LinkedEditingRangeFeature=void 0;var H4=dt(),W4=t=>class extends t{onLinkedEditingRange(e){return this.connection.onRequest(H4.LinkedEditingRangeRequest.type,(r,n)=>e(r,n,this.attachWorkDoneProgress(r),void 0))}};Hc.LinkedEditingRangeFeature=W4;});var QD=A(Wc=>{Object.defineProperty(Wc,"__esModule",{value:!0});Wc.TypeHierarchyFeature=void 0;var Jm=dt(),B4=t=>class extends t{get typeHierarchy(){return {onPrepare:e=>this.connection.onRequest(Jm.TypeHierarchyPrepareRequest.type,(r,n)=>e(r,n,this.attachWorkDoneProgress(r),void 0)),onSupertypes:e=>{let r=Jm.TypeHierarchySupertypesRequest.type;return this.connection.onRequest(r,(n,i)=>e(n,i,this.attachWorkDoneProgress(n),this.attachPartialResultProgress(r,n)))},onSubtypes:e=>{let r=Jm.TypeHierarchySubtypesRequest.type;return this.connection.onRequest(r,(n,i)=>e(n,i,this.attachWorkDoneProgress(n),this.attachPartialResultProgress(r,n)))}}}};Wc.TypeHierarchyFeature=B4;});var t1=A(Bc=>{Object.defineProperty(Bc,"__esModule",{value:!0});Bc.InlineValueFeature=void 0;var e1=dt(),U4=t=>class extends t{get inlineValue(){return {refresh:()=>this.connection.sendRequest(e1.InlineValueRefreshRequest.type),on:e=>this.connection.onRequest(e1.InlineValueRequest.type,(r,n)=>e(r,n,this.attachWorkDoneProgress(r)))}}};Bc.InlineValueFeature=U4;});var n1=A(Uc=>{Object.defineProperty(Uc,"__esModule",{value:!0});Uc.FoldingRangeFeature=void 0;var r1=dt(),z4=t=>class extends t{get foldingRange(){return {refresh:()=>this.connection.sendRequest(r1.FoldingRangeRefreshRequest.type),on:e=>{let r=r1.FoldingRangeRequest.type;return this.connection.onRequest(r,(n,i)=>e(n,i,this.attachWorkDoneProgress(n),this.attachPartialResultProgress(r,n)))}}}};Uc.FoldingRangeFeature=z4;});var i1=A(zc=>{Object.defineProperty(zc,"__esModule",{value:!0});zc.InlayHintFeature=void 0;var Ym=dt(),V4=t=>class extends t{get inlayHint(){return {refresh:()=>this.connection.sendRequest(Ym.InlayHintRefreshRequest.type),on:e=>this.connection.onRequest(Ym.InlayHintRequest.type,(r,n)=>e(r,n,this.attachWorkDoneProgress(r))),resolve:e=>this.connection.onRequest(Ym.InlayHintResolveRequest.type,(r,n)=>e(r,n))}}};zc.InlayHintFeature=V4;});var s1=A(Vc=>{Object.defineProperty(Vc,"__esModule",{value:!0});Vc.DiagnosticFeature=void 0;var ko=dt(),G4=t=>class extends t{get diagnostics(){return {refresh:()=>this.connection.sendRequest(ko.DiagnosticRefreshRequest.type),on:e=>this.connection.onRequest(ko.DocumentDiagnosticRequest.type,(r,n)=>e(r,n,this.attachWorkDoneProgress(r),this.attachPartialResultProgress(ko.DocumentDiagnosticRequest.partialResult,r))),onWorkspace:e=>this.connection.onRequest(ko.WorkspaceDiagnosticRequest.type,(r,n)=>e(r,n,this.attachWorkDoneProgress(r),this.attachPartialResultProgress(ko.WorkspaceDiagnosticRequest.partialResult,r)))}}};Vc.DiagnosticFeature=G4;});var Qm=A(Gc=>{Object.defineProperty(Gc,"__esModule",{value:!0});Gc.TextDocuments=void 0;var gi=dt(),Xm=class{constructor(e){this._configuration=e,this._syncedDocuments=new Map,this._onDidChangeContent=new gi.Emitter,this._onDidOpen=new gi.Emitter,this._onDidClose=new gi.Emitter,this._onDidSave=new gi.Emitter,this._onWillSave=new gi.Emitter;}get onDidOpen(){return this._onDidOpen.event}get onDidChangeContent(){return this._onDidChangeContent.event}get onWillSave(){return this._onWillSave.event}onWillSaveWaitUntil(e){this._willSaveWaitUntil=e;}get onDidSave(){return this._onDidSave.event}get onDidClose(){return this._onDidClose.event}get(e){return this._syncedDocuments.get(e)}all(){return Array.from(this._syncedDocuments.values())}keys(){return Array.from(this._syncedDocuments.keys())}listen(e){e.__textDocumentSync=gi.TextDocumentSyncKind.Incremental;let r=[];return r.push(e.onDidOpenTextDocument(n=>{let i=n.textDocument,s=this._configuration.create(i.uri,i.languageId,i.version,i.text);this._syncedDocuments.set(i.uri,s);let o=Object.freeze({document:s});this._onDidOpen.fire(o),this._onDidChangeContent.fire(o);})),r.push(e.onDidChangeTextDocument(n=>{let i=n.textDocument,s=n.contentChanges;if(s.length===0)return;let{version:o}=i;if(o==null)throw new Error(`Received document change event for ${i.uri} without valid version identifier`);let a=this._syncedDocuments.get(i.uri);a!==void 0&&(a=this._configuration.update(a,s,o),this._syncedDocuments.set(i.uri,a),this._onDidChangeContent.fire(Object.freeze({document:a})));})),r.push(e.onDidCloseTextDocument(n=>{let i=this._syncedDocuments.get(n.textDocument.uri);i!==void 0&&(this._syncedDocuments.delete(n.textDocument.uri),this._onDidClose.fire(Object.freeze({document:i})));})),r.push(e.onWillSaveTextDocument(n=>{let i=this._syncedDocuments.get(n.textDocument.uri);i!==void 0&&this._onWillSave.fire(Object.freeze({document:i,reason:n.reason}));})),r.push(e.onWillSaveTextDocumentWaitUntil((n,i)=>{let s=this._syncedDocuments.get(n.textDocument.uri);return s!==void 0&&this._willSaveWaitUntil?this._willSaveWaitUntil(Object.freeze({document:s,reason:n.reason}),i):[]})),r.push(e.onDidSaveTextDocument(n=>{let i=this._syncedDocuments.get(n.textDocument.uri);i!==void 0&&this._onDidSave.fire(Object.freeze({document:i}));})),gi.Disposable.create(()=>{r.forEach(n=>n.dispose());})}};Gc.TextDocuments=Xm;});var tg=A(vs=>{Object.defineProperty(vs,"__esModule",{value:!0});vs.NotebookDocuments=vs.NotebookSyncFeature=void 0;var Sr=dt(),o1=Qm(),K4=t=>class extends t{get synchronization(){return {onDidOpenNotebookDocument:e=>this.connection.onNotification(Sr.DidOpenNotebookDocumentNotification.type,r=>{e(r);}),onDidChangeNotebookDocument:e=>this.connection.onNotification(Sr.DidChangeNotebookDocumentNotification.type,r=>{e(r);}),onDidSaveNotebookDocument:e=>this.connection.onNotification(Sr.DidSaveNotebookDocumentNotification.type,r=>{e(r);}),onDidCloseNotebookDocument:e=>this.connection.onNotification(Sr.DidCloseNotebookDocumentNotification.type,r=>{e(r);})}}};vs.NotebookSyncFeature=K4;var Kc=class t{onDidOpenTextDocument(e){return this.openHandler=e,Sr.Disposable.create(()=>{this.openHandler=void 0;})}openTextDocument(e){this.openHandler&&this.openHandler(e);}onDidChangeTextDocument(e){return this.changeHandler=e,Sr.Disposable.create(()=>{this.changeHandler=e;})}changeTextDocument(e){this.changeHandler&&this.changeHandler(e);}onDidCloseTextDocument(e){return this.closeHandler=e,Sr.Disposable.create(()=>{this.closeHandler=void 0;})}closeTextDocument(e){this.closeHandler&&this.closeHandler(e);}onWillSaveTextDocument(){return t.NULL_DISPOSE}onWillSaveTextDocumentWaitUntil(){return t.NULL_DISPOSE}onDidSaveTextDocument(){return t.NULL_DISPOSE}};Kc.NULL_DISPOSE=Object.freeze({dispose:()=>{}});var eg=class{constructor(e){e instanceof o1.TextDocuments?this._cellTextDocuments=e:this._cellTextDocuments=new o1.TextDocuments(e),this.notebookDocuments=new Map,this.notebookCellMap=new Map,this._onDidOpen=new Sr.Emitter,this._onDidChange=new Sr.Emitter,this._onDidSave=new Sr.Emitter,this._onDidClose=new Sr.Emitter;}get cellTextDocuments(){return this._cellTextDocuments}getCellTextDocument(e){return this._cellTextDocuments.get(e.document)}getNotebookDocument(e){return this.notebookDocuments.get(e)}getNotebookCell(e){let r=this.notebookCellMap.get(e);return r&&r[0]}findNotebookDocumentForCell(e){let r=typeof e=="string"?e:e.document,n=this.notebookCellMap.get(r);return n&&n[1]}get onDidOpen(){return this._onDidOpen.event}get onDidSave(){return this._onDidSave.event}get onDidChange(){return this._onDidChange.event}get onDidClose(){return this._onDidClose.event}listen(e){let r=new Kc,n=[];return n.push(this.cellTextDocuments.listen(r)),n.push(e.notebooks.synchronization.onDidOpenNotebookDocument(i=>{this.notebookDocuments.set(i.notebookDocument.uri,i.notebookDocument);for(let s of i.cellTextDocuments)r.openTextDocument({textDocument:s});this.updateCellMap(i.notebookDocument),this._onDidOpen.fire(i.notebookDocument);})),n.push(e.notebooks.synchronization.onDidChangeNotebookDocument(i=>{let s=this.notebookDocuments.get(i.notebookDocument.uri);if(s===void 0)return;s.version=i.notebookDocument.version;let o=s.metadata,a=!1,l=i.change;l.metadata!==void 0&&(a=!0,s.metadata=l.metadata);let d=[],c=[],p=[],m=[];if(l.cells!==void 0){let D=l.cells;if(D.structure!==void 0){let g=D.structure.array;if(s.cells.splice(g.start,g.deleteCount,...g.cells!==void 0?g.cells:[]),D.structure.didOpen!==void 0)for(let S of D.structure.didOpen)r.openTextDocument({textDocument:S}),d.push(S.uri);if(D.structure.didClose)for(let S of D.structure.didClose)r.closeTextDocument({textDocument:S}),c.push(S.uri);}if(D.data!==void 0){let g=new Map(D.data.map(S=>[S.document,S]));for(let S=0;S<=s.cells.length;S++){let I=g.get(s.cells[S].document);if(I!==void 0){let L=s.cells.splice(S,1,I);if(p.push({old:L[0],new:I}),g.delete(I.document),g.size===0)break}}}if(D.textContent!==void 0)for(let g of D.textContent)r.changeTextDocument({textDocument:g.document,contentChanges:g.changes}),m.push(g.document.uri);}this.updateCellMap(s);let _={notebookDocument:s};a&&(_.metadata={old:o,new:s.metadata});let w=[];for(let D of d)w.push(this.getNotebookCell(D));let E=[];for(let D of c)E.push(this.getNotebookCell(D));let P=[];for(let D of m)P.push(this.getNotebookCell(D));(w.length>0||E.length>0||p.length>0||P.length>0)&&(_.cells={added:w,removed:E,changed:{data:p,textContent:P}}),(_.metadata!==void 0||_.cells!==void 0)&&this._onDidChange.fire(_);})),n.push(e.notebooks.synchronization.onDidSaveNotebookDocument(i=>{let s=this.notebookDocuments.get(i.notebookDocument.uri);s!==void 0&&this._onDidSave.fire(s);})),n.push(e.notebooks.synchronization.onDidCloseNotebookDocument(i=>{let s=this.notebookDocuments.get(i.notebookDocument.uri);if(s!==void 0){this._onDidClose.fire(s);for(let o of i.cellTextDocuments)r.closeTextDocument({textDocument:o});this.notebookDocuments.delete(i.notebookDocument.uri);for(let o of s.cells)this.notebookCellMap.delete(o.document);}})),Sr.Disposable.create(()=>{n.forEach(i=>i.dispose());})}updateCellMap(e){for(let r of e.cells)this.notebookCellMap.set(r.document,[r,e]);}};vs.NotebookDocuments=eg;});var a1=A(Zc=>{Object.defineProperty(Zc,"__esModule",{value:!0});Zc.MonikerFeature=void 0;var Z4=dt(),J4=t=>class extends t{get moniker(){return {on:e=>{let r=Z4.MonikerRequest.type;return this.connection.onRequest(r,(n,i)=>e(n,i,this.attachWorkDoneProgress(n),this.attachPartialResultProgress(r,n)))}}}};Zc.MonikerFeature=J4;});var ag=A(Ne=>{Object.defineProperty(Ne,"__esModule",{value:!0});Ne.createConnection=Ne.combineFeatures=Ne.combineNotebooksFeatures=Ne.combineLanguagesFeatures=Ne.combineWorkspaceFeatures=Ne.combineWindowFeatures=Ne.combineClientFeatures=Ne.combineTracerFeatures=Ne.combineTelemetryFeatures=Ne.combineConsoleFeatures=Ne._NotebooksImpl=Ne._LanguagesImpl=Ne.BulkUnregistration=Ne.BulkRegistration=Ne.ErrorMessageTracker=void 0;var ue=dt(),Er=Uu(),ng=Um(),Re=VD(),Y4=GD(),X4=KD(),Q4=ZD(),ez=Zm(),tz=JD(),rz=YD(),nz=XD(),iz=QD(),sz=t1(),oz=n1(),az=i1(),uz=s1(),cz=tg(),lz=a1();function rg(t){if(t!==null)return t}var ig=class{constructor(){this._messages=Object.create(null);}add(e){let r=this._messages[e];r||(r=0),r++,this._messages[e]=r;}sendErrors(e){Object.keys(this._messages).forEach(r=>{e.window.showErrorMessage(r);});}};Ne.ErrorMessageTracker=ig;var Jc=class{constructor(){}rawAttach(e){this._rawConnection=e;}attach(e){this._connection=e;}get connection(){if(!this._connection)throw new Error("Remote is not attached to a connection yet.");return this._connection}fillServerCapabilities(e){}initialize(e){}error(e){this.send(ue.MessageType.Error,e);}warn(e){this.send(ue.MessageType.Warning,e);}info(e){this.send(ue.MessageType.Info,e);}log(e){this.send(ue.MessageType.Log,e);}debug(e){this.send(ue.MessageType.Debug,e);}send(e,r){this._rawConnection&&this._rawConnection.sendNotification(ue.LogMessageNotification.type,{type:e,message:r}).catch(()=>{(0, ue.RAL)().console.error("Sending log message failed");});}},sg=class{constructor(){}attach(e){this._connection=e;}get connection(){if(!this._connection)throw new Error("Remote is not attached to a connection yet.");return this._connection}initialize(e){}fillServerCapabilities(e){}showErrorMessage(e,...r){let n={type:ue.MessageType.Error,message:e,actions:r};return this.connection.sendRequest(ue.ShowMessageRequest.type,n).then(rg)}showWarningMessage(e,...r){let n={type:ue.MessageType.Warning,message:e,actions:r};return this.connection.sendRequest(ue.ShowMessageRequest.type,n).then(rg)}showInformationMessage(e,...r){let n={type:ue.MessageType.Info,message:e,actions:r};return this.connection.sendRequest(ue.ShowMessageRequest.type,n).then(rg)}},u1=(0, tz.ShowDocumentFeature)((0, Re.ProgressFeature)(sg)),c1;(function(t){function e(){return new Yc}t.create=e;})(c1||(Ne.BulkRegistration=c1={}));var Yc=class{constructor(){this._registrations=[],this._registered=new Set;}add(e,r){let n=Er.string(e)?e:e.method;if(this._registered.has(n))throw new Error(`${n} is already added to this registration`);let i=ng.generateUuid();this._registrations.push({id:i,method:n,registerOptions:r||{}}),this._registered.add(n);}asRegistrationParams(){return {registrations:this._registrations}}},l1;(function(t){function e(){return new Mo(void 0,[])}t.create=e;})(l1||(Ne.BulkUnregistration=l1={}));var Mo=class{constructor(e,r){this._connection=e,this._unregistrations=new Map,r.forEach(n=>{this._unregistrations.set(n.method,n);});}get isAttached(){return !!this._connection}attach(e){this._connection=e;}add(e){this._unregistrations.set(e.method,e);}dispose(){let e=[];for(let n of this._unregistrations.values())e.push(n);let r={unregisterations:e};this._connection.sendRequest(ue.UnregistrationRequest.type,r).catch(()=>{this._connection.console.info("Bulk unregistration failed.");});}disposeSingle(e){let r=Er.string(e)?e:e.method,n=this._unregistrations.get(r);if(!n)return !1;let i={unregisterations:[n]};return this._connection.sendRequest(ue.UnregistrationRequest.type,i).then(()=>{this._unregistrations.delete(r);},s=>{this._connection.console.info(`Un-registering request handler for ${n.id} failed.`);}),!0}},Xc=class{attach(e){this._connection=e;}get connection(){if(!this._connection)throw new Error("Remote is not attached to a connection yet.");return this._connection}initialize(e){}fillServerCapabilities(e){}register(e,r,n){return e instanceof Yc?this.registerMany(e):e instanceof Mo?this.registerSingle1(e,r,n):this.registerSingle2(e,r)}registerSingle1(e,r,n){let i=Er.string(r)?r:r.method,s=ng.generateUuid(),o={registrations:[{id:s,method:i,registerOptions:n||{}}]};return e.isAttached||e.attach(this.connection),this.connection.sendRequest(ue.RegistrationRequest.type,o).then(a=>(e.add({id:s,method:i}),e),a=>(this.connection.console.info(`Registering request handler for ${i} failed.`),Promise.reject(a)))}registerSingle2(e,r){let n=Er.string(e)?e:e.method,i=ng.generateUuid(),s={registrations:[{id:i,method:n,registerOptions:r||{}}]};return this.connection.sendRequest(ue.RegistrationRequest.type,s).then(o=>ue.Disposable.create(()=>{this.unregisterSingle(i,n).catch(()=>{this.connection.console.info(`Un-registering capability with id ${i} failed.`);});}),o=>(this.connection.console.info(`Registering request handler for ${n} failed.`),Promise.reject(o)))}unregisterSingle(e,r){let n={unregisterations:[{id:e,method:r}]};return this.connection.sendRequest(ue.UnregistrationRequest.type,n).catch(()=>{this.connection.console.info(`Un-registering request handler for ${e} failed.`);})}registerMany(e){let r=e.asRegistrationParams();return this.connection.sendRequest(ue.RegistrationRequest.type,r).then(()=>new Mo(this._connection,r.registrations.map(n=>({id:n.id,method:n.method}))),n=>(this.connection.console.info("Bulk registration failed."),Promise.reject(n)))}},og=class{constructor(){}attach(e){this._connection=e;}get connection(){if(!this._connection)throw new Error("Remote is not attached to a connection yet.");return this._connection}initialize(e){}fillServerCapabilities(e){}applyEdit(e){function r(i){return i&&!!i.edit}let n=r(e)?e:{edit:e};return this.connection.sendRequest(ue.ApplyWorkspaceEditRequest.type,n)}},f1=(0, rz.FileOperationsFeature)((0, X4.WorkspaceFoldersFeature)((0, Y4.ConfigurationFeature)(og))),Qc=class{constructor(){this._trace=ue.Trace.Off;}attach(e){this._connection=e;}get connection(){if(!this._connection)throw new Error("Remote is not attached to a connection yet.");return this._connection}initialize(e){}fillServerCapabilities(e){}set trace(e){this._trace=e;}log(e,r){this._trace!==ue.Trace.Off&&this.connection.sendNotification(ue.LogTraceNotification.type,{message:e,verbose:this._trace===ue.Trace.Verbose?r:void 0}).catch(()=>{});}},el=class{constructor(){}attach(e){this._connection=e;}get connection(){if(!this._connection)throw new Error("Remote is not attached to a connection yet.");return this._connection}initialize(e){}fillServerCapabilities(e){}logEvent(e){this.connection.sendNotification(ue.TelemetryEventNotification.type,e).catch(()=>{this.connection.console.log("Sending TelemetryEventNotification failed");});}},tl=class{constructor(){}attach(e){this._connection=e;}get connection(){if(!this._connection)throw new Error("Remote is not attached to a connection yet.");return this._connection}initialize(e){}fillServerCapabilities(e){}attachWorkDoneProgress(e){return (0, Re.attachWorkDone)(this.connection,e)}attachPartialResultProgress(e,r){return (0, Re.attachPartialResult)(this.connection,r)}};Ne._LanguagesImpl=tl;var d1=(0, oz.FoldingRangeFeature)((0, lz.MonikerFeature)((0, uz.DiagnosticFeature)((0, az.InlayHintFeature)((0, sz.InlineValueFeature)((0, iz.TypeHierarchyFeature)((0, nz.LinkedEditingRangeFeature)((0, ez.SemanticTokensFeature)((0, Q4.CallHierarchyFeature)(tl))))))))),rl=class{constructor(){}attach(e){this._connection=e;}get connection(){if(!this._connection)throw new Error("Remote is not attached to a connection yet.");return this._connection}initialize(e){}fillServerCapabilities(e){}attachWorkDoneProgress(e){return (0, Re.attachWorkDone)(this.connection,e)}attachPartialResultProgress(e,r){return (0, Re.attachPartialResult)(this.connection,r)}};Ne._NotebooksImpl=rl;var h1=(0, cz.NotebookSyncFeature)(rl);function p1(t,e){return function(r){return e(t(r))}}Ne.combineConsoleFeatures=p1;function m1(t,e){return function(r){return e(t(r))}}Ne.combineTelemetryFeatures=m1;function g1(t,e){return function(r){return e(t(r))}}Ne.combineTracerFeatures=g1;function _1(t,e){return function(r){return e(t(r))}}Ne.combineClientFeatures=_1;function y1(t,e){return function(r){return e(t(r))}}Ne.combineWindowFeatures=y1;function b1(t,e){return function(r){return e(t(r))}}Ne.combineWorkspaceFeatures=b1;function v1(t,e){return function(r){return e(t(r))}}Ne.combineLanguagesFeatures=v1;function w1(t,e){return function(r){return e(t(r))}}Ne.combineNotebooksFeatures=w1;function fz(t,e){function r(i,s,o){return i&&s?o(i,s):i||s}return {__brand:"features",console:r(t.console,e.console,p1),tracer:r(t.tracer,e.tracer,g1),telemetry:r(t.telemetry,e.telemetry,m1),client:r(t.client,e.client,_1),window:r(t.window,e.window,y1),workspace:r(t.workspace,e.workspace,b1),languages:r(t.languages,e.languages,v1),notebooks:r(t.notebooks,e.notebooks,w1)}}Ne.combineFeatures=fz;function dz(t,e,r){let n=r&&r.console?new(r.console(Jc)):new Jc,i=t(n);n.rawAttach(i);let s=r&&r.tracer?new(r.tracer(Qc)):new Qc,o=r&&r.telemetry?new(r.telemetry(el)):new el,a=r&&r.client?new(r.client(Xc)):new Xc,l=r&&r.window?new(r.window(u1)):new u1,d=r&&r.workspace?new(r.workspace(f1)):new f1,c=r&&r.languages?new(r.languages(d1)):new d1,p=r&&r.notebooks?new(r.notebooks(h1)):new h1,m=[n,s,o,a,l,d,c,p];function _(g){return g instanceof Promise?g:Er.thenable(g)?new Promise((S,I)=>{g.then(L=>S(L),L=>I(L));}):Promise.resolve(g)}let w,E,P,D={listen:()=>i.listen(),sendRequest:(g,...S)=>i.sendRequest(Er.string(g)?g:g.method,...S),onRequest:(g,S)=>i.onRequest(g,S),sendNotification:(g,S)=>{let I=Er.string(g)?g:g.method;return i.sendNotification(I,S)},onNotification:(g,S)=>i.onNotification(g,S),onProgress:i.onProgress,sendProgress:i.sendProgress,onInitialize:g=>(E=g,{dispose:()=>{E=void 0;}}),onInitialized:g=>i.onNotification(ue.InitializedNotification.type,g),onShutdown:g=>(w=g,{dispose:()=>{w=void 0;}}),onExit:g=>(P=g,{dispose:()=>{P=void 0;}}),get console(){return n},get telemetry(){return o},get tracer(){return s},get client(){return a},get window(){return l},get workspace(){return d},get languages(){return c},get notebooks(){return p},onDidChangeConfiguration:g=>i.onNotification(ue.DidChangeConfigurationNotification.type,g),onDidChangeWatchedFiles:g=>i.onNotification(ue.DidChangeWatchedFilesNotification.type,g),__textDocumentSync:void 0,onDidOpenTextDocument:g=>i.onNotification(ue.DidOpenTextDocumentNotification.type,g),onDidChangeTextDocument:g=>i.onNotification(ue.DidChangeTextDocumentNotification.type,g),onDidCloseTextDocument:g=>i.onNotification(ue.DidCloseTextDocumentNotification.type,g),onWillSaveTextDocument:g=>i.onNotification(ue.WillSaveTextDocumentNotification.type,g),onWillSaveTextDocumentWaitUntil:g=>i.onRequest(ue.WillSaveTextDocumentWaitUntilRequest.type,g),onDidSaveTextDocument:g=>i.onNotification(ue.DidSaveTextDocumentNotification.type,g),sendDiagnostics:g=>i.sendNotification(ue.PublishDiagnosticsNotification.type,g),onHover:g=>i.onRequest(ue.HoverRequest.type,(S,I)=>g(S,I,(0, Re.attachWorkDone)(i,S),void 0)),onCompletion:g=>i.onRequest(ue.CompletionRequest.type,(S,I)=>g(S,I,(0, Re.attachWorkDone)(i,S),(0, Re.attachPartialResult)(i,S))),onCompletionResolve:g=>i.onRequest(ue.CompletionResolveRequest.type,g),onSignatureHelp:g=>i.onRequest(ue.SignatureHelpRequest.type,(S,I)=>g(S,I,(0, Re.attachWorkDone)(i,S),void 0)),onDeclaration:g=>i.onRequest(ue.DeclarationRequest.type,(S,I)=>g(S,I,(0, Re.attachWorkDone)(i,S),(0, Re.attachPartialResult)(i,S))),onDefinition:g=>i.onRequest(ue.DefinitionRequest.type,(S,I)=>g(S,I,(0, Re.attachWorkDone)(i,S),(0, Re.attachPartialResult)(i,S))),onTypeDefinition:g=>i.onRequest(ue.TypeDefinitionRequest.type,(S,I)=>g(S,I,(0, Re.attachWorkDone)(i,S),(0, Re.attachPartialResult)(i,S))),onImplementation:g=>i.onRequest(ue.ImplementationRequest.type,(S,I)=>g(S,I,(0, Re.attachWorkDone)(i,S),(0, Re.attachPartialResult)(i,S))),onReferences:g=>i.onRequest(ue.ReferencesRequest.type,(S,I)=>g(S,I,(0, Re.attachWorkDone)(i,S),(0, Re.attachPartialResult)(i,S))),onDocumentHighlight:g=>i.onRequest(ue.DocumentHighlightRequest.type,(S,I)=>g(S,I,(0, Re.attachWorkDone)(i,S),(0, Re.attachPartialResult)(i,S))),onDocumentSymbol:g=>i.onRequest(ue.DocumentSymbolRequest.type,(S,I)=>g(S,I,(0, Re.attachWorkDone)(i,S),(0, Re.attachPartialResult)(i,S))),onWorkspaceSymbol:g=>i.onRequest(ue.WorkspaceSymbolRequest.type,(S,I)=>g(S,I,(0, Re.attachWorkDone)(i,S),(0, Re.attachPartialResult)(i,S))),onWorkspaceSymbolResolve:g=>i.onRequest(ue.WorkspaceSymbolResolveRequest.type,g),onCodeAction:g=>i.onRequest(ue.CodeActionRequest.type,(S,I)=>g(S,I,(0, Re.attachWorkDone)(i,S),(0, Re.attachPartialResult)(i,S))),onCodeActionResolve:g=>i.onRequest(ue.CodeActionResolveRequest.type,(S,I)=>g(S,I)),onCodeLens:g=>i.onRequest(ue.CodeLensRequest.type,(S,I)=>g(S,I,(0, Re.attachWorkDone)(i,S),(0, Re.attachPartialResult)(i,S))),onCodeLensResolve:g=>i.onRequest(ue.CodeLensResolveRequest.type,(S,I)=>g(S,I)),onDocumentFormatting:g=>i.onRequest(ue.DocumentFormattingRequest.type,(S,I)=>g(S,I,(0, Re.attachWorkDone)(i,S),void 0)),onDocumentRangeFormatting:g=>i.onRequest(ue.DocumentRangeFormattingRequest.type,(S,I)=>g(S,I,(0, Re.attachWorkDone)(i,S),void 0)),onDocumentOnTypeFormatting:g=>i.onRequest(ue.DocumentOnTypeFormattingRequest.type,(S,I)=>g(S,I)),onRenameRequest:g=>i.onRequest(ue.RenameRequest.type,(S,I)=>g(S,I,(0, Re.attachWorkDone)(i,S),void 0)),onPrepareRename:g=>i.onRequest(ue.PrepareRenameRequest.type,(S,I)=>g(S,I)),onDocumentLinks:g=>i.onRequest(ue.DocumentLinkRequest.type,(S,I)=>g(S,I,(0, Re.attachWorkDone)(i,S),(0, Re.attachPartialResult)(i,S))),onDocumentLinkResolve:g=>i.onRequest(ue.DocumentLinkResolveRequest.type,(S,I)=>g(S,I)),onDocumentColor:g=>i.onRequest(ue.DocumentColorRequest.type,(S,I)=>g(S,I,(0, Re.attachWorkDone)(i,S),(0, Re.attachPartialResult)(i,S))),onColorPresentation:g=>i.onRequest(ue.ColorPresentationRequest.type,(S,I)=>g(S,I,(0, Re.attachWorkDone)(i,S),(0, Re.attachPartialResult)(i,S))),onFoldingRanges:g=>i.onRequest(ue.FoldingRangeRequest.type,(S,I)=>g(S,I,(0, Re.attachWorkDone)(i,S),(0, Re.attachPartialResult)(i,S))),onSelectionRanges:g=>i.onRequest(ue.SelectionRangeRequest.type,(S,I)=>g(S,I,(0, Re.attachWorkDone)(i,S),(0, Re.attachPartialResult)(i,S))),onExecuteCommand:g=>i.onRequest(ue.ExecuteCommandRequest.type,(S,I)=>g(S,I,(0, Re.attachWorkDone)(i,S),void 0)),dispose:()=>i.dispose()};for(let g of m)g.attach(D);return i.onRequest(ue.InitializeRequest.type,g=>{e.initialize(g),Er.string(g.trace)&&(s.trace=ue.Trace.fromString(g.trace));for(let S of m)S.initialize(g.capabilities);if(E){let S=E(g,new ue.CancellationTokenSource().token,(0, Re.attachWorkDone)(i,g),void 0);return _(S).then(I=>{if(I instanceof ue.ResponseError)return I;let L=I;L||(L={capabilities:{}});let Z=L.capabilities;Z||(Z={},L.capabilities=Z),Z.textDocumentSync===void 0||Z.textDocumentSync===null?Z.textDocumentSync=Er.number(D.__textDocumentSync)?D.__textDocumentSync:ue.TextDocumentSyncKind.None:!Er.number(Z.textDocumentSync)&&!Er.number(Z.textDocumentSync.change)&&(Z.textDocumentSync.change=Er.number(D.__textDocumentSync)?D.__textDocumentSync:ue.TextDocumentSyncKind.None);for(let K of m)K.fillServerCapabilities(Z);return L})}else {let S={capabilities:{textDocumentSync:ue.TextDocumentSyncKind.None}};for(let I of m)I.fillServerCapabilities(S.capabilities);return S}}),i.onRequest(ue.ShutdownRequest.type,()=>{if(e.shutdownReceived=!0,w)return w(new ue.CancellationTokenSource().token)}),i.onNotification(ue.ExitNotification.type,()=>{try{P&&P();}finally{e.shutdownReceived?e.exit(0):e.exit(1);}}),i.onNotification(ue.SetTraceNotification.type,g=>{s.trace=ue.Trace.fromString(g.value);}),D}Ne.createConnection=dz;});var S1=A(er=>{Object.defineProperty(er,"__esModule",{value:!0});er.resolveModulePath=er.FileSystem=er.resolveGlobalYarnPath=er.resolveGlobalNodePath=er.resolve=er.uriToFilePath=void 0;var hz=oe("url"),qr=oe("path"),ug=oe("fs"),dg=oe("child_process");function pz(t){let e=hz.parse(t);if(e.protocol!=="file:"||!e.path)return;let r=e.path.split("/");for(var n=0,i=r.length;n<i;n++)r[n]=decodeURIComponent(r[n]);if(process.platform==="win32"&&r.length>1){let s=r[0],o=r[1];s.length===0&&o.length>1&&o[1]===":"&&r.shift();}return qr.normalize(r.join("/"))}er.uriToFilePath=pz;function cg(){return process.platform==="win32"}function nl(t,e,r,n){let i="NODE_PATH",s=["var p = process;","p.on('message',function(m){","if(m.c==='e'){","p.exit(0);","}","else if(m.c==='rs'){","try{","var r=require.resolve(m.a);","p.send({c:'r',s:true,r:r});","}","catch(err){","p.send({c:'r',s:false});","}","}","});"].join("");return new Promise((o,a)=>{let l=process.env,d=Object.create(null);Object.keys(l).forEach(c=>d[c]=l[c]),e&&ug.existsSync(e)&&(d[i]?d[i]=e+qr.delimiter+d[i]:d[i]=e,n&&n(`NODE_PATH value is: ${d[i]}`)),d.ELECTRON_RUN_AS_NODE="1";try{let c=(0, dg.fork)("",[],{cwd:r,env:d,execArgv:["-e",s]});if(c.pid===void 0){a(new Error(`Starting process to resolve node module  ${t} failed`));return}c.on("error",m=>{a(m);}),c.on("message",m=>{m.c==="r"&&(c.send({c:"e"}),m.s?o(m.r):a(new Error(`Failed to resolve module: ${t}`)));});let p={c:"rs",a:t};c.send(p);}catch(c){a(c);}})}er.resolve=nl;function lg(t){let e="npm",r=Object.create(null);Object.keys(process.env).forEach(s=>r[s]=process.env[s]),r.NO_UPDATE_NOTIFIER="true";let n={encoding:"utf8",env:r};cg()&&(e="npm.cmd",n.shell=!0);let i=()=>{};try{process.on("SIGPIPE",i);let s=(0, dg.spawnSync)(e,["config","get","prefix"],n).stdout;if(!s){t&&t("'npm config get prefix' didn't return a value.");return}let o=s.trim();return t&&t(`'npm config get prefix' value is: ${o}`),o.length>0?cg()?qr.join(o,"node_modules"):qr.join(o,"lib","node_modules"):void 0}catch{return}finally{process.removeListener("SIGPIPE",i);}}er.resolveGlobalNodePath=lg;function mz(t){let e="yarn",r={encoding:"utf8"};cg()&&(e="yarn.cmd",r.shell=!0);let n=()=>{};try{process.on("SIGPIPE",n);let i=(0, dg.spawnSync)(e,["global","dir","--json"],r),s=i.stdout;if(!s){t&&(t("'yarn global dir' didn't return a value."),i.stderr&&t(i.stderr));return}let o=s.trim().split(/\r?\n/);for(let a of o)try{let l=JSON.parse(a);if(l.type==="log")return qr.join(l.data,"node_modules")}catch{}return}catch{return}finally{process.removeListener("SIGPIPE",n);}}er.resolveGlobalYarnPath=mz;var fg;(function(t){let e;function r(){return e!==void 0||(process.platform==="win32"?e=!1:e=!ug.existsSync(__filename.toUpperCase())||!ug.existsSync(__filename.toLowerCase())),e}t.isCaseSensitive=r;function n(i,s){return r()?qr.normalize(s).indexOf(qr.normalize(i))===0:qr.normalize(s).toLowerCase().indexOf(qr.normalize(i).toLowerCase())===0}t.isParent=n;})(fg||(er.FileSystem=fg={}));function gz(t,e,r,n){return r?(qr.isAbsolute(r)||(r=qr.join(t,r)),nl(e,r,r,n).then(i=>fg.isParent(r,i)?i:Promise.reject(new Error(`Failed to load ${e} from node path location.`))).then(void 0,i=>nl(e,lg(n),t,n))):nl(e,lg(n),t,n)}er.resolveModulePath=gz;});var hg=A((FZ,E1)=>{E1.exports=dt();});var R1=A(il=>{Object.defineProperty(il,"__esModule",{value:!0});il.InlineCompletionFeature=void 0;var _z=dt(),yz=t=>class extends t{get inlineCompletion(){return {on:e=>this.connection.onRequest(_z.InlineCompletionRequest.type,(r,n)=>e(r,n,this.attachWorkDoneProgress(r)))}}};il.InlineCompletionFeature=yz;});var T1=A(Ft=>{var bz=Ft&&Ft.__createBinding||(Object.create?function(t,e,r,n){n===void 0&&(n=r);var i=Object.getOwnPropertyDescriptor(e,r);(!i||("get"in i?!e.__esModule:i.writable||i.configurable))&&(i={enumerable:!0,get:function(){return e[r]}}),Object.defineProperty(t,n,i);}:function(t,e,r,n){n===void 0&&(n=r),t[n]=e[r];}),x1=Ft&&Ft.__exportStar||function(t,e){for(var r in t)r!=="default"&&!Object.prototype.hasOwnProperty.call(e,r)&&bz(e,t,r);};Object.defineProperty(Ft,"__esModule",{value:!0});Ft.ProposedFeatures=Ft.NotebookDocuments=Ft.TextDocuments=Ft.SemanticTokensBuilder=void 0;var vz=Zm();Object.defineProperty(Ft,"SemanticTokensBuilder",{enumerable:!0,get:function(){return vz.SemanticTokensBuilder}});var wz=R1();x1(dt(),Ft);var Sz=Qm();Object.defineProperty(Ft,"TextDocuments",{enumerable:!0,get:function(){return Sz.TextDocuments}});var Ez=tg();Object.defineProperty(Ft,"NotebookDocuments",{enumerable:!0,get:function(){return Ez.NotebookDocuments}});x1(ag(),Ft);var C1;(function(t){t.all={__brand:"features",languages:wz.InlineCompletionFeature};})(C1||(Ft.ProposedFeatures=C1={}));});var k1=A(Rr=>{var Rz=Rr&&Rr.__createBinding||(Object.create?function(t,e,r,n){n===void 0&&(n=r);var i=Object.getOwnPropertyDescriptor(e,r);(!i||("get"in i?!e.__esModule:i.writable||i.configurable))&&(i={enumerable:!0,get:function(){return e[r]}}),Object.defineProperty(t,n,i);}:function(t,e,r,n){n===void 0&&(n=r),t[n]=e[r];}),O1=Rr&&Rr.__exportStar||function(t,e){for(var r in t)r!=="default"&&!Object.prototype.hasOwnProperty.call(e,r)&&Rz(e,t,r);};Object.defineProperty(Rr,"__esModule",{value:!0});Rr.createConnection=Rr.Files=void 0;var A1=oe("util"),pg=Uu(),Cz=ag(),Fo=S1(),_i=hg();O1(hg(),Rr);O1(T1(),Rr);var P1;(function(t){t.uriToFilePath=Fo.uriToFilePath,t.resolveGlobalNodePath=Fo.resolveGlobalNodePath,t.resolveGlobalYarnPath=Fo.resolveGlobalYarnPath,t.resolve=Fo.resolve,t.resolveModulePath=Fo.resolveModulePath;})(P1||(Rr.Files=P1={}));var ws=!1,I1;function xz(){let t="--clientProcessId";function e(r){try{let n=parseInt(r);isNaN(n)||(I1=setInterval(()=>{try{process.kill(n,0);}catch{process.exit(ws?0:1);}},3e3));}catch{}}for(let r=2;r<process.argv.length;r++){let n=process.argv[r];if(n===t&&r+1<process.argv.length){e(process.argv[r+1]);return}else {let i=n.split("=");i[0]===t&&e(i[1]);}}}xz();var Tz={initialize:t=>{let e=t.processId;pg.number(e)&&I1===void 0&&setInterval(()=>{try{process.kill(e,0);}catch{process.exit(ws?0:1);}},3e3);},get shutdownReceived(){return ws},set shutdownReceived(t){ws=t;},exit:t=>{process.exit(t);}};function Az(t,e,r,n){let i,s,o,a;return t!==void 0&&t.__brand==="features"&&(i=t,t=e,e=r,r=n),_i.ConnectionStrategy.is(t)||_i.ConnectionOptions.is(t)?a=t:(s=t,o=e,a=r),Pz(s,o,a,i)}Rr.createConnection=Az;function Pz(t,e,r,n){let i=!1;if(!t&&!e&&process.argv.length>2){let l,d,c=process.argv.slice(2);for(let p=0;p<c.length;p++){let m=c[p];if(m==="--node-ipc"){t=new _i.IPCMessageReader(process),e=new _i.IPCMessageWriter(process);break}else if(m==="--stdio"){i=!0,t=process.stdin,e=process.stdout;break}else if(m==="--socket"){l=parseInt(c[p+1]);break}else if(m==="--pipe"){d=c[p+1];break}else {var s=m.split("=");if(s[0]==="--socket"){l=parseInt(s[1]);break}else if(s[0]==="--pipe"){d=s[1];break}}}if(l){let p=(0, _i.createServerSocketTransport)(l);t=p[0],e=p[1];}else if(d){let p=(0, _i.createServerPipeTransport)(d);t=p[0],e=p[1];}}var o="Use arguments of createConnection or set command line parameters: '--node-ipc', '--stdio' or '--socket={number}'";if(!t)throw new Error("Connection input stream is not set. "+o);if(!e)throw new Error("Connection output stream is not set. "+o);if(pg.func(t.read)&&pg.func(t.on)){let l=t;l.on("end",()=>{process.exit(ws?0:1);}),l.on("close",()=>{process.exit(ws?0:1);});}let a=l=>{let d=(0, _i.createProtocolConnection)(t,e,l,r);return i&&Dz(l),d};return (0, Cz.createConnection)(a,Tz,n)}function Dz(t){function e(n){return n.map(i=>typeof i=="string"?i:(0, A1.inspect)(i)).join(" ")}let r=new Map;console.assert=function(i,...s){if(!i)if(s.length===0)t.error("Assertion failed");else {let[o,...a]=s;t.error(`Assertion failed: ${o} ${e(a)}`);}},console.count=function(i="default"){let s=String(i),o=r.get(s)??0;o+=1,r.set(s,o),t.log(`${s}: ${s}`);},console.countReset=function(i){i===void 0?r.clear():r.delete(String(i));},console.debug=function(...i){t.log(e(i));},console.dir=function(i,s){t.log((0, A1.inspect)(i,s));},console.log=function(...i){t.log(e(i));},console.error=function(...i){t.error(e(i));},console.trace=function(...i){let s=new Error().stack.replace(/(.+\n){2}/,""),o="Trace";i.length!==0&&(o+=`: ${e(i)}`),t.log(`${o}
${s}`);},console.warn=function(...i){t.warn(e(i));};}});var F1=A((jZ,M1)=>{M1.exports=k1();});var zo=new Uint8Array(256),Uo=zo.length;function yl(){return Uo>zo.length-16&&(DO__default.default.randomFillSync(zo),Uo=0),zo.slice(Uo,Uo+=16)}var xt=[];for(let t=0;t<256;++t)xt.push((t+256).toString(16).slice(1));function Kg(t,e=0){return xt[t[e+0]]+xt[t[e+1]]+xt[t[e+2]]+xt[t[e+3]]+"-"+xt[t[e+4]]+xt[t[e+5]]+"-"+xt[t[e+6]]+xt[t[e+7]]+"-"+xt[t[e+8]]+xt[t[e+9]]+"-"+xt[t[e+10]]+xt[t[e+11]]+xt[t[e+12]]+xt[t[e+13]]+xt[t[e+14]]+xt[t[e+15]]}var bl={randomUUID:DO__default.default.randomUUID};function IO(t,e,r){if(bl.randomUUID&&!e&&!t)return bl.randomUUID();t=t||{};let n=t.random||(t.rng||yl)();if(n[6]=n[6]&15|64,n[8]=n[8]&63|128,e){r=r||0;for(let i=0;i<16;++i)e[r+i]=n[i];return e}return Kg(n)}var Xr=IO;var Hu=$t(xa());var wn={defaultMerge:Symbol("deepmerge-ts: default merge"),skip:Symbol("deepmerge-ts: skip")};function pF(t,e){return e}function zv(t){return typeof t!="object"||t===null?0:Array.isArray(t)?2:_F(t)?1:t instanceof Set?3:t instanceof Map?4:5}function mF(t){let e=new Set;for(let r of t)for(let n of [...Object.keys(r),...Object.getOwnPropertySymbols(r)])e.add(n);return e}function gF(t,e){return typeof t=="object"&&Object.prototype.propertyIsEnumerable.call(t,e)}function Gv(t){return {*[Symbol.iterator](){for(let e of t)for(let r of e)yield r;}}}var Vv=new Set(["[object Object]","[object Module]"]);function _F(t){if(!Vv.has(Object.prototype.toString.call(t)))return !1;let{constructor:e}=t;if(e===void 0)return !0;let r=e.prototype;return !(r===null||typeof r!="object"||!Vv.has(Object.prototype.toString.call(r))||!r.hasOwnProperty("isPrototypeOf"))}function yF(t,e,r){let n={};for(let i of mF(t)){let s=[];for(let l of t)gF(l,i)&&s.push(l[i]);if(s.length===0)continue;let o=e.metaDataUpdater(r,{key:i,parents:t}),a=Jv(s,e,o);a!==wn.skip&&(i==="__proto__"?Object.defineProperty(n,i,{value:a,configurable:!0,enumerable:!0,writable:!0}):n[i]=a);}return n}function bF(t){return t.flat()}function vF(t){return new Set(Gv(t))}function wF(t){return new Map(Gv(t))}function Kv(t){return t.at(-1)}var Ef=Object.freeze({__proto__:null,mergeArrays:bF,mergeMaps:wF,mergeOthers:Kv,mergeRecords:yF,mergeSets:vF});function Zv(...t){return SF({})(...t)}function SF(t,e){let r=EF(t,n);function n(...i){return Jv(i,r,e)}return n}function EF(t,e){return {defaultMergeFunctions:Ef,mergeFunctions:{...Ef,...Object.fromEntries(Object.entries(t).filter(([r,n])=>Object.hasOwn(Ef,r)).map(([r,n])=>n===!1?[r,Kv]:[r,n]))},metaDataUpdater:t.metaDataUpdater??pF,deepmerge:e,useImplicitDefaultMerging:t.enableImplicitDefaultMerging??!1,actions:wn}}function Jv(t,e,r){if(t.length===0)return;if(t.length===1)return Rf(t,e,r);let n=zv(t[0]);if(n!==0&&n!==5){for(let i=1;i<t.length;i++)if(zv(t[i])!==n)return Rf(t,e,r)}switch(n){case 1:return RF(t,e,r);case 2:return CF(t,e,r);case 3:return xF(t,e,r);case 4:return TF(t,e,r);default:return Rf(t,e,r)}}function RF(t,e,r){let n=e.mergeFunctions.mergeRecords(t,e,r);return n===wn.defaultMerge||e.useImplicitDefaultMerging&&n===void 0&&e.mergeFunctions.mergeRecords!==e.defaultMergeFunctions.mergeRecords?e.defaultMergeFunctions.mergeRecords(t,e,r):n}function CF(t,e,r){let n=e.mergeFunctions.mergeArrays(t,e,r);return n===wn.defaultMerge||e.useImplicitDefaultMerging&&n===void 0&&e.mergeFunctions.mergeArrays!==e.defaultMergeFunctions.mergeArrays?e.defaultMergeFunctions.mergeArrays(t):n}function xF(t,e,r){let n=e.mergeFunctions.mergeSets(t,e,r);return n===wn.defaultMerge||e.useImplicitDefaultMerging&&n===void 0&&e.mergeFunctions.mergeSets!==e.defaultMergeFunctions.mergeSets?e.defaultMergeFunctions.mergeSets(t):n}function TF(t,e,r){let n=e.mergeFunctions.mergeMaps(t,e,r);return n===wn.defaultMerge||e.useImplicitDefaultMerging&&n===void 0&&e.mergeFunctions.mergeMaps!==e.defaultMergeFunctions.mergeMaps?e.defaultMergeFunctions.mergeMaps(t):n}function Rf(t,e,r){let n=e.mergeFunctions.mergeOthers(t,e,r);return n===wn.defaultMerge||e.useImplicitDefaultMerging&&n===void 0&&e.mergeFunctions.mergeOthers!==e.defaultMergeFunctions.mergeOthers?e.defaultMergeFunctions.mergeOthers(t):n}var Ls=t=>{let e=typeof t;return t!==null&&(e==="object"||e==="function")};var Cf=new Set(["__proto__","prototype","constructor"]),AF=new Set("0123456789");function xf(t){let e=[],r="",n="start",i=!1;for(let s of t)switch(s){case"\\":{if(n==="index")throw new Error("Invalid character in an index");if(n==="indexEnd")throw new Error("Invalid character after an index");i&&(r+=s),n="property",i=!i;break}case".":{if(n==="index")throw new Error("Invalid character in an index");if(n==="indexEnd"){n="property";break}if(i){i=!1,r+=s;break}if(Cf.has(r))return [];e.push(r),r="",n="property";break}case"[":{if(n==="index")throw new Error("Invalid character in an index");if(n==="indexEnd"){n="index";break}if(i){i=!1,r+=s;break}if(n==="property"){if(Cf.has(r))return [];e.push(r),r="";}n="index";break}case"]":{if(n==="index"){e.push(Number.parseInt(r,10)),r="",n="indexEnd";break}if(n==="indexEnd")throw new Error("Invalid character after an index")}default:{if(n==="index"&&!AF.has(s))throw new Error("Invalid character in an index");if(n==="indexEnd")throw new Error("Invalid character after an index");n==="start"&&(n="property"),i&&(i=!1,r+="\\"),r+=s;}}switch(i&&(r+="\\"),n){case"property":{if(Cf.has(r))return [];e.push(r);break}case"index":throw new Error("Index was not closed");case"start":{e.push("");break}}return e}function Yv(t,e){if(typeof e!="number"&&Array.isArray(t)){let r=Number.parseInt(e,10);return Number.isInteger(r)&&t[r]===t[e]}return !1}function Xv(t,e){if(Yv(t,e))throw new Error("Cannot use string index")}function Ta(t,e,r){if(!Ls(t)||typeof e!="string")return r===void 0?t:r;let n=xf(e);if(n.length===0)return r;for(let i=0;i<n.length;i++){let s=n[i];if(Yv(t,s)?t=i===n.length-1?void 0:null:t=t[s],t==null){if(i!==n.length-1)return r;break}}return t===void 0?r:t}function Zn(t,e,r){if(!Ls(t)||typeof e!="string")return t;let n=t,i=xf(e);for(let s=0;s<i.length;s++){let o=i[s];Xv(t,o),s===i.length-1?t[o]=r:Ls(t[o])||(t[o]=typeof i[s+1]=="number"?[]:{}),t=t[o];}return n}function Aa(t,e){if(!Ls(t)||typeof e!="string")return !1;let r=xf(e);for(let n=0;n<r.length;n++){let i=r[n];if(Xv(t,i),n===r.length-1)return delete t[i],!0;if(t=t[i],!Ls(t))return !1}}var PF={"Content-Type":"application/json"};function Jn(t={}){let{fetch:e=globalThis.fetch,querySerializer:r,bodySerializer:n,...i}=t,s=i.baseUrl??"";s.endsWith("/")&&(s=s.slice(0,-1));async function o(a,l){let{fetch:d=e,headers:c,body:p,params:m={},parseAs:_="json",querySerializer:w=r??DF,bodySerializer:E=n??OF,...P}=l||{},D=IF(a,{baseUrl:s,params:m,querySerializer:w}),g=kF(PF,t?.headers,c,m.header),S={redirect:"follow",...i,...P,headers:g};p&&(S.body=E(p)),S.body instanceof FormData&&g.delete("Content-Type");let I=await d(D,S);if(I.status===204||I.headers.get("Content-Length")==="0")return I.ok?{data:{},response:I}:{error:{},response:I};if(I.ok){let Z;if(_!=="stream"){let K=I.clone();Z=typeof K[_]=="function"?await K[_]():await K.text();}else Z=I.clone().body;return {data:Z,response:I}}let L={};try{L=await I.clone().json();}catch{L=await I.clone().text();}return {error:L,response:I}}return {async GET(a,...l){return o(a,{...l[0],method:"GET"})},async PUT(a,...l){return o(a,{...l[0],method:"PUT"})},async POST(a,...l){return o(a,{...l[0],method:"POST"})},async DELETE(a,...l){return o(a,{...l[0],method:"DELETE"})},async OPTIONS(a,...l){return o(a,{...l[0],method:"OPTIONS"})},async HEAD(a,...l){return o(a,{...l[0],method:"HEAD"})},async PATCH(a,...l){return o(a,{...l[0],method:"PATCH"})},async TRACE(a,...l){return o(a,{...l[0],method:"TRACE"})}}}function DF(t){let e=new URLSearchParams;if(t&&typeof t=="object")for(let[r,n]of Object.entries(t))n!=null&&e.set(r,n);return e.toString()}function OF(t){return JSON.stringify(t)}function IF(t,e){let r=`${e.baseUrl}${t}`;if(e.params.path)for(let[i,s]of Object.entries(e.params.path))r=r.replace(`{${i}}`,encodeURIComponent(String(s)));let n=e.querySerializer(e.params.query??{});return n&&(r+=`?${n}`),r}function kF(...t){let e=new Headers;for(let r of t){if(!r||typeof r!="object")continue;let n=r instanceof Headers?r.entries():Object.entries(r);for(let[i,s]of n)s===null?e.delete(i):s!==void 0&&e.set(i,s);}return e}var iw=$t(rw());function Je(t){let e=t.match(/.*(?:$|\r?\n)/g)?.filter(Boolean)??[];return e.length>0&&e[e.length-1]?.endsWith(`
`)&&e.push(""),e}function Ae(t){return t.trim().length===0}function Hr(t,e){if(e===void 0)return t.match(/^[ \t]*/)?.[0]?.length??0;if(e==="	")return t.match(/^\t*/)?.[0].length??0;if(e.match(/^ *$/))return (t.match(/^ */)?.[0].length??0)/e.length;throw new Error(`Invalid indentation: ${e}`)}function Af(t,e){return e<0||e>=t.length-1?!1:Hr(t[e])<Hr(t[e+1])}function Pa(t,e){return e<=0||e>t.length-1?!1:Hr(t[e-1])>Hr(t[e])}var Pf=[{open:{chars:"(",reg:/\(/},close:{chars:")",reg:/\)/}},{open:{chars:"[",reg:/\[/},close:{chars:"]",reg:/\]/}},{open:{chars:"{",reg:/\{/},close:{chars:"}",reg:/\}/}},{open:{chars:"<",reg:/<(?=\w)/},close:{chars:"/>",reg:/\/>/}},{open:{chars:"<",reg:/<(?=[/\w])/},close:{chars:">",reg:/>/}},{openOrClose:{chars:'"',reg:/"/}},{openOrClose:{chars:"'",reg:/'/}},{openOrClose:{chars:"`",reg:/`/}}],nw=/^([)\]}>"'`]|(\/>))*$/g;function Da(t){let e=[],r=0;for(;r<t.length;){let n=t.slice(r),i={index:n.length,found:void 0};if(Pf.forEach(s=>{Object.entries(s).forEach(([o,a])=>{let l=n.match(a.reg);l&&l.index!==void 0&&l.index<i.index&&(i={index:l.index,found:{pair:s,pos:o,pattern:a}});});}),!i.found)break;switch(i.found.pos){case"openOrClose":{let s=i.found.pattern.chars;e.length>0&&e.includes(s)?e.splice(e.lastIndexOf(s),e.length-e.lastIndexOf(s)):e.push(s);break}case"open":{e.push(i.found.pattern.chars);break}case"close":{let s=i.found.pair;e.length>0&&"open"in s&&e[e.length-1]===s.open.chars?e.pop():e.push(i.found.pattern.chars);break}}r+=i.index+i.found.pattern.chars.length;}return e}function ki(t,e){return iw.get(t,e)}function js(t){let e=new AbortController;for(let r of t){if(r?.aborted)return e.abort(r.reason),r;r?.addEventListener("abort",()=>e.abort(r.reason),{signal:e.signal});}return e.signal}var jt=class extends Error{constructor(r){super(`${r.status} ${r.statusText}`);this.name="HttpError",this.status=r.status,this.statusText=r.statusText,this.response=r;}};function Hs(t){return t instanceof Error&&t.name==="TimeoutError"||t instanceof jt&&[408,499].includes(t.status)}function en(t){return t instanceof Error&&t.name==="AbortError"}function Df(t){let e=t.message||t.toString();return t.cause&&(e+=`
Caused by: `+Df(t.cause)),e}function Of(t){this.message=t;}Of.prototype=new Error,Of.prototype.name="InvalidCharacterError";var sw=typeof window<"u"&&window.atob&&window.atob.bind(window)||function(t){var e=String(t).replace(/=+$/,"");if(e.length%4==1)throw new Of("'atob' failed: The string to be decoded is not correctly encoded.");for(var r,n,i=0,s=0,o="";n=e.charAt(s++);~n&&(r=i%4?64*r+n:n,i++%4)?o+=String.fromCharCode(255&r>>(-2*i&6)):0)n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=".indexOf(n);return o};function qF(t){var e=t.replace(/-/g,"+").replace(/_/g,"/");switch(e.length%4){case 0:break;case 2:e+="==";break;case 3:e+="=";break;default:throw "Illegal base64url string!"}try{return function(r){return decodeURIComponent(sw(r).replace(/(.)/g,function(n,i){var s=i.charCodeAt(0).toString(16).toUpperCase();return s.length<2&&(s="0"+s),"%"+s}))}(e)}catch{return sw(e)}}function Oa(t){this.message=t;}function LF(t,e){if(typeof t!="string")throw new Oa("Invalid token specified");var r=(e=e||{}).header===!0?0:1;try{return JSON.parse(qF(t.split(".")[r]))}catch(n){throw new Oa("Invalid token specified: "+n.message)}}Oa.prototype=new Error,Oa.prototype.name="InvalidTokenError";var Ia=LF;var zd=$t(Vf()),X0=$t(xa()),Q0=$t(Ud());var Vd=class extends events.EventEmitter{constructor(r){super();this.filepath=r;this.data={};}async load(){this.data=await zd.default.readJson(Gd,{throws:!1})||{};}async save(){await zd.default.outputJson(Gd,this.data);}watch(){this.watcher=Q0.default.watch(this.filepath,{interval:1e3});let r=async()=>{let n=this.data;await this.load(),(0, X0.default)(n,this.data)||super.emit("updated",this.data);};this.watcher.on("add",r),this.watcher.on("change",r);}},Gd=Vx__default.default.join(oT__default.default.homedir(),".tabby-client","agent","data.json"),ri=new Vd(Gd);var Pu=$t(ax()),yx=$t(mx());var Xh=class{constructor(){this.streamOptions={filename:Vx__default.default.join(oT__default.default.homedir(),".tabby-client","agent","logs","%DATE%"),frequency:"daily",size:"10M",max_logs:"30d",extension:".log",create_symlink:!0};}write(e){this.stream||(this.stream=yx.getStream(this.streamOptions)),this.stream.write(e);}},gx=new Xh,_x={serializers:{error:Pu.default.stdSerializers.err}},ht=gx?(0, Pu.default)(_x,gx):(0, Pu.default)(_x);ht.level="silent";var ho=[ht];ht.onChild=t=>{ho.push(t);};var Qh=class extends Error{constructor(r){super();this.cause=r;this.name="RetryLimitReachedError";}},Du=class t extends events.EventEmitter{constructor(r){super();this.endpoint=r;this.logger=ht.child({component:"Auth"});this.authApi=Jn({baseUrl:"https://app.tabbyml.com/api"});}static{this.authPageUrl="https://app.tabbyml.com/account/device-token";}static{this.tokenStrategy={polling:{interval:5e3,timeout:5*60*1e3},refresh:{interval:15*60*1e3,beforeExpire:30*60*1e3,whenLoaded:{maxTry:5,retryDelay:1e3},whenScheduled:{maxTry:60,retryDelay:30*1e3}}};}async init(r){r?.dataStore?this.dataStore=r.dataStore:(this.dataStore=ri,ri&&(ri.on("updated",async()=>{await this.load(),super.emit("updated",this.jwt);}),ri.watch())),this.scheduleRefreshToken(),await this.load();}get token(){return this.jwt?.token}get user(){return this.jwt?.payload.email}async load(){if(this.dataStore)try{await this.dataStore.load();let r=this.dataStore.data.auth?.[this.endpoint]?.jwt;if(typeof r=="string"&&this.jwt?.token!==r){this.logger.debug({storedJwt:r},"Load jwt from data store.");let n={token:r,payload:Ia(r)};n.payload.exp*1e3-Date.now()<t.tokenStrategy.refresh.beforeExpire?(this.jwt=await this.refreshToken(n,t.tokenStrategy.refresh.whenLoaded),await this.save()):this.jwt=n;}}catch(r){this.logger.debug({error:r},"Error when loading auth");}}async save(){if(this.dataStore)try{if(this.jwt){if(this.dataStore.data.auth?.[this.endpoint]?.jwt===this.jwt.token)return;this.dataStore.data.auth={...this.dataStore.data.auth,[this.endpoint]:{jwt:this.jwt.token}};}else {if(typeof this.dataStore.data.auth?.[this.endpoint]>"u")return;delete this.dataStore.data.auth[this.endpoint];}await this.dataStore.save(),this.logger.debug("Save changes to data store.");}catch(r){this.logger.error({error:r},"Error when saving auth");}}async reset(){this.jwt&&(this.jwt=void 0,await this.save());}async requestAuthUrl(r){try{if(await this.reset(),r?.signal.aborted)throw r.signal.reason;this.logger.debug("Start to request device token");let n=await this.authApi.POST("/device-token",{body:{auth_url:this.endpoint},signal:r?.signal});if(n.error||!n.response.ok)throw new jt(n.response);let i=n.data;this.logger.debug({deviceToken:i},"Request device token response");let s=new URL(t.authPageUrl);return s.searchParams.append("code",i.data.code),{authUrl:s.toString(),code:i.data.code}}catch(n){throw this.logger.error({error:n},"Error when requesting token"),n}}async pollingToken(r,n){return new Promise((i,s)=>{let o=js([AbortSignal.timeout(t.tokenStrategy.polling.timeout),n?.signal]),a=setInterval(async()=>{try{let l=await this.authApi.POST("/device-token/accept",{params:{query:{code:r}},signal:o});if(l.error||!l.response.ok)throw new jt(l.response);let d=l.data;this.logger.debug({result:d},"Poll jwt response"),this.jwt={token:d.data.jwt,payload:Ia(d.data.jwt)},super.emit("updated",this.jwt),await this.save(),clearInterval(a),i(!0);}catch(l){l instanceof jt&&[400,401,403,405].includes(l.status)?this.logger.debug({error:l},"Expected error when polling jwt"):this.logger.error({error:l},"Error when polling jwt");}},t.tokenStrategy.polling.interval);o.aborted?(clearInterval(a),s(o.reason)):o.addEventListener("abort",()=>{clearInterval(a),s(o.reason);});})}async refreshToken(r,n={maxTry:1,retryDelay:1e3},i=0){try{this.logger.debug({retry:i},"Start to refresh token");let s=await this.authApi.POST("/device-token/refresh",{headers:{Authorization:`Bearer ${r.token}`}});if(s.error||!s.response.ok)throw new jt(s.response);let o=s.data;return this.logger.debug({refreshedJwt:o},"Refresh token response"),{token:o.data.jwt,payload:Ia(o.data.jwt)}}catch(s){if(s instanceof jt&&[400,401,403,405].includes(s.status))this.logger.debug({error:s},"Error when refreshing jwt");else if(this.logger.error({error:s},"Unknown error when refreshing jwt"),i<n.maxTry)return this.logger.debug(`Retry refreshing jwt after ${n.retryDelay}ms`),await new Promise(o=>setTimeout(o,n.retryDelay)),this.refreshToken(r,n,i+1);throw new Qh(s)}}scheduleRefreshToken(){setInterval(async()=>{if(this.jwt)if(this.jwt.payload.exp*1e3-Date.now()<t.tokenStrategy.refresh.beforeExpire)try{this.jwt=await this.refreshToken(this.jwt,t.tokenStrategy.refresh.whenScheduled),super.emit("updated",this.jwt),await this.save();}catch(r){this.logger.error({error:r},"Error when refreshing jwt");}else this.logger.debug("Check token, still valid");},t.tokenStrategy.refresh.interval);}};var ep={server:{endpoint:"http://localhost:8080",token:"",requestHeaders:{},requestTimeout:12e4},completion:{prompt:{experimentalStripAutoClosingCharacters:!0,maxPrefixLines:20,maxSuffixLines:20,clipboard:{minChars:3,maxChars:2e3}},debounce:{mode:"adaptive",interval:250}},postprocess:{limitScope:{experimentalSyntax:!0,indentation:{experimentalKeepBlockScopeWhenCompletingLine:!0}},calculateReplaceRange:{experimentalSyntax:!0}},logs:{level:"silent"},anonymousUsageTracking:{disable:!1}};var tp=$t(Vf()),xx=$t(Rx()),Tx=$t(Ud()),Ax=$t(xa());var Cx=`## Tabby agent configuration file

## Online documentation: https://tabby.tabbyml.com/docs/extensions/configurations
## You can uncomment and edit the values below to change the default settings.
## Configurations in this file have lower priority than the IDE settings.

## Server
## You can set the server endpoint here and an optional authentication token if required.
# [server]
# endpoint = "http://localhost:8080" # http or https URL
# token = "your-token-here" # if token is set, request header Authorization = "Bearer $token" will be added automatically

## You can add custom request headers.
# [server.requestHeaders]
# Header1 = "Value1" # list your custom headers here
# Header2 = "Value2" # values can be strings, numbers or booleans

## Logs
## You can set the log level here. The log file is located at ~/.tabby-client/agent/logs/.
# [logs]
# level = "silent" # "silent" or "error" or "debug"

## Anonymous usage tracking
## Tabby collects anonymous usage data and sends it to the Tabby team to help improve our products.
## Your code, generated completions, or any sensitive information is never tracked or sent.
## For more details on data collection, see https://tabby.tabbyml.com/docs/extensions/configurations#usage-collection
## Your contribution is greatly appreciated. However, if you prefer not to participate, you can disable anonymous usage tracking here.
# [anonymousUsageTracking]
# disable = false # set to true to disable

`,JU={server:"object","server.endpoint":"string","server.token":"string","server.requestHeaders":"object","server.requestTimeout":"number",completion:"object","completion.prompt":"object","completion.prompt.experimentalStripAutoClosingCharacters":"boolean","completion.prompt.maxPrefixLines":"number","completion.prompt.maxSuffixLines":"number","completion.prompt.clipboard":"object","completion.prompt.clipboard.minChars":"number","completion.prompt.clipboard.maxChars":"number","completion.debounce":"object","completion.debounce.mode":"string","completion.debounce.interval":"number",postprocess:"object","postprocess.limitScopeByIndentation":"object","postprocess.limitScopeByIndentation.experimentalKeepBlockScopeWhenCompletingLine":"boolean",logs:"object","logs.level":"string",anonymousUsageTracking:"object","anonymousUsageTracking.disable":"boolean"};function YU(t){for(let[e,r]of Object.entries(JU))typeof Ta(t,e)!==r&&Aa(t,e);return t}var rp=class extends events.EventEmitter{constructor(r){super();this.filepath=r;this.data={};this.logger=ht.child({component:"ConfigFile"});}get config(){return this.data}async load(){try{let r=await tp.default.readFile(this.filepath,"utf8"),n=xx.default.parse(r);if(Object.keys(n).length===0&&r.trim()!==Cx.trim()){await this.createTemplate();return}this.data=YU(n);}catch(r){r instanceof Error&&"code"in r&&r.code==="ENOENT"?await this.createTemplate():this.logger.error({error:r},"Failed to load config file");}}watch(){this.watcher=Tx.default.watch(this.filepath,{interval:1e3});let r=async()=>{let n=this.data;await this.load(),(0, Ax.default)(n,this.data)||super.emit("updated",this.data);};this.watcher.on("add",r),this.watcher.on("change",r);}async createTemplate(){try{await tp.default.outputFile(this.filepath,Cx);}catch(r){this.logger.error({error:r},"Failed to create config template file");}}},XU=Vx__default.default.join(oT__default.default.homedir(),".tabby-client","agent","config.toml"),Zi=new rp(XU);var po=typeof performance=="object"&&performance&&typeof performance.now=="function"?performance:Date,Dx=new Set,np=typeof process=="object"&&process?process:{},Ox=(t,e,r,n)=>{typeof np.emitWarning=="function"?np.emitWarning(t,e,r,n):console.error(`[${r}] ${e}: ${t}`);},Ou=globalThis.AbortController,Px=globalThis.AbortSignal;if(typeof Ou>"u"){Px=class{onabort;_onabort=[];reason;aborted=!1;addEventListener(n,i){this._onabort.push(i);}},Ou=class{constructor(){e();}signal=new Px;abort(n){if(!this.signal.aborted){this.signal.reason=n,this.signal.aborted=!0;for(let i of this.signal._onabort)i(n);this.signal.onabort?.(n);}}};let t=np.env?.LRU_CACHE_IGNORE_AC_WARNING!=="1",e=()=>{t&&(t=!1,Ox("AbortController is not defined. If using lru-cache in node 14, load an AbortController polyfill from the `node-abort-controller` package. A minimal polyfill is provided for use by LRUCache.fetch(), but it should not be relied upon in other contexts (eg, passing it to other APIs that use AbortController/AbortSignal might have undesirable effects). You may disable this with LRU_CACHE_IGNORE_AC_WARNING=1 in the env.","NO_ABORT_CONTROLLER","ENOTSUP",e));};}var QU=t=>!Dx.has(t),An=t=>t&&t===Math.floor(t)&&t>0&&isFinite(t),Ix=t=>An(t)?t<=Math.pow(2,8)?Uint8Array:t<=Math.pow(2,16)?Uint16Array:t<=Math.pow(2,32)?Uint32Array:t<=Number.MAX_SAFE_INTEGER?Ji:null:null,Ji=class extends Array{constructor(e){super(e),this.fill(0);}},ip=class t{heap;length;static#u=!1;static create(e){let r=Ix(e);if(!r)return [];t.#u=!0;let n=new t(e,r);return t.#u=!1,n}constructor(e,r){if(!t.#u)throw new TypeError("instantiate Stack using Stack.create(n)");this.heap=new r(e),this.length=0;}push(e){this.heap[this.length++]=e;}pop(){return this.heap[--this.length]}},Iu=class t{#u;#f;#y;#p;#P;ttl;ttlResolution;ttlAutopurge;updateAgeOnGet;updateAgeOnHas;allowStale;noDisposeOnSet;noUpdateTTL;maxEntrySize;sizeCalculation;noDeleteOnFetchRejection;noDeleteOnStaleGet;allowStaleOnFetchAbort;allowStaleOnFetchRejection;ignoreFetchAbort;#n;#m;#i;#r;#e;#c;#d;#a;#s;#g;#o;#S;#E;#_;#b;#C;#l;static unsafeExposeInternals(e){return {starts:e.#E,ttls:e.#_,sizes:e.#S,keyMap:e.#i,keyList:e.#r,valList:e.#e,next:e.#c,prev:e.#d,get head(){return e.#a},get tail(){return e.#s},free:e.#g,isBackgroundFetch:r=>e.#t(r),backgroundFetch:(r,n,i,s)=>e.#I(r,n,i,s),moveToTail:r=>e.#A(r),indexes:r=>e.#v(r),rindexes:r=>e.#w(r),isStale:r=>e.#h(r)}}get max(){return this.#u}get maxSize(){return this.#f}get calculatedSize(){return this.#m}get size(){return this.#n}get fetchMethod(){return this.#P}get dispose(){return this.#y}get disposeAfter(){return this.#p}constructor(e){let{max:r=0,ttl:n,ttlResolution:i=1,ttlAutopurge:s,updateAgeOnGet:o,updateAgeOnHas:a,allowStale:l,dispose:d,disposeAfter:c,noDisposeOnSet:p,noUpdateTTL:m,maxSize:_=0,maxEntrySize:w=0,sizeCalculation:E,fetchMethod:P,noDeleteOnFetchRejection:D,noDeleteOnStaleGet:g,allowStaleOnFetchRejection:S,allowStaleOnFetchAbort:I,ignoreFetchAbort:L}=e;if(r!==0&&!An(r))throw new TypeError("max option must be a nonnegative integer");let Z=r?Ix(r):Array;if(!Z)throw new Error("invalid max value: "+r);if(this.#u=r,this.#f=_,this.maxEntrySize=w||this.#f,this.sizeCalculation=E,this.sizeCalculation){if(!this.#f&&!this.maxEntrySize)throw new TypeError("cannot set sizeCalculation without setting maxSize or maxEntrySize");if(typeof this.sizeCalculation!="function")throw new TypeError("sizeCalculation set to non-function")}if(P!==void 0&&typeof P!="function")throw new TypeError("fetchMethod must be a function if specified");if(this.#P=P,this.#C=!!P,this.#i=new Map,this.#r=new Array(r).fill(void 0),this.#e=new Array(r).fill(void 0),this.#c=new Z(r),this.#d=new Z(r),this.#a=0,this.#s=0,this.#g=ip.create(r),this.#n=0,this.#m=0,typeof d=="function"&&(this.#y=d),typeof c=="function"?(this.#p=c,this.#o=[]):(this.#p=void 0,this.#o=void 0),this.#b=!!this.#y,this.#l=!!this.#p,this.noDisposeOnSet=!!p,this.noUpdateTTL=!!m,this.noDeleteOnFetchRejection=!!D,this.allowStaleOnFetchRejection=!!S,this.allowStaleOnFetchAbort=!!I,this.ignoreFetchAbort=!!L,this.maxEntrySize!==0){if(this.#f!==0&&!An(this.#f))throw new TypeError("maxSize must be a positive integer if specified");if(!An(this.maxEntrySize))throw new TypeError("maxEntrySize must be a positive integer if specified");this.#L();}if(this.allowStale=!!l,this.noDeleteOnStaleGet=!!g,this.updateAgeOnGet=!!o,this.updateAgeOnHas=!!a,this.ttlResolution=An(i)||i===0?i:1,this.ttlAutopurge=!!s,this.ttl=n||0,this.ttl){if(!An(this.ttl))throw new TypeError("ttl must be a positive integer if specified");this.#k();}if(this.#u===0&&this.ttl===0&&this.#f===0)throw new TypeError("At least one of max, maxSize, or ttl is required");if(!this.ttlAutopurge&&!this.#u&&!this.#f){let K="LRU_CACHE_UNBOUNDED";QU(K)&&(Dx.add(K),Ox("TTL caching without ttlAutopurge, max, or maxSize can result in unbounded memory consumption.","UnboundedCacheWarning",K,t));}}getRemainingTTL(e){return this.#i.has(e)?1/0:0}#k(){let e=new Ji(this.#u),r=new Ji(this.#u);this.#_=e,this.#E=r,this.#M=(s,o,a=po.now())=>{if(r[s]=o!==0?a:0,e[s]=o,o!==0&&this.ttlAutopurge){let l=setTimeout(()=>{this.#h(s)&&this.delete(this.#r[s]);},o+1);l.unref&&l.unref();}},this.#x=s=>{r[s]=e[s]!==0?po.now():0;},this.#R=(s,o)=>{if(e[o]){let a=e[o],l=r[o];s.ttl=a,s.start=l,s.now=n||i();let d=s.now-l;s.remainingTTL=a-d;}};let n=0,i=()=>{let s=po.now();if(this.ttlResolution>0){n=s;let o=setTimeout(()=>n=0,this.ttlResolution);o.unref&&o.unref();}return s};this.getRemainingTTL=s=>{let o=this.#i.get(s);if(o===void 0)return 0;let a=e[o],l=r[o];if(a===0||l===0)return 1/0;let d=(n||i())-l;return a-d},this.#h=s=>e[s]!==0&&r[s]!==0&&(n||i())-r[s]>e[s];}#x=()=>{};#R=()=>{};#M=()=>{};#h=()=>!1;#L(){let e=new Ji(this.#u);this.#m=0,this.#S=e,this.#T=r=>{this.#m-=e[r],e[r]=0;},this.#F=(r,n,i,s)=>{if(this.#t(n))return 0;if(!An(i))if(s){if(typeof s!="function")throw new TypeError("sizeCalculation must be a function");if(i=s(n,r),!An(i))throw new TypeError("sizeCalculation return invalid (expect positive integer)")}else throw new TypeError("invalid size value (must be positive integer). When maxSize or maxEntrySize is used, sizeCalculation or size must be set.");return i},this.#D=(r,n,i)=>{if(e[r]=n,this.#f){let s=this.#f-e[r];for(;this.#m>s;)this.#O(!0);}this.#m+=e[r],i&&(i.entrySize=n,i.totalCalculatedSize=this.#m);};}#T=e=>{};#D=(e,r,n)=>{};#F=(e,r,n,i)=>{if(n||i)throw new TypeError("cannot set size without setting maxSize or maxEntrySize on cache");return 0};*#v({allowStale:e=this.allowStale}={}){if(this.#n)for(let r=this.#s;!(!this.#N(r)||((e||!this.#h(r))&&(yield r),r===this.#a));)r=this.#d[r];}*#w({allowStale:e=this.allowStale}={}){if(this.#n)for(let r=this.#a;!(!this.#N(r)||((e||!this.#h(r))&&(yield r),r===this.#s));)r=this.#c[r];}#N(e){return e!==void 0&&this.#i.get(this.#r[e])===e}*entries(){for(let e of this.#v())this.#e[e]!==void 0&&this.#r[e]!==void 0&&!this.#t(this.#e[e])&&(yield [this.#r[e],this.#e[e]]);}*rentries(){for(let e of this.#w())this.#e[e]!==void 0&&this.#r[e]!==void 0&&!this.#t(this.#e[e])&&(yield [this.#r[e],this.#e[e]]);}*keys(){for(let e of this.#v()){let r=this.#r[e];r!==void 0&&!this.#t(this.#e[e])&&(yield r);}}*rkeys(){for(let e of this.#w()){let r=this.#r[e];r!==void 0&&!this.#t(this.#e[e])&&(yield r);}}*values(){for(let e of this.#v())this.#e[e]!==void 0&&!this.#t(this.#e[e])&&(yield this.#e[e]);}*rvalues(){for(let e of this.#w())this.#e[e]!==void 0&&!this.#t(this.#e[e])&&(yield this.#e[e]);}[Symbol.iterator](){return this.entries()}find(e,r={}){for(let n of this.#v()){let i=this.#e[n],s=this.#t(i)?i.__staleWhileFetching:i;if(s!==void 0&&e(s,this.#r[n],this))return this.get(this.#r[n],r)}}forEach(e,r=this){for(let n of this.#v()){let i=this.#e[n],s=this.#t(i)?i.__staleWhileFetching:i;s!==void 0&&e.call(r,s,this.#r[n],this);}}rforEach(e,r=this){for(let n of this.#w()){let i=this.#e[n],s=this.#t(i)?i.__staleWhileFetching:i;s!==void 0&&e.call(r,s,this.#r[n],this);}}purgeStale(){let e=!1;for(let r of this.#w({allowStale:!0}))this.#h(r)&&(this.delete(this.#r[r]),e=!0);return e}dump(){let e=[];for(let r of this.#v({allowStale:!0})){let n=this.#r[r],i=this.#e[r],s=this.#t(i)?i.__staleWhileFetching:i;if(s===void 0||n===void 0)continue;let o={value:s};if(this.#_&&this.#E){o.ttl=this.#_[r];let a=po.now()-this.#E[r];o.start=Math.floor(Date.now()-a);}this.#S&&(o.size=this.#S[r]),e.unshift([n,o]);}return e}load(e){this.clear();for(let[r,n]of e){if(n.start){let i=Date.now()-n.start;n.start=po.now()-i;}this.set(r,n.value,n);}}set(e,r,n={}){if(r===void 0)return this.delete(e),this;let{ttl:i=this.ttl,start:s,noDisposeOnSet:o=this.noDisposeOnSet,sizeCalculation:a=this.sizeCalculation,status:l}=n,{noUpdateTTL:d=this.noUpdateTTL}=n,c=this.#F(e,r,n.size||0,a);if(this.maxEntrySize&&c>this.maxEntrySize)return l&&(l.set="miss",l.maxEntrySizeExceeded=!0),this.delete(e),this;let p=this.#n===0?void 0:this.#i.get(e);if(p===void 0)p=this.#n===0?this.#s:this.#g.length!==0?this.#g.pop():this.#n===this.#u?this.#O(!1):this.#n,this.#r[p]=e,this.#e[p]=r,this.#i.set(e,p),this.#c[this.#s]=p,this.#d[p]=this.#s,this.#s=p,this.#n++,this.#D(p,c,l),l&&(l.set="add"),d=!1;else {this.#A(p);let m=this.#e[p];if(r!==m){if(this.#C&&this.#t(m)?m.__abortController.abort(new Error("replaced")):o||(this.#b&&this.#y?.(m,e,"set"),this.#l&&this.#o?.push([m,e,"set"])),this.#T(p),this.#D(p,c,l),this.#e[p]=r,l){l.set="replace";let _=m&&this.#t(m)?m.__staleWhileFetching:m;_!==void 0&&(l.oldValue=_);}}else l&&(l.set="update");}if(i!==0&&!this.#_&&this.#k(),this.#_&&(d||this.#M(p,i,s),l&&this.#R(l,p)),!o&&this.#l&&this.#o){let m=this.#o,_;for(;_=m?.shift();)this.#p?.(..._);}return this}pop(){try{for(;this.#n;){let e=this.#e[this.#a];if(this.#O(!0),this.#t(e)){if(e.__staleWhileFetching)return e.__staleWhileFetching}else if(e!==void 0)return e}}finally{if(this.#l&&this.#o){let e=this.#o,r;for(;r=e?.shift();)this.#p?.(...r);}}}#O(e){let r=this.#a,n=this.#r[r],i=this.#e[r];return this.#C&&this.#t(i)?i.__abortController.abort(new Error("evicted")):(this.#b||this.#l)&&(this.#b&&this.#y?.(i,n,"evict"),this.#l&&this.#o?.push([i,n,"evict"])),this.#T(r),e&&(this.#r[r]=void 0,this.#e[r]=void 0,this.#g.push(r)),this.#n===1?(this.#a=this.#s=0,this.#g.length=0):this.#a=this.#c[r],this.#i.delete(n),this.#n--,r}has(e,r={}){let{updateAgeOnHas:n=this.updateAgeOnHas,status:i}=r,s=this.#i.get(e);if(s!==void 0){let o=this.#e[s];if(this.#t(o)&&o.__staleWhileFetching===void 0)return !1;if(this.#h(s))i&&(i.has="stale",this.#R(i,s));else return n&&this.#x(s),i&&(i.has="hit",this.#R(i,s)),!0}else i&&(i.has="miss");return !1}peek(e,r={}){let{allowStale:n=this.allowStale}=r,i=this.#i.get(e);if(i!==void 0&&(n||!this.#h(i))){let s=this.#e[i];return this.#t(s)?s.__staleWhileFetching:s}}#I(e,r,n,i){let s=r===void 0?void 0:this.#e[r];if(this.#t(s))return s;let o=new Ou,{signal:a}=n;a?.addEventListener("abort",()=>o.abort(a.reason),{signal:o.signal});let l={signal:o.signal,options:n,context:i},d=(E,P=!1)=>{let{aborted:D}=o.signal,g=n.ignoreFetchAbort&&E!==void 0;if(n.status&&(D&&!P?(n.status.fetchAborted=!0,n.status.fetchError=o.signal.reason,g&&(n.status.fetchAbortIgnored=!0)):n.status.fetchResolved=!0),D&&!g&&!P)return p(o.signal.reason);let S=_;return this.#e[r]===_&&(E===void 0?S.__staleWhileFetching?this.#e[r]=S.__staleWhileFetching:this.delete(e):(n.status&&(n.status.fetchUpdated=!0),this.set(e,E,l.options))),E},c=E=>(n.status&&(n.status.fetchRejected=!0,n.status.fetchError=E),p(E)),p=E=>{let{aborted:P}=o.signal,D=P&&n.allowStaleOnFetchAbort,g=D||n.allowStaleOnFetchRejection,S=g||n.noDeleteOnFetchRejection,I=_;if(this.#e[r]===_&&(!S||I.__staleWhileFetching===void 0?this.delete(e):D||(this.#e[r]=I.__staleWhileFetching)),g)return n.status&&I.__staleWhileFetching!==void 0&&(n.status.returnedStale=!0),I.__staleWhileFetching;if(I.__returned===I)throw E},m=(E,P)=>{let D=this.#P?.(e,s,l);D&&D instanceof Promise&&D.then(g=>E(g),P),o.signal.addEventListener("abort",()=>{(!n.ignoreFetchAbort||n.allowStaleOnFetchAbort)&&(E(),n.allowStaleOnFetchAbort&&(E=g=>d(g,!0)));});};n.status&&(n.status.fetchDispatched=!0);let _=new Promise(m).then(d,c),w=Object.assign(_,{__abortController:o,__staleWhileFetching:s,__returned:void 0});return r===void 0?(this.set(e,w,{...l.options,status:void 0}),r=this.#i.get(e)):this.#e[r]=w,w}#t(e){if(!this.#C)return !1;let r=e;return !!r&&r instanceof Promise&&r.hasOwnProperty("__staleWhileFetching")&&r.__abortController instanceof Ou}async fetch(e,r={}){let{allowStale:n=this.allowStale,updateAgeOnGet:i=this.updateAgeOnGet,noDeleteOnStaleGet:s=this.noDeleteOnStaleGet,ttl:o=this.ttl,noDisposeOnSet:a=this.noDisposeOnSet,size:l=0,sizeCalculation:d=this.sizeCalculation,noUpdateTTL:c=this.noUpdateTTL,noDeleteOnFetchRejection:p=this.noDeleteOnFetchRejection,allowStaleOnFetchRejection:m=this.allowStaleOnFetchRejection,ignoreFetchAbort:_=this.ignoreFetchAbort,allowStaleOnFetchAbort:w=this.allowStaleOnFetchAbort,context:E,forceRefresh:P=!1,status:D,signal:g}=r;if(!this.#C)return D&&(D.fetch="get"),this.get(e,{allowStale:n,updateAgeOnGet:i,noDeleteOnStaleGet:s,status:D});let S={allowStale:n,updateAgeOnGet:i,noDeleteOnStaleGet:s,ttl:o,noDisposeOnSet:a,size:l,sizeCalculation:d,noUpdateTTL:c,noDeleteOnFetchRejection:p,allowStaleOnFetchRejection:m,allowStaleOnFetchAbort:w,ignoreFetchAbort:_,status:D,signal:g},I=this.#i.get(e);if(I===void 0){D&&(D.fetch="miss");let L=this.#I(e,I,S,E);return L.__returned=L}else {let L=this.#e[I];if(this.#t(L)){let Q=n&&L.__staleWhileFetching!==void 0;return D&&(D.fetch="inflight",Q&&(D.returnedStale=!0)),Q?L.__staleWhileFetching:L.__returned=L}let Z=this.#h(I);if(!P&&!Z)return D&&(D.fetch="hit"),this.#A(I),i&&this.#x(I),D&&this.#R(D,I),L;let K=this.#I(e,I,S,E),B=K.__staleWhileFetching!==void 0&&n;return D&&(D.fetch=Z?"stale":"refresh",B&&Z&&(D.returnedStale=!0)),B?K.__staleWhileFetching:K.__returned=K}}get(e,r={}){let{allowStale:n=this.allowStale,updateAgeOnGet:i=this.updateAgeOnGet,noDeleteOnStaleGet:s=this.noDeleteOnStaleGet,status:o}=r,a=this.#i.get(e);if(a!==void 0){let l=this.#e[a],d=this.#t(l);return o&&this.#R(o,a),this.#h(a)?(o&&(o.get="stale"),d?(o&&n&&l.__staleWhileFetching!==void 0&&(o.returnedStale=!0),n?l.__staleWhileFetching:void 0):(s||this.delete(e),o&&n&&(o.returnedStale=!0),n?l:void 0)):(o&&(o.get="hit"),d?l.__staleWhileFetching:(this.#A(a),i&&this.#x(a),l))}else o&&(o.get="miss");}#q(e,r){this.#d[r]=e,this.#c[e]=r;}#A(e){e!==this.#s&&(e===this.#a?this.#a=this.#c[e]:this.#q(this.#d[e],this.#c[e]),this.#q(this.#s,e),this.#s=e);}delete(e){let r=!1;if(this.#n!==0){let n=this.#i.get(e);if(n!==void 0)if(r=!0,this.#n===1)this.clear();else {this.#T(n);let i=this.#e[n];this.#t(i)?i.__abortController.abort(new Error("deleted")):(this.#b||this.#l)&&(this.#b&&this.#y?.(i,e,"delete"),this.#l&&this.#o?.push([i,e,"delete"])),this.#i.delete(e),this.#r[n]=void 0,this.#e[n]=void 0,n===this.#s?this.#s=this.#d[n]:n===this.#a?this.#a=this.#c[n]:(this.#c[this.#d[n]]=this.#c[n],this.#d[this.#c[n]]=this.#d[n]),this.#n--,this.#g.push(n);}}if(this.#l&&this.#o?.length){let n=this.#o,i;for(;i=n?.shift();)this.#p?.(...i);}return r}clear(){for(let e of this.#w({allowStale:!0})){let r=this.#e[e];if(this.#t(r))r.__abortController.abort(new Error("deleted"));else {let n=this.#r[e];this.#b&&this.#y?.(r,n,"delete"),this.#l&&this.#o?.push([r,n,"delete"]);}}if(this.#i.clear(),this.#e.fill(void 0),this.#r.fill(void 0),this.#_&&this.#E&&(this.#_.fill(0),this.#E.fill(0)),this.#S&&this.#S.fill(0),this.#a=0,this.#s=0,this.#g.length=0,this.#m=0,this.#n=0,this.#l&&this.#o){let e=this.#o,r;for(;r=e?.shift();)this.#p?.(...r);}}};var $x=$t(Lx());function t3(t){return t.trimEnd().match(nw)}var ci=class{constructor(e){this.filepath=e.filepath,this.language=e.language,this.text=e.text,this.position=e.position,this.indentation=e.indentation,this.prefix=e.text.slice(0,e.position),this.suffix=e.text.slice(e.position),this.prefixLines=Je(this.prefix),this.suffixLines=Je(this.suffix),this.currentLinePrefix=this.prefixLines[this.prefixLines.length-1]??"",this.currentLineSuffix=this.suffixLines[0]??"",this.clipboard=e.clipboard?.trim()??"";let r=t3(this.suffixLines[0]??"");this.mode=r?"default":"fill-in-line",this.hash=(0, $x.default)({filepath:this.filepath,language:this.language,text:this.text,position:this.position,clipboard:this.clipboard});}};var ku=class{constructor(){this.logger=ht.child({component:"CompletionCache"});this.options={maxCount:1e4,prebuildCache:{enabled:!0,perCharacter:{lines:1,max:50},perLine:{max:10},autoClosingPairCheck:{max:3}}};this.cache=new Iu({max:this.options.maxCount});}has(e){return this.cache.has(e.hash)}buildCache(e,r){this.logger.debug({key:e,value:r},"Starting to build cache");let n=this.createCacheEntries(e,r);n.forEach(i=>{this.cache.set(i.key.hash,{value:i.value,rebuildFlag:i.rebuildFlag});}),this.logger.debug({newEntries:n.length,cacheSize:this.cache.size},"Cache updated");}get(e){let r=this.cache.get(e.hash);return r?.rebuildFlag&&this.buildCache(e,r?.value),r?.value}createCacheEntries(e,r){let n=[{key:e,value:r,rebuildFlag:!1}];if(this.options.prebuildCache.enabled)for(let s of r.choices){let o=s.text.slice(e.position-s.replaceRange.start),a=this.getPerLinePositions(o);this.logger.trace({completionText:o,perLinePositions:a},"Calculate per-line cache positions");for(let d of a){let c=o.slice(0,d),p=this.generateAutoClosedPrefixes(c);for(let m of [c,...p]){let _={key:new ci({...e,text:e.text.slice(0,e.position)+m+e.text.slice(e.position),position:e.position+d}),value:{...r,choices:[{index:s.index,text:o.slice(d),replaceRange:{start:e.position+d,end:e.position+d}}]},rebuildFlag:!0};this.logger.trace({prefix:m,entry:_},"Build per-line cache entry"),n.push(_);}}let l=this.getPerCharacterPositions(o);this.logger.trace({completionText:o,perCharacterPositions:l},"Calculate per-character cache positions");for(let d of l){let c=d;for(;c>0&&o[c-1]!==`
`;)c--;let p=o.slice(0,d),m=this.generateAutoClosedPrefixes(p);for(let _ of [p,...m]){let w={key:new ci({...e,text:e.text.slice(0,e.position)+_+e.text.slice(e.position),position:e.position+d}),value:{...r,choices:[{index:s.index,text:o.slice(c),replaceRange:{start:e.position+c,end:e.position+d}}]},rebuildFlag:!1};this.logger.trace({prefix:_,entry:w},"Build per-character cache entry"),n.push(w);}}}return n.reduce((s,o)=>{let a=s.find(l=>l.key.hash===o.key.hash);return a?(a.value.choices.push(...o.value.choices),a.rebuildFlag=a.rebuildFlag||o.rebuildFlag):s.push(o),s},[])}getPerLinePositions(e){let r=[],n=this.options.prebuildCache,i=Je(e),s=0,o=0;for(;s<i.length-1&&s<n.perLine.max;){o+=i[s]?.length??0,r.push(o-1),r.push(o);let a=o;for(;a<e.length&&e[a].match(/\s/);)a++;r.push(a),s++;}return r}getPerCharacterPositions(e){let r=[],n=this.options.prebuildCache,i=Je(e).slice(0,n.perCharacter.lines).join(""),s=0;for(;s<i.length&&s<n.perCharacter.max;)r.push(s),s++;return r}generateAutoClosedPrefixes(e){let r=[],n=Da(e),i=0,s="";for(;i<n.length&&i<this.options.prebuildCache.autoClosingPairCheck.max;)Pf.filter(o=>{let a;return "open"in o?a=o.open:a=o.openOrClose,a.chars===n[n.length-1-i]}).forEach(o=>{let a;"close"in o?a=o.close:a=o.openOrClose,s+=a.chars,r.push(e+s);}),i++;return r}};function ap(t,e,r){return Math.max(t,Math.min(e,r))}var Mu=class{constructor(){this.lastCalledTimeStamp=0;this.baseInterval=200;this.calledIntervalHistory=[];this.options={baseIntervalSlideWindowAvg:{minSize:20,maxSize:100,min:100,max:400},adaptiveRate:{min:1.5,max:3},contextScoreWeights:{triggerCharacter:.5,noSuffixInCurrentLine:.4,noSuffix:.1},requestDelay:{min:100,max:1e3}};}async debounce(e,r){let{request:n,config:i,responseTime:s}=e;if(n.manually)return this.sleep(0,r);if(i.mode==="fixed")return this.sleep(i.interval,r);let o=Date.now();this.updateBaseInterval(o-this.lastCalledTimeStamp),this.lastCalledTimeStamp=o;let a=this.calcContextScore(n),d=(this.options.adaptiveRate.max-(this.options.adaptiveRate.max-this.options.adaptiveRate.min)*a)*this.baseInterval,c=ap(this.options.requestDelay.min,this.options.requestDelay.max,d-s);return this.sleep(c,r)}async sleep(e,r){return new Promise((n,i)=>{let s=setTimeout(n,Math.min(e,2147483647));r?.signal&&(r.signal.aborted?(clearTimeout(s),i(r.signal.reason)):r.signal.addEventListener("abort",()=>{clearTimeout(s),i(r.signal.reason);}));})}updateBaseInterval(e){if(!(e>this.options.baseIntervalSlideWindowAvg.max)&&(this.calledIntervalHistory.push(e),this.calledIntervalHistory.length>this.options.baseIntervalSlideWindowAvg.maxSize&&this.calledIntervalHistory.shift(),this.calledIntervalHistory.length>this.options.baseIntervalSlideWindowAvg.minSize)){let r=this.calledIntervalHistory.reduce((n,i)=>n+i,0)/this.calledIntervalHistory.length;this.baseInterval=ap(this.options.baseIntervalSlideWindowAvg.min,this.options.baseIntervalSlideWindowAvg.max,r);}}calcContextScore(e){let r=0,n=this.options.contextScoreWeights,i=e.text[e.position-1]??"";r+=i.match(/^\W*$/)?n.triggerCharacter:0;let s=e.text.slice(e.position)??"",o=Je(s)[0]??"";return r+=o.match(/^\W*$/)?n.noSuffixInCurrentLine:0,r+=s.match(/^\W*$/)?n.noSuffix:0,r=ap(0,1,r),r}};var Ge=ht.child({component:"Postprocess"});Array.prototype.distinct||(Array.prototype.distinct=function(t){return [...new Map(this.map(e=>[t?.(e)??e,e])).values()]});Array.prototype.mapAsync||(Array.prototype.mapAsync=async function(t,e){return await Promise.all(this.map((r,n)=>t.call(e,r,n,this)))});function Zt(t,e){return up(async r=>{let n=e.position-r.replaceRange.start,i=r.text.slice(n),s=await t(i,e);return r.text=r.text.slice(0,n)+(s??""),r},e)}function up(t,e){return async r=>(r.choices=(await r.choices.mapAsync(async n=>await t(n,e))).filter(n=>!!n&&!!n.text).distinct(n=>n.text),r)}function r3(t){return /\n(\s*)\n/g}function jx(){return (t,e)=>{let r=t.split(r3()),n=0,i=2,s=r.length-2;for(;s>=1;){if(Ae(r[s])){s--;continue}let o=s-1;for(;o>=0&&Ae(r[o]);)o--;if(o<0)break;let a=r[s].trim(),l=r[o].trim(),d=Math.max(.1*a.length,.1*l.length);if(ki(a,l)<=d)n++,s--;else break}return n>=i?(Ge.debug({inputBlocks:r,repetitionCount:n},"Remove repetitive blocks."),r.slice(0,s+1).join("").trimEnd()):t}}function Hx(){return t=>{let e=Je(t),r=0,n=5,i=e.length-2;for(;i>=1;){if(Ae(e[i])){i--;continue}let s=i-1;for(;s>=0&&Ae(e[s]);)s--;if(s<0)break;let o=e[i].trim(),a=e[s].trim(),l=Math.max(.1*o.length,.1*a.length);if(ki(o,a)<=l)r++,i=s;else break}return r>=n?(Ge.debug({inputLines:e,repetitionCount:r},"Remove repetitive lines."),e.slice(0,i+1).join("").trimEnd()):t}}var n3=[/(.{3,}?)\1{5,}$/g,/(.{10,}?)\1{3,}$/g];function Wx(){return t=>{let e=Je(t),r=e.length-1;for(;r>=0&&Ae(e[r]);)r--;if(r<0)return t;for(let n of n3){let i=e[r].match(n);if(i)return Ge.debug({inputLines:e,lineNumber:r,match:i},"Remove line ends with repetition."),r<1?null:e.slice(0,r).join("").trimEnd()}return t}}function Bx(){return (t,e)=>{let{suffixLines:r,currentLinePrefix:n}=e,i=Je(t);if(i.length<2)return t;let s=i.map((d,c)=>c===0?n+d:d);if(!Pa(s,i.length-1))return t;let o=i[i.length-1],a=1;for(;a<r.length&&Ae(r[a]);)a++;if(a>=r.length)return t;let l=r[a];return o.startsWith(l.trimEnd())||l.startsWith(o.trimEnd())?(Ge.debug({inputLines:i,suffixLines:r},"Removing duplicated block closing line"),i.slice(0,i.length-1).join("").trimEnd()):t}}function i3(t,e,r,n){let i={indentLevelLimit:0,allowClosingLine:!0},{prefixLines:s,suffixLines:o,currentLinePrefix:a}=r;if(t.length==0||s.length==0)return i;let l=Ae(a),d=s.length-1;for(;d>=0&&Ae(s[d]);)d--;if(d<0)return i;let c=s[d],p=Hr(c),m=t[0],_=Ae(m),w=0;for(;w<t.length&&Ae(t[w]);)w++;if(w>=t.length)return i;let E=t[w],P;_?P=Hr(E):P=Hr(a+E),!_&&!l?n.experimentalKeepBlockScopeWhenCompletingLine?i.indentLevelLimit=p:(i.indentLevelLimit=p+1,i.allowClosingLine&&=Af(e,0)):P>p?i.indentLevelLimit=p+1:(i.indentLevelLimit=p);let D=1;for(;D<o.length&&Ae(o[D]);)D++;if(D<o.length){let g=o[D];i.allowClosingLine&&=Hr(g)<i.indentLevelLimit;}return i}function Ux(t){return (e,r)=>{let{prefixLines:n,suffixLines:i,currentLinePrefix:s}=r,o=Je(e),a=o.map((c,p)=>p===0?s+c:c),l=i3(o,a,r,t),d=1;for(;d<o.length;){let c=o[d],p=o[d-1];if(Ae(c)){d++;continue}if(Hr(c)<l.indentLevelLimit){if(Pa(a,d)&&Af(a,d)){d++;continue}l.allowClosingLine&&(r.language!=="python"||!Ae(p))&&d++;break}d++;}return d<o.length?(Ge.debug({inputLines:o,prefixLines:n,suffixLines:i,scopeLineCount:d},"Remove content out of indent scope"),o.slice(0,d).join("").trimEnd()):e}}var Fu=$t(zx());var Xi={javascript:"tsx",typescript:"tsx",javascriptreact:"tsx",typescriptreact:"tsx",python:"python",go:"go",rust:"rust",ruby:"ruby"},Gx=!1;async function s3(t){Gx||(await Fu.default.init({locateFile(n,i){let s=[i,"wasm",n];return Vx__default.default.join(...s)}}),Gx=!0);let e=new Fu.default,r=[__dirname,"wasm",`tree-sitter-${t}.wasm`];return e.setLanguage(await Fu.default.Language.load(Vx__default.default.join(...r))),e}var Kx=new Map;async function Nu(t){let e=Kx.get(t);return e||(e=await s3(t),Kx.set(t,e)),e}var Zx={tsx:[["jsx_element","jsx_self_closing_element","for_statement","for_in_statement","if_statement","while_statement","do_statement","switch_statement","try_statement","with_statement","labeled_statement","class_declaration","abstract_class_declaration","interface_declaration","enum_declaration","type_alias_declaration","function_declaration","generator_function_declaration","ambient_declaration","method_definition","import_statement","export_statement","module"],["expression_statement","lexical_declaration"]],python:[["for_statement","if_statement","while_statement","match_statement","try_statement","with_statement","function_definition","decorated_definition","class_definition","import_statement","import_from_statement"]],go:[["for_statement","if_statement","expression_switch_statement","type_switch_statement","select_statement","labeled_statement","function_declaration","method_declaration","type_declaration","import_declaration","package_clause"]],rust:[["for_expression","if_expression","while_expression","loop_expression","match_expression","try_expression","function_item","type_item","enum_item","struct_item","union_item","trait_item","impl_item","use_declaration"]],ruby:[["for","if","unless","while","until","case","class","singleton_class","method","singleton_method","module"]]};var o3=Object.keys(Xi);function a3(t,e){let r=e-1;for(;r>=0&&t[r]?.match(/\s/);)r--;if(r<0)return 0;let n=t.lastIndexOf(`
`,r);if(n<0)return 0;let s=t.slice(n+1,e).search(/\S/);return n+1+s}function u3(t,e){let r=e;for(;r<t.length&&t[r]?.match(/\s/);)r++;if(r>=t.length)return t.length;let n=t.indexOf(`
`,r);return n<0?t.length:n}function c3(t,e){for(let r of e){let n=t;for(;n;){if(r.includes(n.type))return n;n=n.parent;}}return t}function Jx(){return async(t,e)=>{let{position:r,text:n,language:i,prefix:s,suffix:o}=e;if(!o3.includes(i))throw new Error(`Language ${i} is not supported`);let a=Xi[i],l=await Nu(a),d=s+t+o,c=l.parse(d),p=a3(d,r),m=u3(d,r),_=c3(c.rootNode.namedDescendantForIndex(p,m),Zx[a]??[]);if(_.type=="ERROR")throw new Error("Cannot determine syntax scope.");return _.endIndex<r+t.length?(Ge.debug({languageConfig:a,text:n,updatedText:d,position:r,lineBegin:p,lineEnd:m,scope:{type:_.type,start:_.startIndex,end:_.endIndex}},"Remove content out of syntax scope"),t.slice(0,_.endIndex-r)):t}}function Yx(t){return async(e,r)=>{if(t.experimentalSyntax)try{return await Jx()(e,r)}catch(i){Ge.debug({error:i},"Failed to limit scope by syntax parser");}return Ux(t.indentation)(e,r)}}function cp(t){let e={"	":0,"  ":0,"    ":0};for(let r of t)if(r.match(/^\t/))e["	"]++;else {let n=r.match(/^ */)?.[0].length??0;n>0&&(n%4===0&&e["    "]++,n%2===0&&e["  "]++);}return e["	"]>0?"	":e["  "]>e["    "]?"  ":e["    "]>0?"    ":null}function l3(t,e){return e==="	"?t.match(/^\t*/)?.[0].length??0:(t.match(/^ */)?.[0].length??0)/e.length}function Xx(){return (t,e)=>{let{prefixLines:r,suffixLines:n,currentLinePrefix:i,indentation:s}=e,o=Je(t);if(!s)return t;let a=Ae(i)?r.slice(0,r.length-1):r;if(r.length>1&&cp(a)!==null)return t;let l=n.slice(1);if(n.length>1&&cp(l)!==null)return t;let d=o.map((m,_)=>_===0?i+m:m),c=cp(d);if(c===null||c===s)return t;let p=d.map((m,_)=>{let w=l3(m,c);if(w===0)return o[_];let E=m.slice(c.length*w);return _===0?Ae(i)?s.repeat(w).slice(i.length)+E:o[0]:s.repeat(w)+E});return Ge.debug({prefixLines:r,suffixLines:n,inputLines:o,formatted:p},"Format indentation."),p.join("")}}function lp(){return (t,e)=>{let{currentLinePrefix:r,currentLineSuffix:n}=e,i=t;return !Ae(r)&&r.match(/\s$/)&&(i=i.trimStart()),(Ae(n)||!Ae(n)&&n.match(/^\s/))&&(i=i.trimEnd()),i}}function Qx(){return (t,e)=>{let r=Je(t);if(e.mode==="fill-in-line"&&r.length>1){let n=e.currentLineSuffix.trimEnd(),i=r[0].trimEnd();if(i.endsWith(n)){let s=i.slice(0,-n.length);if(s.length>0)return Ge.debug({inputLines:r,trimmedInputLine:s},"Trim content with multiple lines"),s}return Ge.debug({inputLines:r},"Drop content with multiple lines"),null}return t}}function fp(){return (t,e)=>{let{suffixLines:r}=e,n=Je(t),i=0;for(;i<n.length&&Ae(n[i]);)i++;let s=0;for(;s<r.length&&Ae(r[s]);)s++;let o=Math.min(3,n.length-i,r.length-s);if(o<1)return t;let a=n.slice(i,i+o).join("").trim(),l=r.slice(s,s+o).join("").trim(),d=Math.max(1,.05*a.length,.05*l.length),c=ki(a,l);return c<=d?(Ge.debug({inputLines:n,suffixLines:r,inputToCompare:a,suffixToCompare:l,distance:c,threshold:d},"Drop completion due to duplicated."),null):t}}function dp(){return t=>Ae(t)?null:t}function eT(t,e){let{currentLineSuffix:r}=e,n=r.trimEnd();if(Ae(n))return t;let i=t.text.slice(e.position-t.replaceRange.start),s=Da(i).join("");return Ae(s)||(n.startsWith(s)?(t.replaceRange.end=e.position+s.length,Ge.trace({context:e,completion:t.text,range:t.replaceRange,unpaired:s},"Adjust replace range by bracket stack")):s.startsWith(n)&&(t.replaceRange.end=e.position+n.length,Ge.trace({context:e,completion:t.text,range:t.replaceRange,unpaired:s},"Adjust replace range by bracket stack"))),t}var f3=Object.keys(Xi);async function tT(t,e){let{position:r,prefix:n,suffix:i,prefixLines:s,currentLinePrefix:o,currentLineSuffix:a,language:l}=e,d=a.trimEnd();if(Ae(d))return t;if(!f3.includes(l))throw new Error(`Language ${l} is not supported`);let c=Xi[l],p=await Nu(c),m=t.text.slice(r-t.replaceRange.start),_=Je(m),w=0,E=p.parse(n+m+i),P=E.rootNode.namedDescendantForIndex(n.length+m.length,n.length+m.length+d.length-w);for(;P.hasError()&&w<d.length;){w++;let D=s.length-1+_.length-1,g=_[_.length-1]?.length??0;_.length==1&&(g+=o.length),E.edit({startIndex:n.length+m.length,oldEndIndex:n.length+m.length+1,newEndIndex:n.length+m.length,startPosition:{row:D,column:g},oldEndPosition:{row:D,column:g+1},newEndPosition:{row:D,column:g}}),E=p.parse(n+m+i.slice(w),E),P=E.rootNode.namedDescendantForIndex(n.length+m.length,n.length+m.length+d.length-w);}if(P.hasError())throw new Error("Syntax error when parsing completion");return t.replaceRange.end=r+w,Ge.trace({context:e,completion:t.text,range:t.replaceRange},"Adjust replace range by syntax"),t}function rT(t){return async(e,r)=>{if(t.experimentalSyntax)try{return await tT(e,r)}catch(i){Ge.debug({error:i},"Failed to calculate replace range by syntax parser");}return eT(e,r)}}async function nT(t,e,r){return Promise.resolve(r).then(Zt(Qx(),t)).then(Zt(Wx(),t)).then(Zt(fp(),t)).then(Zt(lp(),t)).then(Zt(dp(),t))}async function iT(t,e,r){return Promise.resolve(r).then(Zt(jx(),t)).then(Zt(Hx(),t)).then(Zt(Yx(e.limitScope),t)).then(Zt(Bx(),t)).then(Zt(Xx(),t)).then(Zt(fp(),t)).then(Zt(lp(),t)).then(Zt(dp(),t)).then(up(rT(e.calculateReplaceRange),t))}var go="tabby-agent",_o="1.3.1";var qu=class{constructor(){this.anonymousUsageTrackingApi=Jn({baseUrl:"https://app.tabbyml.com/api"});this.logger=ht.child({component:"AnonymousUsage"});this.systemData={agent:`${go}, ${_o}`,browser:void 0,node:`${process.version} ${process.platform} ${oT__default.default.arch()} ${oT__default.default.release()}`};this.sessionProperties={};this.userProperties={};this.userPropertiesUpdated=!1;this.emittedUniqueEvent=[];this.disabled=!1;}async init(e){if(this.dataStore=e?.dataStore||ri,this.dataStore){try{await this.dataStore.load();}catch(r){this.logger.debug({error:r},"Error when loading anonymousId");}if(typeof this.dataStore.data.anonymousId=="string")this.anonymousId=this.dataStore.data.anonymousId;else {this.anonymousId=Xr(),this.dataStore.data.anonymousId=this.anonymousId;try{await this.dataStore.save();}catch(r){this.logger.debug({error:r},"Error when saving anonymousId");}}}else this.anonymousId=Xr();}setSessionProperties(e,r){Zn(this.sessionProperties,e,r);}setUserProperties(e,r){Zn(this.userProperties,e,r),this.userPropertiesUpdated=!0;}async uniqueEvent(e,r={}){await this.event(e,r,!0);}async event(e,r={},n=!1){if(this.disabled||!this.anonymousId||n&&this.emittedUniqueEvent.includes(e))return;n&&this.emittedUniqueEvent.push(e);let i={...this.systemData,...this.sessionProperties,...r};this.userPropertiesUpdated&&(Zn(i,"$set",this.userProperties),this.userPropertiesUpdated=!1);try{await this.anonymousUsageTrackingApi.POST("/usage",{body:{distinctId:this.anonymousId,event:e,properties:i}});}catch(s){this.logger.error({error:s},"Error when sending anonymous usage data");}}};var gp=$t(lT()),Lu=class{constructor(){this.sum=0;this.quantity=0;}add(e){this.sum+=e,this.quantity+=1;}mean(){if(this.quantity!==0)return this.sum/this.quantity}count(){return this.quantity}},$u=class{constructor(e){this.values=[];this.maxSize=e;}add(e){this.values.push(e),this.values.length>this.maxSize&&this.values.shift();}getValues(){return this.values}},ju=class{constructor(){this.config={windowSize:10,checks:{disable:!1,healthy:{windowSize:1,latency:3e3},slowResponseTime:{latency:5e3,count:1},highTimeoutRate:{rate:.5,count:1}}};this.autoCompletionCount=0;this.manualCompletionCount=0;this.cacheHitCount=0;this.cacheMissCount=0;this.eventMap=new Map;this.completionRequestLatencyStats=new gp.Univariate;this.completionRequestCanceledStats=new Lu;this.completionRequestTimeoutCount=0;this.recentCompletionRequestLatencies=new $u(this.config.windowSize);}add(e){let{triggerMode:r,cacheHit:n,aborted:i,requestSent:s,requestLatency:o,requestCanceled:a,requestTimeout:l}=e;i||(r==="auto"?this.autoCompletionCount+=1:this.manualCompletionCount+=1,n?this.cacheHitCount+=1:this.cacheMissCount+=1),s&&(a?this.completionRequestCanceledStats.add(o):l?this.completionRequestTimeoutCount+=1:this.completionRequestLatencyStats.add(o),a||this.recentCompletionRequestLatencies.add(o));}addEvent(e){let r=this.eventMap.get(e)||0;this.eventMap.set(e,r+1);}reset(){this.autoCompletionCount=0,this.manualCompletionCount=0,this.cacheHitCount=0,this.cacheMissCount=0,this.eventMap=new Map,this.completionRequestLatencyStats=new gp.Univariate,this.completionRequestCanceledStats=new Lu,this.completionRequestTimeoutCount=0;}resetWindowed(){this.recentCompletionRequestLatencies=new $u(this.config.windowSize);}stats(){let e=Object.fromEntries(Array.from(this.eventMap.entries()).map(([r,n])=>["count_"+r,n]));return {completion:{count_auto:this.autoCompletionCount,count_manual:this.manualCompletionCount,cache_hit:this.cacheHitCount,cache_miss:this.cacheMissCount,...e},completion_request:{count:this.completionRequestLatencyStats.count(),latency_avg:this.completionRequestLatencyStats.mean(),latency_p50:this.completionRequestLatencyStats.percentile(50),latency_p95:this.completionRequestLatencyStats.percentile(95),latency_p99:this.completionRequestLatencyStats.percentile(99)},completion_request_canceled:{count:this.completionRequestCanceledStats.count(),latency_avg:this.completionRequestCanceledStats.mean()},completion_request_timeout:{count:this.completionRequestTimeoutCount}}}windowed(){let e=this.recentCompletionRequestLatencies.getValues(),r=e.filter(s=>Number.isNaN(s)),n=e.filter(s=>!Number.isNaN(s)),i=n.reduce((s,o)=>s+o,0)/n.length;return {values:e,stats:{total:e.length,timeouts:r.length,responses:n.length,averageResponseTime:i}}}check(e){if(this.config.checks.disable)return null;let r=this.config.checks,{values:n,stats:{total:i,timeouts:s,responses:o,averageResponseTime:a}}=e;return n.slice(-Math.min(this.config.windowSize,r.healthy.windowSize)).every(l=>l<r.healthy.latency)?"healthy":s/i>r.highTimeoutRate.rate&&s>=r.highTimeoutRate.count?"highTimeoutRate":a>r.slowResponseTime.latency&&o>=r.slowResponseTime.count?"slowResponseTime":null}};var Wu=class t extends events.EventEmitter{constructor(){super();this.logger=ht.child({component:"TabbyAgent"});this.anonymousUsageLogger=new qu;this.config=ep;this.userConfig={};this.clientConfig={};this.status="notInitialized";this.issues=[];this.completionCache=new ku;this.completionDebounce=new Mu;this.completionProviderStats=new ju;this.tryingConnectTimer=setInterval(async()=>{this.status==="disconnected"&&(this.logger.debug("Trying to connect..."),await this.healthCheck());},t.tryConnectInterval),this.submitStatsTimer=setInterval(async()=>{await this.submitStats();},t.submitStatsInterval);}static{this.tryConnectInterval=1e3*30;}static{this.submitStatsInterval=1e3*60*60*24;}async applyConfig(){let r=this.config,n=this.status;this.config=Zv(ep,this.userConfig,this.clientConfig),ho.forEach(s=>s.level=this.config.logs.level),this.anonymousUsageLogger.disabled=this.config.anonymousUsageTracking.disable,Ae(this.config.server.token)&&this.config.server.requestHeaders.Authorization===void 0?this.config.server.endpoint!==this.auth?.endpoint&&(this.auth=new Du(this.config.server.endpoint),await this.auth.init({dataStore:this.dataStore}),this.auth.on("updated",()=>{this.setupApi();})):this.auth=void 0,(0, Hu.default)(r.server,this.config.server)||(this.serverHealthState=void 0,this.completionProviderStats.resetWindowed(),this.popIssue("slowCompletionResponseTime"),this.popIssue("highCompletionTimeoutRate"),this.popIssue("connectionFailed"),this.connectionErrorMessage=void 0),await this.setupApi(),(0, Hu.default)(r.server,this.config.server)||n==="unauthorized"&&this.status==="unauthorized"&&this.emitAuthRequired();let i={event:"configUpdated",config:this.config};this.logger.debug({event:i},"Config updated"),super.emit("configUpdated",i);}async setupApi(){let r=Ae(this.config.server.token)?this.auth?.token?`Bearer ${this.auth.token}`:void 0:`Bearer ${this.config.server.token}`;this.api=Jn({baseUrl:this.config.server.endpoint.replace(/\/+$/,""),headers:{Authorization:r,...this.config.server.requestHeaders}}),await this.healthCheck();}changeStatus(r){if(this.status!=r){this.status=r;let n={event:"statusChanged",status:r};this.logger.debug({event:n},"Status changed"),super.emit("statusChanged",n),this.status==="unauthorized"&&this.emitAuthRequired();}}issueFromName(r){switch(r){case"highCompletionTimeoutRate":return {name:"highCompletionTimeoutRate",completionResponseStats:this.completionProviderStats.windowed().stats};case"slowCompletionResponseTime":return {name:"slowCompletionResponseTime",completionResponseStats:this.completionProviderStats.windowed().stats};case"connectionFailed":return {name:"connectionFailed",message:this.connectionErrorMessage}}}pushIssue(r){this.issues.includes(r)||(this.issues.push(r),this.logger.debug({issue:r},"Issues Pushed"),this.emitIssueUpdated());}popIssue(r){let n=this.issues.indexOf(r);n>=0&&(this.issues.splice(n,1),this.logger.debug({issue:r},"Issues Popped"),this.emitIssueUpdated());}emitAuthRequired(){let r={event:"authRequired",server:this.config.server};super.emit("authRequired",r);}emitIssueUpdated(){let r={event:"issuesUpdated",issues:this.issues};super.emit("issuesUpdated",r);}async submitStats(){let r=this.completionProviderStats.stats();r.completion_request.count>0&&(await this.anonymousUsageLogger.event("AgentStats",{stats:r}),this.completionProviderStats.reset(),this.logger.debug({stats:r},"Stats submitted"));}createAbortSignal(r){let n=Math.min(2147483647,r?.timeout||this.config.server.requestTimeout);return js([AbortSignal.timeout(n),r?.signal])}async healthCheck(r){let n=Xr(),i="/v1/health",s=this.config.server.endpoint+i,o={signal:this.createAbortSignal({signal:r?.signal})};try{if(!this.api)throw new Error("http client not initialized");this.logger.debug({requestId:n,requestOptions:o,url:s},"Health check request");let a;if(r?.method==="POST"?a=await this.api.POST(i,o):a=await this.api.GET(i,o),a.error||!a.response.ok)throw new jt(a.response);this.logger.debug({requestId:n,response:a},"Health check response"),this.changeStatus("ready"),this.popIssue("connectionFailed"),this.connectionErrorMessage=void 0;let l=a.data;typeof l=="object"&&l.model!==void 0&&l.device!==void 0&&(this.serverHealthState=l,this.anonymousUsageLogger.uniqueEvent("AgentConnected",l));}catch(a){if(this.serverHealthState=void 0,a instanceof jt&&a.status==405&&r?.method!=="POST")return await this.healthCheck({method:"POST"});if(a instanceof jt&&[401,403].includes(a.status))this.logger.debug({requestId:n,error:a},"Health check error: unauthorized"),this.changeStatus("unauthorized");else {if(Hs(a))this.logger.debug({requestId:n,error:a},"Health check error: timeout"),this.connectionErrorMessage=`GET ${s}: Timed out.`;else if(en(a))this.logger.debug({requestId:n,error:a},"Health check error: canceled"),this.connectionErrorMessage=`GET ${s}: Canceled.`;else {this.logger.error({requestId:n,error:a},"Health check error: unknown error");let l=a instanceof Error?Df(a):JSON.stringify(a);this.connectionErrorMessage=`GET ${s}: Request failed: 
${l}`;}this.pushIssue("connectionFailed"),this.changeStatus("disconnected");}}}createSegments(r){let n=this.config.completion.prompt.maxPrefixLines,i=this.config.completion.prompt.maxSuffixLines,{prefixLines:s,suffixLines:o}=r,a=s.slice(Math.max(s.length-n,0)).join(""),l;this.config.completion.prompt.experimentalStripAutoClosingCharacters&&r.mode!=="fill-in-line"?l=`
`+o.slice(1,i).join(""):l=o.slice(0,i).join("");let d,c=this.config.completion.prompt.clipboard;return r.clipboard.length>=c.minChars&&r.clipboard.length<=c.maxChars&&(d=r.clipboard),{prefix:a,suffix:l,clipboard:d}}async initialize(r){if(this.dataStore=r?.dataStore,await this.anonymousUsageLogger.init({dataStore:this.dataStore}),r.clientProperties){let{user:n,session:i}=r.clientProperties;ho.forEach(s=>s.setBindings?.({...i})),i&&Object.entries(i).forEach(([s,o])=>{this.anonymousUsageLogger.setSessionProperties(s,o);}),n&&Object.entries(n).forEach(([s,o])=>{this.anonymousUsageLogger.setUserProperties(s,o);});}return Zi&&(await Zi.load(),this.userConfig=Zi.config,Zi.on("updated",async n=>{this.userConfig=n,await this.applyConfig();}),Zi.watch()),r.config&&(this.clientConfig=r.config),await this.applyConfig(),await this.anonymousUsageLogger.uniqueEvent("AgentInitialized"),this.logger.debug({options:r},"Initialized"),this.status!=="notInitialized"}async finalize(){return this.status==="finalized"?!1:(await this.submitStats(),this.tryingConnectTimer&&clearInterval(this.tryingConnectTimer),this.submitStatsTimer&&clearInterval(this.submitStatsTimer),this.changeStatus("finalized"),!0)}async updateClientProperties(r,n,i){switch(r){case"session":ho.forEach(s=>s.setBindings?.(Zn({},n,i))),this.anonymousUsageLogger.setSessionProperties(n,i);break;case"user":this.anonymousUsageLogger.setUserProperties(n,i);break}return !0}async updateConfig(r,n){let i=Ta(this.clientConfig,r);return (0, Hu.default)(i,n)||(n===void 0?Aa(this.clientConfig,r):Zn(this.clientConfig,r,n),await this.applyConfig()),!0}async clearConfig(r){return await this.updateConfig(r,void 0)}getConfig(){return this.config}getStatus(){return this.status}getIssues(){return this.issues}getIssueDetail(r){let n=this.getIssues();return r.index!==void 0&&r.index<n.length?this.issueFromName(n[r.index]):r.name!==void 0&&this.issues.includes(r.name)?this.issueFromName(r.name):null}getServerHealthState(){return this.serverHealthState??null}async requestAuthUrl(r){if(this.status==="notInitialized")throw new Error("Agent is not initialized");return await this.healthCheck(r),this.status!=="unauthorized"||!this.auth?null:await this.auth.requestAuthUrl(r)}async waitForAuthToken(r,n){if(this.status==="notInitialized")throw new Error("Agent is not initialized");this.status!=="unauthorized"||!this.auth||(await this.auth.pollingToken(r,n),await this.setupApi());}async provideCompletions(r,n){if(this.status==="notInitialized")throw new Error("Agent is not initialized");this.logger.trace({request:r},"Call provideCompletions"),this.nonParallelProvideCompletionAbortController&&this.nonParallelProvideCompletionAbortController.abort(),this.nonParallelProvideCompletionAbortController=new AbortController;let i=js([this.nonParallelProvideCompletionAbortController.signal,n?.signal]),s,o={triggerMode:r.manually?"manual":"auto",cacheHit:!1,aborted:!1,requestSent:!1,requestLatency:0,requestCanceled:!1,requestTimeout:!1},a,l=new ci(r);try{if(this.completionCache.has(l))o.cacheHit=!0,this.logger.debug({context:l},"Completion cache hit"),await this.completionDebounce.debounce({request:r,config:this.config.completion.debounce,responseTime:0},{signal:i}),s=this.completionCache.get(l);else {o.cacheHit=!1;let d=this.createSegments(l);if(Ae(d.prefix))o=void 0,this.logger.debug("Segment prefix is blank, returning empty completion response"),s={id:"agent-"+Xr(),choices:[]};else {await this.completionDebounce.debounce({request:r,config:this.config.completion.debounce,responseTime:this.completionProviderStats.windowed().stats.averageResponseTime},n);let c=Xr();o.requestSent=!0,a=performance.now();try{if(!this.api)throw new Error("http client not initialized");let p="/v1/completions",m={body:{language:r.language,segments:d,user:this.auth?.user},signal:this.createAbortSignal({signal:i})};this.logger.debug({requestId:c,requestOptions:m,url:this.config.server.endpoint+p},"Completion request");let _=await this.api.POST(p,m);if(_.error||!_.response.ok)throw new jt(_.response);this.logger.debug({requestId:c,response:_},"Completion response");let w=_.data;o.requestLatency=performance.now()-a,s={id:w.id,choices:w.choices.map(E=>({index:E.index,text:E.text,replaceRange:{start:r.position,end:r.position}}))};}catch(p){throw en(p)?(this.logger.debug({requestId:c,error:p},"Completion request canceled"),o.requestCanceled=!0,o.requestLatency=performance.now()-a):Hs(p)?(this.logger.debug({requestId:c,error:p},"Completion request timeout"),o.requestTimeout=!0,o.requestLatency=NaN):(this.logger.error({requestId:c,error:p},"Completion request failed with unknown error"),this.healthCheck()),p}if(s=await nT(l,this.config.postprocess,s),i.aborted)throw i.reason;this.completionCache.buildCache(l,JSON.parse(JSON.stringify(s)));}}if(s=await iT(l,this.config.postprocess,s),i.aborted)throw i.reason}catch(d){throw en(d)||Hs(d)?o&&(o.aborted=!0):o=void 0,d}finally{if(o&&(this.completionProviderStats.add(o),o.requestSent&&!o.requestCanceled)){let d=this.completionProviderStats.windowed();switch(this.completionProviderStats.check(d)){case"healthy":this.popIssue("slowCompletionResponseTime"),this.popIssue("highCompletionTimeoutRate");break;case"highTimeoutRate":this.popIssue("slowCompletionResponseTime"),this.pushIssue("highCompletionTimeoutRate");break;case"slowResponseTime":this.popIssue("highCompletionTimeoutRate"),this.pushIssue("slowCompletionResponseTime");break}}}return this.logger.trace({context:l,completionResponse:s},"Return from provideCompletions"),s}async postEvent(r,n){if(this.status==="notInitialized")throw new Error("Agent is not initialized");this.completionProviderStats.addEvent(r.type);let i=Xr();try{if(!this.api)throw new Error("http client not initialized");let s="/v1/events",o={body:r,params:{query:{select_kind:r.select_kind}},signal:this.createAbortSignal(n),parseAs:"text"};this.logger.debug({requestId:i,requestOptions:o,url:this.config.server.endpoint+s},"Event request");let a=await this.api.POST(s,o);if(a.error||!a.response.ok)throw new jt(a.response);return this.logger.debug({requestId:i,response:a},"Event response"),!0}catch(s){return Hs(s)?this.logger.debug({requestId:i,error:s},"Event request timeout"):en(s)?this.logger.debug({requestId:i,error:s},"Event request canceled"):this.logger.error({requestId:i,error:s},"Event request failed with unknown error"),!1}}};var fT=["statusChanged","configUpdated","authRequired","issuesUpdated"];var Bu=class{constructor(){this.process=process;this.inStream=process.stdin;this.outStream=process.stdout;this.logger=ht.child({component:"JsonLineServer"});this.abortControllers={};}async handleLine(e){let r;try{r=JSON.parse(e);}catch(i){this.logger.error({error:i},`Failed to parse request: ${e}`);return}this.logger.debug({request:r},"Received request");let n=await this.handleRequest(r);this.sendResponse(n),this.logger.debug({response:n},"Sent response");}async handleRequest(e){let r=0,n=[0,null],i=new AbortController;try{if(!this.agent)throw new Error(`Agent not bound.
`);r=e[0],n[0]=r;let s=e[1].func;if(s==="cancelRequest")n[1]=this.cancelRequest(e);else {let o=this.agent[s];if(!o)throw new Error(`Unknown function: ${s}`);let a=e[1].args;a.length>0&&typeof a[a.length-1]=="object"&&a[a.length-1].signal&&(this.abortControllers[r]=i,a[a.length-1].signal=i.signal),n[1]=await o.apply(this.agent,a);}}catch(s){en(s)?this.logger.debug({error:s,request:e},"Request canceled"):this.logger.error({error:s,request:e},"Failed to handle request");}finally{this.abortControllers[r]&&delete this.abortControllers[r];}return n}cancelRequest(e){let r=e[1].args[0],n=this.abortControllers[r];return n?(n.abort(),!0):!1}sendResponse(e){this.outStream.write(JSON.stringify(e)+`
`);}bind(e){this.agent=e;for(let r of fT)this.agent.on(r,n=>{this.sendResponse([0,n]);});}listen(){m3__default.default.createInterface({input:this.inStream}).on("line",e=>{this.handleLine(e);}),["SIGTERM","SIGINT"].forEach(e=>{this.process.on(e,async()=>{this.agent&&this.agent.getStatus()!=="finalized"&&await this.agent.finalize(),this.process.exit(0);});});}};var Jr=$t(F1());var ol=class t{constructor(e,r,n,i){this._uri=e,this._languageId=r,this._version=n,this._content=i,this._lineOffsets=void 0;}get uri(){return this._uri}get languageId(){return this._languageId}get version(){return this._version}getText(e){if(e){let r=this.offsetAt(e.start),n=this.offsetAt(e.end);return this._content.substring(r,n)}return this._content}update(e,r){for(let n of e)if(t.isIncremental(n)){let i=q1(n.range),s=this.offsetAt(i.start),o=this.offsetAt(i.end);this._content=this._content.substring(0,s)+n.text+this._content.substring(o,this._content.length);let a=Math.max(i.start.line,0),l=Math.max(i.end.line,0),d=this._lineOffsets,c=N1(n.text,!1,s);if(l-a===c.length)for(let m=0,_=c.length;m<_;m++)d[m+a+1]=c[m];else c.length<1e4?d.splice(a+1,l-a,...c):this._lineOffsets=d=d.slice(0,a+1).concat(c,d.slice(l+1));let p=n.text.length-(o-s);if(p!==0)for(let m=a+1+c.length,_=d.length;m<_;m++)d[m]=d[m]+p;}else if(t.isFull(n))this._content=n.text,this._lineOffsets=void 0;else throw new Error("Unknown change event received");this._version=r;}getLineOffsets(){return this._lineOffsets===void 0&&(this._lineOffsets=N1(this._content,!0)),this._lineOffsets}positionAt(e){e=Math.max(Math.min(e,this._content.length),0);let r=this.getLineOffsets(),n=0,i=r.length;if(i===0)return {line:0,character:e};for(;n<i;){let o=Math.floor((n+i)/2);r[o]>e?i=o:n=o+1;}let s=n-1;return {line:s,character:e-r[s]}}offsetAt(e){let r=this.getLineOffsets();if(e.line>=r.length)return this._content.length;if(e.line<0)return 0;let n=r[e.line],i=e.line+1<r.length?r[e.line+1]:this._content.length;return Math.max(Math.min(n+e.character,i),n)}get lineCount(){return this.getLineOffsets().length}static isIncremental(e){let r=e;return r!=null&&typeof r.text=="string"&&r.range!==void 0&&(r.rangeLength===void 0||typeof r.rangeLength=="number")}static isFull(e){let r=e;return r!=null&&typeof r.text=="string"&&r.range===void 0&&r.rangeLength===void 0}},al;(function(t){function e(i,s,o,a){return new ol(i,s,o,a)}t.create=e;function r(i,s,o){if(i instanceof ol)return i.update(s,o),i;throw new Error("TextDocument.update: document must be created by TextDocument.create")}t.update=r;function n(i,s){let o=i.getText(),a=mg(s.map(Oz),(c,p)=>{let m=c.range.start.line-p.range.start.line;return m===0?c.range.start.character-p.range.start.character:m}),l=0,d=[];for(let c of a){let p=i.offsetAt(c.range.start);if(p<l)throw new Error("Overlapping edit");p>l&&d.push(o.substring(l,p)),c.newText.length&&d.push(c.newText),l=i.offsetAt(c.range.end);}return d.push(o.substr(l)),d.join("")}t.applyEdits=n;})(al||(al={}));function mg(t,e){if(t.length<=1)return t;let r=t.length/2|0,n=t.slice(0,r),i=t.slice(r);mg(n,e),mg(i,e);let s=0,o=0,a=0;for(;s<n.length&&o<i.length;)e(n[s],i[o])<=0?t[a++]=n[s++]:t[a++]=i[o++];for(;s<n.length;)t[a++]=n[s++];for(;o<i.length;)t[a++]=i[o++];return t}function N1(t,e,r=0){let n=e?[r]:[];for(let i=0;i<t.length;i++){let s=t.charCodeAt(i);(s===13||s===10)&&(s===13&&i+1<t.length&&t.charCodeAt(i+1)===10&&i++,n.push(r+i+1));}return n}function q1(t){let e=t.start,r=t.end;return e.line>r.line||e.line===r.line&&e.character>r.character?{start:r,end:e}:t}function Oz(t){let e=q1(t.range);return e!==t.range?{newText:t.newText,range:e}:t}var ul=class{constructor(){this.connection=(0, Jr.createConnection)();this.documents=new Jr.TextDocuments(al);this.logger=ht.child({component:"LspServer"});this.connection.onInitialize(async e=>await this.initialize(e)),this.connection.onShutdown(async()=>await this.shutdown()),this.connection.onExit(async()=>this.exit()),this.connection.onCompletion(async e=>await this.completion(e));}bind(e){this.agent=e,this.agent.on("statusChanged",r=>{(r.status==="disconnected"||r.status==="unauthorized")&&this.showMessage({type:Jr.MessageType.Warning,message:`Tabby agent status: ${r.status}`});});}listen(){this.documents.listen(this.connection),this.connection.listen();}async initialize(e){if(this.logger.debug({params:e},"LSP: initialize: request"),!this.agent)throw new Error(`Agent not bound.
`);let{clientInfo:r,capabilities:n}=e;return await this.agent.initialize({clientProperties:{session:{client:`${r?.name} ${r?.version??""}`,ide:{name:r?.name,version:r?.version},tabby_plugin:{name:`${go} (LSP)`,version:_o}}}}),{capabilities:{textDocumentSync:{openClose:!0,change:Jr.TextDocumentSyncKind.Incremental},completionProvider:{}},serverInfo:{name:go,version:_o}}}async shutdown(){if(this.logger.debug("LSP: shutdown: request"),!this.agent)throw new Error(`Agent not bound.
`);await this.agent.finalize();}exit(){return this.logger.debug("LSP: exit: request"),process.exit(0)}async showMessage(e){this.logger.debug({params:e},"LSP server notification: window/showMessage"),await this.connection.sendNotification("window/showMessage",e);}async completion(e){if(this.logger.debug({params:e},"LSP: textDocument/completion: request"),!this.agent)throw new Error(`Agent not bound.
`);try{let r=this.buildCompletionRequest(e),n=await this.agent.provideCompletions(r),i=this.toCompletionList(n,e);return this.logger.debug({completionList:i},"LSP: textDocument/completion: response"),i}catch(r){en(r)?this.logger.debug({error:r},"LSP: textDocument/completion: canceled"):this.logger.error({error:r},"LSP: textDocument/completion: error");}return {isIncomplete:!0,items:[]}}buildCompletionRequest(e,r=!1){let{textDocument:n,position:i}=e,s=this.documents.get(n.uri);return {filepath:s.uri,language:s.languageId,text:s.getText(),position:s.offsetAt(i),manually:r}}toCompletionList(e,r){let{textDocument:n,position:i}=r,s=this.documents.get(n.uri),o=s.getText({start:{line:i.line,character:0},end:i}),a=o.match(/(\w+)$/)?.[0]??"";return {isIncomplete:!0,items:e.choices.map(l=>{let d=l.text.slice(s.offsetAt(i)-l.replaceRange.start),c=Je(d),p=c[0]||"",m=c[1]||"";return {label:a+p,labelDetails:{detail:m,description:"Tabby"},kind:Jr.CompletionItemKind.Text,documentation:{kind:"markdown",value:`\`\`\`
${o+d}
\`\`\`
 ---
Suggested by Tabby.`},textEdit:{newText:a+d,range:{start:{line:i.line,character:i.character-a.length},end:s.positionAt(l.replaceRange.end)}},data:{completionId:e.id,choiceIndex:l.index}}})}}};var Iz=process.argv.slice(2),cl;Iz.indexOf("--lsp")>=0?cl=new ul:cl=new Bu;var kz=new Wu;cl.bind(kz);cl.listen();
/*! Bundled license information:

normalize-path/index.js:
  (*!
   * normalize-path <https://github.com/jonschlinkert/normalize-path>
   *
   * Copyright (c) 2014-2018, Jon Schlinkert.
   * Released under the MIT License.
   *)

is-extglob/index.js:
  (*!
   * is-extglob <https://github.com/jonschlinkert/is-extglob>
   *
   * Copyright (c) 2014-2016, Jon Schlinkert.
   * Licensed under the MIT License.
   *)

is-glob/index.js:
  (*!
   * is-glob <https://github.com/jonschlinkert/is-glob>
   *
   * Copyright (c) 2014-2017, Jon Schlinkert.
   * Released under the MIT License.
   *)

is-number/index.js:
  (*!
   * is-number <https://github.com/jonschlinkert/is-number>
   *
   * Copyright (c) 2014-present, Jon Schlinkert.
   * Released under the MIT License.
   *)

to-regex-range/index.js:
  (*!
   * to-regex-range <https://github.com/micromatch/to-regex-range>
   *
   * Copyright (c) 2015-present, Jon Schlinkert.
   * Released under the MIT License.
   *)

fill-range/index.js:
  (*!
   * fill-range <https://github.com/jonschlinkert/fill-range>
   *
   * Copyright (c) 2014-present, Jon Schlinkert.
   * Licensed under the MIT License.
   *)
*/
//# sourceMappingURL=out.js.map
//# sourceMappingURL=cli.js.map